package com.avaje.ebean;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;














































public class InvalidValue
  implements Serializable
{
  private static final long serialVersionUID = 2408556605456324913L;
  private static final Object[] EMPTY = new Object[0];
  
  private final String beanType;
  
  private final String propertyName;
  
  private final String validatorKey;
  
  private final Object value;
  
  private final InvalidValue[] children;
  
  private final Object[] validatorAttributes;
  private String message;
  
  public InvalidValue(String validatorKey, String beanType, Object bean, InvalidValue[] children)
  {
    this.validatorKey = validatorKey;
    validatorAttributes = EMPTY;
    this.beanType = beanType;
    propertyName = null;
    value = bean;
    this.children = children;
  }
  
  public InvalidValue(String validatorKey, Object[] validatorAttributes, String beanType, String propertyName, Object value) {
    this.validatorKey = validatorKey;
    this.validatorAttributes = validatorAttributes;
    this.beanType = beanType;
    this.propertyName = propertyName;
    this.value = value;
    children = null;
  }
  
  public String getBeanType() {
    return beanType;
  }
  


  public String getPropertyName()
  {
    return propertyName;
  }
  


  public String getValidatorKey()
  {
    return validatorKey;
  }
  











  public Object[] getValidatorAttributes()
  {
    return validatorAttributes;
  }
  


  public Object getValue()
  {
    return value;
  }
  


  public InvalidValue[] getChildren()
  {
    return children;
  }
  


  public String getMessage()
  {
    return message;
  }
  


  public void setMessage(String message)
  {
    this.message = message;
  }
  







  public boolean isBean()
  {
    return !isError();
  }
  


  public boolean isError()
  {
    return children == null;
  }
  



  public InvalidValue[] getErrors()
  {
    ArrayList<InvalidValue> list = new ArrayList();
    buildList(list);
    
    return toArray(list);
  }
  


  private void buildList(List<InvalidValue> list)
  {
    if (isError()) {
      list.add(this);
    } else {
      for (int i = 0; i < children.length; i++) {
        children[i].buildList(list);
      }
    }
  }
  
  public String toString()
  {
    if (isError()) {
      return "errorKey=" + validatorKey + " type=" + beanType + " property=" + propertyName + " value=" + value;
    }
    
    if (children.length == 1) {
      return children[0].toString();
    }
    

    StringBuilder sb = new StringBuilder(50);
    sb.append("\r\nCHILDREN[").append(children.length).append("]");
    for (int i = 0; i < children.length; i++) {
      sb.append(children[i].toString()).append(", ");
    }
    return sb.toString();
  }
  


  public static InvalidValue[] toArray(List<InvalidValue> list)
  {
    return (InvalidValue[])list.toArray(new InvalidValue[list.size()]);
  }
  


  public static List<InvalidValue> toList(InvalidValue invalid)
  {
    ArrayList<InvalidValue> list = new ArrayList();
    list.add(invalid);
    return list;
  }
}
