package com.avaje.ebean.bean;

import com.avaje.ebean.Ebean;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.ObjectStreamException;
import java.io.Serializable;
import java.math.BigDecimal;
import java.net.URL;
import java.util.HashSet;
import java.util.Set;
import javax.persistence.PersistenceException;






































































































public final class EntityBeanIntercept
  implements Serializable
{
  private static final long serialVersionUID = -3664031775464862648L;
  public static final int DEFAULT = 0;
  public static final int UPDATE = 1;
  public static final int READONLY = 2;
  public static final int SHARED = 3;
  private transient NodeUsageCollector nodeUsageCollector;
  private transient PropertyChangeSupport pcs;
  private transient PersistenceContext persistenceContext;
  private transient BeanLoader beanLoader;
  private int beanLoaderIndex;
  private String ebeanServerName;
  private EntityBean owner;
  private Object parentBean;
  private boolean loaded;
  private boolean disableLazyLoad;
  private boolean intercepting;
  private int state;
  private boolean useCache;
  private Object oldValues;
  private Set<String> loadedProps;
  private HashSet<String> changedProps;
  private String lazyLoadProperty;
  
  public EntityBeanIntercept(Object owner)
  {
    this.owner = ((EntityBean)owner);
  }
  






  public void setState(int parentState)
  {
    state = parentState;
  }
  


  public int getState()
  {
    return state;
  }
  


  public void copyStateTo(EntityBeanIntercept dest)
  {
    loadedProps = loadedProps;
    ebeanServerName = ebeanServerName;
    
    if (loaded) {
      dest.setLoaded();
    }
  }
  


  public EntityBean getOwner()
  {
    return owner;
  }
  
  public String toString() {
    if (!loaded) {
      return "Reference...";
    }
    return "OldValues: " + oldValues;
  }
  


  public PersistenceContext getPersistenceContext()
  {
    return persistenceContext;
  }
  


  public void setPersistenceContext(PersistenceContext persistenceContext)
  {
    this.persistenceContext = persistenceContext;
  }
  


  public void addPropertyChangeListener(PropertyChangeListener listener)
  {
    if (pcs == null) {
      pcs = new PropertyChangeSupport(owner);
    }
    pcs.addPropertyChangeListener(listener);
  }
  


  public void addPropertyChangeListener(String propertyName, PropertyChangeListener listener)
  {
    if (pcs == null) {
      pcs = new PropertyChangeSupport(owner);
    }
    pcs.addPropertyChangeListener(propertyName, listener);
  }
  


  public void removePropertyChangeListener(PropertyChangeListener listener)
  {
    if (pcs != null) {
      pcs.removePropertyChangeListener(listener);
    }
  }
  


  public void removePropertyChangeListener(String propertyName, PropertyChangeListener listener)
  {
    if (pcs != null) {
      pcs.removePropertyChangeListener(propertyName, listener);
    }
  }
  


  public void setNodeUsageCollector(NodeUsageCollector usageCollector)
  {
    nodeUsageCollector = usageCollector;
  }
  


  public Object getParentBean()
  {
    return parentBean;
  }
  



  public void setParentBean(Object parentBean)
  {
    this.parentBean = parentBean;
  }
  


  public int getBeanLoaderIndex()
  {
    return beanLoaderIndex;
  }
  
  public void setBeanLoader(int index, BeanLoader ctx) {
    beanLoaderIndex = index;
    beanLoader = ctx;
    ebeanServerName = ctx.getName();
  }
  




  public boolean isDirty()
  {
    if (oldValues != null) {
      return true;
    }
    
    return owner._ebean_isEmbeddedNewOrDirty();
  }
  


  public boolean isNew()
  {
    return (!intercepting) && (!loaded);
  }
  


  public boolean isNewOrDirty()
  {
    return (isNew()) || (isDirty());
  }
  


  public boolean isReference()
  {
    return (intercepting) && (!loaded);
  }
  


  public void setReference()
  {
    loaded = false;
    intercepting = true;
  }
  


  public Object getOldValues()
  {
    return oldValues;
  }
  


  public boolean isUseCache()
  {
    return useCache;
  }
  


  public void setUseCache(boolean loadFromCache)
  {
    useCache = loadFromCache;
  }
  







  public boolean isSharedInstance()
  {
    return state == 3;
  }
  



  public void setSharedInstance()
  {
    state = 3;
  }
  



  public boolean isReadOnly()
  {
    return state >= 2;
  }
  



  public void setReadOnly(boolean readOnly)
  {
    if (state == 3) {
      if (!readOnly) {
        throw new IllegalStateException("sharedInstance so must remain readOnly");
      }
    } else {
      state = (readOnly ? 2 : 0);
    }
  }
  





  public boolean isIntercepting()
  {
    return intercepting;
  }
  







  public void setIntercepting(boolean intercepting)
  {
    this.intercepting = intercepting;
  }
  


  public boolean isLoaded()
  {
    return loaded;
  }
  










  public void setLoaded()
  {
    loaded = true;
    oldValues = null;
    intercepting = true;
    owner._ebean_setEmbeddedLoaded();
    lazyLoadProperty = null;
    changedProps = null;
  }
  



  public void setLoadedLazy()
  {
    loaded = true;
    intercepting = true;
    lazyLoadProperty = null;
  }
  


  public boolean isDisableLazyLoad()
  {
    return disableLazyLoad;
  }
  





  public void setDisableLazyLoad(boolean disableLazyLoad)
  {
    this.disableLazyLoad = disableLazyLoad;
  }
  


  public void setEmbeddedLoaded(Object embeddedBean)
  {
    if ((embeddedBean instanceof EntityBean)) {
      EntityBean eb = (EntityBean)embeddedBean;
      eb._ebean_getIntercept().setLoaded();
    }
  }
  



  public boolean isEmbeddedNewOrDirty(Object embeddedBean)
  {
    if (embeddedBean == null)
    {

      return false;
    }
    if ((embeddedBean instanceof EntityBean)) {
      return ((EntityBean)embeddedBean)._ebean_getIntercept().isNewOrDirty();
    }
    

    return true;
  }
  






  public void setLoadedProps(Set<String> loadedPropertyNames)
  {
    loadedProps = loadedPropertyNames;
  }
  


  public Set<String> getLoadedProps()
  {
    return loadedProps;
  }
  


  public Set<String> getChangedProps()
  {
    return changedProps;
  }
  


  public String getLazyLoadProperty()
  {
    return lazyLoadProperty;
  }
  



  protected void loadBean(String loadProperty)
  {
    synchronized (this) {
      if (disableLazyLoad) {
        loaded = true;
        return;
      }
      
      if (lazyLoadProperty == null) {
        if (beanLoader == null) {
          beanLoader = ((BeanLoader)Ebean.getServer(ebeanServerName));
        }
        
        if (beanLoader == null) {
          String msg = "Lazy loading but InternalEbean is null? The InternalEbean needs to be set after deserialization to support lazy loading.";
          

          throw new PersistenceException(msg);
        }
        
        lazyLoadProperty = loadProperty;
        
        if (nodeUsageCollector != null) {
          nodeUsageCollector.setLoadProperty(lazyLoadProperty);
        }
        
        beanLoader.loadBean(this);
      }
    }
  }
  








  protected void createOldValues()
  {
    oldValues = owner._ebean_createCopy();
    
    if (nodeUsageCollector != null) {
      nodeUsageCollector.setModified();
    }
  }
  









  public Object writeReplaceIntercept()
    throws ObjectStreamException
  {
    if (!SerializeControl.isVanillaBeans()) {
      return owner;
    }
    


    return owner._ebean_createCopy();
  }
  



  protected boolean areEqual(Object obj1, Object obj2)
  {
    if (obj1 == null) {
      return obj2 == null;
    }
    if (obj2 == null) {
      return false;
    }
    if (obj1 == obj2) {
      return true;
    }
    if ((obj1 instanceof BigDecimal))
    {

      if ((obj2 instanceof BigDecimal)) {
        Comparable com1 = (Comparable)obj1;
        return com1.compareTo(obj2) == 0;
      }
      
      return false;
    }
    

    if ((obj1 instanceof URL))
    {
      return obj1.toString().equals(obj2.toString());
    }
    return obj1.equals(obj2);
  }
  





  public void preGetter(String propertyName)
  {
    if (!intercepting) {
      return;
    }
    
    if (!loaded) {
      loadBean(propertyName);
    } else if ((loadedProps != null) && (!loadedProps.contains(propertyName))) {
      loadBean(propertyName);
    }
    
    if ((nodeUsageCollector != null) && (loaded)) {
      nodeUsageCollector.addUsed(propertyName);
    }
  }
  



  public void postSetter(PropertyChangeEvent event)
  {
    if ((pcs != null) && (event != null)) {
      pcs.firePropertyChange(event);
    }
  }
  




  public void postSetter(PropertyChangeEvent event, Object newValue)
  {
    if ((pcs != null) && (event != null)) {
      if ((newValue != null) && (newValue.equals(event.getNewValue()))) {
        pcs.firePropertyChange(event);
      } else {
        pcs.firePropertyChange(event.getPropertyName(), event.getOldValue(), newValue);
      }
    }
  }
  







  public PropertyChangeEvent preSetterMany(boolean interceptField, String propertyName, Object oldValue, Object newValue)
  {
    if (pcs != null) {
      return new PropertyChangeEvent(owner, propertyName, oldValue, newValue);
    }
    return null;
  }
  

  private final void addDirty(String propertyName)
  {
    if (!intercepting) {
      return;
    }
    if (state >= 2) {
      throw new IllegalStateException("This bean is readOnly");
    }
    
    if (loaded) {
      if (oldValues == null)
      {
        createOldValues();
      }
      if (changedProps == null) {
        changedProps = new HashSet();
      }
      changedProps.add(propertyName);
    }
  }
  




  public PropertyChangeEvent preSetter(boolean intercept, String propertyName, Object oldValue, Object newValue)
  {
    boolean changed = !areEqual(oldValue, newValue);
    
    if ((intercept) && (changed)) {
      addDirty(propertyName);
    }
    
    if ((changed) && (pcs != null)) {
      return new PropertyChangeEvent(owner, propertyName, oldValue, newValue);
    }
    
    return null;
  }
  



  public PropertyChangeEvent preSetter(boolean intercept, String propertyName, boolean oldValue, boolean newValue)
  {
    boolean changed = oldValue != newValue;
    
    if ((intercept) && (changed)) {
      addDirty(propertyName);
    }
    
    if ((changed) && (pcs != null)) {
      return new PropertyChangeEvent(owner, propertyName, Boolean.valueOf(oldValue), Boolean.valueOf(newValue));
    }
    
    return null;
  }
  



  public PropertyChangeEvent preSetter(boolean intercept, String propertyName, int oldValue, int newValue)
  {
    boolean changed = oldValue != newValue;
    
    if ((intercept) && (changed)) {
      addDirty(propertyName);
    }
    
    if ((changed) && (pcs != null)) {
      return new PropertyChangeEvent(owner, propertyName, Integer.valueOf(oldValue), Integer.valueOf(newValue));
    }
    return null;
  }
  



  public PropertyChangeEvent preSetter(boolean intercept, String propertyName, long oldValue, long newValue)
  {
    boolean changed = oldValue != newValue;
    
    if ((intercept) && (changed)) {
      addDirty(propertyName);
    }
    
    if ((changed) && (pcs != null)) {
      return new PropertyChangeEvent(owner, propertyName, Long.valueOf(oldValue), Long.valueOf(newValue));
    }
    return null;
  }
  



  public PropertyChangeEvent preSetter(boolean intercept, String propertyName, double oldValue, double newValue)
  {
    boolean changed = oldValue != newValue;
    
    if ((intercept) && (changed)) {
      addDirty(propertyName);
    }
    
    if ((changed) && (pcs != null)) {
      return new PropertyChangeEvent(owner, propertyName, Double.valueOf(oldValue), Double.valueOf(newValue));
    }
    return null;
  }
  



  public PropertyChangeEvent preSetter(boolean intercept, String propertyName, float oldValue, float newValue)
  {
    boolean changed = oldValue != newValue;
    
    if ((intercept) && (changed)) {
      addDirty(propertyName);
    }
    
    if ((changed) && (pcs != null)) {
      return new PropertyChangeEvent(owner, propertyName, Float.valueOf(oldValue), Float.valueOf(newValue));
    }
    return null;
  }
  



  public PropertyChangeEvent preSetter(boolean intercept, String propertyName, short oldValue, short newValue)
  {
    boolean changed = oldValue != newValue;
    
    if ((intercept) && (changed)) {
      addDirty(propertyName);
    }
    
    if ((changed) && (pcs != null)) {
      return new PropertyChangeEvent(owner, propertyName, Short.valueOf(oldValue), Short.valueOf(newValue));
    }
    return null;
  }
  



  public PropertyChangeEvent preSetter(boolean intercept, String propertyName, char oldValue, char newValue)
  {
    boolean changed = oldValue != newValue;
    
    if ((intercept) && (changed)) {
      addDirty(propertyName);
    }
    
    if ((changed) && (pcs != null)) {
      return new PropertyChangeEvent(owner, propertyName, Character.valueOf(oldValue), Character.valueOf(newValue));
    }
    return null;
  }
  



  public PropertyChangeEvent preSetter(boolean intercept, String propertyName, byte oldValue, byte newValue)
  {
    boolean changed = oldValue != newValue;
    
    if ((intercept) && (changed)) {
      addDirty(propertyName);
    }
    
    if ((changed) && (pcs != null)) {
      return new PropertyChangeEvent(owner, propertyName, Byte.valueOf(oldValue), Byte.valueOf(newValue));
    }
    return null;
  }
  



  public PropertyChangeEvent preSetter(boolean intercept, String propertyName, char[] oldValue, char[] newValue)
  {
    boolean changed = !areEqualChars(oldValue, newValue);
    
    if ((intercept) && (changed)) {
      addDirty(propertyName);
    }
    
    if ((changed) && (pcs != null)) {
      return new PropertyChangeEvent(owner, propertyName, oldValue, newValue);
    }
    return null;
  }
  



  public PropertyChangeEvent preSetter(boolean intercept, String propertyName, byte[] oldValue, byte[] newValue)
  {
    boolean changed = !areEqualBytes(oldValue, newValue);
    
    if ((intercept) && (changed)) {
      addDirty(propertyName);
    }
    
    if ((changed) && (pcs != null)) {
      return new PropertyChangeEvent(owner, propertyName, oldValue, newValue);
    }
    return null;
  }
  

  private static boolean areEqualBytes(byte[] b1, byte[] b2)
  {
    if (b1 == null) {
      return b2 == null;
    }
    if (b2 == null) {
      return false;
    }
    if (b1 == b2) {
      return true;
    }
    if (b1.length != b2.length) {
      return false;
    }
    for (int i = 0; i < b1.length; i++) {
      if (b1[i] != b2[i]) {
        return false;
      }
    }
    return true;
  }
  
  private static boolean areEqualChars(char[] b1, char[] b2) {
    if (b1 == null) {
      return b2 == null;
    }
    if (b2 == null) {
      return false;
    }
    if (b1 == b2) {
      return true;
    }
    if (b1.length != b2.length) {
      return false;
    }
    for (int i = 0; i < b1.length; i++) {
      if (b1[i] != b2[i]) {
        return false;
      }
    }
    return true;
  }
}
