package com.avaje.ebean.bean;

import java.io.Serializable;































public final class ObjectGraphOrigin
  implements Serializable
{
  private static final long serialVersionUID = 410937765287968707L;
  private final CallStack callStack;
  private final String key;
  private final String beanType;
  
  public ObjectGraphOrigin(int queryHash, CallStack callStack, String beanType)
  {
    this.callStack = callStack;
    this.beanType = beanType;
    key = callStack.getOriginKey(queryHash);
  }
  



  public String getKey()
  {
    return key;
  }
  


  public String getBeanType()
  {
    return beanType;
  }
  


  public CallStack getCallStack()
  {
    return callStack;
  }
  
  public String getFirstStackElement() {
    return callStack.getFirstStackTraceElement().toString();
  }
  
  public String toString() {
    return key + " " + beanType + " " + callStack.getFirstStackTraceElement();
  }
}
