package com.avaje.ebean.cache;

import com.avaje.ebean.annotation.CacheTuning;






























public class ServerCacheOptions
{
  private int maxSize;
  private int maxIdleSecs;
  private int maxSecsToLive;
  
  public ServerCacheOptions() {}
  
  public ServerCacheOptions(CacheTuning cacheTuning)
  {
    maxSize = cacheTuning.maxSize();
    maxIdleSecs = cacheTuning.maxIdleSecs();
    maxSecsToLive = cacheTuning.maxSecsToLive();
  }
  


  public ServerCacheOptions(ServerCacheOptions d)
  {
    maxSize = d.getMaxSize();
    maxIdleSecs = d.getMaxIdleSecs();
    maxSecsToLive = d.getMaxIdleSecs();
  }
  



  public void applyDefaults(ServerCacheOptions defaults)
  {
    if (maxSize == 0) {
      maxSize = defaults.getMaxSize();
    }
    if (maxIdleSecs == 0) {
      maxIdleSecs = defaults.getMaxIdleSecs();
    }
    if (maxSecsToLive == 0) {
      maxSecsToLive = defaults.getMaxSecsToLive();
    }
  }
  



  public ServerCacheOptions copy()
  {
    ServerCacheOptions copy = new ServerCacheOptions();
    maxSize = maxSize;
    maxIdleSecs = maxIdleSecs;
    maxSecsToLive = maxSecsToLive;
    
    return copy;
  }
  


  public int getMaxSize()
  {
    return maxSize;
  }
  


  public void setMaxSize(int maxSize)
  {
    this.maxSize = maxSize;
  }
  


  public int getMaxIdleSecs()
  {
    return maxIdleSecs;
  }
  


  public void setMaxIdleSecs(int maxIdleSecs)
  {
    this.maxIdleSecs = maxIdleSecs;
  }
  


  public int getMaxSecsToLive()
  {
    return maxSecsToLive;
  }
  


  public void setMaxSecsToLive(int maxSecsToLive)
  {
    this.maxSecsToLive = maxSecsToLive;
  }
}
