package com.avaje.ebean.common;

import com.avaje.ebean.bean.BeanCollection;
import java.util.ListIterator;
































class ModifyListIterator<E>
  implements ListIterator<E>
{
  private final BeanCollection<E> owner;
  private final ListIterator<E> it;
  private E last;
  
  ModifyListIterator(BeanCollection<E> owner, ListIterator<E> it)
  {
    this.owner = owner;
    this.it = it;
  }
  
  public void add(E bean) {
    owner.modifyAddition(bean);
    last = null;
    it.add(bean);
  }
  
  public boolean hasNext() {
    return it.hasNext();
  }
  
  public boolean hasPrevious() {
    return it.hasPrevious();
  }
  
  public E next() {
    last = it.next();
    return last;
  }
  
  public int nextIndex() {
    return it.nextIndex();
  }
  
  public E previous() {
    last = it.previous();
    return last;
  }
  
  public int previousIndex() {
    return it.previousIndex();
  }
  
  public void remove() {
    owner.modifyRemoval(last);
    last = null;
    it.remove();
  }
  
  public void set(E o) {
    if (last != null)
    {

      owner.modifyRemoval(last);
      owner.modifyAddition(o);
    }
    it.set(o);
  }
}
