package com.avaje.ebean.config;




public class AutofetchConfig
{
  private AutofetchMode mode = AutofetchMode.DEFAULT_ONIFEMPTY;
  
  private boolean queryTuning = false;
  
  private boolean queryTuningAddVersion = false;
  
  private boolean profiling = false;
  
  private int profilingMin = 1;
  
  private int profilingBase = 10;
  
  private double profilingRate = 0.05D;
  
  private boolean useFileLogging = false;
  
  private String logDirectory;
  
  private int profileUpdateFrequency = 60;
  
  private int garbageCollectionWait = 100;
  






  public AutofetchMode getMode()
  {
    return mode;
  }
  



  public void setMode(AutofetchMode mode)
  {
    this.mode = mode;
  }
  


  public boolean isQueryTuning()
  {
    return queryTuning;
  }
  


  public void setQueryTuning(boolean queryTuning)
  {
    this.queryTuning = queryTuning;
  }
  







  public boolean isQueryTuningAddVersion()
  {
    return queryTuningAddVersion;
  }
  







  public void setQueryTuningAddVersion(boolean queryTuningAddVersion)
  {
    this.queryTuningAddVersion = queryTuningAddVersion;
  }
  


  public boolean isProfiling()
  {
    return profiling;
  }
  






  public void setProfiling(boolean profiling)
  {
    this.profiling = profiling;
  }
  



  public int getProfilingMin()
  {
    return profilingMin;
  }
  



  public void setProfilingMin(int profilingMin)
  {
    this.profilingMin = profilingMin;
  }
  




  public int getProfilingBase()
  {
    return profilingBase;
  }
  


  public void setProfilingBase(int profilingBase)
  {
    this.profilingBase = profilingBase;
  }
  



  public double getProfilingRate()
  {
    return profilingRate;
  }
  



  public void setProfilingRate(double profilingRate)
  {
    this.profilingRate = profilingRate;
  }
  



  public boolean isUseFileLogging()
  {
    return useFileLogging;
  }
  



  public void setUseFileLogging(boolean useFileLogging)
  {
    this.useFileLogging = useFileLogging;
  }
  


  public String getLogDirectory()
  {
    return logDirectory;
  }
  



  public String getLogDirectoryWithEval()
  {
    return GlobalProperties.evaluateExpressions(logDirectory);
  }
  


  public void setLogDirectory(String logDirectory)
  {
    this.logDirectory = logDirectory;
  }
  



  public int getProfileUpdateFrequency()
  {
    return profileUpdateFrequency;
  }
  



  public void setProfileUpdateFrequency(int profileUpdateFrequency)
  {
    this.profileUpdateFrequency = profileUpdateFrequency;
  }
  










  public int getGarbageCollectionWait()
  {
    return garbageCollectionWait;
  }
  



  public void setGarbageCollectionWait(int garbageCollectionWait)
  {
    this.garbageCollectionWait = garbageCollectionWait;
  }
  



  public void loadSettings(ConfigPropertyMap p)
  {
    logDirectory = p.get("autofetch.logDirectory", null);
    queryTuning = p.getBoolean("autofetch.querytuning", false);
    queryTuningAddVersion = p.getBoolean("autofetch.queryTuningAddVersion", false);
    
    profiling = p.getBoolean("autofetch.profiling", false);
    mode = ((AutofetchMode)p.getEnum(AutofetchMode.class, "autofetch.implicitmode", AutofetchMode.DEFAULT_ONIFEMPTY));
    
    profilingMin = p.getInt("autofetch.profiling.min", 1);
    profilingBase = p.getInt("autofetch.profiling.base", 10);
    
    String rate = p.get("autofetch.profiling.rate", "0.05");
    profilingRate = Double.parseDouble(rate);
    
    useFileLogging = p.getBoolean("autofetch.useFileLogging", profiling);
    profileUpdateFrequency = p.getInt("autofetch.profiling.updatefrequency", 60);
  }
}
