package com.avaje.ebean.config;

import com.avaje.ebeaninternal.server.lib.sql.TransactionIsolation;















public class DataSourceConfig
{
  private String url;
  private String username;
  private String password;
  private String driver;
  private int minConnections = 2;
  
  private int maxConnections = 20;
  
  private int isolationLevel = 2;
  
  private String heartbeatSql;
  
  private boolean captureStackTrace;
  
  private int maxStackTraceSize = 5;
  
  private int leakTimeMinutes = 30;
  
  private int maxInactiveTimeSecs = 900;
  
  private int pstmtCacheSize = 20;
  private int cstmtCacheSize = 20;
  
  private int waitTimeoutMillis = 1000;
  

  private String poolListener;
  
  private boolean offline;
  

  public String getUrl()
  {
    return url;
  }
  


  public void setUrl(String url)
  {
    this.url = url;
  }
  


  public String getUsername()
  {
    return username;
  }
  


  public void setUsername(String username)
  {
    this.username = username;
  }
  


  public String getPassword()
  {
    return password;
  }
  


  public void setPassword(String password)
  {
    this.password = password;
  }
  


  public String getDriver()
  {
    return driver;
  }
  


  public void setDriver(String driver)
  {
    this.driver = driver;
  }
  


  public int getIsolationLevel()
  {
    return isolationLevel;
  }
  


  public void setIsolationLevel(int isolationLevel)
  {
    this.isolationLevel = isolationLevel;
  }
  


  public int getMinConnections()
  {
    return minConnections;
  }
  


  public void setMinConnections(int minConnections)
  {
    this.minConnections = minConnections;
  }
  


  public int getMaxConnections()
  {
    return maxConnections;
  }
  


  public void setMaxConnections(int maxConnections)
  {
    this.maxConnections = maxConnections;
  }
  





  public String getHeartbeatSql()
  {
    return heartbeatSql;
  }
  





  public void setHeartbeatSql(String heartbeatSql)
  {
    this.heartbeatSql = heartbeatSql;
  }
  










  public boolean isCaptureStackTrace()
  {
    return captureStackTrace;
  }
  









  public void setCaptureStackTrace(boolean captureStackTrace)
  {
    this.captureStackTrace = captureStackTrace;
  }
  


  public int getMaxStackTraceSize()
  {
    return maxStackTraceSize;
  }
  


  public void setMaxStackTraceSize(int maxStackTraceSize)
  {
    this.maxStackTraceSize = maxStackTraceSize;
  }
  



  public int getLeakTimeMinutes()
  {
    return leakTimeMinutes;
  }
  



  public void setLeakTimeMinutes(int leakTimeMinutes)
  {
    this.leakTimeMinutes = leakTimeMinutes;
  }
  


  public int getPstmtCacheSize()
  {
    return pstmtCacheSize;
  }
  


  public void setPstmtCacheSize(int pstmtCacheSize)
  {
    this.pstmtCacheSize = pstmtCacheSize;
  }
  


  public int getCstmtCacheSize()
  {
    return cstmtCacheSize;
  }
  


  public void setCstmtCacheSize(int cstmtCacheSize)
  {
    this.cstmtCacheSize = cstmtCacheSize;
  }
  



  public int getWaitTimeoutMillis()
  {
    return waitTimeoutMillis;
  }
  



  public void setWaitTimeoutMillis(int waitTimeoutMillis)
  {
    this.waitTimeoutMillis = waitTimeoutMillis;
  }
  







  public int getMaxInactiveTimeSecs()
  {
    return maxInactiveTimeSecs;
  }
  







  public void setMaxInactiveTimeSecs(int maxInactiveTimeSecs)
  {
    this.maxInactiveTimeSecs = maxInactiveTimeSecs;
  }
  


  public String getPoolListener()
  {
    return poolListener;
  }
  



  public void setPoolListener(String poolListener)
  {
    this.poolListener = poolListener;
  }
  






  public boolean isOffline()
  {
    return offline;
  }
  










  public void setOffline(boolean offline)
  {
    this.offline = offline;
  }
  



  public void loadSettings(String serverName)
  {
    String prefix = "datasource." + serverName + ".";
    
    username = GlobalProperties.get(prefix + "username", null);
    password = GlobalProperties.get(prefix + "password", null);
    


    String v = GlobalProperties.get(prefix + "databaseDriver", null);
    driver = GlobalProperties.get(prefix + "driver", v);
    

    v = GlobalProperties.get(prefix + "databaseUrl", null);
    url = GlobalProperties.get(prefix + "url", v);
    
    captureStackTrace = GlobalProperties.getBoolean(prefix + "captureStackTrace", false);
    maxStackTraceSize = GlobalProperties.getInt(prefix + "maxStackTraceSize", 5);
    leakTimeMinutes = GlobalProperties.getInt(prefix + "leakTimeMinutes", 30);
    maxInactiveTimeSecs = GlobalProperties.getInt(prefix + "maxInactiveTimeSecs", 900);
    
    minConnections = GlobalProperties.getInt(prefix + "minConnections", 0);
    maxConnections = GlobalProperties.getInt(prefix + "maxConnections", 20);
    pstmtCacheSize = GlobalProperties.getInt(prefix + "pstmtCacheSize", 20);
    cstmtCacheSize = GlobalProperties.getInt(prefix + "cstmtCacheSize", 20);
    
    waitTimeoutMillis = GlobalProperties.getInt(prefix + "waitTimeout", 1000);
    
    heartbeatSql = GlobalProperties.get(prefix + "heartbeatSql", null);
    poolListener = GlobalProperties.get(prefix + "poolListener", null);
    offline = GlobalProperties.getBoolean(prefix + "offline", false);
    
    String isoLevel = GlobalProperties.get(prefix + "isolationlevel", "READ_COMMITTED");
    isolationLevel = TransactionIsolation.getLevel(isoLevel);
  }
}
