package com.avaje.ebean.config;

import com.avaje.ebean.LogLevel;
import com.avaje.ebean.config.dbplatform.DatabasePlatform;
import com.avaje.ebean.config.dbplatform.DbEncrypt;
import com.avaje.ebean.config.ldap.LdapConfig;
import com.avaje.ebean.config.ldap.LdapContextFactory;
import com.avaje.ebean.config.lucene.LuceneConfig;
import com.avaje.ebean.event.BeanPersistController;
import com.avaje.ebean.event.BeanPersistListener;
import com.avaje.ebean.event.BeanQueryAdapter;
import com.avaje.ebeaninternal.api.ClassUtil;
import com.avaje.ebeaninternal.server.core.DetectLucene;
import java.util.ArrayList;
import java.util.List;
import javax.sql.DataSource;























































































public class ServerConfig
{
  private static final int DEFAULT_QUERY_BATCH_SIZE = 100;
  private String name;
  private String resourceDirectory;
  private int enhanceLogLevel;
  private boolean register = true;
  



  private boolean defaultServer;
  



  private boolean validateOnSave = true;
  




  private List<Class<?>> classes = new ArrayList();
  




  private List<String> packages = new ArrayList();
  





  private List<String> searchJars = new ArrayList();
  

  private AutofetchConfig autofetchConfig = new AutofetchConfig();
  


  private String databasePlatformName;
  


  private DatabasePlatform databasePlatform;
  


  private int databaseSequenceBatchSize = 20;
  
  private boolean persistBatching;
  
  private int persistBatchSize = 20;
  

  private int lazyLoadBatchSize = 1;
  

  private int queryBatchSize = -1;
  


  private boolean ddlGenerate;
  


  private boolean ddlRun;
  

  private boolean debugSql;
  

  private boolean debugLazyLoad;
  

  private boolean useJtaTransactionManager;
  

  private ExternalTransactionManager externalTransactionManager;
  

  private boolean loggingToJavaLogger;
  

  private String loggingDirectory = "logs";
  



  private LogLevel loggingLevel = LogLevel.NONE;
  


  private PstmtDelegate pstmtDelegate;
  


  private DataSource dataSource;
  


  private DataSourceConfig dataSourceConfig = new DataSourceConfig();
  

  private String dataSourceJndiName;
  

  private String databaseBooleanTrue;
  

  private String databaseBooleanFalse;
  

  private NamingConvention namingConvention;
  

  private boolean updateChangesOnly = true;
  
  private List<BeanPersistController> persistControllers = new ArrayList();
  private List<BeanPersistListener<?>> persistListeners = new ArrayList();
  private List<BeanQueryAdapter> queryAdapters = new ArrayList();
  


  private EncryptKeyManager encryptKeyManager;
  


  private EncryptDeployManager encryptDeployManager;
  


  private Encryptor encryptor;
  


  private DbEncrypt dbEncrypt;
  


  private LdapConfig ldapConfig;
  


  private LuceneConfig luceneConfig;
  


  private boolean vanillaMode;
  


  private boolean vanillaRefMode;
  



  public String getName()
  {
    return name;
  }
  


  public void setName(String name)
  {
    this.name = name;
  }
  






  public boolean isRegister()
  {
    return register;
  }
  






  public void setRegister(boolean register)
  {
    this.register = register;
  }
  






  public boolean isDefaultServer()
  {
    return defaultServer;
  }
  






  public void setDefaultServer(boolean defaultServer)
  {
    this.defaultServer = defaultServer;
  }
  








  public boolean isPersistBatching()
  {
    return persistBatching;
  }
  

  /**
   * @deprecated
   */
  public boolean isUsePersistBatching()
  {
    return persistBatching;
  }
  








  public void setPersistBatching(boolean persistBatching)
  {
    this.persistBatching = persistBatching;
  }
  

  /**
   * @deprecated
   */
  public void setUsePersistBatching(boolean persistBatching)
  {
    this.persistBatching = persistBatching;
  }
  


  public int getPersistBatchSize()
  {
    return persistBatchSize;
  }
  


  public void setPersistBatchSize(int persistBatchSize)
  {
    this.persistBatchSize = persistBatchSize;
  }
  


  public int getLazyLoadBatchSize()
  {
    return lazyLoadBatchSize;
  }
  




  public int getQueryBatchSize()
  {
    return queryBatchSize;
  }
  




  public void setQueryBatchSize(int queryBatchSize)
  {
    this.queryBatchSize = queryBatchSize;
  }
  













  public void setLazyLoadBatchSize(int lazyLoadBatchSize)
  {
    this.lazyLoadBatchSize = lazyLoadBatchSize;
  }
  







  public void setDatabaseSequenceBatchSize(int databaseSequenceBatchSize)
  {
    this.databaseSequenceBatchSize = databaseSequenceBatchSize;
  }
  


  public boolean isUseJtaTransactionManager()
  {
    return useJtaTransactionManager;
  }
  


  public void setUseJtaTransactionManager(boolean useJtaTransactionManager)
  {
    this.useJtaTransactionManager = useJtaTransactionManager;
  }
  


  public ExternalTransactionManager getExternalTransactionManager()
  {
    return externalTransactionManager;
  }
  


  public void setExternalTransactionManager(ExternalTransactionManager externalTransactionManager)
  {
    this.externalTransactionManager = externalTransactionManager;
  }
  







  public boolean isVanillaMode()
  {
    return vanillaMode;
  }
  














  public void setVanillaMode(boolean vanillaMode)
  {
    this.vanillaMode = vanillaMode;
  }
  






  public boolean isVanillaRefMode()
  {
    return vanillaRefMode;
  }
  




  public void setVanillaRefMode(boolean vanillaRefMode)
  {
    this.vanillaRefMode = vanillaRefMode;
  }
  


  public boolean isValidateOnSave()
  {
    return validateOnSave;
  }
  


  public void setValidateOnSave(boolean validateOnSave)
  {
    this.validateOnSave = validateOnSave;
  }
  


  public int getEnhanceLogLevel()
  {
    return enhanceLogLevel;
  }
  


  public void setEnhanceLogLevel(int enhanceLogLevel)
  {
    this.enhanceLogLevel = enhanceLogLevel;
  }
  





  public NamingConvention getNamingConvention()
  {
    return namingConvention;
  }
  





  public void setNamingConvention(NamingConvention namingConvention)
  {
    this.namingConvention = namingConvention;
  }
  


  public AutofetchConfig getAutofetchConfig()
  {
    return autofetchConfig;
  }
  


  public void setAutofetchConfig(AutofetchConfig autofetchConfig)
  {
    this.autofetchConfig = autofetchConfig;
  }
  


  public PstmtDelegate getPstmtDelegate()
  {
    return pstmtDelegate;
  }
  






  public void setPstmtDelegate(PstmtDelegate pstmtDelegate)
  {
    this.pstmtDelegate = pstmtDelegate;
  }
  


  public DataSource getDataSource()
  {
    return dataSource;
  }
  


  public void setDataSource(DataSource dataSource)
  {
    this.dataSource = dataSource;
  }
  



  public DataSourceConfig getDataSourceConfig()
  {
    return dataSourceConfig;
  }
  



  public void setDataSourceConfig(DataSourceConfig dataSourceConfig)
  {
    this.dataSourceConfig = dataSourceConfig;
  }
  


  public String getDataSourceJndiName()
  {
    return dataSourceJndiName;
  }
  







  public void setDataSourceJndiName(String dataSourceJndiName)
  {
    this.dataSourceJndiName = dataSourceJndiName;
  }
  








  public String getDatabaseBooleanTrue()
  {
    return databaseBooleanTrue;
  }
  








  public void setDatabaseBooleanTrue(String databaseTrue)
  {
    databaseBooleanTrue = databaseTrue;
  }
  








  public String getDatabaseBooleanFalse()
  {
    return databaseBooleanFalse;
  }
  








  public void setDatabaseBooleanFalse(String databaseFalse)
  {
    databaseBooleanFalse = databaseFalse;
  }
  


  public int getDatabaseSequenceBatchSize()
  {
    return databaseSequenceBatchSize;
  }
  














  public void setDatabaseSequenceBatch(int databaseSequenceBatchSize)
  {
    this.databaseSequenceBatchSize = databaseSequenceBatchSize;
  }
  






  public String getDatabasePlatformName()
  {
    return databasePlatformName;
  }
  

















  public void setDatabasePlatformName(String databasePlatformName)
  {
    this.databasePlatformName = databasePlatformName;
  }
  


  public DatabasePlatform getDatabasePlatform()
  {
    return databasePlatform;
  }
  






  public void setDatabasePlatform(DatabasePlatform databasePlatform)
  {
    this.databasePlatform = databasePlatform;
  }
  


  public EncryptKeyManager getEncryptKeyManager()
  {
    return encryptKeyManager;
  }
  














  public void setEncryptKeyManager(EncryptKeyManager encryptKeyManager)
  {
    this.encryptKeyManager = encryptKeyManager;
  }
  






  public EncryptDeployManager getEncryptDeployManager()
  {
    return encryptDeployManager;
  }
  






  public void setEncryptDeployManager(EncryptDeployManager encryptDeployManager)
  {
    this.encryptDeployManager = encryptDeployManager;
  }
  



  public Encryptor getEncryptor()
  {
    return encryptor;
  }
  







  public void setEncryptor(Encryptor encryptor)
  {
    this.encryptor = encryptor;
  }
  






  public DbEncrypt getDbEncrypt()
  {
    return dbEncrypt;
  }
  






  public void setDbEncrypt(DbEncrypt dbEncrypt)
  {
    this.dbEncrypt = dbEncrypt;
  }
  






  public boolean isDebugSql()
  {
    return debugSql;
  }
  






  public void setDebugSql(boolean debugSql)
  {
    this.debugSql = debugSql;
  }
  


  public boolean isDebugLazyLoad()
  {
    return debugLazyLoad;
  }
  


  public void setDebugLazyLoad(boolean debugLazyLoad)
  {
    this.debugLazyLoad = debugLazyLoad;
  }
  





  public LogLevel getLoggingLevel()
  {
    return loggingLevel;
  }
  





  public void setLoggingLevel(LogLevel logLevel)
  {
    loggingLevel = logLevel;
  }
  


  public String getLoggingDirectory()
  {
    return loggingDirectory;
  }
  



  public String getLoggingDirectoryWithEval()
  {
    return GlobalProperties.evaluateExpressions(loggingDirectory);
  }
  
















  public void setLoggingDirectory(String loggingDirectory)
  {
    this.loggingDirectory = loggingDirectory;
  }
  







  public boolean isLoggingToJavaLogger()
  {
    return loggingToJavaLogger;
  }
  




  public void setLoggingToJavaLogger(boolean transactionLogToJavaLogger)
  {
    loggingToJavaLogger = transactionLogToJavaLogger;
  }
  

  /**
   * @deprecated
   */
  public boolean isUseJuliTransactionLogger()
  {
    return isLoggingToJavaLogger();
  }
  

  /**
   * @deprecated
   */
  public void setUseJuliTransactionLogger(boolean transactionLogToJavaLogger)
  {
    setLoggingToJavaLogger(transactionLogToJavaLogger);
  }
  


  public void setDdlGenerate(boolean ddlGenerate)
  {
    this.ddlGenerate = ddlGenerate;
  }
  


  public void setDdlRun(boolean ddlRun)
  {
    this.ddlRun = ddlRun;
  }
  


  public boolean isDdlGenerate()
  {
    return ddlGenerate;
  }
  


  public boolean isDdlRun()
  {
    return ddlRun;
  }
  


  public LdapConfig getLdapConfig()
  {
    return ldapConfig;
  }
  


  public void setLdapConfig(LdapConfig ldapConfig)
  {
    this.ldapConfig = ldapConfig;
  }
  


  public LuceneConfig getLuceneConfig()
  {
    return luceneConfig;
  }
  


  public void setLuceneConfig(LuceneConfig luceneConfig)
  {
    this.luceneConfig = luceneConfig;
  }
  


















  public void addClass(Class<?> cls)
  {
    if (classes == null) {
      classes = new ArrayList();
    }
    classes.add(cls);
  }
  





  public void addPackage(String packageName)
  {
    if (packages == null) {
      packages = new ArrayList();
    }
    packages.add(packageName);
  }
  





  public List<String> getPackages()
  {
    return packages;
  }
  





  public void setPackages(List<String> packages)
  {
    this.packages = packages;
  }
  
















  public void addJar(String jarName)
  {
    if (searchJars == null) {
      searchJars = new ArrayList();
    }
    searchJars.add(jarName);
  }
  





  public List<String> getJars()
  {
    return searchJars;
  }
  





  public void setJars(List<String> searchJars)
  {
    this.searchJars = searchJars;
  }
  










  public void setClasses(List<Class<?>> classes)
  {
    this.classes = classes;
  }
  



  public List<Class<?>> getClasses()
  {
    return classes;
  }
  


  public boolean isUpdateChangesOnly()
  {
    return updateChangesOnly;
  }
  


  public void setUpdateChangesOnly(boolean updateChangesOnly)
  {
    this.updateChangesOnly = updateChangesOnly;
  }
  


  public String getResourceDirectory()
  {
    return resourceDirectory;
  }
  


  public void setResourceDirectory(String resourceDirectory)
  {
    this.resourceDirectory = resourceDirectory;
  }
  






  public void add(BeanQueryAdapter beanQueryAdapter)
  {
    queryAdapters.add(beanQueryAdapter);
  }
  


  public List<BeanQueryAdapter> getQueryAdapters()
  {
    return queryAdapters;
  }
  






  public void setQueryAdapters(List<BeanQueryAdapter> queryAdapters)
  {
    this.queryAdapters = queryAdapters;
  }
  






  public void add(BeanPersistController beanPersistController)
  {
    persistControllers.add(beanPersistController);
  }
  


  public List<BeanPersistController> getPersistControllers()
  {
    return persistControllers;
  }
  






  public void setPersistControllers(List<BeanPersistController> persistControllers)
  {
    this.persistControllers = persistControllers;
  }
  






  public void add(BeanPersistListener<?> beanPersistListener)
  {
    persistListeners.add(beanPersistListener);
  }
  


  public List<BeanPersistListener<?>> getPersistListeners()
  {
    return persistListeners;
  }
  






  public void setPersistListeners(List<BeanPersistListener<?>> persistListeners)
  {
    this.persistListeners = persistListeners;
  }
  


  public void loadFromProperties()
  {
    ConfigPropertyMap p = new ConfigPropertyMap(name);
    loadSettings(p);
  }
  


  public GlobalProperties.PropertySource getPropertySource()
  {
    return GlobalProperties.getPropertySource(name);
  }
  


  public String getProperty(String propertyName, String defaultValue)
  {
    GlobalProperties.PropertySource p = new ConfigPropertyMap(name);
    return p.get(propertyName, defaultValue);
  }
  


  public String getProperty(String propertyName)
  {
    return getProperty(propertyName, null);
  }
  

  private <T> T createInstance(GlobalProperties.PropertySource p, Class<T> type, String key)
  {
    String classname = p.get(key, null);
    if (classname == null) {
      return null;
    }
    try
    {
      Class<?> cls = ClassUtil.forName(classname, getClass());
      return cls.newInstance();
    } catch (Exception e) {
      throw new RuntimeException(e);
    }
  }
  



  private void loadSettings(ConfigPropertyMap p)
  {
    if (autofetchConfig == null) {
      autofetchConfig = new AutofetchConfig();
    }
    autofetchConfig.loadSettings(p);
    if (dataSourceConfig == null) {
      dataSourceConfig = new DataSourceConfig();
    }
    dataSourceConfig.loadSettings(p.getServerName());
    
    if (ldapConfig == null) {
      LdapContextFactory ctxFact = (LdapContextFactory)createInstance(p, LdapContextFactory.class, "ldapContextFactory");
      if (ctxFact != null) {
        ldapConfig = new LdapConfig();
        ldapConfig.setContextFactory(ctxFact);
        ldapConfig.setVanillaMode(p.getBoolean("ldapVanillaMode", false));
      }
    }
    if ((luceneConfig == null) && 
      (DetectLucene.isPresent())) {
      luceneConfig = new LuceneConfig();
      luceneConfig.loadSettings(name);
    }
    

    useJtaTransactionManager = p.getBoolean("useJtaTransactionManager", false);
    namingConvention = createNamingConvention(p);
    databasePlatform = ((DatabasePlatform)createInstance(p, DatabasePlatform.class, "databasePlatform"));
    encryptKeyManager = ((EncryptKeyManager)createInstance(p, EncryptKeyManager.class, "encryptKeyManager"));
    encryptDeployManager = ((EncryptDeployManager)createInstance(p, EncryptDeployManager.class, "encryptDeployManager"));
    encryptor = ((Encryptor)createInstance(p, Encryptor.class, "encryptor"));
    dbEncrypt = ((DbEncrypt)createInstance(p, DbEncrypt.class, "dbEncrypt"));
    
    String jarsProp = p.get("search.jars", p.get("jars", null));
    if (jarsProp != null) {
      searchJars = getSearchJarsPackages(jarsProp);
    }
    
    String packagesProp = p.get("search.packages", p.get("packages", null));
    if (packages != null) {
      packages = getSearchJarsPackages(packagesProp);
    }
    
    vanillaMode = p.getBoolean("vanillaMode", false);
    vanillaRefMode = p.getBoolean("vanillaRefMode", false);
    updateChangesOnly = p.getBoolean("updateChangesOnly", true);
    
    boolean batchMode = p.getBoolean("batch.mode", false);
    persistBatching = p.getBoolean("persistBatching", batchMode);
    
    int batchSize = p.getInt("batch.size", 20);
    persistBatchSize = p.getInt("persistBatchSize", batchSize);
    
    dataSourceJndiName = p.get("dataSourceJndiName", null);
    databaseSequenceBatchSize = p.getInt("databaseSequenceBatchSize", 20);
    databaseBooleanTrue = p.get("databaseBooleanTrue", null);
    databaseBooleanFalse = p.get("databaseBooleanFalse", null);
    databasePlatformName = p.get("databasePlatformName", null);
    
    lazyLoadBatchSize = p.getInt("lazyLoadBatchSize", 1);
    queryBatchSize = p.getInt("queryBatchSize", 100);
    
    ddlGenerate = p.getBoolean("ddl.generate", false);
    ddlRun = p.getBoolean("ddl.run", false);
    debugSql = p.getBoolean("debug.sql", false);
    debugLazyLoad = p.getBoolean("debug.lazyload", false);
    
    loggingLevel = getLogLevelValue(p);
    
    String s = p.get("useJuliTransactionLogger", null);
    s = p.get("loggingToJavaLogger", s);
    loggingToJavaLogger = "true".equalsIgnoreCase(s);
    
    s = p.get("log.directory", "logs");
    loggingDirectory = p.get("logging.directory", s);
    
    classes = getClasses(p);
  }
  
  private LogLevel getLogLevelValue(ConfigPropertyMap p)
  {
    String logValue = p.get("logging", "NONE");
    logValue = p.get("log.level", logValue);
    logValue = p.get("logging.level", logValue);
    if (logValue.trim().equalsIgnoreCase("ALL")) {
      logValue = "SQL";
    }
    return (LogLevel)Enum.valueOf(LogLevel.class, logValue.toUpperCase());
  }
  
  private NamingConvention createNamingConvention(GlobalProperties.PropertySource p)
  {
    NamingConvention nc = (NamingConvention)createInstance(p, NamingConvention.class, "namingconvention");
    if (nc == null) {
      return null;
    }
    if ((nc instanceof AbstractNamingConvention)) {
      AbstractNamingConvention anc = (AbstractNamingConvention)nc;
      String v = p.get("namingConvention.useForeignKeyPrefix", null);
      if (v != null) {
        boolean useForeignKeyPrefix = Boolean.valueOf(v).booleanValue();
        anc.setUseForeignKeyPrefix(useForeignKeyPrefix);
      }
      
      String sequenceFormat = p.get("namingConvention.sequenceFormat", null);
      if (sequenceFormat != null) {
        anc.setSequenceFormat(sequenceFormat);
      }
    }
    return nc;
  }
  








  private ArrayList<Class<?>> getClasses(GlobalProperties.PropertySource p)
  {
    String classNames = p.get("classes", null);
    if (classNames == null)
    {
      return null;
    }
    
    ArrayList<Class<?>> classes = new ArrayList();
    
    String[] split = classNames.split("[ ,;]");
    for (int i = 0; i < split.length; i++) {
      String cn = split[i].trim();
      if ((cn.length() > 0) && (!"class".equalsIgnoreCase(cn))) {
        try {
          classes.add(ClassUtil.forName(cn, getClass()));
        } catch (ClassNotFoundException e) {
          String msg = "Error registering class [" + cn + "] from [" + classNames + "]";
          throw new RuntimeException(msg, e);
        }
      }
    }
    return classes;
  }
  
  private List<String> getSearchJarsPackages(String searchPackages)
  {
    List<String> hitList = new ArrayList();
    
    if (searchPackages != null)
    {
      String[] entries = searchPackages.split("[ ,;]");
      for (int i = 0; i < entries.length; i++) {
        hitList.add(entries[i].trim());
      }
    }
    return hitList;
  }
}
