package com.avaje.ebean.config;










public final class TableName
{
  private String catalog;
  








  private String schema;
  








  private String name;
  









  public TableName(String catalog, String schema, String name)
  {
    this.catalog = (catalog != null ? catalog.trim() : null);
    this.schema = (schema != null ? schema.trim() : null);
    this.name = (name != null ? name.trim() : null);
  }
  











  public TableName(String qualifiedTableName)
  {
    String[] split = qualifiedTableName.split("\\.");
    int len = split.length;
    if (split.length > 3) {
      String m = "Error splitting " + qualifiedTableName + ". Expecting at most 2 '.' characters";
      throw new RuntimeException(m);
    }
    if (len == 3) {
      catalog = split[0];
    }
    if (len >= 2) {
      schema = split[(len - 2)];
    }
    name = split[(len - 1)];
  }
  
  public String toString() {
    return getQualifiedName();
  }
  




  public String getCatalog()
  {
    return catalog;
  }
  




  public String getSchema()
  {
    return schema;
  }
  




  public String getName()
  {
    return name;
  }
  








  public String getQualifiedName()
  {
    StringBuilder buffer = new StringBuilder();
    

    if (catalog != null) {
      buffer.append(catalog);
    }
    

    if (schema != null) {
      if (buffer.length() > 0) {
        buffer.append(".");
      }
      buffer.append(schema);
    }
    
    if (buffer.length() > 0) {
      buffer.append(".");
    }
    buffer.append(name);
    
    return buffer.toString();
  }
  




  public boolean isValid()
  {
    return (name != null) && (name.length() > 0);
  }
}
