package com.avaje.ebean.config.dbplatform;

import com.avaje.ebean.BackgroundExecutor;
import javax.sql.DataSource;






public class DB2SequenceIdGenerator
  extends SequenceIdGenerator
{
  private final String baseSql;
  private final String unionBaseSql;
  
  public DB2SequenceIdGenerator(BackgroundExecutor be, DataSource ds, String seqName, int batchSize)
  {
    super(be, ds, seqName, batchSize);
    baseSql = ("select nextval for " + seqName);
    unionBaseSql = (" union " + baseSql);
  }
  
  public String getSql(int batchSize)
  {
    StringBuilder sb = new StringBuilder();
    sb.append(baseSql);
    for (int i = 1; i < batchSize; i++) {
      sb.append(unionBaseSql);
    }
    return sb.toString();
  }
}
