package com.avaje.ebean.config.dbplatform;

import com.avaje.ebean.BackgroundExecutor;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.sql.DataSource;



























public class DatabasePlatform
{
  private static final Logger logger = Logger.getLogger(DatabasePlatform.class.getName());
  

  protected String openQuote = "\"";
  

  protected String closeQuote = "\"";
  

  protected SqlLimiter sqlLimiter = new LimitOffsetSqlLimiter();
  

  protected DbTypeMap dbTypeMap = new DbTypeMap();
  

  protected DbDdlSyntax dbDdlSyntax = new DbDdlSyntax();
  

  protected DbIdentity dbIdentity = new DbIdentity();
  

  protected int booleanDbType = 16;
  

  protected int blobDbType = 2004;
  

  protected int clobDbType = 2005;
  

  protected boolean treatEmptyStringsAsNull;
  

  protected String name = "generic";
  



  private static final char BACK_TICK = '`';
  



  protected DbEncrypt dbEncrypt;
  



  protected boolean idInExpandedForm;
  



  protected boolean selectCountWithAlias;
  



  public String getName()
  {
    return name;
  }
  














  public IdGenerator createSequenceIdGenerator(BackgroundExecutor be, DataSource ds, String seqName, int batchSize)
  {
    return null;
  }
  


  public DbEncrypt getDbEncrypt()
  {
    return dbEncrypt;
  }
  


  public void setDbEncrypt(DbEncrypt dbEncrypt)
  {
    this.dbEncrypt = dbEncrypt;
  }
  




  public DbTypeMap getDbTypeMap()
  {
    return dbTypeMap;
  }
  




  public DbDdlSyntax getDbDdlSyntax()
  {
    return dbDdlSyntax;
  }
  




  public String getCloseQuote()
  {
    return closeQuote;
  }
  




  public String getOpenQuote()
  {
    return openQuote;
  }
  




  public int getBooleanDbType()
  {
    return booleanDbType;
  }
  






  public int getBlobDbType()
  {
    return blobDbType;
  }
  





  public int getClobDbType()
  {
    return clobDbType;
  }
  




  public boolean isTreatEmptyStringsAsNull()
  {
    return treatEmptyStringsAsNull;
  }
  




  public boolean isIdInExpandedForm()
  {
    return idInExpandedForm;
  }
  




  public DbIdentity getDbIdentity()
  {
    return dbIdentity;
  }
  








  public SqlLimiter getSqlLimiter()
  {
    return sqlLimiter;
  }
  











  public String convertQuotedIdentifiers(String dbName)
  {
    if ((dbName != null) && (dbName.length() > 0) && 
      (dbName.charAt(0) == '`')) {
      if (dbName.charAt(dbName.length() - 1) == '`')
      {
        String quotedName = getOpenQuote();
        quotedName = quotedName + dbName.substring(1, dbName.length() - 1);
        quotedName = quotedName + getCloseQuote();
        
        return quotedName;
      }
      
      logger.log(Level.SEVERE, "Missing backquote on [" + dbName + "]");
    }
    

    return dbName;
  }
  


  public boolean isSelectCountWithAlias()
  {
    return selectCountWithAlias;
  }
}
