package com.avaje.ebean.config.dbplatform;





public class DbDdlSyntax
{
  private boolean renderIndexForFkey = true;
  
  private boolean inlinePrimaryKeyConstraint = false;
  
  private boolean addOneToOneUniqueContraint = false;
  
  private int maxConstraintNameLength = 32;
  
  private int columnNameWidth = 25;
  
  private String dropTableCascade;
  
  private String dropIfExists;
  private String newLine = "\r\n";
  
  private String identity = "auto_increment";
  
  private String pkPrefix = "pk_";
  

  private String disableReferentialIntegrity;
  
  private String enableReferentialIntegrity;
  
  private String foreignKeySuffix;
  

  public String getPrimaryKeyName(String tableName)
  {
    String pk = pkPrefix + tableName;
    if (pk.length() > maxConstraintNameLength)
    {
      pk = pk.substring(0, maxConstraintNameLength);
    }
    return pk;
  }
  


  public String getIdentity()
  {
    return identity;
  }
  


  public void setIdentity(String identity)
  {
    this.identity = identity;
  }
  


  public int getColumnNameWidth()
  {
    return columnNameWidth;
  }
  


  public void setColumnNameWidth(int columnNameWidth)
  {
    this.columnNameWidth = columnNameWidth;
  }
  


  public String getNewLine()
  {
    return newLine;
  }
  


  public void setNewLine(String newLine)
  {
    this.newLine = newLine;
  }
  


  public String getPkPrefix()
  {
    return pkPrefix;
  }
  


  public void setPkPrefix(String pkPrefix)
  {
    this.pkPrefix = pkPrefix;
  }
  


  public String getDisableReferentialIntegrity()
  {
    return disableReferentialIntegrity;
  }
  


  public void setDisableReferentialIntegrity(String disableReferentialIntegrity)
  {
    this.disableReferentialIntegrity = disableReferentialIntegrity;
  }
  


  public String getEnableReferentialIntegrity()
  {
    return enableReferentialIntegrity;
  }
  


  public void setEnableReferentialIntegrity(String enableReferentialIntegrity)
  {
    this.enableReferentialIntegrity = enableReferentialIntegrity;
  }
  


  public boolean isRenderIndexForFkey()
  {
    return renderIndexForFkey;
  }
  


  public void setRenderIndexForFkey(boolean renderIndexForFkey)
  {
    this.renderIndexForFkey = renderIndexForFkey;
  }
  



  public String getDropIfExists()
  {
    return dropIfExists;
  }
  



  public void setDropIfExists(String dropIfExists)
  {
    this.dropIfExists = dropIfExists;
  }
  


  public String getDropTableCascade()
  {
    return dropTableCascade;
  }
  


  public void setDropTableCascade(String dropTableCascade)
  {
    this.dropTableCascade = dropTableCascade;
  }
  


  public String getForeignKeySuffix()
  {
    return foreignKeySuffix;
  }
  


  public void setForeignKeySuffix(String foreignKeySuffix)
  {
    this.foreignKeySuffix = foreignKeySuffix;
  }
  


  public int getMaxConstraintNameLength()
  {
    return maxConstraintNameLength;
  }
  


  public void setMaxConstraintNameLength(int maxFkeyLength)
  {
    maxConstraintNameLength = maxFkeyLength;
  }
  




  public boolean isAddOneToOneUniqueContraint()
  {
    return addOneToOneUniqueContraint;
  }
  


  public void setAddOneToOneUniqueContraint(boolean addOneToOneUniqueContraint)
  {
    this.addOneToOneUniqueContraint = addOneToOneUniqueContraint;
  }
  


  public boolean isInlinePrimaryKeyConstraint()
  {
    return inlinePrimaryKeyConstraint;
  }
  


  public void setInlinePrimaryKeyConstraint(boolean inlinePrimaryKeyConstraint)
  {
    this.inlinePrimaryKeyConstraint = inlinePrimaryKeyConstraint;
  }
  
  public String getIndexName(String table, String propName, int ixCount)
  {
    StringBuilder buffer = new StringBuilder();
    buffer.append("ix_");
    buffer.append(table);
    buffer.append("_");
    buffer.append(propName);
    
    addSuffix(buffer, ixCount);
    
    return buffer.toString();
  }
  
  public String getForeignKeyName(String table, String propName, int fkCount)
  {
    StringBuilder buffer = new StringBuilder();
    buffer.append("fk_");
    buffer.append(table);
    buffer.append("_");
    buffer.append(propName);
    
    addSuffix(buffer, fkCount);
    
    return buffer.toString();
  }
  





  protected void addSuffix(StringBuilder buffer, int count)
  {
    String suffixNr = Integer.toString(count);
    int suffixLen = suffixNr.length() + 1;
    
    if (buffer.length() + suffixLen > maxConstraintNameLength) {
      buffer.setLength(maxConstraintNameLength - suffixLen);
    }
    buffer.append("_");
    buffer.append(suffixNr);
  }
}
