package com.avaje.ebean.config.dbplatform;

import com.avaje.ebean.BackgroundExecutor;
import com.avaje.ebean.config.GlobalProperties;
import javax.sql.DataSource;























public class H2Platform
  extends DatabasePlatform
{
  public H2Platform()
  {
    name = "h2";
    dbEncrypt = new H2DbEncrypt();
    


    boolean useIdentity = GlobalProperties.getBoolean("ebean.h2platform.useIdentity", false);
    
    IdType idType = useIdentity ? IdType.IDENTITY : IdType.SEQUENCE;
    dbIdentity.setIdType(idType);
    
    dbIdentity.setSupportsGetGeneratedKeys(true);
    dbIdentity.setSupportsSequence(true);
    dbIdentity.setSupportsIdentity(true);
    
    openQuote = "\"";
    closeQuote = "\"";
    



    dbDdlSyntax.setDropIfExists("if exists");
    dbDdlSyntax.setDisableReferentialIntegrity("SET REFERENTIAL_INTEGRITY FALSE");
    dbDdlSyntax.setEnableReferentialIntegrity("SET REFERENTIAL_INTEGRITY TRUE");
    dbDdlSyntax.setForeignKeySuffix("on delete restrict on update restrict");
  }
  






  public IdGenerator createSequenceIdGenerator(BackgroundExecutor be, DataSource ds, String seqName, int batchSize)
  {
    return new H2SequenceIdGenerator(be, ds, seqName, batchSize);
  }
}
