package com.avaje.ebean.config.dbplatform;

import com.avaje.ebean.BackgroundExecutor;
import com.avaje.ebean.config.GlobalProperties;
import javax.sql.DataSource;

























public class HsqldbPlatform
  extends DatabasePlatform
{
  public HsqldbPlatform()
  {
    name = "hsqldb";
    dbEncrypt = new H2DbEncrypt();
    


    boolean useIdentity = GlobalProperties.getBoolean("ebean.hsqldb.useIdentity", true);
    
    IdType idType = useIdentity ? IdType.IDENTITY : IdType.SEQUENCE;
    dbIdentity.setIdType(idType);
    
    dbIdentity.setSupportsGetGeneratedKeys(true);
    dbIdentity.setSupportsSequence(true);
    dbIdentity.setSupportsIdentity(true);
    
    openQuote = "\"";
    closeQuote = "\"";
    


    dbTypeMap.put(4, new DbType("integer", false));
    
    dbDdlSyntax.setDropIfExists("if exists");
    dbDdlSyntax.setDisableReferentialIntegrity("SET DATABASE REFERENTIAL INTEGRITY FALSE");
    dbDdlSyntax.setEnableReferentialIntegrity("SET DATABASE REFERENTIAL INTEGRITY TRUE");
    dbDdlSyntax.setForeignKeySuffix("on delete restrict on update restrict");
    dbDdlSyntax.setIdentity("GENERATED BY DEFAULT AS IDENTITY (START WITH 1) ");
  }
  






  public IdGenerator createSequenceIdGenerator(BackgroundExecutor be, DataSource ds, String seqName, int batchSize)
  {
    return new H2SequenceIdGenerator(be, ds, seqName, batchSize);
  }
}
