package com.avaje.ebean.config.dbplatform;

import com.avaje.ebean.BackgroundExecutor;
import javax.sql.DataSource;



































public class MySqlPlatform
  extends DatabasePlatform
{
  public MySqlPlatform()
  {
    name = "mysql";
    selectCountWithAlias = true;
    dbEncrypt = new MySqlDbEncrypt();
    
    dbIdentity.setIdType(IdType.IDENTITY);
    dbIdentity.setSupportsGetGeneratedKeys(true);
    dbIdentity.setSupportsIdentity(true);
    dbIdentity.setSupportsSequence(false);
    
    openQuote = "`";
    closeQuote = "`";
    
    booleanDbType = -7;
    
    dbTypeMap.put(-7, new DbType("tinyint(1) default 0"));
    dbTypeMap.put(16, new DbType("tinyint(1) default 0"));
    dbTypeMap.put(93, new DbType("datetime"));
    dbTypeMap.put(2005, new MySqlClob());
    dbTypeMap.put(2004, new MySqlBlob());
    dbTypeMap.put(-2, new DbType("binary", 255));
    dbTypeMap.put(-3, new DbType("varbinary", 255));
    
    dbDdlSyntax.setDisableReferentialIntegrity("SET FOREIGN_KEY_CHECKS=0");
    dbDdlSyntax.setEnableReferentialIntegrity("SET FOREIGN_KEY_CHECKS=1");
    dbDdlSyntax.setForeignKeySuffix("on delete restrict on update restrict");
  }
  






  public IdGenerator createSequenceIdGenerator(BackgroundExecutor be, DataSource ds, String seqName, int batchSize)
  {
    return null;
  }
}
