package com.avaje.ebean.config.dbplatform;

import com.avaje.ebean.config.GlobalProperties;


































































public class Oracle10DbEncrypt
  extends AbstractDbEncrypt
{
  public Oracle10DbEncrypt()
  {
    String encryptfunction = GlobalProperties.get("ebean.oracle.encryptfunction", "eb_encrypt");
    String decryptfunction = GlobalProperties.get("ebean.oracle.decryptfunction", "eb_decrypt");
    
    varcharEncryptFunction = new OraVarcharFunction(encryptfunction, decryptfunction);
    dateEncryptFunction = new OraDateFunction(encryptfunction, decryptfunction);
  }
  

  private static class OraVarcharFunction
    implements DbEncryptFunction
  {
    private final String encryptfunction;
    private final String decryptfunction;
    
    public OraVarcharFunction(String encryptfunction, String decryptfunction)
    {
      this.encryptfunction = encryptfunction;
      this.decryptfunction = decryptfunction;
    }
    
    public String getDecryptSql(String columnWithTableAlias) {
      return decryptfunction + "(" + columnWithTableAlias + ",?)";
    }
    
    public String getEncryptBindSql() {
      return encryptfunction + "(?,?)";
    }
  }
  

  private static class OraDateFunction
    implements DbEncryptFunction
  {
    private final String encryptfunction;
    
    private final String decryptfunction;
    
    public OraDateFunction(String encryptfunction, String decryptfunction)
    {
      this.encryptfunction = encryptfunction;
      this.decryptfunction = decryptfunction;
    }
    
    public String getDecryptSql(String columnWithTableAlias) {
      return "to_date(" + decryptfunction + "(" + columnWithTableAlias + ",?),'YYYYMMDD')";
    }
    
    public String getEncryptBindSql() {
      return encryptfunction + "(to_char(?,'YYYYMMDD'),?)";
    }
  }
}
