package com.avaje.ebean.config.dbplatform;

import com.avaje.ebean.BackgroundExecutor;
import javax.sql.DataSource;


























public class Oracle10Platform
  extends DatabasePlatform
{
  public Oracle10Platform()
  {
    name = "oracle";
    dbEncrypt = new Oracle10DbEncrypt();
    
    sqlLimiter = new RownumSqlLimiter();
    


    dbIdentity.setSupportsGetGeneratedKeys(false);
    dbIdentity.setIdType(IdType.SEQUENCE);
    dbIdentity.setSupportsSequence(true);
    
    treatEmptyStringsAsNull = true;
    
    openQuote = "\"";
    closeQuote = "\"";
    
    booleanDbType = 4;
    dbTypeMap.put(16, new DbType("number(1) default 0"));
    
    dbTypeMap.put(4, new DbType("number", 10));
    dbTypeMap.put(-5, new DbType("number", 19));
    dbTypeMap.put(7, new DbType("number", 19, 4));
    dbTypeMap.put(8, new DbType("number", 19, 4));
    dbTypeMap.put(5, new DbType("number", 5));
    dbTypeMap.put(-6, new DbType("number", 3));
    dbTypeMap.put(3, new DbType("number", 38));
    
    dbTypeMap.put(12, new DbType("varchar2", 255));
    
    dbTypeMap.put(-4, new DbType("blob"));
    dbTypeMap.put(-1, new DbType("clob"));
    dbTypeMap.put(-3, new DbType("raw", 255));
    dbTypeMap.put(-2, new DbType("raw", 255));
    
    dbTypeMap.put(92, new DbType("timestamp"));
    

    dbDdlSyntax.setDropTableCascade("cascade constraints purge");
    dbDdlSyntax.setIdentity(null);
    dbDdlSyntax.setMaxConstraintNameLength(30);
  }
  


  public IdGenerator createSequenceIdGenerator(BackgroundExecutor be, DataSource ds, String seqName, int batchSize)
  {
    return new OracleSequenceIdGenerator(be, ds, seqName, batchSize);
  }
}
