package com.avaje.ebean.config.dbplatform;

import com.avaje.ebean.BackgroundExecutor;
import com.avaje.ebean.config.GlobalProperties;
import javax.sql.DataSource;





























public class PostgresPlatform
  extends DatabasePlatform
{
  public PostgresPlatform()
  {
    name = "postgres";
    selectCountWithAlias = true;
    blobDbType = -4;
    clobDbType = 12;
    
    dbEncrypt = new PostgresDbEncrypt();
    
    dbIdentity.setSupportsGetGeneratedKeys(false);
    dbIdentity.setIdType(IdType.SEQUENCE);
    dbIdentity.setSupportsSequence(true);
    
    String colAlias = GlobalProperties.get("ebean.columnAliasPrefix", null);
    if (colAlias == null)
    {
      GlobalProperties.put("ebean.columnAliasPrefix", "as c");
    }
    
    openQuote = "\"";
    closeQuote = "\"";
    


    dbTypeMap.put(4, new DbType("integer", false));
    dbTypeMap.put(8, new DbType("float"));
    dbTypeMap.put(-6, new DbType("smallint"));
    dbTypeMap.put(3, new DbType("decimal", 38));
    
    dbTypeMap.put(-2, new DbType("bytea", false));
    dbTypeMap.put(-3, new DbType("bytea", false));
    
    dbTypeMap.put(2004, new DbType("bytea", false));
    dbTypeMap.put(2005, new DbType("text"));
    dbTypeMap.put(-4, new DbType("bytea", false));
    dbTypeMap.put(-1, new DbType("text"));
    
    dbDdlSyntax.setDropTableCascade("cascade");
    dbDdlSyntax.setDropIfExists("if exists");
  }
  






  public IdGenerator createSequenceIdGenerator(BackgroundExecutor be, DataSource ds, String seqName, int batchSize)
  {
    return new PostgresSequenceIdGenerator(be, ds, seqName, batchSize);
  }
}
