package com.avaje.ebean.config.dbplatform;

import com.avaje.ebean.BackgroundExecutor;
import javax.sql.DataSource;



public class SQLitePlatform
  extends DatabasePlatform
{
  public SQLitePlatform()
  {
    name = "sqlite";
    
    dbIdentity.setIdType(IdType.IDENTITY);
    dbIdentity.setSupportsGetGeneratedKeys(false);
    dbIdentity.setSelectLastInsertedIdTemplate("select last_insert_rowid()");
    openQuote = "\"";
    closeQuote = "\"";
    
    booleanDbType = 4;
    
    dbTypeMap.put(-7, new DbType("int default 0"));
    dbTypeMap.put(16, new DbType("int default 0"));
    
    dbDdlSyntax.setInlinePrimaryKeyConstraint(true);
    dbDdlSyntax.setIdentity("AUTOINCREMENT");
    dbDdlSyntax.setDisableReferentialIntegrity("PRAGMA foreign_keys = OFF");
    dbDdlSyntax.setEnableReferentialIntegrity("PRAGMA foreign_keys = ON");
  }
  





  public IdGenerator createSequenceIdGenerator(BackgroundExecutor be, DataSource ds, String seqName, int batchSize)
  {
    return null;
  }
}
