package com.avaje.ebean.config.lucene;

import java.util.List;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.index.IndexWriter.MaxFieldLength;

public abstract interface IndexDefn<T>
{
  public abstract void initialise(IndexDefnBuilder paramIndexDefnBuilder);
  
  public abstract String getDefaultField();
  
  public abstract List<IndexFieldDefn> getFields();
  
  public abstract boolean isUpdateSinceSupported();
  
  public abstract String[] getUpdateSinceProperties();
  
  public abstract Analyzer getAnalyzer();
  
  public abstract IndexWriter.MaxFieldLength getMaxFieldLength();
  
  public abstract int getMaxBufferedDocs();
  
  public abstract double getRAMBufferSizeMB();
  
  public abstract int getTermIndexInterval();
}
