package com.avaje.ebean.config.lucene;

import com.avaje.ebean.Query.UseIndex;
import com.avaje.ebean.config.GlobalProperties;
import com.avaje.ebean.config.GlobalProperties.PropertySource;
import org.apache.lucene.analysis.Analyzer;






























public class LuceneConfig
{
  protected String baseDirectory;
  protected Analyzer defaultAnalyzer;
  protected Query.UseIndex defaultUseIndex;
  
  public Analyzer getDefaultAnalyzer()
  {
    return defaultAnalyzer;
  }
  


  public void setDefaultAnalyzer(Analyzer defaultAnalyzer)
  {
    this.defaultAnalyzer = defaultAnalyzer;
  }
  


  public String getBaseDirectory()
  {
    return baseDirectory;
  }
  


  public void setBaseDirectory(String baseDirectory)
  {
    this.baseDirectory = baseDirectory;
  }
  


  public Query.UseIndex getDefaultUseIndex()
  {
    return defaultUseIndex;
  }
  


  public void setDefaultUseIndex(Query.UseIndex defaultUseIndex)
  {
    this.defaultUseIndex = defaultUseIndex;
  }
  



  public void loadSettings(String serverName)
  {
    GlobalProperties.PropertySource p = GlobalProperties.getPropertySource(serverName);
    
    baseDirectory = p.get("lucene.baseDirectory", "lucene");
    defaultUseIndex = ((Query.UseIndex)p.getEnum(Query.UseIndex.class, "lucene.useIndex", Query.UseIndex.NO));
  }
}
