package com.avaje.ebean.enhance.agent;

import java.util.ArrayList;
import java.util.HashMap;




public class AnnotationInfo
{
  final HashMap<String, Object> valueMap = new HashMap();
  

  AnnotationInfo parent;
  


  public AnnotationInfo(AnnotationInfo parent)
  {
    this.parent = parent;
  }
  
  public String toString() {
    return valueMap.toString();
  }
  
  public AnnotationInfo getParent()
  {
    return parent;
  }
  
  public void setParent(AnnotationInfo parent) {
    this.parent = parent;
  }
  



  public void add(String prefix, String name, Object value)
  {
    if (name == null)
    {
      ArrayList<Object> list = (ArrayList)valueMap.get(prefix);
      if (list == null) {
        list = new ArrayList();
        valueMap.put(prefix, list);
      }
      
      list.add(value);
    }
    else {
      String key = getKey(prefix, name);
      
      valueMap.put(key, value);
    }
  }
  



  public void addEnum(String prefix, String name, String desc, String value)
  {
    add(prefix, name, value);
  }
  
  private String getKey(String prefix, String name) {
    if (prefix == null) {
      return name;
    }
    return prefix + "." + name;
  }
  



  public Object getValue(String key)
  {
    Object o = valueMap.get(key);
    if ((o == null) && (parent != null))
    {
      o = parent.getValue(key);
    }
    return o;
  }
}
