package com.avaje.ebean.enhance.asm;







public class ClassWriter
  implements ClassVisitor
{
  public static final int COMPUTE_MAXS = 1;
  





  public static final int COMPUTE_FRAMES = 2;
  





  static final int NOARG_INSN = 0;
  





  static final int SBYTE_INSN = 1;
  





  static final int SHORT_INSN = 2;
  





  static final int VAR_INSN = 3;
  





  static final int IMPLVAR_INSN = 4;
  





  static final int TYPE_INSN = 5;
  





  static final int FIELDORMETH_INSN = 6;
  





  static final int ITFMETH_INSN = 7;
  





  static final int LABEL_INSN = 8;
  





  static final int LABELW_INSN = 9;
  





  static final int LDC_INSN = 10;
  





  static final int LDCW_INSN = 11;
  





  static final int IINC_INSN = 12;
  





  static final int TABL_INSN = 13;
  





  static final int LOOK_INSN = 14;
  





  static final int MANA_INSN = 15;
  





  static final int WIDE_INSN = 16;
  





  static final byte[] TYPE;
  





  static final int CLASS = 7;
  





  static final int FIELD = 9;
  





  static final int METH = 10;
  





  static final int IMETH = 11;
  





  static final int STR = 8;
  




  static final int INT = 3;
  




  static final int FLOAT = 4;
  




  static final int LONG = 5;
  




  static final int DOUBLE = 6;
  




  static final int NAME_TYPE = 12;
  




  static final int UTF8 = 1;
  




  static final int TYPE_NORMAL = 13;
  




  static final int TYPE_UNINIT = 14;
  




  static final int TYPE_MERGED = 15;
  




  ClassReader cr;
  




  int version;
  




  int index;
  




  final ByteVector pool;
  




  Item[] items;
  




  int threshold;
  




  final Item key;
  




  final Item key2;
  




  final Item key3;
  




  Item[] typeTable;
  




  private short typeCount;
  




  private int access;
  




  private int name;
  




  String thisName;
  




  private int signature;
  




  private int superName;
  




  private int interfaceCount;
  




  private int[] interfaces;
  




  private int sourceFile;
  




  private ByteVector sourceDebug;
  




  private int enclosingMethodOwner;
  




  private int enclosingMethod;
  




  private AnnotationWriter anns;
  




  private AnnotationWriter ianns;
  




  private Attribute attrs;
  




  private int innerClassesCount;
  




  private ByteVector innerClasses;
  




  FieldWriter firstField;
  




  FieldWriter lastField;
  




  MethodWriter firstMethod;
  




  MethodWriter lastMethod;
  




  private final boolean computeMaxs;
  




  private final boolean computeFrames;
  




  boolean invalidFrames;
  





  static
  {
    byte[] b = new byte['Ü'];
    String s = "AAAAAAAAAAAAAAAABCKLLDDDDDEEEEEEEEEEEEEEEEEEEEAAAAAAAADDDDDEEEEEEEEEEEEEEEEEEEEAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAMAAAAAAAAAAAAAAAAAAAAIIIIIIIIIIIIIIIIDNOAAAAAAGGGGGGGHAFBFAAFFAAQPIIJJIIIIIIIIIIIIIIIIII";
    


    for (int i = 0; i < b.length; i++) {
      b[i] = ((byte)(s.charAt(i) - 'A'));
    }
    TYPE = b;
  }
  












































































  public ClassWriter(int flags)
  {
    index = 1;
    pool = new ByteVector();
    items = new Item[256];
    threshold = ((int)(0.75D * items.length));
    key = new Item();
    key2 = new Item();
    key3 = new Item();
    computeMaxs = ((flags & 0x1) != 0);
    computeFrames = ((flags & 0x2) != 0);
  }
  























  public ClassWriter(ClassReader classReader, int flags)
  {
    this(flags);
    classReader.copyPool(this);
    cr = classReader;
  }
  










  public void visit(int version, int access, String name, String signature, String superName, String[] interfaces)
  {
    this.version = version;
    this.access = access;
    this.name = newClass(name);
    thisName = name;
    if (signature != null) {
      this.signature = newUTF8(signature);
    }
    this.superName = (superName == null ? 0 : newClass(superName));
    if ((interfaces != null) && (interfaces.length > 0)) {
      interfaceCount = interfaces.length;
      this.interfaces = new int[interfaceCount];
      for (int i = 0; i < interfaceCount; i++) {
        this.interfaces[i] = newClass(interfaces[i]);
      }
    }
  }
  
  public void visitSource(String file, String debug) {
    if (file != null) {
      sourceFile = newUTF8(file);
    }
    if (debug != null) {
      sourceDebug = new ByteVector().putUTF8(debug);
    }
  }
  



  public void visitOuterClass(String owner, String name, String desc)
  {
    enclosingMethodOwner = newClass(owner);
    if ((name != null) && (desc != null)) {
      enclosingMethod = newNameType(name, desc);
    }
  }
  





  public AnnotationVisitor visitAnnotation(String desc, boolean visible)
  {
    ByteVector bv = new ByteVector();
    
    bv.putShort(newUTF8(desc)).putShort(0);
    AnnotationWriter aw = new AnnotationWriter(this, true, bv, bv, 2);
    if (visible) {
      next = anns;
      anns = aw;
    } else {
      next = ianns;
      ianns = aw;
    }
    return aw;
  }
  
  public void visitAttribute(Attribute attr) {
    next = attrs;
    attrs = attr;
  }
  




  public void visitInnerClass(String name, String outerName, String innerName, int access)
  {
    if (innerClasses == null) {
      innerClasses = new ByteVector();
    }
    innerClassesCount += 1;
    innerClasses.putShort(name == null ? 0 : newClass(name));
    innerClasses.putShort(outerName == null ? 0 : newClass(outerName));
    innerClasses.putShort(innerName == null ? 0 : newUTF8(innerName));
    innerClasses.putShort(access);
  }
  





  public FieldVisitor visitField(int access, String name, String desc, String signature, Object value)
  {
    return new FieldWriter(this, access, name, desc, signature, value);
  }
  





  public MethodVisitor visitMethod(int access, String name, String desc, String signature, String[] exceptions)
  {
    return new MethodWriter(this, access, name, desc, signature, exceptions, computeMaxs, computeFrames);
  }
  



















  public byte[] toByteArray()
  {
    int size = 24 + 2 * interfaceCount;
    int nbFields = 0;
    FieldWriter fb = firstField;
    while (fb != null) {
      nbFields++;
      size += fb.getSize();
      fb = next;
    }
    int nbMethods = 0;
    MethodWriter mb = firstMethod;
    while (mb != null) {
      nbMethods++;
      size += mb.getSize();
      mb = next;
    }
    int attributeCount = 0;
    if (signature != 0) {
      attributeCount++;
      size += 8;
      newUTF8("Signature");
    }
    if (sourceFile != 0) {
      attributeCount++;
      size += 8;
      newUTF8("SourceFile");
    }
    if (sourceDebug != null) {
      attributeCount++;
      size += sourceDebug.length + 4;
      newUTF8("SourceDebugExtension");
    }
    if (enclosingMethodOwner != 0) {
      attributeCount++;
      size += 10;
      newUTF8("EnclosingMethod");
    }
    if ((access & 0x20000) != 0) {
      attributeCount++;
      size += 6;
      newUTF8("Deprecated");
    }
    if (((access & 0x1000) != 0) && ((version & 0xFFFF) < 49))
    {

      attributeCount++;
      size += 6;
      newUTF8("Synthetic");
    }
    if (innerClasses != null) {
      attributeCount++;
      size += 8 + innerClasses.length;
      newUTF8("InnerClasses");
    }
    if (anns != null) {
      attributeCount++;
      size += 8 + anns.getSize();
      newUTF8("RuntimeVisibleAnnotations");
    }
    if (ianns != null) {
      attributeCount++;
      size += 8 + ianns.getSize();
      newUTF8("RuntimeInvisibleAnnotations");
    }
    if (attrs != null) {
      attributeCount += attrs.getCount();
      size += attrs.getSize(this, null, 0, -1, -1);
    }
    size += pool.length;
    

    ByteVector out = new ByteVector(size);
    out.putInt(-889275714).putInt(version);
    out.putShort(index).putByteArray(pool.data, 0, pool.length);
    out.putShort(access).putShort(name).putShort(superName);
    out.putShort(interfaceCount);
    for (int i = 0; i < interfaceCount; i++) {
      out.putShort(interfaces[i]);
    }
    out.putShort(nbFields);
    fb = firstField;
    while (fb != null) {
      fb.put(out);
      fb = next;
    }
    out.putShort(nbMethods);
    mb = firstMethod;
    while (mb != null) {
      mb.put(out);
      mb = next;
    }
    out.putShort(attributeCount);
    if (signature != 0) {
      out.putShort(newUTF8("Signature")).putInt(2).putShort(signature);
    }
    if (sourceFile != 0) {
      out.putShort(newUTF8("SourceFile")).putInt(2).putShort(sourceFile);
    }
    if (sourceDebug != null) {
      int len = sourceDebug.length - 2;
      out.putShort(newUTF8("SourceDebugExtension")).putInt(len);
      out.putByteArray(sourceDebug.data, 2, len);
    }
    if (enclosingMethodOwner != 0) {
      out.putShort(newUTF8("EnclosingMethod")).putInt(4);
      out.putShort(enclosingMethodOwner).putShort(enclosingMethod);
    }
    if ((access & 0x20000) != 0) {
      out.putShort(newUTF8("Deprecated")).putInt(0);
    }
    if (((access & 0x1000) != 0) && ((version & 0xFFFF) < 49))
    {

      out.putShort(newUTF8("Synthetic")).putInt(0);
    }
    if (innerClasses != null) {
      out.putShort(newUTF8("InnerClasses"));
      out.putInt(innerClasses.length + 2).putShort(innerClassesCount);
      out.putByteArray(innerClasses.data, 0, innerClasses.length);
    }
    if (anns != null) {
      out.putShort(newUTF8("RuntimeVisibleAnnotations"));
      anns.put(out);
    }
    if (ianns != null) {
      out.putShort(newUTF8("RuntimeInvisibleAnnotations"));
      ianns.put(out);
    }
    if (attrs != null) {
      attrs.put(this, null, 0, -1, -1, out);
    }
    if (invalidFrames) {
      ClassWriter cw = new ClassWriter(2);
      new ClassReader(data).accept(cw, 4);
      return cw.toByteArray();
    }
    return data;
  }
  













  Item newConstItem(Object cst)
  {
    if ((cst instanceof Integer)) {
      int val = ((Integer)cst).intValue();
      return newInteger(val); }
    if ((cst instanceof Byte)) {
      int val = ((Byte)cst).intValue();
      return newInteger(val); }
    if ((cst instanceof Character)) {
      int val = ((Character)cst).charValue();
      return newInteger(val); }
    if ((cst instanceof Short)) {
      int val = ((Short)cst).intValue();
      return newInteger(val); }
    if ((cst instanceof Boolean)) {
      int val = ((Boolean)cst).booleanValue() ? 1 : 0;
      return newInteger(val); }
    if ((cst instanceof Float)) {
      float val = ((Float)cst).floatValue();
      return newFloat(val); }
    if ((cst instanceof Long)) {
      long val = ((Long)cst).longValue();
      return newLong(val); }
    if ((cst instanceof Double)) {
      double val = ((Double)cst).doubleValue();
      return newDouble(val); }
    if ((cst instanceof String))
      return newString((String)cst);
    if ((cst instanceof Type)) {
      Type t = (Type)cst;
      return newClassItem(t.getSort() == 10 ? t.getInternalName() : t.getDescriptor());
    }
    

    throw new IllegalArgumentException("value " + cst);
  }
  












  public int newConst(Object cst)
  {
    return newConstItemindex;
  }
  








  public int newUTF8(String value)
  {
    key.set(1, value, null, null);
    Item result = get(key);
    if (result == null) {
      pool.putByte(1).putUTF8(value);
      result = new Item(index++, key);
      put(result);
    }
    return index;
  }
  








  Item newClassItem(String value)
  {
    key2.set(7, value, null, null);
    Item result = get(key2);
    if (result == null) {
      pool.put12(7, newUTF8(value));
      result = new Item(index++, key2);
      put(result);
    }
    return result;
  }
  








  public int newClass(String value)
  {
    return newClassItemindex;
  }
  









  Item newFieldItem(String owner, String name, String desc)
  {
    key3.set(9, owner, name, desc);
    Item result = get(key3);
    if (result == null) {
      put122(9, newClass(owner), newNameType(name, desc));
      result = new Item(index++, key3);
      put(result);
    }
    return result;
  }
  











  public int newField(String owner, String name, String desc)
  {
    return newFieldItem, , index;
  }
  














  Item newMethodItem(String owner, String name, String desc, boolean itf)
  {
    int type = itf ? 11 : 10;
    key3.set(type, owner, name, desc);
    Item result = get(key3);
    if (result == null) {
      put122(type, newClass(owner), newNameType(name, desc));
      result = new Item(index++, key3);
      put(result);
    }
    return result;
  }
  
















  public int newMethod(String owner, String name, String desc, boolean itf)
  {
    return newMethodItem, , , index;
  }
  






  Item newInteger(int value)
  {
    key.set(value);
    Item result = get(key);
    if (result == null) {
      pool.putByte(3).putInt(value);
      result = new Item(index++, key);
      put(result);
    }
    return result;
  }
  






  Item newFloat(float value)
  {
    key.set(value);
    Item result = get(key);
    if (result == null) {
      pool.putByte(4).putInt(key.intVal);
      result = new Item(index++, key);
      put(result);
    }
    return result;
  }
  






  Item newLong(long value)
  {
    key.set(value);
    Item result = get(key);
    if (result == null) {
      pool.putByte(5).putLong(value);
      result = new Item(index, key);
      put(result);
      index += 2;
    }
    return result;
  }
  






  Item newDouble(double value)
  {
    key.set(value);
    Item result = get(key);
    if (result == null) {
      pool.putByte(6).putLong(key.longVal);
      result = new Item(index, key);
      put(result);
      index += 2;
    }
    return result;
  }
  






  private Item newString(String value)
  {
    key2.set(8, value, null, null);
    Item result = get(key2);
    if (result == null) {
      pool.put12(8, newUTF8(value));
      result = new Item(index++, key2);
      put(result);
    }
    return result;
  }
  









  public int newNameType(String name, String desc)
  {
    key2.set(12, name, desc, null);
    Item result = get(key2);
    if (result == null) {
      put122(12, newUTF8(name), newUTF8(desc));
      result = new Item(index++, key2);
      put(result);
    }
    return index;
  }
  






  int addType(String type)
  {
    key.set(13, type, null, null);
    Item result = get(key);
    if (result == null) {
      result = addType(key);
    }
    return index;
  }
  









  int addUninitializedType(String type, int offset)
  {
    key.type = 14;
    key.intVal = offset;
    key.strVal1 = type;
    key.hashCode = (0x7FFFFFFF & 14 + type.hashCode() + offset);
    Item result = get(key);
    if (result == null) {
      result = addType(key);
    }
    return index;
  }
  






  private Item addType(Item item)
  {
    typeCount = ((short)(typeCount + 1));
    Item result = new Item(typeCount, key);
    put(result);
    if (typeTable == null) {
      typeTable = new Item[16];
    }
    if (typeCount == typeTable.length) {
      Item[] newTable = new Item[2 * typeTable.length];
      System.arraycopy(typeTable, 0, newTable, 0, typeTable.length);
      typeTable = newTable;
    }
    typeTable[typeCount] = result;
    return result;
  }
  









  int getMergedType(int type1, int type2)
  {
    key2.type = 15;
    key2.longVal = (type1 | type2 << 32);
    key2.hashCode = (0x7FFFFFFF & 15 + type1 + type2);
    Item result = get(key2);
    if (result == null) {
      String t = typeTable[type1].strVal1;
      String u = typeTable[type2].strVal1;
      key2.intVal = addType(getCommonSuperClass(t, u));
      result = new Item(0, key2);
      put(result);
    }
    return intVal;
  }
  
  protected Class<?> classForName(String name) throws ClassNotFoundException {
    try {
      ClassLoader contextClassLoader = Thread.currentThread().getContextClassLoader();
      if (contextClassLoader != null) {
        return Class.forName(name, false, contextClassLoader);
      }
    }
    catch (Throwable e) {}
    
    return Class.forName(name, false, getClass().getClassLoader());
  }
  




  protected String getCommonSuperClass(String type1, String type2)
  {
    Class c;
    



    Class d;
    



    try
    {
      c = classForName(type1.replace('/', '.'));
      d = classForName(type2.replace('/', '.'));
    } catch (Exception e) {
      throw new RuntimeException(e.toString());
    }
    if (c.isAssignableFrom(d)) {
      return type1;
    }
    if (d.isAssignableFrom(c)) {
      return type2;
    }
    if ((c.isInterface()) || (d.isInterface())) {
      return "java/lang/Object";
    }
    do {
      c = c.getSuperclass();
    } while (!c.isAssignableFrom(d));
    return c.getName().replace('.', '/');
  }
  








  private Item get(Item key)
  {
    Item i = items[(hashCode % items.length)];
    while ((i != null) && (!key.isEqualTo(i))) {
      i = next;
    }
    return i;
  }
  





  private void put(Item i)
  {
    if (this.index > threshold) {
      int ll = items.length;
      int nl = ll * 2 + 1;
      Item[] newItems = new Item[nl];
      for (int l = ll - 1; l >= 0; l--) {
        Item j = items[l];
        while (j != null) {
          int index = hashCode % newItems.length;
          Item k = next;
          next = newItems[index];
          newItems[index] = j;
          j = k;
        }
      }
      items = newItems;
      threshold = ((int)(nl * 0.75D));
    }
    int index = hashCode % items.length;
    next = items[index];
    items[index] = i;
  }
  






  private void put122(int b, int s1, int s2)
  {
    pool.put12(b, s1).putShort(s2);
  }
  
  public void visitEnd() {}
}
