package com.avaje.ebean.enhance.asm;























public class MethodAdapter
  implements MethodVisitor
{
  protected MethodVisitor mv;
  





















  public MethodAdapter(MethodVisitor mv)
  {
    this.mv = mv;
  }
  
  public AnnotationVisitor visitAnnotationDefault() {
    return mv.visitAnnotationDefault();
  }
  


  public AnnotationVisitor visitAnnotation(String desc, boolean visible)
  {
    return mv.visitAnnotation(desc, visible);
  }
  



  public AnnotationVisitor visitParameterAnnotation(int parameter, String desc, boolean visible)
  {
    return mv.visitParameterAnnotation(parameter, desc, visible);
  }
  
  public void visitAttribute(Attribute attr) {
    mv.visitAttribute(attr);
  }
  
  public void visitCode() {
    mv.visitCode();
  }
  





  public void visitFrame(int type, int nLocal, Object[] local, int nStack, Object[] stack)
  {
    mv.visitFrame(type, nLocal, local, nStack, stack);
  }
  
  public void visitInsn(int opcode) {
    mv.visitInsn(opcode);
  }
  
  public void visitIntInsn(int opcode, int operand) {
    mv.visitIntInsn(opcode, operand);
  }
  
  public void visitVarInsn(int opcode, int var) {
    mv.visitVarInsn(opcode, var);
  }
  
  public void visitTypeInsn(int opcode, String type) {
    mv.visitTypeInsn(opcode, type);
  }
  




  public void visitFieldInsn(int opcode, String owner, String name, String desc)
  {
    mv.visitFieldInsn(opcode, owner, name, desc);
  }
  




  public void visitMethodInsn(int opcode, String owner, String name, String desc)
  {
    mv.visitMethodInsn(opcode, owner, name, desc);
  }
  
  public void visitJumpInsn(int opcode, Label label) {
    mv.visitJumpInsn(opcode, label);
  }
  
  public void visitLabel(Label label) {
    mv.visitLabel(label);
  }
  
  public void visitLdcInsn(Object cst) {
    mv.visitLdcInsn(cst);
  }
  
  public void visitIincInsn(int var, int increment) {
    mv.visitIincInsn(var, increment);
  }
  




  public void visitTableSwitchInsn(int min, int max, Label dflt, Label[] labels)
  {
    mv.visitTableSwitchInsn(min, max, dflt, labels);
  }
  



  public void visitLookupSwitchInsn(Label dflt, int[] keys, Label[] labels)
  {
    mv.visitLookupSwitchInsn(dflt, keys, labels);
  }
  
  public void visitMultiANewArrayInsn(String desc, int dims) {
    mv.visitMultiANewArrayInsn(desc, dims);
  }
  




  public void visitTryCatchBlock(Label start, Label end, Label handler, String type)
  {
    mv.visitTryCatchBlock(start, end, handler, type);
  }
  






  public void visitLocalVariable(String name, String desc, String signature, Label start, Label end, int index)
  {
    mv.visitLocalVariable(name, desc, signature, start, end, index);
  }
  
  public void visitLineNumber(int line, Label start) {
    mv.visitLineNumber(line, start);
  }
  
  public void visitMaxs(int maxStack, int maxLocals) {
    mv.visitMaxs(maxStack, maxLocals);
  }
  
  public void visitEnd() {
    mv.visitEnd();
  }
}
