package com.avaje.ebean.enhance.asm.commons;

import com.avaje.ebean.enhance.asm.Label;
import com.avaje.ebean.enhance.asm.MethodVisitor;
import com.avaje.ebean.enhance.asm.Opcodes;





















































public abstract class MethodAdviceAdapter
  extends GeneratorAdapter
  implements Opcodes
{
  protected int methodAccess;
  protected String methodName;
  protected String methodDesc;
  
  protected MethodAdviceAdapter(MethodVisitor mv, int access, String name, String desc)
  {
    super(mv, access, name, desc);
    methodAccess = access;
    methodDesc = desc;
    methodName = name;
  }
  
  public void visitCode()
  {
    mv.visitCode();
    onMethodEnter();
  }
  
  public void visitLabel(Label label) {
    mv.visitLabel(label);
  }
  
  public void visitInsn(int opcode)
  {
    switch (opcode) {
    case 172: 
    case 173: 
    case 174: 
    case 175: 
    case 176: 
    case 177: 
    case 191: 
      onMethodExit(opcode);
    }
    
    mv.visitInsn(opcode);
  }
  
  public void visitVarInsn(int opcode, int var) {
    super.visitVarInsn(opcode, var);
  }
  
  public void visitFieldInsn(int opcode, String owner, String name, String desc) {
    mv.visitFieldInsn(opcode, owner, name, desc);
  }
  
  public void visitIntInsn(int opcode, int operand) {
    mv.visitIntInsn(opcode, operand);
  }
  
  public void visitLdcInsn(Object cst) {
    mv.visitLdcInsn(cst);
  }
  
  public void visitMultiANewArrayInsn(String desc, int dims) {
    mv.visitMultiANewArrayInsn(desc, dims);
  }
  
  public void visitTypeInsn(int opcode, String type) {
    mv.visitTypeInsn(opcode, type);
  }
  
  public void visitMethodInsn(int opcode, String owner, String name, String desc) {
    mv.visitMethodInsn(opcode, owner, name, desc);
  }
  
  public void visitJumpInsn(int opcode, Label label) {
    mv.visitJumpInsn(opcode, label);
  }
  
  public void visitLookupSwitchInsn(Label dflt, int[] keys, Label[] labels) {
    mv.visitLookupSwitchInsn(dflt, keys, labels);
  }
  
  public void visitTableSwitchInsn(int min, int max, Label dflt, Label[] labels) {
    mv.visitTableSwitchInsn(min, max, dflt, labels);
  }
  
  protected void onMethodEnter() {}
  
  protected void onMethodExit(int opcode) {}
}
