package com.avaje.ebean.meta;

import java.io.Serializable;
import javax.persistence.Entity;




























@Entity
public class MetaQueryStatistic
  implements Serializable
{
  private static final long serialVersionUID = -8746524372894472583L;
  boolean autofetchTuned;
  String beanType;
  int origQueryPlanHash;
  int finalQueryPlanHash;
  String sql;
  int executionCount;
  int totalLoadedBeans;
  int totalTimeMicros;
  long collectionStart;
  long lastQueryTime;
  int avgTimeMicros;
  int avgLoadedBeans;
  
  public MetaQueryStatistic() {}
  
  public MetaQueryStatistic(boolean autofetchTuned, String beanType, int plan, String sql, int executionCount, int totalLoadedBeans, int totalTimeMicros, long collectionStart, long lastQueryTime)
  {
    this.autofetchTuned = autofetchTuned;
    this.beanType = beanType;
    finalQueryPlanHash = plan;
    this.sql = sql;
    this.executionCount = executionCount;
    this.totalLoadedBeans = totalLoadedBeans;
    this.totalTimeMicros = totalTimeMicros;
    this.collectionStart = collectionStart;
    
    this.lastQueryTime = lastQueryTime;
    avgTimeMicros = (executionCount == 0 ? 0 : totalTimeMicros / executionCount);
    avgLoadedBeans = (executionCount == 0 ? 0 : totalLoadedBeans / executionCount);
  }
  
  public String toString() {
    return "type=" + beanType + " tuned:" + autofetchTuned + " origHash=" + origQueryPlanHash + " count=" + executionCount + " avgMicros=" + getAvgTimeMicros();
  }
  


  public boolean isAutofetchTuned()
  {
    return autofetchTuned;
  }
  





  public int getOrigQueryPlanHash()
  {
    return origQueryPlanHash;
  }
  


  public int getFinalQueryPlanHash()
  {
    return finalQueryPlanHash;
  }
  


  public String getBeanType()
  {
    return beanType;
  }
  


  public String getSql()
  {
    return sql;
  }
  


  public int getExecutionCount()
  {
    return executionCount;
  }
  





  public int getTotalLoadedBeans()
  {
    return totalLoadedBeans;
  }
  


  public int getTotalTimeMicros()
  {
    return totalTimeMicros;
  }
  


  public long getCollectionStart()
  {
    return collectionStart;
  }
  


  public long getLastQueryTime()
  {
    return lastQueryTime;
  }
  





  public int getAvgTimeMicros()
  {
    return avgTimeMicros;
  }
  





  public int getAvgLoadedBeans()
  {
    return avgLoadedBeans;
  }
}
