package com.avaje.ebean.text.json;

import com.avaje.ebean.text.PathProperties;
import java.util.HashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;























































































public class JsonWriteOptions
{
  protected String callback;
  protected JsonValueAdapter valueAdapter;
  protected Map<String, JsonWriteBeanVisitor<?>> visitorMap;
  protected PathProperties pathProperties;
  
  public JsonWriteOptions copy()
  {
    JsonWriteOptions copy = new JsonWriteOptions();
    callback = callback;
    valueAdapter = valueAdapter;
    pathProperties = pathProperties;
    if (visitorMap != null) {
      visitorMap = new HashMap(visitorMap);
    }
    return copy;
  }
  


  public String getCallback()
  {
    return callback;
  }
  


  public JsonWriteOptions setCallback(String callback)
  {
    this.callback = callback;
    return this;
  }
  


  public JsonValueAdapter getValueAdapter()
  {
    return valueAdapter;
  }
  


  public JsonWriteOptions setValueAdapter(JsonValueAdapter valueAdapter)
  {
    this.valueAdapter = valueAdapter;
    return this;
  }
  


  public JsonWriteOptions setRootPathVisitor(JsonWriteBeanVisitor<?> visitor)
  {
    return setPathVisitor(null, visitor);
  }
  


  public JsonWriteOptions setPathVisitor(String path, JsonWriteBeanVisitor<?> visitor)
  {
    if (visitorMap == null) {
      visitorMap = new HashMap();
    }
    visitorMap.put(path, visitor);
    return this;
  }
  





  public JsonWriteOptions setPathProperties(String path, Set<String> propertiesToInclude)
  {
    if (pathProperties == null) {
      pathProperties = new PathProperties();
    }
    pathProperties.put(path, propertiesToInclude);
    return this;
  }
  





  public JsonWriteOptions setPathProperties(String path, String propertiesToInclude)
  {
    return setPathProperties(path, parseProps(propertiesToInclude));
  }
  





  public JsonWriteOptions setRootPathProperties(String propertiesToInclude)
  {
    return setPathProperties(null, parseProps(propertiesToInclude));
  }
  





  public JsonWriteOptions setRootPathProperties(Set<String> propertiesToInclude)
  {
    return setPathProperties(null, propertiesToInclude);
  }
  
  private Set<String> parseProps(String propertiesToInclude)
  {
    LinkedHashSet<String> props = new LinkedHashSet();
    
    String[] split = propertiesToInclude.split(",");
    for (int i = 0; i < split.length; i++) {
      String s = split[i].trim();
      if (s.length() > 0) {
        props.add(s);
      }
    }
    return props;
  }
  


  public Map<String, JsonWriteBeanVisitor<?>> getVisitorMap()
  {
    return visitorMap;
  }
  


  public void setPathProperties(PathProperties pathProperties)
  {
    this.pathProperties = pathProperties;
  }
  


  public PathProperties getPathProperties()
  {
    return pathProperties;
  }
}
