package com.avaje.ebeaninternal.api;

import com.avaje.ebean.Transaction;
import com.avaje.ebean.bean.EntityBeanIntercept;
import java.util.List;


























public class LoadBeanRequest
  extends LoadRequest
{
  private final List<EntityBeanIntercept> batch;
  private final LoadBeanContext loadContext;
  private final String lazyLoadProperty;
  
  public LoadBeanRequest(LoadBeanContext loadContext, List<EntityBeanIntercept> batch, Transaction transaction, int batchSize, boolean lazy, String lazyLoadProperty)
  {
    super(transaction, batchSize, lazy);
    this.loadContext = loadContext;
    this.batch = batch;
    this.lazyLoadProperty = lazyLoadProperty;
  }
  
  public String getDescription() {
    String fullPath = loadContext.getFullPath();
    String s = "path:" + fullPath + " batch:" + batchSize + " actual:" + batch.size();
    
    return s;
  }
  


  public List<EntityBeanIntercept> getBatch()
  {
    return batch;
  }
  


  public LoadBeanContext getLoadContext()
  {
    return loadContext;
  }
  


  public String getLazyLoadProperty()
  {
    return lazyLoadProperty;
  }
}
