package com.avaje.ebeaninternal.api;

import com.avaje.ebean.Transaction;
import com.avaje.ebean.bean.BeanCollection;
import java.util.List;




























public class LoadManyRequest
  extends LoadRequest
{
  private final List<BeanCollection<?>> batch;
  private final LoadManyContext loadContext;
  private final boolean onlyIds;
  
  public LoadManyRequest(LoadManyContext loadContext, List<BeanCollection<?>> batch, Transaction transaction, int batchSize, boolean lazy, boolean onlyIds)
  {
    super(transaction, batchSize, lazy);
    this.loadContext = loadContext;
    this.batch = batch;
    this.onlyIds = onlyIds;
  }
  
  public String getDescription() {
    String fullPath = loadContext.getFullPath();
    String s = "path:" + fullPath + " batch:" + batchSize + " actual:" + batch.size();
    
    return s;
  }
  


  public List<BeanCollection<?>> getBatch()
  {
    return batch;
  }
  


  public LoadManyContext getLoadContext()
  {
    return loadContext;
  }
  








  public boolean isOnlyIds()
  {
    return onlyIds;
  }
}
