package com.avaje.ebeaninternal.server.autofetch;

import com.avaje.ebean.meta.MetaAutoFetchStatistic.QueryStats;
import java.io.Serializable;







public class StatisticsQuery
  implements Serializable
{
  private static final long serialVersionUID = -1133958958072778811L;
  private final String path;
  private int exeCount;
  private int totalBeanLoaded;
  private int totalMicros;
  
  public StatisticsQuery(String path)
  {
    this.path = path;
  }
  
  public MetaAutoFetchStatistic.QueryStats createPublicMeta() {
    return new MetaAutoFetchStatistic.QueryStats(path, exeCount, totalBeanLoaded, totalMicros);
  }
  
  public void add(int beansLoaded, int micros) {
    exeCount += 1;
    totalBeanLoaded += beansLoaded;
    totalMicros += micros;
  }
  
  public String toString() {
    long avgMicros = exeCount == 0 ? 0L : totalMicros / exeCount;
    
    return "queryExe path[" + path + "] count[" + exeCount + "] totalBeansLoaded[" + totalBeanLoaded + "] avgMicros[" + avgMicros + "] totalMicros[" + totalMicros + "]";
  }
}
