package com.avaje.ebeaninternal.server.cluster;

import com.avaje.ebeaninternal.api.SpiEbeanServer;
import com.avaje.ebeaninternal.api.TransactionEventTable.TableIUD;
import com.avaje.ebeaninternal.server.transaction.BeanDelta;
import com.avaje.ebeaninternal.server.transaction.BeanPersistIds;
import com.avaje.ebeaninternal.server.transaction.IndexEvent;
import com.avaje.ebeaninternal.server.transaction.RemoteTransactionEvent;
import java.io.DataInput;
import java.io.IOException;



























public class PacketTransactionEvent
  extends Packet
{
  private final SpiEbeanServer server;
  private final RemoteTransactionEvent event;
  
  public static PacketTransactionEvent forWrite(long packetId, long timestamp, String serverName)
    throws IOException
  {
    return new PacketTransactionEvent(true, packetId, timestamp, serverName);
  }
  
  private PacketTransactionEvent(boolean write, long packetId, long timestamp, String serverName) throws IOException {
    super(write, (short)2, packetId, timestamp, serverName);
    server = null;
    event = null;
  }
  
  private PacketTransactionEvent(Packet header, SpiEbeanServer server) throws IOException {
    super(false, (short)2, packetId, timestamp, serverName);
    this.server = server;
    event = new RemoteTransactionEvent(server);
  }
  
  public static PacketTransactionEvent forRead(Packet header, SpiEbeanServer server) throws IOException {
    return new PacketTransactionEvent(header, server);
  }
  
  public RemoteTransactionEvent getEvent() {
    return event;
  }
  
  protected void readMessage(DataInput dataInput, int msgType) throws IOException
  {
    switch (msgType) {
    case 1: 
      event.addBeanPersistIds(BeanPersistIds.readBinaryMessage(server, dataInput));
      break;
    
    case 2: 
      event.addTableIUD(TransactionEventTable.TableIUD.readBinaryMessage(dataInput));
      break;
    
    case 3: 
      event.addBeanDelta(BeanDelta.readBinaryMessage(server, dataInput));
      break;
    
    case 7: 
      event.addIndexEvent(IndexEvent.readBinaryMessage(dataInput));
      break;
    case 4: case 5: 
    case 6: default: 
      throw new RuntimeException("Invalid Transaction msgType " + msgType);
    }
  }
}
