package com.avaje.ebeaninternal.server.cluster.socket;

import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.Socket;









































class SocketConnection
{
  ObjectOutputStream oos;
  ObjectInputStream ois;
  InputStream is;
  OutputStream os;
  Socket socket;
  
  public SocketConnection(Socket socket)
    throws IOException
  {
    is = socket.getInputStream();
    os = socket.getOutputStream();
    this.socket = socket;
  }
  

  public void disconnect()
    throws IOException
  {
    os.flush();
    socket.close();
  }
  

  public void flush()
    throws IOException
  {
    os.flush();
  }
  

  public Object readObject()
    throws IOException, ClassNotFoundException
  {
    return getObjectInputStream().readObject();
  }
  

  public ObjectOutputStream writeObject(Object object)
    throws IOException
  {
    ObjectOutputStream oos = getObjectOutputStream();
    oos.writeObject(object);
    return oos;
  }
  

  public ObjectOutputStream getObjectOutputStream()
    throws IOException
  {
    if (oos == null) {
      oos = new ObjectOutputStream(os);
    }
    return oos;
  }
  

  public ObjectInputStream getObjectInputStream()
    throws IOException
  {
    if (ois == null) {
      ois = new ObjectInputStream(is);
    }
    return ois;
  }
  



  public void setObjectInputStream(ObjectInputStream ois)
  {
    this.ois = ois;
  }
  


  public void setObjectOutputStream(ObjectOutputStream oos)
  {
    this.oos = oos;
  }
  

  public InputStream getInputStream()
    throws IOException
  {
    return is;
  }
  

  public OutputStream getOutputStream()
    throws IOException
  {
    return os;
  }
}
