package com.avaje.ebeaninternal.server.core;

import com.avaje.ebean.EbeanServer;
import com.avaje.ebean.LogLevel;
import com.avaje.ebeaninternal.api.SpiEbeanServer;
import com.avaje.ebeaninternal.api.SpiTransaction;
import java.sql.Connection;

































public abstract class BeanRequest
{
  final SpiEbeanServer ebeanServer;
  final String serverName;
  SpiTransaction transaction;
  boolean createdTransaction;
  boolean readOnly;
  
  public BeanRequest(SpiEbeanServer ebeanServer, SpiTransaction t)
  {
    this.ebeanServer = ebeanServer;
    serverName = ebeanServer.getName();
    transaction = t;
  }
  







  public abstract void initTransIfRequired();
  






  public void createImplicitTransIfRequired(boolean readOnlyTransaction)
  {
    if (transaction == null) {
      transaction = ebeanServer.getCurrentServerTransaction();
      if ((transaction == null) || (!transaction.isActive()))
      {
        transaction = ebeanServer.createServerTransaction(false, -1);
        





        createdTransaction = true;
      }
    }
  }
  


  public void commitTransIfRequired()
  {
    if (createdTransaction) {
      if (readOnly) {
        transaction.rollback();
      } else {
        transaction.commit();
      }
    }
  }
  


  public void rollbackTransIfRequired()
  {
    if (createdTransaction) {
      transaction.rollback();
    }
  }
  



  public EbeanServer getEbeanServer()
  {
    return ebeanServer;
  }
  


  public SpiTransaction getTransaction()
  {
    return transaction;
  }
  


  public Connection getConnection()
  {
    return transaction.getInternalConnection();
  }
  


  public boolean isLogSql()
  {
    return transaction.getLogLevel().ordinal() >= LogLevel.SQL.ordinal();
  }
  


  public boolean isLogSummary()
  {
    return transaction.getLogLevel().ordinal() >= LogLevel.SUMMARY.ordinal();
  }
}
