package com.avaje.ebeaninternal.server.core;

import com.avaje.ebean.SqlUpdate;
import com.avaje.ebeaninternal.api.SpiEbeanServer;
import com.avaje.ebeaninternal.api.SpiSqlUpdate;
import com.avaje.ebeaninternal.api.SpiTransaction;
import com.avaje.ebeaninternal.api.TransactionEvent;
import com.avaje.ebeaninternal.server.persist.PersistExecute;
import java.sql.SQLException;














public final class PersistRequestUpdateSql
  extends PersistRequest
{
  private final SpiSqlUpdate updateSql;
  private int rowCount;
  private String bindLog;
  private SqlType sqlType;
  private String tableName;
  private String description;
  
  public static enum SqlType
  {
    SQL_UPDATE,  SQL_DELETE,  SQL_INSERT,  SQL_UNKNOWN;
    







    private SqlType() {}
  }
  






  public PersistRequestUpdateSql(SpiEbeanServer server, SqlUpdate updateSql, SpiTransaction t, PersistExecute persistExecute)
  {
    super(server, t, persistExecute);
    type = PersistRequest.Type.UPDATESQL;
    this.updateSql = ((SpiSqlUpdate)updateSql);
  }
  
  public int executeNow()
  {
    return persistExecute.executeSqlUpdate(this);
  }
  
  public int executeOrQueue()
  {
    return executeStatement();
  }
  


  public SpiSqlUpdate getUpdateSql()
  {
    return updateSql;
  }
  

  public void checkRowCount(int count)
    throws SQLException
  {
    rowCount = count;
  }
  


  public boolean useGeneratedKeys()
  {
    return false;
  }
  




  public void setGeneratedKey(Object idValue) {}
  



  public void setType(SqlType sqlType, String tableName, String description)
  {
    this.sqlType = sqlType;
    this.tableName = tableName;
    this.description = description;
  }
  


  public void setBindLog(String bindLog)
  {
    this.bindLog = bindLog;
  }
  


  public void postExecute()
    throws SQLException
  {
    if (transaction.isLogSummary()) {
      String m = description + " table[" + tableName + "] rows[" + rowCount + "] bind[" + bindLog + "]";
      transaction.logInternal(m);
    }
    
    if (updateSql.isAutoTableMod())
    {

      switch (1.$SwitchMap$com$avaje$ebeaninternal$server$core$PersistRequestUpdateSql$SqlType[sqlType.ordinal()]) {
      case 1: 
        transaction.getEvent().add(tableName, true, false, false);
        break;
      case 2: 
        transaction.getEvent().add(tableName, false, true, false);
        break;
      case 3: 
        transaction.getEvent().add(tableName, false, false, true);
        break;
      }
    }
  }
}
