package com.avaje.ebeaninternal.server.core;

import com.avaje.ebean.BackgroundExecutor;
import com.avaje.ebeaninternal.server.lib.DaemonScheduleThreadPool;
import com.avaje.ebeaninternal.server.lib.thread.ThreadPool;
import java.util.concurrent.TimeUnit;




























public class TraditionalBackgroundExecutor
  implements BackgroundExecutor
{
  private final ThreadPool pool;
  private final DaemonScheduleThreadPool schedulePool;
  
  public TraditionalBackgroundExecutor(ThreadPool pool, int schedulePoolSize, int shutdownWaitSeconds, String namePrefix)
  {
    this.pool = pool;
    schedulePool = new DaemonScheduleThreadPool(schedulePoolSize, shutdownWaitSeconds, namePrefix + "-periodic-");
  }
  


  public void execute(Runnable r)
  {
    pool.assign(r, true);
  }
  
  public void executePeriodically(Runnable r, long delay, TimeUnit unit) {
    schedulePool.scheduleWithFixedDelay(r, delay, delay, unit);
  }
}
