package com.avaje.ebeaninternal.server.deploy;

import javax.persistence.CascadeType;







































public class BeanCascadeInfo
{
  boolean delete;
  boolean save;
  boolean validate;
  
  public void setAttribute(String attr)
  {
    if (attr == null) {
      return;
    }
    attr = attr.toLowerCase();
    delete = (attr.indexOf("delete") > -1);
    if (!delete)
    {
      delete = (attr.indexOf("remove") > -1);
    }
    save = (attr.indexOf("save") > -1);
    if (!save)
    {
      save = (attr.indexOf("persist") > -1);
    }
    if (attr.indexOf("validate") > -1) {
      validate = true;
    }
    
    if (attr.indexOf("all") > -1) {
      delete = true;
      save = true;
      validate = true;
    }
  }
  
  public void setTypes(CascadeType[] types) {
    for (int i = 0; i < types.length; i++) {
      setType(types[i]);
    }
  }
  
  private void setType(CascadeType type) {
    if (type.equals(CascadeType.ALL)) {
      save = true;
      delete = true;
    }
    if (type.equals(CascadeType.REMOVE)) {
      delete = true;
    }
    if (type.equals(CascadeType.PERSIST)) {
      save = true;
    }
    if (type.equals(CascadeType.MERGE)) {
      save = true;
    }
    if ((save) || (delete)) {
      validate = true;
    }
  }
  


  public boolean isDelete()
  {
    return delete;
  }
  

  public void setDelete(boolean isDelete)
  {
    delete = isDelete;
  }
  

  public boolean isSave()
  {
    return save;
  }
  


  public void setSave(boolean isUpdate)
  {
    save = isUpdate;
  }
  


  public boolean isValidate()
  {
    return validate;
  }
  


  public void setValidate(boolean isValidate)
  {
    validate = isValidate;
  }
}
