package com.avaje.ebeaninternal.server.deploy;

import com.avaje.ebean.Query.Type;
import com.avaje.ebeaninternal.api.SpiQuery;
import com.avaje.ebeaninternal.server.core.OrmQueryRequest;







public class BeanCollectionHelpFactory
{
  public static <T> BeanCollectionHelp<T> create(BeanPropertyAssocMany<T> manyProperty)
  {
    ManyType manyType = manyProperty.getManyType();
    switch (1.$SwitchMap$com$avaje$ebeaninternal$server$deploy$ManyType$Underlying[manyType.getUnderlying().ordinal()]) {
    case 1: 
      return new BeanListHelp(manyProperty);
    case 2: 
      return new BeanSetHelp(manyProperty);
    case 3: 
      return new BeanMapHelp(manyProperty);
    }
    throw new RuntimeException("Invalid type " + manyType);
  }
  


  public static <T> BeanCollectionHelp<T> create(OrmQueryRequest<T> request)
  {
    Query.Type manyType = request.getQuery().getType();
    
    if (manyType.equals(Query.Type.LIST)) {
      return new BeanListHelp();
    }
    if (manyType.equals(Query.Type.SET)) {
      return new BeanSetHelp();
    }
    
    BeanDescriptor<T> target = request.getBeanDescriptor();
    String mapKey = request.getQuery().getMapKey();
    return new BeanMapHelp(target, mapKey);
  }
}
