package com.avaje.ebeaninternal.server.deploy;

import com.avaje.ebeaninternal.server.lib.util.StringHelper;
import javax.persistence.PersistenceException;

public class BeanSqlSelect
{
  public static final String HAVING_PREDICATES = "${HAVING_PREDICATES}";
  public static final String WHERE_PREDICATES = "${WHERE_PREDICATES}";
  public static final String AND_PREDICATES = "${AND_PREDICATES}";
  public static final String ORDER_BY = "${ORDER_BY}";
  final String sql;
  final PredicatesType predicatesType;
  final boolean hasOrderBy;
  
  public static enum PredicatesType
  {
    HAVING,  WHERE,  AND,  NONE;
    


    private PredicatesType() {}
  }
  

  public BeanSqlSelect(String sql, PredicatesType predicatesType, boolean hasOrderBy)
  {
    this.sql = sql;
    this.predicatesType = predicatesType;
    this.hasOrderBy = hasOrderBy;
  }
  
  public String getSql() {
    return sql;
  }
  
  public PredicatesType getPredicatesType() {
    return predicatesType;
  }
  
  public boolean hasOrderBy() {
    return hasOrderBy;
  }
  
  public String addPredicates(String query, String predicates) {
    if (predicates == null) {
      switch (1.$SwitchMap$com$avaje$ebeaninternal$server$deploy$BeanSqlSelect$PredicatesType[predicatesType.ordinal()]) {
      case 1: 
        return StringHelper.replaceString(query, "${HAVING_PREDICATES}", "");
      case 2: 
        return StringHelper.replaceString(query, "${WHERE_PREDICATES}", "");
      case 3: 
        return StringHelper.replaceString(query, "${AND_PREDICATES}", "");
      case 4: 
        return query;
      }
      
      throw new PersistenceException("predicatesType " + predicatesType + " not handled");
    }
    
    switch (1.$SwitchMap$com$avaje$ebeaninternal$server$deploy$BeanSqlSelect$PredicatesType[predicatesType.ordinal()]) {
    case 1: 
      return StringHelper.replaceString(query, "${HAVING_PREDICATES}", " HAVING " + predicates);
    
    case 2: 
      return StringHelper.replaceString(query, "${WHERE_PREDICATES}", " WHERE " + predicates);
    case 3: 
      return StringHelper.replaceString(query, "${AND_PREDICATES}", " AND " + predicates);
    case 4: 
      return query;
    }
    
    throw new PersistenceException("predicatesType " + predicatesType + " not handled");
  }
  

  public String addOrderBy(String query, String orderBy)
  {
    if (!hasOrderBy) {
      return query;
    }
    if (orderBy == null) {
      return StringHelper.replaceString(query, "${ORDER_BY}", "");
    }
    return StringHelper.replaceString(query, "${ORDER_BY}", " ORDER BY " + orderBy);
  }
}
