package com.avaje.ebeaninternal.server.deploy;

import com.avaje.ebean.bean.PersistenceContext;
import com.avaje.ebeaninternal.server.transaction.DefaultPersistenceContext;


























public class CopyContext
{
  private final boolean vanillaMode;
  private final boolean sharing;
  private final PersistenceContext pc;
  
  public CopyContext(boolean vanillaMode, boolean sharing)
  {
    this.vanillaMode = vanillaMode;
    this.sharing = sharing;
    pc = new DefaultPersistenceContext();
  }
  
  public CopyContext(boolean vanillaMode) {
    this(vanillaMode, false);
  }
  


  public boolean isVanillaMode()
  {
    return vanillaMode;
  }
  


  public boolean isSharing()
  {
    return sharing;
  }
  


  public PersistenceContext getPersistenceContext()
  {
    return pc;
  }
  


  public Object putIfAbsent(Object id, Object bean)
  {
    return pc.putIfAbsent(id, bean);
  }
  


  public Object get(Class<?> beanType, Object beanId)
  {
    return pc.get(beanType, beanId);
  }
}
