package com.avaje.ebeaninternal.server.deploy;

import com.avaje.ebean.RawSql;
import javax.persistence.NamedQuery;
import javax.persistence.QueryHint;





public class DeployNamedQuery
{
  private final String name;
  private final String query;
  private final QueryHint[] hints;
  private final DRawSqlSelect sqlSelect;
  private final RawSql rawSql;
  
  public DeployNamedQuery(NamedQuery namedQuery)
  {
    name = namedQuery.name();
    query = namedQuery.query();
    hints = namedQuery.hints();
    sqlSelect = null;
    rawSql = null;
  }
  
  public DeployNamedQuery(String name, String query, QueryHint[] hints) {
    this.name = name;
    this.query = query;
    this.hints = hints;
    sqlSelect = null;
    rawSql = null;
  }
  
  public DeployNamedQuery(String name, RawSql rawSql) {
    this.name = name;
    query = null;
    hints = null;
    sqlSelect = null;
    this.rawSql = rawSql;
  }
  
  public DeployNamedQuery(DRawSqlSelect sqlSelect) {
    name = sqlSelect.getName();
    query = null;
    hints = null;
    this.sqlSelect = sqlSelect;
    rawSql = null;
  }
  
  public boolean isRawSql() {
    return rawSql != null;
  }
  
  public boolean isSqlSelect() {
    return sqlSelect != null;
  }
  
  public String getName() {
    return name;
  }
  
  public String getQuery() {
    return query;
  }
  
  public QueryHint[] getHints() {
    return hints;
  }
  
  public RawSql getRawSql() {
    return rawSql;
  }
  
  public DRawSqlSelect getSqlSelect() {
    return sqlSelect;
  }
}
