package com.avaje.ebeaninternal.server.deploy;

import com.avaje.ebean.annotation.NamedUpdate;






public class DeployNamedUpdate
{
  private final String name;
  private final String updateStatement;
  private final boolean notifyCache;
  private String sqlUpdateStatement;
  
  public DeployNamedUpdate(NamedUpdate update)
  {
    name = update.name();
    updateStatement = update.update();
    notifyCache = update.notifyCache();
  }
  
  public void initialise(DeployUpdateParser parser) {
    sqlUpdateStatement = parser.parse(updateStatement);
  }
  
  public String getName() {
    return name;
  }
  
  public String getSqlUpdateStatement() {
    return sqlUpdateStatement;
  }
  
  public boolean isNotifyCache() {
    return notifyCache;
  }
}
