package com.avaje.ebeaninternal.server.deploy;

import com.avaje.ebeaninternal.server.el.ElPropertyDeploy;
import java.util.HashSet;
import java.util.Set;










public final class DeployPropertyParser
  extends DeployParser
{
  private final BeanDescriptor<?> beanDescriptor;
  private final Set<String> includes = new HashSet();
  
  public DeployPropertyParser(BeanDescriptor<?> beanDescriptor) {
    this.beanDescriptor = beanDescriptor;
  }
  
  public Set<String> getIncludes() {
    return includes;
  }
  
  public String getDeployWord(String expression)
  {
    ElPropertyDeploy elProp = beanDescriptor.getElPropertyDeploy(expression);
    if (elProp == null) {
      return null;
    }
    addIncludes(elProp.getElPrefix());
    return elProp.getElPlaceholder(encrypted);
  }
  

  public String convertWord()
  {
    String r = getDeployWord(word);
    return r == null ? word : r;
  }
  
  private void addIncludes(String prefix) {
    if (prefix != null) {
      includes.add(prefix);
    }
  }
}
