package com.avaje.ebeaninternal.server.deploy;

import com.avaje.ebeaninternal.server.core.InternString;
import com.avaje.ebeaninternal.server.deploy.meta.DeployTableJoinColumn;


































public class TableJoinColumn
{
  private final String localDbColumn;
  private final String foreignDbColumn;
  private final boolean insertable;
  private final boolean updateable;
  
  public TableJoinColumn(DeployTableJoinColumn deploy)
  {
    localDbColumn = InternString.intern(deploy.getLocalDbColumn());
    foreignDbColumn = InternString.intern(deploy.getForeignDbColumn());
    insertable = deploy.isInsertable();
    updateable = deploy.isUpdateable();
  }
  
  public String toString() {
    return localDbColumn + " = " + foreignDbColumn;
  }
  



  public String getForeignDbColumn()
  {
    return foreignDbColumn;
  }
  


  public String getLocalDbColumn()
  {
    return localDbColumn;
  }
  


  public boolean isInsertable()
  {
    return insertable;
  }
  


  public boolean isUpdateable()
  {
    return updateable;
  }
}
