package com.avaje.ebeaninternal.server.deploy.generatedproperty;

import com.avaje.ebeaninternal.server.deploy.meta.DeployBeanProperty;
import java.math.BigDecimal;
import java.util.HashSet;



























public class GeneratedPropertyFactory
{
  CounterFactory counterFactory;
  InsertTimestampFactory insertFactory;
  UpdateTimestampFactory updateFactory;
  HashSet<String> numberTypes = new HashSet();
  
  public GeneratedPropertyFactory() {
    counterFactory = new CounterFactory();
    insertFactory = new InsertTimestampFactory();
    updateFactory = new UpdateTimestampFactory();
    

    numberTypes.add(Integer.class.getName());
    numberTypes.add(Integer.TYPE.getName());
    numberTypes.add(Long.class.getName());
    numberTypes.add(Long.TYPE.getName());
    numberTypes.add(Short.class.getName());
    numberTypes.add(Short.TYPE.getName());
    numberTypes.add(Double.class.getName());
    numberTypes.add(Double.TYPE.getName());
    numberTypes.add(BigDecimal.class.getName());
  }
  
  private boolean isNumberType(String typeClassName) {
    return numberTypes.contains(typeClassName);
  }
  
  public void setVersion(DeployBeanProperty property) {
    if (isNumberType(property.getPropertyType().getName())) {
      setCounter(property);
    } else {
      setUpdateTimestamp(property);
    }
  }
  
  public void setCounter(DeployBeanProperty property)
  {
    counterFactory.setCounter(property);
  }
  
  public void setInsertTimestamp(DeployBeanProperty property)
  {
    insertFactory.setInsertTimestamp(property);
  }
  
  public void setUpdateTimestamp(DeployBeanProperty property)
  {
    updateFactory.setUpdateTimestamp(property);
  }
}
