package com.avaje.ebeaninternal.server.deploy.parse;

import com.avaje.ebeaninternal.server.deploy.InheritInfo;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;





































public class DeployInheritInfo
{
  private static final String JPA_DEFAULT_DISCRIM_COLUMN = "dtype";
  private int discriminatorLength;
  private int discriminatorType;
  private String discriminatorStringValue;
  private Object discriminatorObjectValue;
  private String discriminatorColumn;
  private String discriminatorWhere;
  private Class<?> type;
  private Class<?> parent;
  private ArrayList<DeployInheritInfo> children = new ArrayList();
  


  public DeployInheritInfo(Class<?> type)
  {
    this.type = type;
  }
  


  public Class<?> getType()
  {
    return type;
  }
  


  public Class<?> getParent()
  {
    return parent;
  }
  


  public void setParent(Class<?> parent)
  {
    this.parent = parent;
  }
  


  public boolean isAbstract()
  {
    return discriminatorObjectValue == null;
  }
  


  public boolean isRoot()
  {
    return parent == null;
  }
  


  public Iterator<DeployInheritInfo> children()
  {
    return children.iterator();
  }
  


  public void addChild(DeployInheritInfo childInfo)
  {
    children.add(childInfo);
  }
  


  public String getDiscriminatorWhere()
  {
    return discriminatorWhere;
  }
  


  public void setDiscriminatorWhere(String discriminatorWhere)
  {
    this.discriminatorWhere = discriminatorWhere;
  }
  


  public String getDiscriminatorColumn(InheritInfo parent)
  {
    if (discriminatorColumn == null) {
      if (parent == null) {
        discriminatorColumn = "dtype";
      } else {
        discriminatorColumn = parent.getDiscriminatorColumn();
      }
    }
    return discriminatorColumn;
  }
  


  public void setDiscriminatorColumn(String discriminatorColumn)
  {
    this.discriminatorColumn = discriminatorColumn;
  }
  
  public int getDiscriminatorLength(InheritInfo parent) {
    if (discriminatorLength == 0) {
      if (parent == null) {
        discriminatorLength = 10;
      } else {
        discriminatorLength = parent.getDiscriminatorLength();
      }
    }
    return discriminatorLength;
  }
  


  public int getDiscriminatorType(InheritInfo parent)
  {
    if (discriminatorType == 0) {
      if (parent == null) {
        discriminatorType = 12;
      } else {
        discriminatorType = parent.getDiscriminatorType();
      }
    }
    return discriminatorType;
  }
  


  public void setDiscriminatorType(int discriminatorType)
  {
    this.discriminatorType = discriminatorType;
  }
  


  public int getDiscriminatorLength()
  {
    return discriminatorLength;
  }
  


  public void setDiscriminatorLength(int discriminatorLength)
  {
    this.discriminatorLength = discriminatorLength;
  }
  


  public Object getDiscriminatorObjectValue()
  {
    return discriminatorObjectValue;
  }
  
  public String getDiscriminatorStringValue() {
    return discriminatorStringValue;
  }
  


  public void setDiscriminatorValue(String value)
  {
    if (value != null) {
      value = value.trim();
      if (value.length() == 0) {
        value = null;
      } else {
        discriminatorStringValue = value;
        
        if (discriminatorType == 4) {
          discriminatorObjectValue = Integer.valueOf(value.toString());
        } else {
          discriminatorObjectValue = value;
        }
      }
    }
  }
  
  public String getWhere()
  {
    List<Object> discList = new ArrayList();
    
    appendDiscriminator(discList);
    
    return buildWhereLiteral(discList);
  }
  
  private void appendDiscriminator(List<Object> list) {
    if (discriminatorObjectValue != null) {
      list.add(discriminatorObjectValue);
    }
    for (DeployInheritInfo child : children) {
      child.appendDiscriminator(list);
    }
  }
  
  private String buildWhereLiteral(List<Object> discList) {
    int size = discList.size();
    if (size == 0) {
      return "";
    }
    StringBuilder sb = new StringBuilder();
    sb.append(discriminatorColumn);
    if (size == 1) {
      sb.append(" = ");
    } else {
      sb.append(" in (");
    }
    for (int i = 0; i < discList.size(); i++) {
      appendSqlLiteralValue(i, discList.get(i), sb);
    }
    if (size > 1) {
      sb.append(")");
    }
    return sb.toString();
  }
  
  private void appendSqlLiteralValue(int count, Object value, StringBuilder sb) {
    if (count > 0) {
      sb.append(",");
    }
    if ((value instanceof String)) {
      sb.append("'").append(value).append("'");
    } else {
      sb.append(value);
    }
  }
  
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("InheritInfo[").append(type.getName()).append("]");
    sb.append(" root[").append(parent.getName()).append("]");
    sb.append(" disValue[").append(discriminatorStringValue).append("]");
    return sb.toString();
  }
}
