package com.avaje.ebeaninternal.server.el;

import java.util.ArrayList;
import java.util.List;































public class ElPropertyChainBuilder
{
  private final String expression;
  private final List<ElPropertyValue> chain = new ArrayList();
  

  private final boolean embedded;
  
  private boolean containsMany;
  

  public ElPropertyChainBuilder(boolean embedded, String expression)
  {
    this.embedded = embedded;
    this.expression = expression;
  }
  
  public boolean isContainsMany() {
    return containsMany;
  }
  
  public void setContainsMany(boolean containsMany) {
    this.containsMany = containsMany;
  }
  
  public String getExpression() {
    return expression;
  }
  


  public ElPropertyChainBuilder add(ElPropertyValue element)
  {
    if (element == null) {
      throw new NullPointerException("element null in expression " + expression);
    }
    chain.add(element);
    return this;
  }
  


  public ElPropertyChain build()
  {
    return new ElPropertyChain(containsMany, embedded, expression, (ElPropertyValue[])chain.toArray(new ElPropertyValue[chain.size()]));
  }
}
