package com.avaje.ebeaninternal.server.expression;

import com.avaje.ebean.event.BeanQueryRequest;
import com.avaje.ebeaninternal.api.SpiExpressionRequest;
import com.avaje.ebeaninternal.api.SpiLuceneExpr;
import java.util.Set;




class BetweenExpression
  extends AbstractExpression
{
  private static final long serialVersionUID = 2078918165221454910L;
  private static final String BETWEEN = " between ";
  private final Object valueHigh;
  private final Object valueLow;
  
  BetweenExpression(FilterExprPath pathPrefix, String propertyName, Object valLo, Object valHigh)
  {
    super(pathPrefix, propertyName);
    valueLow = valLo;
    valueHigh = valHigh;
  }
  
  public boolean isLuceneResolvable(Set<String> indexedProperties) {
    return indexedProperties.contains(getPropertyName());
  }
  
  public SpiLuceneExpr createLuceneExpr(SpiExpressionRequest request) {
    return null;
  }
  
  public void addBindValues(SpiExpressionRequest request) {
    request.addBindValue(valueLow);
    request.addBindValue(valueHigh);
  }
  
  public void addSql(SpiExpressionRequest request)
  {
    request.append(getPropertyName()).append(" between ").append(" ? and ? ");
  }
  
  public int queryAutoFetchHash() {
    int hc = BetweenExpression.class.getName().hashCode();
    hc = hc * 31 + propName.hashCode();
    return hc;
  }
  
  public int queryPlanHash(BeanQueryRequest<?> request) {
    return queryAutoFetchHash();
  }
  
  public int queryBindHash() {
    int hc = valueLow.hashCode();
    hc = hc * 31 + valueHigh.hashCode();
    return hc;
  }
}
