package com.avaje.ebeaninternal.server.expression;

import com.avaje.ebeaninternal.api.SpiExpression;
import com.avaje.ebeaninternal.api.SpiExpressionRequest;
import com.avaje.ebeaninternal.api.SpiLuceneExpr;
import java.util.List;
import org.apache.lucene.search.BooleanClause.Occur;
import org.apache.lucene.search.BooleanQuery;
import org.apache.lucene.search.Query;




























public class JunctionExpressionLucene
{
  public SpiLuceneExpr createLuceneExpr(SpiExpressionRequest request, List<SpiExpression> list, boolean disjunction)
  {
    BooleanClause.Occur occur = disjunction ? BooleanClause.Occur.SHOULD : BooleanClause.Occur.MUST;
    
    StringBuilder sb = new StringBuilder();
    
    BooleanQuery bq = new BooleanQuery();
    for (int i = 0; i < list.size(); i++) {
      SpiLuceneExpr luceneExpr = ((SpiExpression)list.get(i)).createLuceneExpr(request);
      Query query = luceneExpr.mergeLuceneQuery();
      bq.add(query, occur);
      
      if (i > 0) {
        sb.append(" ").append(occur).append(" ");
      }
      sb.append(luceneExpr.getDescription());
    }
    
    return new LuceneExprResponse(bq, sb.toString());
  }
}
