package com.avaje.ebeaninternal.server.expression;

import com.avaje.ebean.LikeType;
import com.avaje.ebeaninternal.api.SpiExpressionRequest;
import com.avaje.ebeaninternal.api.SpiLuceneExpr;
import com.avaje.ebeaninternal.server.lucene.LIndex;
import org.apache.lucene.queryParser.ParseException;
import org.apache.lucene.queryParser.QueryParser;




















public class LikeExpressionLucene
{
  public SpiLuceneExpr createLuceneExpr(SpiExpressionRequest request, String propertyName, LikeType type, boolean caseInsensitive, String val)
  {
    try
    {
      String exprValue = getLuceneValue(val, caseInsensitive, type);
      
      String desc = propertyName + " like " + exprValue;
      
      QueryParser queryParser = request.getLuceneIndex().createQueryParser(propertyName);
      return new LuceneExprResponse(queryParser.parse(exprValue), desc);
    } catch (ParseException e) {
      throw new PersistenceLuceneParseException(e);
    }
  }
  
  private static String getLuceneValue(String value, boolean caseInsensitive, LikeType type) {
    if (caseInsensitive) {
      value = value.toLowerCase();
    }
    value = value.replace('%', '*');
    
    switch (1.$SwitchMap$com$avaje$ebean$LikeType[type.ordinal()]) {
    case 1: 
      return value;
    case 2: 
      return value + "*";
    case 3: 
      return value;
    case 4: 
      return value;
    case 5: 
      throw new RuntimeException("Not Supported - Never get here");
    }
    
    throw new RuntimeException("LikeType " + type + " missed?");
  }
}
