package com.avaje.ebeaninternal.server.jmx;

import com.avaje.ebean.AdminLogging;
import com.avaje.ebean.LogLevel;
import com.avaje.ebean.config.ServerConfig;
import com.avaje.ebeaninternal.server.transaction.TransactionManager;






























public class MAdminLogging
  implements MAdminLoggingMBean, AdminLogging
{
  private final TransactionManager transactionManager;
  private boolean debugSql;
  private boolean debugLazyLoad;
  
  public MAdminLogging(ServerConfig serverConfig, TransactionManager txManager)
  {
    transactionManager = txManager;
    debugSql = serverConfig.isDebugSql();
    debugLazyLoad = serverConfig.isDebugLazyLoad();
  }
  
  public void setLogLevel(LogLevel logLevel) {
    transactionManager.setTransactionLogLevel(logLevel);
  }
  
  public LogLevel getLogLevel() {
    return transactionManager.getTransactionLogLevel();
  }
  
  public boolean isDebugGeneratedSql() {
    return debugSql;
  }
  
  public void setDebugGeneratedSql(boolean debugSql) {
    this.debugSql = debugSql;
  }
  
  public boolean isDebugLazyLoad() {
    return debugLazyLoad;
  }
  
  public void setDebugLazyLoad(boolean debugLazyLoad) {
    this.debugLazyLoad = debugLazyLoad;
  }
}
