package com.avaje.ebeaninternal.server.lib;












public class BackgroundRunnable
{
  Runnable runnable;
  










  int freqInSecs;
  









  int runCount = 0;
  



  long totalRunTime = 0L;
  


  long startTimeTemp;
  


  long startAfter;
  


  boolean isActive = true;
  
  public BackgroundRunnable(Runnable runnable, int freqInSecs) {
    this(runnable, freqInSecs, System.currentTimeMillis() + 1000 * (freqInSecs + 10));
  }
  
  public BackgroundRunnable(Runnable runnable, int freqInSecs, long startAfter) {
    this.runnable = runnable;
    this.freqInSecs = freqInSecs;
    this.startAfter = startAfter;
  }
  





  public boolean runNow(long now)
  {
    return now > startAfter;
  }
  


  public boolean isActive()
  {
    return isActive;
  }
  



  public void setActive(boolean isActive)
  {
    this.isActive = isActive;
  }
  


  protected void runStart()
  {
    startTimeTemp = System.currentTimeMillis();
  }
  


  protected void runEnd()
  {
    runCount += 1;
    long exeTime = System.currentTimeMillis() - startTimeTemp;
    totalRunTime += exeTime;
  }
  


  public int getRunCount()
  {
    return runCount;
  }
  


  public long getAverageRunTime()
  {
    if (runCount == 0) {
      return 0L;
    }
    return totalRunTime / runCount;
  }
  


  public int getFreqInSecs()
  {
    return freqInSecs;
  }
  


  public void setFreqInSecs(int freqInSecs)
  {
    this.freqInSecs = freqInSecs;
  }
  


  public Runnable getRunnable()
  {
    return runnable;
  }
  


  public void setRunnable(Runnable runnable)
  {
    this.runnable = runnable;
  }
  
  public String toString() {
    StringBuffer sb = new StringBuffer();
    sb.append("[");
    sb.append(runnable.getClass().getName());
    sb.append(" freq:").append(freqInSecs);
    sb.append(" count:").append(getRunCount());
    sb.append(" avgTime:").append(getAverageRunTime());
    sb.append("]");
    return sb.toString();
  }
}
