package com.avaje.ebeaninternal.server.lib.cron;

import java.util.Calendar;





















public class CronRunnable
{
  boolean isEnabled = true;
  

  CronSchedule schedule;
  
  Runnable runnable;
  

  public CronRunnable(String schedule, Runnable runnable)
  {
    this(new CronSchedule(schedule), runnable);
  }
  


  public CronRunnable(CronSchedule schedule, Runnable runnable)
  {
    this.schedule = schedule;
    this.runnable = runnable;
  }
  
  public boolean equals(Object obj) {
    if (obj == null) {
      return false;
    }
    if ((obj instanceof CronRunnable)) {
      return hashCode() == obj.hashCode();
    }
    return false;
  }
  
  public int hashCode() {
    int hc = CronRunnable.class.getName().hashCode();
    hc += 31 * hc + schedule.hashCode();
    hc += 31 * hc + runnable.hashCode();
    return hc;
  }
  





  public boolean isScheduledToRunNow(Calendar thisMinute)
  {
    return (isEnabled) && (schedule.isScheduledToRunNow(thisMinute));
  }
  



  public void setSchedule(String scheduleLine)
  {
    schedule.setSchedule(scheduleLine);
  }
  


  public String getSchedule()
  {
    return schedule.getSchedule();
  }
  


  public Runnable getRunnable()
  {
    return runnable;
  }
  


  public void setRunnable(Runnable runnable)
  {
    this.runnable = runnable;
  }
  


  public boolean isEnabled()
  {
    return isEnabled;
  }
  



  public void setEnabled(boolean isEnabled)
  {
    this.isEnabled = isEnabled;
  }
  
  public String toString() {
    return "CronRunnable: isEnabled[" + isEnabled + "] sch[" + schedule.getSchedule() + "] [" + runnable.toString() + "]";
  }
}
