package com.avaje.ebeaninternal.server.lib.sql;

import java.util.ArrayList;
import java.util.List;





































class FreeConnectionBuffer
{
  private PooledConnection[] conns;
  private int removeIndex;
  private int addIndex;
  private int size;
  
  protected FreeConnectionBuffer(int capacity)
  {
    conns = new PooledConnection[capacity];
  }
  
  protected int getCapacity() {
    return conns.length;
  }
  
  protected int size() {
    return size;
  }
  
  protected boolean isEmpty() {
    return size == 0;
  }
  


  protected void add(PooledConnection pc)
  {
    conns[addIndex] = pc;
    addIndex = inc(addIndex);
    size += 1;
  }
  


  protected PooledConnection remove()
  {
    PooledConnection[] items = conns;
    PooledConnection pc = items[removeIndex];
    items[removeIndex] = null;
    removeIndex = inc(removeIndex);
    size -= 1;
    return pc;
  }
  



  protected List<PooledConnection> getShallowCopy()
  {
    List<PooledConnection> copy = new ArrayList(conns.length);
    for (int i = 0; i < conns.length; i++) {
      if (conns[i] != null) {
        copy.add(conns[i]);
      }
    }
    return copy;
  }
  









  protected void setShallowCopy(List<PooledConnection> copy)
  {
    removeIndex = 0;
    addIndex = 0;
    size = 0;
    

    for (int i = 0; i < conns.length; i++) {
      conns[i] = null;
    }
    

    for (int i = 0; i < copy.size(); i++) {
      add((PooledConnection)copy.get(i));
    }
  }
  



  protected void setCapacity(int newCapacity)
  {
    if (newCapacity > conns.length)
    {
      List<PooledConnection> copy = getShallowCopy();
      

      removeIndex = 0;
      addIndex = 0;
      size = 0;
      
      conns = new PooledConnection[newCapacity];
      

      for (int i = 0; i < copy.size(); i++) {
        add((PooledConnection)copy.get(i));
      }
    }
  }
  


  private final int inc(int i)
  {
    i++;return i == conns.length ? 0 : i;
  }
}
