package com.avaje.ebeaninternal.server.lib.util;

import java.util.Stack;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;






































public class DnodeParser
  extends DefaultHandler
{
  Dnode root;
  Dnode currentNode;
  StringBuffer buffer;
  Stack<Dnode> stack = new Stack();
  




  Class<?> nodeClass = Dnode.class;
  
  int depth = 0;
  



  boolean trimWhitespace = true;
  



  String contentName;
  



  int contentDepth;
  



  public boolean isTrimWhitespace()
  {
    return trimWhitespace;
  }
  


  public void setTrimWhitespace(boolean trimWhitespace)
  {
    this.trimWhitespace = trimWhitespace;
  }
  


  public Dnode getRoot()
  {
    return root;
  }
  


  public void setNodeClass(Class<?> nodeClass)
  {
    this.nodeClass = nodeClass;
  }
  

  private Dnode createNewNode()
  {
    try
    {
      return (Dnode)nodeClass.newInstance();
    } catch (Exception ex) {
      throw new RuntimeException(ex);
    }
  }
  




  public void startElement(String uri, String localName, String qName, Attributes attributes)
    throws SAXException
  {
    super.startElement(uri, localName, qName, attributes);
    depth += 1;
    
    boolean isContent = contentName != null;
    
    if (isContent)
    {
      buffer.append("<").append(localName);
      for (int i = 0; i < attributes.getLength(); i++) {
        String key = attributes.getLocalName(i);
        String val = attributes.getValue(i);
        buffer.append(" ").append(key).append("='").append(val).append("'");
      }
      buffer.append(">");
      return;
    }
    

    buffer = new StringBuffer();
    Dnode node = createNewNode();
    node.setNodeName(localName);
    for (int i = 0; i < attributes.getLength(); i++) {
      String key = attributes.getLocalName(i);
      String val = attributes.getValue(i);
      node.setAttribute(key, val);
      if (("type".equalsIgnoreCase(key)) && ("content".equalsIgnoreCase(val)))
      {

        contentName = localName;
        contentDepth = (depth - 1);
      }
    }
    
    if (root == null) {
      root = node;
    }
    if (currentNode != null) {
      currentNode.addChild(node);
    }
    stack.push(node);
    currentNode = node;
  }
  


  public void characters(char[] ch, int start, int length)
    throws SAXException
  {
    super.characters(ch, start, length);
    String s = new String(ch, start, length);
    int p = s.indexOf('\r');
    int p2 = s.indexOf('\n');
    if ((p == -1) && (p2 > -1))
    {

      s = StringHelper.replaceString(s, "\n", "\r\n");
    }
    buffer.append(s);
  }
  

  public void endElement(String uri, String localName, String qName)
    throws SAXException
  {
    super.endElement(uri, localName, qName);
    depth -= 1;
    
    if (contentName != null)
    {
      if ((contentName.equals(localName)) && (contentDepth == depth)) {
        contentName = null;
      }
      else
      {
        buffer.append("</").append(localName).append(">");
      }
      return;
    }
    String content = buffer.toString();
    if (content.length() > 0) {
      if (trimWhitespace) {
        content = content.trim();
      }
      if (content.length() > 0) {
        currentNode.setNodeContent(content);
      }
    }
    stack.pop();
    if (!stack.isEmpty())
    {
      currentNode = ((Dnode)stack.pop());
      stack.push(currentNode);
    }
  }
}
