package com.avaje.ebeaninternal.server.lucene;

import com.avaje.ebeaninternal.api.TransactionEventTable.TableIUD;
import com.avaje.ebeaninternal.server.deploy.BeanDescriptor;
import com.avaje.ebeaninternal.server.transaction.BeanDeltaList;
import com.avaje.ebeaninternal.server.transaction.BeanPersistIds;
import java.util.ArrayList;
import java.util.List;

























public class IndexUpdates
{
  private final BeanDescriptor<?> beanDescriptor;
  private List<TransactionEventTable.TableIUD> tableList;
  private BeanPersistIds deleteIds;
  private BeanPersistIds beanPersistIds;
  private BeanDeltaList deltaList;
  private boolean invalidate;
  
  public IndexUpdates(BeanDescriptor<?> beanDescriptor)
  {
    this.beanDescriptor = beanDescriptor;
  }
  
  public BeanDescriptor<?> getBeanDescriptor() {
    return beanDescriptor;
  }
  
  public boolean isInvalidate() {
    return invalidate;
  }
  
  public void setInvalidate(boolean invalidate) {
    this.invalidate = invalidate;
  }
  
  public void addTableIUD(TransactionEventTable.TableIUD tableIud) {
    if (tableList == null) {
      tableList = new ArrayList(4);
    }
    tableList.add(tableIud);
  }
  
  public List<TransactionEventTable.TableIUD> getTableList() {
    return tableList;
  }
  
  public void setTableList(List<TransactionEventTable.TableIUD> tableList) {
    this.tableList = tableList;
  }
  
  public BeanPersistIds getBeanPersistIds() {
    return beanPersistIds;
  }
  
  public void setBeanPersistIds(BeanPersistIds beanPersistIds) {
    this.beanPersistIds = beanPersistIds;
  }
  
  public BeanPersistIds getDeleteIds() {
    return deleteIds;
  }
  
  public void setDeleteIds(BeanPersistIds deleteIds) {
    this.deleteIds = deleteIds;
  }
  
  public BeanDeltaList getDeltaList() {
    return deltaList;
  }
  
  public void setDeltaList(BeanDeltaList deltaList) {
    this.deltaList = deltaList;
  }
}
