package com.avaje.ebeaninternal.server.lucene;

import com.avaje.ebeaninternal.server.el.ElPropertyValue;
import com.avaje.ebeaninternal.server.type.ScalarType;
import java.util.Set;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.document.Field;




















public final class LIndexFieldBinary
  extends LIndexFieldBase
{
  public LIndexFieldBinary(Analyzer queryAnalyzer, String fieldName, FieldFactory fieldFactory, ElPropertyValue property)
  {
    super(queryAnalyzer, fieldName, 7, property, fieldFactory);
  }
  



  public void addIndexResolvePropertyNames(Set<String> resolvePropertyNames) {}
  


  public void addIndexRestorePropertyNames(Set<String> restorePropertyNames)
  {
    if ((propertyName != null) && (isStored())) {
      restorePropertyNames.add(propertyName);
    }
  }
  
  public String getSortableProperty()
  {
    return null;
  }
  

  public void readValue(Document doc, Object bean)
  {
    Object v = doc.get(fieldName);
    if (v != null) {
      v = scalarType.luceneFromIndexValue(v);
    }
    property.elSetValue(bean, v, true, false);
  }
  
  public DocFieldWriter createDocFieldWriter() {
    Field f = (Field)fieldFactory.createFieldable();
    return new Writer(property, scalarType, f, null);
  }
  
  private static class Writer implements DocFieldWriter
  {
    private final ElPropertyValue property;
    private final ScalarType<?> scalarType;
    private final Field field;
    
    private Writer(ElPropertyValue property, ScalarType<?> scalarType, Field field) {
      this.property = property;
      this.scalarType = scalarType;
      this.field = field;
    }
    
    public void writeValue(Object bean, Document document) {
      Object value = property.elGetValue(bean);
      
      if (value != null)
      {


        byte[] s = (byte[])scalarType.luceneToIndexValue(value);
        field.setValue(s);
        document.add(field);
      }
    }
  }
}
