package com.avaje.ebeaninternal.server.lucene;

import com.avaje.ebeaninternal.server.deploy.id.IdBinder;
import com.avaje.ebeaninternal.server.el.ElPropertyValue;
import java.io.PrintStream;
import java.util.Set;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.document.Field;
import org.apache.lucene.index.Term;



















public final class LIndexFieldId
  extends LIndexFieldBase
{
  private final IdBinder idBinder;
  
  public LIndexFieldId(Analyzer queryAnalyzer, String fieldName, FieldFactory fieldFactory, ElPropertyValue property, IdBinder idBinder)
  {
    super(queryAnalyzer, fieldName, 0, property, fieldFactory);
    this.idBinder = idBinder;
  }
  
  public Term createTerm(Object id) {
    String termVal = idBinder.writeTerm(id);
    return new Term(fieldName, termVal);
  }
  
  public void addIndexResolvePropertyNames(Set<String> resolvePropertyNames) {
    if ((propertyName != null) && (isIndexed())) {
      resolvePropertyNames.add(propertyName);
    }
  }
  
  public void addIndexRestorePropertyNames(Set<String> restorePropertyNames) {
    if ((propertyName != null) && (isStored())) {
      restorePropertyNames.add(propertyName);
    }
  }
  
  public String getSortableProperty() {
    if ((isIndexed()) && (!isTokenized()))
    {

      return propertyName;
    }
    return null;
  }
  

  public void readValue(Document doc, Object bean)
  {
    String v = doc.get(fieldName);
    if (v != null) {
      Object id = idBinder.readTerm(v);
      property.elSetValue(bean, id, true, false);
    }
  }
  
  public DocFieldWriter createDocFieldWriter()
  {
    Field f = (Field)fieldFactory.createFieldable();
    return new Writer(property, f, idBinder);
  }
  
  private static class Writer implements DocFieldWriter
  {
    private final IdBinder idBinder;
    private final ElPropertyValue property;
    private final Field field;
    
    Writer(ElPropertyValue property, Field field, IdBinder idBinder) {
      this.property = property;
      this.field = field;
      this.idBinder = idBinder;
    }
    
    public void writeValue(Object bean, Document document)
    {
      Object value = property.elGetValue(bean);
      
      if (value != null)
      {

        System.out.println("- write " + field.name() + " " + value);
        
        String writeTerm = idBinder.writeTerm(value);
        field.setValue(writeTerm);
        document.add(field);
      }
    }
  }
}
