package com.avaje.ebeaninternal.server.lucene;

import com.avaje.ebeaninternal.server.el.ElPropertyValue;
import com.avaje.ebeaninternal.server.type.ScalarType;
import java.io.PrintStream;
import java.util.Set;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.document.NumericField;



















public final class LIndexFieldNumeric
  extends LIndexFieldBase
{
  public LIndexFieldNumeric(Analyzer queryAnalyzer, String fieldName, FieldFactory fieldFactory, int luceneType, ElPropertyValue property)
  {
    super(queryAnalyzer, fieldName, luceneType, property, fieldFactory);
  }
  
  public void addIndexResolvePropertyNames(Set<String> resolvePropertyNames) {
    if ((propertyName != null) && (isIndexed())) {
      resolvePropertyNames.add(propertyName);
    }
  }
  
  public void addIndexRestorePropertyNames(Set<String> restorePropertyNames) {
    if ((propertyName != null) && (isStored())) {
      restorePropertyNames.add(propertyName);
    }
  }
  
  public String getSortableProperty() {
    return isIndexed() ? propertyName : null;
  }
  
  public DocFieldWriter createDocFieldWriter() {
    NumericField f = (NumericField)fieldFactory.createFieldable();
    return new Writer(luceneType, property, scalarType, f);
  }
  
  private static class Writer implements DocFieldWriter
  {
    private final int luceneType;
    private final ElPropertyValue property;
    private final ScalarType<?> scalarType;
    private final NumericField field;
    
    Writer(int luceneType, ElPropertyValue property, ScalarType<?> scalarType, NumericField field) {
      this.luceneType = luceneType;
      this.property = property;
      this.scalarType = scalarType;
      this.field = field;
    }
    
    public void writeValue(Object bean, Document document)
    {
      Object value = property.elGetValue(bean);
      if (value != null)
      {


        System.out.println("- write " + field.name() + " " + value);
        
        value = scalarType.luceneToIndexValue(value);
        setValueToField(value);
        document.add(field);
      }
    }
    
    protected void setValueToField(Object value)
    {
      switch (luceneType) {
      case 1: 
        field.setIntValue(((Integer)value).intValue());
        break;
      
      case 2: 
        field.setLongValue(((Long)value).longValue());
        break;
      
      case 5: 
        field.setLongValue(((Long)value).longValue());
        break;
      
      case 6: 
        field.setLongValue(((Long)value).longValue());
        break;
      
      case 3: 
        field.setDoubleValue(((Double)value).doubleValue());
        break;
      
      case 4: 
        field.setFloatValue(((Float)value).floatValue());
        break;
      
      default: 
        throw new RuntimeException("Unhandled type " + luceneType);
      }
    }
  }
}
