package com.avaje.ebeaninternal.server.lucene;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.File;
import java.io.IOException;






















public class LIndexFileInfo
{
  private final transient File file;
  private final String name;
  private final long length;
  private final long lastModified;
  
  public LIndexFileInfo(File file)
  {
    this.file = file;
    name = file.getName();
    length = file.length();
    lastModified = file.lastModified();
  }
  
  public LIndexFileInfo(String name, long length, long lastModified) {
    file = null;
    this.name = name;
    this.length = length;
    this.lastModified = lastModified;
  }
  
  public String toString() {
    return name + " length[" + length + "] lastModified[" + lastModified + "]";
  }
  
  public static LIndexFileInfo read(DataInput dataInput) throws IOException {
    String name = dataInput.readUTF();
    long len = dataInput.readLong();
    long lastMod = dataInput.readLong();
    return new LIndexFileInfo(name, len, lastMod);
  }
  
  public void write(DataOutput dataOutput) throws IOException {
    dataOutput.writeUTF(name);
    dataOutput.writeLong(length);
    dataOutput.writeLong(lastModified);
  }
  
  public boolean exists() {
    return file.exists();
  }
  
  public File getFile() {
    return file;
  }
  
  public String getName() {
    return name;
  }
  
  public long getLength() {
    return length;
  }
  
  public long getLastModified() {
    return lastModified;
  }
  
  public boolean isMatch(LIndexFileInfo otherFile) {
    return (length == length) && (lastModified == lastModified);
  }
}
