package com.avaje.ebeaninternal.server.lucene;

import com.avaje.ebean.config.lucene.IndexUpdateFuture;
import java.io.PrintStream;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;
import java.util.concurrent.FutureTask;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;


















public class LIndexUpdateFuture
  implements Future<Integer>, IndexUpdateFuture
{
  private final Class<?> beanType;
  private final Runnable commitRunnable;
  private final FutureTask<Void> commitFuture;
  private FutureTask<Integer> task;
  
  public LIndexUpdateFuture(Class<?> beanType)
  {
    this.beanType = beanType;
    commitRunnable = new DummyRunnable(null);
    commitFuture = new FutureTask(commitRunnable, null);
  }
  


  public Class<?> getBeanType()
  {
    return beanType;
  }
  
  public Runnable getCommitRunnable() {
    return commitFuture;
  }
  
  public void setTask(FutureTask<Integer> task) {
    this.task = task;
  }
  


  public boolean isCancelled()
  {
    return false;
  }
  


  public boolean cancel(boolean mayInterruptIfRunning)
  {
    return false;
  }
  

  public Integer get()
    throws InterruptedException, ExecutionException
  {
    commitFuture.get();
    return (Integer)task.get();
  }
  

  public Integer get(long timeout, TimeUnit unit)
    throws InterruptedException, ExecutionException, TimeoutException
  {
    commitFuture.get(timeout, unit);
    return (Integer)task.get(0L, unit);
  }
  


  public boolean isDone()
  {
    return commitFuture.isDone();
  }
  
  private static class DummyRunnable implements Runnable {
    public void run() {
      System.out.println("-- dummy runnable");
    }
  }
}
