package com.avaje.ebeaninternal.server.lucene;






public final class LIndexWork
{
  private final WorkType workType;
  




  private final LIndexUpdateFuture future;
  




  private final IndexUpdates indexUpdates;
  




  public static enum WorkType
  {
    TXN_UPDATE, 
    



    QUERY_UPDATE, 
    



    REBUILD;
    
    private WorkType() {} }
  
  public static LIndexWork newRebuild(LIndexUpdateFuture future) { return new LIndexWork(WorkType.REBUILD, future, null); }
  
  public static LIndexWork newQueryUpdate(LIndexUpdateFuture future)
  {
    return new LIndexWork(WorkType.QUERY_UPDATE, future, null);
  }
  
  public static LIndexWork newTxnUpdate(LIndexUpdateFuture future, IndexUpdates indexUpdates) {
    return new LIndexWork(WorkType.TXN_UPDATE, future, indexUpdates);
  }
  





  private LIndexWork(WorkType workType, LIndexUpdateFuture future, IndexUpdates indexUpdates)
  {
    this.workType = workType;
    this.future = future;
    this.indexUpdates = indexUpdates;
  }
  
  public WorkType getWorkType() {
    return workType;
  }
  
  public IndexUpdates getIndexUpdates() {
    return indexUpdates;
  }
  
  public LIndexUpdateFuture getFuture() {
    return future;
  }
}
