package com.avaje.ebeaninternal.server.lucene.cluster;

import com.avaje.ebeaninternal.server.lucene.LIndex;
import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;





















public class SLuceneClient
{
  private final String serverName;
  private final LIndex index;
  private final long localVersion;
  private long remoteVersion;
  private final SocketClient client;
  
  public SLuceneClient(String serverName, SocketClient client, long localVersion, LIndex index)
  {
    this.serverName = serverName;
    this.client = client;
    this.localVersion = localVersion;
    this.index = index;
  }
  
  public void setRemoteVersion(long remoteVersion) {
    this.remoteVersion = remoteVersion;
  }
  
  public LIndex getIndex() {
    return index;
  }
  
  public void disconnect() {
    client.disconnect();
  }
  
  public SocketClient getSocketClient() {
    return client;
  }
  
  private void sendMessageHeader(short msgType, long version) throws IOException
  {
    client.connect();
    client.initData();
    
    DataOutput dataOutput = client.getDataOutput();
    dataOutput.writeUTF(serverName);
    dataOutput.writeShort(msgType);
    dataOutput.writeUTF(index.getName());
    dataOutput.writeLong(version);
  }
  
  private boolean sendMessageHeader2(short msgType, long version) throws IOException {
    sendMessageHeader(msgType, version);
    client.getOutputStream().flush();
    return client.getDataInput().readBoolean();
  }
  
  public boolean sendObtainCommit() throws IOException
  {
    return sendMessageHeader2((short)2, localVersion);
  }
  
  public void sendRelease() throws IOException {
    sendMessageHeader2((short)3, remoteVersion);
  }
  
  public InputStream sendGetFile(String fileName) throws IOException
  {
    sendMessageHeader((short)4, remoteVersion);
    client.getDataOutput().writeUTF(fileName);
    client.getOutputStream().flush();
    boolean exists = client.getDataInput().readBoolean();
    if (!exists) {
      return null;
    }
    return client.getInputStream();
  }
}
