package com.avaje.ebeaninternal.server.persist;

import com.avaje.ebeaninternal.api.SpiTransaction;
import com.avaje.ebeaninternal.server.core.PersistRequest;
import com.avaje.ebeaninternal.server.core.PersistRequestBean;
import com.avaje.ebeaninternal.server.deploy.BeanDescriptor;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
































public class BatchedBeanControl
{
  private final HashMap<String, BatchedBeanHolder> beanHoldMap = new HashMap();
  
  private final SpiTransaction transaction;
  
  private final BatchControl batchControl;
  private int topOrder;
  
  public BatchedBeanControl(SpiTransaction t, BatchControl batchControl)
  {
    transaction = t;
    this.batchControl = batchControl;
  }
  
  public ArrayList<PersistRequest> getPersistList(PersistRequestBean<?> request) {
    BatchedBeanHolder beanHolder = getBeanHolder(request);
    return beanHolder.getList(request);
  }
  




  private BatchedBeanHolder getBeanHolder(PersistRequestBean<?> request)
  {
    BeanDescriptor<?> beanDescriptor = request.getBeanDescriptor();
    BatchedBeanHolder batchBeanHolder = (BatchedBeanHolder)beanHoldMap.get(beanDescriptor.getFullName());
    if (batchBeanHolder == null) {
      int relativeDepth = transaction.depth(0);
      
      if (relativeDepth == 0) {
        topOrder += 1;
      }
      int stmtOrder = topOrder * 100 + relativeDepth;
      
      batchBeanHolder = new BatchedBeanHolder(batchControl, beanDescriptor, stmtOrder);
      beanHoldMap.put(beanDescriptor.getFullName(), batchBeanHolder);
    }
    return batchBeanHolder;
  }
  


  public boolean isEmpty()
  {
    return beanHoldMap.isEmpty();
  }
  





  public BatchedBeanHolder[] getArray()
  {
    BatchedBeanHolder[] bsArray = new BatchedBeanHolder[beanHoldMap.size()];
    beanHoldMap.values().toArray(bsArray);
    beanHoldMap.clear();
    topOrder = 0;
    return bsArray;
  }
}
