package com.avaje.ebeaninternal.server.persist;

import com.avaje.ebeaninternal.server.core.PersistRequest;
import com.avaje.ebeaninternal.server.core.PersistRequestBean;
import com.avaje.ebeaninternal.server.deploy.BeanDescriptor;
import java.util.ArrayList;
import java.util.HashSet;






















































public class BatchedBeanHolder
{
  private final BatchControl control;
  private final String shortDesc;
  private final int order;
  private ArrayList<PersistRequest> inserts;
  private ArrayList<PersistRequest> updates;
  private ArrayList<PersistRequest> deletes;
  private HashSet<Integer> beanHashCodes = new HashSet();
  


  public BatchedBeanHolder(BatchControl control, BeanDescriptor<?> beanDescriptor, int order)
  {
    this.control = control;
    shortDesc = (beanDescriptor.getName() + ":" + order);
    this.order = order;
  }
  


  public int getOrder()
  {
    return order;
  }
  











  public void executeNow()
  {
    if (inserts != null) {
      control.executeNow(inserts);
      inserts.clear();
    }
    if (updates != null) {
      control.executeNow(updates);
      updates.clear();
    }
    if (deletes != null) {
      control.executeNow(deletes);
      deletes.clear();
    }
    beanHashCodes.clear();
  }
  
  public String toString() {
    return shortDesc;
  }
  



  public ArrayList<PersistRequest> getList(PersistRequestBean<?> request)
  {
    Integer objHashCode = Integer.valueOf(System.identityHashCode(request.getBean()));
    
    if (!beanHashCodes.add(objHashCode))
    {


      return null;
    }
    
    switch (1.$SwitchMap$com$avaje$ebeaninternal$server$core$PersistRequest$Type[request.getType().ordinal()]) {
    case 1: 
      if (inserts == null) {
        inserts = new ArrayList();
      }
      return inserts;
    
    case 2: 
      if (updates == null) {
        updates = new ArrayList();
      }
      return updates;
    
    case 3: 
      if (deletes == null) {
        deletes = new ArrayList();
      }
      return deletes;
    }
    
    throw new RuntimeException("Invalid type code " + request.getType());
  }
}
