package com.avaje.ebeaninternal.server.persist;

import com.avaje.ebean.ExpressionList;
import com.avaje.ebeaninternal.api.SpiEbeanServer;
import com.avaje.ebeaninternal.api.SpiQuery;
import com.avaje.ebeaninternal.api.SpiTransaction;
import com.avaje.ebeaninternal.server.core.PersistRequestBean;
import com.avaje.ebeaninternal.server.deploy.BeanDescriptor;
import com.avaje.ebeaninternal.server.deploy.BeanPropertyAssocOne;
import com.avaje.ebeaninternal.server.transaction.DefaultPersistenceContext;
import java.util.ArrayList;
import java.util.List;






























public class DeleteUnloadedForeignKeys
{
  private final List<BeanPropertyAssocOne<?>> propList = new ArrayList(4);
  
  private final SpiEbeanServer server;
  
  private final PersistRequestBean<?> request;
  private Object beanWithForeignKeys;
  
  public DeleteUnloadedForeignKeys(SpiEbeanServer server, PersistRequestBean<?> request)
  {
    this.server = server;
    this.request = request;
  }
  
  public boolean isEmpty() {
    return propList.isEmpty();
  }
  
  public void add(BeanPropertyAssocOne<?> prop) {
    propList.add(prop);
  }
  




  public void queryForeignKeys()
  {
    BeanDescriptor<?> descriptor = request.getBeanDescriptor();
    SpiQuery<?> q = (SpiQuery)server.createQuery(descriptor.getBeanType());
    
    Object id = request.getBeanId();
    
    StringBuilder sb = new StringBuilder(30);
    for (int i = 0; i < propList.size(); i++) {
      sb.append(((BeanPropertyAssocOne)propList.get(i)).getName()).append(",");
    }
    

    q.setPersistenceContext(new DefaultPersistenceContext());
    q.setAutofetch(false);
    q.select(sb.toString());
    q.where().idEq(id);
    
    SpiTransaction t = request.getTransaction();
    if (t.isLogSummary()) {
      t.logInternal("-- Ebean fetching foreign key values for delete of " + descriptor.getName() + " id:" + id);
    }
    beanWithForeignKeys = server.findUnique(q, t);
  }
  




  public void deleteCascade()
  {
    for (int i = 0; i < propList.size(); i++) {
      BeanPropertyAssocOne<?> prop = (BeanPropertyAssocOne)propList.get(i);
      Object detailBean = prop.getValue(beanWithForeignKeys);
      

      if ((detailBean != null) && (prop.hasId(detailBean))) {
        server.delete(detailBean, request.getTransaction());
      }
    }
  }
}
