package com.avaje.ebeaninternal.server.persist.dml;

import com.avaje.ebeaninternal.api.SpiTransaction;
import com.avaje.ebeaninternal.server.core.PersistRequestBean;
import com.avaje.ebeaninternal.server.deploy.BeanProperty;
import com.avaje.ebeaninternal.server.type.DataBind;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Set;
import javax.persistence.OptimisticLockException;






















public class DeleteHandler
  extends DmlHandler
{
  private final DeleteMeta meta;
  
  public DeleteHandler(PersistRequestBean<?> persist, DeleteMeta meta)
  {
    super(persist, meta.isEmptyStringAsNull());
    this.meta = meta;
  }
  


  public void bind()
    throws SQLException
  {
    sql = meta.getSql(persistRequest);
    
    SpiTransaction t = persistRequest.getTransaction();
    boolean isBatch = t.isBatchThisRequest();
    PreparedStatement pstmt;
    PreparedStatement pstmt;
    if (isBatch) {
      pstmt = getPstmt(t, sql, persistRequest, false);
    }
    else {
      logSql(sql);
      pstmt = getPstmt(t, sql, false);
    }
    dataBind = new DataBind(pstmt);
    
    bindLogAppend("Binding Delete [");
    bindLogAppend(meta.getTableName());
    bindLogAppend("] where[");
    
    meta.bind(persistRequest, this);
    
    bindLogAppend("]");
    

    logBinding();
  }
  

  public void execute()
    throws SQLException, OptimisticLockException
  {
    int rowCount = dataBind.executeUpdate();
    checkRowCount(rowCount);
  }
  
  public boolean isIncluded(BeanProperty prop)
  {
    return (prop.isDbUpdatable()) && (super.isIncluded(prop));
  }
  
  public boolean isIncludedWhere(BeanProperty prop)
  {
    return (prop.isDbUpdatable()) && ((loadedProps == null) || (loadedProps.contains(prop.getName())));
  }
}
