package com.avaje.ebeaninternal.server.persist.dml;

import com.avaje.ebeaninternal.server.deploy.BeanProperty;
import java.util.Set;







public class GenerateDmlRequest
{
  private static final String IS_NULL = " is null";
  private final boolean emptyStringAsNull;
  private final StringBuilder sb = new StringBuilder(100);
  
  private final Set<String> includeProps;
  
  private final Set<String> includeWhereProps;
  
  private final Object oldValues;
  
  private StringBuilder insertBindBuffer;
  
  private String prefix;
  
  private String prefix2;
  
  private int insertMode;
  
  private int bindColumnCount;
  
  public GenerateDmlRequest(boolean emptyStringAsNull, Set<String> includeProps, Object oldValues)
  {
    this(emptyStringAsNull, includeProps, includeProps, oldValues);
  }
  


  public GenerateDmlRequest(boolean emptyStringAsNull, Set<String> includeProps, Set<String> includeWhereProps, Object oldValues)
  {
    this.emptyStringAsNull = emptyStringAsNull;
    this.includeProps = includeProps;
    this.includeWhereProps = includeWhereProps;
    this.oldValues = oldValues;
  }
  


  public GenerateDmlRequest(boolean emptyStringAsNull)
  {
    this(emptyStringAsNull, null, null, null);
  }
  
  public GenerateDmlRequest append(String s) {
    sb.append(s);
    return this;
  }
  
  public boolean isDbNull(Object v) {
    return (v == null) || ((emptyStringAsNull) && ((v instanceof String)) && (((String)v).length() == 0));
  }
  


  public boolean isIncluded(BeanProperty prop)
  {
    return (includeProps == null) || (includeProps.contains(prop.getName()));
  }
  


  public boolean isIncludedWhere(BeanProperty prop)
  {
    return (includeWhereProps == null) || (includeWhereProps.contains(prop.getName()));
  }
  
  public void appendColumnIsNull(String column) {
    appendColumn(column, " is null");
  }
  
  public void appendColumn(String column) {
    String bind = insertMode > 0 ? "?" : "=?";
    appendColumn(column, bind);
  }
  
  public void appendColumn(String column, String suffik) {
    appendColumn(column, "", suffik);
  }
  
  public void appendColumn(String column, String expr, String suffik)
  {
    bindColumnCount += 1;
    
    sb.append(prefix);
    sb.append(column);
    sb.append(expr);
    if (insertMode > 0) {
      if (insertMode++ > 1) {
        insertBindBuffer.append(",");
      }
      insertBindBuffer.append(suffik);
    } else {
      sb.append(suffik);
    }
    
    if (prefix2 != null) {
      prefix = prefix2;
      prefix2 = null;
    }
  }
  
  public int getBindColumnCount() {
    return bindColumnCount;
  }
  
  public String getInsertBindBuffer() {
    return insertBindBuffer.toString();
  }
  
  public String toString() {
    return sb.toString();
  }
  
  public void setWhereMode() {
    prefix = " and ";
    prefix2 = " and ";
  }
  
  public void setWhereIdMode() {
    prefix = "";
    prefix2 = " and ";
  }
  
  public void setInsertSetMode() {
    insertBindBuffer = new StringBuilder(100);
    insertMode = 1;
    prefix = "";
    prefix2 = ", ";
  }
  
  public void setUpdateSetMode() {
    prefix = "";
    prefix2 = ", ";
  }
  
  public Object getOldValues() {
    return oldValues;
  }
}
