package com.avaje.ebeaninternal.server.persist.dmlbind;

import com.avaje.ebeaninternal.server.core.PersistRequestBean;
import com.avaje.ebeaninternal.server.deploy.BeanPropertyAssocOne;
import com.avaje.ebeaninternal.server.deploy.id.ImportedId;
import com.avaje.ebeaninternal.server.persist.dml.GenerateDmlRequest;
import java.sql.SQLException;
import java.util.List;























public class BindableAssocOne
  implements Bindable
{
  private final BeanPropertyAssocOne<?> assocOne;
  private final ImportedId importedId;
  
  public BindableAssocOne(BeanPropertyAssocOne<?> assocOne)
  {
    this.assocOne = assocOne;
    importedId = assocOne.getImportedId();
  }
  
  public String toString() {
    return "BindableAssocOne " + assocOne;
  }
  
  public void addChanged(PersistRequestBean<?> request, List<Bindable> list) {
    if (request.hasChanged(assocOne)) {
      list.add(this);
    }
  }
  
  public void dmlInsert(GenerateDmlRequest request, boolean checkIncludes) {
    dmlAppend(request, checkIncludes);
  }
  
  public void dmlAppend(GenerateDmlRequest request, boolean checkIncludes) {
    if ((checkIncludes) && (!request.isIncluded(assocOne))) {
      return;
    }
    importedId.dmlAppend(request);
  }
  


  public void dmlWhere(GenerateDmlRequest request, boolean checkIncludes, Object bean)
  {
    if ((checkIncludes) && (!request.isIncludedWhere(assocOne))) {
      return;
    }
    Object assocBean = assocOne.getValue(bean);
    importedId.dmlWhere(request, assocBean);
  }
  
  public void dmlBind(BindableRequest request, boolean checkIncludes, Object bean) throws SQLException {
    if ((checkIncludes) && (!request.isIncluded(assocOne))) {
      return;
    }
    dmlBind(request, bean, true);
  }
  
  public void dmlBindWhere(BindableRequest request, boolean checkIncludes, Object bean) throws SQLException {
    if ((checkIncludes) && (!request.isIncludedWhere(assocOne))) {
      return;
    }
    dmlBind(request, bean, false);
  }
  
  private void dmlBind(BindableRequest request, Object bean, boolean bindNull)
    throws SQLException
  {
    Object assocBean = assocOne.getValue(bean);
    importedId.bind(request, assocBean, bindNull);
  }
}
