package com.avaje.ebeaninternal.server.query;

import com.avaje.ebean.QueryIterator;
import com.avaje.ebeaninternal.server.core.OrmQueryRequest;
import java.sql.SQLException;
import java.util.ArrayList;
import javax.persistence.PersistenceException;






























class CQueryIteratorWithBuffer<T>
  implements QueryIterator<T>
{
  private final CQuery<T> cquery;
  private final int bufferSize;
  private final OrmQueryRequest<T> request;
  private final ArrayList<T> buffer;
  private boolean moreToLoad = true;
  
  CQueryIteratorWithBuffer(CQuery<T> cquery, OrmQueryRequest<T> request, int bufferSize) {
    this.cquery = cquery;
    this.request = request;
    this.bufferSize = bufferSize;
    buffer = new ArrayList(bufferSize);
  }
  
  public boolean hasNext() {
    try {
      if ((buffer.isEmpty()) && (moreToLoad))
      {
        int i = -1;
        while (moreToLoad) { i++; if (i >= bufferSize) break;
          if (cquery.hasNextBean(true)) {
            buffer.add(cquery.getLoadedBean());
          } else {
            moreToLoad = false;
          }
        }
        
        request.executeSecondaryQueries(bufferSize);
      }
      return !buffer.isEmpty();
    }
    catch (SQLException e) {
      throw cquery.createPersistenceException(e);
    }
  }
  
  public T next() {
    return buffer.remove(0);
  }
  
  public void close() {
    cquery.updateExecutionStatistics();
    cquery.close();
    request.endTransIfRequired();
  }
  
  public void remove() {
    throw new PersistenceException("Remove not allowed");
  }
}
