package com.avaje.ebeaninternal.server.query;

import com.avaje.ebean.SqlRow;
import com.avaje.ebeaninternal.server.core.BasicTypeConverter;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import java.util.UUID;














































public class DefaultSqlRow
  implements SqlRow
{
  static final long serialVersionUID = -3120927797041336242L;
  private final String dbTrueValue;
  Map<String, Object> map;
  
  public DefaultSqlRow(Map<String, Object> map, String dbTrueValue)
  {
    this.map = map;
    this.dbTrueValue = dbTrueValue;
  }
  



  public DefaultSqlRow(String dbTrueValue)
  {
    map = new LinkedHashMap();
    this.dbTrueValue = dbTrueValue;
  }
  









  public DefaultSqlRow(int initialCapacity, float loadFactor, String dbTrueValue)
  {
    map = new LinkedHashMap(initialCapacity, loadFactor);
    this.dbTrueValue = dbTrueValue;
  }
  
  public Iterator<String> keys() {
    return map.keySet().iterator();
  }
  
  public Object remove(Object name) {
    name = ((String)name).toLowerCase();
    return map.remove(name);
  }
  
  public Object get(Object name) {
    name = ((String)name).toLowerCase();
    return map.get(name);
  }
  
  public Object put(String name, Object value) {
    return setInternal(name, value);
  }
  
  public Object set(String name, Object value) {
    return setInternal(name, value);
  }
  
  private Object setInternal(String name, Object newValue)
  {
    name = name.toLowerCase();
    

    return map.put(name, newValue);
  }
  
  public UUID getUUID(String name) {
    Object val = get(name);
    return BasicTypeConverter.toUUID(val);
  }
  
  public Boolean getBoolean(String name) {
    Object val = get(name);
    return BasicTypeConverter.toBoolean(val, dbTrueValue);
  }
  
  public Integer getInteger(String name) {
    Object val = get(name);
    return BasicTypeConverter.toInteger(val);
  }
  
  public BigDecimal getBigDecimal(String name) {
    Object val = get(name);
    return BasicTypeConverter.toBigDecimal(val);
  }
  
  public Long getLong(String name) {
    Object val = get(name);
    return BasicTypeConverter.toLong(val);
  }
  
  public Double getDouble(String name) {
    Object val = get(name);
    return BasicTypeConverter.toDouble(val);
  }
  
  public Float getFloat(String name) {
    Object val = get(name);
    return BasicTypeConverter.toFloat(val);
  }
  
  public String getString(String name) {
    Object val = get(name);
    return BasicTypeConverter.toString(val);
  }
  
  public java.util.Date getUtilDate(String name) {
    Object val = get(name);
    return BasicTypeConverter.toUtilDate(val);
  }
  
  public java.sql.Date getDate(String name) {
    Object val = get(name);
    return BasicTypeConverter.toDate(val);
  }
  
  public Timestamp getTimestamp(String name) {
    Object val = get(name);
    return BasicTypeConverter.toTimestamp(val);
  }
  
  public String toString() {
    return map.toString();
  }
  


  public void clear()
  {
    map.clear();
  }
  
  public boolean containsKey(Object key) {
    key = ((String)key).toLowerCase();
    return map.containsKey(key);
  }
  
  public boolean containsValue(Object value) {
    return map.containsValue(value);
  }
  
  public Set<Map.Entry<String, Object>> entrySet() {
    return map.entrySet();
  }
  
  public boolean isEmpty() {
    return map.isEmpty();
  }
  
  public Set<String> keySet() {
    return map.keySet();
  }
  
  public void putAll(Map<? extends String, ? extends Object> t) {
    map.putAll(t);
  }
  
  public int size() {
    return map.size();
  }
  
  public Collection<Object> values() {
    return map.values();
  }
}
