package com.avaje.ebeaninternal.server.query;

import com.avaje.ebeaninternal.server.deploy.BeanDescriptor;
import com.avaje.ebeaninternal.server.lucene.LIndex;
import com.avaje.ebeaninternal.server.lucene.LIndexField;
import com.avaje.ebeaninternal.server.lucene.LIndexFields;
import java.util.Set;





















public class LuceneResolvableRequest
{
  private final BeanDescriptor<?> beanDescriptor;
  private final LIndex luceneIndex;
  private final Set<String> resolvePropertyNames;
  
  public LuceneResolvableRequest(BeanDescriptor<?> beanDescriptor, LIndex luceneIndex)
  {
    this.beanDescriptor = beanDescriptor;
    this.luceneIndex = luceneIndex;
    resolvePropertyNames = luceneIndex.getResolvePropertyNames();
  }
  
  public boolean indexContains(String propertyName) {
    return resolvePropertyNames.contains(propertyName);
  }
  
  public LIndexField getSortableProperty(String propertyName) {
    return luceneIndex.getIndexFieldDefn().getSortableField(propertyName);
  }
  
  public BeanDescriptor<?> getBeanDescriptor() {
    return beanDescriptor;
  }
}
