package com.avaje.ebeaninternal.server.query;

import com.avaje.ebeaninternal.server.deploy.BeanPropertyAssoc;
import com.avaje.ebeaninternal.server.deploy.BeanPropertyAssocMany;
import com.avaje.ebeaninternal.server.deploy.DbReadContext;
import com.avaje.ebeaninternal.server.deploy.DbSqlContext;
import com.avaje.ebeaninternal.server.deploy.TableJoin;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;












public class SqlTreeNodeExtraJoin
  implements SqlTreeNode
{
  final BeanPropertyAssoc<?> assocBeanProperty;
  final String prefix;
  final boolean manyJoin;
  List<SqlTreeNodeExtraJoin> children;
  
  public SqlTreeNodeExtraJoin(String prefix, BeanPropertyAssoc<?> assocBeanProperty)
  {
    this.prefix = prefix;
    this.assocBeanProperty = assocBeanProperty;
    manyJoin = (assocBeanProperty instanceof BeanPropertyAssocMany);
  }
  






  public void buildSelectExpressionChain(List<String> selectChain) {}
  





  public boolean isManyJoin()
  {
    return manyJoin;
  }
  
  public String getName()
  {
    return prefix;
  }
  
  public void addChild(SqlTreeNodeExtraJoin child) {
    if (children == null) {
      children = new ArrayList();
    }
    children.add(child);
  }
  
  public void appendFrom(DbSqlContext ctx, boolean forceOuterJoin)
  {
    boolean manyToMany = false;
    
    if ((assocBeanProperty instanceof BeanPropertyAssocMany)) {
      BeanPropertyAssocMany<?> manyProp = (BeanPropertyAssocMany)assocBeanProperty;
      if (manyProp.isManyToMany())
      {
        manyToMany = true;
        
        String alias = ctx.getTableAlias(prefix);
        String[] split = SplitName.split(prefix);
        String parentAlias = ctx.getTableAlias(split[0]);
        String alias2 = alias + "z_";
        
        TableJoin manyToManyJoin = manyProp.getIntersectionTableJoin();
        manyToManyJoin.addJoin(forceOuterJoin, parentAlias, alias2, ctx);
        
        assocBeanProperty.addJoin(forceOuterJoin, alias2, alias, ctx);
      }
    }
    
    if (!manyToMany) {
      assocBeanProperty.addJoin(forceOuterJoin, prefix, ctx);
    }
    
    if (children != null)
    {
      if (manyJoin)
      {
        forceOuterJoin = true;
      }
      
      for (int i = 0; i < children.size(); i++) {
        SqlTreeNodeExtraJoin child = (SqlTreeNodeExtraJoin)children.get(i);
        child.appendFrom(ctx, forceOuterJoin);
      }
    }
  }
  
  public void appendSelect(DbSqlContext ctx, boolean subQuery) {}
  
  public void appendWhere(DbSqlContext ctx) {}
  
  public void load(DbReadContext ctx, Object parentBean, int parentState)
    throws SQLException
  {}
}
