package com.avaje.ebeaninternal.server.transaction;

import com.avaje.ebean.LogLevel;
import java.sql.Connection;
import java.sql.SQLException;
import javax.persistence.PersistenceException;
import javax.sql.DataSource;
import javax.transaction.UserTransaction;


























public class JtaTransaction
  extends JdbcTransaction
{
  private UserTransaction userTransaction;
  private DataSource dataSource;
  private boolean commmitted = false;
  
  private boolean newTransaction = false;
  



  public JtaTransaction(String id, boolean explicit, LogLevel logLevel, UserTransaction utx, DataSource ds, TransactionManager manager)
  {
    super(id, explicit, logLevel, null, manager);
    userTransaction = utx;
    dataSource = ds;
    try
    {
      newTransaction = (userTransaction.getStatus() == 6);
      if (newTransaction) {
        userTransaction.begin();
      }
    } catch (Exception e) {
      throw new PersistenceException(e);
    }
    
    try
    {
      connection = dataSource.getConnection();
      if (connection == null) {
        throw new PersistenceException("The DataSource returned a null connection.");
      }
      if (connection.getAutoCommit()) {
        connection.setAutoCommit(false);
      }
    }
    catch (SQLException e) {
      throw new PersistenceException(e);
    }
  }
  


  public void commit()
  {
    if (commmitted) {
      throw new PersistenceException("This transaction has already been committed.");
    }
    try {
      try {
        if (newTransaction) {
          userTransaction.commit();
        }
        notifyCommit();
      } finally {
        close();
      }
    } catch (Exception e) {
      throw new PersistenceException(e);
    }
    commmitted = true;
  }
  
  public void rollback() {
    rollback(null);
  }
  


  public void rollback(Throwable e)
  {
    if (!commmitted) {
      try {
        try {
          if (userTransaction != null) {
            if (newTransaction) {
              userTransaction.rollback();
            } else {
              userTransaction.setRollbackOnly();
            }
          }
          notifyRollback(e);
        } finally {
          close();
        }
      } catch (Exception ex) {
        throw new PersistenceException(ex);
      }
    }
  }
  


  private void close()
    throws SQLException
  {
    if (connection != null) {
      connection.close();
      connection = null;
    }
  }
}
