package com.avaje.ebeaninternal.server.transaction;

import java.util.ArrayList;
import java.util.List;




































public class TransactionLogBuffer
{
  private final String transactionId;
  private final ArrayList<LogEntry> buffer;
  private final int maxSize;
  private int currentSize;
  
  public TransactionLogBuffer(int maxSize, String transactionId)
  {
    this.maxSize = maxSize;
    this.transactionId = transactionId;
    buffer = new ArrayList(maxSize);
  }
  


  public TransactionLogBuffer newBuffer()
  {
    return new TransactionLogBuffer(maxSize, transactionId);
  }
  


  public String getTransactionId()
  {
    return transactionId;
  }
  


  public boolean add(String msg)
  {
    buffer.add(new LogEntry(msg));
    return ++currentSize >= maxSize;
  }
  


  public boolean isEmpty()
  {
    return buffer.isEmpty();
  }
  


  public List<LogEntry> messages()
  {
    return buffer;
  }
  


  public class LogEntry
  {
    private final long timestamp;
    

    private final String msg;
    

    public LogEntry(String msg)
    {
      timestamp = System.currentTimeMillis();
      this.msg = msg;
    }
    


    public long getTimestamp()
    {
      return timestamp;
    }
    


    public String getMsg()
    {
      return msg;
    }
  }
}
