package com.avaje.ebeaninternal.server.transaction;

import com.avaje.ebean.config.ServerConfig;
import com.avaje.ebeaninternal.server.transaction.log.FileTransactionLoggerWrapper;
import com.avaje.ebeaninternal.server.transaction.log.JuliTransactionLogger;































public class TransactionLogManager
{
  private final TransactionLogWriter logWriter;
  
  public TransactionLogManager(ServerConfig serverConfig)
  {
    if (serverConfig.isLoggingToJavaLogger()) {
      logWriter = new JuliTransactionLogger();
    } else {
      logWriter = new FileTransactionLoggerWrapper(serverConfig);
    }
  }
  
  public void shutdown() {
    logWriter.shutdown();
  }
  
  public void log(TransactionLogBuffer logBuffer) {
    logWriter.log(logBuffer);
  }
}
