package com.avaje.ebeaninternal.server.transaction;

import com.avaje.ebeaninternal.api.SpiTransaction;
import java.util.HashMap;
import javax.persistence.PersistenceException;

























public class TransactionMap
{
  HashMap<String, State> map;
  
  public TransactionMap()
  {
    map = new HashMap();
  }
  


  public State getState(String serverName)
  {
    State state = (State)map.get(serverName);
    if (state == null) {
      state = new State();
      map.put(serverName, state);
    }
    return state;
  }
  

  public static class State
  {
    SpiTransaction transaction;
    

    public SpiTransaction get()
    {
      return transaction;
    }
    



    public void set(SpiTransaction trans)
    {
      if ((transaction != null) && (transaction.isActive())) {
        String m = "The existing transaction is still active?";
        throw new PersistenceException(m);
      }
      transaction = trans;
    }
    



    public void commit()
    {
      transaction.commit();
      transaction = null;
    }
    


    public void rollback()
    {
      transaction.rollback();
      transaction = null;
    }
    


    public void end()
    {
      if (transaction != null) {
        transaction.end();
        transaction = null;
      }
    }
    


    public void replace(SpiTransaction trans)
    {
      transaction = trans;
    }
  }
}
