package com.avaje.ebeaninternal.server.type;

import java.util.HashMap;




































public class BeanToDbMap<B, D>
{
  final HashMap<B, D> keyMap;
  final HashMap<D, B> valueMap;
  final boolean allowNulls;
  
  public BeanToDbMap()
  {
    this(false);
  }
  







  public BeanToDbMap(boolean allowNulls)
  {
    this.allowNulls = allowNulls;
    keyMap = new HashMap();
    valueMap = new HashMap();
  }
  


  public BeanToDbMap<B, D> add(B beanValue, D dbValue)
  {
    keyMap.put(beanValue, dbValue);
    valueMap.put(dbValue, beanValue);
    return this;
  }
  


  public D getDbValue(B beanValue)
  {
    if (beanValue == null) {
      return null;
    }
    D dbValue = keyMap.get(beanValue);
    if ((dbValue == null) && (!allowNulls)) {
      String msg = "DB value for " + beanValue + " not found in " + valueMap;
      throw new IllegalArgumentException(msg);
    }
    return dbValue;
  }
  


  public B getBeanValue(D dbValue)
  {
    if (dbValue == null) {
      return null;
    }
    B beanValue = valueMap.get(dbValue);
    if ((beanValue == null) && (!allowNulls)) {
      String msg = "Bean value for " + dbValue + " not found in " + valueMap;
      throw new IllegalArgumentException(msg);
    }
    return beanValue;
  }
}
