package com.avaje.ebeaninternal.server.type;

import com.avaje.ebean.config.CompoundTypeProperty;































public class CtCompoundProperty
{
  private final String relativeName;
  private final CtCompoundProperty parent;
  private final CtCompoundType<?> compoundType;
  private final CompoundTypeProperty property;
  
  public CtCompoundProperty(String relativeName, CtCompoundProperty parent, CtCompoundType<?> ctType, CompoundTypeProperty<?, ?> property)
  {
    this.relativeName = relativeName;
    this.parent = parent;
    compoundType = ctType;
    this.property = property;
  }
  


  public String getRelativeName()
  {
    return relativeName;
  }
  


  public String getPropertyName()
  {
    return property.getName();
  }
  
  public String toString() {
    return relativeName;
  }
  
  public Object getValue(Object valueObject)
  {
    if (valueObject == null) {
      return null;
    }
    if (parent != null) {
      valueObject = parent.getValue(valueObject);
    }
    return property.getValue(valueObject);
  }
  









  public Object setValue(Object bean, Object value)
  {
    Object compoundValue = ImmutableCompoundTypeBuilder.set(compoundType, property.getName(), value);
    
    if ((compoundValue != null) && (parent != null))
    {
      return parent.setValue(bean, compoundValue);
    }
    
    return compoundValue;
  }
}
