package com.avaje.ebeaninternal.server.type;

import com.avaje.ebean.config.CompoundTypeProperty;
import com.avaje.ebeaninternal.server.query.SplitName;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map.Entry;
import java.util.Set;


























public final class CtCompoundTypeScalarList
{
  private final LinkedHashMap<String, ScalarType<?>> scalarProps = new LinkedHashMap();
  
  private final LinkedHashMap<String, CtCompoundProperty> compoundProperties = new LinkedHashMap();
  



  public List<CtCompoundProperty> getNonScalarProperties()
  {
    List<CtCompoundProperty> nonScalarProps = new ArrayList();
    
    for (String propKey : compoundProperties.keySet()) {
      if (!scalarProps.containsKey(propKey)) {
        nonScalarProps.add(compoundProperties.get(propKey));
      }
    }
    
    return nonScalarProps;
  }
  



  public void addCompoundProperty(String propName, CtCompoundType<?> t, CompoundTypeProperty<?, ?> prop)
  {
    CtCompoundProperty parent = null;
    String[] split = SplitName.split(propName);
    if (split[0] != null) {
      parent = (CtCompoundProperty)compoundProperties.get(split[0]);
    }
    
    CtCompoundProperty p = new CtCompoundProperty(propName, parent, t, prop);
    compoundProperties.put(propName, p);
  }
  


  public void addScalarType(String propName, ScalarType<?> scalar)
  {
    scalarProps.put(propName, scalar);
  }
  
  public CtCompoundProperty getCompoundType(String propName) {
    return (CtCompoundProperty)compoundProperties.get(propName);
  }
  
  public Set<Map.Entry<String, ScalarType<?>>> entries() {
    return scalarProps.entrySet();
  }
}
