package com.avaje.ebeaninternal.server.type;






















public class EscapeJson
{
  public static String escapeQuote(String value)
  {
    StringBuilder sb = new StringBuilder(value.length() + 2);
    sb.append("\"");
    escape(value, sb);
    sb.append("\"");
    return sb.toString();
  }
  



  public static String escape(String s)
  {
    if (s == null) {
      return null;
    }
    StringBuilder sb = new StringBuilder();
    escape(s, sb);
    return sb.toString();
  }
  




  public static void escape(String s, StringBuilder sb)
  {
    for (int i = 0; i < s.length(); i++) {
      char ch = s.charAt(i);
      switch (ch) {
      case '"': 
        sb.append("\\\"");
        break;
      case '\\': 
        sb.append("\\\\");
        break;
      case '\b': 
        sb.append("\\b");
        break;
      case '\f': 
        sb.append("\\f");
        break;
      case '\n': 
        sb.append("\\n");
        break;
      case '\r': 
        sb.append("\\r");
        break;
      case '\t': 
        sb.append("\\t");
        break;
      case '/': 
        sb.append("\\/");
        break;
      default: 
        if (((ch >= 0) && (ch <= '\037')) || ((ch >= '') && (ch <= '')) || ((ch >= ' ') && (ch <= '⃿')))
        {

          String hs = Integer.toHexString(ch);
          sb.append("\\u");
          for (int j = 0; j < 4 - hs.length(); j++) {
            sb.append('0');
          }
          sb.append(hs.toUpperCase());
        } else {
          sb.append(ch);
        }
        break;
      }
    }
  }
}
