package com.avaje.ebeaninternal.server.type;

import com.avaje.ebeaninternal.server.query.LuceneIndexDataReader;
import java.sql.SQLException;
import java.util.Iterator;


























public class ScalarTypeEnumWithMapping
  extends ScalarTypeEnumStandard.EnumBase
  implements ScalarType, ScalarTypeEnum
{
  private final EnumToDbValueMap beanDbMap;
  private final int length;
  
  public ScalarTypeEnumWithMapping(EnumToDbValueMap<?> beanDbMap, Class<?> enumType, int length)
  {
    super(enumType, false, beanDbMap.getDbType());
    this.beanDbMap = beanDbMap;
    this.length = length;
  }
  




  public String getContraintInValues()
  {
    StringBuilder sb = new StringBuilder();
    
    int i = 0;
    
    sb.append("(");
    
    Iterator<?> it = beanDbMap.dbValues();
    while (it.hasNext()) {
      Object dbValue = it.next();
      if (i++ > 0) {
        sb.append(",");
      }
      if (!beanDbMap.isIntegerType()) {
        sb.append("'");
      }
      sb.append(dbValue.toString());
      if (!beanDbMap.isIntegerType()) {
        sb.append("'");
      }
    }
    
    sb.append(")");
    
    return sb.toString();
  }
  





  public int getLength()
  {
    return length;
  }
  
  public void bind(DataBind b, Object value) throws SQLException {
    beanDbMap.bind(b, value);
  }
  
  public Object read(DataReader dataReader) throws SQLException {
    if ((dataReader instanceof LuceneIndexDataReader))
    {

      String s = dataReader.getString();
      return s == null ? null : parse(s);
    }
    return beanDbMap.read(dataReader);
  }
  
  public Object toBeanType(Object dbValue)
  {
    return beanDbMap.getBeanValue(dbValue);
  }
  
  public Object toJdbcType(Object beanValue) {
    return beanDbMap.getDbValue(beanValue);
  }
}
