package com.avaje.ebeaninternal.server.util;

import java.util.ArrayList;
import java.util.EmptyStackException;



























public class ArrayStack<E>
{
  private final ArrayList<E> list;
  
  public ArrayStack(int size)
  {
    list = new ArrayList(size);
  }
  


  public ArrayStack()
  {
    list = new ArrayList();
  }
  


  public E push(E item)
  {
    list.add(item);
    return item;
  }
  



  public E pop()
  {
    int len = list.size();
    E obj = peek();
    list.remove(len - 1);
    return obj;
  }
  
  protected E peekZero(boolean retNull) {
    int len = list.size();
    if (len == 0) {
      if (retNull) {
        return null;
      }
      throw new EmptyStackException();
    }
    return list.get(len - 1);
  }
  


  public E peek()
  {
    return peekZero(false);
  }
  



  public E peekWithNull()
  {
    return peekZero(true);
  }
  


  public boolean isEmpty()
  {
    return list.isEmpty();
  }
  
  public int size() {
    return list.size();
  }
}
