package com.avaje.ebeaninternal.util;

import com.avaje.ebeaninternal.api.SpiLuceneExpr;
import com.avaje.ebeaninternal.api.SpiLuceneExpr.ExprOccur;
import java.util.ArrayList;
import org.apache.lucene.search.BooleanClause.Occur;
import org.apache.lucene.search.BooleanQuery;
import org.apache.lucene.search.Query;






















public class LuceneQueryList
  implements SpiLuceneExpr
{
  private final SpiLuceneExpr.ExprOccur localOccur;
  private final ArrayList<SpiLuceneExpr> list = new ArrayList();
  private String description;
  
  public LuceneQueryList(SpiLuceneExpr.ExprOccur loccur)
  {
    localOccur = loccur;
  }
  
  public void add(SpiLuceneExpr q) {
    list.add(q);
  }
  
  public ArrayList<SpiLuceneExpr> getList() {
    return list;
  }
  
  public String getDescription() {
    return description;
  }
  
  public Query mergeLuceneQuery()
  {
    BooleanClause.Occur luceneOccur = getLuceneOccur();
    
    StringBuilder sb = new StringBuilder();
    
    BooleanQuery bq = new BooleanQuery();
    for (int i = 0; i < list.size(); i++) {
      SpiLuceneExpr luceneExpr = (SpiLuceneExpr)list.get(i);
      Query lucQuery = luceneExpr.mergeLuceneQuery();
      bq.add(lucQuery, luceneOccur);
      
      if (i > 0) {
        sb.append(" ").append(luceneOccur).append(" ");
      }
      sb.append(luceneExpr.getDescription());
    }
    
    description = sb.toString();
    return bq;
  }
  
  private BooleanClause.Occur getLuceneOccur() {
    switch (1.$SwitchMap$com$avaje$ebeaninternal$api$SpiLuceneExpr$ExprOccur[localOccur.ordinal()]) {
    case 1: 
      return BooleanClause.Occur.MUST;
    case 2: 
      return BooleanClause.Occur.MUST_NOT;
    case 3: 
      return BooleanClause.Occur.SHOULD;
    }
    
    throw new RuntimeException("Invalid type " + localOccur);
  }
}
