package com.avaje.ebeaninternal.util;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;














public class SortByClause
{
  public static final String NULLSHIGH = "nullshigh";
  public static final String NULLSLOW = "nullslow";
  public static final String ASC = "asc";
  public static final String DESC = "desc";
  private List<Property> properties;
  
  public SortByClause()
  {
    properties = new ArrayList();
  }
  

  public int size()
  {
    return properties.size();
  }
  


  public List<Property> getProperties()
  {
    return properties;
  }
  


  public void add(Property p)
  {
    properties.add(p);
  }
  

  public static class Property
    implements Serializable
  {
    private static final long serialVersionUID = 7588760362420690963L;
    
    private final String name;
    
    private final boolean ascending;
    
    private final Boolean nullsHigh;
    
    public Property(String name, boolean ascending, Boolean nullsHigh)
    {
      this.name = name;
      this.ascending = ascending;
      this.nullsHigh = nullsHigh;
    }
    
    public String toString() {
      return name + " asc:" + ascending;
    }
    


    public String getName()
    {
      return name;
    }
    


    public boolean isAscending()
    {
      return ascending;
    }
    
    public Boolean getNullsHigh() {
      return nullsHigh;
    }
  }
}
