package com.google.common.cache;

import com.google.common.annotations.Beta;
import java.util.concurrent.Executor;


































@Beta
public final class RemovalListeners
{
  public static <K, V> RemovalListener<K, V> asynchronous(final RemovalListener<K, V> listener, Executor executor)
  {
    new RemovalListener()
    {
      public void onRemoval(final RemovalNotification<K, V> notification) {
        val$executor.execute(new Runnable()
        {
          public void run() {
            val$listener.onRemoval(notification);
          }
        });
      }
    };
  }
}
