package com.google.common.collect;

import com.google.common.annotations.GwtCompatible;
import com.google.common.base.Preconditions;
import javax.annotation.Nullable;























@GwtCompatible
abstract class BstPath<N extends BstNode<?, N>, P extends BstPath<N, P>>
{
  private final N tip;
  @Nullable
  private final P prefix;
  
  BstPath(N tip, @Nullable P prefix)
  {
    this.tip = ((BstNode)Preconditions.checkNotNull(tip));
    this.prefix = prefix;
  }
  


  public final N getTip()
  {
    return tip;
  }
  


  public final boolean hasPrefix()
  {
    return prefix != null;
  }
  



  @Nullable
  public final P prefixOrNull()
  {
    return prefix;
  }
  




  public final P getPrefix()
  {
    Preconditions.checkState(hasPrefix());
    return prefix;
  }
}
