package com.google.common.util.concurrent;

import com.google.common.annotations.Beta;













































































































@Beta
public abstract interface Service
{
  public abstract ListenableFuture<State> start();
  
  public abstract State startAndWait();
  
  public abstract boolean isRunning();
  
  public abstract State state();
  
  public abstract ListenableFuture<State> stop();
  
  public abstract State stopAndWait();
  
  @Beta
  public static enum State
  {
    NEW, 
    



    STARTING, 
    



    RUNNING, 
    



    STOPPING, 
    




    TERMINATED, 
    




    FAILED;
    
    private State() {}
  }
}
