package com.mysql.jdbc;

import java.sql.SQLException;





































public class CommunicationsException
  extends SQLException
  implements StreamingNotifiable
{
  private String exceptionMessage = null;
  
  private boolean streamingResultSetInPlay = false;
  
  private MySQLConnection conn;
  
  private long lastPacketSentTimeMs;
  
  private long lastPacketReceivedTimeMs;
  private Exception underlyingException;
  
  public CommunicationsException(MySQLConnection conn, long lastPacketSentTimeMs, long lastPacketReceivedTimeMs, Exception underlyingException)
  {
    this.conn = conn;
    this.lastPacketReceivedTimeMs = lastPacketReceivedTimeMs;
    this.lastPacketSentTimeMs = lastPacketSentTimeMs;
    this.underlyingException = underlyingException;
    
    if (underlyingException != null) {
      initCause(underlyingException);
    }
  }
  








  public String getMessage()
  {
    if (exceptionMessage == null) {
      exceptionMessage = SQLError.createLinkFailureMessageBasedOnHeuristics(conn, lastPacketSentTimeMs, lastPacketReceivedTimeMs, underlyingException, streamingResultSetInPlay);
      

      conn = null;
      underlyingException = null;
    }
    return exceptionMessage;
  }
  




  public String getSQLState()
  {
    return "08S01";
  }
  


  public void setWasStreamingResults()
  {
    streamingResultSetInPlay = true;
  }
}
