package com.mysql.jdbc;

































public class EscapeTokenizer
{
  private int bracesLevel = 0;
  
  private boolean emittingEscapeCode = false;
  
  private boolean inComment = false;
  
  private boolean inQuotes = false;
  
  private char lastChar = '\000';
  
  private char lastLastChar = '\000';
  
  private int pos = 0;
  
  private char quoteChar = '\000';
  
  private boolean sawVariableUse = false;
  
  private String source = null;
  
  private int sourceLength = 0;
  








  public EscapeTokenizer(String s)
  {
    source = s;
    sourceLength = s.length();
    pos = 0;
  }
  







  public synchronized boolean hasMoreTokens()
  {
    return pos < sourceLength;
  }
  




  public synchronized String nextToken()
  {
    StringBuffer tokenBuf = new StringBuffer();
    
    if (emittingEscapeCode) {
      tokenBuf.append("{");
      emittingEscapeCode = false;
    }
    for (; 
        pos < sourceLength; pos += 1) {
      char c = source.charAt(pos);
      


      if ((!inQuotes) && (c == '@')) {
        sawVariableUse = true;
      }
      
      if (((c == '\'') || (c == '"')) && (!inComment)) {
        if ((inQuotes) && (c == quoteChar) && 
          (pos + 1 < sourceLength) && 
          (source.charAt(pos + 1) == quoteChar))
        {
          if (lastChar != '\\') {
            tokenBuf.append(quoteChar);
            tokenBuf.append(quoteChar);
            pos += 1;
            continue;
          }
        }
        

        if (lastChar != '\\') {
          if (inQuotes) {
            if (quoteChar == c) {
              inQuotes = false;
            }
          } else {
            inQuotes = true;
            quoteChar = c;
          }
        } else if (lastLastChar == '\\') {
          if (inQuotes) {
            if (quoteChar == c) {
              inQuotes = false;
            }
          } else {
            inQuotes = true;
            quoteChar = c;
          }
        }
        
        tokenBuf.append(c);
      } else if (c == '-') {
        if ((lastChar == '-') && (lastLastChar != '\\') && (!inQuotes))
        {
          inComment = true;
        }
        
        tokenBuf.append(c);
      } else if ((c == '\n') || (c == '\r')) {
        inComment = false;
        
        tokenBuf.append(c);
      } else if (c == '{') {
        if ((inQuotes) || (inComment)) {
          tokenBuf.append(c);
        } else {
          bracesLevel += 1;
          
          if (bracesLevel == 1) {
            pos += 1;
            emittingEscapeCode = true;
            
            return tokenBuf.toString();
          }
          
          tokenBuf.append(c);
        }
      } else if (c == '}') {
        tokenBuf.append(c);
        
        if ((!inQuotes) && (!inComment)) {
          lastChar = c;
          
          bracesLevel -= 1;
          
          if (bracesLevel == 0) {
            pos += 1;
            
            return tokenBuf.toString();
          }
        }
      } else {
        tokenBuf.append(c);
      }
      
      lastLastChar = lastChar;
      lastChar = c;
    }
    
    return tokenBuf.toString();
  }
  
  boolean sawVariableUse() {
    return sawVariableUse;
  }
}
