package com.mysql.jdbc;

import java.sql.SQLException;
import java.util.List;























































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































class VersionedStringProperty
{
  int majorVersion;
  int minorVersion;
  int subminorVersion;
  boolean preferredValue = false;
  String propertyInfo;
  
  VersionedStringProperty(String property)
  {
    property = property.trim();
    
    if (property.startsWith("*")) {
      property = property.substring(1);
      preferredValue = true;
    }
    
    if (property.startsWith(">")) {
      property = property.substring(1);
      
      int charPos = 0;
      
      for (charPos = 0; charPos < property.length(); charPos++) {
        char c = property.charAt(charPos);
        
        if ((!Character.isWhitespace(c)) && (!Character.isDigit(c)) && (c != '.')) {
          break;
        }
      }
      

      String versionInfo = property.substring(0, charPos);
      List versionParts = StringUtils.split(versionInfo, ".", true);
      
      majorVersion = Integer.parseInt(versionParts.get(0).toString());
      
      if (versionParts.size() > 1) {
        minorVersion = Integer.parseInt(versionParts.get(1).toString());
      } else {
        minorVersion = 0;
      }
      
      if (versionParts.size() > 2) {
        subminorVersion = Integer.parseInt(versionParts.get(2).toString());
      }
      else {
        subminorVersion = 0;
      }
      
      propertyInfo = property.substring(charPos);
    } else {
      majorVersion = (this.minorVersion = this.subminorVersion = 0);
      propertyInfo = property;
    }
  }
  
  VersionedStringProperty(String property, int major, int minor, int subminor) {
    propertyInfo = property;
    majorVersion = major;
    minorVersion = minor;
    subminorVersion = subminor;
  }
  
  boolean isOkayForVersion(Connection conn) throws SQLException {
    return conn.versionMeetsMinimum(majorVersion, minorVersion, subminorVersion);
  }
  

  public String toString()
  {
    return propertyInfo;
  }
}
