package com.mysql.jdbc.jdbc2.optional;

import com.mysql.jdbc.ConnectionImpl;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;
import javax.sql.StatementEvent;
import javax.sql.StatementEventListener;


























public class JDBC4MysqlXAConnection
  extends MysqlXAConnection
{
  private Map<StatementEventListener, StatementEventListener> statementEventListeners;
  
  public JDBC4MysqlXAConnection(ConnectionImpl connection, boolean logXaCommands)
    throws SQLException
  {
    super(connection, logXaCommands);
    
    statementEventListeners = new HashMap();
  }
  
  public synchronized void close() throws SQLException {
    super.close();
    
    if (statementEventListeners != null) {
      statementEventListeners.clear();
      
      statementEventListeners = null;
    }
  }
  











  public void addStatementEventListener(StatementEventListener listener)
  {
    synchronized (statementEventListeners) {
      statementEventListeners.put(listener, listener);
    }
  }
  










  public void removeStatementEventListener(StatementEventListener listener)
  {
    synchronized (statementEventListeners) {
      statementEventListeners.remove(listener);
    }
  }
  
  void fireStatementEvent(StatementEvent event) throws SQLException {
    synchronized (statementEventListeners) {
      for (StatementEventListener listener : statementEventListeners.keySet()) {
        listener.statementClosed(event);
      }
    }
  }
}
