package javax.annotation;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.util.regex.Pattern;
import javax.annotation.meta.TypeQualifier;
import javax.annotation.meta.When;

@Documented
@TypeQualifier(applicableTo=String.class)
@Retention(java.lang.annotation.RetentionPolicy.RUNTIME)
public @interface MatchesPattern
{
  @RegEx
  String value();
  
  int flags() default 0;
  
  public static class Checker implements javax.annotation.meta.TypeQualifierValidator<MatchesPattern>
  {
    public When forConstantValue(MatchesPattern annotation, Object value)
    {
      Pattern p = Pattern.compile(annotation.value(), annotation.flags());
      if (p.matcher((String)value).matches())
        return When.ALWAYS;
      return When.NEVER;
    }
  }
}
