package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.List;

public class AABBPool
{
  private final int a;
  private final int b;
  private final List pool = new ArrayList();
  private int d;
  private int largestSize;
  private int resizeTime;
  
  public AABBPool(int i, int j) {
    a = i;
    b = j;
  }
  
  public AxisAlignedBB a(double d0, double d1, double d2, double d3, double d4, double d5)
  {
    if (resizeTime == 0) { return new AxisAlignedBB(d0, d1, d2, d3, d4, d5);
    }
    AxisAlignedBB axisalignedbb;
    if (d >= pool.size()) {
      AxisAlignedBB axisalignedbb = new AxisAlignedBB(d0, d1, d2, d3, d4, d5);
      pool.add(axisalignedbb);
    } else {
      axisalignedbb = (AxisAlignedBB)pool.get(d);
      axisalignedbb.b(d0, d1, d2, d3, d4, d5);
    }
    
    d += 1;
    return axisalignedbb;
  }
  
  public void a() {
    if (d > largestSize) {
      largestSize = d;
    }
    

    if ((resizeTime++ & 0xFF) == 0) {
      int newSize = pool.size() - (pool.size() >> 3);
      
      if (newSize > largestSize)
      {
        for (int i = pool.size() - 1; i > newSize; i--) {
          pool.remove(i);
        }
      }
      
      largestSize = 0;
    }
    


    d = 0;
  }
  
  public int c() {
    return pool.size();
  }
  
  public int d() {
    return d;
  }
}
