package net.minecraft.server.v1_7_R1;

import java.util.Random;

public class BlockDispenser extends BlockContainer
{
  public static final IRegistry a = new RegistryDefault(new DispenseBehaviorItem());
  protected Random b = new Random();
  public static boolean eventFired = false;
  
  protected BlockDispenser() {
    super(Material.STONE);
    a(CreativeModeTab.d);
  }
  
  public int a(World world) {
    return 4;
  }
  
  public void onPlace(World world, int i, int j, int k) {
    super.onPlace(world, i, j, k);
    m(world, i, j, k);
  }
  
  private void m(World world, int i, int j, int k) {
    if (!isStatic) {
      Block block = world.getType(i, j, k - 1);
      Block block1 = world.getType(i, j, k + 1);
      Block block2 = world.getType(i - 1, j, k);
      Block block3 = world.getType(i + 1, j, k);
      byte b0 = 3;
      
      if ((block.j()) && (!block1.j())) {
        b0 = 3;
      }
      
      if ((block1.j()) && (!block.j())) {
        b0 = 2;
      }
      
      if ((block2.j()) && (!block3.j())) {
        b0 = 5;
      }
      
      if ((block3.j()) && (!block2.j())) {
        b0 = 4;
      }
      
      world.setData(i, j, k, b0, 2);
    }
  }
  
  public boolean interact(World world, int i, int j, int k, EntityHuman entityhuman, int l, float f, float f1, float f2) {
    if (isStatic) {
      return true;
    }
    TileEntityDispenser tileentitydispenser = (TileEntityDispenser)world.getTileEntity(i, j, k);
    
    if (tileentitydispenser != null) {
      entityhuman.openDispenser(tileentitydispenser);
    }
    
    return true;
  }
  

  public void dispense(World world, int i, int j, int k)
  {
    SourceBlock sourceblock = new SourceBlock(world, i, j, k);
    TileEntityDispenser tileentitydispenser = (TileEntityDispenser)sourceblock.getTileEntity();
    
    if (tileentitydispenser != null) {
      int l = tileentitydispenser.i();
      
      if (l < 0) {
        world.triggerEffect(1001, i, j, k, 0);
      } else {
        ItemStack itemstack = tileentitydispenser.getItem(l);
        IDispenseBehavior idispensebehavior = a(itemstack);
        
        if (idispensebehavior != IDispenseBehavior.a) {
          ItemStack itemstack1 = idispensebehavior.a(sourceblock, itemstack);
          eventFired = false;
          
          tileentitydispenser.setItem(l, count == 0 ? null : itemstack1);
        }
      }
    }
  }
  
  protected IDispenseBehavior a(ItemStack itemstack) {
    return (IDispenseBehavior)a.a(itemstack.getItem());
  }
  
  public void doPhysics(World world, int i, int j, int k, Block block) {
    boolean flag = (world.isBlockIndirectlyPowered(i, j, k)) || (world.isBlockIndirectlyPowered(i, j + 1, k));
    int l = world.getData(i, j, k);
    boolean flag1 = (l & 0x8) != 0;
    
    if ((flag) && (!flag1)) {
      world.a(i, j, k, this, a(world));
      world.setData(i, j, k, l | 0x8, 4);
    } else if ((!flag) && (flag1)) {
      world.setData(i, j, k, l & 0xFFFFFFF7, 4);
    }
  }
  
  public void a(World world, int i, int j, int k, Random random) {
    if (!isStatic) {
      dispense(world, i, j, k);
    }
  }
  
  public TileEntity a(World world, int i) {
    return new TileEntityDispenser();
  }
  
  public void postPlace(World world, int i, int j, int k, EntityLiving entityliving, ItemStack itemstack) {
    int l = BlockPiston.a(world, i, j, k, entityliving);
    
    world.setData(i, j, k, l, 2);
    if (itemstack.hasName()) {
      ((TileEntityDispenser)world.getTileEntity(i, j, k)).a(itemstack.getName());
    }
  }
  
  public void remove(World world, int i, int j, int k, Block block, int l) {
    TileEntityDispenser tileentitydispenser = (TileEntityDispenser)world.getTileEntity(i, j, k);
    
    if (tileentitydispenser != null) {
      for (int i1 = 0; i1 < tileentitydispenser.getSize(); i1++) {
        ItemStack itemstack = tileentitydispenser.getItem(i1);
        
        if (itemstack != null) {
          float f = b.nextFloat() * 0.8F + 0.1F;
          float f1 = b.nextFloat() * 0.8F + 0.1F;
          float f2 = b.nextFloat() * 0.8F + 0.1F;
          
          while (count > 0) {
            int j1 = b.nextInt(21) + 10;
            
            if (j1 > count) {
              j1 = count;
            }
            
            count -= j1;
            EntityItem entityitem = new EntityItem(world, i + f, j + f1, k + f2, new ItemStack(itemstack.getItem(), j1, itemstack.getData()));
            
            if (itemstack.hasTag()) {
              entityitem.getItemStack().setTag((NBTTagCompound)itemstack.getTag().clone());
            }
            
            float f3 = 0.05F;
            
            motX = ((float)b.nextGaussian() * f3);
            motY = ((float)b.nextGaussian() * f3 + 0.2F);
            motZ = ((float)b.nextGaussian() * f3);
            world.addEntity(entityitem);
          }
        }
      }
      
      world.f(i, j, k, block);
    }
    
    super.remove(world, i, j, k, block, l);
  }
  
  public static IPosition a(ISourceBlock isourceblock) {
    EnumFacing enumfacing = b(isourceblock.h());
    double d0 = isourceblock.getX() + 0.7D * enumfacing.c();
    double d1 = isourceblock.getY() + 0.7D * enumfacing.d();
    double d2 = isourceblock.getZ() + 0.7D * enumfacing.e();
    
    return new Position(d0, d1, d2);
  }
  
  public static EnumFacing b(int i) {
    return EnumFacing.a(i & 0x7);
  }
  
  public boolean M() {
    return true;
  }
  
  public int g(World world, int i, int j, int k, int l) {
    return Container.b((IInventory)world.getTileEntity(i, j, k));
  }
}
