package net.minecraft.server.v1_7_R1;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.event.block.BlockRedstoneEvent;
import org.bukkit.plugin.PluginManager;

public class BlockRedstoneTorch extends BlockTorch
{
  private boolean isOn;
  private static Map b = new HashMap();
  
  private boolean a(World world, int i, int j, int k, boolean flag) {
    if (!b.containsKey(world)) {
      b.put(world, new java.util.ArrayList());
    }
    
    List list = (List)b.get(world);
    
    if (flag) {
      list.add(new RedstoneUpdateInfo(i, j, k, world.getTime()));
    }
    
    int l = 0;
    
    for (int i1 = 0; i1 < list.size(); i1++) {
      RedstoneUpdateInfo redstoneupdateinfo = (RedstoneUpdateInfo)list.get(i1);
      
      if ((a == i) && (b == j) && (c == k)) {
        l++;
        if (l >= 8) {
          return true;
        }
      }
    }
    
    return false;
  }
  
  protected BlockRedstoneTorch(boolean flag) {
    isOn = flag;
    a(true);
    a((CreativeModeTab)null);
  }
  
  public int a(World world) {
    return 2;
  }
  
  public void onPlace(World world, int i, int j, int k) {
    if (world.getData(i, j, k) == 0) {
      super.onPlace(world, i, j, k);
    }
    
    if (isOn) {
      world.applyPhysics(i, j - 1, k, this);
      world.applyPhysics(i, j + 1, k, this);
      world.applyPhysics(i - 1, j, k, this);
      world.applyPhysics(i + 1, j, k, this);
      world.applyPhysics(i, j, k - 1, this);
      world.applyPhysics(i, j, k + 1, this);
    }
  }
  
  public void remove(World world, int i, int j, int k, Block block, int l) {
    if (isOn) {
      world.applyPhysics(i, j - 1, k, this);
      world.applyPhysics(i, j + 1, k, this);
      world.applyPhysics(i - 1, j, k, this);
      world.applyPhysics(i + 1, j, k, this);
      world.applyPhysics(i, j, k - 1, this);
      world.applyPhysics(i, j, k + 1, this);
    }
  }
  
  public int b(IBlockAccess iblockaccess, int i, int j, int k, int l) {
    if (!isOn) {
      return 0;
    }
    int i1 = iblockaccess.getData(i, j, k);
    
    return (i1 == 2) && (l == 4) ? 0 : (i1 == 1) && (l == 5) ? 0 : (i1 == 4) && (l == 2) ? 0 : (i1 == 3) && (l == 3) ? 0 : (i1 == 5) && (l == 1) ? 0 : 15;
  }
  
  private boolean m(World world, int i, int j, int k)
  {
    int l = world.getData(i, j, k);
    
    return (l == 5) && (world.isBlockFacePowered(i, j - 1, k, 0));
  }
  
  public void a(World world, int i, int j, int k, Random random) {
    boolean flag = m(world, i, j, k);
    List list = (List)b.get(world);
    
    while ((list != null) && (!list.isEmpty()) && (world.getTime() - get0d > 60L)) {
      list.remove(0);
    }
    

    PluginManager manager = world.getServer().getPluginManager();
    org.bukkit.block.Block block = world.getWorld().getBlockAt(i, j, k);
    int oldCurrent = isOn ? 15 : 0;
    
    BlockRedstoneEvent event = new BlockRedstoneEvent(block, oldCurrent, oldCurrent);
    

    if (isOn) {
      if (flag)
      {
        if (oldCurrent != 0) {
          event.setNewCurrent(0);
          manager.callEvent(event);
          if (event.getNewCurrent() != 0) {
            return;
          }
        }
        

        world.setTypeAndData(i, j, k, Blocks.REDSTONE_TORCH_OFF, world.getData(i, j, k), 3);
        if (a(world, i, j, k, true)) {
          world.makeSound(i + 0.5F, j + 0.5F, k + 0.5F, "random.fizz", 0.5F, 2.6F + (random.nextFloat() - random.nextFloat()) * 0.8F);
          
          for (int l = 0; l < 5; l++) {
            double d0 = i + random.nextDouble() * 0.6D + 0.2D;
            double d1 = j + random.nextDouble() * 0.6D + 0.2D;
            double d2 = k + random.nextDouble() * 0.6D + 0.2D;
            
            world.addParticle("smoke", d0, d1, d2, 0.0D, 0.0D, 0.0D);
          }
        }
      }
    } else if ((!flag) && (!a(world, i, j, k, false)))
    {
      if (oldCurrent != 15) {
        event.setNewCurrent(15);
        manager.callEvent(event);
        if (event.getNewCurrent() != 15) {
          return;
        }
      }
      

      world.setTypeAndData(i, j, k, Blocks.REDSTONE_TORCH_ON, world.getData(i, j, k), 3);
    }
  }
  
  public void doPhysics(World world, int i, int j, int k, Block block) {
    if (!b(world, i, j, k, block)) {
      boolean flag = m(world, i, j, k);
      
      if (((isOn) && (flag)) || ((!isOn) && (!flag))) {
        world.a(i, j, k, this, a(world));
      }
    }
  }
  
  public int c(IBlockAccess iblockaccess, int i, int j, int k, int l) {
    return l == 0 ? b(iblockaccess, i, j, k, l) : 0;
  }
  
  public Item getDropType(int i, Random random, int j) {
    return Item.getItemOf(Blocks.REDSTONE_TORCH_ON);
  }
  
  public boolean isPowerSource() {
    return true;
  }
  
  public boolean c(Block block) {
    return (block == Blocks.REDSTONE_TORCH_OFF) || (block == Blocks.REDSTONE_TORCH_ON);
  }
}
