package net.minecraft.server.v1_7_R1;

import java.io.PrintStream;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;
import org.apache.logging.log4j.LogManager;
import org.bukkit.Bukkit;
import org.bukkit.craftbukkit.v1_7_R1.CraftChunk;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_7_R1.util.UnsafeList;

public class Chunk
{
  private static final org.apache.logging.log4j.Logger t = ;
  
  public static boolean a;
  
  private ChunkSection[] sections;
  
  private byte[] v;
  
  public int[] b;
  
  public boolean[] c;
  
  public boolean d;
  
  public World world;
  
  public int[] heightMap;
  
  public final int locX;
  
  public final int locZ;
  private boolean w;
  public Map tileEntities;
  
  public Chunk(World world, int i, int j)
  {
    sections = new ChunkSection[16];
    v = new byte[256];
    b = new int[256];
    c = new boolean[256];
    tileEntities = new HashMap();
    x = 4096;
    entitySlices = new List[16];
    this.world = world;
    locX = i;
    locZ = j;
    heightMap = new int[256];
    
    for (int k = 0; k < entitySlices.length; k++) {
      entitySlices[k] = new UnsafeList();
    }
    
    Arrays.fill(b, -999);
    Arrays.fill(v, (byte)-1);
    

    if (!(this instanceof EmptyChunk))
      bukkitChunk = new CraftChunk(this); }
  
  public List[] entitySlices;
  public boolean done;
  public boolean lit;
  public boolean m;
  public boolean n;
  public boolean o;
  
  public Chunk(World world, Block[] ablock, int i, int j) { this(world, i, j);
    int k = ablock.length / 256;
    boolean flag = !worldProvider.g;
    
    for (int l = 0; l < 16; l++) {
      for (int i1 = 0; i1 < 16; i1++) {
        for (int j1 = 0; j1 < k; j1++) {
          Block block = ablock[(l << 11 | i1 << 7 | j1)];
          
          if ((block != null) && (block.getMaterial() != Material.AIR)) {
            int k1 = j1 >> 4;
            
            if (sections[k1] == null) {
              sections[k1] = new ChunkSection(k1 << 4, flag);
            }
            
            sections[k1].setTypeId(l, j1 & 0xF, i1, block);
          }
        }
      }
    }
  }
  
  public Chunk(World world, Block[] ablock, byte[] abyte, int i, int j) {
    this(world, i, j);
    int k = ablock.length / 256;
    boolean flag = !worldProvider.g;
    
    for (int l = 0; l < 16; l++) {
      for (int i1 = 0; i1 < 16; i1++) {
        for (int j1 = 0; j1 < k; j1++) {
          int k1 = l * k * 16 | i1 * k | j1;
          Block block = ablock[k1];
          
          if ((block != null) && (block != Blocks.AIR)) {
            int l1 = j1 >> 4;
            
            if (sections[l1] == null) {
              sections[l1] = new ChunkSection(l1 << 4, flag);
            }
            
            sections[l1].setTypeId(l, j1 & 0xF, i1, block);
            sections[l1].setData(l, j1 & 0xF, i1, abyte[k1]);
          }
        }
      }
    }
  }
  
  public boolean a(int i, int j) {
    return (i == locX) && (j == locZ);
  }
  
  public int b(int i, int j) {
    return heightMap[(j << 4 | i)];
  }
  
  public int h() {
    for (int i = sections.length - 1; i >= 0; i--) {
      if (sections[i] != null) {
        return sections[i].getYPosition();
      }
    }
    
    return 0;
  }
  
  public ChunkSection[] i() {
    return sections;
  }
  
  public void initLighting() {
    int i = h();
    
    r = 2147483647;
    
    for (int j = 0; j < 16; j++) {
      int k = 0;
      
      while (k < 16) {
        b[(j + (k << 4))] = -999;
        int l = i + 16 - 1;
        

        while (l > 0) {
          if (b(j, l - 1, k) == 0) {
            l--;
          }
          else
          {
            heightMap[(k << 4 | j)] = l;
            if (l < r) {
              r = l;
            }
          }
        }
        if (!world.worldProvider.g) {
          l = 15;
          int i1 = i + 16 - 1;
          do
          {
            int j1 = b(j, i1, k);
            
            if ((j1 == 0) && (l != 15)) {
              j1 = 1;
            }
            
            l -= j1;
            if (l > 0) {
              ChunkSection chunksection = sections[(i1 >> 4)];
              
              if (chunksection != null) {
                chunksection.setSkyLight(j, i1 & 0xF, k, l);
                world.m((locX << 4) + j, i1, (locZ << 4) + k);
              }
            }
            
            i1--;
          } while ((i1 > 0) && (l > 0));
        }
        
        k++;
      }
    }
    


    n = true;
  }
  
  private void e(int i, int j) {
    c[(i + j * 16)] = true;
    w = true;
  }
  
  private void c(boolean flag) {
    world.methodProfiler.a("recheckGaps");
    if (world.areChunksLoaded(locX * 16 + 8, 0, locZ * 16 + 8, 16)) {
      for (int i = 0; i < 16; i++) {
        for (int j = 0; j < 16; j++) {
          if (c[(i + j * 16)] != 0) {
            c[(i + j * 16)] = false;
            int k = b(i, j);
            int l = locX * 16 + i;
            int i1 = locZ * 16 + j;
            int j1 = world.g(l - 1, i1);
            int k1 = world.g(l + 1, i1);
            int l1 = world.g(l, i1 - 1);
            int i2 = world.g(l, i1 + 1);
            
            if (k1 < j1) {
              j1 = k1;
            }
            
            if (l1 < j1) {
              j1 = l1;
            }
            
            if (i2 < j1) {
              j1 = i2;
            }
            
            g(l, i1, j1);
            g(l - 1, i1, k);
            g(l + 1, i1, k);
            g(l, i1 - 1, k);
            g(l, i1 + 1, k);
            if (flag) {
              world.methodProfiler.b();
              return;
            }
          }
        }
      }
      
      w = false;
    }
    
    world.methodProfiler.b();
  }
  
  private void g(int i, int j, int k) {
    int l = world.getHighestBlockYAt(i, j);
    
    if (l > k) {
      c(i, j, k, l + 1);
    } else if (l < k) {
      c(i, j, l, k + 1);
    }
  }
  
  private void c(int i, int j, int k, int l) {
    if ((l > k) && (world.areChunksLoaded(i, 0, j, 16))) {
      for (int i1 = k; i1 < l; i1++) {
        world.c(EnumSkyBlock.SKY, i, i1, j);
      }
      
      n = true;
    }
  }
  
  private void h(int i, int j, int k) {
    int l = heightMap[(k << 4 | i)] & 0xFF;
    int i1 = l;
    
    if (j > l) {
      i1 = j;
    }
    
    while ((i1 > 0) && (b(i, i1 - 1, k) == 0)) {
      i1--;
    }
    
    if (i1 != l) {
      world.b(i + locX * 16, k + locZ * 16, i1, l);
      heightMap[(k << 4 | i)] = i1;
      int j1 = locX * 16 + i;
      int k1 = locZ * 16 + k;
      


      if (!world.worldProvider.g)
      {

        if (i1 < l) {
          for (int l1 = i1; l1 < l; l1++) {
            ChunkSection chunksection = sections[(l1 >> 4)];
            if (chunksection != null) {
              chunksection.setSkyLight(i, l1 & 0xF, k, 15);
              world.m((locX << 4) + i, l1, (locZ << 4) + k);
            }
          }
        }
        for (int l1 = l; l1 < i1; l1++) {
          ChunkSection chunksection = sections[(l1 >> 4)];
          if (chunksection != null) {
            chunksection.setSkyLight(i, l1 & 0xF, k, 0);
            world.m((locX << 4) + i, l1, (locZ << 4) + k);
          }
        }
        

        l1 = 15;
        
        while ((i1 > 0) && (l1 > 0)) {
          i1--;
          int i2 = b(i, i1, k);
          if (i2 == 0) {
            i2 = 1;
          }
          
          l1 -= i2;
          if (l1 < 0) {
            l1 = 0;
          }
          
          ChunkSection chunksection1 = sections[(i1 >> 4)];
          
          if (chunksection1 != null) {
            chunksection1.setSkyLight(i, i1 & 0xF, k, l1);
          }
        }
      }
      
      int l1 = heightMap[(k << 4 | i)];
      int i2 = l;
      int j2 = l1;
      
      if (l1 < l) {
        i2 = l1;
        j2 = l;
      }
      
      if (l1 < r) {
        r = l1;
      }
      
      if (!world.worldProvider.g) {
        c(j1 - 1, k1, i2, j2);
        c(j1 + 1, k1, i2, j2);
        c(j1, k1 - 1, i2, j2);
        c(j1, k1 + 1, i2, j2);
        c(j1, k1, i2, j2);
      }
      
      n = true;
    }
  }
  
  public int b(int i, int j, int k) {
    return getType(i, j, k).k();
  }
  
  public Block getType(int i, int j, int k) {
    Block block = Blocks.AIR;
    
    if (j >> 4 < sections.length) {
      ChunkSection chunksection = sections[(j >> 4)];
      
      if (chunksection != null) {
        try {
          block = chunksection.getTypeId(i, j & 0xF, k);
        } catch (Throwable throwable) {
          CrashReport crashreport = CrashReport.a(throwable, "Getting block");
          CrashReportSystemDetails crashreportsystemdetails = crashreport.a("Block being got");
          
          crashreportsystemdetails.a("Location", new CrashReportLocation(this, i, j, k));
          throw new ReportedException(crashreport);
        }
      }
    }
    
    return block;
  }
  
  public int getData(int i, int j, int k) {
    if (j >> 4 >= sections.length) {
      return 0;
    }
    ChunkSection chunksection = sections[(j >> 4)];
    
    return chunksection != null ? chunksection.getData(i, j & 0xF, k) : 0;
  }
  
  public boolean a(int i, int j, int k, Block block, int l)
  {
    int i1 = k << 4 | i;
    
    if (j >= b[i1] - 1) {
      b[i1] = -999;
    }
    
    int j1 = heightMap[i1];
    Block block1 = getType(i, j, k);
    int k1 = getData(i, j, k);
    
    if ((block1 == block) && (k1 == l)) {
      return false;
    }
    ChunkSection chunksection = sections[(j >> 4)];
    boolean flag = false;
    
    if (chunksection == null) {
      if (block == Blocks.AIR) {
        return false;
      }
      
      chunksection = sections[(j >> 4)] =  = new ChunkSection(j >> 4 << 4, !world.worldProvider.g);
      flag = j >= j1;
    }
    
    int l1 = locX * 16 + i;
    int i2 = locZ * 16 + k;
    
    if (!world.isStatic) {
      block1.f(world, l1, j, i2, k1);
    }
    

    if (!(block1 instanceof IContainer)) {
      chunksection.setTypeId(i, j & 0xF, k, block);
    }
    

    if (!world.isStatic) {
      block1.remove(world, l1, j, i2, block1, k1);
    } else if (((block1 instanceof IContainer)) && (block1 != block)) {
      world.p(l1, j, i2);
    }
    

    if ((block1 instanceof IContainer)) {
      chunksection.setTypeId(i, j & 0xF, k, block);
    }
    

    if (chunksection.getTypeId(i, j & 0xF, k) != block) {
      return false;
    }
    chunksection.setData(i, j & 0xF, k, l);
    if (flag) {
      initLighting();
    } else {
      int j2 = block.k();
      int k2 = block1.k();
      
      if (j2 > 0) {
        if (j >= j1) {
          h(i, j + 1, k);
        }
      } else if (j == j1 - 1) {
        h(i, j, k);
      }
      
      if ((j2 != k2) && ((j2 < k2) || (getBrightness(EnumSkyBlock.SKY, i, j, k) > 0) || (getBrightness(EnumSkyBlock.BLOCK, i, j, k) > 0))) {
        e(i, k);
      }
    }
    


    if ((block1 instanceof IContainer)) {
      TileEntity tileentity = e(i, j, k);
      if (tileentity != null) {
        tileentity.u();
      }
    }
    

    if ((!world.isStatic) && ((!world.callingPlaceEvent) || ((block instanceof BlockContainer)))) {
      block.onPlace(world, l1, j, i2);
    }
    
    if ((block instanceof IContainer))
    {
      if (getType(i, j, k) != block) {
        return false;
      }
      

      TileEntity tileentity = e(i, j, k);
      if (tileentity == null) {
        tileentity = ((IContainer)block).a(world, l);
        world.setTileEntity(l1, j, i2, tileentity);
      }
      
      if (tileentity != null) {
        tileentity.u();
      }
    }
    
    n = true;
    return true; }
  
  public long p;
  public boolean q;
  public int r;
  
  public boolean a(int i, int j, int k, int l) { ChunkSection chunksection = sections[(j >> 4)];
    
    if (chunksection == null) {
      return false;
    }
    int i1 = chunksection.getData(i, j & 0xF, k);
    
    if (i1 == l) {
      return false;
    }
    n = true;
    chunksection.setData(i, j & 0xF, k, l);
    if ((chunksection.getTypeId(i, j & 0xF, k) instanceof IContainer)) {
      TileEntity tileentity = e(i, j, k);
      
      if (tileentity != null) {
        tileentity.u();
        g = l;
      }
    }
    
    return true; }
  
  public long s;
  private int x;
  public org.bukkit.Chunk bukkitChunk;
  public boolean mustSave;
  public int getBrightness(EnumSkyBlock enumskyblock, int i, int j, int k) { ChunkSection chunksection = sections[(j >> 4)];
    
    return enumskyblock == EnumSkyBlock.BLOCK ? chunksection.getEmittedLight(i, j & 0xF, k) : enumskyblock == EnumSkyBlock.SKY ? chunksection.getSkyLight(i, j & 0xF, k) : world.worldProvider.g ? 0 : chunksection == null ? 0 : d(i, j, k) ? c : c;
  }
  
  public void a(EnumSkyBlock enumskyblock, int i, int j, int k, int l) {
    ChunkSection chunksection = sections[(j >> 4)];
    
    if (chunksection == null) {
      chunksection = sections[(j >> 4)] =  = new ChunkSection(j >> 4 << 4, !world.worldProvider.g);
      initLighting();
    }
    
    n = true;
    if (enumskyblock == EnumSkyBlock.SKY) {
      if (!world.worldProvider.g) {
        chunksection.setSkyLight(i, j & 0xF, k, l);
      }
    } else if (enumskyblock == EnumSkyBlock.BLOCK) {
      chunksection.setEmittedLight(i, j & 0xF, k, l);
    }
  }
  
  public int b(int i, int j, int k, int l) {
    ChunkSection chunksection = sections[(j >> 4)];
    
    if (chunksection == null) {
      return (!world.worldProvider.g) && (l < SKYc) ? SKYc - l : 0;
    }
    int i1 = world.worldProvider.g ? 0 : chunksection.getSkyLight(i, j & 0xF, k);
    
    if (i1 > 0) {
      a = true;
    }
    
    i1 -= l;
    int j1 = chunksection.getEmittedLight(i, j & 0xF, k);
    
    if (j1 > i1) {
      i1 = j1;
    }
    
    return i1;
  }
  
  public void a(Entity entity)
  {
    o = true;
    int i = MathHelper.floor(locX / 16.0D);
    int j = MathHelper.floor(locZ / 16.0D);
    
    if ((i != locX) || (j != locZ))
    {
      Bukkit.getLogger().warning("Wrong location for " + entity + " in world '" + world.getWorld().getName() + "'!");
      

      Bukkit.getLogger().warning("Entity is at " + locX + "," + locZ + " (chunk " + i + "," + j + ") but was stored in chunk " + locX + "," + locZ);
    }
    

    int k = MathHelper.floor(locY / 16.0D);
    
    if (k < 0) {
      k = 0;
    }
    
    if (k >= entitySlices.length) {
      k = entitySlices.length - 1;
    }
    
    ah = true;
    ai = locX;
    aj = k;
    ak = locZ;
    entitySlices[k].add(entity);
  }
  
  public void b(Entity entity) {
    a(entity, aj);
  }
  
  public void a(Entity entity, int i) {
    if (i < 0) {
      i = 0;
    }
    
    if (i >= entitySlices.length) {
      i = entitySlices.length - 1;
    }
    
    entitySlices[i].remove(entity);
  }
  
  public boolean d(int i, int j, int k) {
    return j >= heightMap[(k << 4 | i)];
  }
  
  public TileEntity e(int i, int j, int k) {
    ChunkPosition chunkposition = new ChunkPosition(i, j, k);
    TileEntity tileentity = (TileEntity)tileEntities.get(chunkposition);
    
    if (tileentity == null) {
      Block block = getType(i, j, k);
      
      if (!block.isTileEntity()) {
        return null;
      }
      
      tileentity = ((IContainer)block).a(world, getData(i, j, k));
      world.setTileEntity(locX * 16 + i, j, locZ * 16 + k, tileentity);
    }
    
    if ((tileentity != null) && (tileentity.r())) {
      tileEntities.remove(chunkposition);
      return null;
    }
    return tileentity;
  }
  
  public void a(TileEntity tileentity)
  {
    int i = x - locX * 16;
    int j = y;
    int k = z - locZ * 16;
    
    a(i, j, k, tileentity);
    if (d) {
      world.tileEntityList.add(tileentity);
    }
  }
  
  public void a(int i, int j, int k, TileEntity tileentity) {
    ChunkPosition chunkposition = new ChunkPosition(i, j, k);
    
    tileentity.a(world);
    x = (locX * 16 + i);
    y = j;
    z = (locZ * 16 + k);
    if ((getType(i, j, k) instanceof IContainer)) {
      if (tileEntities.containsKey(chunkposition)) {
        ((TileEntity)tileEntities.get(chunkposition)).s();
      }
      
      tileentity.t();
      tileEntities.put(chunkposition, tileentity);
    }
    else {
      System.out.println("Attempted to place a tile entity (" + tileentity + ") at " + x + "," + y + "," + z + " (" + org.bukkit.Material.getMaterial(Block.b(getType(i, j, k))) + ") where there was no entity tile!");
      
      System.out.println("Chunk coordinates: " + locX * 16 + "," + locZ * 16);
      new Exception().printStackTrace();
    }
  }
  
  public void f(int i, int j, int k)
  {
    ChunkPosition chunkposition = new ChunkPosition(i, j, k);
    
    if (d) {
      TileEntity tileentity = (TileEntity)tileEntities.remove(chunkposition);
      
      if (tileentity != null) {
        tileentity.s();
      }
    }
  }
  
  public void addEntities() {
    d = true;
    world.a(tileEntities.values());
    
    for (int i = 0; i < entitySlices.length; i++) {
      Iterator iterator = entitySlices[i].iterator();
      
      while (iterator.hasNext()) {
        Entity entity = (Entity)iterator.next();
        
        entity.X();
      }
      
      world.a(entitySlices[i]);
    }
  }
  
  public void removeEntities() {
    d = false;
    Iterator iterator = tileEntities.values().iterator();
    
    while (iterator.hasNext()) {
      TileEntity tileentity = (TileEntity)iterator.next();
      
      world.a(tileentity);
    }
    
    for (int i = 0; i < entitySlices.length; i++)
    {
      Iterator<Object> iter = entitySlices[i].iterator();
      while (iter.hasNext()) {
        Entity entity = (Entity)iter.next();
        


        if ((entity instanceof EntityPlayer)) {
          iter.remove();
        }
      }
      

      world.b(entitySlices[i]);
    }
  }
  
  public void e() {
    n = true;
  }
  
  public void a(Entity entity, AxisAlignedBB axisalignedbb, List list, IEntitySelector ientityselector) {
    int i = MathHelper.floor((b - 2.0D) / 16.0D);
    int j = MathHelper.floor((e + 2.0D) / 16.0D);
    
    i = MathHelper.a(i, 0, entitySlices.length - 1);
    j = MathHelper.a(j, 0, entitySlices.length - 1);
    
    for (int k = i; k <= j; k++) {
      List list1 = entitySlices[k];
      
      for (int l = 0; l < list1.size(); l++) {
        Entity entity1 = (Entity)list1.get(l);
        
        if ((entity1 != entity) && (boundingBox.b(axisalignedbb)) && ((ientityselector == null) || (ientityselector.a(entity1)))) {
          list.add(entity1);
          Entity[] aentity = entity1.at();
          
          if (aentity != null) {
            for (int i1 = 0; i1 < aentity.length; i1++) {
              entity1 = aentity[i1];
              if ((entity1 != entity) && (boundingBox.b(axisalignedbb)) && ((ientityselector == null) || (ientityselector.a(entity1)))) {
                list.add(entity1);
              }
            }
          }
        }
      }
    }
  }
  
  public void a(Class oclass, AxisAlignedBB axisalignedbb, List list, IEntitySelector ientityselector) {
    int i = MathHelper.floor((b - 2.0D) / 16.0D);
    int j = MathHelper.floor((e + 2.0D) / 16.0D);
    
    i = MathHelper.a(i, 0, entitySlices.length - 1);
    j = MathHelper.a(j, 0, entitySlices.length - 1);
    
    for (int k = i; k <= j; k++) {
      List list1 = entitySlices[k];
      
      for (int l = 0; l < list1.size(); l++) {
        Entity entity = (Entity)list1.get(l);
        
        if ((oclass.isAssignableFrom(entity.getClass())) && (boundingBox.b(axisalignedbb)) && ((ientityselector == null) || (ientityselector.a(entity)))) {
          list.add(entity);
        }
      }
    }
  }
  
  public boolean a(boolean flag) {
    if (flag) {
      if (((o) && (world.getTime() != p)) || (n)) {
        return true;
      }
    } else if ((o) && (world.getTime() >= p + 600L)) {
      return true;
    }
    
    return n;
  }
  
  public Random a(long i) {
    return new Random(world.getSeed() + locX * locX * 4987142 + locX * 5947611 + locZ * locZ * 4392871L + locZ * 389711 ^ i);
  }
  
  public boolean isEmpty() {
    return false;
  }
  
  public void a(IChunkProvider ichunkprovider, IChunkProvider ichunkprovider1, int i, int j) {
    if ((!done) && (ichunkprovider.isChunkLoaded(i + 1, j + 1)) && (ichunkprovider.isChunkLoaded(i, j + 1)) && (ichunkprovider.isChunkLoaded(i + 1, j))) {
      ichunkprovider.getChunkAt(ichunkprovider1, i, j);
    }
    
    if ((ichunkprovider.isChunkLoaded(i - 1, j)) && (!getOrCreateChunk1, done) && (ichunkprovider.isChunkLoaded(i - 1, j + 1)) && (ichunkprovider.isChunkLoaded(i, j + 1)) && (ichunkprovider.isChunkLoaded(i - 1, j + 1))) {
      ichunkprovider.getChunkAt(ichunkprovider1, i - 1, j);
    }
    
    if ((ichunkprovider.isChunkLoaded(i, j - 1)) && (!getOrCreateChunk, 1done) && (ichunkprovider.isChunkLoaded(i + 1, j - 1)) && (ichunkprovider.isChunkLoaded(i + 1, j - 1)) && (ichunkprovider.isChunkLoaded(i + 1, j))) {
      ichunkprovider.getChunkAt(ichunkprovider1, i, j - 1);
    }
    
    if ((ichunkprovider.isChunkLoaded(i - 1, j - 1)) && (!getOrCreateChunk1, 1done) && (ichunkprovider.isChunkLoaded(i, j - 1)) && (ichunkprovider.isChunkLoaded(i - 1, j))) {
      ichunkprovider.getChunkAt(ichunkprovider1, i - 1, j - 1);
    }
  }
  
  public int d(int i, int j) {
    int k = i | j << 4;
    int l = b[k];
    
    if (l == -999) {
      int i1 = h() + 15;
      
      l = -1;
      
      while ((i1 > 0) && (l == -1)) {
        Block block = getType(i, i1, j);
        Material material = block.getMaterial();
        
        if ((!material.isSolid()) && (!material.isLiquid())) {
          i1--;
        } else {
          l = i1 + 1;
        }
      }
      
      b[k] = l;
    }
    
    return l;
  }
  
  public void b(boolean flag) {
    if ((w) && (!world.worldProvider.g) && (!flag)) {
      c(world.isStatic);
    }
    
    m = true;
    if ((!lit) && (done)) {
      p();
    }
  }
  
  public boolean k() {
    return (m) && (done) && (lit);
  }
  
  public ChunkCoordIntPair l() {
    return new ChunkCoordIntPair(locX, locZ);
  }
  
  public boolean c(int i, int j) {
    if (i < 0) {
      i = 0;
    }
    
    if (j >= 256) {
      j = 255;
    }
    
    for (int k = i; k <= j; k += 16) {
      ChunkSection chunksection = sections[(k >> 4)];
      
      if ((chunksection != null) && (!chunksection.isEmpty())) {
        return false;
      }
    }
    
    return true;
  }
  
  public void a(ChunkSection[] achunksection) {
    sections = achunksection;
  }
  
  public BiomeBase a(int i, int j, WorldChunkManager worldchunkmanager) {
    int k = v[(j << 4 | i)] & 0xFF;
    
    if (k == 255) {
      BiomeBase biomebase = worldchunkmanager.getBiome((locX << 4) + i, (locZ << 4) + j);
      
      k = id;
      v[(j << 4 | i)] = ((byte)(k & 0xFF));
    }
    
    return BiomeBase.getBiome(k) == null ? BiomeBase.PLAINS : BiomeBase.getBiome(k);
  }
  
  public byte[] m() {
    return v;
  }
  
  public void a(byte[] abyte) {
    v = abyte;
  }
  
  public void n() {
    x = 0;
  }
  
  public void o() {
    for (int i = 0; i < 8; i++) {
      if (x >= 4096) {
        return;
      }
      
      int j = x % 16;
      int k = x / 16 % 16;
      int l = x / 256;
      
      x += 1;
      int i1 = (locX << 4) + k;
      int j1 = (locZ << 4) + l;
      
      for (int k1 = 0; k1 < 16; k1++) {
        int l1 = (j << 4) + k1;
        
        if (((sections[j] == null) && ((k1 == 0) || (k1 == 15) || (k == 0) || (k == 15) || (l == 0) || (l == 15))) || ((sections[j] != null) && (sections[j].getTypeId(k, k1, l).getMaterial() == Material.AIR))) {
          if (world.getType(i1, l1 - 1, j1).m() > 0) {
            world.t(i1, l1 - 1, j1);
          }
          
          if (world.getType(i1, l1 + 1, j1).m() > 0) {
            world.t(i1, l1 + 1, j1);
          }
          
          if (world.getType(i1 - 1, l1, j1).m() > 0) {
            world.t(i1 - 1, l1, j1);
          }
          
          if (world.getType(i1 + 1, l1, j1).m() > 0) {
            world.t(i1 + 1, l1, j1);
          }
          
          if (world.getType(i1, l1, j1 - 1).m() > 0) {
            world.t(i1, l1, j1 - 1);
          }
          
          if (world.getType(i1, l1, j1 + 1).m() > 0) {
            world.t(i1, l1, j1 + 1);
          }
          
          world.t(i1, l1, j1);
        }
      }
    }
  }
  
  public void p() {
    done = true;
    lit = true;
    if (!world.worldProvider.g) {
      if (world.b(locX * 16 - 1, 0, locZ * 16 - 1, locX * 16 + 1, 63, locZ * 16 + 1)) {
        for (int i = 0; i < 16; i++) {
          for (int j = 0; j < 16; j++) {
            if (!f(i, j)) {
              lit = false;
              break;
            }
          }
        }
        
        if (lit) {
          Chunk chunk = world.getChunkAtWorldCoords(locX * 16 - 1, locZ * 16);
          
          chunk.a(3);
          chunk = world.getChunkAtWorldCoords(locX * 16 + 16, locZ * 16);
          chunk.a(1);
          chunk = world.getChunkAtWorldCoords(locX * 16, locZ * 16 - 1);
          chunk.a(0);
          chunk = world.getChunkAtWorldCoords(locX * 16, locZ * 16 + 16);
          chunk.a(2);
        }
      } else {
        lit = false;
      }
    }
  }
  
  private void a(int i) {
    if (done)
    {

      if (i == 3) {
        for (int j = 0; j < 16; j++)
          f(15, j);
      }
      if (i == 1) {
        for (int j = 0; j < 16; j++)
          f(0, j);
      }
      if (i == 0) {
        for (int j = 0; j < 16; j++)
          f(j, 15);
      }
      if (i == 2) {
        for (int j = 0; j < 16; j++) {
          f(j, 0);
        }
      }
    }
  }
  
  private boolean f(int i, int j) {
    int k = h();
    boolean flag = false;
    boolean flag1 = false;
    


    for (int l = k + 16 - 1; (l > 63) || ((l > 0) && (!flag1)); l--) {
      int i1 = b(i, l, j);
      
      if ((i1 == 255) && (l < 63)) {
        flag1 = true;
      }
      
      if ((!flag) && (i1 > 0)) {
        flag = true;
      } else if ((flag) && (i1 == 0) && (!world.t(locX * 16 + i, l, locZ * 16 + j))) {
        return false;
      }
    }
    for (; 
        l > 0; l--) {
      if (getType(i, l, j).m() > 0) {
        world.t(locX * 16 + i, l, locZ * 16 + j);
      }
    }
    
    return true;
  }
}
