package net.minecraft.server.v1_7_R1;

import com.google.common.base.Joiner;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import org.apache.logging.log4j.Level;
import org.apache.logging.log4j.Logger;
import org.bukkit.command.SimpleCommandMap;

public abstract class CommandBlockListenerAbstract implements ICommandListener
{
  private static final SimpleDateFormat a = new SimpleDateFormat("HH:mm:ss");
  private int b;
  private boolean c = true;
  private IChatBaseComponent d = null;
  public String e = "";
  private String f = "@";
  
  protected org.bukkit.command.CommandSender sender;
  
  public int g()
  {
    return b;
  }
  
  public IChatBaseComponent h() {
    return d;
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    nbttagcompound.setString("Command", e);
    nbttagcompound.setInt("SuccessCount", b);
    nbttagcompound.setString("CustomName", f);
    if (d != null) {
      nbttagcompound.setString("LastOutput", ChatSerializer.a(d));
    }
    
    nbttagcompound.setBoolean("TrackOutput", c);
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    e = nbttagcompound.getString("Command");
    b = nbttagcompound.getInt("SuccessCount");
    if (nbttagcompound.hasKeyOfType("CustomName", 8)) {
      f = nbttagcompound.getString("CustomName");
    }
    
    if (nbttagcompound.hasKeyOfType("LastOutput", 8)) {
      d = ChatSerializer.a(nbttagcompound.getString("LastOutput"));
    }
    
    if (nbttagcompound.hasKeyOfType("TrackOutput", 1)) {
      c = nbttagcompound.getBoolean("TrackOutput");
    }
  }
  
  public boolean a(int i, String s) {
    return i <= 2;
  }
  
  public void a(String s) {
    e = s;
  }
  
  public String i() {
    return e;
  }
  
  public void a(World world) {
    if (isStatic) {
      b = 0;
    }
    
    MinecraftServer minecraftserver = MinecraftServer.getServer();
    
    if ((minecraftserver != null) && (minecraftserver.getEnableCommandBlock()))
    {
      SimpleCommandMap commandMap = server.getCommandMap();
      Joiner joiner = Joiner.on(" ");
      String command = e;
      if (e.startsWith("/")) {
        command = e.substring(1);
      }
      String[] args = command.split(" ");
      ArrayList<String[]> commands = new ArrayList();
      

      if ((args[0].equalsIgnoreCase("stop")) || (args[0].equalsIgnoreCase("kick")) || (args[0].equalsIgnoreCase("op")) || (args[0].equalsIgnoreCase("deop")) || (args[0].equalsIgnoreCase("ban")) || (args[0].equalsIgnoreCase("ban-ip")) || (args[0].equalsIgnoreCase("pardon")) || (args[0].equalsIgnoreCase("pardon-ip")) || (args[0].equalsIgnoreCase("reload")))
      {

        b = 0;
        return;
      }
      

      if (commandMap.getCommand(args[0]) == null) {
        b = 0;
        return;
      }
      

      if (getWorld()players.isEmpty()) {
        b = 0;
        return;
      }
      

      if (args[0].equalsIgnoreCase("testfor")) {
        if (args.length < 2) {
          b = 0;
          return;
        }
        
        EntityPlayer[] players = PlayerSelector.getPlayers(this, args[1]);
        
        if ((players != null) && (players.length > 0)) {
          b = players.length;
          return;
        }
        EntityPlayer player = MinecraftServer.getServer().getPlayerList().getPlayer(args[1]);
        if (player == null) {
          b = 0;
          return;
        }
        b = 1;
        return;
      }
      


      commands.add(args);
      

      ArrayList<String[]> newCommands = new ArrayList();
      for (int i = 0; i < args.length; i++) {
        if (PlayerSelector.isPattern(args[i])) {
          for (int j = 0; j < commands.size(); j++) {
            newCommands.addAll(buildCommands((String[])commands.get(j), i));
          }
          ArrayList<String[]> temp = commands;
          commands = newCommands;
          newCommands = temp;
          newCommands.clear();
        }
      }
      
      int completed = 0;
      

      for (int i = 0; i < commands.size(); i++) {
        try {
          if (commandMap.dispatch(sender, joiner.join(java.util.Arrays.asList((Object[])commands.get(i))))) {
            completed++;
          }
        } catch (Throwable exception) {
          if ((this instanceof TileEntityCommandListener)) {
            TileEntityCommandListener listener = (TileEntityCommandListener)this;
            MinecraftServer.av().log(Level.WARN, String.format("CommandBlock at (%d,%d,%d) failed to handle command", new Object[] { Integer.valueOf(getChunkCoordinates()x), Integer.valueOf(getChunkCoordinates()y), Integer.valueOf(getChunkCoordinates()z) }), exception);
          } else if ((this instanceof EntityMinecartCommandBlockListener)) {
            EntityMinecartCommandBlockListener listener = (EntityMinecartCommandBlockListener)this;
            MinecraftServer.av().log(Level.WARN, String.format("MinecartCommandBlock at (%d,%d,%d) failed to handle command", new Object[] { Integer.valueOf(getChunkCoordinates()x), Integer.valueOf(getChunkCoordinates()y), Integer.valueOf(getChunkCoordinates()z) }), exception);
          } else {
            MinecraftServer.av().log(Level.WARN, String.format("Unknown CommandBlock failed to handle command", new Object[0]), exception);
          }
        }
      }
      
      b = completed;
    }
    else {
      b = 0;
    }
  }
  
  private ArrayList<String[]> buildCommands(String[] args, int pos)
  {
    ArrayList<String[]> commands = new ArrayList();
    EntityPlayer[] players = PlayerSelector.getPlayers(this, args[pos]);
    if (players != null) {
      for (EntityPlayer player : players) {
        if (world == getWorld())
        {

          String[] command = (String[])args.clone();
          command[pos] = player.getName();
          commands.add(command);
        }
      }
    }
    return commands;
  }
  
  public String getName()
  {
    return f;
  }
  
  public IChatBaseComponent getScoreboardDisplayName() {
    return new ChatComponentText(getName());
  }
  
  public void b(String s) {
    f = s;
  }
  
  public void sendMessage(IChatBaseComponent ichatbasecomponent) {
    if ((c) && (getWorld() != null) && (!getWorld()isStatic)) {
      d = new ChatComponentText("[" + a.format(new Date()) + "] ").a(ichatbasecomponent);
      e();
    }
  }
  
  public abstract void e();
  
  public void b(IChatBaseComponent ichatbasecomponent) {
    d = ichatbasecomponent;
  }
}
