package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftHumanEntity;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftInventory;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack;
import org.bukkit.event.Event.Result;
import org.bukkit.event.inventory.InventoryDragEvent;
import org.bukkit.inventory.InventoryView;

public abstract class Container
{
  public abstract InventoryView getBukkitView();
  
  public List b = new ArrayList();
  public List c = new ArrayList();
  public int windowId;
  private int f = -1;
  public int g;
  private final Set h = new HashSet();
  protected List listeners = new ArrayList();
  private Set i = new HashSet();
  

  public boolean checkReachable = true;
  
  public void transferTo(Container other, CraftHumanEntity player) {
    InventoryView source = getBukkitView();InventoryView destination = other.getBukkitView();
    ((CraftInventory)source.getTopInventory()).getInventory().onClose(player);
    ((CraftInventory)source.getBottomInventory()).getInventory().onClose(player);
    ((CraftInventory)destination.getTopInventory()).getInventory().onOpen(player);
    ((CraftInventory)destination.getBottomInventory()).getInventory().onOpen(player);
  }
  


  protected Slot a(Slot slot)
  {
    rawSlotIndex = c.size();
    c.add(slot);
    b.add(null);
    return slot;
  }
  
  public void addSlotListener(ICrafting icrafting) {
    if (listeners.contains(icrafting)) {
      throw new IllegalArgumentException("Listener already listening");
    }
    listeners.add(icrafting);
    icrafting.a(this, a());
    b();
  }
  
  public List a()
  {
    ArrayList arraylist = new ArrayList();
    
    for (int i = 0; i < c.size(); i++) {
      arraylist.add(((Slot)c.get(i)).getItem());
    }
    
    return arraylist;
  }
  
  public void b() {
    for (int i = 0; i < c.size(); i++) {
      ItemStack itemstack = ((Slot)c.get(i)).getItem();
      ItemStack itemstack1 = (ItemStack)b.get(i);
      
      if (!ItemStack.matches(itemstack1, itemstack)) {
        itemstack1 = itemstack == null ? null : itemstack.cloneItemStack();
        b.set(i, itemstack1);
        
        for (int j = 0; j < listeners.size(); j++) {
          ((ICrafting)listeners.get(j)).a(this, i, itemstack1);
        }
      }
    }
  }
  
  public boolean a(EntityHuman entityhuman, int i) {
    return false;
  }
  
  public Slot a(IInventory iinventory, int i) {
    for (int j = 0; j < c.size(); j++) {
      Slot slot = (Slot)c.get(j);
      
      if (slot.a(iinventory, i)) {
        return slot;
      }
    }
    
    return null;
  }
  
  public Slot getSlot(int i) {
    return (Slot)c.get(i);
  }
  
  public ItemStack b(EntityHuman entityhuman, int i) {
    Slot slot = (Slot)c.get(i);
    
    return slot != null ? slot.getItem() : null;
  }
  
  public ItemStack clickItem(int i, int j, int k, EntityHuman entityhuman) {
    ItemStack itemstack = null;
    PlayerInventory playerinventory = inventory;
    


    if (k == 5) {
      int i1 = g;
      
      g = c(j);
      if (((i1 != 1) || (g != 2)) && (i1 != g)) {
        d();
      } else if (playerinventory.getCarried() == null) {
        d();
      } else if (g == 0) {
        f = b(j);
        if (d(f)) {
          g = 1;
          h.clear();
        } else {
          d();
        }
      } else if (g == 1) {
        Slot slot = (Slot)c.get(i);
        
        if ((slot != null) && (a(slot, playerinventory.getCarried(), true)) && (slot.isAllowed(playerinventory.getCarried())) && (getCarried()count > h.size()) && (b(slot))) {
          h.add(slot);
        }
      } else if (g == 2) {
        if (!h.isEmpty()) {
          ItemStack itemstack1 = playerinventory.getCarried().cloneItemStack();
          int l = getCarried()count;
          Iterator iterator = h.iterator();
          
          Map<Integer, ItemStack> draggedSlots = new java.util.HashMap();
          while (iterator.hasNext()) {
            Slot slot1 = (Slot)iterator.next();
            
            if ((slot1 != null) && (a(slot1, playerinventory.getCarried(), true)) && (slot1.isAllowed(playerinventory.getCarried())) && (getCarried()count >= h.size()) && (b(slot1))) {
              ItemStack itemstack2 = itemstack1.cloneItemStack();
              int j1 = slot1.e() ? getItem()count : 0;
              
              a(h, f, itemstack2, j1);
              if (count > itemstack2.getMaxStackSize()) {
                count = itemstack2.getMaxStackSize();
              }
              
              if (count > slot1.a()) {
                count = slot1.a();
              }
              
              l -= count - j1;
              draggedSlots.put(Integer.valueOf(rawSlotIndex), itemstack2);
            }
          }
          

          InventoryView view = getBukkitView();
          org.bukkit.inventory.ItemStack newcursor = CraftItemStack.asCraftMirror(itemstack1);
          newcursor.setAmount(l);
          Map<Integer, org.bukkit.inventory.ItemStack> eventmap = new java.util.HashMap();
          for (Map.Entry<Integer, ItemStack> ditem : draggedSlots.entrySet()) {
            eventmap.put(ditem.getKey(), CraftItemStack.asBukkitCopy((ItemStack)ditem.getValue()));
          }
          

          ItemStack oldCursor = playerinventory.getCarried();
          playerinventory.setCarried(CraftItemStack.asNMSCopy(newcursor));
          
          InventoryDragEvent event = new InventoryDragEvent(view, newcursor.getType() != org.bukkit.Material.AIR ? newcursor : null, CraftItemStack.asBukkitCopy(oldCursor), f == 1, eventmap);
          world.getServer().getPluginManager().callEvent(event);
          

          boolean needsUpdate = event.getResult() != Event.Result.DEFAULT;
          
          if (event.getResult() != Event.Result.DENY) {
            for (Map.Entry<Integer, ItemStack> dslot : draggedSlots.entrySet()) {
              view.setItem(((Integer)dslot.getKey()).intValue(), CraftItemStack.asBukkitCopy((ItemStack)dslot.getValue()));
            }
            

            if (playerinventory.getCarried() != null) {
              playerinventory.setCarried(CraftItemStack.asNMSCopy(event.getCursor()));
              needsUpdate = true;
            }
          }
          else {
            playerinventory.setCarried(oldCursor);
          }
          
          if ((needsUpdate) && ((entityhuman instanceof EntityPlayer))) {
            ((EntityPlayer)entityhuman).updateInventory(this);
          }
        }
        

        d();
      } else {
        d();
      }
    } else if (g != 0) {
      d();




    }
    else if (((k == 0) || (k == 1)) && ((j == 0) || (j == 1))) {
      if (i == -999) {
        if ((playerinventory.getCarried() != null) && (i == -999)) {
          if (j == 0) {
            entityhuman.drop(playerinventory.getCarried(), true);
            playerinventory.setCarried((ItemStack)null);
          }
          
          if (j == 1)
          {
            ItemStack itemstack4 = playerinventory.getCarried();
            if (count > 0) {
              entityhuman.drop(itemstack4.a(1), true);
            }
            
            if (count == 0)
            {
              playerinventory.setCarried((ItemStack)null);
            }
          }
        }
      } else if (k == 1) {
        if (i < 0) {
          return null;
        }
        
        Slot slot2 = (Slot)c.get(i);
        if ((slot2 != null) && (slot2.a(entityhuman))) {
          ItemStack itemstack1 = b(entityhuman, i);
          if (itemstack1 != null) {
            Item item = itemstack1.getItem();
            
            itemstack = itemstack1.cloneItemStack();
            if ((slot2.getItem() != null) && (slot2.getItem().getItem() == item)) {
              a(i, j, true, entityhuman);
            }
          }
        }
      } else {
        if (i < 0) {
          return null;
        }
        
        Slot slot2 = (Slot)c.get(i);
        if (slot2 != null) {
          ItemStack itemstack1 = slot2.getItem();
          ItemStack itemstack4 = playerinventory.getCarried();
          
          if (itemstack1 != null) {
            itemstack = itemstack1.cloneItemStack();
          }
          
          if (itemstack1 == null) {
            if ((itemstack4 != null) && (slot2.isAllowed(itemstack4))) {
              int k1 = j == 0 ? count : 1;
              if (k1 > slot2.a()) {
                k1 = slot2.a();
              }
              
              if (count >= k1) {
                slot2.set(itemstack4.a(k1));
              }
              
              if (count == 0) {
                playerinventory.setCarried((ItemStack)null);
              }
            }
          } else if (slot2.a(entityhuman)) {
            if (itemstack4 == null) {
              int k1 = j == 0 ? count : (count + 1) / 2;
              ItemStack itemstack3 = slot2.a(k1);
              playerinventory.setCarried(itemstack3);
              if (count == 0) {
                slot2.set((ItemStack)null);
              }
              
              slot2.a(entityhuman, playerinventory.getCarried());
            } else if (slot2.isAllowed(itemstack4)) {
              if ((itemstack1.getItem() == itemstack4.getItem()) && (itemstack1.getData() == itemstack4.getData()) && (ItemStack.equals(itemstack1, itemstack4))) {
                int k1 = j == 0 ? count : 1;
                if (k1 > slot2.a() - count) {
                  k1 = slot2.a() - count;
                }
                
                if (k1 > itemstack4.getMaxStackSize() - count) {
                  k1 = itemstack4.getMaxStackSize() - count;
                }
                
                itemstack4.a(k1);
                if (count == 0) {
                  playerinventory.setCarried((ItemStack)null);
                }
                
                count += k1;
              } else if (count <= slot2.a()) {
                slot2.set(itemstack4);
                playerinventory.setCarried(itemstack1);
              }
            } else if ((itemstack1.getItem() == itemstack4.getItem()) && (itemstack4.getMaxStackSize() > 1) && ((!itemstack1.usesData()) || (itemstack1.getData() == itemstack4.getData())) && (ItemStack.equals(itemstack1, itemstack4))) {
              int k1 = count;
              if ((k1 > 0) && (k1 + count <= itemstack4.getMaxStackSize())) {
                count += k1;
                itemstack1 = slot2.a(k1);
                if (count == 0) {
                  slot2.set((ItemStack)null);
                }
                
                slot2.a(entityhuman, playerinventory.getCarried());
              }
            }
          }
          
          slot2.f();
        }
      }
    } else if ((k == 2) && (j >= 0) && (j < 9)) {
      Slot slot2 = (Slot)c.get(i);
      if (slot2.a(entityhuman)) {
        ItemStack itemstack1 = playerinventory.getItem(j);
        boolean flag = (itemstack1 == null) || ((inventory == playerinventory) && (slot2.isAllowed(itemstack1)));
        
        int k1 = -1;
        if (!flag) {
          k1 = playerinventory.j();
          flag |= k1 > -1;
        }
        
        if ((slot2.e()) && (flag)) {
          ItemStack itemstack3 = slot2.getItem();
          playerinventory.setItem(j, itemstack3.cloneItemStack());
          if (((inventory != playerinventory) || (!slot2.isAllowed(itemstack1))) && (itemstack1 != null)) {
            if (k1 > -1) {
              playerinventory.pickup(itemstack1);
              slot2.a(count);
              slot2.set((ItemStack)null);
              slot2.a(entityhuman, itemstack3);
            }
          } else {
            slot2.a(count);
            slot2.set(itemstack1);
            slot2.a(entityhuman, itemstack3);
          }
        } else if ((!slot2.e()) && (itemstack1 != null) && (slot2.isAllowed(itemstack1))) {
          playerinventory.setItem(j, (ItemStack)null);
          slot2.set(itemstack1);
        }
      }
    } else if ((k == 3) && (abilities.canInstantlyBuild) && (playerinventory.getCarried() == null) && (i >= 0)) {
      Slot slot2 = (Slot)c.get(i);
      if ((slot2 != null) && (slot2.e())) {
        ItemStack itemstack1 = slot2.getItem().cloneItemStack();
        count = itemstack1.getMaxStackSize();
        playerinventory.setCarried(itemstack1);
      }
    } else if ((k == 4) && (playerinventory.getCarried() == null) && (i >= 0)) {
      Slot slot2 = (Slot)c.get(i);
      if ((slot2 != null) && (slot2.e()) && (slot2.a(entityhuman))) {
        ItemStack itemstack1 = slot2.a(j == 0 ? 1 : getItem()count);
        slot2.a(entityhuman, itemstack1);
        entityhuman.drop(itemstack1, true);
      }
    } else if ((k == 6) && (i >= 0)) {
      Slot slot2 = (Slot)c.get(i);
      ItemStack itemstack1 = playerinventory.getCarried();
      if ((itemstack1 != null) && ((slot2 == null) || (!slot2.e()) || (!slot2.a(entityhuman)))) {
        int l = j == 0 ? 0 : c.size() - 1;
        int k1 = j == 0 ? 1 : -1;
        
        for (int l1 = 0; l1 < 2; l1++) {
          for (int i2 = l; (i2 >= 0) && (i2 < c.size()) && (count < itemstack1.getMaxStackSize()); i2 += k1) {
            Slot slot3 = (Slot)c.get(i2);
            
            if ((slot3.e()) && (a(slot3, itemstack1, true)) && (slot3.a(entityhuman)) && (a(itemstack1, slot3)) && ((l1 != 0) || (getItem()count != slot3.getItem().getMaxStackSize()))) {
              int j2 = Math.min(itemstack1.getMaxStackSize() - count, getItem()count);
              ItemStack itemstack5 = slot3.a(j2);
              
              count += j2;
              if (count <= 0) {
                slot3.set((ItemStack)null);
              }
              
              slot3.a(entityhuman, itemstack5);
            }
          }
        }
      }
      
      b();
    }
    

    return itemstack;
  }
  
  public boolean a(ItemStack itemstack, Slot slot) {
    return true;
  }
  
  protected void a(int i, int j, boolean flag, EntityHuman entityhuman) {
    clickItem(i, j, 1, entityhuman);
  }
  
  public void b(EntityHuman entityhuman) {
    PlayerInventory playerinventory = inventory;
    
    if (playerinventory.getCarried() != null) {
      entityhuman.drop(playerinventory.getCarried(), false);
      playerinventory.setCarried((ItemStack)null);
    }
  }
  
  public void a(IInventory iinventory) {
    b();
  }
  
  public void setItem(int i, ItemStack itemstack) {
    getSlot(i).set(itemstack);
  }
  
  public boolean c(EntityHuman entityhuman) {
    return !i.contains(entityhuman);
  }
  
  public void a(EntityHuman entityhuman, boolean flag) {
    if (flag) {
      i.remove(entityhuman);
    } else {
      i.add(entityhuman);
    }
  }
  
  public abstract boolean a(EntityHuman paramEntityHuman);
  
  protected boolean a(ItemStack itemstack, int i, int j, boolean flag) {
    boolean flag1 = false;
    int k = i;
    
    if (flag) {
      k = j - 1;
    }
    



    if (itemstack.isStackable()) {
      while ((count > 0) && (((!flag) && (k < j)) || ((flag) && (k >= i)))) {
        Slot slot = (Slot)c.get(k);
        ItemStack itemstack1 = slot.getItem();
        if ((itemstack1 != null) && (itemstack1.getItem() == itemstack.getItem()) && ((!itemstack.usesData()) || (itemstack.getData() == itemstack1.getData())) && (ItemStack.equals(itemstack, itemstack1))) {
          int l = count + count;
          
          if (l <= itemstack.getMaxStackSize()) {
            count = 0;
            count = l;
            slot.f();
            flag1 = true;
          } else if (count < itemstack.getMaxStackSize()) {
            count -= itemstack.getMaxStackSize() - count;
            count = itemstack.getMaxStackSize();
            slot.f();
            flag1 = true;
          }
        }
        
        if (flag) {
          k--;
        } else {
          k++;
        }
      }
    }
    
    if (count > 0) {
      if (flag) {
        k = j - 1;
      } else {
        k = i;
      }
      
      while (((!flag) && (k < j)) || ((flag) && (k >= i))) {
        Slot slot = (Slot)c.get(k);
        ItemStack itemstack1 = slot.getItem();
        if (itemstack1 == null) {
          slot.set(itemstack.cloneItemStack());
          slot.f();
          count = 0;
          flag1 = true;
          break;
        }
        
        if (flag) {
          k--;
        } else {
          k++;
        }
      }
    }
    
    return flag1;
  }
  
  public static int b(int i) {
    return i >> 2 & 0x3;
  }
  
  public static int c(int i) {
    return i & 0x3;
  }
  
  public static boolean d(int i) {
    return (i == 0) || (i == 1);
  }
  
  protected void d() {
    g = 0;
    h.clear();
  }
  
  public static boolean a(Slot slot, ItemStack itemstack, boolean flag) {
    boolean flag1 = (slot == null) || (!slot.e());
    
    if ((slot != null) && (slot.e()) && (itemstack != null) && (itemstack.doMaterialsMatch(slot.getItem())) && (ItemStack.equals(slot.getItem(), itemstack))) {
      int i = flag ? 0 : count;
      
      flag1 |= getItem()count + i <= itemstack.getMaxStackSize();
    }
    
    return flag1;
  }
  
  public static void a(Set set, int i, ItemStack itemstack, int j) {
    switch (i) {
    case 0: 
      count = MathHelper.d(count / set.size());
      break;
    
    case 1: 
      count = 1;
    }
    
    count += j;
  }
  
  public boolean b(Slot slot) {
    return true;
  }
  
  public static int b(IInventory iinventory) {
    if (iinventory == null) {
      return 0;
    }
    int i = 0;
    float f = 0.0F;
    
    for (int j = 0; j < iinventory.getSize(); j++) {
      ItemStack itemstack = iinventory.getItem(j);
      
      if (itemstack != null) {
        f += count / Math.min(iinventory.getMaxStackSize(), itemstack.getMaxStackSize());
        i++;
      }
    }
    
    f /= iinventory.getSize();
    return MathHelper.d(f * 14.0F) + (i > 0 ? 1 : 0);
  }
}
