package net.minecraft.server.v1_7_R1;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Random;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftInventoryEnchanting;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftInventoryView;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack;
import org.bukkit.entity.Player;
import org.bukkit.event.enchantment.EnchantItemEvent;
import org.bukkit.event.enchantment.PrepareItemEnchantEvent;
import org.bukkit.plugin.PluginManager;

public class ContainerEnchantTable extends Container
{
  public ContainerEnchantTableInventory enchantSlots = new ContainerEnchantTableInventory(this, "Enchant", true, 1);
  private World world;
  private int x;
  private int y;
  private int z;
  private Random l = new Random();
  public long f;
  public int[] costs = new int[3];
  
  private CraftInventoryView bukkitEntity = null;
  private Player player;
  
  public ContainerEnchantTable(PlayerInventory playerinventory, World world, int i, int j, int k)
  {
    this.world = world;
    x = i;
    y = j;
    z = k;
    a(new SlotEnchant(this, enchantSlots, 0, 25, 47));
    


    for (int l = 0; l < 3; l++) {
      for (int i1 = 0; i1 < 9; i1++) {
        a(new Slot(playerinventory, i1 + l * 9 + 9, 8 + i1 * 18, 84 + l * 18));
      }
    }
    
    for (l = 0; l < 9; l++) {
      a(new Slot(playerinventory, l, 8 + l * 18, 142));
    }
    

    player = ((Player)player.getBukkitEntity());
    enchantSlots.player = player;
  }
  
  public void addSlotListener(ICrafting icrafting)
  {
    super.addSlotListener(icrafting);
    icrafting.setContainerData(this, 0, costs[0]);
    icrafting.setContainerData(this, 1, costs[1]);
    icrafting.setContainerData(this, 2, costs[2]);
  }
  
  public void b() {
    super.b();
    
    for (int i = 0; i < listeners.size(); i++) {
      ICrafting icrafting = (ICrafting)listeners.get(i);
      
      icrafting.setContainerData(this, 0, costs[0]);
      icrafting.setContainerData(this, 1, costs[1]);
      icrafting.setContainerData(this, 2, costs[2]);
    }
  }
  
  public void a(IInventory iinventory) {
    if (iinventory == enchantSlots) {
      ItemStack itemstack = iinventory.getItem(0);
      

      if (itemstack != null) {
        f = l.nextLong();
        if (!world.isStatic) {
          int i = 0;
          


          for (int j = -1; j <= 1; j++) {
            for (int k = -1; k <= 1; k++) {
              if (((j != 0) || (k != 0)) && (world.isEmpty(x + k, y, z + j)) && (world.isEmpty(x + k, y + 1, z + j))) {
                if (world.getType(x + k * 2, y, z + j * 2) == Blocks.BOOKSHELF) {
                  i++;
                }
                
                if (world.getType(x + k * 2, y + 1, z + j * 2) == Blocks.BOOKSHELF) {
                  i++;
                }
                
                if ((k != 0) && (j != 0)) {
                  if (world.getType(x + k * 2, y, z + j) == Blocks.BOOKSHELF) {
                    i++;
                  }
                  
                  if (world.getType(x + k * 2, y + 1, z + j) == Blocks.BOOKSHELF) {
                    i++;
                  }
                  
                  if (world.getType(x + k, y, z + j * 2) == Blocks.BOOKSHELF) {
                    i++;
                  }
                  
                  if (world.getType(x + k, y + 1, z + j * 2) == Blocks.BOOKSHELF) {
                    i++;
                  }
                }
              }
            }
          }
          
          for (j = 0; j < 3; j++) {
            costs[j] = EnchantmentManager.a(l, j, i, itemstack);
          }
          

          CraftItemStack item = CraftItemStack.asCraftMirror(itemstack);
          PrepareItemEnchantEvent event = new PrepareItemEnchantEvent(player, getBukkitView(), world.getWorld().getBlockAt(x, y, z), item, costs, i);
          event.setCancelled(!itemstack.x());
          world.getServer().getPluginManager().callEvent(event);
          
          if (event.isCancelled()) {
            for (i = 0; i < 3; i++) {
              costs[i] = 0;
            }
            return;
          }
          

          b();
        }
      } else {
        for (int i = 0; i < 3; i++) {
          costs[i] = 0;
        }
      }
    }
  }
  
  public boolean a(EntityHuman entityhuman, int i) {
    ItemStack itemstack = enchantSlots.getItem(0);
    
    if ((costs[i] > 0) && (itemstack != null) && ((expLevel >= costs[i]) || (abilities.canInstantlyBuild))) {
      if (!world.isStatic) {
        List list = EnchantmentManager.b(l, itemstack, costs[i]);
        boolean flag = itemstack.getItem() == Items.BOOK;
        
        if (list != null)
        {
          Map<org.bukkit.enchantments.Enchantment, Integer> enchants = new HashMap();
          for (Object obj : list) {
            EnchantmentInstance instance = (EnchantmentInstance)obj;
            enchants.put(org.bukkit.enchantments.Enchantment.getById(enchantment.id), Integer.valueOf(level));
          }
          CraftItemStack item = CraftItemStack.asCraftMirror(itemstack);
          
          EnchantItemEvent event = new EnchantItemEvent((Player)entityhuman.getBukkitEntity(), getBukkitView(), world.getWorld().getBlockAt(x, y, z), item, costs[i], enchants, i);
          world.getServer().getPluginManager().callEvent(event);
          
          int level = event.getExpLevelCost();
          if ((event.isCancelled()) || ((level > expLevel) && (!abilities.canInstantlyBuild)) || (enchants.isEmpty())) {
            return false;
          }
          
          boolean applied = !flag;
          for (Map.Entry<org.bukkit.enchantments.Enchantment, Integer> entry : event.getEnchantsToAdd().entrySet()) {
            try {
              if (flag) {
                int enchantId = ((org.bukkit.enchantments.Enchantment)entry.getKey()).getId();
                if (Enchantment.byId[enchantId] != null)
                {


                  EnchantmentInstance enchantment = new EnchantmentInstance(enchantId, ((Integer)entry.getValue()).intValue());
                  Items.ENCHANTED_BOOK.a(itemstack, enchantment);
                  applied = true;
                  itemstack.setItem(Items.ENCHANTED_BOOK);
                  break;
                }
              } else { item.addEnchantment((org.bukkit.enchantments.Enchantment)entry.getKey(), ((Integer)entry.getValue()).intValue());
              }
            }
            catch (IllegalArgumentException e) {}
          }
          


          if (applied) {
            entityhuman.levelDown(-level);
          }
          

          a(enchantSlots);
        }
      }
      
      return true;
    }
    return false;
  }
  
  public void b(EntityHuman entityhuman)
  {
    super.b(entityhuman);
    if (!world.isStatic) {
      ItemStack itemstack = enchantSlots.splitWithoutUpdate(0);
      
      if (itemstack != null) {
        entityhuman.drop(itemstack, false);
      }
    }
  }
  
  public boolean a(EntityHuman entityhuman) {
    if (!checkReachable) return true;
    return world.getType(x, y, z) == Blocks.ENCHANTMENT_TABLE;
  }
  
  public ItemStack b(EntityHuman entityhuman, int i) {
    ItemStack itemstack = null;
    Slot slot = (Slot)c.get(i);
    
    if ((slot != null) && (slot.e())) {
      ItemStack itemstack1 = slot.getItem();
      
      itemstack = itemstack1.cloneItemStack();
      if (i == 0) {
        if (!a(itemstack1, 1, 37, true)) {
          return null;
        }
      } else {
        if ((((Slot)c.get(0)).e()) || (!((Slot)c.get(0)).isAllowed(itemstack1))) {
          return null;
        }
        
        if ((itemstack1.hasTag()) && (count == 1)) {
          ((Slot)c.get(0)).set(itemstack1.cloneItemStack());
          count = 0;
        } else if (count >= 1) {
          ((Slot)c.get(0)).set(new ItemStack(itemstack1.getItem(), 1, itemstack1.getData()));
          count -= 1;
        }
      }
      
      if (count == 0) {
        slot.set((ItemStack)null);
      } else {
        slot.f();
      }
      
      if (count == count) {
        return null;
      }
      
      slot.a(entityhuman, itemstack1);
    }
    
    return itemstack;
  }
  
  public CraftInventoryView getBukkitView()
  {
    if (bukkitEntity != null) {
      return bukkitEntity;
    }
    
    CraftInventoryEnchanting inventory = new CraftInventoryEnchanting(enchantSlots);
    bukkitEntity = new CraftInventoryView(player, inventory, this);
    return bukkitEntity;
  }
}
