package net.minecraft.server.v1_7_R1;

import java.io.File;
import java.io.PrintStream;
import java.net.InetAddress;
import java.net.Proxy;
import java.net.UnknownHostException;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;
import org.apache.logging.log4j.Level;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.core.Appender;
import org.apache.logging.log4j.core.appender.ConsoleAppender;
import org.bukkit.craftbukkit.libs.joptsimple.OptionSet;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.LoggerOutputStream;
import org.bukkit.craftbukkit.v1_7_R1.command.CraftRemoteConsoleCommandSender;
import org.bukkit.craftbukkit.v1_7_R1.util.ForwardLogHandler;
import org.bukkit.event.server.ServerCommandEvent;
import org.bukkit.plugin.PluginManager;

public class DedicatedServer extends MinecraftServer implements IMinecraftServer
{
  private static final org.apache.logging.log4j.Logger h = ;
  private final List i = java.util.Collections.synchronizedList(new java.util.ArrayList());
  private RemoteStatusListener j;
  private RemoteControlListener k;
  public PropertyManager propertyManager;
  private boolean generateStructures;
  private EnumGamemode n;
  private boolean o;
  
  public DedicatedServer(OptionSet options)
  {
    super(options, Proxy.NO_PROXY);
    

    new ThreadSleepForever(this, "Server Infinisleeper");
  }
  
  protected boolean init() throws UnknownHostException {
    ThreadCommandReader threadcommandreader = new ThreadCommandReader(this, "Server console handler");
    
    threadcommandreader.setDaemon(true);
    threadcommandreader.start();
    

    java.util.logging.Logger global = java.util.logging.Logger.getLogger("");
    global.setUseParentHandlers(false);
    for (java.util.logging.Handler handler : global.getHandlers()) {
      global.removeHandler(handler);
    }
    global.addHandler(new ForwardLogHandler());
    
    org.apache.logging.log4j.core.Logger logger = (org.apache.logging.log4j.core.Logger)LogManager.getRootLogger();
    for (Appender appender : logger.getAppenders().values()) {
      if ((appender instanceof ConsoleAppender)) {
        logger.removeAppender(appender);
      }
    }
    
    new Thread(new org.bukkit.craftbukkit.v1_7_R1.util.TerminalConsoleWriterThread(System.out, reader)).start();
    
    System.setOut(new PrintStream(new LoggerOutputStream(logger, Level.INFO), true));
    System.setErr(new PrintStream(new LoggerOutputStream(logger, Level.WARN), true));
    

    h.info("Starting minecraft server version 1.7.2");
    if (Runtime.getRuntime().maxMemory() / 1024L / 1024L < 512L) {
      h.warn("To start the server with more ram, launch it as \"java -Xmx1024M -Xms1024M -jar minecraft_server.jar\"");
    }
    
    h.info("Loading properties");
    propertyManager = new PropertyManager(options);
    if (L()) {
      c("127.0.0.1");
    } else {
      setOnlineMode(propertyManager.getBoolean("online-mode", true));
      c(propertyManager.getString("server-ip", ""));
    }
    
    setSpawnAnimals(propertyManager.getBoolean("spawn-animals", true));
    setSpawnNPCs(propertyManager.getBoolean("spawn-npcs", true));
    setPvP(propertyManager.getBoolean("pvp", true));
    setAllowFlight(propertyManager.getBoolean("allow-flight", false));
    setTexturePack(propertyManager.getString("resource-pack", ""));
    setMotd(propertyManager.getString("motd", "A Minecraft Server"));
    setForceGamemode(propertyManager.getBoolean("force-gamemode", false));
    d(propertyManager.getInt("player-idle-timeout", 0));
    if (propertyManager.getInt("difficulty", 1) < 0) {
      propertyManager.a("difficulty", Integer.valueOf(0));
    } else if (propertyManager.getInt("difficulty", 1) > 3) {
      propertyManager.a("difficulty", Integer.valueOf(3));
    }
    
    generateStructures = propertyManager.getBoolean("generate-structures", true);
    int i = propertyManager.getInt("gamemode", EnumGamemode.SURVIVAL.a());
    
    n = WorldSettings.a(i);
    h.info("Default game type: " + n);
    InetAddress inetaddress = null;
    
    if (getServerIp().length() > 0) {
      inetaddress = InetAddress.getByName(getServerIp());
    }
    
    if (J() < 0) {
      setPort(propertyManager.getInt("server-port", 25565));
    }
    
    h.info("Generating keypair");
    a(MinecraftEncryption.b());
    h.info("Starting Minecraft server on " + (getServerIp().length() == 0 ? "*" : getServerIp()) + ":" + J());
    try
    {
      ag().a(inetaddress, J());
    } catch (Throwable ioexception) {
      h.warn("**** FAILED TO BIND TO PORT!");
      h.warn("The exception was: {}", new Object[] { ioexception.toString() });
      h.warn("Perhaps a server is already running on that port?");
      return false;
    }
    
    a(new DedicatedPlayerList(this));
    
    if (!getOnlineMode()) {
      h.warn("**** SERVER IS RUNNING IN OFFLINE/INSECURE MODE!");
      h.warn("The server will make no attempt to authenticate usernames. Beware.");
      h.warn("While this makes the game possible to play without internet access, it also opens up the ability for hackers to connect with any username they choose.");
      h.warn("To change this, set \"online-mode\" to \"true\" in the server.properties file.");
    }
    

    convertable = new WorldLoaderServer(server.getWorldContainer());
    long j = System.nanoTime();
    
    if (M() == null) {
      k(propertyManager.getString("level-name", "world"));
    }
    
    String s = propertyManager.getString("level-seed", "");
    String s1 = propertyManager.getString("level-type", "DEFAULT");
    String s2 = propertyManager.getString("generator-settings", "");
    long k = new Random().nextLong();
    
    if (s.length() > 0) {
      try {
        long l = Long.parseLong(s);
        
        if (l != 0L) {
          k = l;
        }
      } catch (NumberFormatException numberformatexception) {
        k = s.hashCode();
      }
    }
    
    WorldType worldtype = WorldType.getType(s1);
    
    if (worldtype == null) {
      worldtype = WorldType.NORMAL;
    }
    
    ar();
    getEnableCommandBlock();
    l();
    getSnooperEnabled();
    c(propertyManager.getInt("max-build-height", 256));
    c((getMaxBuildHeight() + 8) / 16 * 16);
    c(MathHelper.a(getMaxBuildHeight(), 64, 256));
    propertyManager.a("max-build-height", Integer.valueOf(getMaxBuildHeight()));
    h.info("Preparing level \"" + M() + "\"");
    a(M(), M(), k, worldtype, s2);
    long i1 = System.nanoTime() - j;
    String s3 = String.format("%.3fs", new Object[] { Double.valueOf(i1 / 1000000000.0D) });
    
    h.info("Done (" + s3 + ")! For help, type \"help\" or \"?\"");
    if (propertyManager.getBoolean("enable-query", false)) {
      h.info("Starting GS4 status listener");
      this.j = new RemoteStatusListener(this);
      this.j.a();
    }
    
    if (propertyManager.getBoolean("enable-rcon", false)) {
      h.info("Starting remote control listener");
      this.k = new RemoteControlListener(this);
      this.k.a();
      remoteConsole = new CraftRemoteConsoleCommandSender();
    }
    

    if (server.getBukkitSpawnRadius() > -1) {
      h.info("'settings.spawn-radius' in bukkit.yml has been moved to 'spawn-protection' in server.properties. I will move your config for you.");
      propertyManager.properties.remove("spawn-protection");
      propertyManager.getInt("spawn-protection", server.getBukkitSpawnRadius());
      server.removeBukkitSpawnRadius();
      propertyManager.savePropertiesFile();
    }
    
    return true;
  }
  
  public PropertyManager getPropertyManager() {
    return propertyManager;
  }
  
  public boolean getGenerateStructures()
  {
    return generateStructures;
  }
  
  public EnumGamemode getGamemode() {
    return n;
  }
  
  public EnumDifficulty getDifficulty() {
    return EnumDifficulty.a(propertyManager.getInt("difficulty", 1));
  }
  
  public boolean isHardcore() {
    return propertyManager.getBoolean("hardcore", false);
  }
  
  protected void a(CrashReport crashreport) {
    while (isRunning()) {
      aw();
      try
      {
        Thread.sleep(10L);
      }
      catch (InterruptedException interruptedexception) {}
    }
  }
  
  public CrashReport b(CrashReport crashreport)
  {
    crashreport = super.b(crashreport);
    crashreport.g().a("Is Modded", new CrashReportModded(this));
    crashreport.g().a("Type", new CrashReportType(this));
    return crashreport;
  }
  
  protected void s() {
    System.exit(0);
  }
  
  public void u() {
    super.u();
    aw();
  }
  
  public boolean getAllowNether() {
    return propertyManager.getBoolean("allow-nether", true);
  }
  
  public boolean getSpawnMonsters() {
    return propertyManager.getBoolean("spawn-monsters", true);
  }
  
  public void a(MojangStatisticsGenerator mojangstatisticsgenerator) {
    mojangstatisticsgenerator.a("whitelist_enabled", Boolean.valueOf(ax().getHasWhitelist()));
    mojangstatisticsgenerator.a("whitelist_count", Integer.valueOf(ax().getWhitelisted().size()));
    super.a(mojangstatisticsgenerator);
  }
  
  public boolean getSnooperEnabled() {
    return propertyManager.getBoolean("snooper-enabled", true);
  }
  
  public void issueCommand(String s, ICommandListener icommandlistener) {
    i.add(new ServerCommand(s, icommandlistener));
  }
  
  public void aw() {
    while (!i.isEmpty()) {
      ServerCommand servercommand = (ServerCommand)i.remove(0);
      

      ServerCommandEvent event = new ServerCommandEvent(console, command);
      server.getPluginManager().callEvent(event);
      servercommand = new ServerCommand(event.getCommand(), source);
      

      server.dispatchServerCommand(console, servercommand);
    }
  }
  
  public boolean V()
  {
    return true;
  }
  
  public DedicatedPlayerList ax() {
    return (DedicatedPlayerList)super.getPlayerList();
  }
  
  public int a(String s, int i) {
    return propertyManager.getInt(s, i);
  }
  
  public String a(String s, String s1) {
    return propertyManager.getString(s, s1);
  }
  
  public boolean a(String s, boolean flag) {
    return propertyManager.getBoolean(s, flag);
  }
  
  public void a(String s, Object object) {
    propertyManager.a(s, object);
  }
  
  public void a() {
    propertyManager.savePropertiesFile();
  }
  
  public String b() {
    File file1 = propertyManager.c();
    
    return file1 != null ? file1.getAbsolutePath() : "No settings file";
  }
  
  public void ay() {
    ServerGUI.a(this);
    o = true;
  }
  
  public boolean ai() {
    return o;
  }
  
  public String a(EnumGamemode enumgamemode, boolean flag) {
    return "";
  }
  
  public boolean getEnableCommandBlock() {
    return propertyManager.getBoolean("enable-command-block", false);
  }
  
  public int getSpawnProtection() {
    return propertyManager.getInt("spawn-protection", super.getSpawnProtection());
  }
  
  public boolean a(World world, int i, int j, int k, EntityHuman entityhuman) {
    if (worldProvider.dimension != 0)
      return false;
    if (ax().getOPs().isEmpty())
      return false;
    if (ax().isOp(entityhuman.getName()))
      return false;
    if (getSpawnProtection() <= 0) {
      return false;
    }
    ChunkCoordinates chunkcoordinates = world.getSpawn();
    int l = MathHelper.a(i - x);
    int i1 = MathHelper.a(k - z);
    int j1 = Math.max(l, i1);
    
    return j1 <= getSpawnProtection();
  }
  
  public int l()
  {
    return propertyManager.getInt("op-permission-level", 4);
  }
  
  public void d(int i) {
    super.d(i);
    propertyManager.a("player-idle-timeout", Integer.valueOf(i));
    a();
  }
  
  public boolean ar() {
    return propertyManager.getBoolean("announce-player-achievements", true);
  }
  
  public PlayerList getPlayerList() {
    return ax();
  }
  
  static org.apache.logging.log4j.Logger az() {
    return h;
  }
}
