package net.minecraft.server.v1_7_R1;

import org.bukkit.event.entity.CreatureSpawnEvent.SpawnReason;

public abstract class EntityAgeable extends EntityCreature { private float bp = -1.0F;
  private float bq;
  public boolean ageLocked = false;
  
  public EntityAgeable(World world) {
    super(world);
  }
  
  public abstract EntityAgeable createChild(EntityAgeable paramEntityAgeable);
  
  public boolean a(EntityHuman entityhuman) {
    ItemStack itemstack = inventory.getItemInHand();
    
    if ((itemstack != null) && (itemstack.getItem() == Items.MONSTER_EGG)) {
      if (!world.isStatic) {
        Class oclass = EntityTypes.a(itemstack.getData());
        
        if ((oclass != null) && (oclass.isAssignableFrom(getClass()))) {
          EntityAgeable entityageable = createChild(this);
          
          if (entityageable != null) {
            entityageable.setAge(-24000);
            entityageable.setPositionRotation(locX, locY, locZ, 0.0F, 0.0F);
            world.addEntity(entityageable, CreatureSpawnEvent.SpawnReason.SPAWNER_EGG);
            if (itemstack.hasName()) {
              entityageable.setCustomName(itemstack.getName());
            }
            
            if (!abilities.canInstantlyBuild) {
              count -= 1;
              if (count == 0) {
                inventory.setItem(inventory.itemInHandIndex, (ItemStack)null);
              }
            }
          }
        }
      }
      
      return true;
    }
    return false;
  }
  
  protected void c()
  {
    super.c();
    datawatcher.a(12, new Integer(0));
  }
  
  public int getAge() {
    return datawatcher.getInt(12);
  }
  
  public void a(int i) {
    int j = getAge();
    
    j += i * 20;
    if (j > 0) {
      j = 0;
    }
    
    setAge(j);
  }
  
  public void setAge(int i) {
    datawatcher.watch(12, Integer.valueOf(i));
    a(isBaby());
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    nbttagcompound.setInt("Age", getAge());
    nbttagcompound.setBoolean("AgeLocked", ageLocked);
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    setAge(nbttagcompound.getInt("Age"));
    ageLocked = nbttagcompound.getBoolean("AgeLocked");
  }
  
  public void e() {
    super.e();
    if ((world.isStatic) || (ageLocked)) {
      a(isBaby());
    } else {
      int i = getAge();
      
      if (i < 0) {
        i++;
        setAge(i);
      } else if (i > 0) {
        i--;
        setAge(i);
      }
    }
  }
  
  public boolean isBaby() {
    return getAge() < 0;
  }
  
  public void a(boolean flag) {
    a(flag ? 0.5F : 1.0F);
  }
  
  protected final void a(float f, float f1) {
    boolean flag = bp > 0.0F;
    
    bp = f;
    bq = f1;
    if (!flag) {
      a(1.0F);
    }
  }
  
  protected final void a(float f) {
    super.a(bp * f, bq * f);
  }
}
