package net.minecraft.server.v1_7_R1;

import java.util.List;
import java.util.Random;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.entity.EntityCombustByEntityEvent;
import org.bukkit.event.player.PlayerPickupItemEvent;
import org.bukkit.plugin.PluginManager;

public class EntityArrow extends Entity implements IProjectile
{
  private int d = -1;
  private int e = -1;
  private int f = -1;
  private Block g;
  private int h;
  private boolean inGround;
  public int fromPlayer;
  public int shake;
  public Entity shooter;
  private int j;
  private int au;
  private double damage = 2.0D;
  public int aw;
  
  public EntityArrow(World world) {
    super(world);
    k = 10.0D;
    a(0.5F, 0.5F);
  }
  
  public EntityArrow(World world, double d0, double d1, double d2) {
    super(world);
    k = 10.0D;
    a(0.5F, 0.5F);
    setPosition(d0, d1, d2);
    height = 0.0F;
  }
  
  public EntityArrow(World world, EntityLiving entityliving, EntityLiving entityliving1, float f, float f1) {
    super(world);
    k = 10.0D;
    shooter = entityliving;
    projectileSource = ((LivingEntity)entityliving.getBukkitEntity());
    if ((entityliving instanceof EntityHuman)) {
      fromPlayer = 1;
    }
    
    locY = (locY + entityliving.getHeadHeight() - 0.1000000014901161D);
    double d0 = locX - locX;
    double d1 = boundingBox.b + length / 3.0F - locY;
    double d2 = locZ - locZ;
    double d3 = MathHelper.sqrt(d0 * d0 + d2 * d2);
    
    if (d3 >= 1.0E-007D) {
      float f2 = (float)(Math.atan2(d2, d0) * 180.0D / 3.141592741012573D) - 90.0F;
      float f3 = (float)-(Math.atan2(d1, d3) * 180.0D / 3.141592741012573D);
      double d4 = d0 / d3;
      double d5 = d2 / d3;
      
      setPositionRotation(locX + d4, locY, locZ + d5, f2, f3);
      height = 0.0F;
      float f4 = (float)d3 * 0.2F;
      
      shoot(d0, d1 + f4, d2, f, f1);
    }
  }
  
  public EntityArrow(World world, EntityLiving entityliving, float f) {
    super(world);
    k = 10.0D;
    shooter = entityliving;
    projectileSource = ((LivingEntity)entityliving.getBukkitEntity());
    if ((entityliving instanceof EntityHuman)) {
      fromPlayer = 1;
    }
    
    a(0.5F, 0.5F);
    setPositionRotation(locX, locY + entityliving.getHeadHeight(), locZ, yaw, pitch);
    locX -= MathHelper.cos(yaw / 180.0F * 3.141593F) * 0.16F;
    locY -= 0.1000000014901161D;
    locZ -= MathHelper.sin(yaw / 180.0F * 3.141593F) * 0.16F;
    setPosition(locX, locY, locZ);
    height = 0.0F;
    motX = (-MathHelper.sin(yaw / 180.0F * 3.141593F) * MathHelper.cos(pitch / 180.0F * 3.141593F));
    motZ = (MathHelper.cos(yaw / 180.0F * 3.141593F) * MathHelper.cos(pitch / 180.0F * 3.141593F));
    motY = (-MathHelper.sin(pitch / 180.0F * 3.141593F));
    shoot(motX, motY, motZ, f * 1.5F, 1.0F);
  }
  
  protected void c() {
    datawatcher.a(16, Byte.valueOf((byte)0));
  }
  
  public void shoot(double d0, double d1, double d2, float f, float f1) {
    float f2 = MathHelper.sqrt(d0 * d0 + d1 * d1 + d2 * d2);
    
    d0 /= f2;
    d1 /= f2;
    d2 /= f2;
    d0 += random.nextGaussian() * (random.nextBoolean() ? -1 : 1) * 0.007499999832361937D * f1;
    d1 += random.nextGaussian() * (random.nextBoolean() ? -1 : 1) * 0.007499999832361937D * f1;
    d2 += random.nextGaussian() * (random.nextBoolean() ? -1 : 1) * 0.007499999832361937D * f1;
    d0 *= f;
    d1 *= f;
    d2 *= f;
    motX = d0;
    motY = d1;
    motZ = d2;
    float f3 = MathHelper.sqrt(d0 * d0 + d2 * d2);
    
    lastYaw = (this.yaw = (float)(Math.atan2(d0, d2) * 180.0D / 3.141592741012573D));
    lastPitch = (this.pitch = (float)(Math.atan2(d1, f3) * 180.0D / 3.141592741012573D));
    j = 0;
  }
  
  public void h() {
    super.h();
    if ((lastPitch == 0.0F) && (lastYaw == 0.0F)) {
      float f = MathHelper.sqrt(motX * motX + motZ * motZ);
      
      lastYaw = (this.yaw = (float)(Math.atan2(motX, motZ) * 180.0D / 3.141592741012573D));
      lastPitch = (this.pitch = (float)(Math.atan2(motY, f) * 180.0D / 3.141592741012573D));
    }
    
    Block block = world.getType(d, e, this.f);
    
    if (block.getMaterial() != Material.AIR) {
      block.updateShape(world, d, e, this.f);
      AxisAlignedBB axisalignedbb = block.a(world, d, e, this.f);
      
      if ((axisalignedbb != null) && (axisalignedbb.a(world.getVec3DPool().create(locX, locY, locZ)))) {
        inGround = true;
      }
    }
    
    if (shake > 0) {
      shake -= 1;
    }
    
    if (inGround) {
      int i = world.getData(d, e, this.f);
      
      if ((block == g) && (i == h)) {
        this.j += 1;
        if (this.j == 1200) {
          die();
        }
      } else {
        inGround = false;
        motX *= random.nextFloat() * 0.2F;
        motY *= random.nextFloat() * 0.2F;
        motZ *= random.nextFloat() * 0.2F;
        this.j = 0;
        au = 0;
      }
    } else {
      au += 1;
      Vec3D vec3d = world.getVec3DPool().create(locX, locY, locZ);
      Vec3D vec3d1 = world.getVec3DPool().create(locX + motX, locY + motY, locZ + motZ);
      MovingObjectPosition movingobjectposition = world.rayTrace(vec3d, vec3d1, false, true, false);
      
      vec3d = world.getVec3DPool().create(locX, locY, locZ);
      vec3d1 = world.getVec3DPool().create(locX + motX, locY + motY, locZ + motZ);
      if (movingobjectposition != null) {
        vec3d1 = world.getVec3DPool().create(pos.c, pos.d, pos.e);
      }
      
      Entity entity = null;
      List list = world.getEntities(this, boundingBox.a(motX, motY, motZ).grow(1.0D, 1.0D, 1.0D));
      double d0 = 0.0D;
      



      for (int j = 0; j < list.size(); j++) {
        Entity entity1 = (Entity)list.get(j);
        
        if ((entity1.R()) && ((entity1 != shooter) || (au >= 5))) {
          float f1 = 0.3F;
          AxisAlignedBB axisalignedbb1 = boundingBox.grow(f1, f1, f1);
          MovingObjectPosition movingobjectposition1 = axisalignedbb1.a(vec3d, vec3d1);
          
          if (movingobjectposition1 != null) {
            double d1 = vec3d.distanceSquared(pos);
            
            if ((d1 < d0) || (d0 == 0.0D)) {
              entity = entity1;
              d0 = d1;
            }
          }
        }
      }
      
      if (entity != null) {
        movingobjectposition = new MovingObjectPosition(entity);
      }
      
      if ((movingobjectposition != null) && (entity != null) && ((entity instanceof EntityHuman))) {
        EntityHuman entityhuman = (EntityHuman)entity;
        
        if ((abilities.isInvulnerable) || (((shooter instanceof EntityHuman)) && (!((EntityHuman)shooter).a(entityhuman)))) {
          movingobjectposition = null;
        }
      }
      



      if (movingobjectposition != null) {
        org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callProjectileHitEvent(this);
        
        if (entity != null) {
          float f2 = MathHelper.sqrt(motX * motX + motY * motY + motZ * motZ);
          int k = MathHelper.f(f2 * damage);
          
          if (f()) {
            k += random.nextInt(k / 2 + 2);
          }
          
          DamageSource damagesource = null;
          
          if (shooter == null) {
            damagesource = DamageSource.arrow(this, this);
          } else {
            damagesource = DamageSource.arrow(this, shooter);
          }
          

          if (entity.damageEntity(damagesource, k)) {
            if ((isBurning()) && (!(entity instanceof EntityEnderman)) && ((!(entity instanceof EntityPlayer)) || (!(shooter instanceof EntityPlayer)) || (world.pvpMode))) {
              EntityCombustByEntityEvent combustEvent = new EntityCombustByEntityEvent(getBukkitEntity(), entity.getBukkitEntity(), 5);
              org.bukkit.Bukkit.getPluginManager().callEvent(combustEvent);
              
              if (!combustEvent.isCancelled()) {
                entity.setOnFire(combustEvent.getDuration());
              }
            }
            


            if ((entity instanceof EntityLiving)) {
              EntityLiving entityliving = (EntityLiving)entity;
              
              if (!world.isStatic) {
                entityliving.p(entityliving.aZ() + 1);
              }
              
              if (aw > 0) {
                float f3 = MathHelper.sqrt(motX * motX + motZ * motZ);
                if (f3 > 0.0F) {
                  entity.g(motX * aw * 0.6000000238418579D / f3, 0.1D, motZ * aw * 0.6000000238418579D / f3);
                }
              }
              
              if ((shooter != null) && ((shooter instanceof EntityLiving))) {
                EnchantmentManager.a(entityliving, shooter);
                EnchantmentManager.b((EntityLiving)shooter, entityliving);
              }
              
              if ((shooter != null) && (entity != shooter) && ((entity instanceof EntityHuman)) && ((shooter instanceof EntityPlayer))) {
                shooter).playerConnection.sendPacket(new PacketPlayOutGameStateChange(6, 0.0F));
              }
            }
            
            makeSound("random.bowhit", 1.0F, 1.2F / (random.nextFloat() * 0.2F + 0.9F));
            if (!(entity instanceof EntityEnderman)) {
              die();
            }
          } else {
            motX *= -0.1000000014901161D;
            motY *= -0.1000000014901161D;
            motZ *= -0.1000000014901161D;
            yaw += 180.0F;
            lastYaw += 180.0F;
            au = 0;
          }
        } else {
          d = b;
          e = c;
          this.f = d;
          g = world.getType(d, e, this.f);
          h = world.getData(d, e, this.f);
          motX = ((float)(pos.c - locX));
          motY = ((float)(pos.d - locY));
          motZ = ((float)(pos.e - locZ));
          float f2 = MathHelper.sqrt(motX * motX + motY * motY + motZ * motZ);
          locX -= motX / f2 * 0.0500000007450581D;
          locY -= motY / f2 * 0.0500000007450581D;
          locZ -= motZ / f2 * 0.0500000007450581D;
          makeSound("random.bowhit", 1.0F, 1.2F / (random.nextFloat() * 0.2F + 0.9F));
          inGround = true;
          shake = 7;
          a(false);
          if (g.getMaterial() != Material.AIR) {
            g.a(world, d, e, this.f, this);
          }
        }
      }
      
      if (f()) {
        for (j = 0; j < 4; j++) {
          world.addParticle("crit", locX + motX * j / 4.0D, locY + motY * j / 4.0D, locZ + motZ * j / 4.0D, -motX, -motY + 0.2D, -motZ);
        }
      }
      
      locX += motX;
      locY += motY;
      locZ += motZ;
      float f2 = MathHelper.sqrt(motX * motX + motZ * motZ);
      yaw = ((float)(Math.atan2(motX, motZ) * 180.0D / 3.141592741012573D));
      
      for (pitch = ((float)(Math.atan2(motY, f2) * 180.0D / 3.141592741012573D)); pitch - lastPitch < -180.0F; lastPitch -= 360.0F) {}
      


      while (pitch - lastPitch >= 180.0F) {
        lastPitch += 360.0F;
      }
      
      while (yaw - lastYaw < -180.0F) {
        lastYaw -= 360.0F;
      }
      
      while (yaw - lastYaw >= 180.0F) {
        lastYaw += 360.0F;
      }
      
      pitch = (lastPitch + (pitch - lastPitch) * 0.2F);
      yaw = (lastYaw + (yaw - lastYaw) * 0.2F);
      float f4 = 0.99F;
      
      float f1 = 0.05F;
      if (M()) {
        for (int l = 0; l < 4; l++) {
          float f3 = 0.25F;
          world.addParticle("bubble", locX - motX * f3, locY - motY * f3, locZ - motZ * f3, motX, motY, motZ);
        }
        
        f4 = 0.8F;
      }
      
      if (L()) {
        extinguish();
      }
      
      motX *= f4;
      motY *= f4;
      motZ *= f4;
      motY -= f1;
      setPosition(locX, locY, locZ);
      I();
    }
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    nbttagcompound.setShort("xTile", (short)d);
    nbttagcompound.setShort("yTile", (short)e);
    nbttagcompound.setShort("zTile", (short)f);
    nbttagcompound.setShort("life", (short)j);
    nbttagcompound.setByte("inTile", (byte)Block.b(g));
    nbttagcompound.setByte("inData", (byte)h);
    nbttagcompound.setByte("shake", (byte)shake);
    nbttagcompound.setByte("inGround", (byte)(inGround ? 1 : 0));
    nbttagcompound.setByte("pickup", (byte)fromPlayer);
    nbttagcompound.setDouble("damage", damage);
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    d = nbttagcompound.getShort("xTile");
    e = nbttagcompound.getShort("yTile");
    f = nbttagcompound.getShort("zTile");
    j = nbttagcompound.getShort("life");
    g = Block.e(nbttagcompound.getByte("inTile") & 0xFF);
    h = (nbttagcompound.getByte("inData") & 0xFF);
    shake = (nbttagcompound.getByte("shake") & 0xFF);
    inGround = (nbttagcompound.getByte("inGround") == 1);
    if (nbttagcompound.hasKeyOfType("damage", 99)) {
      damage = nbttagcompound.getDouble("damage");
    }
    
    if (nbttagcompound.hasKeyOfType("pickup", 99)) {
      fromPlayer = nbttagcompound.getByte("pickup");
    } else if (nbttagcompound.hasKeyOfType("player", 99)) {
      fromPlayer = (nbttagcompound.getBoolean("player") ? 1 : 0);
    }
  }
  
  public void b_(EntityHuman entityhuman) {
    if ((!world.isStatic) && (inGround) && (shake <= 0))
    {
      ItemStack itemstack = new ItemStack(Items.ARROW);
      if ((fromPlayer == 1) && (inventory.canHold(itemstack) > 0)) {
        EntityItem item = new EntityItem(world, locX, locY, locZ, itemstack);
        
        PlayerPickupItemEvent event = new PlayerPickupItemEvent((Player)entityhuman.getBukkitEntity(), new org.bukkit.craftbukkit.v1_7_R1.entity.CraftItem(world.getServer(), this, item), 0);
        
        world.getServer().getPluginManager().callEvent(event);
        
        if (event.isCancelled()) {
          return;
        }
      }
      

      boolean flag = (fromPlayer == 1) || ((fromPlayer == 2) && (abilities.canInstantlyBuild));
      
      if ((fromPlayer == 1) && (!inventory.pickup(new ItemStack(Items.ARROW, 1)))) {
        flag = false;
      }
      
      if (flag) {
        makeSound("random.pop", 0.2F, ((random.nextFloat() - random.nextFloat()) * 0.7F + 1.0F) * 2.0F);
        entityhuman.receive(this, 1);
        die();
      }
    }
  }
  
  protected boolean g_() {
    return false;
  }
  
  public void b(double d0) {
    damage = d0;
  }
  
  public double e() {
    return damage;
  }
  
  public void a(int i) {
    aw = i;
  }
  
  public boolean av() {
    return false;
  }
  
  public void a(boolean flag) {
    byte b0 = datawatcher.getByte(16);
    
    if (flag) {
      datawatcher.watch(16, Byte.valueOf((byte)(b0 | 0x1)));
    } else {
      datawatcher.watch(16, Byte.valueOf((byte)(b0 & 0xFFFFFFFE)));
    }
  }
  
  public boolean f() {
    byte b0 = datawatcher.getByte(16);
    
    return (b0 & 0x1) != 0;
  }
  
  public boolean isInGround()
  {
    return inGround;
  }
}
