package net.minecraft.server.v1_7_R1;

import java.util.Random;
import java.util.UUID;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftEntity;
import org.bukkit.event.entity.EntityTargetEvent;
import org.bukkit.event.entity.EntityTargetEvent.TargetReason;
import org.bukkit.plugin.PluginManager;

public abstract class EntityCreature extends EntityInsentient
{
  public static final UUID h = UUID.fromString("E199AD21-BA8A-4C53-8D13-6182D5C69D3A");
  public static final AttributeModifier i = new AttributeModifier(h, "Fleeing speed bonus", 2.0D, 2).a(false);
  public PathEntity pathEntity;
  public Entity target;
  protected boolean bn;
  protected int bo;
  private ChunkCoordinates bq = new ChunkCoordinates(0, 0, 0);
  private float br = -1.0F;
  private PathfinderGoal bs = new PathfinderGoalMoveTowardsRestriction(this, 1.0D);
  private boolean bt;
  
  public EntityCreature(World world) {
    super(world);
  }
  
  protected boolean bN() {
    return false;
  }
  
  protected void bq() {
    world.methodProfiler.a("ai");
    if ((bo > 0) && (--bo == 0)) {
      AttributeInstance attributeinstance = getAttributeInstance(GenericAttributes.d);
      
      attributeinstance.b(i);
    }
    
    bn = bN();
    float f11 = 16.0F;
    
    if (this.target == null)
    {
      Entity target = findTarget();
      if (target != null) {
        EntityTargetEvent event = new EntityTargetEvent(getBukkitEntity(), target.getBukkitEntity(), EntityTargetEvent.TargetReason.CLOSEST_PLAYER);
        world.getServer().getPluginManager().callEvent(event);
        
        if (!event.isCancelled()) {
          if (event.getTarget() == null) {
            this.target = null;
          } else {
            this.target = ((CraftEntity)event.getTarget()).getHandle();
          }
        }
      }
      

      if (this.target != null) {
        pathEntity = world.findPath(this, this.target, f11, true, false, false, true);
      }
    } else if (this.target.isAlive()) {
      float f1 = this.target.d(this);
      
      if (o(this.target)) {
        a(this.target, f1);
      }
    }
    else {
      EntityTargetEvent event = new EntityTargetEvent(getBukkitEntity(), null, EntityTargetEvent.TargetReason.TARGET_DIED);
      world.getServer().getPluginManager().callEvent(event);
      
      if (!event.isCancelled()) {
        if (event.getTarget() == null) {
          this.target = null;
        } else {
          this.target = ((CraftEntity)event.getTarget()).getHandle();
        }
      }
    }
    

    if (((this.target instanceof EntityPlayer)) && (targetplayerInteractManager.isCreative())) {
      this.target = null;
    }
    
    world.methodProfiler.b();
    if ((!bn) && (this.target != null) && ((pathEntity == null) || (random.nextInt(20) == 0))) {
      pathEntity = world.findPath(this, this.target, f11, true, false, false, true);
    } else if ((!bn) && (((pathEntity == null) && (random.nextInt(180) == 0)) || (((random.nextInt(120) == 0) || (bo > 0)) && (aV < 100)))) {
      bO();
    }
    
    int i = MathHelper.floor(boundingBox.b + 0.5D);
    boolean flag = M();
    boolean flag1 = P();
    
    pitch = 0.0F;
    if ((pathEntity != null) && (random.nextInt(100) != 0)) {
      world.methodProfiler.a("followpath");
      Vec3D vec3d = pathEntity.a(this);
      double d0 = width * 2.0F;
      
      while ((vec3d != null) && (vec3d.d(locX, d, locZ) < d0 * d0)) {
        pathEntity.a();
        if (pathEntity.b()) {
          vec3d = null;
          pathEntity = null;
        } else {
          vec3d = pathEntity.a(this);
        }
      }
      
      bd = false;
      if (vec3d != null) {
        double d1 = c - locX;
        double d2 = e - locZ;
        double d3 = d - i;
        
        float f2 = (float)(org.bukkit.craftbukkit.v1_7_R1.TrigMath.atan2(d2, d1) * 180.0D / 3.141592741012573D) - 90.0F;
        float f3 = MathHelper.g(f2 - yaw);
        
        bf = ((float)getAttributeInstance(GenericAttributes.d).getValue());
        if (f3 > 30.0F) {
          f3 = 30.0F;
        }
        
        if (f3 < -30.0F) {
          f3 = -30.0F;
        }
        
        yaw += f3;
        if ((bn) && (this.target != null)) {
          double d4 = targetlocX - locX;
          double d5 = targetlocZ - locZ;
          float f4 = yaw;
          
          yaw = ((float)(Math.atan2(d5, d4) * 180.0D / 3.141592741012573D) - 90.0F);
          f3 = (f4 - yaw + 90.0F) * 3.141593F / 180.0F;
          be = (-MathHelper.sin(f3) * bf * 1.0F);
          bf = (MathHelper.cos(f3) * bf * 1.0F);
        }
        
        if (d3 > 0.0D) {
          bd = true;
        }
      }
      
      if (this.target != null) {
        a(this.target, 30.0F, 30.0F);
      }
      
      if ((positionChanged) && (!bQ())) {
        bd = true;
      }
      
      if ((random.nextFloat() < 0.8F) && ((flag) || (flag1))) {
        bd = true;
      }
      
      world.methodProfiler.b();
    } else {
      super.bq();
      pathEntity = null;
    }
  }
  
  protected void bO() {
    world.methodProfiler.a("stroll");
    boolean flag = false;
    int i = -1;
    int j = -1;
    int k = -1;
    float f = -99999.0F;
    
    for (int l = 0; l < 10; l++) {
      int i1 = MathHelper.floor(locX + random.nextInt(13) - 6.0D);
      int j1 = MathHelper.floor(locY + random.nextInt(7) - 3.0D);
      int k1 = MathHelper.floor(locZ + random.nextInt(13) - 6.0D);
      float f1 = a(i1, j1, k1);
      
      if (f1 > f) {
        f = f1;
        i = i1;
        j = j1;
        k = k1;
        flag = true;
      }
    }
    
    if (flag) {
      pathEntity = world.a(this, i, j, k, 10.0F, true, false, false, true);
    }
    
    world.methodProfiler.b();
  }
  
  protected void a(Entity entity, float f) {}
  
  public float a(int i, int j, int k) {
    return 0.0F;
  }
  
  protected Entity findTarget() {
    return null;
  }
  
  public boolean canSpawn() {
    int i = MathHelper.floor(locX);
    int j = MathHelper.floor(boundingBox.b);
    int k = MathHelper.floor(locZ);
    
    return (super.canSpawn()) && (a(i, j, k) >= 0.0F);
  }
  
  public boolean bQ() {
    return pathEntity != null;
  }
  
  public void setPathEntity(PathEntity pathentity) {
    pathEntity = pathentity;
  }
  
  public Entity bR() {
    return target;
  }
  
  public void setTarget(Entity entity) {
    target = entity;
  }
  
  public boolean bS() {
    return b(MathHelper.floor(locX), MathHelper.floor(locY), MathHelper.floor(locZ));
  }
  
  public boolean b(int i, int j, int k) {
    return br == -1.0F;
  }
  
  public void a(int i, int j, int k, int l) {
    bq.b(i, j, k);
    br = l;
  }
  
  public ChunkCoordinates bT() {
    return bq;
  }
  
  public float bU() {
    return br;
  }
  
  public void bV() {
    br = -1.0F;
  }
  
  public boolean bW() {
    return br != -1.0F;
  }
  
  protected void bJ() {
    super.bJ();
    if ((bL()) && (getLeashHolder() != null) && (getLeashHolder()world == world)) {
      Entity entity = getLeashHolder();
      
      a((int)locX, (int)locY, (int)locZ, 5);
      float f = d(entity);
      
      if (((this instanceof EntityTameableAnimal)) && (((EntityTameableAnimal)this).isSitting())) {
        if (f > 10.0F) {
          world.getServer().getPluginManager().callEvent(new org.bukkit.event.entity.EntityUnleashEvent(getBukkitEntity(), org.bukkit.event.entity.EntityUnleashEvent.UnleashReason.DISTANCE));
          unleash(true, true);
        }
        
        return;
      }
      
      if (!bt) {
        goalSelector.a(2, bs);
        getNavigation().a(false);
        bt = true;
      }
      
      o(f);
      if (f > 4.0F) {
        getNavigation().a(entity, 1.0D);
      }
      
      if (f > 6.0F) {
        double d0 = (locX - locX) / f;
        double d1 = (locY - locY) / f;
        double d2 = (locZ - locZ) / f;
        
        motX += d0 * Math.abs(d0) * 0.4D;
        motY += d1 * Math.abs(d1) * 0.4D;
        motZ += d2 * Math.abs(d2) * 0.4D;
      }
      
      if (f > 10.0F) {
        world.getServer().getPluginManager().callEvent(new org.bukkit.event.entity.EntityUnleashEvent(getBukkitEntity(), org.bukkit.event.entity.EntityUnleashEvent.UnleashReason.DISTANCE));
        unleash(true, true);
      }
    } else if ((!bL()) && (bt)) {
      bt = false;
      goalSelector.a(bs);
      getNavigation().a(true);
      bV();
    }
  }
  
  protected void o(float f) {}
}
