package net.minecraft.server.v1_7_R1;

import java.util.List;
import java.util.Random;
import org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory;
import org.bukkit.event.entity.ExplosionPrimeEvent;

public class EntityCreeper extends EntityMonster
{
  private int bp;
  private int fuseTicks;
  private int maxFuseTicks = 30;
  private int explosionRadius = 3;
  private int record = -1;
  
  public EntityCreeper(World world) {
    super(world);
    goalSelector.a(1, new PathfinderGoalFloat(this));
    goalSelector.a(2, new PathfinderGoalSwell(this));
    goalSelector.a(3, new PathfinderGoalAvoidPlayer(this, EntityOcelot.class, 6.0F, 1.0D, 1.2D));
    goalSelector.a(4, new PathfinderGoalMeleeAttack(this, 1.0D, false));
    goalSelector.a(5, new PathfinderGoalRandomStroll(this, 0.8D));
    goalSelector.a(6, new PathfinderGoalLookAtPlayer(this, EntityHuman.class, 8.0F));
    goalSelector.a(6, new PathfinderGoalRandomLookaround(this));
    targetSelector.a(1, new PathfinderGoalNearestAttackableTarget(this, EntityHuman.class, 0, true));
    targetSelector.a(2, new PathfinderGoalHurtByTarget(this, false));
  }
  
  protected void aD() {
    super.aD();
    getAttributeInstance(GenericAttributes.d).setValue(0.25D);
  }
  
  public boolean bk() {
    return true;
  }
  
  public int ax() {
    return getGoalTarget() == null ? 3 : 3 + (int)(getHealth() - 1.0F);
  }
  
  protected void b(float f) {
    super.b(f);
    fuseTicks = ((int)(fuseTicks + f * 1.5F));
    if (fuseTicks > maxFuseTicks - 5) {
      fuseTicks = (maxFuseTicks - 5);
    }
  }
  
  protected void c() {
    super.c();
    datawatcher.a(16, Byte.valueOf((byte)-1));
    datawatcher.a(17, Byte.valueOf((byte)0));
    datawatcher.a(18, Byte.valueOf((byte)0));
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    if (datawatcher.getByte(17) == 1) {
      nbttagcompound.setBoolean("powered", true);
    }
    
    nbttagcompound.setShort("Fuse", (short)maxFuseTicks);
    nbttagcompound.setByte("ExplosionRadius", (byte)explosionRadius);
    nbttagcompound.setBoolean("ignited", ca());
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    datawatcher.watch(17, Byte.valueOf((byte)(nbttagcompound.getBoolean("powered") ? 1 : 0)));
    if (nbttagcompound.hasKeyOfType("Fuse", 99)) {
      maxFuseTicks = nbttagcompound.getShort("Fuse");
    }
    
    if (nbttagcompound.hasKeyOfType("ExplosionRadius", 99)) {
      explosionRadius = nbttagcompound.getByte("ExplosionRadius");
    }
    
    if (nbttagcompound.getBoolean("ignited")) {
      cb();
    }
  }
  
  public void h() {
    if (isAlive()) {
      bp = fuseTicks;
      if (ca()) {
        a(1);
      }
      
      int i = bZ();
      
      if ((i > 0) && (fuseTicks == 0)) {
        makeSound("creeper.primed", 1.0F, 0.5F);
      }
      
      fuseTicks += i;
      if (fuseTicks < 0) {
        fuseTicks = 0;
      }
      
      if (fuseTicks >= maxFuseTicks) {
        fuseTicks = maxFuseTicks;
        cc();
      }
    }
    
    super.h();
  }
  
  protected String aT() {
    return "mob.creeper.say";
  }
  
  protected String aU() {
    return "mob.creeper.death";
  }
  
  public void die(DamageSource damagesource)
  {
    if ((damagesource.getEntity() instanceof EntitySkeleton)) {
      int i = Item.b(Items.RECORD_1);
      int j = Item.b(Items.RECORD_12);
      int k = i + random.nextInt(j - i + 1);
      

      record = k;
    }
    
    super.die(damagesource);
  }
  

  protected void dropDeathLoot(boolean flag, int i)
  {
    Item j = getLoot();
    
    List<org.bukkit.inventory.ItemStack> loot = new java.util.ArrayList();
    
    if (j != null) {
      int k = random.nextInt(3);
      
      if (i > 0) {
        k += random.nextInt(i + 1);
      }
      
      if (k > 0) {
        loot.add(new org.bukkit.inventory.ItemStack(org.bukkit.craftbukkit.v1_7_R1.util.CraftMagicNumbers.getMaterial(j), k));
      }
    }
    

    if (record != -1) {
      loot.add(new org.bukkit.inventory.ItemStack(record, 1));
      record = -1;
    }
    
    CraftEventFactory.callEntityDeathEvent(this, loot);
  }
  
  public boolean m(Entity entity)
  {
    return true;
  }
  
  public boolean isPowered() {
    return datawatcher.getByte(17) == 1;
  }
  
  protected Item getLoot() {
    return Items.SULPHUR;
  }
  
  public int bZ() {
    return datawatcher.getByte(16);
  }
  
  public void a(int i) {
    datawatcher.watch(16, Byte.valueOf((byte)i));
  }
  
  public void a(EntityLightning entitylightning) {
    super.a(entitylightning);
    
    if (CraftEventFactory.callCreeperPowerEvent(this, entitylightning, org.bukkit.event.entity.CreeperPowerEvent.PowerCause.LIGHTNING).isCancelled()) {
      return;
    }
    
    setPowered(true);
  }
  
  public void setPowered(boolean powered) {
    if (!powered) {
      datawatcher.watch(17, Byte.valueOf((byte)0));
    } else {
      datawatcher.watch(17, Byte.valueOf((byte)1));
    }
  }
  
  protected boolean a(EntityHuman entityhuman)
  {
    ItemStack itemstack = inventory.getItemInHand();
    
    if ((itemstack != null) && (itemstack.getItem() == Items.FLINT_AND_STEEL)) {
      world.makeSound(locX + 0.5D, locY + 0.5D, locZ + 0.5D, "fire.ignite", 1.0F, random.nextFloat() * 0.4F + 0.8F);
      entityhuman.ba();
      if (!world.isStatic) {
        cb();
        itemstack.damage(1, entityhuman);
        return true;
      }
    }
    
    return super.a(entityhuman);
  }
  
  private void cc() {
    if (!world.isStatic) {
      boolean flag = world.getGameRules().getBoolean("mobGriefing");
      

      float radius = isPowered() ? 6.0F : 3.0F;
      
      ExplosionPrimeEvent event = new ExplosionPrimeEvent(getBukkitEntity(), radius, false);
      world.getServer().getPluginManager().callEvent(event);
      if (!event.isCancelled()) {
        world.createExplosion(this, locX, locY, locZ, event.getRadius(), event.getFire(), flag);
        die();
      } else {
        fuseTicks = 0;
      }
    }
  }
  
  public boolean ca()
  {
    return datawatcher.getByte(18) != 0;
  }
  
  public void cb() {
    datawatcher.watch(18, Byte.valueOf((byte)1));
  }
}
