package net.minecraft.server.v1_7_R1;

import org.bukkit.Location;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftPlayer;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.player.PlayerTeleportEvent;

public class EntityEnderPearl extends EntityProjectile
{
  public EntityEnderPearl(World world)
  {
    super(world);
  }
  
  public EntityEnderPearl(World world, EntityLiving entityliving) {
    super(world, entityliving);
  }
  
  protected void a(MovingObjectPosition movingobjectposition) {
    if (entity != null) {
      entity.damageEntity(DamageSource.projectile(this, getShooter()), 0.0F);
    }
    
    for (int i = 0; i < 32; i++) {
      world.addParticle("portal", locX, locY + random.nextDouble() * 2.0D, locZ, random.nextGaussian(), 0.0D, random.nextGaussian());
    }
    
    if (!world.isStatic) {
      if ((getShooter() != null) && ((getShooter() instanceof EntityPlayer))) {
        EntityPlayer entityplayer = (EntityPlayer)getShooter();
        
        if ((playerConnection.b().d()) && (world == world))
        {
          CraftPlayer player = entityplayer.getBukkitEntity();
          Location location = getBukkitEntity().getLocation();
          location.setPitch(player.getLocation().getPitch());
          location.setYaw(player.getLocation().getYaw());
          
          PlayerTeleportEvent teleEvent = new PlayerTeleportEvent(player, player.getLocation(), location, org.bukkit.event.player.PlayerTeleportEvent.TeleportCause.ENDER_PEARL);
          org.bukkit.Bukkit.getPluginManager().callEvent(teleEvent);
          
          if ((!teleEvent.isCancelled()) && (!playerConnection.isDisconnected())) {
            playerConnection.teleport(teleEvent.getTo());
            getShooter()fallDistance = 0.0F;
            
            EntityDamageByEntityEvent damageEvent = new EntityDamageByEntityEvent(getBukkitEntity(), player, org.bukkit.event.entity.EntityDamageEvent.DamageCause.FALL, 5.0D);
            org.bukkit.Bukkit.getPluginManager().callEvent(damageEvent);
            
            if ((!damageEvent.isCancelled()) && (!playerConnection.isDisconnected())) {
              invulnerableTicks = -1;
              player.setLastDamageCause(damageEvent);
              entityplayer.damageEntity(DamageSource.FALL, (float)damageEvent.getDamage());
            }
          }
        }
      }
      

      die();
    }
  }
}
