package net.minecraft.server.v1_7_R1;

import java.util.List;
import java.util.Random;
import java.util.UUID;
import org.bukkit.Location;
import org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory;
import org.bukkit.event.entity.EntityChangeBlockEvent;
import org.bukkit.event.entity.EntityTeleportEvent;

public class EntityEnderman extends EntityMonster
{
  private static final UUID bp = UUID.fromString("020E0DFB-87AE-4653-9556-831010E291A0");
  private static final AttributeModifier bq = new AttributeModifier(bp, "Attacking speed boost", 6.199999809265137D, 0).a(false);
  private static boolean[] br = new boolean[256];
  private int bs;
  private int bt;
  private Entity bu;
  private boolean bv;
  
  public EntityEnderman(World world) {
    super(world);
    a(0.6F, 2.9F);
    X = 1.0F;
  }
  
  protected void aD() {
    super.aD();
    getAttributeInstance(GenericAttributes.a).setValue(40.0D);
    getAttributeInstance(GenericAttributes.d).setValue(0.300000011920929D);
    getAttributeInstance(GenericAttributes.e).setValue(7.0D);
  }
  
  protected void c() {
    super.c();
    datawatcher.a(16, new Byte((byte)0));
    datawatcher.a(17, new Byte((byte)0));
    datawatcher.a(18, new Byte((byte)0));
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    nbttagcompound.setShort("carried", (short)Block.b(getCarried()));
    nbttagcompound.setShort("carriedData", (short)getCarriedData());
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    setCarried(Block.e(nbttagcompound.getShort("carried")));
    setCarriedData(nbttagcompound.getShort("carriedData"));
  }
  
  protected Entity findTarget() {
    EntityHuman entityhuman = world.findNearbyVulnerablePlayer(this, 64.0D);
    
    if (entityhuman != null) {
      if (f(entityhuman)) {
        bv = true;
        if (bt == 0) {
          world.makeSound(locX, locY, locZ, "mob.endermen.stare", 1.0F, 1.0F);
        }
        
        if (bt++ == 5) {
          bt = 0;
          a(true);
          return entityhuman;
        }
      } else {
        bt = 0;
      }
    }
    
    return null;
  }
  
  private boolean f(EntityHuman entityhuman) {
    ItemStack itemstack = inventory.armor[3];
    
    if ((itemstack != null) && (itemstack.getItem() == Item.getItemOf(Blocks.PUMPKIN))) {
      return false;
    }
    Vec3D vec3d = entityhuman.j(1.0F).a();
    Vec3D vec3d1 = world.getVec3DPool().create(locX - locX, boundingBox.b + length / 2.0F - (locY + entityhuman.getHeadHeight()), locZ - locZ);
    double d0 = vec3d1.b();
    
    vec3d1 = vec3d1.a();
    double d1 = vec3d.b(vec3d1);
    
    return d1 > 1.0D - 0.025D / d0 ? entityhuman.o(this) : false;
  }
  
  public void e()
  {
    if (L()) {
      damageEntity(DamageSource.DROWN, 1.0F);
    }
    
    if (bu != target) {
      AttributeInstance attributeinstance = getAttributeInstance(GenericAttributes.d);
      
      attributeinstance.b(bq);
      if (target != null) {
        attributeinstance.a(bq);
      }
    }
    
    bu = target;
    

    if ((!world.isStatic) && (world.getGameRules().getBoolean("mobGriefing")))
    {



      if (getCarried().getMaterial() == Material.AIR) {
        if (random.nextInt(20) == 0) {
          int i = MathHelper.floor(locX - 2.0D + random.nextDouble() * 4.0D);
          int j = MathHelper.floor(locY + random.nextDouble() * 3.0D);
          int k = MathHelper.floor(locZ - 2.0D + random.nextDouble() * 4.0D);
          Block block = world.getType(i, j, k);
          if (br[Block.b(block)] != 0)
          {
            if (!CraftEventFactory.callEntityChangeBlockEvent(this, world.getWorld().getBlockAt(i, j, k), org.bukkit.Material.AIR).isCancelled()) {
              setCarried(block);
              setCarriedData(world.getData(i, j, k));
              world.setTypeUpdate(i, j, k, Blocks.AIR);
            }
          }
        }
      }
      else if (random.nextInt(2000) == 0) {
        int i = MathHelper.floor(locX - 1.0D + random.nextDouble() * 2.0D);
        int j = MathHelper.floor(locY + random.nextDouble() * 2.0D);
        int k = MathHelper.floor(locZ - 1.0D + random.nextDouble() * 2.0D);
        Block block = world.getType(i, j, k);
        Block block1 = world.getType(i, j - 1, k);
        
        if ((block.getMaterial() == Material.AIR) && (block1.getMaterial() != Material.AIR) && (block1.d()))
        {
          if (!CraftEventFactory.callEntityChangeBlockEvent(this, i, j, k, getCarried(), getCarriedData()).isCancelled()) {
            world.setTypeAndData(i, j, k, getCarried(), getCarriedData(), 3);
            setCarried(Blocks.AIR);
          }
        }
      }
    }
    

    for (int i = 0; i < 2; i++) {
      world.addParticle("portal", locX + (random.nextDouble() - 0.5D) * width, locY + random.nextDouble() * length - 0.25D, locZ + (random.nextDouble() - 0.5D) * width, (random.nextDouble() - 0.5D) * 2.0D, -random.nextDouble(), (random.nextDouble() - 0.5D) * 2.0D);
    }
    
    if ((world.v()) && (!world.isStatic)) {
      float f = d(1.0F);
      
      if ((f > 0.5F) && (world.i(MathHelper.floor(locX), MathHelper.floor(locY), MathHelper.floor(locZ))) && (random.nextFloat() * 30.0F < (f - 0.4F) * 2.0F)) {
        target = null;
        a(false);
        bv = false;
        bX();
      }
    }
    
    if ((L()) || (isBurning())) {
      target = null;
      a(false);
      bv = false;
      bX();
    }
    
    if ((cb()) && (!bv) && (random.nextInt(100) == 0)) {
      a(false);
    }
    
    bd = false;
    if (target != null) {
      a(target, 100.0F, 100.0F);
    }
    
    if ((!world.isStatic) && (isAlive())) {
      if (target != null) {
        if (((target instanceof EntityHuman)) && (f((EntityHuman)target))) {
          if (target.e(this) < 16.0D) {
            bX();
          }
          
          bs = 0;
        } else if ((target.e(this) > 256.0D) && (bs++ >= 30) && (c(target))) {
          bs = 0;
        }
      } else {
        a(false);
        bs = 0;
      }
    }
    
    super.e();
  }
  
  protected boolean bX() {
    double d0 = locX + (random.nextDouble() - 0.5D) * 64.0D;
    double d1 = locY + (random.nextInt(64) - 32);
    double d2 = locZ + (random.nextDouble() - 0.5D) * 64.0D;
    
    return k(d0, d1, d2);
  }
  
  protected boolean c(Entity entity) {
    Vec3D vec3d = world.getVec3DPool().create(locX - locX, boundingBox.b + length / 2.0F - locY + entity.getHeadHeight(), locZ - locZ);
    
    vec3d = vec3d.a();
    double d0 = 16.0D;
    double d1 = locX + (random.nextDouble() - 0.5D) * 8.0D - c * d0;
    double d2 = locY + (random.nextInt(16) - 8) - d * d0;
    double d3 = locZ + (random.nextDouble() - 0.5D) * 8.0D - e * d0;
    
    return k(d1, d2, d3);
  }
  
  protected boolean k(double d0, double d1, double d2) {
    double d3 = locX;
    double d4 = locY;
    double d5 = locZ;
    
    locX = d0;
    locY = d1;
    locZ = d2;
    boolean flag = false;
    int i = MathHelper.floor(locX);
    int j = MathHelper.floor(locY);
    int k = MathHelper.floor(locZ);
    
    if (world.isLoaded(i, j, k)) {
      boolean flag1 = false;
      
      while ((!flag1) && (j > 0)) {
        Block block = world.getType(i, j - 1, k);
        
        if (block.getMaterial().isSolid()) {
          flag1 = true;
        } else {
          locY -= 1.0D;
          j--;
        }
      }
      
      if (flag1)
      {
        EntityTeleportEvent teleport = new EntityTeleportEvent(getBukkitEntity(), new Location(world.getWorld(), d3, d4, d5), new Location(world.getWorld(), locX, locY, locZ));
        world.getServer().getPluginManager().callEvent(teleport);
        if (teleport.isCancelled()) {
          return false;
        }
        
        Location to = teleport.getTo();
        setPosition(to.getX(), to.getY(), to.getZ());
        

        if ((world.getCubes(this, boundingBox).isEmpty()) && (!world.containsLiquid(boundingBox))) {
          flag = true;
        }
      }
    }
    
    if (!flag) {
      setPosition(d3, d4, d5);
      return false;
    }
    short short1 = 128;
    
    for (int l = 0; l < short1; l++) {
      double d6 = l / (short1 - 1.0D);
      float f = (random.nextFloat() - 0.5F) * 0.2F;
      float f1 = (random.nextFloat() - 0.5F) * 0.2F;
      float f2 = (random.nextFloat() - 0.5F) * 0.2F;
      double d7 = d3 + (locX - d3) * d6 + (random.nextDouble() - 0.5D) * width * 2.0D;
      double d8 = d4 + (locY - d4) * d6 + random.nextDouble() * length;
      double d9 = d5 + (locZ - d5) * d6 + (random.nextDouble() - 0.5D) * width * 2.0D;
      
      world.addParticle("portal", d7, d8, d9, f, f1, f2);
    }
    
    world.makeSound(d3, d4, d5, "mob.endermen.portal", 1.0F, 1.0F);
    makeSound("mob.endermen.portal", 1.0F, 1.0F);
    return true;
  }
  
  protected String t()
  {
    return cb() ? "mob.endermen.scream" : "mob.endermen.idle";
  }
  
  protected String aT() {
    return "mob.endermen.hit";
  }
  
  protected String aU() {
    return "mob.endermen.death";
  }
  
  protected Item getLoot() {
    return Items.ENDER_PEARL;
  }
  
  protected void dropDeathLoot(boolean flag, int i) {
    Item item = getLoot();
    
    if (item != null)
    {
      List<org.bukkit.inventory.ItemStack> loot = new java.util.ArrayList();
      int count = random.nextInt(2 + i);
      
      if (count > 0) {
        loot.add(new org.bukkit.inventory.ItemStack(org.bukkit.craftbukkit.v1_7_R1.util.CraftMagicNumbers.getMaterial(item), count));
      }
      
      CraftEventFactory.callEntityDeathEvent(this, loot);
    }
  }
  
  public void setCarried(Block block)
  {
    datawatcher.watch(16, Byte.valueOf((byte)(Block.b(block) & 0xFF)));
  }
  
  public Block getCarried() {
    return Block.e(datawatcher.getByte(16));
  }
  
  public void setCarriedData(int i) {
    datawatcher.watch(17, Byte.valueOf((byte)(i & 0xFF)));
  }
  
  public int getCarriedData() {
    return datawatcher.getByte(17);
  }
  
  public boolean damageEntity(DamageSource damagesource, float f) {
    if (isInvulnerable()) {
      return false;
    }
    a(true);
    if (((damagesource instanceof EntityDamageSource)) && ((damagesource.getEntity() instanceof EntityHuman))) {
      bv = true;
    }
    
    if ((damagesource instanceof EntityDamageSourceIndirect)) {
      bv = false;
      
      for (int i = 0; i < 64; i++) {
        if (bX()) {
          return true;
        }
      }
      
      return false;
    }
    return super.damageEntity(damagesource, f);
  }
  

  public boolean cb()
  {
    return datawatcher.getByte(18) > 0;
  }
  
  public void a(boolean flag) {
    datawatcher.watch(18, Byte.valueOf((byte)(flag ? 1 : 0)));
  }
  
  static {
    br[Block.b(Blocks.GRASS)] = true;
    br[Block.b(Blocks.DIRT)] = true;
    br[Block.b(Blocks.SAND)] = true;
    br[Block.b(Blocks.GRAVEL)] = true;
    br[Block.b(Blocks.YELLOW_FLOWER)] = true;
    br[Block.b(Blocks.RED_ROSE)] = true;
    br[Block.b(Blocks.BROWN_MUSHROOM)] = true;
    br[Block.b(Blocks.RED_MUSHROOM)] = true;
    br[Block.b(Blocks.TNT)] = true;
    br[Block.b(Blocks.CACTUS)] = true;
    br[Block.b(Blocks.CLAY)] = true;
    br[Block.b(Blocks.PUMPKIN)] = true;
    br[Block.b(Blocks.MELON)] = true;
    br[Block.b(Blocks.MYCEL)] = true;
  }
}
