package net.minecraft.server.v1_7_R1;

import java.util.List;
import java.util.Random;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftEntity;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack;
import org.bukkit.event.entity.EntityTargetEvent;

public class EntityGhast extends EntityFlying implements IMonster
{
  public int h;
  public double i;
  public double j;
  public double bn;
  private Entity target;
  private int br;
  public int bo;
  public int bp;
  private int explosionPower = 1;
  
  public EntityGhast(World world) {
    super(world);
    a(4.0F, 4.0F);
    fireProof = true;
    b = 5;
  }
  
  public boolean damageEntity(DamageSource damagesource, float f) {
    if (isInvulnerable())
      return false;
    if (("fireball".equals(damagesource.p())) && ((damagesource.getEntity() instanceof EntityHuman))) {
      super.damageEntity(damagesource, 1000.0F);
      ((EntityHuman)damagesource.getEntity()).a(AchievementList.z);
      return true;
    }
    return super.damageEntity(damagesource, f);
  }
  
  protected void c()
  {
    super.c();
    datawatcher.a(16, Byte.valueOf((byte)0));
  }
  
  protected void aD() {
    super.aD();
    getAttributeInstance(GenericAttributes.a).setValue(10.0D);
  }
  
  protected void bq() {
    if ((!world.isStatic) && (world.difficulty == EnumDifficulty.PEACEFUL)) {
      die();
    }
    
    w();
    bo = bp;
    double d0 = i - locX;
    double d1 = j - locY;
    double d2 = bn - locZ;
    double d3 = d0 * d0 + d1 * d1 + d2 * d2;
    
    if ((d3 < 1.0D) || (d3 > 3600.0D)) {
      i = (locX + (random.nextFloat() * 2.0F - 1.0F) * 16.0F);
      j = (locY + (random.nextFloat() * 2.0F - 1.0F) * 16.0F);
      bn = (locZ + (random.nextFloat() * 2.0F - 1.0F) * 16.0F);
    }
    
    if (h-- <= 0) {
      h += random.nextInt(5) + 2;
      d3 = MathHelper.sqrt(d3);
      if (a(i, j, bn, d3)) {
        motX += d0 / d3 * 0.1D;
        motY += d1 / d3 * 0.1D;
        motZ += d2 / d3 * 0.1D;
      } else {
        i = locX;
        j = locY;
        bn = locZ;
      }
    }
    
    if ((this.target != null) && (targetdead))
    {
      EntityTargetEvent event = new EntityTargetEvent(getBukkitEntity(), null, org.bukkit.event.entity.EntityTargetEvent.TargetReason.TARGET_DIED);
      world.getServer().getPluginManager().callEvent(event);
      
      if (!event.isCancelled()) {
        if (event.getTarget() == null) {
          this.target = null;
        } else {
          this.target = ((CraftEntity)event.getTarget()).getHandle();
        }
      }
    }
    

    if ((this.target == null) || (br-- <= 0))
    {
      Entity target = world.findNearbyVulnerablePlayer(this, 100.0D);
      if (target != null) {
        EntityTargetEvent event = new EntityTargetEvent(getBukkitEntity(), target.getBukkitEntity(), org.bukkit.event.entity.EntityTargetEvent.TargetReason.CLOSEST_PLAYER);
        world.getServer().getPluginManager().callEvent(event);
        
        if (!event.isCancelled()) {
          if (event.getTarget() == null) {
            this.target = null;
          } else {
            this.target = ((CraftEntity)event.getTarget()).getHandle();
          }
        }
      }
      

      if (this.target != null) {
        br = 20;
      }
    }
    
    double d4 = 64.0D;
    
    if ((this.target != null) && (this.target.e(this) < d4 * d4)) {
      double d5 = targetlocX - locX;
      double d6 = targetboundingBox.b + targetlength / 2.0F - (locY + length / 2.0F);
      double d7 = targetlocZ - locZ;
      
      aN = (this.yaw = -(float)Math.atan2(d5, d7) * 180.0F / 3.141593F);
      if (o(this.target)) {
        if (bp == 10) {
          world.a((EntityHuman)null, 1007, (int)locX, (int)locY, (int)locZ, 0);
        }
        
        bp += 1;
        if (bp == 20) {
          world.a((EntityHuman)null, 1008, (int)locX, (int)locY, (int)locZ, 0);
          EntityLargeFireball entitylargefireball = new EntityLargeFireball(world, this, d5, d6, d7);
          

          bukkitYield = (entitylargefireball.yield = explosionPower);
          double d8 = 4.0D;
          Vec3D vec3d = j(1.0F);
          
          locX = (locX + c * d8);
          locY = (locY + length / 2.0F + 0.5D);
          locZ = (locZ + e * d8);
          world.addEntity(entitylargefireball);
          bp = -40;
        }
      } else if (bp > 0) {
        bp -= 1;
      }
    } else {
      aN = (this.yaw = -(float)Math.atan2(motX, motZ) * 180.0F / 3.141593F);
      if (bp > 0) {
        bp -= 1;
      }
    }
    
    if (!world.isStatic) {
      byte b0 = datawatcher.getByte(16);
      byte b1 = (byte)(bp > 10 ? 1 : 0);
      
      if (b0 != b1) {
        datawatcher.watch(16, Byte.valueOf(b1));
      }
    }
  }
  
  private boolean a(double d0, double d1, double d2, double d3) {
    double d4 = (this.i - locX) / d3;
    double d5 = (j - locY) / d3;
    double d6 = (bn - locZ) / d3;
    AxisAlignedBB axisalignedbb = boundingBox.clone();
    
    for (int i = 1; i < d3; i++) {
      axisalignedbb.d(d4, d5, d6);
      if (!world.getCubes(this, axisalignedbb).isEmpty()) {
        return false;
      }
    }
    
    return true;
  }
  
  protected String t() {
    return "mob.ghast.moan";
  }
  
  protected String aT() {
    return "mob.ghast.scream";
  }
  
  protected String aU() {
    return "mob.ghast.death";
  }
  
  protected Item getLoot() {
    return Items.SULPHUR;
  }
  
  protected void dropDeathLoot(boolean flag, int i)
  {
    List<org.bukkit.inventory.ItemStack> loot = new java.util.ArrayList();
    int j = random.nextInt(2) + random.nextInt(1 + i);
    


    if (j > 0) {
      loot.add(CraftItemStack.asNewCraftStack(Items.GHAST_TEAR, j));
    }
    
    j = random.nextInt(3) + random.nextInt(1 + i);
    
    if (j > 0) {
      loot.add(CraftItemStack.asNewCraftStack(Items.SULPHUR, j));
    }
    
    org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callEntityDeathEvent(this, loot);
  }
  
  protected float bf()
  {
    return 10.0F;
  }
  
  public boolean canSpawn() {
    return (random.nextInt(20) == 0) && (super.canSpawn()) && (world.difficulty != EnumDifficulty.PEACEFUL);
  }
  
  public int bz() {
    return 1;
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    nbttagcompound.setInt("ExplosionPower", explosionPower);
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    if (nbttagcompound.hasKeyOfType("ExplosionPower", 99)) {
      explosionPower = nbttagcompound.getInt("ExplosionPower");
    }
  }
}
