package net.minecraft.server.v1_7_R1;

import java.util.Iterator;
import java.util.List;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.entity.Hanging;
import org.bukkit.event.hanging.HangingBreakEvent;
import org.bukkit.event.hanging.HangingBreakEvent.RemoveCause;
import org.bukkit.event.painting.PaintingBreakEvent;
import org.bukkit.plugin.PluginManager;

public abstract class EntityHanging extends Entity
{
  private int e;
  public int direction;
  public int x;
  public int y;
  public int z;
  
  public EntityHanging(World world)
  {
    super(world);
    height = 0.0F;
    a(0.5F, 0.5F);
  }
  
  public EntityHanging(World world, int i, int j, int k, int l) {
    this(world);
    x = i;
    y = j;
    z = k;
  }
  
  protected void c() {}
  
  public void setDirection(int i) {
    direction = i;
    lastYaw = (this.yaw = i * 90);
    float f = f();
    float f1 = i();
    float f2 = f();
    
    if ((i != 2) && (i != 0)) {
      f = 0.5F;
    } else {
      f2 = 0.5F;
      yaw = (this.lastYaw = Direction.f[i] * 90);
    }
    
    f /= 32.0F;
    f1 /= 32.0F;
    f2 /= 32.0F;
    float f3 = x + 0.5F;
    float f4 = y + 0.5F;
    float f5 = z + 0.5F;
    float f6 = 0.5625F;
    
    if (i == 2) {
      f5 -= f6;
    }
    
    if (i == 1) {
      f3 -= f6;
    }
    
    if (i == 0) {
      f5 += f6;
    }
    
    if (i == 3) {
      f3 += f6;
    }
    
    if (i == 2) {
      f3 -= c(f());
    }
    
    if (i == 1) {
      f5 += c(f());
    }
    
    if (i == 0) {
      f3 += c(f());
    }
    
    if (i == 3) {
      f5 -= c(f());
    }
    
    f4 += c(i());
    setPosition(f3, f4, f5);
    float f7 = -0.03125F;
    
    boundingBox.b(f3 - f - f7, f4 - f1 - f7, f5 - f2 - f7, f3 + f + f7, f4 + f1 + f7, f5 + f2 + f7);
  }
  
  private float c(int i) {
    return i == 64 ? 0.5F : i == 32 ? 0.5F : 0.0F;
  }
  
  public void h() {
    lastX = locX;
    lastY = locY;
    lastZ = locZ;
    if ((e++ == 100) && (!world.isStatic)) {
      e = 0;
      if ((!dead) && (!survives()))
      {
        Material material = world.getType((int)locX, (int)locY, (int)locZ).getMaterial();
        HangingBreakEvent.RemoveCause cause;
        HangingBreakEvent.RemoveCause cause;
        if (!material.equals(Material.AIR))
        {
          cause = HangingBreakEvent.RemoveCause.OBSTRUCTION;
        } else {
          cause = HangingBreakEvent.RemoveCause.PHYSICS;
        }
        
        HangingBreakEvent event = new HangingBreakEvent((Hanging)getBukkitEntity(), cause);
        world.getServer().getPluginManager().callEvent(event);
        
        PaintingBreakEvent paintingEvent = null;
        if ((this instanceof EntityPainting))
        {
          paintingEvent = new PaintingBreakEvent((org.bukkit.entity.Painting)getBukkitEntity(), org.bukkit.event.painting.PaintingBreakEvent.RemoveCause.valueOf(cause.name()));
          paintingEvent.setCancelled(event.isCancelled());
          world.getServer().getPluginManager().callEvent(paintingEvent);
        }
        
        if ((dead) || (event.isCancelled()) || ((paintingEvent != null) && (paintingEvent.isCancelled()))) {
          return;
        }
        

        die();
        b((Entity)null);
      }
    }
  }
  
  public boolean survives() {
    if (!world.getCubes(this, boundingBox).isEmpty()) {
      return false;
    }
    int i = Math.max(1, f() / 16);
    int j = Math.max(1, i() / 16);
    int k = x;
    int l = y;
    int i1 = z;
    
    if (direction == 2) {
      k = MathHelper.floor(locX - f() / 32.0F);
    }
    
    if (direction == 1) {
      i1 = MathHelper.floor(locZ - f() / 32.0F);
    }
    
    if (direction == 0) {
      k = MathHelper.floor(locX - f() / 32.0F);
    }
    
    if (direction == 3) {
      i1 = MathHelper.floor(locZ - f() / 32.0F);
    }
    
    l = MathHelper.floor(locY - i() / 32.0F);
    
    for (int j1 = 0; j1 < i; j1++) {
      for (int k1 = 0; k1 < j; k1++) {
        Material material;
        Material material;
        if ((direction != 2) && (direction != 0)) {
          material = world.getType(x, l + k1, i1 + j1).getMaterial();
        } else {
          material = world.getType(k + j1, l + k1, z).getMaterial();
        }
        
        if (!material.isBuildable()) {
          return false;
        }
      }
    }
    
    List list = world.getEntities(this, boundingBox);
    Iterator iterator = list.iterator();
    
    Entity entity;
    do
    {
      if (!iterator.hasNext()) {
        return true;
      }
      
      entity = (Entity)iterator.next();
    } while (!(entity instanceof EntityHanging));
    
    return false;
  }
  
  public boolean R()
  {
    return true;
  }
  
  public boolean i(Entity entity) {
    return (entity instanceof EntityHuman) ? damageEntity(DamageSource.playerAttack((EntityHuman)entity), 0.0F) : false;
  }
  
  public void i(int i) {
    world.X();
  }
  
  public boolean damageEntity(DamageSource damagesource, float f) {
    if (isInvulnerable()) {
      return false;
    }
    if ((!dead) && (!world.isStatic))
    {
      HangingBreakEvent event = new HangingBreakEvent((Hanging)getBukkitEntity(), HangingBreakEvent.RemoveCause.DEFAULT);
      PaintingBreakEvent paintingEvent = null;
      if (damagesource.getEntity() != null) {
        event = new org.bukkit.event.hanging.HangingBreakByEntityEvent((Hanging)getBukkitEntity(), damagesource.getEntity() == null ? null : damagesource.getEntity().getBukkitEntity());
        
        if ((this instanceof EntityPainting))
        {
          paintingEvent = new org.bukkit.event.painting.PaintingBreakByEntityEvent((org.bukkit.entity.Painting)getBukkitEntity(), damagesource.getEntity() == null ? null : damagesource.getEntity().getBukkitEntity());
        }
      } else if (damagesource.c()) {
        event = new HangingBreakEvent((Hanging)getBukkitEntity(), HangingBreakEvent.RemoveCause.EXPLOSION);
      }
      
      world.getServer().getPluginManager().callEvent(event);
      
      if (paintingEvent != null) {
        paintingEvent.setCancelled(event.isCancelled());
        world.getServer().getPluginManager().callEvent(paintingEvent);
      }
      
      if ((dead) || (event.isCancelled()) || ((paintingEvent != null) && (paintingEvent.isCancelled()))) {
        return true;
      }
      

      die();
      Q();
      b(damagesource.getEntity());
    }
    
    return true;
  }
  
  public void move(double d0, double d1, double d2)
  {
    if ((!world.isStatic) && (!dead) && (d0 * d0 + d1 * d1 + d2 * d2 > 0.0D)) {
      if (dead) { return;
      }
      

      HangingBreakEvent event = new HangingBreakEvent((Hanging)getBukkitEntity(), HangingBreakEvent.RemoveCause.PHYSICS);
      world.getServer().getPluginManager().callEvent(event);
      
      if ((dead) || (event.isCancelled())) {
        return;
      }
      

      die();
      b((Entity)null);
    }
  }
  


  public void g(double d0, double d1, double d2) {}
  


  public void b(NBTTagCompound nbttagcompound)
  {
    nbttagcompound.setByte("Direction", (byte)direction);
    nbttagcompound.setInt("TileX", x);
    nbttagcompound.setInt("TileY", y);
    nbttagcompound.setInt("TileZ", z);
    switch (direction) {
    case 0: 
      nbttagcompound.setByte("Dir", (byte)2);
      break;
    
    case 1: 
      nbttagcompound.setByte("Dir", (byte)1);
      break;
    
    case 2: 
      nbttagcompound.setByte("Dir", (byte)0);
      break;
    
    case 3: 
      nbttagcompound.setByte("Dir", (byte)3);
    }
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    if (nbttagcompound.hasKeyOfType("Direction", 99)) {
      direction = nbttagcompound.getByte("Direction");
    } else {
      switch (nbttagcompound.getByte("Dir")) {
      case 0: 
        direction = 2;
        break;
      
      case 1: 
        direction = 1;
        break;
      
      case 2: 
        direction = 0;
        break;
      
      case 3: 
        direction = 3;
      }
      
    }
    x = nbttagcompound.getInt("TileX");
    y = nbttagcompound.getInt("TileY");
    z = nbttagcompound.getInt("TileZ");
    setDirection(direction);
  }
  
  public abstract int f();
  
  public abstract int i();
  
  public abstract void b(Entity paramEntity);
  
  protected boolean V() {
    return false;
  }
}
