package net.minecraft.server.v1_7_R1;

import java.util.Iterator;
import java.util.List;
import java.util.Random;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftEntity;
import org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.HorseJumpEvent;

public class EntityHorse extends EntityAnimal implements IInventoryListener
{
  private static final IEntitySelector bu = new EntitySelectorHorse();
  public static final IAttribute attributeJumpStrength = new AttributeRanged("horse.jumpStrength", 0.7D, 0.0D, 2.0D).a("Jump Strength").a(true);
  private static final String[] bw = { null, "textures/entity/horse/armor/horse_armor_iron.png", "textures/entity/horse/armor/horse_armor_gold.png", "textures/entity/horse/armor/horse_armor_diamond.png" };
  private static final String[] bx = { "", "meo", "goo", "dio" };
  private static final int[] by = { 0, 5, 7, 11 };
  private static final String[] bz = { "textures/entity/horse/horse_white.png", "textures/entity/horse/horse_creamy.png", "textures/entity/horse/horse_chestnut.png", "textures/entity/horse/horse_brown.png", "textures/entity/horse/horse_black.png", "textures/entity/horse/horse_gray.png", "textures/entity/horse/horse_darkbrown.png" };
  private static final String[] bA = { "hwh", "hcr", "hch", "hbr", "hbl", "hgr", "hdb" };
  private static final String[] bB = { null, "textures/entity/horse/horse_markings_white.png", "textures/entity/horse/horse_markings_whitefield.png", "textures/entity/horse/horse_markings_whitedots.png", "textures/entity/horse/horse_markings_blackdots.png" };
  private static final String[] bC = { "", "wo_", "wmo", "wdo", "bdo" };
  private int bD;
  private int bE;
  private int bF;
  public int bp;
  public int bq;
  protected boolean br;
  public InventoryHorseChest inventoryChest;
  private boolean bH;
  protected int bs;
  protected float bt;
  private boolean bI;
  private float bJ;
  private float bK;
  private float bL;
  private float bM;
  private float bN;
  private float bO;
  private int bP;
  private String bQ;
  private String[] bR = new String[3];
  public int maxDomestication = 100;
  
  public EntityHorse(World world) {
    super(world);
    a(1.4F, 1.6F);
    fireProof = false;
    setHasChest(false);
    getNavigation().a(true);
    goalSelector.a(0, new PathfinderGoalFloat(this));
    goalSelector.a(1, new PathfinderGoalPanic(this, 1.2D));
    goalSelector.a(1, new PathfinderGoalTame(this, 1.2D));
    goalSelector.a(2, new PathfinderGoalBreed(this, 1.0D));
    goalSelector.a(4, new PathfinderGoalFollowParent(this, 1.0D));
    goalSelector.a(6, new PathfinderGoalRandomStroll(this, 0.7D));
    goalSelector.a(7, new PathfinderGoalLookAtPlayer(this, EntityHuman.class, 6.0F));
    goalSelector.a(8, new PathfinderGoalRandomLookaround(this));
    loadChest();
  }
  
  protected void c() {
    super.c();
    datawatcher.a(16, Integer.valueOf(0));
    datawatcher.a(19, Byte.valueOf((byte)0));
    datawatcher.a(20, Integer.valueOf(0));
    datawatcher.a(21, String.valueOf(""));
    datawatcher.a(22, Integer.valueOf(0));
  }
  
  public void setType(int i) {
    datawatcher.watch(19, Byte.valueOf((byte)i));
    cN();
  }
  
  public int getType() {
    return datawatcher.getByte(19);
  }
  
  public void setVariant(int i) {
    datawatcher.watch(20, Integer.valueOf(i));
    cN();
  }
  
  public int getVariant() {
    return datawatcher.getInt(20);
  }
  
  public String getName() {
    if (hasCustomName()) {
      return getCustomName();
    }
    int i = getType();
    
    switch (i) {
    case 0: 
    default: 
      return LocaleI18n.get("entity.horse.name");
    
    case 1: 
      return LocaleI18n.get("entity.donkey.name");
    
    case 2: 
      return LocaleI18n.get("entity.mule.name");
    
    case 3: 
      return LocaleI18n.get("entity.zombiehorse.name");
    }
    
    return LocaleI18n.get("entity.skeletonhorse.name");
  }
  

  private boolean x(int i)
  {
    return (datawatcher.getInt(16) & i) != 0;
  }
  
  private void b(int i, boolean flag) {
    int j = datawatcher.getInt(16);
    
    if (flag) {
      datawatcher.watch(16, Integer.valueOf(j | i));
    } else {
      datawatcher.watch(16, Integer.valueOf(j & (i ^ 0xFFFFFFFF)));
    }
  }
  
  public boolean bZ() {
    return !isBaby();
  }
  
  public boolean isTame() {
    return x(2);
  }
  
  public boolean ce() {
    return bZ();
  }
  
  public String getOwnerName() {
    return datawatcher.getString(21);
  }
  
  public void setOwnerName(String s) {
    datawatcher.watch(21, s);
  }
  
  public float cg() {
    int i = getAge();
    
    return i >= 0 ? 1.0F : 0.5F + (-24000 - i) / -24000.0F * 0.5F;
  }
  
  public void a(boolean flag) {
    if (flag) {
      a(cg());
    } else {
      a(1.0F);
    }
  }
  
  public boolean ch() {
    return br;
  }
  
  public void setTame(boolean flag) {
    b(2, flag);
  }
  
  public void j(boolean flag) {
    br = flag;
  }
  
  public boolean bK() {
    return (!cC()) && (super.bK());
  }
  
  protected void o(float f) {
    if ((f > 6.0F) && (ck())) {
      o(false);
    }
  }
  
  public boolean hasChest() {
    return x(8);
  }
  
  public int cj() {
    return datawatcher.getInt(22);
  }
  
  private int e(ItemStack itemstack) {
    if (itemstack == null) {
      return 0;
    }
    Item item = itemstack.getItem();
    
    return item == Items.HORSE_ARMOR_DIAMOND ? 3 : item == Items.HORSE_ARMOR_GOLD ? 2 : item == Items.HORSE_ARMOR_IRON ? 1 : 0;
  }
  
  public boolean ck()
  {
    return x(32);
  }
  
  public boolean cl() {
    return x(64);
  }
  
  public boolean cm() {
    return x(16);
  }
  
  public boolean cn() {
    return bH;
  }
  
  public void d(ItemStack itemstack) {
    datawatcher.watch(22, Integer.valueOf(e(itemstack)));
    cN();
  }
  
  public void k(boolean flag) {
    b(16, flag);
  }
  
  public void setHasChest(boolean flag) {
    b(8, flag);
  }
  
  public void m(boolean flag) {
    bH = flag;
  }
  
  public void n(boolean flag) {
    b(4, flag);
  }
  
  public int getTemper() {
    return bs;
  }
  
  public void setTemper(int i) {
    bs = i;
  }
  
  public int v(int i) {
    int j = MathHelper.a(getTemper() + i, 0, getMaxDomestication());
    
    setTemper(j);
    return j;
  }
  
  public boolean damageEntity(DamageSource damagesource, float f) {
    Entity entity = damagesource.getEntity();
    
    return (passenger != null) && (passenger.equals(entity)) ? false : super.damageEntity(damagesource, f);
  }
  
  public int aV() {
    return by[cj()];
  }
  
  public boolean S() {
    return passenger == null;
  }
  
  public boolean cp() {
    int i = MathHelper.floor(locX);
    int j = MathHelper.floor(locZ);
    
    world.getBiome(i, j);
    return true;
  }
  
  public void cq() {
    if ((!world.isStatic) && (hasChest())) {
      a(Item.getItemOf(Blocks.CHEST), 1);
      setHasChest(false);
    }
  }
  
  private void cJ() {
    cQ();
    world.makeSound(this, "eating", 1.0F, 1.0F + (random.nextFloat() - random.nextFloat()) * 0.2F);
  }
  
  protected void b(float f) {
    if (f > 1.0F) {
      makeSound("mob.horse.land", 0.4F, 1.0F);
    }
    
    int i = MathHelper.f(f * 0.5F - 3.0F);
    
    if (i > 0)
    {
      EntityDamageEvent event = CraftEventFactory.callEntityDamageEvent(null, this, org.bukkit.event.entity.EntityDamageEvent.DamageCause.FALL, i);
      if (!event.isCancelled()) {
        float damage = (float)event.getDamage();
        if (damage > 0.0F) {
          getBukkitEntity().setLastDamageCause(event);
          damageEntity(DamageSource.FALL, damage);
        }
      }
      
      if (passenger != null) {
        EntityDamageEvent passengerEvent = CraftEventFactory.callEntityDamageEvent(null, passenger, org.bukkit.event.entity.EntityDamageEvent.DamageCause.FALL, i);
        if ((!passengerEvent.isCancelled()) && (passenger != null)) {
          float damage = (float)passengerEvent.getDamage();
          if (damage > 0.0F) {
            passenger.getBukkitEntity().setLastDamageCause(passengerEvent);
            passenger.damageEntity(DamageSource.FALL, damage);
          }
        }
      }
      

      Block block = world.getType(MathHelper.floor(locX), MathHelper.floor(locY - 0.2D - lastYaw), MathHelper.floor(locZ));
      
      if (block.getMaterial() != Material.AIR) {
        StepSound stepsound = stepSound;
        
        world.makeSound(this, stepsound.getStepSound(), stepsound.getVolume1() * 0.5F, stepsound.getVolume2() * 0.75F);
      }
    }
  }
  
  private int cK() {
    int i = getType();
    
    return hasChest() ? 17 : 2;
  }
  
  public void loadChest() {
    InventoryHorseChest inventoryhorsechest = inventoryChest;
    
    inventoryChest = new InventoryHorseChest("HorseChest", cK(), this);
    inventoryChest.a(getName());
    if (inventoryhorsechest != null) {
      inventoryhorsechest.b(this);
      int i = Math.min(inventoryhorsechest.getSize(), inventoryChest.getSize());
      
      for (int j = 0; j < i; j++) {
        ItemStack itemstack = inventoryhorsechest.getItem(j);
        
        if (itemstack != null) {
          inventoryChest.setItem(j, itemstack.cloneItemStack());
        }
      }
      
      inventoryhorsechest = null;
    }
    
    inventoryChest.a(this);
    cM();
  }
  
  private void cM() {
    if (!world.isStatic) {
      n(inventoryChest.getItem(0) != null);
      if (cz()) {
        d(inventoryChest.getItem(1));
      }
    }
  }
  
  public void a(InventorySubcontainer inventorysubcontainer) {
    int i = cj();
    boolean flag = cs();
    
    cM();
    if (ticksLived > 20) {
      if ((i == 0) && (i != cj())) {
        makeSound("mob.horse.armor", 0.5F, 1.0F);
      } else if (i != cj()) {
        makeSound("mob.horse.armor", 0.5F, 1.0F);
      }
      
      if ((!flag) && (cs())) {
        makeSound("mob.horse.leather", 0.5F, 1.0F);
      }
    }
  }
  
  public boolean canSpawn() {
    cp();
    return super.canSpawn();
  }
  
  protected EntityHorse a(Entity entity, double d0) {
    double d1 = 1.7976931348623157E+308D;
    Entity entity1 = null;
    List list = world.getEntities(entity, boundingBox.a(d0, d0, d0), bu);
    Iterator iterator = list.iterator();
    
    while (iterator.hasNext()) {
      Entity entity2 = (Entity)iterator.next();
      double d2 = entity2.e(locX, locY, locZ);
      
      if (d2 < d1) {
        entity1 = entity2;
        d1 = d2;
      }
    }
    
    return (EntityHorse)entity1;
  }
  
  public double getJumpStrength() {
    return getAttributeInstance(attributeJumpStrength).getValue();
  }
  
  protected String aU() {
    cQ();
    int i = getType();
    
    return (i != 1) && (i != 2) ? "mob.horse.death" : i == 4 ? "mob.horse.skeleton.death" : i == 3 ? "mob.horse.zombie.death" : "mob.horse.donkey.death";
  }
  
  protected Item getLoot() {
    boolean flag = random.nextInt(4) == 0;
    int i = getType();
    
    return i == 3 ? Items.ROTTEN_FLESH : flag ? Item.d(0) : i == 4 ? Items.BONE : Items.LEATHER;
  }
  
  protected String aT() {
    cQ();
    if (random.nextInt(3) == 0) {
      cS();
    }
    
    int i = getType();
    
    return (i != 1) && (i != 2) ? "mob.horse.hit" : i == 4 ? "mob.horse.skeleton.hit" : i == 3 ? "mob.horse.zombie.hit" : "mob.horse.donkey.hit";
  }
  
  public boolean cs() {
    return x(4);
  }
  
  protected String t() {
    cQ();
    if ((random.nextInt(10) == 0) && (!bh())) {
      cS();
    }
    
    int i = getType();
    
    return (i != 1) && (i != 2) ? "mob.horse.idle" : i == 4 ? "mob.horse.skeleton.idle" : i == 3 ? "mob.horse.zombie.idle" : "mob.horse.donkey.idle";
  }
  
  protected String ct() {
    cQ();
    cS();
    int i = getType();
    
    return (i != 3) && (i != 4) ? "mob.horse.donkey.angry" : (i != 1) && (i != 2) ? "mob.horse.angry" : null;
  }
  
  protected void a(int i, int j, int k, Block block) {
    StepSound stepsound = stepSound;
    
    if (world.getType(i, j + 1, k) == Blocks.SNOW) {
      stepsound = SNOWstepSound;
    }
    
    if (!block.getMaterial().isLiquid()) {
      int l = getType();
      
      if ((passenger != null) && (l != 1) && (l != 2)) {
        bP += 1;
        if ((bP > 5) && (bP % 3 == 0)) {
          makeSound("mob.horse.gallop", stepsound.getVolume1() * 0.15F, stepsound.getVolume2());
          if ((l == 0) && (random.nextInt(10) == 0)) {
            makeSound("mob.horse.breathe", stepsound.getVolume1() * 0.6F, stepsound.getVolume2());
          }
        } else if (bP <= 5) {
          makeSound("mob.horse.wood", stepsound.getVolume1() * 0.15F, stepsound.getVolume2());
        }
      } else if (stepsound == Block.f) {
        makeSound("mob.horse.wood", stepsound.getVolume1() * 0.15F, stepsound.getVolume2());
      } else {
        makeSound("mob.horse.soft", stepsound.getVolume1() * 0.15F, stepsound.getVolume2());
      }
    }
  }
  
  protected void aD() {
    super.aD();
    bc().b(attributeJumpStrength);
    getAttributeInstance(GenericAttributes.a).setValue(53.0D);
    getAttributeInstance(GenericAttributes.d).setValue(0.2249999940395355D);
  }
  
  public int bz() {
    return 6;
  }
  
  public int getMaxDomestication() {
    return maxDomestication;
  }
  
  protected float bf() {
    return 0.8F;
  }
  
  public int q() {
    return 400;
  }
  
  private void cN() {
    bQ = null;
  }
  
  public void g(EntityHuman entityhuman) {
    if ((!world.isStatic) && ((passenger == null) || (passenger == entityhuman)) && (isTame())) {
      inventoryChest.a(getName());
      entityhuman.openHorseInventory(this, inventoryChest);
    }
  }
  
  public boolean a(EntityHuman entityhuman) {
    ItemStack itemstack = inventory.getItemInHand();
    
    if ((itemstack != null) && (itemstack.getItem() == Items.MONSTER_EGG))
      return super.a(entityhuman);
    if ((!isTame()) && (cC()))
      return false;
    if ((isTame()) && (bZ()) && (entityhuman.isSneaking())) {
      g(entityhuman);
      return true; }
    if ((ce()) && (passenger != null)) {
      return super.a(entityhuman);
    }
    if (itemstack != null) {
      boolean flag = false;
      
      if (cz()) {
        byte b0 = -1;
        
        if (itemstack.getItem() == Items.HORSE_ARMOR_IRON) {
          b0 = 1;
        } else if (itemstack.getItem() == Items.HORSE_ARMOR_GOLD) {
          b0 = 2;
        } else if (itemstack.getItem() == Items.HORSE_ARMOR_DIAMOND) {
          b0 = 3;
        }
        
        if (b0 >= 0) {
          if (!isTame()) {
            cH();
            return true;
          }
          
          g(entityhuman);
          return true;
        }
      }
      
      if ((!flag) && (!cC())) {
        float f = 0.0F;
        short short1 = 0;
        byte b1 = 0;
        
        if (itemstack.getItem() == Items.WHEAT) {
          f = 2.0F;
          short1 = 60;
          b1 = 3;
        } else if (itemstack.getItem() == Items.SUGAR) {
          f = 1.0F;
          short1 = 30;
          b1 = 3;
        } else if (itemstack.getItem() == Items.BREAD) {
          f = 7.0F;
          short1 = 180;
          b1 = 3;
        } else if (Block.a(itemstack.getItem()) == Blocks.HAY_BLOCK) {
          f = 20.0F;
          short1 = 180;
        } else if (itemstack.getItem() == Items.APPLE) {
          f = 3.0F;
          short1 = 60;
          b1 = 3;
        } else if (itemstack.getItem() == Items.CARROT_GOLDEN) {
          f = 4.0F;
          short1 = 60;
          b1 = 5;
          if ((isTame()) && (getAge() == 0)) {
            flag = true;
            f(entityhuman);
          }
        } else if (itemstack.getItem() == Items.GOLDEN_APPLE) {
          f = 10.0F;
          short1 = 240;
          b1 = 10;
          if ((isTame()) && (getAge() == 0)) {
            flag = true;
            f(entityhuman);
          }
        }
        
        if ((getHealth() < getMaxHealth()) && (f > 0.0F)) {
          heal(f);
          flag = true;
        }
        
        if ((!bZ()) && (short1 > 0)) {
          a(short1);
          flag = true;
        }
        
        if ((b1 > 0) && ((flag) || (!isTame())) && (b1 < getMaxDomestication())) {
          flag = true;
          v(b1);
        }
        
        if (flag) {
          cJ();
        }
      }
      
      if ((!isTame()) && (!flag)) {
        if ((itemstack != null) && (itemstack.a(entityhuman, this))) {
          return true;
        }
        
        cH();
        return true;
      }
      
      if ((!flag) && (cA()) && (!hasChest()) && (itemstack.getItem() == Item.getItemOf(Blocks.CHEST))) {
        setHasChest(true);
        makeSound("mob.chickenplop", 1.0F, (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
        flag = true;
        loadChest();
      }
      
      if ((!flag) && (ce()) && (!cs()) && (itemstack.getItem() == Items.SADDLE)) {
        g(entityhuman);
        return true;
      }
      
      if (flag) {
        if (!abilities.canInstantlyBuild) { if (--count == 0) {
            inventory.setItem(inventory.itemInHandIndex, (ItemStack)null);
          }
        }
        return true;
      }
    }
    
    if ((ce()) && (passenger == null)) {
      if ((itemstack != null) && (itemstack.a(entityhuman, this))) {
        return true;
      }
      i(entityhuman);
      return true;
    }
    
    return super.a(entityhuman);
  }
  

  private void i(EntityHuman entityhuman)
  {
    yaw = yaw;
    pitch = pitch;
    o(false);
    p(false);
    if (!world.isStatic) {
      entityhuman.mount(this);
    }
  }
  
  public boolean cz() {
    return getType() == 0;
  }
  
  public boolean cA() {
    int i = getType();
    
    return (i == 2) || (i == 1);
  }
  
  protected boolean bh() {
    return (passenger != null) && (cs());
  }
  
  public boolean cC() {
    int i = getType();
    
    return (i == 3) || (i == 4);
  }
  
  public boolean cD() {
    return (cC()) || (getType() == 2);
  }
  
  public boolean c(ItemStack itemstack) {
    return false;
  }
  
  private void cP() {
    bp = 1;
  }
  
  public void die(DamageSource damagesource) {
    super.die(damagesource);
    if (!world.isStatic) {
      cI();
    }
  }
  
  public void e() {
    if (random.nextInt(200) == 0) {
      cP();
    }
    
    super.e();
    if (!world.isStatic) {
      if ((random.nextInt(900) == 0) && (deathTicks == 0)) {
        heal(1.0F);
      }
      
      if ((!ck()) && (passenger == null) && (random.nextInt(300) == 0) && (world.getType(MathHelper.floor(locX), MathHelper.floor(locY) - 1, MathHelper.floor(locZ)) == Blocks.GRASS)) {
        o(true);
      }
      
      if ((ck()) && (++bD > 50)) {
        bD = 0;
        o(false);
      }
      
      if ((cm()) && (!bZ()) && (!ck())) {
        EntityHorse entityhorse = a(this, 16.0D);
        
        if ((entityhorse != null) && (e(entityhorse) > 4.0D)) {
          PathEntity pathentity = world.findPath(this, entityhorse, 16.0F, true, false, false, true);
          
          setPathEntity(pathentity);
        }
      }
    }
  }
  
  public void h() {
    super.h();
    if ((world.isStatic) && (datawatcher.a())) {
      datawatcher.e();
      cN();
    }
    
    if ((bE > 0) && (++bE > 30)) {
      bE = 0;
      b(128, false);
    }
    
    if ((!world.isStatic) && (bF > 0) && (++bF > 20)) {
      bF = 0;
      p(false);
    }
    
    if ((bp > 0) && (++bp > 8)) {
      bp = 0;
    }
    
    if (bq > 0) {
      bq += 1;
      if (bq > 300) {
        bq = 0;
      }
    }
    
    bK = bJ;
    if (ck()) {
      bJ += (1.0F - bJ) * 0.4F + 0.05F;
      if (bJ > 1.0F) {
        bJ = 1.0F;
      }
    } else {
      bJ += (0.0F - bJ) * 0.4F - 0.05F;
      if (bJ < 0.0F) {
        bJ = 0.0F;
      }
    }
    
    bM = bL;
    if (cl()) {
      bK = (this.bJ = 0.0F);
      bL += (1.0F - bL) * 0.4F + 0.05F;
      if (bL > 1.0F) {
        bL = 1.0F;
      }
    } else {
      bI = false;
      bL += (0.8F * bL * bL * bL - bL) * 0.6F - 0.05F;
      if (bL < 0.0F) {
        bL = 0.0F;
      }
    }
    
    bO = bN;
    if (x(128)) {
      bN += (1.0F - bN) * 0.7F + 0.05F;
      if (bN > 1.0F) {
        bN = 1.0F;
      }
    } else {
      bN += (0.0F - bN) * 0.7F - 0.05F;
      if (bN < 0.0F) {
        bN = 0.0F;
      }
    }
  }
  
  private void cQ() {
    if (!world.isStatic) {
      bE = 1;
      b(128, true);
    }
  }
  
  private boolean cR() {
    return (passenger == null) && (vehicle == null) && (isTame()) && (bZ()) && (!cD()) && (getHealth() >= getMaxHealth());
  }
  
  public void e(boolean flag) {
    b(32, flag);
  }
  
  public void o(boolean flag) {
    e(flag);
  }
  
  public void p(boolean flag) {
    if (flag) {
      o(false);
    }
    
    b(64, flag);
  }
  
  private void cS() {
    if (!world.isStatic) {
      bF = 1;
      p(true);
    }
  }
  
  public void cH() {
    cS();
    String s = ct();
    
    if (s != null) {
      makeSound(s, bf(), bg());
    }
  }
  
  public void cI() {
    a(this, inventoryChest);
    cq();
  }
  
  private void a(Entity entity, InventoryHorseChest inventoryhorsechest) {
    if ((inventoryhorsechest != null) && (!world.isStatic)) {
      for (int i = 0; i < inventoryhorsechest.getSize(); i++) {
        ItemStack itemstack = inventoryhorsechest.getItem(i);
        
        if (itemstack != null) {
          a(itemstack, 0.0F);
        }
      }
    }
  }
  
  public boolean h(EntityHuman entityhuman) {
    setOwnerName(entityhuman.getName());
    setTame(true);
    return true;
  }
  
  public void e(float f, float f1) {
    if ((passenger != null) && ((passenger instanceof EntityLiving)) && (cs())) {
      lastYaw = (this.yaw = passenger.yaw);
      pitch = (passenger.pitch * 0.5F);
      b(yaw, pitch);
      aP = (this.aN = yaw);
      f = passenger).be * 0.5F;
      f1 = passenger).bf;
      if (f1 <= 0.0F) {
        f1 *= 0.25F;
        bP = 0;
      }
      
      if ((onGround) && (bt == 0.0F) && (cl()) && (!bI)) {
        f = 0.0F;
        f1 = 0.0F;
      }
      
      if ((bt > 0.0F) && (!ch()) && (onGround)) {
        motY = (getJumpStrength() * bt);
        if (hasEffect(MobEffectList.JUMP)) {
          motY += (getEffect(MobEffectList.JUMP).getAmplifier() + 1) * 0.1F;
        }
        
        j(true);
        am = true;
        if (f1 > 0.0F) {
          float f2 = MathHelper.sin(yaw * 3.141593F / 180.0F);
          float f3 = MathHelper.cos(yaw * 3.141593F / 180.0F);
          
          motX += -0.4F * f2 * bt;
          motZ += 0.4F * f3 * bt;
          makeSound("mob.horse.jump", 0.4F, 1.0F);
        }
        
        bt = 0.0F;
      }
      
      X = 1.0F;
      aR = (bl() * 0.1F);
      if (!world.isStatic) {
        i((float)getAttributeInstance(GenericAttributes.d).getValue());
        super.e(f, f1);
      }
      
      if (onGround) {
        bt = 0.0F;
        j(false);
      }
      
      aF = aG;
      double d0 = locX - lastX;
      double d1 = locZ - lastZ;
      float f4 = MathHelper.sqrt(d0 * d0 + d1 * d1) * 4.0F;
      
      if (f4 > 1.0F) {
        f4 = 1.0F;
      }
      
      aG += (f4 - aG) * 0.4F;
      aH += aG;
    } else {
      X = 0.5F;
      aR = 0.02F;
      super.e(f, f1);
    }
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    nbttagcompound.setBoolean("EatingHaystack", ck());
    nbttagcompound.setBoolean("ChestedHorse", hasChest());
    nbttagcompound.setBoolean("HasReproduced", cn());
    nbttagcompound.setBoolean("Bred", cm());
    nbttagcompound.setInt("Type", getType());
    nbttagcompound.setInt("Variant", getVariant());
    nbttagcompound.setInt("Temper", getTemper());
    nbttagcompound.setBoolean("Tame", isTame());
    nbttagcompound.setString("OwnerName", getOwnerName());
    nbttagcompound.setInt("Bukkit.MaxDomestication", maxDomestication);
    if (hasChest()) {
      NBTTagList nbttaglist = new NBTTagList();
      
      for (int i = 2; i < inventoryChest.getSize(); i++) {
        ItemStack itemstack = inventoryChest.getItem(i);
        
        if (itemstack != null) {
          NBTTagCompound nbttagcompound1 = new NBTTagCompound();
          
          nbttagcompound1.setByte("Slot", (byte)i);
          itemstack.save(nbttagcompound1);
          nbttaglist.add(nbttagcompound1);
        }
      }
      
      nbttagcompound.set("Items", nbttaglist);
    }
    
    if (inventoryChest.getItem(1) != null) {
      nbttagcompound.set("ArmorItem", inventoryChest.getItem(1).save(new NBTTagCompound()));
    }
    
    if (inventoryChest.getItem(0) != null) {
      nbttagcompound.set("SaddleItem", inventoryChest.getItem(0).save(new NBTTagCompound()));
    }
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    o(nbttagcompound.getBoolean("EatingHaystack"));
    k(nbttagcompound.getBoolean("Bred"));
    setHasChest(nbttagcompound.getBoolean("ChestedHorse"));
    m(nbttagcompound.getBoolean("HasReproduced"));
    setType(nbttagcompound.getInt("Type"));
    setVariant(nbttagcompound.getInt("Variant"));
    setTemper(nbttagcompound.getInt("Temper"));
    setTame(nbttagcompound.getBoolean("Tame"));
    if (nbttagcompound.hasKeyOfType("OwnerName", 8)) {
      setOwnerName(nbttagcompound.getString("OwnerName"));
    }
    
    if (nbttagcompound.hasKey("Bukkit.MaxDomestication")) {
      maxDomestication = nbttagcompound.getInt("Bukkit.MaxDomestication");
    }
    
    AttributeInstance attributeinstance = bc().a("Speed");
    
    if (attributeinstance != null) {
      getAttributeInstance(GenericAttributes.d).setValue(attributeinstance.b() * 0.25D);
    }
    
    if (hasChest()) {
      NBTTagList nbttaglist = nbttagcompound.getList("Items", 10);
      
      loadChest();
      
      for (int i = 0; i < nbttaglist.size(); i++) {
        NBTTagCompound nbttagcompound1 = nbttaglist.get(i);
        int j = nbttagcompound1.getByte("Slot") & 0xFF;
        
        if ((j >= 2) && (j < inventoryChest.getSize())) {
          inventoryChest.setItem(j, ItemStack.createStack(nbttagcompound1));
        }
      }
    }
    


    if (nbttagcompound.hasKeyOfType("ArmorItem", 10)) {
      ItemStack itemstack = ItemStack.createStack(nbttagcompound.getCompound("ArmorItem"));
      if ((itemstack != null) && (a(itemstack.getItem()))) {
        inventoryChest.setItem(1, itemstack);
      }
    }
    
    if (nbttagcompound.hasKeyOfType("SaddleItem", 10)) {
      ItemStack itemstack = ItemStack.createStack(nbttagcompound.getCompound("SaddleItem"));
      if ((itemstack != null) && (itemstack.getItem() == Items.SADDLE)) {
        inventoryChest.setItem(0, itemstack);
      }
    } else if (nbttagcompound.getBoolean("Saddle")) {
      inventoryChest.setItem(0, new ItemStack(Items.SADDLE));
    }
    
    cM();
  }
  
  public boolean mate(EntityAnimal entityanimal) {
    if (entityanimal == this)
      return false;
    if (entityanimal.getClass() != getClass()) {
      return false;
    }
    EntityHorse entityhorse = (EntityHorse)entityanimal;
    
    if ((cR()) && (entityhorse.cR())) {
      int i = getType();
      int j = entityhorse.getType();
      
      return (i == j) || ((i == 0) && (j == 1)) || ((i == 1) && (j == 0));
    }
    return false;
  }
  

  public EntityAgeable createChild(EntityAgeable entityageable)
  {
    EntityHorse entityhorse = (EntityHorse)entityageable;
    EntityHorse entityhorse1 = new EntityHorse(world);
    int i = getType();
    int j = entityhorse.getType();
    int k = 0;
    
    if (i == j) {
      k = i;
    } else if (((i == 0) && (j == 1)) || ((i == 1) && (j == 0))) {
      k = 2;
    }
    
    if (k == 0) {
      int l = random.nextInt(9);
      int i1;
      int i1;
      if (l < 4) {
        i1 = getVariant() & 0xFF; } else { int i1;
        if (l < 8) {
          i1 = entityhorse.getVariant() & 0xFF;
        } else {
          i1 = random.nextInt(7);
        }
      }
      int j1 = random.nextInt(5);
      
      if (j1 < 2) {
        i1 |= getVariant() & 0xFF00;
      } else if (j1 < 4) {
        i1 |= entityhorse.getVariant() & 0xFF00;
      } else {
        i1 |= random.nextInt(5) << 8 & 0xFF00;
      }
      
      entityhorse1.setVariant(i1);
    }
    
    entityhorse1.setType(k);
    double d0 = getAttributeInstance(GenericAttributes.a).b() + entityageable.getAttributeInstance(GenericAttributes.a).b() + cT();
    
    entityhorse1.getAttributeInstance(GenericAttributes.a).setValue(d0 / 3.0D);
    double d1 = getAttributeInstance(attributeJumpStrength).b() + entityageable.getAttributeInstance(attributeJumpStrength).b() + cU();
    
    entityhorse1.getAttributeInstance(attributeJumpStrength).setValue(d1 / 3.0D);
    double d2 = getAttributeInstance(GenericAttributes.d).b() + entityageable.getAttributeInstance(GenericAttributes.d).b() + cV();
    
    entityhorse1.getAttributeInstance(GenericAttributes.d).setValue(d2 / 3.0D);
    return entityhorse1;
  }
  
  public GroupDataEntity a(GroupDataEntity groupdataentity) {
    Object object = super.a(groupdataentity);
    boolean flag = false;
    int i = 0;
    
    int j;
    if ((object instanceof GroupDataHorse)) {
      int j = a;
      i = b & 0xFF | random.nextInt(5) << 8;
    } else { int j;
      if (random.nextInt(10) == 0) {
        j = 1;
      } else {
        int k = random.nextInt(7);
        int l = random.nextInt(5);
        
        j = 0;
        i = k | l << 8;
      }
      
      object = new GroupDataHorse(j, i);
    }
    
    setType(j);
    setVariant(i);
    if (random.nextInt(5) == 0) {
      setAge(-24000);
    }
    
    if ((j != 4) && (j != 3)) {
      getAttributeInstance(GenericAttributes.a).setValue(cT());
      if (j == 0) {
        getAttributeInstance(GenericAttributes.d).setValue(cV());
      } else {
        getAttributeInstance(GenericAttributes.d).setValue(0.1749999970197678D);
      }
    } else {
      getAttributeInstance(GenericAttributes.a).setValue(15.0D);
      getAttributeInstance(GenericAttributes.d).setValue(0.2000000029802322D);
    }
    
    if ((j != 2) && (j != 1)) {
      getAttributeInstance(attributeJumpStrength).setValue(cU());
    } else {
      getAttributeInstance(attributeJumpStrength).setValue(0.5D);
    }
    
    setHealth(getMaxHealth());
    return (GroupDataEntity)object;
  }
  
  protected boolean bk() {
    return true;
  }
  
  public void w(int i) {
    if (cs())
    {
      if (i < 0) {
        i = 0;
      }
      float power;
      float power;
      if (i >= 90) {
        power = 1.0F;
      } else {
        power = 0.4F + 0.4F * i / 90.0F;
      }
      
      HorseJumpEvent event = CraftEventFactory.callHorseJumpEvent(this, power);
      if (!event.isCancelled()) {
        bI = true;
        cS();
        bt = event.getPower();
      }
    }
  }
  
  public void ac()
  {
    super.ac();
    if (bM > 0.0F) {
      float f = MathHelper.sin(aN * 3.141593F / 180.0F);
      float f1 = MathHelper.cos(aN * 3.141593F / 180.0F);
      float f2 = 0.7F * bM;
      float f3 = 0.15F * bM;
      
      passenger.setPosition(locX + f2 * f, locY + ae() + passenger.ad() + f3, locZ - f2 * f1);
      if ((passenger instanceof EntityLiving)) {
        passenger).aN = aN;
      }
    }
  }
  
  private float cT() {
    return 15.0F + random.nextInt(8) + random.nextInt(9);
  }
  
  private double cU() {
    return 0.4000000059604645D + random.nextDouble() * 0.2D + random.nextDouble() * 0.2D + random.nextDouble() * 0.2D;
  }
  
  private double cV() {
    return (0.449999988079071D + random.nextDouble() * 0.3D + random.nextDouble() * 0.3D + random.nextDouble() * 0.3D) * 0.25D;
  }
  
  public static boolean a(Item item) {
    return (item == Items.HORSE_ARMOR_IRON) || (item == Items.HORSE_ARMOR_GOLD) || (item == Items.HORSE_ARMOR_DIAMOND);
  }
  
  public boolean h_() {
    return false;
  }
}
