package net.minecraft.server.v1_7_R1;

import java.util.Random;

public class EntityIronGolem extends EntityGolem
{
  private int bq;
  Village bp;
  private int br;
  private int bs;
  
  public EntityIronGolem(World world) {
    super(world);
    a(1.4F, 2.9F);
    getNavigation().a(true);
    goalSelector.a(1, new PathfinderGoalMeleeAttack(this, 1.0D, true));
    goalSelector.a(2, new PathfinderGoalMoveTowardsTarget(this, 0.9D, 32.0F));
    goalSelector.a(3, new PathfinderGoalMoveThroughVillage(this, 0.6D, true));
    goalSelector.a(4, new PathfinderGoalMoveTowardsRestriction(this, 1.0D));
    goalSelector.a(5, new PathfinderGoalOfferFlower(this));
    goalSelector.a(6, new PathfinderGoalRandomStroll(this, 0.6D));
    goalSelector.a(7, new PathfinderGoalLookAtPlayer(this, EntityHuman.class, 6.0F));
    goalSelector.a(8, new PathfinderGoalRandomLookaround(this));
    targetSelector.a(1, new PathfinderGoalDefendVillage(this));
    targetSelector.a(2, new PathfinderGoalHurtByTarget(this, false));
    targetSelector.a(3, new PathfinderGoalNearestAttackableTarget(this, EntityInsentient.class, 0, false, true, IMonster.a));
  }
  
  protected void c() {
    super.c();
    datawatcher.a(16, Byte.valueOf((byte)0));
  }
  
  public boolean bk() {
    return true;
  }
  
  protected void bp() {
    if (--bq <= 0) {
      bq = (70 + random.nextInt(50));
      bp = world.villages.getClosestVillage(MathHelper.floor(locX), MathHelper.floor(locY), MathHelper.floor(locZ), 32);
      if (bp == null) {
        bV();
      } else {
        ChunkCoordinates chunkcoordinates = bp.getCenter();
        
        a(x, y, z, (int)(bp.getSize() * 0.6F));
      }
    }
    
    super.bp();
  }
  
  protected void aD() {
    super.aD();
    getAttributeInstance(GenericAttributes.a).setValue(100.0D);
    getAttributeInstance(GenericAttributes.d).setValue(0.25D);
  }
  
  protected int j(int i) {
    return i;
  }
  
  protected void n(Entity entity) {
    if (((entity instanceof IMonster)) && (aI().nextInt(20) == 0)) {
      setGoalTarget((EntityLiving)entity);
    }
    
    super.n(entity);
  }
  
  public void e() {
    super.e();
    if (br > 0) {
      br -= 1;
    }
    
    if (bs > 0) {
      bs -= 1;
    }
    
    if ((motX * motX + motZ * motZ > 2.500000277905201E-007D) && (random.nextInt(5) == 0)) {
      int i = MathHelper.floor(locX);
      int j = MathHelper.floor(locY - 0.2000000029802322D - height);
      int k = MathHelper.floor(locZ);
      Block block = world.getType(i, j, k);
      
      if (block.getMaterial() != Material.AIR) {
        world.addParticle("blockcrack_" + Block.b(block) + "_" + world.getData(i, j, k), locX + (random.nextFloat() - 0.5D) * width, boundingBox.b + 0.1D, locZ + (random.nextFloat() - 0.5D) * width, 4.0D * (random.nextFloat() - 0.5D), 0.5D, (random.nextFloat() - 0.5D) * 4.0D);
      }
    }
  }
  
  public boolean a(Class oclass) {
    return (isPlayerCreated()) && (EntityHuman.class.isAssignableFrom(oclass)) ? false : super.a(oclass);
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    nbttagcompound.setBoolean("PlayerCreated", isPlayerCreated());
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    setPlayerCreated(nbttagcompound.getBoolean("PlayerCreated"));
  }
  
  public boolean m(Entity entity) {
    br = 10;
    world.broadcastEntityEffect(this, (byte)4);
    boolean flag = entity.damageEntity(DamageSource.mobAttack(this), 7 + random.nextInt(15));
    
    if (flag) {
      motY += 0.4000000059604645D;
    }
    
    makeSound("mob.irongolem.throw", 1.0F, 1.0F);
    return flag;
  }
  
  public Village bX() {
    return bp;
  }
  
  public void a(boolean flag) {
    bs = (flag ? 400 : 0);
    world.broadcastEntityEffect(this, (byte)11);
  }
  
  protected String aT() {
    return "mob.irongolem.hit";
  }
  
  protected String aU() {
    return "mob.irongolem.death";
  }
  
  protected void a(int i, int j, int k, Block block) {
    makeSound("mob.irongolem.walk", 1.0F, 1.0F);
  }
  
  protected void dropDeathLoot(boolean flag, int i)
  {
    java.util.List<org.bukkit.inventory.ItemStack> loot = new java.util.ArrayList();
    int j = random.nextInt(3);
    


    if (j > 0) {
      loot.add(org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack.asNewCraftStack(Item.getItemOf(Blocks.RED_ROSE), j));
    }
    
    int k = 3 + random.nextInt(3);
    
    if (k > 0) {
      loot.add(org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack.asNewCraftStack(Items.IRON_INGOT, k));
    }
    
    org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callEntityDeathEvent(this, loot);
  }
  
  public int bZ()
  {
    return bs;
  }
  
  public boolean isPlayerCreated() {
    return (datawatcher.getByte(16) & 0x1) != 0;
  }
  
  public void setPlayerCreated(boolean flag) {
    byte b0 = datawatcher.getByte(16);
    
    if (flag) {
      datawatcher.watch(16, Byte.valueOf((byte)(b0 | 0x1)));
    } else {
      datawatcher.watch(16, Byte.valueOf((byte)(b0 & 0xFFFFFFFE)));
    }
  }
  
  public void die(DamageSource damagesource) {
    if ((!isPlayerCreated()) && (killer != null) && (bp != null)) {
      bp.a(killer.getName(), -5);
    }
    
    super.die(damagesource);
  }
}
