package net.minecraft.server.v1_7_R1;

import java.util.Iterator;
import java.util.List;
import java.util.Random;
import org.apache.logging.log4j.Logger;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.event.player.PlayerPickupItemEvent;

public class EntityItem extends Entity
{
  private static final Logger d = ;
  public int age;
  public int pickupDelay;
  private int e;
  private String f;
  private String g;
  public float c;
  private int lastTick = MinecraftServer.currentTick;
  
  public EntityItem(World world, double d0, double d1, double d2) {
    super(world);
    e = 5;
    c = ((float)(Math.random() * 3.141592653589793D * 2.0D));
    a(0.25F, 0.25F);
    height = (length / 2.0F);
    setPosition(d0, d1, d2);
    yaw = ((float)(Math.random() * 360.0D));
    motX = ((float)(Math.random() * 0.2000000029802322D - 0.1000000014901161D));
    motY = 0.2000000029802322D;
    motZ = ((float)(Math.random() * 0.2000000029802322D - 0.1000000014901161D));
  }
  
  public EntityItem(World world, double d0, double d1, double d2, ItemStack itemstack) {
    this(world, d0, d1, d2);
    
    if ((itemstack == null) || (itemstack.getItem() == null)) {
      return;
    }
    
    setItemStack(itemstack);
  }
  
  protected boolean g_() {
    return false;
  }
  
  public EntityItem(World world) {
    super(world);
    e = 5;
    c = ((float)(Math.random() * 3.141592653589793D * 2.0D));
    a(0.25F, 0.25F);
    height = (length / 2.0F);
  }
  
  protected void c() {
    getDataWatcher().a(10, 5);
  }
  
  public void h() {
    if (getItemStack() == null) {
      die();
    } else {
      super.h();
      
      int elapsedTicks = MinecraftServer.currentTick - lastTick;
      pickupDelay -= elapsedTicks;
      age += elapsedTicks;
      lastTick = MinecraftServer.currentTick;
      

      lastX = locX;
      lastY = locY;
      lastZ = locZ;
      motY -= 0.03999999910593033D;
      Y = j(locX, (boundingBox.b + boundingBox.e) / 2.0D, locZ);
      move(motX, motY, motZ);
      boolean flag = ((int)lastX != (int)locX) || ((int)lastY != (int)locY) || ((int)lastZ != (int)locZ);
      
      if ((flag) || (ticksLived % 25 == 0)) {
        if (world.getType(MathHelper.floor(locX), MathHelper.floor(locY), MathHelper.floor(locZ)).getMaterial() == Material.LAVA) {
          motY = 0.2000000029802322D;
          motX = ((random.nextFloat() - random.nextFloat()) * 0.2F);
          motZ = ((random.nextFloat() - random.nextFloat()) * 0.2F);
          makeSound("random.fizz", 0.4F, 2.0F + random.nextFloat() * 0.4F);
        }
        
        if (!world.isStatic) {
          k();
        }
      }
      
      float f = 0.98F;
      
      if (onGround) {
        f = world.getType(MathHelper.floor(locX), MathHelper.floor(boundingBox.b) - 1, MathHelper.floor(locZ)).frictionFactor * 0.98F;
      }
      
      motX *= f;
      motY *= 0.9800000190734863D;
      motZ *= f;
      if (onGround) {
        motY *= -0.5D;
      }
      

      if ((!world.isStatic) && (age >= 6000))
      {
        if (org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callItemDespawnEvent(this).isCancelled()) {
          age = 0;
          return;
        }
        
        die();
      }
    }
  }
  
  private void k() {
    Iterator iterator = world.a(EntityItem.class, boundingBox.grow(0.5D, 0.0D, 0.5D)).iterator();
    
    while (iterator.hasNext()) {
      EntityItem entityitem = (EntityItem)iterator.next();
      
      a(entityitem);
    }
  }
  
  public boolean a(EntityItem entityitem) {
    if (entityitem == this)
      return false;
    if ((entityitem.isAlive()) && (isAlive())) {
      ItemStack itemstack = getItemStack();
      ItemStack itemstack1 = entityitem.getItemStack();
      
      if (itemstack1.getItem() != itemstack.getItem())
        return false;
      if ((itemstack1.hasTag() ^ itemstack.hasTag()))
        return false;
      if ((itemstack1.hasTag()) && (!itemstack1.getTag().equals(itemstack.getTag())))
        return false;
      if (itemstack1.getItem() == null)
        return false;
      if ((itemstack1.getItem().n()) && (itemstack1.getData() != itemstack.getData()))
        return false;
      if (count < count)
        return entityitem.a(this);
      if (count + count > itemstack1.getMaxStackSize()) {
        return false;
      }
      count += count;
      pickupDelay = Math.max(pickupDelay, pickupDelay);
      age = Math.min(age, age);
      entityitem.setItemStack(itemstack1);
      die();
      return true;
    }
    
    return false;
  }
  
  public void e()
  {
    age = 4800;
  }
  
  public boolean N() {
    return world.a(boundingBox, Material.WATER, this);
  }
  
  protected void burn(int i) {
    damageEntity(DamageSource.FIRE, i);
  }
  
  public boolean damageEntity(DamageSource damagesource, float f) {
    if (isInvulnerable())
      return false;
    if ((getItemStack() != null) && (getItemStack().getItem() == Items.NETHER_STAR) && (damagesource.c())) {
      return false;
    }
    Q();
    e = ((int)(e - f));
    if (e <= 0) {
      die();
    }
    
    return false;
  }
  
  public void b(NBTTagCompound nbttagcompound)
  {
    nbttagcompound.setShort("Health", (short)(byte)e);
    nbttagcompound.setShort("Age", (short)age);
    if (j() != null) {
      nbttagcompound.setString("Thrower", f);
    }
    
    if (i() != null) {
      nbttagcompound.setString("Owner", g);
    }
    
    if (getItemStack() != null) {
      nbttagcompound.set("Item", getItemStack().save(new NBTTagCompound()));
    }
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    e = (nbttagcompound.getShort("Health") & 0xFF);
    age = nbttagcompound.getShort("Age");
    if (nbttagcompound.hasKey("Owner")) {
      g = nbttagcompound.getString("Owner");
    }
    
    if (nbttagcompound.hasKey("Thrower")) {
      f = nbttagcompound.getString("Thrower");
    }
    
    NBTTagCompound nbttagcompound1 = nbttagcompound.getCompound("Item");
    

    if (nbttagcompound1 != null) {
      ItemStack itemstack = ItemStack.createStack(nbttagcompound1);
      if (itemstack != null) {
        setItemStack(itemstack);
      } else {
        die();
      }
    } else {
      die();
    }
    
    if (getItemStack() == null) {
      die();
    }
  }
  
  public void b_(EntityHuman entityhuman) {
    if (!world.isStatic) {
      ItemStack itemstack = getItemStack();
      int i = count;
      

      int canHold = inventory.canHold(itemstack);
      int remaining = count - canHold;
      
      if ((pickupDelay <= 0) && (canHold > 0)) {
        count = canHold;
        PlayerPickupItemEvent event = new PlayerPickupItemEvent((org.bukkit.entity.Player)entityhuman.getBukkitEntity(), (org.bukkit.entity.Item)getBukkitEntity(), remaining);
        
        world.getServer().getPluginManager().callEvent(event);
        count = (canHold + remaining);
        
        if (event.isCancelled()) {
          return;
        }
        

        pickupDelay = 0;
      }
      

      if ((pickupDelay == 0) && ((g == null) || (6000 - age <= 200) || (g.equals(entityhuman.getName()))) && (inventory.pickup(itemstack))) {
        if (itemstack.getItem() == Item.getItemOf(Blocks.LOG)) {
          entityhuman.a(AchievementList.g);
        }
        
        if (itemstack.getItem() == Item.getItemOf(Blocks.LOG2)) {
          entityhuman.a(AchievementList.g);
        }
        
        if (itemstack.getItem() == Items.LEATHER) {
          entityhuman.a(AchievementList.t);
        }
        
        if (itemstack.getItem() == Items.DIAMOND) {
          entityhuman.a(AchievementList.w);
        }
        
        if (itemstack.getItem() == Items.BLAZE_ROD) {
          entityhuman.a(AchievementList.A);
        }
        
        if ((itemstack.getItem() == Items.DIAMOND) && (j() != null)) {
          EntityHuman entityhuman1 = world.a(j());
          
          if ((entityhuman1 != null) && (entityhuman1 != entityhuman)) {
            entityhuman1.a(AchievementList.x);
          }
        }
        
        world.makeSound(entityhuman, "random.pop", 0.2F, ((random.nextFloat() - random.nextFloat()) * 0.7F + 1.0F) * 2.0F);
        entityhuman.receive(this, i);
        if (count <= 0) {
          die();
        }
      }
    }
  }
  
  public String getName() {
    return LocaleI18n.get("item." + getItemStack().a());
  }
  
  public boolean av() {
    return false;
  }
  
  public void b(int i) {
    super.b(i);
    if (!world.isStatic) {
      k();
    }
  }
  
  public ItemStack getItemStack() {
    ItemStack itemstack = getDataWatcher().getItemStack(10);
    
    if (itemstack == null) {
      if (world != null) {
        d.error("Item entity " + getId() + " has no item?!");
      }
      
      return new ItemStack(Blocks.STONE);
    }
    return itemstack;
  }
  
  public void setItemStack(ItemStack itemstack)
  {
    getDataWatcher().watch(10, itemstack);
    getDataWatcher().h(10);
  }
  
  public String i() {
    return g;
  }
  
  public void a(String s) {
    g = s;
  }
  
  public String j() {
    return f;
  }
  
  public void b(String s) {
    f = s;
  }
}
