package net.minecraft.server.v1_7_R1;

import java.util.List;
import java.util.Random;
import org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory;
import org.bukkit.event.block.BlockIgniteEvent;

public class EntityLightning
  extends EntityWeather
{
  private int lifeTicks;
  public long a;
  private int c;
  public boolean isEffect = false;
  
  public EntityLightning(World world, double d0, double d1, double d2) {
    this(world, d0, d1, d2, false);
  }
  

  public EntityLightning(World world, double d0, double d1, double d2, boolean isEffect)
  {
    super(world);
    

    this.isEffect = isEffect;
    

    setPositionRotation(d0, d1, d2, 0.0F, 0.0F);
    lifeTicks = 2;
    a = random.nextLong();
    c = (random.nextInt(3) + 1);
    

    if ((!isEffect) && (!isStatic) && (world.getGameRules().getBoolean("doFireTick")) && ((difficulty == EnumDifficulty.NORMAL) || (difficulty == EnumDifficulty.HARD)) && (world.areChunksLoaded(MathHelper.floor(d0), MathHelper.floor(d1), MathHelper.floor(d2), 10))) {
      int i = MathHelper.floor(d0);
      int j = MathHelper.floor(d1);
      int k = MathHelper.floor(d2);
      
      if ((world.getType(i, j, k).getMaterial() == Material.AIR) && (Blocks.FIRE.canPlace(world, i, j, k)))
      {
        if (!CraftEventFactory.callBlockIgniteEvent(world, i, j, k, this).isCancelled()) {
          world.setTypeUpdate(i, j, k, Blocks.FIRE);
        }
      }
      

      for (i = 0; i < 4; i++) {
        j = MathHelper.floor(d0) + random.nextInt(3) - 1;
        k = MathHelper.floor(d1) + random.nextInt(3) - 1;
        int l = MathHelper.floor(d2) + random.nextInt(3) - 1;
        
        if ((world.getType(j, k, l).getMaterial() == Material.AIR) && (Blocks.FIRE.canPlace(world, j, k, l)))
        {
          if (!CraftEventFactory.callBlockIgniteEvent(world, j, k, l, this).isCancelled()) {
            world.setTypeUpdate(j, k, l, Blocks.FIRE);
          }
        }
      }
    }
  }
  
  public void h()
  {
    super.h();
    if (lifeTicks == 2) {
      world.makeSound(locX, locY, locZ, "ambient.weather.thunder", 10000.0F, 0.8F + random.nextFloat() * 0.2F);
      world.makeSound(locX, locY, locZ, "random.explode", 2.0F, 0.5F + random.nextFloat() * 0.2F);
    }
    
    lifeTicks -= 1;
    if (lifeTicks < 0) {
      if (c == 0) {
        die();
      } else if (lifeTicks < -random.nextInt(10)) {
        c -= 1;
        lifeTicks = 1;
        a = random.nextLong();
        
        if ((!isEffect) && (!world.isStatic) && (world.getGameRules().getBoolean("doFireTick")) && (world.areChunksLoaded(MathHelper.floor(locX), MathHelper.floor(locY), MathHelper.floor(locZ), 10))) {
          int i = MathHelper.floor(locX);
          int j = MathHelper.floor(locY);
          int k = MathHelper.floor(locZ);
          
          if ((world.getType(i, j, k).getMaterial() == Material.AIR) && (Blocks.FIRE.canPlace(world, i, j, k)))
          {
            if (!CraftEventFactory.callBlockIgniteEvent(world, i, j, k, this).isCancelled()) {
              world.setTypeUpdate(i, j, k, Blocks.FIRE);
            }
          }
        }
      }
    }
    

    if ((lifeTicks >= 0) && (!isEffect)) {
      if (world.isStatic) {
        world.q = 2;
      } else {
        double d0 = 3.0D;
        List list = world.getEntities(this, AxisAlignedBB.a().a(locX - d0, locY - d0, locZ - d0, locX + d0, locY + 6.0D + d0, locZ + d0));
        
        for (int l = 0; l < list.size(); l++) {
          Entity entity = (Entity)list.get(l);
          
          entity.a(this);
        }
      }
    }
  }
  
  protected void c() {}
  
  protected void a(NBTTagCompound nbttagcompound) {}
  
  protected void b(NBTTagCompound nbttagcompound) {}
}
