package net.minecraft.server.v1_7_R1;

import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Random;
import java.util.Set;
import java.util.UUID;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftPlayer;
import org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.EntityRegainHealthEvent;
import org.bukkit.event.entity.EntityRegainHealthEvent.RegainReason;

public abstract class EntityLiving extends Entity
{
  private static final UUID b = UUID.fromString("662A6B8D-DA3E-4C1C-8813-96EA6097278D");
  private static final AttributeModifier c = new AttributeModifier(b, "Sprinting speed boost", 0.300000011920929D, 2).a(false);
  private AttributeMapBase d;
  public CombatTracker combatTracker = new CombatTracker(this);
  public final HashMap effects = new HashMap();
  private final ItemStack[] g = new ItemStack[5];
  public boolean au;
  public int av;
  public int aw;
  public float ax;
  public int hurtTicks;
  public int az;
  public float aA;
  public int deathTicks;
  public int attackTicks;
  public float aD;
  public float aE;
  public float aF;
  public float aG;
  public float aH;
  public int maxNoDamageTicks = 20;
  public float aJ;
  public float aK;
  public float aL;
  public float aM;
  public float aN;
  public float aO;
  public float aP;
  public float aQ;
  public float aR = 0.02F;
  public EntityHuman killer;
  protected int lastDamageByPlayerTime;
  protected boolean aU;
  protected int aV;
  protected float aW;
  protected float aX;
  protected float aY;
  protected float aZ;
  protected float ba;
  protected int bb;
  public float lastDamage;
  protected boolean bd;
  public float be;
  public float bf;
  protected float bg;
  protected int bh;
  protected double bi;
  protected double bj;
  protected double bk;
  protected double bl;
  protected double bm;
  public boolean updateEffects = true;
  
  public EntityLiving lastDamager;
  private int j;
  private EntityLiving bn;
  private int bo;
  private float bp;
  private int bq;
  private float br;
  public int expToDrop;
  public int maxAirTicks = 300;
  
  public EntityLiving(World world)
  {
    super(world);
    aD();
    
    datawatcher.watch(6, Float.valueOf((float)getAttributeInstance(GenericAttributes.a).getValue()));
    l = true;
    aM = ((float)(Math.random() + 1.0D) * 0.01F);
    setPosition(locX, locY, locZ);
    aL = ((float)Math.random() * 12398.0F);
    yaw = ((float)(Math.random() * 3.141592741012573D * 2.0D));
    aP = yaw;
    X = 0.5F;
  }
  
  protected void c() {
    datawatcher.a(7, Integer.valueOf(0));
    datawatcher.a(8, Byte.valueOf((byte)0));
    datawatcher.a(9, Byte.valueOf((byte)0));
    datawatcher.a(6, Float.valueOf(1.0F));
  }
  
  protected void aD() {
    bc().b(GenericAttributes.a);
    bc().b(GenericAttributes.c);
    bc().b(GenericAttributes.d);
    if (!bk()) {
      getAttributeInstance(GenericAttributes.d).setValue(0.1000000014901161D);
    }
  }
  
  protected void a(double d0, boolean flag) {
    if (!M()) {
      N();
    }
    
    if ((flag) && (fallDistance > 0.0F)) {
      int i = MathHelper.floor(locX);
      int j = MathHelper.floor(locY - 0.2000000029802322D - height);
      int k = MathHelper.floor(locZ);
      Block block = world.getType(i, j, k);
      
      if (block.getMaterial() == Material.AIR) {
        int l = world.getType(i, j - 1, k).b();
        
        if ((l == 11) || (l == 32) || (l == 21)) {
          block = world.getType(i, j - 1, k);
        }
      } else if ((!world.isStatic) && (fallDistance > 3.0F))
      {
        if ((this instanceof EntityPlayer)) {
          world.a((EntityHuman)this, 2006, i, j, k, MathHelper.f(fallDistance - 3.0F));
          playerConnection.sendPacket(new PacketPlayOutWorldEvent(2006, i, j, k, MathHelper.f(fallDistance - 3.0F), false));
        } else {
          world.triggerEffect(2006, i, j, k, MathHelper.f(fallDistance - 3.0F));
        }
      }
      

      block.a(world, i, j, k, this, fallDistance);
    }
    
    super.a(d0, flag);
  }
  
  public boolean aE() {
    return false;
  }
  
  public void C() {
    aD = aE;
    super.C();
    world.methodProfiler.a("livingEntityBaseTick");
    if ((isAlive()) && (inBlock())) {
      damageEntity(DamageSource.STUCK, 1.0F);
    }
    
    if ((isFireproof()) || (world.isStatic)) {
      extinguish();
    }
    
    boolean flag = ((this instanceof EntityHuman)) && (abilities.isInvulnerable);
    
    if ((isAlive()) && (a(Material.WATER))) {
      if ((!aE()) && (!hasEffect(WATER_BREATHINGid)) && (!flag)) {
        setAirTicks(j(getAirTicks()));
        if (getAirTicks() == -20) {
          setAirTicks(0);
          
          for (int i = 0; i < 8; i++) {
            float f = random.nextFloat() - random.nextFloat();
            float f1 = random.nextFloat() - random.nextFloat();
            float f2 = random.nextFloat() - random.nextFloat();
            
            world.addParticle("bubble", locX + f, locY + f1, locZ + f2, motX, motY, motZ);
          }
          
          damageEntity(DamageSource.DROWN, 2.0F);
        }
      }
      
      if ((!world.isStatic) && (am()) && ((vehicle instanceof EntityLiving))) {
        mount((Entity)null);
      }
      
    }
    else if (getAirTicks() != 300) {
      setAirTicks(maxAirTicks);
    }
    


    if ((isAlive()) && (L())) {
      extinguish();
    }
    
    aJ = aK;
    if (attackTicks > 0) {
      attackTicks -= 1;
    }
    
    if (hurtTicks > 0) {
      hurtTicks -= 1;
    }
    
    if ((noDamageTicks > 0) && (!(this instanceof EntityPlayer))) {
      noDamageTicks -= 1;
    }
    
    if (getHealth() <= 0.0F) {
      aF();
    }
    
    if (lastDamageByPlayerTime > 0) {
      lastDamageByPlayerTime -= 1;
    } else {
      killer = null;
    }
    
    if ((bn != null) && (!bn.isAlive())) {
      bn = null;
    }
    
    if (lastDamager != null) {
      if (!lastDamager.isAlive()) {
        b((EntityLiving)null);
      } else if (ticksLived - j > 100) {
        b((EntityLiving)null);
      }
    }
    
    removeAllEffects();
    aZ = aY;
    aO = aN;
    aQ = aP;
    lastYaw = yaw;
    lastPitch = pitch;
    world.methodProfiler.b();
  }
  
  public int getExpReward()
  {
    int exp = getExpValue(killer);
    
    if ((!world.isStatic) && ((lastDamageByPlayerTime > 0) || (alwaysGivesExp())) && (aG())) {
      return exp;
    }
    return 0;
  }
  

  public boolean isBaby()
  {
    return false;
  }
  
  protected void aF() {
    deathTicks += 1;
    if ((deathTicks >= 20) && (!dead))
    {


      int i = expToDrop;
      while (i > 0) {
        int j = EntityExperienceOrb.getOrbValue(i);
        
        i -= j;
        world.addEntity(new EntityExperienceOrb(world, locX, locY, locZ, j));
      }
      expToDrop = 0;
      

      die();
      
      for (i = 0; i < 20; i++) {
        double d0 = random.nextGaussian() * 0.02D;
        double d1 = random.nextGaussian() * 0.02D;
        double d2 = random.nextGaussian() * 0.02D;
        
        world.addParticle("explode", locX + random.nextFloat() * width * 2.0F - width, locY + random.nextFloat() * length, locZ + random.nextFloat() * width * 2.0F - width, d0, d1, d2);
      }
    }
  }
  
  protected boolean aG() {
    return !isBaby();
  }
  
  protected int j(int i) {
    int j = EnchantmentManager.getOxygenEnchantmentLevel(this);
    
    return (j > 0) && (random.nextInt(j + 1) > 0) ? i : i - 1;
  }
  
  protected int getExpValue(EntityHuman entityhuman) {
    return 0;
  }
  
  protected boolean alwaysGivesExp() {
    return false;
  }
  
  public Random aI() {
    return random;
  }
  
  public EntityLiving getLastDamager() {
    return lastDamager;
  }
  
  public int aK() {
    return j;
  }
  
  public void b(EntityLiving entityliving) {
    lastDamager = entityliving;
    j = ticksLived;
  }
  
  public EntityLiving aL() {
    return bn;
  }
  
  public int aM() {
    return bo;
  }
  
  public void k(Entity entity) {
    if ((entity instanceof EntityLiving)) {
      bn = ((EntityLiving)entity);
    } else {
      bn = null;
    }
    
    bo = ticksLived;
  }
  
  public int aN() {
    return aV;
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    nbttagcompound.setFloat("HealF", getHealth());
    nbttagcompound.setShort("Health", (short)(int)Math.ceil(getHealth()));
    nbttagcompound.setShort("HurtTime", (short)hurtTicks);
    nbttagcompound.setShort("DeathTime", (short)deathTicks);
    nbttagcompound.setShort("AttackTime", (short)attackTicks);
    nbttagcompound.setFloat("AbsorptionAmount", bs());
    ItemStack[] aitemstack = getEquipment();
    int i = aitemstack.length;
    



    for (int j = 0; j < i; j++) {
      ItemStack itemstack = aitemstack[j];
      if (itemstack != null) {
        d.a(itemstack.D());
      }
    }
    
    nbttagcompound.set("Attributes", GenericAttributes.a(bc()));
    aitemstack = getEquipment();
    i = aitemstack.length;
    
    for (j = 0; j < i; j++) {
      ItemStack itemstack = aitemstack[j];
      if (itemstack != null) {
        d.b(itemstack.D());
      }
    }
    
    if (!effects.isEmpty()) {
      NBTTagList nbttaglist = new NBTTagList();
      Iterator iterator = effects.values().iterator();
      
      while (iterator.hasNext()) {
        MobEffect mobeffect = (MobEffect)iterator.next();
        
        nbttaglist.add(mobeffect.a(new NBTTagCompound()));
      }
      
      nbttagcompound.set("ActiveEffects", nbttaglist);
    }
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    m(nbttagcompound.getFloat("AbsorptionAmount"));
    if ((nbttagcompound.hasKeyOfType("Attributes", 9)) && (world != null) && (!world.isStatic)) {
      GenericAttributes.a(bc(), nbttagcompound.getList("Attributes", 10));
    }
    
    if (nbttagcompound.hasKeyOfType("ActiveEffects", 9)) {
      NBTTagList nbttaglist = nbttagcompound.getList("ActiveEffects", 10);
      
      for (int i = 0; i < nbttaglist.size(); i++) {
        NBTTagCompound nbttagcompound1 = nbttaglist.get(i);
        MobEffect mobeffect = MobEffect.b(nbttagcompound1);
        
        if (mobeffect != null) {
          effects.put(Integer.valueOf(mobeffect.getEffectId()), mobeffect);
        }
      }
    }
    

    if (nbttagcompound.hasKey("Bukkit.MaxHealth")) {
      NBTBase nbtbase = nbttagcompound.get("Bukkit.MaxHealth");
      if (nbtbase.getTypeId() == 5) {
        getAttributeInstance(GenericAttributes.a).setValue(((NBTTagFloat)nbtbase).c());
      } else if (nbtbase.getTypeId() == 3) {
        getAttributeInstance(GenericAttributes.a).setValue(((NBTTagInt)nbtbase).d());
      }
    }
    

    if (nbttagcompound.hasKeyOfType("HealF", 99)) {
      setHealth(nbttagcompound.getFloat("HealF"));
    } else {
      NBTBase nbtbase = nbttagcompound.get("Health");
      
      if (nbtbase == null) {
        setHealth(getMaxHealth());
      } else if (nbtbase.getTypeId() == 5) {
        setHealth(((NBTTagFloat)nbtbase).h());
      } else if (nbtbase.getTypeId() == 2) {
        setHealth(((NBTTagShort)nbtbase).e());
      }
    }
    
    hurtTicks = nbttagcompound.getShort("HurtTime");
    deathTicks = nbttagcompound.getShort("DeathTime");
    attackTicks = nbttagcompound.getShort("AttackTime");
  }
  
  protected void removeAllEffects() {
    Iterator iterator = effects.keySet().iterator();
    
    while (iterator.hasNext()) {
      Integer integer = (Integer)iterator.next();
      MobEffect mobeffect = (MobEffect)effects.get(integer);
      
      if (!mobeffect.tick(this)) {
        if (!world.isStatic) {
          iterator.remove();
          b(mobeffect);
        }
      } else if (mobeffect.getDuration() % 600 == 0) {
        a(mobeffect, false);
      }
    }
    


    if (updateEffects) {
      if (!world.isStatic) {
        if (effects.isEmpty()) {
          datawatcher.watch(8, Byte.valueOf((byte)0));
          datawatcher.watch(7, Integer.valueOf(0));
          setInvisible(false);
        } else {
          int i = PotionBrewer.a(effects.values());
          datawatcher.watch(8, Byte.valueOf((byte)(PotionBrewer.b(effects.values()) ? 1 : 0)));
          datawatcher.watch(7, Integer.valueOf(i));
          setInvisible(hasEffect(INVISIBILITYid));
        }
      }
      
      updateEffects = false;
    }
    
    int i = datawatcher.getInt(7);
    boolean flag = datawatcher.getByte(8) > 0;
    
    if (i > 0) {
      boolean flag1 = false;
      
      if (!isInvisible()) {
        flag1 = random.nextBoolean();
      } else {
        flag1 = random.nextInt(15) == 0;
      }
      
      if (flag) {
        flag1 &= random.nextInt(5) == 0;
      }
      
      if ((flag1) && (i > 0)) {
        double d0 = (i >> 16 & 0xFF) / 255.0D;
        double d1 = (i >> 8 & 0xFF) / 255.0D;
        double d2 = (i >> 0 & 0xFF) / 255.0D;
        
        world.addParticle(flag ? "mobSpellAmbient" : "mobSpell", locX + (random.nextDouble() - 0.5D) * width, locY + random.nextDouble() * length - height, locZ + (random.nextDouble() - 0.5D) * width, d0, d1, d2);
      }
    }
  }
  
  public void aP() {
    Iterator iterator = effects.keySet().iterator();
    
    while (iterator.hasNext()) {
      Integer integer = (Integer)iterator.next();
      MobEffect mobeffect = (MobEffect)effects.get(integer);
      
      if (!world.isStatic) {
        iterator.remove();
        b(mobeffect);
      }
    }
  }
  
  public Collection getEffects() {
    return effects.values();
  }
  
  public boolean hasEffect(int i)
  {
    return (effects.size() != 0) && (effects.containsKey(Integer.valueOf(i)));
  }
  
  public boolean hasEffect(MobEffectList mobeffectlist)
  {
    return (effects.size() != 0) && (effects.containsKey(Integer.valueOf(id)));
  }
  
  public MobEffect getEffect(MobEffectList mobeffectlist) {
    return (MobEffect)effects.get(Integer.valueOf(id));
  }
  
  public void addEffect(MobEffect mobeffect) {
    if (d(mobeffect)) {
      if (effects.containsKey(Integer.valueOf(mobeffect.getEffectId()))) {
        ((MobEffect)effects.get(Integer.valueOf(mobeffect.getEffectId()))).a(mobeffect);
        a((MobEffect)effects.get(Integer.valueOf(mobeffect.getEffectId())), true);
      } else {
        effects.put(Integer.valueOf(mobeffect.getEffectId()), mobeffect);
        a(mobeffect);
      }
    }
  }
  
  public boolean d(MobEffect mobeffect) {
    if (getMonsterType() == EnumMonsterType.UNDEAD) {
      int i = mobeffect.getEffectId();
      
      if ((i == REGENERATIONid) || (i == POISONid)) {
        return false;
      }
    }
    
    return true;
  }
  
  public boolean aR() {
    return getMonsterType() == EnumMonsterType.UNDEAD;
  }
  
  public void m(int i) {
    MobEffect mobeffect = (MobEffect)effects.remove(Integer.valueOf(i));
    
    if (mobeffect != null) {
      b(mobeffect);
    }
  }
  
  protected void a(MobEffect mobeffect) {
    updateEffects = true;
    if (!world.isStatic) {
      MobEffectList.byId[mobeffect.getEffectId()].b(this, bc(), mobeffect.getAmplifier());
    }
  }
  
  protected void a(MobEffect mobeffect, boolean flag) {
    updateEffects = true;
    if ((flag) && (!world.isStatic)) {
      MobEffectList.byId[mobeffect.getEffectId()].a(this, bc(), mobeffect.getAmplifier());
      MobEffectList.byId[mobeffect.getEffectId()].b(this, bc(), mobeffect.getAmplifier());
    }
  }
  
  protected void b(MobEffect mobeffect) {
    updateEffects = true;
    if (!world.isStatic) {
      MobEffectList.byId[mobeffect.getEffectId()].a(this, bc(), mobeffect.getAmplifier());
    }
  }
  
  public void heal(float f)
  {
    heal(f, EntityRegainHealthEvent.RegainReason.CUSTOM);
  }
  
  public void heal(float f, EntityRegainHealthEvent.RegainReason regainReason) {
    float f1 = getHealth();
    
    if (f1 > 0.0F) {
      EntityRegainHealthEvent event = new EntityRegainHealthEvent(getBukkitEntity(), f, regainReason);
      world.getServer().getPluginManager().callEvent(event);
      
      if (!event.isCancelled()) {
        setHealth((float)(getHealth() + event.getAmount()));
      }
    }
  }
  
  public final float getHealth()
  {
    if ((this instanceof EntityPlayer)) {
      return (float)((EntityPlayer)this).getBukkitEntity().getHealth();
    }
    
    return datawatcher.getFloat(6);
  }
  
  public void setHealth(float f)
  {
    if ((this instanceof EntityPlayer)) {
      CraftPlayer player = ((EntityPlayer)this).getBukkitEntity();
      
      if (f < 0.0F) {
        player.setRealHealth(0.0D);
      } else if (f > player.getMaxHealth()) {
        player.setRealHealth(player.getMaxHealth());
      } else {
        player.setRealHealth(f);
      }
      
      datawatcher.watch(6, Float.valueOf(player.getScaledHealth()));
      return;
    }
    
    datawatcher.watch(6, Float.valueOf(MathHelper.a(f, 0.0F, getMaxHealth())));
  }
  
  public boolean damageEntity(DamageSource damagesource, float f) {
    if (isInvulnerable())
      return false;
    if (world.isStatic) {
      return false;
    }
    aV = 0;
    if (getHealth() <= 0.0F)
      return false;
    if ((damagesource.o()) && (hasEffect(MobEffectList.FIRE_RESISTANCE))) {
      return false;
    }
    if (((damagesource == DamageSource.ANVIL) || (damagesource == DamageSource.FALLING_BLOCK)) && (getEquipment(4) != null)) {
      getEquipment(4).damage((int)(f * 4.0F + random.nextFloat() * f * 2.0F), this);
      f *= 0.75F;
    }
    
    aG = 1.5F;
    boolean flag = true;
    

    EntityDamageEvent event = CraftEventFactory.handleEntityDamageEvent(this, damagesource, f);
    if (event != null) {
      if (event.isCancelled()) {
        return false;
      }
      f = (float)event.getDamage();
    }
    

    if (noDamageTicks > maxNoDamageTicks / 2.0F) {
      if (f <= lastDamage) {
        return false;
      }
      
      d(damagesource, f - lastDamage);
      lastDamage = f;
      flag = false;
    } else {
      lastDamage = f;
      ax = getHealth();
      noDamageTicks = maxNoDamageTicks;
      d(damagesource, f);
      hurtTicks = (this.az = 10);
    }
    
    aA = 0.0F;
    Entity entity = damagesource.getEntity();
    
    if (entity != null) {
      if ((entity instanceof EntityLiving)) {
        b((EntityLiving)entity);
      }
      
      if ((entity instanceof EntityHuman)) {
        lastDamageByPlayerTime = 100;
        killer = ((EntityHuman)entity);
      } else if ((entity instanceof EntityWolf)) {
        EntityWolf entitywolf = (EntityWolf)entity;
        
        if (entitywolf.isTamed()) {
          lastDamageByPlayerTime = 100;
          killer = null;
        }
      }
    }
    
    if (flag) {
      world.broadcastEntityEffect(this, (byte)2);
      if (damagesource != DamageSource.DROWN) {
        Q();
      }
      
      if (entity != null) {
        double d0 = locX - locX;
        


        for (double d1 = locZ - locZ; d0 * d0 + d1 * d1 < 0.0001D; d1 = (Math.random() - Math.random()) * 0.01D) {
          d0 = (Math.random() - Math.random()) * 0.01D;
        }
        
        aA = ((float)(Math.atan2(d1, d0) * 180.0D / 3.141592741012573D) - yaw);
        a(entity, f, d0, d1);
      } else {
        aA = ((int)(Math.random() * 2.0D) * 180);
      }
    }
    


    if (getHealth() <= 0.0F) {
      String s = aU();
      if ((flag) && (s != null)) {
        makeSound(s, bf(), bg());
      }
      
      die(damagesource);
    } else {
      String s = aT();
      if ((flag) && (s != null)) {
        makeSound(s, bf(), bg());
      }
    }
    
    return true;
  }
  

  public void a(ItemStack itemstack)
  {
    makeSound("random.break", 0.8F, 0.8F + world.random.nextFloat() * 0.4F);
    
    for (int i = 0; i < 5; i++) {
      Vec3D vec3d = world.getVec3DPool().create((random.nextFloat() - 0.5D) * 0.1D, Math.random() * 0.1D + 0.1D, 0.0D);
      
      vec3d.a(-pitch * 3.141593F / 180.0F);
      vec3d.b(-yaw * 3.141593F / 180.0F);
      Vec3D vec3d1 = world.getVec3DPool().create((random.nextFloat() - 0.5D) * 0.3D, -random.nextFloat() * 0.6D - 0.3D, 0.6D);
      
      vec3d1.a(-pitch * 3.141593F / 180.0F);
      vec3d1.b(-yaw * 3.141593F / 180.0F);
      vec3d1 = vec3d1.add(locX, locY + getHeadHeight(), locZ);
      world.addParticle("iconcrack_" + Item.b(itemstack.getItem()), c, d, e, c, d + 0.05D, e);
    }
  }
  
  public void die(DamageSource damagesource) {
    Entity entity = damagesource.getEntity();
    EntityLiving entityliving = aX();
    
    if ((bb >= 0) && (entityliving != null)) {
      entityliving.b(this, bb);
    }
    
    if (entity != null) {
      entity.a(this);
    }
    
    aU = true;
    if (!world.isStatic) {
      int i = 0;
      
      if ((entity instanceof EntityHuman)) {
        i = EnchantmentManager.getBonusMonsterLootEnchantmentLevel((EntityLiving)entity);
      }
      
      if ((aG()) && (world.getGameRules().getBoolean("doMobLoot"))) {
        dropDeathLoot(lastDamageByPlayerTime > 0, i);
        dropEquipment(lastDamageByPlayerTime > 0, i);



      }
      else
      {


        CraftEventFactory.callEntityDeathEvent(this);
      }
    }
    
    world.broadcastEntityEffect(this, (byte)3);
  }
  
  protected void dropEquipment(boolean flag, int i) {}
  
  public void a(Entity entity, float f, double d0, double d1) {
    if (random.nextDouble() >= getAttributeInstance(GenericAttributes.c).getValue()) {
      am = true;
      float f1 = MathHelper.sqrt(d0 * d0 + d1 * d1);
      float f2 = 0.4F;
      
      motX /= 2.0D;
      motY /= 2.0D;
      motZ /= 2.0D;
      motX -= d0 / f1 * f2;
      motY += f2;
      motZ -= d1 / f1 * f2;
      if (motY > 0.4000000059604645D) {
        motY = 0.4000000059604645D;
      }
    }
  }
  
  protected String aT() {
    return "game.neutral.hurt";
  }
  
  protected String aU() {
    return "game.neutral.die";
  }
  
  protected ItemStack getRareDrop(int i)
  {
    return null;
  }
  
  protected void dropDeathLoot(boolean flag, int i) {}
  
  public boolean h_()
  {
    int i = MathHelper.floor(locX);
    int j = MathHelper.floor(boundingBox.b);
    int k = MathHelper.floor(locZ);
    Block block = world.getType(i, j, k);
    
    return (block == Blocks.LADDER) || (block == Blocks.VINE);
  }
  
  public boolean isAlive() {
    return (!dead) && (getHealth() > 0.0F);
  }
  
  protected void b(float f) {
    super.b(f);
    MobEffect mobeffect = getEffect(MobEffectList.JUMP);
    float f1 = mobeffect != null ? mobeffect.getAmplifier() + 1 : 0.0F;
    
    float i = MathHelper.f(f - 3.0F - f1);
    
    if (i > 0.0F) {
      EntityDamageEvent event = CraftEventFactory.callEntityDamageEvent(null, this, org.bukkit.event.entity.EntityDamageEvent.DamageCause.FALL, i);
      if (event.isCancelled()) {
        return;
      }
      
      i = (float)event.getDamage();
      if (i > 0.0F) {
        getBukkitEntity().setLastDamageCause(event);
      }
    }
    

    if (i > 0.0F) {
      makeSound(o(org.bukkit.util.NumberConversions.ceil(i)), 1.0F, 1.0F);
      damageEntity(DamageSource.FALL, i);
      int j = MathHelper.floor(locX);
      int k = MathHelper.floor(locY - 0.2000000029802322D - height);
      int l = MathHelper.floor(locZ);
      Block block = world.getType(j, k, l);
      
      if (block.getMaterial() != Material.AIR) {
        StepSound stepsound = stepSound;
        
        makeSound(stepsound.getStepSound(), stepsound.getVolume1() * 0.5F, stepsound.getVolume2() * 0.75F);
      }
    }
  }
  
  protected String o(int i) {
    return i > 4 ? "game.neutral.hurt.fall.big" : "game.neutral.hurt.fall.small";
  }
  
  public int aV() {
    int i = 0;
    ItemStack[] aitemstack = getEquipment();
    int j = aitemstack.length;
    
    for (int k = 0; k < j; k++) {
      ItemStack itemstack = aitemstack[k];
      
      if ((itemstack != null) && ((itemstack.getItem() instanceof ItemArmor))) {
        int l = getItem()c;
        
        i += l;
      }
    }
    
    return i;
  }
  
  protected void h(float f) {}
  
  protected float b(DamageSource damagesource, float f) {
    if (!damagesource.ignoresArmor()) {
      int i = 25 - aV();
      float f1 = f * i;
      
      h(f);
      f = f1 / 25.0F;
    }
    
    return f;
  }
  
  protected float c(DamageSource damagesource, float f) {
    if (damagesource.h()) {
      return f;
    }
    if ((this instanceof EntityZombie)) {
      f = f;
    }
    




    if ((hasEffect(MobEffectList.RESISTANCE)) && (damagesource != DamageSource.OUT_OF_WORLD)) {
      int i = (getEffect(MobEffectList.RESISTANCE).getAmplifier() + 1) * 5;
      int j = 25 - i;
      float f1 = f * j;
      f = f1 / 25.0F;
    }
    
    if (f <= 0.0F) {
      return 0.0F;
    }
    int i = EnchantmentManager.a(getEquipment(), damagesource);
    if (i > 20) {
      i = 20;
    }
    
    if ((i > 0) && (i <= 20)) {
      int j = 25 - i;
      float f1 = f * j;
      f = f1 / 25.0F;
    }
    
    return f;
  }
  

  protected void d(DamageSource damagesource, float f)
  {
    if (!isInvulnerable()) {
      f = b(damagesource, f);
      f = c(damagesource, f);
      float f1 = f;
      
      f = Math.max(f - bs(), 0.0F);
      m(bs() - (f1 - f));
      if (f != 0.0F) {
        float f2 = getHealth();
        
        setHealth(f2 - f);
        aW().a(damagesource, f2, f);
        m(bs() - f);
      }
    }
  }
  
  public CombatTracker aW() {
    return combatTracker;
  }
  
  public EntityLiving aX() {
    return lastDamager != null ? lastDamager : killer != null ? killer : combatTracker.c() != null ? combatTracker.c() : null;
  }
  
  public final float getMaxHealth() {
    return (float)getAttributeInstance(GenericAttributes.a).getValue();
  }
  
  public final int aZ() {
    return datawatcher.getByte(9);
  }
  
  public final void p(int i) {
    datawatcher.watch(9, Byte.valueOf((byte)i));
  }
  
  private int j() {
    return hasEffect(MobEffectList.SLOWER_DIG) ? 6 + (1 + getEffect(MobEffectList.SLOWER_DIG).getAmplifier()) * 2 : hasEffect(MobEffectList.FASTER_DIG) ? 6 - (1 + getEffect(MobEffectList.FASTER_DIG).getAmplifier()) * 1 : 6;
  }
  
  public void ba() {
    if ((!au) || (av >= j() / 2) || (av < 0)) {
      av = -1;
      au = true;
      if ((world instanceof WorldServer)) {
        ((WorldServer)world).getTracker().a(this, new PacketPlayOutAnimation(this, 0));
      }
    }
  }
  
  protected void G() {
    damageEntity(DamageSource.OUT_OF_WORLD, 4.0F);
  }
  
  protected void bb() {
    int i = j();
    
    if (au) {
      av += 1;
      if (av >= i) {
        av = 0;
        au = false;
      }
    } else {
      av = 0;
    }
    
    aE = (av / i);
  }
  
  public AttributeInstance getAttributeInstance(IAttribute iattribute) {
    return bc().a(iattribute);
  }
  
  public AttributeMapBase bc() {
    if (d == null) {
      d = new AttributeMapServer();
    }
    
    return d;
  }
  
  public EnumMonsterType getMonsterType() {
    return EnumMonsterType.UNDEFINED;
  }
  
  public abstract ItemStack be();
  
  public abstract ItemStack getEquipment(int paramInt);
  
  public abstract void setEquipment(int paramInt, ItemStack paramItemStack);
  
  public void setSprinting(boolean flag) {
    super.setSprinting(flag);
    AttributeInstance attributeinstance = getAttributeInstance(GenericAttributes.d);
    
    if (attributeinstance.a(b) != null) {
      attributeinstance.b(c);
    }
    
    if (flag) {
      attributeinstance.a(c);
    }
  }
  
  public abstract ItemStack[] getEquipment();
  
  protected float bf() {
    return 1.0F;
  }
  
  protected float bg() {
    return isBaby() ? (random.nextFloat() - random.nextFloat()) * 0.2F + 1.5F : (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F;
  }
  
  protected boolean bh() {
    return getHealth() <= 0.0F;
  }
  
  public void enderTeleportTo(double d0, double d1, double d2) {
    setPositionRotation(d0, d1, d2, yaw, pitch);
  }
  
  public void l(Entity entity) {
    double d0 = locX;
    double d1 = boundingBox.b + length;
    double d2 = locZ;
    byte b0 = 3;
    
    for (int i = -b0; i <= b0; i++) {
      for (int j = -b0; j < b0; j++) {
        if ((i != 0) || (j != 0)) {
          int k = (int)(locX + i);
          int l = (int)(locZ + j);
          AxisAlignedBB axisalignedbb = boundingBox.c(i, 1.0D, j);
          
          if (world.a(axisalignedbb).isEmpty()) {
            if (World.a(world, k, (int)locY, l)) {
              enderTeleportTo(locX + i, locY + 1.0D, locZ + j);
              return;
            }
            
            if ((World.a(world, k, (int)locY - 1, l)) || (world.getType(k, (int)locY - 1, l).getMaterial() == Material.WATER)) {
              d0 = locX + i;
              d1 = locY + 1.0D;
              d2 = locZ + j;
            }
          }
        }
      }
    }
    
    enderTeleportTo(d0, d1, d2);
  }
  
  protected void bj() {
    motY = 0.4199999868869782D;
    if (hasEffect(MobEffectList.JUMP)) {
      motY += (getEffect(MobEffectList.JUMP).getAmplifier() + 1) * 0.1F;
    }
    
    if (isSprinting()) {
      float f = yaw * 0.01745329F;
      
      motX -= MathHelper.sin(f) * 0.2F;
      motZ += MathHelper.cos(f) * 0.2F;
    }
    
    am = true;
  }
  

  public void e(float f, float f1)
  {
    if ((M()) && ((!(this instanceof EntityHuman)) || (!abilities.isFlying))) {
      double d0 = locY;
      a(f, f1, bk() ? 0.04F : 0.02F);
      move(motX, motY, motZ);
      motX *= 0.800000011920929D;
      motY *= 0.800000011920929D;
      motZ *= 0.800000011920929D;
      motY -= 0.02D;
      if ((positionChanged) && (c(motX, motY + 0.6000000238418579D - locY + d0, motZ))) {
        motY = 0.300000011920929D;
      }
    } else if ((P()) && ((!(this instanceof EntityHuman)) || (!abilities.isFlying))) {
      double d0 = locY;
      a(f, f1, 0.02F);
      move(motX, motY, motZ);
      motX *= 0.5D;
      motY *= 0.5D;
      motZ *= 0.5D;
      motY -= 0.02D;
      if ((positionChanged) && (c(motX, motY + 0.6000000238418579D - locY + d0, motZ))) {
        motY = 0.300000011920929D;
      }
    } else {
      float f2 = 0.91F;
      
      if (onGround) {
        f2 = world.getType(MathHelper.floor(locX), MathHelper.floor(boundingBox.b) - 1, MathHelper.floor(locZ)).frictionFactor * 0.91F;
      }
      
      float f3 = 0.1627714F / (f2 * f2 * f2);
      float f4;
      float f4;
      if (onGround) {
        f4 = bl() * f3;
      } else {
        f4 = aR;
      }
      
      a(f, f1, f4);
      f2 = 0.91F;
      if (onGround) {
        f2 = world.getType(MathHelper.floor(locX), MathHelper.floor(boundingBox.b) - 1, MathHelper.floor(locZ)).frictionFactor * 0.91F;
      }
      
      if (h_()) {
        float f5 = 0.15F;
        
        if (motX < -f5) {
          motX = (-f5);
        }
        
        if (motX > f5) {
          motX = f5;
        }
        
        if (motZ < -f5) {
          motZ = (-f5);
        }
        
        if (motZ > f5) {
          motZ = f5;
        }
        
        fallDistance = 0.0F;
        if (motY < -0.15D) {
          motY = -0.15D;
        }
        
        boolean flag = (isSneaking()) && ((this instanceof EntityHuman));
        
        if ((flag) && (motY < 0.0D)) {
          motY = 0.0D;
        }
      }
      
      move(motX, motY, motZ);
      if ((positionChanged) && (h_())) {
        motY = 0.2D;
      }
      
      if ((world.isStatic) && ((!world.isLoaded((int)locX, 0, (int)locZ)) || (!world.getChunkAtWorldCoords((int)locX, (int)locZ).d))) {
        if (locY > 0.0D) {
          motY = -0.1D;
        } else {
          motY = 0.0D;
        }
      } else {
        motY -= 0.08D;
      }
      
      motY *= 0.9800000190734863D;
      motX *= f2;
      motZ *= f2;
    }
    
    aF = aG;
    double d0 = locX - lastX;
    double d1 = locZ - lastZ;
    float f6 = MathHelper.sqrt(d0 * d0 + d1 * d1) * 4.0F;
    
    if (f6 > 1.0F) {
      f6 = 1.0F;
    }
    
    aG += (f6 - aG) * 0.4F;
    aH += aG;
  }
  
  protected boolean bk() {
    return false;
  }
  
  public float bl() {
    return bk() ? bp : 0.1F;
  }
  
  public void i(float f) {
    bp = f;
  }
  
  public boolean m(Entity entity) {
    k(entity);
    return false;
  }
  
  public boolean isSleeping() {
    return false;
  }
  
  public void h() {
    super.h();
    if (!world.isStatic) {
      int i = aZ();
      
      if (i > 0) {
        if (aw <= 0) {
          aw = (20 * (30 - i));
        }
        
        aw -= 1;
        if (aw <= 0) {
          p(i - 1);
        }
      }
      
      for (int j = 0; j < 5; j++) {
        ItemStack itemstack = g[j];
        ItemStack itemstack1 = getEquipment(j);
        
        if (!ItemStack.matches(itemstack1, itemstack)) {
          ((WorldServer)world).getTracker().a(this, new PacketPlayOutEntityEquipment(getId(), j, itemstack1));
          if (itemstack != null) {
            d.a(itemstack.D());
          }
          
          if (itemstack1 != null) {
            d.b(itemstack1.D());
          }
          
          g[j] = (itemstack1 == null ? null : itemstack1.cloneItemStack());
        }
      }
    }
    
    e();
    double d0 = locX - lastX;
    double d1 = locZ - lastZ;
    float f = (float)(d0 * d0 + d1 * d1);
    float f1 = aN;
    float f2 = 0.0F;
    
    aW = aX;
    float f3 = 0.0F;
    
    if (f > 0.0025F) {
      f3 = 1.0F;
      f2 = (float)Math.sqrt(f) * 3.0F;
      
      f1 = (float)org.bukkit.craftbukkit.v1_7_R1.TrigMath.atan2(d1, d0) * 180.0F / 3.141593F - 90.0F;
    }
    
    if (aE > 0.0F) {
      f1 = yaw;
    }
    
    if (!onGround) {
      f3 = 0.0F;
    }
    
    aX += (f3 - aX) * 0.3F;
    world.methodProfiler.a("headTurn");
    f2 = f(f1, f2);
    world.methodProfiler.b();
    world.methodProfiler.a("rangeChecks");
    
    while (yaw - lastYaw < -180.0F) {
      lastYaw -= 360.0F;
    }
    
    while (yaw - lastYaw >= 180.0F) {
      lastYaw += 360.0F;
    }
    
    while (aN - aO < -180.0F) {
      aO -= 360.0F;
    }
    
    while (aN - aO >= 180.0F) {
      aO += 360.0F;
    }
    
    while (pitch - lastPitch < -180.0F) {
      lastPitch -= 360.0F;
    }
    
    while (pitch - lastPitch >= 180.0F) {
      lastPitch += 360.0F;
    }
    
    while (aP - aQ < -180.0F) {
      aQ -= 360.0F;
    }
    
    while (aP - aQ >= 180.0F) {
      aQ += 360.0F;
    }
    
    world.methodProfiler.b();
    aY += f2;
  }
  
  protected float f(float f, float f1) {
    float f2 = MathHelper.g(f - aN);
    
    aN += f2 * 0.3F;
    float f3 = MathHelper.g(yaw - aN);
    boolean flag = (f3 < -90.0F) || (f3 >= 90.0F);
    
    if (f3 < -75.0F) {
      f3 = -75.0F;
    }
    
    if (f3 >= 75.0F) {
      f3 = 75.0F;
    }
    
    aN = (yaw - f3);
    if (f3 * f3 > 2500.0F) {
      aN += f3 * 0.2F;
    }
    
    if (flag) {
      f1 *= -1.0F;
    }
    
    return f1;
  }
  
  public void e() {
    if (bq > 0) {
      bq -= 1;
    }
    
    if (bh > 0) {
      double d0 = locX + (bi - locX) / bh;
      double d1 = locY + (bj - locY) / bh;
      double d2 = locZ + (bk - locZ) / bh;
      double d3 = MathHelper.g(bl - yaw);
      
      yaw = ((float)(yaw + d3 / bh));
      pitch = ((float)(pitch + (bm - pitch) / bh));
      bh -= 1;
      setPosition(d0, d1, d2);
      b(yaw, pitch);
    } else if (!br()) {
      motX *= 0.98D;
      motY *= 0.98D;
      motZ *= 0.98D;
    }
    
    if (Math.abs(motX) < 0.005D) {
      motX = 0.0D;
    }
    
    if (Math.abs(motY) < 0.005D) {
      motY = 0.0D;
    }
    
    if (Math.abs(motZ) < 0.005D) {
      motZ = 0.0D;
    }
    
    world.methodProfiler.a("ai");
    if (bh()) {
      bd = false;
      be = 0.0F;
      bf = 0.0F;
      bg = 0.0F;
    } else if (br()) {
      if (bk()) {
        world.methodProfiler.a("newAi");
        bn();
        world.methodProfiler.b();
      } else {
        world.methodProfiler.a("oldAi");
        bq();
        world.methodProfiler.b();
        aP = yaw;
      }
    }
    
    world.methodProfiler.b();
    world.methodProfiler.a("jump");
    if (bd) {
      if ((!M()) && (!P())) {
        if ((onGround) && (bq == 0)) {
          bj();
          bq = 10;
        }
      } else {
        motY += 0.03999999910593033D;
      }
    } else {
      bq = 0;
    }
    
    world.methodProfiler.b();
    world.methodProfiler.a("travel");
    be *= 0.98F;
    bf *= 0.98F;
    bg *= 0.9F;
    e(be, bf);
    world.methodProfiler.b();
    world.methodProfiler.a("push");
    if (!world.isStatic) {
      bo();
    }
    
    world.methodProfiler.b();
  }
  
  protected void bn() {}
  
  protected void bo() {
    List list = world.getEntities(this, boundingBox.grow(0.2000000029802322D, 0.0D, 0.2000000029802322D));
    
    if ((list != null) && (!list.isEmpty())) {
      for (int i = 0; i < list.size(); i++) {
        Entity entity = (Entity)list.get(i);
        


        if ((!(entity instanceof EntityLiving)) || ((this instanceof EntityPlayer)) || (ticksLived % 2 != 0))
        {



          if (entity.S())
            n(entity);
        }
      }
    }
  }
  
  protected void n(Entity entity) {
    entity.collide(this);
  }
  
  public void ab() {
    super.ab();
    aW = aX;
    aX = 0.0F;
    fallDistance = 0.0F;
  }
  
  protected void bp() {}
  
  protected void bq() {
    aV += 1;
  }
  
  public void f(boolean flag) {
    bd = flag;
  }
  
  public void receive(Entity entity, int i) {
    if ((!dead) && (!world.isStatic)) {
      EntityTracker entitytracker = ((WorldServer)world).getTracker();
      
      if ((entity instanceof EntityItem)) {
        entitytracker.a(entity, new PacketPlayOutCollect(entity.getId(), getId()));
      }
      
      if ((entity instanceof EntityArrow)) {
        entitytracker.a(entity, new PacketPlayOutCollect(entity.getId(), getId()));
      }
      
      if ((entity instanceof EntityExperienceOrb)) {
        entitytracker.a(entity, new PacketPlayOutCollect(entity.getId(), getId()));
      }
    }
  }
  
  public boolean o(Entity entity) {
    return world.a(world.getVec3DPool().create(locX, locY + getHeadHeight(), locZ), world.getVec3DPool().create(locX, locY + entity.getHeadHeight(), locZ)) == null;
  }
  
  public Vec3D ag() {
    return j(1.0F);
  }
  




  public Vec3D j(float f)
  {
    if (f == 1.0F) {
      float f1 = MathHelper.cos(-yaw * 0.01745329F - 3.141593F);
      float f2 = MathHelper.sin(-yaw * 0.01745329F - 3.141593F);
      float f3 = -MathHelper.cos(-pitch * 0.01745329F);
      float f4 = MathHelper.sin(-pitch * 0.01745329F);
      return world.getVec3DPool().create(f2 * f3, f4, f1 * f3);
    }
    float f1 = lastPitch + (pitch - lastPitch) * f;
    float f2 = lastYaw + (yaw - lastYaw) * f;
    float f3 = MathHelper.cos(-f2 * 0.01745329F - 3.141593F);
    float f4 = MathHelper.sin(-f2 * 0.01745329F - 3.141593F);
    float f5 = -MathHelper.cos(-f1 * 0.01745329F);
    float f6 = MathHelper.sin(-f1 * 0.01745329F);
    
    return world.getVec3DPool().create(f4 * f5, f6, f3 * f5);
  }
  
  public boolean br()
  {
    return !world.isStatic;
  }
  
  public boolean R() {
    return !dead;
  }
  
  public boolean S() {
    return !dead;
  }
  
  public float getHeadHeight() {
    return length * 0.85F;
  }
  
  protected void Q() {
    velocityChanged = (random.nextDouble() >= getAttributeInstance(GenericAttributes.c).getValue());
  }
  
  public float getHeadRotation() {
    return aP;
  }
  
  public float bs() {
    return br;
  }
  
  public void m(float f) {
    if (f < 0.0F) {
      f = 0.0F;
    }
    
    br = f;
  }
  
  public ScoreboardTeamBase getScoreboardTeam() {
    return null;
  }
  
  public boolean c(EntityLiving entityliving) {
    return a(entityliving.getScoreboardTeam());
  }
  
  public boolean a(ScoreboardTeamBase scoreboardteambase) {
    return getScoreboardTeam() != null ? getScoreboardTeam().isAlly(scoreboardteambase) : false;
  }
}
