package net.minecraft.server.v1_7_R1;

import java.util.List;
import org.bukkit.Location;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.entity.Vehicle;
import org.bukkit.event.vehicle.VehicleDamageEvent;
import org.bukkit.event.vehicle.VehicleDestroyEvent;
import org.bukkit.event.vehicle.VehicleEntityCollisionEvent;
import org.bukkit.event.vehicle.VehicleMoveEvent;
import org.bukkit.plugin.PluginManager;
import org.bukkit.util.Vector;

public abstract class EntityMinecartAbstract extends Entity
{
  private boolean a;
  private String b;
  private static final int[][][] matrix = { { { 0, 0, -1 }, { 0, 0, 1 } }, { { -1, 0, 0 }, { 1, 0, 0 } }, { { -1, -1, 0 }, { 1, 0, 0 } }, { { -1, 0, 0 }, { 1, -1, 0 } }, { { 0, 0, -1 }, { 0, -1, 1 } }, { { 0, -1, -1 }, { 0, 0, 1 } }, { { 0, 0, 1 }, { 1, 0, 0 } }, { { 0, 0, 1 }, { -1, 0, 0 } }, { { 0, 0, -1 }, { -1, 0, 0 } }, { { 0, 0, -1 }, { 1, 0, 0 } } };
  
  private int d;
  
  private double e;
  private double f;
  private double g;
  private double h;
  private double i;
  public boolean slowWhenEmpty = true;
  private double derailedX = 0.5D;
  private double derailedY = 0.5D;
  private double derailedZ = 0.5D;
  private double flyingX = 0.95D;
  private double flyingY = 0.95D;
  private double flyingZ = 0.95D;
  public double maxSpeed = 0.4D;
  
  public EntityMinecartAbstract(World world)
  {
    super(world);
    l = true;
    a(0.98F, 0.7F);
    height = (length / 2.0F);
  }
  
  public static EntityMinecartAbstract a(World world, double d0, double d1, double d2, int i) {
    switch (i) {
    case 1: 
      return new EntityMinecartChest(world, d0, d1, d2);
    
    case 2: 
      return new EntityMinecartFurnace(world, d0, d1, d2);
    
    case 3: 
      return new EntityMinecartTNT(world, d0, d1, d2);
    
    case 4: 
      return new EntityMinecartMobSpawner(world, d0, d1, d2);
    
    case 5: 
      return new EntityMinecartHopper(world, d0, d1, d2);
    
    case 6: 
      return new EntityMinecartCommandBlock(world, d0, d1, d2);
    }
    
    return new EntityMinecartRideable(world, d0, d1, d2);
  }
  
  protected boolean g_()
  {
    return false;
  }
  
  protected void c() {
    datawatcher.a(17, new Integer(0));
    datawatcher.a(18, new Integer(1));
    datawatcher.a(19, new Float(0.0F));
    datawatcher.a(20, new Integer(0));
    datawatcher.a(21, new Integer(6));
    datawatcher.a(22, Byte.valueOf((byte)0));
  }
  
  public AxisAlignedBB g(Entity entity) {
    return entity.S() ? boundingBox : null;
  }
  
  public AxisAlignedBB J() {
    return null;
  }
  
  public boolean S() {
    return true;
  }
  
  public EntityMinecartAbstract(World world, double d0, double d1, double d2) {
    this(world);
    setPosition(d0, d1, d2);
    motX = 0.0D;
    motY = 0.0D;
    motZ = 0.0D;
    lastX = d0;
    lastY = d1;
    lastZ = d2;
    
    this.world.getServer().getPluginManager().callEvent(new org.bukkit.event.vehicle.VehicleCreateEvent((Vehicle)getBukkitEntity()));
  }
  
  public double ae() {
    return length * 0.0D - 0.300000011920929D;
  }
  
  public boolean damageEntity(DamageSource damagesource, float f) {
    if ((!world.isStatic) && (!dead)) {
      if (isInvulnerable()) {
        return false;
      }
      
      Vehicle vehicle = (Vehicle)getBukkitEntity();
      org.bukkit.entity.Entity passenger = damagesource.getEntity() == null ? null : damagesource.getEntity().getBukkitEntity();
      
      VehicleDamageEvent event = new VehicleDamageEvent(vehicle, passenger, f);
      world.getServer().getPluginManager().callEvent(event);
      
      if (event.isCancelled()) {
        return true;
      }
      
      f = (float)event.getDamage();
      

      j(-l());
      c(10);
      Q();
      setDamage(getDamage() + f * 10.0F);
      boolean flag = ((damagesource.getEntity() instanceof EntityHuman)) && (getEntity()abilities.canInstantlyBuild);
      
      if ((flag) || (getDamage() > 40.0F)) {
        if (this.passenger != null) {
          this.passenger.mount(this);
        }
        

        VehicleDestroyEvent destroyEvent = new VehicleDestroyEvent(vehicle, passenger);
        world.getServer().getPluginManager().callEvent(destroyEvent);
        
        if (destroyEvent.isCancelled()) {
          setDamage(40.0F);
          return true;
        }
        

        if ((flag) && (!k_())) {
          die();
        } else {
          a(damagesource);
        }
      }
      
      return true;
    }
    
    return true;
  }
  
  public void a(DamageSource damagesource)
  {
    die();
    ItemStack itemstack = new ItemStack(Items.MINECART, 1);
    
    if (b != null) {
      itemstack.c(b);
    }
    
    a(itemstack, 0.0F);
  }
  
  public boolean R() {
    return !dead;
  }
  
  public void die() {
    super.die();
  }
  
  public void h()
  {
    double prevX = locX;
    double prevY = locY;
    double prevZ = locZ;
    float prevYaw = yaw;
    float prevPitch = pitch;
    

    if (getType() > 0) {
      c(getType() - 1);
    }
    
    if (getDamage() > 0.0F) {
      setDamage(getDamage() - 1.0F);
    }
    
    if (locY < -64.0D) {
      G();
    }
    


    if ((!world.isStatic) && ((world instanceof WorldServer))) {
      world.methodProfiler.a("portal");
      MinecraftServer minecraftserver = ((WorldServer)world).getMinecraftServer();
      
      int i = D();
      if (ao)
      {
        if ((this.vehicle == null) && (ap++ >= i)) {
          ap = i;
          portalCooldown = ai();
          byte b0;
          byte b0;
          if (world.worldProvider.dimension == -1) {
            b0 = 0;
          } else {
            b0 = -1;
          }
          
          b(b0);
        }
        
        ao = false;
      }
      else {
        if (ap > 0) {
          ap -= 4;
        }
        
        if (ap < 0) {
          ap = 0;
        }
      }
      
      if (portalCooldown > 0) {
        portalCooldown -= 1;
      }
      
      world.methodProfiler.b();
    }
    
    if (world.isStatic) {
      if (d > 0) {
        double d0 = locX + (e - locX) / d;
        double d1 = locY + (f - locY) / d;
        double d2 = locZ + (g - locZ) / d;
        double d3 = MathHelper.g(h - yaw);
        
        yaw = ((float)(yaw + d3 / d));
        pitch = ((float)(pitch + (this.i - pitch) / d));
        d -= 1;
        setPosition(d0, d1, d2);
        b(yaw, pitch);
      } else {
        setPosition(locX, locY, locZ);
        b(yaw, pitch);
      }
    } else {
      lastX = locX;
      lastY = locY;
      lastZ = locZ;
      motY -= 0.03999999910593033D;
      int j = MathHelper.floor(locX);
      
      int i = MathHelper.floor(locY);
      int k = MathHelper.floor(locZ);
      
      if (BlockMinecartTrackAbstract.b_(world, j, i - 1, k)) {
        i--;
      }
      
      double d4 = maxSpeed;
      double d5 = 0.0078125D;
      Block block = world.getType(j, i, k);
      
      if (BlockMinecartTrackAbstract.a(block)) {
        int l = world.getData(j, i, k);
        
        a(j, i, k, d4, d5, block, l);
        if (block == Blocks.ACTIVATOR_RAIL) {
          a(j, i, k, (l & 0x8) != 0);
        }
      } else {
        b(d4);
      }
      
      I();
      pitch = 0.0F;
      double d6 = lastX - locX;
      double d7 = lastZ - locZ;
      
      if (d6 * d6 + d7 * d7 > 0.001D) {
        yaw = ((float)(Math.atan2(d7, d6) * 180.0D / 3.141592653589793D));
        if (a) {
          yaw += 180.0F;
        }
      }
      
      double d8 = MathHelper.g(yaw - lastYaw);
      
      if ((d8 < -170.0D) || (d8 >= 170.0D)) {
        yaw += 180.0F;
        a = (!a);
      }
      
      b(yaw, pitch);
      

      org.bukkit.World bworld = world.getWorld();
      Location from = new Location(bworld, prevX, prevY, prevZ, prevYaw, prevPitch);
      Location to = new Location(bworld, locX, locY, locZ, yaw, pitch);
      Vehicle vehicle = (Vehicle)getBukkitEntity();
      
      world.getServer().getPluginManager().callEvent(new org.bukkit.event.vehicle.VehicleUpdateEvent(vehicle));
      
      if (!from.equals(to)) {
        world.getServer().getPluginManager().callEvent(new VehicleMoveEvent(vehicle, from, to));
      }
      

      List list = world.getEntities(this, boundingBox.grow(0.2000000029802322D, 0.0D, 0.2000000029802322D));
      
      if ((list != null) && (!list.isEmpty())) {
        for (int i1 = 0; i1 < list.size(); i1++) {
          Entity entity = (Entity)list.get(i1);
          
          if ((entity != passenger) && (entity.S()) && ((entity instanceof EntityMinecartAbstract))) {
            entity.collide(this);
          }
        }
      }
      
      if ((passenger != null) && (passenger.dead)) {
        if (passenger.vehicle == this) {
          passenger.vehicle = null;
        }
        
        passenger = null;
      }
    }
  }
  
  public void a(int i, int j, int k, boolean flag) {}
  
  protected void b(double d0) {
    if (motX < -d0) {
      motX = (-d0);
    }
    
    if (motX > d0) {
      motX = d0;
    }
    
    if (motZ < -d0) {
      motZ = (-d0);
    }
    
    if (motZ > d0) {
      motZ = d0;
    }
    
    if (onGround)
    {
      motX *= derailedX;
      motY *= derailedY;
      motZ *= derailedZ;
    }
    

    move(motX, motY, motZ);
    if (!onGround)
    {
      motX *= flyingX;
      motY *= flyingY;
      motZ *= flyingZ;
    }
  }
  
  protected void a(int i, int j, int k, double d0, double d1, Block block, int l)
  {
    fallDistance = 0.0F;
    Vec3D vec3d = a(locX, locY, locZ);
    
    locY = j;
    boolean flag = false;
    boolean flag1 = false;
    
    if (block == Blocks.GOLDEN_RAIL) {
      flag = (l & 0x8) != 0;
      flag1 = !flag;
    }
    
    if (((BlockMinecartTrackAbstract)block).e()) {
      l &= 0x7;
    }
    
    if ((l >= 2) && (l <= 5)) {
      locY = (j + 1);
    }
    
    if (l == 2) {
      motX -= d1;
    }
    
    if (l == 3) {
      motX += d1;
    }
    
    if (l == 4) {
      motZ += d1;
    }
    
    if (l == 5) {
      motZ -= d1;
    }
    
    int[][] aint = matrix[l];
    double d2 = aint[1][0] - aint[0][0];
    double d3 = aint[1][2] - aint[0][2];
    double d4 = Math.sqrt(d2 * d2 + d3 * d3);
    double d5 = motX * d2 + motZ * d3;
    
    if (d5 < 0.0D) {
      d2 = -d2;
      d3 = -d3;
    }
    
    double d6 = Math.sqrt(motX * motX + motZ * motZ);
    
    if (d6 > 2.0D) {
      d6 = 2.0D;
    }
    
    motX = (d6 * d2 / d4);
    motZ = (d6 * d3 / d4);
    




    if ((passenger != null) && ((passenger instanceof EntityLiving))) {
      double d7 = passenger).bf;
      if (d7 > 0.0D) {
        double d8 = -Math.sin(passenger.yaw * 3.141593F / 180.0F);
        double d9 = Math.cos(passenger.yaw * 3.141593F / 180.0F);
        double d10 = motX * motX + motZ * motZ;
        if (d10 < 0.01D) {
          motX += d8 * 0.1D;
          motZ += d9 * 0.1D;
          flag1 = false;
        }
      }
    }
    
    if (flag1) {
      double d7 = Math.sqrt(motX * motX + motZ * motZ);
      if (d7 < 0.03D) {
        motX *= 0.0D;
        motY *= 0.0D;
        motZ *= 0.0D;
      } else {
        motX *= 0.5D;
        motY *= 0.0D;
        motZ *= 0.5D;
      }
    }
    
    double d7 = 0.0D;
    double d8 = i + 0.5D + aint[0][0] * 0.5D;
    double d9 = k + 0.5D + aint[0][2] * 0.5D;
    double d10 = i + 0.5D + aint[1][0] * 0.5D;
    double d11 = k + 0.5D + aint[1][2] * 0.5D;
    
    d2 = d10 - d8;
    d3 = d11 - d9;
    


    if (d2 == 0.0D) {
      locX = (i + 0.5D);
      d7 = locZ - k;
    } else if (d3 == 0.0D) {
      locZ = (k + 0.5D);
      d7 = locX - i;
    } else {
      double d12 = locX - d8;
      double d13 = locZ - d9;
      d7 = (d12 * d2 + d13 * d3) * 2.0D;
    }
    
    locX = (d8 + d2 * d7);
    locZ = (d9 + d3 * d7);
    setPosition(locX, locY + height, locZ);
    double d12 = motX;
    double d13 = motZ;
    if (passenger != null) {
      d12 *= 0.75D;
      d13 *= 0.75D;
    }
    
    if (d12 < -d0) {
      d12 = -d0;
    }
    
    if (d12 > d0) {
      d12 = d0;
    }
    
    if (d13 < -d0) {
      d13 = -d0;
    }
    
    if (d13 > d0) {
      d13 = d0;
    }
    
    move(d12, 0.0D, d13);
    if ((aint[0][1] != 0) && (MathHelper.floor(locX) - i == aint[0][0]) && (MathHelper.floor(locZ) - k == aint[0][2])) {
      setPosition(locX, locY + aint[0][1], locZ);
    } else if ((aint[1][1] != 0) && (MathHelper.floor(locX) - i == aint[1][0]) && (MathHelper.floor(locZ) - k == aint[1][2])) {
      setPosition(locX, locY + aint[1][1], locZ);
    }
    
    i();
    Vec3D vec3d1 = a(locX, locY, locZ);
    
    if ((vec3d1 != null) && (vec3d != null)) {
      double d14 = (d - d) * 0.05D;
      
      d6 = Math.sqrt(motX * motX + motZ * motZ);
      if (d6 > 0.0D) {
        motX = (motX / d6 * (d6 + d14));
        motZ = (motZ / d6 * (d6 + d14));
      }
      
      setPosition(locX, d, locZ);
    }
    
    int i1 = MathHelper.floor(locX);
    int j1 = MathHelper.floor(locZ);
    
    if ((i1 != i) || (j1 != k)) {
      d6 = Math.sqrt(motX * motX + motZ * motZ);
      motX = (d6 * (i1 - i));
      motZ = (d6 * (j1 - k));
    }
    
    if (flag) {
      double d15 = Math.sqrt(motX * motX + motZ * motZ);
      
      if (d15 > 0.01D) {
        double d16 = 0.06D;
        
        motX += motX / d15 * d16;
        motZ += motZ / d15 * d16;
      } else if (l == 1) {
        if (world.getType(i - 1, j, k).r()) {
          motX = 0.02D;
        } else if (world.getType(i + 1, j, k).r()) {
          motX = -0.02D;
        }
      } else if (l == 0) {
        if (world.getType(i, j, k - 1).r()) {
          motZ = 0.02D;
        } else if (world.getType(i, j, k + 1).r()) {
          motZ = -0.02D;
        }
      }
    }
  }
  
  protected void i() {
    if ((passenger != null) || (!slowWhenEmpty)) {
      motX *= 0.996999979019165D;
      motY *= 0.0D;
      motZ *= 0.996999979019165D;
    } else {
      motX *= 0.9599999785423279D;
      motY *= 0.0D;
      motZ *= 0.9599999785423279D;
    }
  }
  
  public Vec3D a(double d0, double d1, double d2) {
    int i = MathHelper.floor(d0);
    int j = MathHelper.floor(d1);
    int k = MathHelper.floor(d2);
    
    if (BlockMinecartTrackAbstract.b_(world, i, j - 1, k)) {
      j--;
    }
    
    Block block = world.getType(i, j, k);
    
    if (BlockMinecartTrackAbstract.a(block)) {
      int l = world.getData(i, j, k);
      
      d1 = j;
      if (((BlockMinecartTrackAbstract)block).e()) {
        l &= 0x7;
      }
      
      if ((l >= 2) && (l <= 5)) {
        d1 = j + 1;
      }
      
      int[][] aint = matrix[l];
      double d3 = 0.0D;
      double d4 = i + 0.5D + aint[0][0] * 0.5D;
      double d5 = j + 0.5D + aint[0][1] * 0.5D;
      double d6 = k + 0.5D + aint[0][2] * 0.5D;
      double d7 = i + 0.5D + aint[1][0] * 0.5D;
      double d8 = j + 0.5D + aint[1][1] * 0.5D;
      double d9 = k + 0.5D + aint[1][2] * 0.5D;
      double d10 = d7 - d4;
      double d11 = (d8 - d5) * 2.0D;
      double d12 = d9 - d6;
      
      if (d10 == 0.0D) {
        d0 = i + 0.5D;
        d3 = d2 - k;
      } else if (d12 == 0.0D) {
        d2 = k + 0.5D;
        d3 = d0 - i;
      } else {
        double d13 = d0 - d4;
        double d14 = d2 - d6;
        
        d3 = (d13 * d10 + d14 * d12) * 2.0D;
      }
      
      d0 = d4 + d10 * d3;
      d1 = d5 + d11 * d3;
      d2 = d6 + d12 * d3;
      if (d11 < 0.0D) {
        d1 += 1.0D;
      }
      
      if (d11 > 0.0D) {
        d1 += 0.5D;
      }
      
      return world.getVec3DPool().create(d0, d1, d2);
    }
    return null;
  }
  
  protected void a(NBTTagCompound nbttagcompound)
  {
    if (nbttagcompound.getBoolean("CustomDisplayTile")) {
      k(nbttagcompound.getInt("DisplayTile"));
      l(nbttagcompound.getInt("DisplayData"));
      m(nbttagcompound.getInt("DisplayOffset"));
    }
    
    if ((nbttagcompound.hasKeyOfType("CustomName", 8)) && (nbttagcompound.getString("CustomName").length() > 0)) {
      b = nbttagcompound.getString("CustomName");
    }
  }
  
  protected void b(NBTTagCompound nbttagcompound) {
    if (t()) {
      nbttagcompound.setBoolean("CustomDisplayTile", true);
      nbttagcompound.setInt("DisplayTile", n().getMaterial() == Material.AIR ? 0 : Block.b(n()));
      nbttagcompound.setInt("DisplayData", p());
      nbttagcompound.setInt("DisplayOffset", r());
    }
    
    if ((b != null) && (b.length() > 0)) {
      nbttagcompound.setString("CustomName", b);
    }
  }
  
  public void collide(Entity entity) {
    if ((!world.isStatic) && 
      (entity != passenger))
    {
      Vehicle vehicle = (Vehicle)getBukkitEntity();
      org.bukkit.entity.Entity hitEntity = entity == null ? null : entity.getBukkitEntity();
      
      VehicleEntityCollisionEvent collisionEvent = new VehicleEntityCollisionEvent(vehicle, hitEntity);
      world.getServer().getPluginManager().callEvent(collisionEvent);
      
      if (collisionEvent.isCancelled()) {
        return;
      }
      

      if (((entity instanceof EntityLiving)) && (!(entity instanceof EntityHuman)) && (!(entity instanceof EntityIronGolem)) && (m() == 0) && (motX * motX + motZ * motZ > 0.01D) && (passenger == null) && (vehicle == null)) {
        entity.mount(this);
      }
      
      double d0 = locX - locX;
      double d1 = locZ - locZ;
      double d2 = d0 * d0 + d1 * d1;
      

      if ((d2 >= 9.999999747378752E-005D) && (!collisionEvent.isCollisionCancelled())) {
        d2 = MathHelper.sqrt(d2);
        d0 /= d2;
        d1 /= d2;
        double d3 = 1.0D / d2;
        
        if (d3 > 1.0D) {
          d3 = 1.0D;
        }
        
        d0 *= d3;
        d1 *= d3;
        d0 *= 0.1000000014901161D;
        d1 *= 0.1000000014901161D;
        d0 *= (1.0F - Z);
        d1 *= (1.0F - Z);
        d0 *= 0.5D;
        d1 *= 0.5D;
        if ((entity instanceof EntityMinecartAbstract)) {
          double d4 = locX - locX;
          double d5 = locZ - locZ;
          Vec3D vec3d = world.getVec3DPool().create(d4, 0.0D, d5).a();
          Vec3D vec3d1 = world.getVec3DPool().create(MathHelper.cos(yaw * 3.141593F / 180.0F), 0.0D, MathHelper.sin(yaw * 3.141593F / 180.0F)).a();
          double d6 = Math.abs(vec3d.b(vec3d1));
          
          if (d6 < 0.800000011920929D) {
            return;
          }
          
          double d7 = motX + motX;
          double d8 = motZ + motZ;
          
          if ((((EntityMinecartAbstract)entity).m() == 2) && (m() != 2)) {
            motX *= 0.2000000029802322D;
            motZ *= 0.2000000029802322D;
            g(motX - d0, 0.0D, motZ - d1);
            motX *= 0.949999988079071D;
            motZ *= 0.949999988079071D;
          } else if ((((EntityMinecartAbstract)entity).m() != 2) && (m() == 2)) {
            motX *= 0.2000000029802322D;
            motZ *= 0.2000000029802322D;
            entity.g(motX + d0, 0.0D, motZ + d1);
            motX *= 0.949999988079071D;
            motZ *= 0.949999988079071D;
          } else {
            d7 /= 2.0D;
            d8 /= 2.0D;
            motX *= 0.2000000029802322D;
            motZ *= 0.2000000029802322D;
            g(d7 - d0, 0.0D, d8 - d1);
            motX *= 0.2000000029802322D;
            motZ *= 0.2000000029802322D;
            entity.g(d7 + d0, 0.0D, d8 + d1);
          }
        } else {
          g(-d0, 0.0D, -d1);
          entity.g(d0 / 4.0D, 0.0D, d1 / 4.0D);
        }
      }
    }
  }
  
  public void setDamage(float f)
  {
    datawatcher.watch(19, Float.valueOf(f));
  }
  
  public float getDamage() {
    return datawatcher.getFloat(19);
  }
  
  public void c(int i) {
    datawatcher.watch(17, Integer.valueOf(i));
  }
  
  public int getType() {
    return datawatcher.getInt(17);
  }
  
  public void j(int i) {
    datawatcher.watch(18, Integer.valueOf(i));
  }
  
  public int l() {
    return datawatcher.getInt(18);
  }
  
  public abstract int m();
  
  public Block n() {
    if (!t()) {
      return o();
    }
    int i = getDataWatcher().getInt(20) & 0xFFFF;
    
    return Block.e(i);
  }
  
  public Block o()
  {
    return Blocks.AIR;
  }
  
  public int p() {
    return !t() ? q() : getDataWatcher().getInt(20) >> 16;
  }
  
  public int q() {
    return 0;
  }
  
  public int r() {
    return !t() ? s() : getDataWatcher().getInt(21);
  }
  
  public int s() {
    return 6;
  }
  
  public void k(int i) {
    getDataWatcher().watch(20, Integer.valueOf(i & 0xFFFF | p() << 16));
    a(true);
  }
  
  public void l(int i) {
    getDataWatcher().watch(20, Integer.valueOf(Block.b(n()) & 0xFFFF | i << 16));
    a(true);
  }
  
  public void m(int i) {
    getDataWatcher().watch(21, Integer.valueOf(i));
    a(true);
  }
  
  public boolean t() {
    return getDataWatcher().getByte(22) == 1;
  }
  
  public void a(boolean flag) {
    getDataWatcher().watch(22, Byte.valueOf((byte)(flag ? 1 : 0)));
  }
  
  public void a(String s) {
    b = s;
  }
  
  public String getName() {
    return b != null ? b : super.getName();
  }
  
  public boolean k_() {
    return b != null;
  }
  
  public String u() {
    return b;
  }
  
  public Vector getFlyingVelocityMod()
  {
    return new Vector(flyingX, flyingY, flyingZ);
  }
  
  public void setFlyingVelocityMod(Vector flying) {
    flyingX = flying.getX();
    flyingY = flying.getY();
    flyingZ = flying.getZ();
  }
  
  public Vector getDerailedVelocityMod() {
    return new Vector(derailedX, derailedY, derailedZ);
  }
  
  public void setDerailedVelocityMod(Vector derailed) {
    derailedX = derailed.getX();
    derailedY = derailed.getY();
    derailedZ = derailed.getZ();
  }
}
