package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftHumanEntity;
import org.bukkit.entity.Entity;
import org.bukkit.entity.HumanEntity;
import org.bukkit.inventory.InventoryHolder;

public abstract class EntityMinecartContainer extends EntityMinecartAbstract implements IInventory
{
  private ItemStack[] items = new ItemStack[27];
  private boolean b = true;
  

  public List<HumanEntity> transaction = new ArrayList();
  private int maxStack = 64;
  
  public ItemStack[] getContents() {
    return items;
  }
  
  public void onOpen(CraftHumanEntity who) {
    transaction.add(who);
  }
  
  public void onClose(CraftHumanEntity who) {
    transaction.remove(who);
  }
  
  public List<HumanEntity> getViewers() {
    return transaction;
  }
  
  public InventoryHolder getOwner() {
    Entity cart = getBukkitEntity();
    if ((cart instanceof InventoryHolder)) return (InventoryHolder)cart;
    return null;
  }
  
  public void setMaxStackSize(int size) {
    maxStack = size;
  }
  
  public EntityMinecartContainer(World world)
  {
    super(world);
  }
  
  public EntityMinecartContainer(World world, double d0, double d1, double d2) {
    super(world, d0, d1, d2);
  }
  
  public void a(DamageSource damagesource) {
    super.a(damagesource);
    
    for (int i = 0; i < getSize(); i++) {
      ItemStack itemstack = getItem(i);
      
      if (itemstack != null) {
        float f = random.nextFloat() * 0.8F + 0.1F;
        float f1 = random.nextFloat() * 0.8F + 0.1F;
        float f2 = random.nextFloat() * 0.8F + 0.1F;
        
        while (count > 0) {
          int j = random.nextInt(21) + 10;
          
          if (j > count) {
            j = count;
          }
          
          count -= j;
          EntityItem entityitem = new EntityItem(world, locX + f, locY + f1, locZ + f2, new ItemStack(itemstack.getItem(), j, itemstack.getData()));
          float f3 = 0.05F;
          
          motX = ((float)random.nextGaussian() * f3);
          motY = ((float)random.nextGaussian() * f3 + 0.2F);
          motZ = ((float)random.nextGaussian() * f3);
          world.addEntity(entityitem);
        }
      }
    }
  }
  
  public ItemStack getItem(int i) {
    return items[i];
  }
  
  public ItemStack splitStack(int i, int j) {
    if (items[i] != null)
    {

      if (items[i].count <= j) {
        ItemStack itemstack = items[i];
        items[i] = null;
        return itemstack;
      }
      ItemStack itemstack = items[i].a(j);
      if (items[i].count == 0) {
        items[i] = null;
      }
      
      return itemstack;
    }
    
    return null;
  }
  
  public ItemStack splitWithoutUpdate(int i)
  {
    if (items[i] != null) {
      ItemStack itemstack = items[i];
      
      items[i] = null;
      return itemstack;
    }
    return null;
  }
  
  public void setItem(int i, ItemStack itemstack)
  {
    items[i] = itemstack;
    if ((itemstack != null) && (count > getMaxStackSize())) {
      count = getMaxStackSize();
    }
  }
  
  public void update() {}
  
  public boolean a(EntityHuman entityhuman) {
    return !dead;
  }
  
  public void startOpen() {}
  
  public void l_() {}
  
  public boolean b(int i, ItemStack itemstack) {
    return true;
  }
  
  public String getInventoryName() {
    return k_() ? u() : "container.minecart";
  }
  
  public int getMaxStackSize() {
    return 64;
  }
  
  public void b(int i) {
    b = false;
    super.b(i);
  }
  
  public void die() {
    if (b) {
      for (int i = 0; i < getSize(); i++) {
        ItemStack itemstack = getItem(i);
        
        if (itemstack != null) {
          float f = random.nextFloat() * 0.8F + 0.1F;
          float f1 = random.nextFloat() * 0.8F + 0.1F;
          float f2 = random.nextFloat() * 0.8F + 0.1F;
          
          while (count > 0) {
            int j = random.nextInt(21) + 10;
            
            if (j > count) {
              j = count;
            }
            
            count -= j;
            EntityItem entityitem = new EntityItem(world, locX + f, locY + f1, locZ + f2, new ItemStack(itemstack.getItem(), j, itemstack.getData()));
            
            if (itemstack.hasTag()) {
              entityitem.getItemStack().setTag((NBTTagCompound)itemstack.getTag().clone());
            }
            
            float f3 = 0.05F;
            
            motX = ((float)random.nextGaussian() * f3);
            motY = ((float)random.nextGaussian() * f3 + 0.2F);
            motZ = ((float)random.nextGaussian() * f3);
            world.addEntity(entityitem);
          }
        }
      }
    }
    
    super.die();
  }
  
  protected void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    NBTTagList nbttaglist = new NBTTagList();
    
    for (int i = 0; i < items.length; i++) {
      if (items[i] != null) {
        NBTTagCompound nbttagcompound1 = new NBTTagCompound();
        
        nbttagcompound1.setByte("Slot", (byte)i);
        items[i].save(nbttagcompound1);
        nbttaglist.add(nbttagcompound1);
      }
    }
    
    nbttagcompound.set("Items", nbttaglist);
  }
  
  protected void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    NBTTagList nbttaglist = nbttagcompound.getList("Items", 10);
    
    items = new ItemStack[getSize()];
    
    for (int i = 0; i < nbttaglist.size(); i++) {
      NBTTagCompound nbttagcompound1 = nbttaglist.get(i);
      int j = nbttagcompound1.getByte("Slot") & 0xFF;
      
      if ((j >= 0) && (j < items.length)) {
        items[j] = ItemStack.createStack(nbttagcompound1);
      }
    }
  }
  
  public boolean c(EntityHuman entityhuman) {
    if (!world.isStatic) {
      entityhuman.openContainer(this);
    }
    
    return true;
  }
  
  protected void i() {
    int i = 15 - Container.b(this);
    float f = 0.98F + i * 0.001F;
    
    motX *= f;
    motY *= 0.0D;
    motZ *= f;
  }
}
