package net.minecraft.server.v1_7_R1;

import java.util.Random;

public class EntityOcelot extends EntityTameableAnimal {
  private PathfinderGoalTempt bq;
  
  public EntityOcelot(World world) { super(world);
    a(0.6F, 0.8F);
    getNavigation().a(true);
    goalSelector.a(1, new PathfinderGoalFloat(this));
    goalSelector.a(2, bp);
    goalSelector.a(3, this.bq = new PathfinderGoalTempt(this, 0.6D, Items.RAW_FISH, true));
    goalSelector.a(4, new PathfinderGoalAvoidPlayer(this, EntityHuman.class, 16.0F, 0.8D, 1.33D));
    goalSelector.a(5, new PathfinderGoalFollowOwner(this, 1.0D, 10.0F, 5.0F));
    goalSelector.a(6, new PathfinderGoalJumpOnBlock(this, 1.33D));
    goalSelector.a(7, new PathfinderGoalLeapAtTarget(this, 0.3F));
    goalSelector.a(8, new PathfinderGoalOcelotAttack(this));
    goalSelector.a(9, new PathfinderGoalBreed(this, 0.8D));
    goalSelector.a(10, new PathfinderGoalRandomStroll(this, 0.8D));
    goalSelector.a(11, new PathfinderGoalLookAtPlayer(this, EntityHuman.class, 10.0F));
    targetSelector.a(1, new PathfinderGoalRandomTargetNonTamed(this, EntityChicken.class, 750, false));
  }
  
  protected void c() {
    super.c();
    datawatcher.a(18, Byte.valueOf((byte)0));
  }
  
  public void bp() {
    if (getControllerMove().a()) {
      double d0 = getControllerMove().b();
      
      if (d0 == 0.6D) {
        setSneaking(true);
        setSprinting(false);
      } else if (d0 == 1.33D) {
        setSneaking(false);
        setSprinting(true);
      } else {
        setSneaking(false);
        setSprinting(false);
      }
    } else {
      setSneaking(false);
      setSprinting(false);
    }
  }
  
  protected boolean isTypeNotPersistent() {
    return !isTamed();
  }
  
  public boolean bk() {
    return true;
  }
  
  protected void aD() {
    super.aD();
    getAttributeInstance(GenericAttributes.a).setValue(10.0D);
    getAttributeInstance(GenericAttributes.d).setValue(0.300000011920929D);
  }
  
  protected void b(float f) {}
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    nbttagcompound.setInt("CatType", getCatType());
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    setCatType(nbttagcompound.getInt("CatType"));
  }
  
  protected String t() {
    return isTamed() ? "mob.cat.meow" : random.nextInt(4) == 0 ? "mob.cat.purreow" : cc() ? "mob.cat.purr" : "";
  }
  
  protected String aT() {
    return "mob.cat.hitt";
  }
  
  protected String aU() {
    return "mob.cat.hitt";
  }
  
  protected float bf() {
    return 0.4F;
  }
  
  protected Item getLoot() {
    return Items.LEATHER;
  }
  
  public boolean m(Entity entity) {
    return entity.damageEntity(DamageSource.mobAttack(this), 3.0F);
  }
  
  public boolean damageEntity(DamageSource damagesource, float f) {
    if (isInvulnerable()) {
      return false;
    }
    bp.setSitting(false);
    return super.damageEntity(damagesource, f);
  }
  
  protected void dropDeathLoot(boolean flag, int i)
  {
    org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callEntityDeathEvent(this);
  }
  
  public boolean a(EntityHuman entityhuman) {
    ItemStack itemstack = inventory.getItemInHand();
    
    if (isTamed()) {
      if ((entityhuman.getName().equalsIgnoreCase(getOwnerName())) && (!world.isStatic) && (!c(itemstack))) {
        bp.setSitting(!isSitting());
      }
    } else if ((bq.f()) && (itemstack != null) && (itemstack.getItem() == Items.RAW_FISH) && (entityhuman.e(this) < 9.0D)) {
      if (!abilities.canInstantlyBuild) {
        count -= 1;
      }
      
      if (count <= 0) {
        inventory.setItem(inventory.itemInHandIndex, (ItemStack)null);
      }
      
      if (!world.isStatic)
      {
        if ((random.nextInt(3) == 0) && (!org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callEntityTameEvent(this, entityhuman).isCancelled())) {
          setTamed(true);
          setCatType(1 + world.random.nextInt(3));
          setOwnerName(entityhuman.getName());
          i(true);
          bp.setSitting(true);
          world.broadcastEntityEffect(this, (byte)7);
        } else {
          i(false);
          world.broadcastEntityEffect(this, (byte)6);
        }
      }
      
      return true;
    }
    
    return super.a(entityhuman);
  }
  
  public EntityOcelot b(EntityAgeable entityageable) {
    EntityOcelot entityocelot = new EntityOcelot(world);
    
    if (isTamed()) {
      entityocelot.setOwnerName(getOwnerName());
      entityocelot.setTamed(true);
      entityocelot.setCatType(getCatType());
    }
    
    return entityocelot;
  }
  
  public boolean c(ItemStack itemstack) {
    return (itemstack != null) && (itemstack.getItem() == Items.RAW_FISH);
  }
  
  public boolean mate(EntityAnimal entityanimal) {
    if (entityanimal == this)
      return false;
    if (!isTamed())
      return false;
    if (!(entityanimal instanceof EntityOcelot)) {
      return false;
    }
    EntityOcelot entityocelot = (EntityOcelot)entityanimal;
    
    return entityocelot.isTamed();
  }
  
  public int getCatType()
  {
    return datawatcher.getByte(18);
  }
  
  public void setCatType(int i) {
    datawatcher.watch(18, Byte.valueOf((byte)i));
  }
  
  public boolean canSpawn() {
    if (world.random.nextInt(3) == 0) {
      return false;
    }
    if ((world.b(boundingBox)) && (world.getCubes(this, boundingBox).isEmpty()) && (!world.containsLiquid(boundingBox))) {
      int i = MathHelper.floor(locX);
      int j = MathHelper.floor(boundingBox.b);
      int k = MathHelper.floor(locZ);
      
      if (j < 63) {
        return false;
      }
      
      Block block = world.getType(i, j - 1, k);
      
      if ((block == Blocks.GRASS) || (block.getMaterial() == Material.LEAVES)) {
        return true;
      }
    }
    
    return false;
  }
  
  public String getName()
  {
    return isTamed() ? LocaleI18n.get("entity.Cat.name") : hasCustomName() ? getCustomName() : super.getName();
  }
  
  public GroupDataEntity a(GroupDataEntity groupdataentity) {
    groupdataentity = super.a(groupdataentity);
    if (world.random.nextInt(7) == 0) {
      for (int i = 0; i < 2; i++) {
        EntityOcelot entityocelot = new EntityOcelot(world);
        
        entityocelot.setPositionRotation(locX, locY, locZ, yaw, 0.0F);
        entityocelot.setAge(-24000);
        world.addEntity(entityocelot);
      }
    }
    
    return groupdataentity;
  }
  
  public EntityAgeable createChild(EntityAgeable entityageable) {
    return b(entityageable);
  }
}
