package net.minecraft.server.v1_7_R1;

import java.util.List;
import java.util.Random;
import org.bukkit.craftbukkit.v1_7_R1.util.CraftMagicNumbers;

public class EntityPig extends EntityAnimal
{
  private final PathfinderGoalPassengerCarrotStick bp;
  
  public EntityPig(World world)
  {
    super(world);
    a(0.9F, 0.9F);
    getNavigation().a(true);
    goalSelector.a(0, new PathfinderGoalFloat(this));
    goalSelector.a(1, new PathfinderGoalPanic(this, 1.25D));
    goalSelector.a(2, this.bp = new PathfinderGoalPassengerCarrotStick(this, 0.3F));
    goalSelector.a(3, new PathfinderGoalBreed(this, 1.0D));
    goalSelector.a(4, new PathfinderGoalTempt(this, 1.2D, Items.CARROT_STICK, false));
    goalSelector.a(4, new PathfinderGoalTempt(this, 1.2D, Items.CARROT, false));
    goalSelector.a(5, new PathfinderGoalFollowParent(this, 1.1D));
    goalSelector.a(6, new PathfinderGoalRandomStroll(this, 1.0D));
    goalSelector.a(7, new PathfinderGoalLookAtPlayer(this, EntityHuman.class, 6.0F));
    goalSelector.a(8, new PathfinderGoalRandomLookaround(this));
  }
  
  public boolean bk() {
    return true;
  }
  
  protected void aD() {
    super.aD();
    getAttributeInstance(GenericAttributes.a).setValue(10.0D);
    getAttributeInstance(GenericAttributes.d).setValue(0.25D);
  }
  
  protected void bn() {
    super.bn();
  }
  
  public boolean bC() {
    ItemStack itemstack = ((EntityHuman)passenger).be();
    
    return (itemstack != null) && (itemstack.getItem() == Items.CARROT_STICK);
  }
  
  protected void c() {
    super.c();
    datawatcher.a(16, Byte.valueOf((byte)0));
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    nbttagcompound.setBoolean("Saddle", hasSaddle());
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    setSaddle(nbttagcompound.getBoolean("Saddle"));
  }
  
  protected String t() {
    return "mob.pig.say";
  }
  
  protected String aT() {
    return "mob.pig.say";
  }
  
  protected String aU() {
    return "mob.pig.death";
  }
  
  protected void a(int i, int j, int k, Block block) {
    makeSound("mob.pig.step", 0.15F, 1.0F);
  }
  
  public boolean a(EntityHuman entityhuman) {
    if (super.a(entityhuman))
      return true;
    if ((hasSaddle()) && (!world.isStatic) && ((passenger == null) || (passenger == entityhuman))) {
      entityhuman.mount(this);
      return true;
    }
    return false;
  }
  
  protected Item getLoot()
  {
    return isBurning() ? Items.GRILLED_PORK : Items.PORK;
  }
  
  protected void dropDeathLoot(boolean flag, int i)
  {
    List<org.bukkit.inventory.ItemStack> loot = new java.util.ArrayList();
    int j = random.nextInt(3) + 1 + random.nextInt(1 + i);
    
    if (j > 0) {
      if (isBurning()) {
        loot.add(new org.bukkit.inventory.ItemStack(CraftMagicNumbers.getMaterial(Items.GRILLED_PORK), j));
      } else {
        loot.add(new org.bukkit.inventory.ItemStack(CraftMagicNumbers.getMaterial(Items.PORK), j));
      }
    }
    
    if (hasSaddle()) {
      loot.add(new org.bukkit.inventory.ItemStack(CraftMagicNumbers.getMaterial(Items.SADDLE), 1));
    }
    
    org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callEntityDeathEvent(this, loot);
  }
  
  public boolean hasSaddle()
  {
    return (datawatcher.getByte(16) & 0x1) != 0;
  }
  
  public void setSaddle(boolean flag) {
    if (flag) {
      datawatcher.watch(16, Byte.valueOf((byte)1));
    } else {
      datawatcher.watch(16, Byte.valueOf((byte)0));
    }
  }
  
  public void a(EntityLightning entitylightning) {
    if (!world.isStatic) {
      EntityPigZombie entitypigzombie = new EntityPigZombie(world);
      

      if (org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callPigZapEvent(this, entitylightning, entitypigzombie).isCancelled()) {
        return;
      }
      

      entitypigzombie.setEquipment(0, new ItemStack(Items.GOLD_SWORD));
      entitypigzombie.setPositionRotation(locX, locY, locZ, yaw, pitch);
      
      world.addEntity(entitypigzombie, org.bukkit.event.entity.CreatureSpawnEvent.SpawnReason.LIGHTNING);
      die();
    }
  }
  
  protected void b(float f) {
    super.b(f);
    if ((f > 5.0F) && ((passenger instanceof EntityHuman))) {
      ((EntityHuman)passenger).a(AchievementList.u);
    }
  }
  
  public EntityPig b(EntityAgeable entityageable) {
    return new EntityPig(world);
  }
  
  public boolean c(ItemStack itemstack) {
    return (itemstack != null) && (itemstack.getItem() == Items.CARROT);
  }
  
  public PathfinderGoalPassengerCarrotStick bY() {
    return bp;
  }
  
  public EntityAgeable createChild(EntityAgeable entityageable) {
    return b(entityageable);
  }
}
