package net.minecraft.server.v1_7_R1;

import java.util.List;
import java.util.Random;
import java.util.UUID;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftEntity;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack;
import org.bukkit.event.entity.EntityTargetEvent;
import org.bukkit.plugin.PluginManager;

public class EntityPigZombie extends EntityZombie
{
  private static final UUID bq = UUID.fromString("49455A49-7EC5-45BA-B886-3B90B23A1718");
  private static final AttributeModifier br = new AttributeModifier(bq, "Attacking speed boost", 0.45D, 0).a(false);
  public int angerLevel;
  private int soundDelay;
  private Entity bu;
  
  public EntityPigZombie(World world) {
    super(world);
    fireProof = true;
  }
  
  protected void aD() {
    super.aD();
    getAttributeInstance(bp).setValue(0.0D);
    getAttributeInstance(GenericAttributes.d).setValue(0.5D);
    getAttributeInstance(GenericAttributes.e).setValue(5.0D);
  }
  
  protected boolean bk() {
    return false;
  }
  
  public void h() {
    if ((bu != target) && (!world.isStatic)) {
      AttributeInstance attributeinstance = getAttributeInstance(GenericAttributes.d);
      
      attributeinstance.b(br);
      if (target != null) {
        attributeinstance.a(br);
      }
    }
    
    bu = target;
    if ((soundDelay > 0) && (--soundDelay == 0)) {
      makeSound("mob.zombiepig.zpigangry", bf() * 2.0F, ((random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F) * 1.8F);
    }
    
    super.h();
  }
  
  public boolean canSpawn() {
    return (world.difficulty != EnumDifficulty.PEACEFUL) && (world.b(boundingBox)) && (world.getCubes(this, boundingBox).isEmpty()) && (!world.containsLiquid(boundingBox));
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    nbttagcompound.setShort("Anger", (short)angerLevel);
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    angerLevel = nbttagcompound.getShort("Anger");
  }
  
  protected Entity findTarget() {
    return angerLevel == 0 ? null : super.findTarget();
  }
  
  public boolean damageEntity(DamageSource damagesource, float f) {
    if (isInvulnerable()) {
      return false;
    }
    Entity entity = damagesource.getEntity();
    
    if ((entity instanceof EntityHuman)) {
      List list = world.getEntities(this, boundingBox.grow(32.0D, 32.0D, 32.0D));
      
      for (int i = 0; i < list.size(); i++) {
        Entity entity1 = (Entity)list.get(i);
        
        if ((entity1 instanceof EntityPigZombie)) {
          EntityPigZombie entitypigzombie = (EntityPigZombie)entity1;
          
          entitypigzombie.c(entity);
        }
      }
      
      c(entity);
    }
    
    return super.damageEntity(damagesource, f);
  }
  

  private void c(Entity entity)
  {
    org.bukkit.entity.Entity bukkitTarget = entity == null ? null : entity.getBukkitEntity();
    
    EntityTargetEvent event = new EntityTargetEvent(getBukkitEntity(), bukkitTarget, org.bukkit.event.entity.EntityTargetEvent.TargetReason.PIG_ZOMBIE_TARGET);
    world.getServer().getPluginManager().callEvent(event);
    
    if (event.isCancelled()) {
      return;
    }
    
    if (event.getTarget() == null) {
      target = null;
      return;
    }
    entity = ((CraftEntity)event.getTarget()).getHandle();
    

    target = entity;
    angerLevel = (400 + random.nextInt(400));
    soundDelay = random.nextInt(40);
  }
  
  protected String t() {
    return "mob.zombiepig.zpig";
  }
  
  protected String aT() {
    return "mob.zombiepig.zpighurt";
  }
  
  protected String aU() {
    return "mob.zombiepig.zpigdeath";
  }
  
  protected void dropDeathLoot(boolean flag, int i)
  {
    List<org.bukkit.inventory.ItemStack> loot = new java.util.ArrayList();
    int j = random.nextInt(2 + i);
    
    if (j > 0) {
      loot.add(CraftItemStack.asNewCraftStack(Items.ROTTEN_FLESH, j));
    }
    
    j = random.nextInt(2 + i);
    
    if (j > 0) {
      loot.add(CraftItemStack.asNewCraftStack(Items.GOLD_NUGGET, j));
    }
    

    if (lastDamageByPlayerTime > 0) {
      int k = random.nextInt(200) - i;
      
      if (k < 5) {
        ItemStack itemstack = getRareDrop(k <= 0 ? 1 : 0);
        if (itemstack != null) {
          loot.add(CraftItemStack.asCraftMirror(itemstack));
        }
      }
    }
    
    org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callEntityDeathEvent(this, loot);
  }
  
  public boolean a(EntityHuman entityhuman)
  {
    return false;
  }
  
  protected ItemStack getRareDrop(int i)
  {
    return new ItemStack(Items.GOLD_INGOT, 1, 0);
  }
  
  protected void bA()
  {
    setEquipment(0, new ItemStack(Items.GOLD_SWORD));
  }
  
  public GroupDataEntity a(GroupDataEntity groupdataentity) {
    super.a(groupdataentity);
    setVillager(false);
    return groupdataentity;
  }
}
