package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.Collection;
import java.util.EnumSet;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Random;
import net.minecraft.util.com.google.common.collect.Sets;
import net.minecraft.util.com.mojang.authlib.GameProfile;
import org.apache.logging.log4j.Logger;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Server;
import org.bukkit.WeatherType;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftPlayer;
import org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack;
import org.bukkit.craftbukkit.v1_7_R1.scoreboard.CraftScoreboardManager;
import org.bukkit.craftbukkit.v1_7_R1.util.CraftChatMessage;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.event.inventory.InventoryType;
import org.bukkit.event.player.PlayerTeleportEvent.TeleportCause;

public class EntityPlayer extends EntityHuman implements ICrafting
{
  private static final Logger bM = ;
  private String locale = "en_US";
  public PlayerConnection playerConnection;
  public final MinecraftServer server;
  public final PlayerInteractManager playerInteractManager;
  public double d;
  public double e;
  public final List chunkCoordIntPairQueue = new LinkedList();
  public final List removeQueue = new LinkedList();
  private final ServerStatisticManager bO;
  private float bP = 1.4E-45F;
  private float bQ = -1.0E+008F;
  private int bR = -99999999;
  private boolean bS = true;
  public int lastSentExp = -99999999;
  public int invulnerableTicks = 60;
  private int bV;
  private EnumChatVisibility bW;
  private boolean bX = true;
  private long bY = 0L;
  
  private int containerCounter;
  public boolean h;
  public int ping;
  public boolean viewingCredits;
  public String displayName;
  public String listName;
  public Location compassTarget;
  public int newExp = 0;
  public int newLevel = 0;
  public int newTotalExp = 0;
  public boolean keepLevel = false;
  public double maxHealthCache;
  
  public EntityPlayer(MinecraftServer minecraftserver, WorldServer worldserver, GameProfile gameprofile, PlayerInteractManager playerinteractmanager)
  {
    super(worldserver, gameprofile);
    player = this;
    playerInteractManager = playerinteractmanager;
    bV = minecraftserver.getPlayerList().o();
    ChunkCoordinates chunkcoordinates = worldserver.getSpawn();
    int i = x;
    int j = z;
    int k = y;
    
    if ((!worldProvider.g) && (worldserver.getWorldData().getGameType() != EnumGamemode.ADVENTURE)) {
      int l = Math.max(5, minecraftserver.getSpawnProtection() - 6);
      
      i += random.nextInt(l * 2) - l;
      j += random.nextInt(l * 2) - l;
      k = worldserver.i(i, j);
    }
    
    server = minecraftserver;
    bO = minecraftserver.getPlayerList().i(getName());
    X = 0.0F;
    height = 0.0F;
    setPositionRotation(i + 0.5D, k, j + 0.5D, 0.0F, 0.0F);
    
    while (!worldserver.getCubes(this, boundingBox).isEmpty()) {
      setPosition(locX, locY + 1.0D, locZ);
    }
    

    displayName = getName();
    listName = getName();
    
    maxHealthCache = getMaxHealth();
  }
  
  public void a(NBTTagCompound nbttagcompound)
  {
    super.a(nbttagcompound);
    if (nbttagcompound.hasKeyOfType("playerGameType", 99)) {
      if (MinecraftServer.getServer().getForceGamemode()) {
        playerInteractManager.setGameMode(MinecraftServer.getServer().getGamemode());
      } else {
        playerInteractManager.setGameMode(EnumGamemode.a(nbttagcompound.getInt("playerGameType")));
      }
    }
    getBukkitEntity().readExtraData(nbttagcompound);
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    nbttagcompound.setInt("playerGameType", playerInteractManager.getGameMode().a());
    getBukkitEntity().setExtraData(nbttagcompound);
  }
  
  public void spawnIn(World world)
  {
    super.spawnIn(world);
    if (world == null) {
      dead = false;
      ChunkCoordinates position = null;
      if ((spawnWorld != null) && (!spawnWorld.equals(""))) {
        CraftWorld cworld = (CraftWorld)Bukkit.getServer().getWorld(spawnWorld);
        if ((cworld != null) && (getBed() != null)) {
          world = cworld.getHandle();
          position = EntityHuman.getBed(cworld.getHandle(), getBed(), false);
        }
      }
      if ((world == null) || (position == null)) {
        world = ((CraftWorld)Bukkit.getServer().getWorlds().get(0)).getHandle();
        position = world.getSpawn();
      }
      this.world = world;
      setPosition(x + 0.5D, y, z + 0.5D);
    }
    dimension = worlddimension;
    playerInteractManager.a((WorldServer)world);
  }
  
  public void levelDown(int i)
  {
    super.levelDown(i);
    lastSentExp = -1;
  }
  
  public void syncInventory() {
    activeContainer.addSlotListener(this);
  }
  
  protected void e_() {
    height = 0.0F;
  }
  
  public float getHeadHeight() {
    return 1.62F;
  }
  
  public void h() {
    playerInteractManager.a();
    invulnerableTicks -= 1;
    if (noDamageTicks > 0) {
      noDamageTicks -= 1;
    }
    
    activeContainer.b();
    if ((!world.isStatic) && (!activeContainer.a(this))) {
      closeInventory();
      activeContainer = defaultContainer;
    }
    
    while (!removeQueue.isEmpty()) {
      int i = Math.min(removeQueue.size(), 127);
      int[] aint = new int[i];
      Iterator iterator = removeQueue.iterator();
      int j = 0;
      
      while ((iterator.hasNext()) && (j < i)) {
        aint[(j++)] = ((Integer)iterator.next()).intValue();
        iterator.remove();
      }
      
      playerConnection.sendPacket(new PacketPlayOutEntityDestroy(aint));
    }
    
    if (!chunkCoordIntPairQueue.isEmpty()) {
      ArrayList arraylist = new ArrayList();
      Iterator iterator1 = chunkCoordIntPairQueue.iterator();
      ArrayList arraylist1 = new ArrayList();
      


      while ((iterator1.hasNext()) && (arraylist.size() < PacketPlayOutMapChunkBulk.c())) {
        ChunkCoordIntPair chunkcoordintpair = (ChunkCoordIntPair)iterator1.next();
        
        if (chunkcoordintpair != null) {
          if (world.isLoaded(x << 4, 0, z << 4)) {
            Chunk chunk = world.getChunkAt(x, z);
            if (chunk.k()) {
              arraylist.add(chunk);
              arraylist1.addAll(tileEntities.values());
              iterator1.remove();
            }
          }
        } else {
          iterator1.remove();
        }
      }
      
      if (!arraylist.isEmpty()) {
        playerConnection.sendPacket(new PacketPlayOutMapChunkBulk(arraylist));
        Iterator iterator2 = arraylist1.iterator();
        
        while (iterator2.hasNext()) {
          TileEntity tileentity = (TileEntity)iterator2.next();
          
          b(tileentity);
        }
        
        iterator2 = arraylist.iterator();
        
        while (iterator2.hasNext()) {
          Chunk chunk = (Chunk)iterator2.next();
          r().getTracker().a(this, chunk);
        }
      }
    }
    
    if ((bY > 0L) && (server.aq() > 0) && (MinecraftServer.ap() - bY > server.aq() * 1000 * 60)) {
      playerConnection.disconnect("You have been idle for too long!");
    }
  }
  
  public void i() {
    try {
      super.h();
      
      for (int i = 0; i < inventory.getSize(); i++) {
        ItemStack itemstack = inventory.getItem(i);
        
        if ((itemstack != null) && (itemstack.getItem().h())) {
          Packet packet = ((ItemWorldMapBase)itemstack.getItem()).c(itemstack, world, this);
          
          if (packet != null) {
            playerConnection.sendPacket(packet);
          }
        }
      }
      

      if ((getHealth() == bQ) && (bR == foodData.a())) { if ((foodData.e() == 0.0F) == bS) {}
      } else { playerConnection.sendPacket(new PacketPlayOutUpdateHealth(getBukkitEntity().getScaledHealth(), foodData.a(), foodData.e()));
        bQ = getHealth();
        bR = foodData.a();
        bS = (foodData.e() == 0.0F);
      }
      
      if (getHealth() + bs() != bP) {
        bP = (getHealth() + bs());
        
        world.getServer().getScoreboardManager().updateAllScoresForList(IScoreboardCriteria.f, getName(), com.google.common.collect.ImmutableList.of(this));
      }
      

      if (maxHealthCache != getMaxHealth()) {
        getBukkitEntity().updateScaledHealth();
      }
      

      if (expTotal != lastSentExp) {
        lastSentExp = expTotal;
        playerConnection.sendPacket(new PacketPlayOutExperience(exp, expTotal, expLevel));
      }
      
      if ((ticksLived % 20 * 5 == 0) && (!x().a(AchievementList.L))) {
        j();
      }
      

      if (oldLevel == -1) {
        oldLevel = expLevel;
      }
      
      if (oldLevel != expLevel) {
        CraftEventFactory.callPlayerLevelChangeEvent(world.getServer().getPlayer(this), oldLevel, expLevel);
        oldLevel = expLevel;
      }
    }
    catch (Throwable throwable) {
      CrashReport crashreport = CrashReport.a(throwable, "Ticking player");
      CrashReportSystemDetails crashreportsystemdetails = crashreport.a("Player being ticked");
      
      a(crashreportsystemdetails);
      throw new ReportedException(crashreport);
    }
  }
  
  protected void j() {
    BiomeBase biomebase = world.getBiome(MathHelper.floor(locX), MathHelper.floor(locZ));
    
    if (biomebase != null) {
      String s = af;
      AchievementSet achievementset = (AchievementSet)x().b(AchievementList.L);
      
      if (achievementset == null) {
        achievementset = (AchievementSet)x().a(AchievementList.L, new AchievementSet());
      }
      
      achievementset.add(s);
      if ((x().b(AchievementList.L)) && (achievementset.size() == BiomeBase.n.size())) {
        HashSet hashset = Sets.newHashSet(BiomeBase.n);
        Iterator iterator = achievementset.iterator();
        
        while (iterator.hasNext()) {
          String s1 = (String)iterator.next();
          Iterator iterator1 = hashset.iterator();
          
          while (iterator1.hasNext()) {
            BiomeBase biomebase1 = (BiomeBase)iterator1.next();
            
            if (af.equals(s1)) {
              iterator1.remove();
            }
          }
          
          if (hashset.isEmpty()) {
            break;
          }
        }
        
        if (hashset.isEmpty()) {
          a(AchievementList.L);
        }
      }
    }
  }
  
  public void die(DamageSource damagesource)
  {
    if (dead) {
      return;
    }
    
    List<org.bukkit.inventory.ItemStack> loot = new ArrayList();
    boolean keepInventory = world.getGameRules().getBoolean("keepInventory");
    
    if (!keepInventory) {
      for (int i = 0; i < inventory.items.length; i++) {
        if (inventory.items[i] != null) {
          loot.add(CraftItemStack.asCraftMirror(inventory.items[i]));
        }
      }
      
      for (int i = 0; i < inventory.armor.length; i++) {
        if (inventory.armor[i] != null) {
          loot.add(CraftItemStack.asCraftMirror(inventory.armor[i]));
        }
      }
    }
    
    IChatBaseComponent chatmessage = aW().b();
    
    String deathmessage = chatmessage.c();
    PlayerDeathEvent event = CraftEventFactory.callPlayerDeathEvent(this, loot, deathmessage);
    
    String deathMessage = event.getDeathMessage();
    
    if ((deathMessage != null) && (deathMessage.length() > 0)) {
      if (deathMessage.equals(deathmessage)) {
        server.getPlayerList().sendMessage(chatmessage);
      } else {
        server.getPlayerList().sendMessage(CraftChatMessage.fromString(deathMessage));
      }
    }
    

    if (!keepInventory) {
      for (int i = 0; i < inventory.items.length; i++) {
        inventory.items[i] = null;
      }
      
      for (int i = 0; i < inventory.armor.length; i++) {
        inventory.armor[i] = null;
      }
    }
    
    closeInventory();
    


    Collection<ScoreboardScore> collection = world.getServer().getScoreboardManager().getScoreboardScores(IScoreboardCriteria.c, getName(), new ArrayList());
    Iterator iterator = collection.iterator();
    
    while (iterator.hasNext()) {
      ScoreboardScore scoreboardscore = (ScoreboardScore)iterator.next();
      
      scoreboardscore.incrementScore();
    }
    
    EntityLiving entityliving = aX();
    
    if (entityliving != null) {
      int i = EntityTypes.a(entityliving);
      MonsterEggInfo monsteregginfo = (MonsterEggInfo)EntityTypes.a.get(Integer.valueOf(i));
      
      if (monsteregginfo != null) {
        a(e, 1);
      }
      
      entityliving.b(this, bb);
    }
    
    a(StatisticList.v, 1);
  }
  
  public boolean damageEntity(DamageSource damagesource, float f) {
    if (isInvulnerable()) {
      return false;
    }
    
    boolean flag = (server.V()) && (world.pvpMode) && ("fall".equals(translationIndex));
    
    if ((!flag) && (invulnerableTicks > 0) && (damagesource != DamageSource.OUT_OF_WORLD)) {
      return false;
    }
    if ((damagesource instanceof EntityDamageSource)) {
      Entity entity = damagesource.getEntity();
      
      if (((entity instanceof EntityHuman)) && (!a((EntityHuman)entity))) {
        return false;
      }
      
      if ((entity instanceof EntityArrow)) {
        EntityArrow entityarrow = (EntityArrow)entity;
        
        if (((shooter instanceof EntityHuman)) && (!a((EntityHuman)shooter))) {
          return false;
        }
      }
    }
    
    return super.damageEntity(damagesource, f);
  }
  


  public boolean a(EntityHuman entityhuman)
  {
    return !world.pvpMode ? false : super.a(entityhuman);
  }
  
  public void b(int i) {
    if ((dimension == 1) && (i == 1)) {
      a(AchievementList.D);
      world.kill(this);
      viewingCredits = true;
      playerConnection.sendPacket(new PacketPlayOutGameStateChange(4, 0.0F));
    } else {
      if ((dimension == 0) && (i == 1)) {
        a(AchievementList.C);





      }
      else
      {




        a(AchievementList.y);
      }
      

      PlayerTeleportEvent.TeleportCause cause = (dimension == 1) || (i == 1) ? PlayerTeleportEvent.TeleportCause.END_PORTAL : PlayerTeleportEvent.TeleportCause.NETHER_PORTAL;
      server.getPlayerList().changeDimension(this, i, cause);
      
      lastSentExp = -1;
      bQ = -1.0F;
      bR = -1;
    }
  }
  
  private void b(TileEntity tileentity) {
    if (tileentity != null) {
      Packet packet = tileentity.getUpdatePacket();
      
      if (packet != null) {
        playerConnection.sendPacket(packet);
      }
    }
  }
  
  public void receive(Entity entity, int i) {
    super.receive(entity, i);
    activeContainer.b();
  }
  
  public EnumBedResult a(int i, int j, int k) {
    EnumBedResult enumbedresult = super.a(i, j, k);
    
    if (enumbedresult == EnumBedResult.OK) {
      PacketPlayOutBed packetplayoutbed = new PacketPlayOutBed(this, i, j, k);
      
      r().getTracker().a(this, packetplayoutbed);
      playerConnection.a(locX, locY, locZ, yaw, pitch);
      playerConnection.sendPacket(packetplayoutbed);
    }
    
    return enumbedresult;
  }
  
  public void a(boolean flag, boolean flag1, boolean flag2) {
    if ((fauxSleeping) && (!sleeping)) { return;
    }
    if (isSleeping()) {
      r().getTracker().sendPacketToEntity(this, new PacketPlayOutAnimation(this, 2));
    }
    
    super.a(flag, flag1, flag2);
    if (playerConnection != null) {
      playerConnection.a(locX, locY, locZ, yaw, pitch);
    }
  }
  
  public void mount(Entity entity)
  {
    setPassengerOf(entity);
  }
  

  public void setPassengerOf(Entity entity)
  {
    Entity currentVehicle = vehicle;
    
    super.setPassengerOf(entity);
    

    if (currentVehicle != vehicle) {
      playerConnection.sendPacket(new PacketPlayOutAttachEntity(0, this, vehicle));
      playerConnection.a(locX, locY, locZ, yaw, pitch);
    }
  }
  
  protected void a(double d0, boolean flag) {}
  
  public void b(double d0, boolean flag)
  {
    super.a(d0, flag);
  }
  
  public void a(TileEntity tileentity) {
    if ((tileentity instanceof TileEntitySign)) {
      ((TileEntitySign)tileentity).a(this);
      playerConnection.sendPacket(new PacketPlayOutOpenSignEditor(x, y, z));
    }
  }
  
  public int nextContainerCounter() {
    containerCounter = (containerCounter % 100 + 1);
    return containerCounter;
  }
  
  public void startCrafting(int i, int j, int k)
  {
    Container container = CraftEventFactory.callInventoryOpenEvent(this, new ContainerWorkbench(inventory, world, i, j, k));
    if (container == null) { return;
    }
    
    nextContainerCounter();
    playerConnection.sendPacket(new PacketPlayOutOpenWindow(containerCounter, 1, "Crafting", 9, true));
    activeContainer = container;
    activeContainer.windowId = containerCounter;
    activeContainer.addSlotListener(this);
  }
  
  public void startEnchanting(int i, int j, int k, String s)
  {
    Container container = CraftEventFactory.callInventoryOpenEvent(this, new ContainerEnchantTable(inventory, world, i, j, k));
    if (container == null) { return;
    }
    
    nextContainerCounter();
    playerConnection.sendPacket(new PacketPlayOutOpenWindow(containerCounter, 4, s == null ? "" : s, 9, s != null));
    activeContainer = container;
    activeContainer.windowId = containerCounter;
    activeContainer.addSlotListener(this);
  }
  
  public void openAnvil(int i, int j, int k)
  {
    Container container = CraftEventFactory.callInventoryOpenEvent(this, new ContainerAnvil(inventory, world, i, j, k, this));
    if (container == null) { return;
    }
    
    nextContainerCounter();
    playerConnection.sendPacket(new PacketPlayOutOpenWindow(containerCounter, 8, "Repairing", 9, true));
    activeContainer = container;
    activeContainer.windowId = containerCounter;
    activeContainer.addSlotListener(this);
  }
  
  public void openContainer(IInventory iinventory) {
    if (activeContainer != defaultContainer) {
      closeInventory();
    }
    

    Container container = CraftEventFactory.callInventoryOpenEvent(this, new ContainerChest(inventory, iinventory));
    if (container == null) { return;
    }
    
    nextContainerCounter();
    playerConnection.sendPacket(new PacketPlayOutOpenWindow(containerCounter, 0, iinventory.getInventoryName(), iinventory.getSize(), iinventory.k_()));
    activeContainer = container;
    activeContainer.windowId = containerCounter;
    activeContainer.addSlotListener(this);
  }
  
  public void openHopper(TileEntityHopper tileentityhopper)
  {
    Container container = CraftEventFactory.callInventoryOpenEvent(this, new ContainerHopper(inventory, tileentityhopper));
    if (container == null) { return;
    }
    
    nextContainerCounter();
    playerConnection.sendPacket(new PacketPlayOutOpenWindow(containerCounter, 9, tileentityhopper.getInventoryName(), tileentityhopper.getSize(), tileentityhopper.k_()));
    activeContainer = container;
    activeContainer.windowId = containerCounter;
    activeContainer.addSlotListener(this);
  }
  
  public void openMinecartHopper(EntityMinecartHopper entityminecarthopper)
  {
    Container container = CraftEventFactory.callInventoryOpenEvent(this, new ContainerHopper(inventory, entityminecarthopper));
    if (container == null) { return;
    }
    
    nextContainerCounter();
    playerConnection.sendPacket(new PacketPlayOutOpenWindow(containerCounter, 9, entityminecarthopper.getInventoryName(), entityminecarthopper.getSize(), entityminecarthopper.k_()));
    activeContainer = container;
    activeContainer.windowId = containerCounter;
    activeContainer.addSlotListener(this);
  }
  
  public void openFurnace(TileEntityFurnace tileentityfurnace)
  {
    Container container = CraftEventFactory.callInventoryOpenEvent(this, new ContainerFurnace(inventory, tileentityfurnace));
    if (container == null) { return;
    }
    
    nextContainerCounter();
    playerConnection.sendPacket(new PacketPlayOutOpenWindow(containerCounter, 2, tileentityfurnace.getInventoryName(), tileentityfurnace.getSize(), tileentityfurnace.k_()));
    activeContainer = container;
    activeContainer.windowId = containerCounter;
    activeContainer.addSlotListener(this);
  }
  
  public void openDispenser(TileEntityDispenser tileentitydispenser)
  {
    Container container = CraftEventFactory.callInventoryOpenEvent(this, new ContainerDispenser(inventory, tileentitydispenser));
    if (container == null) { return;
    }
    
    nextContainerCounter();
    playerConnection.sendPacket(new PacketPlayOutOpenWindow(containerCounter, (tileentitydispenser instanceof TileEntityDropper) ? 10 : 3, tileentitydispenser.getInventoryName(), tileentitydispenser.getSize(), tileentitydispenser.k_()));
    activeContainer = container;
    activeContainer.windowId = containerCounter;
    activeContainer.addSlotListener(this);
  }
  
  public void openBrewingStand(TileEntityBrewingStand tileentitybrewingstand)
  {
    Container container = CraftEventFactory.callInventoryOpenEvent(this, new ContainerBrewingStand(inventory, tileentitybrewingstand));
    if (container == null) { return;
    }
    
    nextContainerCounter();
    playerConnection.sendPacket(new PacketPlayOutOpenWindow(containerCounter, 5, tileentitybrewingstand.getInventoryName(), tileentitybrewingstand.getSize(), tileentitybrewingstand.k_()));
    activeContainer = container;
    activeContainer.windowId = containerCounter;
    activeContainer.addSlotListener(this);
  }
  
  public void openBeacon(TileEntityBeacon tileentitybeacon)
  {
    Container container = CraftEventFactory.callInventoryOpenEvent(this, new ContainerBeacon(inventory, tileentitybeacon));
    if (container == null) { return;
    }
    
    nextContainerCounter();
    playerConnection.sendPacket(new PacketPlayOutOpenWindow(containerCounter, 7, tileentitybeacon.getInventoryName(), tileentitybeacon.getSize(), tileentitybeacon.k_()));
    activeContainer = container;
    activeContainer.windowId = containerCounter;
    activeContainer.addSlotListener(this);
  }
  
  public void openTrade(IMerchant imerchant, String s)
  {
    Container container = CraftEventFactory.callInventoryOpenEvent(this, new ContainerMerchant(inventory, imerchant, world));
    if (container == null) { return;
    }
    
    nextContainerCounter();
    activeContainer = container;
    activeContainer.windowId = containerCounter;
    activeContainer.addSlotListener(this);
    InventoryMerchant inventorymerchant = ((ContainerMerchant)activeContainer).getMerchantInventory();
    
    playerConnection.sendPacket(new PacketPlayOutOpenWindow(containerCounter, 6, s == null ? "" : s, inventorymerchant.getSize(), s != null));
    MerchantRecipeList merchantrecipelist = imerchant.getOffers(this);
    
    if (merchantrecipelist != null) {
      try {
        PacketDataSerializer packetdataserializer = new PacketDataSerializer(net.minecraft.util.io.netty.buffer.Unpooled.buffer());
        
        packetdataserializer.writeInt(containerCounter);
        merchantrecipelist.a(packetdataserializer);
        playerConnection.sendPacket(new PacketPlayOutCustomPayload("MC|TrList", packetdataserializer));
      } catch (Exception ioexception) {
        bM.error("Couldn't send trade list", ioexception);
      }
    }
  }
  
  public void openHorseInventory(EntityHorse entityhorse, IInventory iinventory)
  {
    Container container = CraftEventFactory.callInventoryOpenEvent(this, new ContainerHorse(inventory, iinventory, entityhorse));
    if (container == null) { return;
    }
    
    if (activeContainer != defaultContainer) {
      closeInventory();
    }
    
    nextContainerCounter();
    playerConnection.sendPacket(new PacketPlayOutOpenWindow(containerCounter, 11, iinventory.getInventoryName(), iinventory.getSize(), iinventory.k_(), entityhorse.getId()));
    activeContainer = container;
    activeContainer.windowId = containerCounter;
    activeContainer.addSlotListener(this);
  }
  
  public void a(Container container, int i, ItemStack itemstack) {
    if ((!(container.getSlot(i) instanceof SlotResult)) && 
      (!h)) {
      playerConnection.sendPacket(new PacketPlayOutSetSlot(windowId, i, itemstack));
    }
  }
  
  public void updateInventory(Container container)
  {
    a(container, container.a());
  }
  
  public void a(Container container, List list) {
    playerConnection.sendPacket(new PacketPlayOutWindowItems(windowId, list));
    playerConnection.sendPacket(new PacketPlayOutSetSlot(-1, -1, inventory.getCarried()));
    
    if (EnumSet.of(InventoryType.CRAFTING, InventoryType.WORKBENCH).contains(container.getBukkitView().getType())) {
      playerConnection.sendPacket(new PacketPlayOutSetSlot(windowId, 0, container.getSlot(0).getItem()));
    }
  }
  
  public void setContainerData(Container container, int i, int j)
  {
    playerConnection.sendPacket(new PacketPlayOutCraftProgressBar(windowId, i, j));
  }
  
  public void closeInventory() {
    CraftEventFactory.handleInventoryCloseEvent(this);
    playerConnection.sendPacket(new PacketPlayOutCloseWindow(activeContainer.windowId));
    m();
  }
  
  public void broadcastCarriedItem() {
    if (!h) {
      playerConnection.sendPacket(new PacketPlayOutSetSlot(-1, -1, inventory.getCarried()));
    }
  }
  
  public void m() {
    activeContainer.b(this);
    activeContainer = defaultContainer;
  }
  
  public void a(float f, float f1, boolean flag, boolean flag1) {
    if (vehicle != null) {
      if ((f >= -1.0F) && (f <= 1.0F)) {
        be = f;
      }
      
      if ((f1 >= -1.0F) && (f1 <= 1.0F)) {
        bf = f1;
      }
      
      bd = flag;
      setSneaking(flag1);
    }
  }
  
  public void a(Statistic statistic, int i) {
    if (statistic != null) {
      bO.b(this, statistic, i);
      Iterator iterator = getScoreboard().getObjectivesForCriteria(statistic.k()).iterator();
      
      while (iterator.hasNext()) {
        ScoreboardObjective scoreboardobjective = (ScoreboardObjective)iterator.next();
        
        getScoreboard().getPlayerScoreForObjective(getName(), scoreboardobjective).incrementScore();
      }
      
      if (bO.e()) {
        bO.a(this);
      }
    }
  }
  
  public void n() {
    if (passenger != null) {
      passenger.mount(this);
    }
    
    if (sleeping) {
      a(true, false, false);
    }
  }
  
  public void triggerHealthUpdate() {
    bQ = -1.0E+008F;
    lastSentExp = -1;
  }
  
  public void b(IChatBaseComponent ichatbasecomponent) {
    playerConnection.sendPacket(new PacketPlayOutChat(ichatbasecomponent));
  }
  
  protected void p() {
    playerConnection.sendPacket(new PacketPlayOutEntityStatus(this, (byte)9));
    super.p();
  }
  
  public void a(ItemStack itemstack, int i) {
    super.a(itemstack, i);
    if ((itemstack != null) && (itemstack.getItem() != null) && (itemstack.getItem().d(itemstack) == EnumAnimation.EAT)) {
      r().getTracker().sendPacketToEntity(this, new PacketPlayOutAnimation(this, 3));
    }
  }
  
  public void copyTo(EntityHuman entityhuman, boolean flag) {
    super.copyTo(entityhuman, flag);
    lastSentExp = -1;
    bQ = -1.0F;
    bR = -1;
    removeQueue.addAll(removeQueue);
  }
  
  protected void a(MobEffect mobeffect) {
    super.a(mobeffect);
    playerConnection.sendPacket(new PacketPlayOutEntityEffect(getId(), mobeffect));
  }
  
  protected void a(MobEffect mobeffect, boolean flag) {
    super.a(mobeffect, flag);
    playerConnection.sendPacket(new PacketPlayOutEntityEffect(getId(), mobeffect));
  }
  
  protected void b(MobEffect mobeffect) {
    super.b(mobeffect);
    playerConnection.sendPacket(new PacketPlayOutRemoveEntityEffect(getId(), mobeffect));
  }
  
  public void enderTeleportTo(double d0, double d1, double d2) {
    playerConnection.a(d0, d1, d2, yaw, pitch);
  }
  
  public void b(Entity entity) {
    r().getTracker().sendPacketToEntity(this, new PacketPlayOutAnimation(entity, 4));
  }
  
  public void c(Entity entity) {
    r().getTracker().sendPacketToEntity(this, new PacketPlayOutAnimation(entity, 5));
  }
  
  public void updateAbilities() {
    if (playerConnection != null) {
      playerConnection.sendPacket(new PacketPlayOutAbilities(abilities));
    }
  }
  
  public WorldServer r() {
    return (WorldServer)world;
  }
  
  public void a(EnumGamemode enumgamemode) {
    playerInteractManager.setGameMode(enumgamemode);
    playerConnection.sendPacket(new PacketPlayOutGameStateChange(3, enumgamemode.a()));
  }
  
  public void sendMessage(IChatBaseComponent[] ichatbasecomponent)
  {
    for (IChatBaseComponent component : ichatbasecomponent) {
      sendMessage(component);
    }
  }
  
  public void sendMessage(IChatBaseComponent ichatbasecomponent)
  {
    playerConnection.sendPacket(new PacketPlayOutChat(ichatbasecomponent));
  }
  
  public boolean a(int i, String s) {
    return ("seed".equals(s)) && (!server.V());
  }
  
  public String s() {
    String s = playerConnection.networkManager.getSocketAddress().toString();
    
    s = s.substring(s.indexOf("/") + 1);
    s = s.substring(0, s.indexOf(":"));
    return s;
  }
  
  public void a(PacketPlayInSettings packetplayinsettings) {
    locale = packetplayinsettings.c();
    int i = 256 >> packetplayinsettings.d();
    
    if ((i > 3) && (i < 15)) {
      bV = i;
    }
    
    bW = packetplayinsettings.e();
    bX = packetplayinsettings.f();
    if ((server.L()) && (server.K().equals(getName()))) {
      server.a(packetplayinsettings.g());
    }
    
    b(1, !packetplayinsettings.h());
  }
  
  public EnumChatVisibility getChatFlags() {
    return bW;
  }
  
  public void a(String s) {
    playerConnection.sendPacket(new PacketPlayOutCustomPayload("MC|RPack", s.getBytes(net.minecraft.util.org.apache.commons.io.Charsets.UTF_8)));
  }
  
  public ChunkCoordinates getChunkCoordinates() {
    return new ChunkCoordinates(MathHelper.floor(locX), MathHelper.floor(locY + 0.5D), MathHelper.floor(locZ));
  }
  
  public void w() {
    bY = MinecraftServer.ap();
  }
  
  public ServerStatisticManager x() {
    return bO;
  }
  

  public long timeOffset = 0L;
  public boolean relativeTime = true;
  
  public long getPlayerTime() {
    if (relativeTime)
    {
      return world.getDayTime() + timeOffset;
    }
    
    return world.getDayTime() - world.getDayTime() % 24000L + timeOffset;
  }
  

  public WeatherType weather = null;
  
  public WeatherType getPlayerWeather() {
    return weather;
  }
  
  public void setPlayerWeather(WeatherType type, boolean plugin) {
    if ((!plugin) && (weather != null)) {
      return;
    }
    
    if (plugin) {
      weather = type;
    }
    
    if (type == WeatherType.DOWNFALL) {
      playerConnection.sendPacket(new PacketPlayOutGameStateChange(2, 0.0F));
    }
    else
    {
      playerConnection.sendPacket(new PacketPlayOutGameStateChange(1, 0.0F));
    }
  }
  
  public void resetPlayerWeather() {
    weather = null;
    setPlayerWeather(world.getWorldData().hasStorm() ? WeatherType.DOWNFALL : WeatherType.CLEAR, false);
  }
  
  public String toString()
  {
    return super.toString() + "(" + getName() + " at " + locX + "," + locY + "," + locZ + ")";
  }
  
  public void reset() {
    float exp = 0.0F;
    boolean keepInventory = world.getGameRules().getBoolean("keepInventory");
    
    if ((keepLevel) || (keepInventory)) {
      exp = this.exp;
      newTotalExp = expTotal;
      newLevel = expLevel;
    }
    
    setHealth(getMaxHealth());
    fireTicks = 0;
    fallDistance = 0.0F;
    foodData = new FoodMetaData(this);
    expLevel = newLevel;
    expTotal = newTotalExp;
    this.exp = 0.0F;
    deathTicks = 0;
    aP();
    updateEffects = true;
    activeContainer = defaultContainer;
    killer = null;
    lastDamager = null;
    combatTracker = new CombatTracker(this);
    lastSentExp = -1;
    if ((keepLevel) || (keepInventory)) {
      this.exp = exp;
    } else {
      giveExp(newExp);
    }
    keepLevel = false;
  }
  
  public CraftPlayer getBukkitEntity()
  {
    return (CraftPlayer)super.getBukkitEntity();
  }
}
