package net.minecraft.server.v1_7_R1;

import java.util.Random;

public abstract class EntityProjectile extends Entity implements IProjectile
{
  private int blockX = -1;
  private int blockY = -1;
  private int blockZ = -1;
  private Block inBlockId;
  protected boolean inGround;
  public int shake;
  public EntityLiving shooter;
  public String shooterName;
  private int i;
  private int j;
  
  public EntityProjectile(World world) {
    super(world);
    a(0.25F, 0.25F);
  }
  
  protected void c() {}
  
  public EntityProjectile(World world, EntityLiving entityliving) {
    super(world);
    shooter = entityliving;
    projectileSource = ((org.bukkit.entity.LivingEntity)entityliving.getBukkitEntity());
    a(0.25F, 0.25F);
    setPositionRotation(locX, locY + entityliving.getHeadHeight(), locZ, yaw, pitch);
    locX -= MathHelper.cos(yaw / 180.0F * 3.141593F) * 0.16F;
    locY -= 0.1000000014901161D;
    locZ -= MathHelper.sin(yaw / 180.0F * 3.141593F) * 0.16F;
    setPosition(locX, locY, locZ);
    height = 0.0F;
    float f = 0.4F;
    
    motX = (-MathHelper.sin(yaw / 180.0F * 3.141593F) * MathHelper.cos(pitch / 180.0F * 3.141593F) * f);
    motZ = (MathHelper.cos(yaw / 180.0F * 3.141593F) * MathHelper.cos(pitch / 180.0F * 3.141593F) * f);
    motY = (-MathHelper.sin((pitch + f()) / 180.0F * 3.141593F) * f);
    shoot(motX, motY, motZ, e(), 1.0F);
  }
  
  public EntityProjectile(World world, double d0, double d1, double d2) {
    super(world);
    i = 0;
    a(0.25F, 0.25F);
    setPosition(d0, d1, d2);
    height = 0.0F;
  }
  
  protected float e() {
    return 1.5F;
  }
  
  protected float f() {
    return 0.0F;
  }
  
  public void shoot(double d0, double d1, double d2, float f, float f1) {
    float f2 = MathHelper.sqrt(d0 * d0 + d1 * d1 + d2 * d2);
    
    d0 /= f2;
    d1 /= f2;
    d2 /= f2;
    d0 += random.nextGaussian() * 0.007499999832361937D * f1;
    d1 += random.nextGaussian() * 0.007499999832361937D * f1;
    d2 += random.nextGaussian() * 0.007499999832361937D * f1;
    d0 *= f;
    d1 *= f;
    d2 *= f;
    motX = d0;
    motY = d1;
    motZ = d2;
    float f3 = MathHelper.sqrt(d0 * d0 + d2 * d2);
    
    lastYaw = (this.yaw = (float)(Math.atan2(d0, d2) * 180.0D / 3.141592741012573D));
    lastPitch = (this.pitch = (float)(Math.atan2(d1, f3) * 180.0D / 3.141592741012573D));
    i = 0;
  }
  
  public void h() {
    T = locX;
    U = locY;
    V = locZ;
    super.h();
    if (shake > 0) {
      shake -= 1;
    }
    
    if (inGround) {
      if (world.getType(blockX, blockY, blockZ) == inBlockId) {
        this.i += 1;
        if (this.i == 1200) {
          die();
        }
        
        return;
      }
      
      inGround = false;
      motX *= random.nextFloat() * 0.2F;
      motY *= random.nextFloat() * 0.2F;
      motZ *= random.nextFloat() * 0.2F;
      this.i = 0;
      this.j = 0;
    } else {
      this.j += 1;
    }
    
    Vec3D vec3d = world.getVec3DPool().create(locX, locY, locZ);
    Vec3D vec3d1 = world.getVec3DPool().create(locX + motX, locY + motY, locZ + motZ);
    MovingObjectPosition movingobjectposition = world.a(vec3d, vec3d1);
    
    vec3d = world.getVec3DPool().create(locX, locY, locZ);
    vec3d1 = world.getVec3DPool().create(locX + motX, locY + motY, locZ + motZ);
    if (movingobjectposition != null) {
      vec3d1 = world.getVec3DPool().create(pos.c, pos.d, pos.e);
    }
    
    if (!world.isStatic) {
      Entity entity = null;
      java.util.List list = world.getEntities(this, boundingBox.a(motX, motY, motZ).grow(1.0D, 1.0D, 1.0D));
      double d0 = 0.0D;
      EntityLiving entityliving = getShooter();
      
      for (int i = 0; i < list.size(); i++) {
        Entity entity1 = (Entity)list.get(i);
        
        if ((entity1.R()) && ((entity1 != entityliving) || (this.j >= 5))) {
          float f = 0.3F;
          AxisAlignedBB axisalignedbb = boundingBox.grow(f, f, f);
          MovingObjectPosition movingobjectposition1 = axisalignedbb.a(vec3d, vec3d1);
          
          if (movingobjectposition1 != null) {
            double d1 = vec3d.distanceSquared(pos);
            
            if ((d1 < d0) || (d0 == 0.0D)) {
              entity = entity1;
              d0 = d1;
            }
          }
        }
      }
      
      if (entity != null) {
        movingobjectposition = new MovingObjectPosition(entity);
      }
    }
    
    if (movingobjectposition != null) {
      if ((type == EnumMovingObjectType.BLOCK) && (world.getType(b, c, d) == Blocks.PORTAL)) {
        ah();
      } else {
        a(movingobjectposition);
        
        if (dead) {
          org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callProjectileHitEvent(this);
        }
      }
    }
    

    locX += motX;
    locY += motY;
    locZ += motZ;
    float f1 = MathHelper.sqrt(motX * motX + motZ * motZ);
    
    yaw = ((float)(Math.atan2(motX, motZ) * 180.0D / 3.141592741012573D));
    
    for (pitch = ((float)(Math.atan2(motY, f1) * 180.0D / 3.141592741012573D)); pitch - lastPitch < -180.0F; lastPitch -= 360.0F) {}
    


    while (pitch - lastPitch >= 180.0F) {
      lastPitch += 360.0F;
    }
    
    while (yaw - lastYaw < -180.0F) {
      lastYaw -= 360.0F;
    }
    
    while (yaw - lastYaw >= 180.0F) {
      lastYaw += 360.0F;
    }
    
    pitch = (lastPitch + (pitch - lastPitch) * 0.2F);
    yaw = (lastYaw + (yaw - lastYaw) * 0.2F);
    float f2 = 0.99F;
    float f3 = i();
    
    if (M()) {
      for (int j = 0; j < 4; j++) {
        float f4 = 0.25F;
        
        world.addParticle("bubble", locX - motX * f4, locY - motY * f4, locZ - motZ * f4, motX, motY, motZ);
      }
      
      f2 = 0.8F;
    }
    
    motX *= f2;
    motY *= f2;
    motZ *= f2;
    motY -= f3;
    setPosition(locX, locY, locZ);
  }
  
  protected float i() {
    return 0.03F;
  }
  
  protected abstract void a(MovingObjectPosition paramMovingObjectPosition);
  
  public void b(NBTTagCompound nbttagcompound) {
    nbttagcompound.setShort("xTile", (short)blockX);
    nbttagcompound.setShort("yTile", (short)blockY);
    nbttagcompound.setShort("zTile", (short)blockZ);
    nbttagcompound.setByte("inTile", (byte)Block.b(inBlockId));
    nbttagcompound.setByte("shake", (byte)shake);
    nbttagcompound.setByte("inGround", (byte)(inGround ? 1 : 0));
    if (((shooterName == null) || (shooterName.length() == 0)) && (shooter != null) && ((shooter instanceof EntityHuman))) {
      shooterName = shooter.getName();
    }
    
    nbttagcompound.setString("ownerName", shooterName == null ? "" : shooterName);
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    blockX = nbttagcompound.getShort("xTile");
    blockY = nbttagcompound.getShort("yTile");
    blockZ = nbttagcompound.getShort("zTile");
    inBlockId = Block.e(nbttagcompound.getByte("inTile") & 0xFF);
    shake = (nbttagcompound.getByte("shake") & 0xFF);
    inGround = (nbttagcompound.getByte("inGround") == 1);
    shooterName = nbttagcompound.getString("ownerName");
    if ((shooterName != null) && (shooterName.length() == 0)) {
      shooterName = null;
    }
  }
  
  public EntityLiving getShooter() {
    if ((shooter == null) && (shooterName != null) && (shooterName.length() > 0)) {
      shooter = world.a(shooterName);
    }
    
    return shooter;
  }
}
