package net.minecraft.server.v1_7_R1;

import java.util.List;
import java.util.Random;
import org.bukkit.event.entity.EntityCombustEvent;

public class EntitySkeleton extends EntityMonster implements IRangedEntity
{
  private PathfinderGoalArrowAttack bp = new PathfinderGoalArrowAttack(this, 1.0D, 20, 60, 15.0F);
  private PathfinderGoalMeleeAttack bq = new PathfinderGoalMeleeAttack(this, EntityHuman.class, 1.2D, false);
  
  public EntitySkeleton(World world) {
    super(world);
    goalSelector.a(1, new PathfinderGoalFloat(this));
    goalSelector.a(2, new PathfinderGoalRestrictSun(this));
    goalSelector.a(3, new PathfinderGoalFleeSun(this, 1.0D));
    goalSelector.a(5, new PathfinderGoalRandomStroll(this, 1.0D));
    goalSelector.a(6, new PathfinderGoalLookAtPlayer(this, EntityHuman.class, 8.0F));
    goalSelector.a(6, new PathfinderGoalRandomLookaround(this));
    targetSelector.a(1, new PathfinderGoalHurtByTarget(this, false));
    targetSelector.a(2, new PathfinderGoalNearestAttackableTarget(this, EntityHuman.class, 0, true));
    if ((world != null) && (!isStatic)) {
      bX();
    }
  }
  
  protected void aD() {
    super.aD();
    getAttributeInstance(GenericAttributes.d).setValue(0.25D);
  }
  
  protected void c() {
    super.c();
    datawatcher.a(13, new Byte((byte)0));
  }
  
  public boolean bk() {
    return true;
  }
  
  protected String t() {
    return "mob.skeleton.say";
  }
  
  protected String aT() {
    return "mob.skeleton.hurt";
  }
  
  protected String aU() {
    return "mob.skeleton.death";
  }
  
  protected void a(int i, int j, int k, Block block) {
    makeSound("mob.skeleton.step", 0.15F, 1.0F);
  }
  
  public boolean m(Entity entity) {
    if (super.m(entity)) {
      if ((getSkeletonType() == 1) && ((entity instanceof EntityLiving))) {
        ((EntityLiving)entity).addEffect(new MobEffect(WITHERid, 200));
      }
      
      return true;
    }
    return false;
  }
  
  public EnumMonsterType getMonsterType()
  {
    return EnumMonsterType.UNDEAD;
  }
  
  public void e() {
    if ((world.v()) && (!world.isStatic)) {
      float f = d(1.0F);
      
      if ((f > 0.5F) && (random.nextFloat() * 30.0F < (f - 0.4F) * 2.0F) && (world.i(MathHelper.floor(locX), MathHelper.floor(locY), MathHelper.floor(locZ)))) {
        boolean flag = true;
        ItemStack itemstack = getEquipment(4);
        
        if (itemstack != null) {
          if (itemstack.g()) {
            itemstack.setData(itemstack.j() + random.nextInt(2));
            if (itemstack.j() >= itemstack.l()) {
              a(itemstack);
              setEquipment(4, (ItemStack)null);
            }
          }
          
          flag = false;
        }
        
        if (flag)
        {
          EntityCombustEvent event = new EntityCombustEvent(getBukkitEntity(), 8);
          world.getServer().getPluginManager().callEvent(event);
          
          if (!event.isCancelled()) {
            setOnFire(event.getDuration());
          }
        }
      }
    }
    

    if ((world.isStatic) && (getSkeletonType() == 1)) {
      a(0.72F, 2.34F);
    }
    
    super.e();
  }
  
  public void ab() {
    super.ab();
    if ((vehicle instanceof EntityCreature)) {
      EntityCreature entitycreature = (EntityCreature)vehicle;
      
      aN = aN;
    }
  }
  
  public void die(DamageSource damagesource) {
    super.die(damagesource);
    if (((damagesource.i() instanceof EntityArrow)) && ((damagesource.getEntity() instanceof EntityHuman))) {
      EntityHuman entityhuman = (EntityHuman)damagesource.getEntity();
      double d0 = locX - locX;
      double d1 = locZ - locZ;
      
      if (d0 * d0 + d1 * d1 >= 2500.0D) {
        entityhuman.a(AchievementList.v);
      }
    }
  }
  
  protected Item getLoot() {
    return Items.ARROW;
  }
  
  protected void dropDeathLoot(boolean flag, int i)
  {
    List<org.bukkit.inventory.ItemStack> loot = new java.util.ArrayList();
    
    if (getSkeletonType() == 1) {
      int count = random.nextInt(3 + i) - 1;
      if (count > 0) {
        loot.add(new org.bukkit.inventory.ItemStack(org.bukkit.Material.COAL, count));
      }
    } else {
      int count = random.nextInt(3 + i);
      if (count > 0) {
        loot.add(new org.bukkit.inventory.ItemStack(org.bukkit.Material.ARROW, count));
      }
    }
    
    int count = random.nextInt(3 + i);
    if (count > 0) {
      loot.add(new org.bukkit.inventory.ItemStack(org.bukkit.Material.BONE, count));
    }
    

    if (lastDamageByPlayerTime > 0) {
      int k = random.nextInt(200) - i;
      
      if (k < 5) {
        ItemStack itemstack = getRareDrop(k <= 0 ? 1 : 0);
        if (itemstack != null) {
          loot.add(org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack.asCraftMirror(itemstack));
        }
      }
    }
    
    org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callEntityDeathEvent(this, loot);
  }
  

  protected ItemStack getRareDrop(int i)
  {
    if (getSkeletonType() == 1) {
      return new ItemStack(Items.SKULL, 1, 1);
    }
    
    return null;
  }
  
  protected void bA() {
    super.bA();
    setEquipment(0, new ItemStack(Items.BOW));
  }
  
  public GroupDataEntity a(GroupDataEntity groupdataentity) {
    groupdataentity = super.a(groupdataentity);
    if (((world.worldProvider instanceof WorldProviderHell)) && (aI().nextInt(5) > 0)) {
      goalSelector.a(4, bq);
      setSkeletonType(1);
      setEquipment(0, new ItemStack(Items.STONE_SWORD));
      getAttributeInstance(GenericAttributes.e).setValue(4.0D);
    } else {
      goalSelector.a(4, bp);
      bA();
      bB();
    }
    
    h(random.nextFloat() < 0.55F * world.b(locX, locY, locZ));
    if (getEquipment(4) == null) {
      java.util.Calendar calendar = world.V();
      
      if ((calendar.get(2) + 1 == 10) && (calendar.get(5) == 31) && (random.nextFloat() < 0.25F)) {
        setEquipment(4, new ItemStack(random.nextFloat() < 0.1F ? Blocks.JACK_O_LANTERN : Blocks.PUMPKIN));
        dropChances[4] = 0.0F;
      }
    }
    
    return groupdataentity;
  }
  
  public void bX() {
    goalSelector.a(bq);
    goalSelector.a(bp);
    ItemStack itemstack = be();
    
    if ((itemstack != null) && (itemstack.getItem() == Items.BOW)) {
      goalSelector.a(4, bp);
    } else {
      goalSelector.a(4, bq);
    }
  }
  
  public void a(EntityLiving entityliving, float f) {
    EntityArrow entityarrow = new EntityArrow(world, this, entityliving, 1.6F, 14 - world.difficulty.a() * 4);
    int i = EnchantmentManager.getEnchantmentLevel(ARROW_DAMAGEid, be());
    int j = EnchantmentManager.getEnchantmentLevel(ARROW_KNOCKBACKid, be());
    
    entityarrow.b(f * 2.0F + random.nextGaussian() * 0.25D + world.difficulty.a() * 0.11F);
    if (i > 0) {
      entityarrow.b(entityarrow.e() + i * 0.5D + 0.5D);
    }
    
    if (j > 0) {
      entityarrow.a(j);
    }
    
    if ((EnchantmentManager.getEnchantmentLevel(ARROW_FIREid, be()) > 0) || (getSkeletonType() == 1)) {
      entityarrow.setOnFire(100);
    }
    

    org.bukkit.event.entity.EntityShootBowEvent event = org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callEntityShootBowEvent(this, be(), entityarrow, 0.8F);
    if (event.isCancelled()) {
      event.getProjectile().remove();
      return;
    }
    
    if (event.getProjectile() == entityarrow.getBukkitEntity()) {
      world.addEntity(entityarrow);
    }
    

    makeSound("random.bow", 1.0F, 1.0F / (aI().nextFloat() * 0.4F + 0.8F));
  }
  
  public int getSkeletonType()
  {
    return datawatcher.getByte(13);
  }
  
  public void setSkeletonType(int i) {
    datawatcher.watch(13, Byte.valueOf((byte)i));
    fireProof = (i == 1);
    if (i == 1) {
      a(0.72F, 2.34F);
    } else {
      a(0.6F, 1.8F);
    }
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    if (nbttagcompound.hasKeyOfType("SkeletonType", 99)) {
      byte b0 = nbttagcompound.getByte("SkeletonType");
      
      setSkeletonType(b0);
    }
    
    bX();
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    nbttagcompound.setByte("SkeletonType", (byte)getSkeletonType());
  }
  
  public void setEquipment(int i, ItemStack itemstack) {
    super.setEquipment(i, itemstack);
    if ((!world.isStatic) && (i == 0)) {
      bX();
    }
  }
  
  public double ad() {
    return super.ad() - 0.5D;
  }
}
