package net.minecraft.server.v1_7_R1;

import java.util.Random;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftEntity;
import org.bukkit.event.entity.EntityTargetEvent;
import org.bukkit.event.entity.EntityTargetEvent.TargetReason;
import org.bukkit.event.entity.SlimeSplitEvent;

public class EntitySlime extends EntityInsentient implements IMonster
{
  public float h;
  public float i;
  public float j;
  private int jumpDelay;
  private Entity lastTarget;
  
  public EntitySlime(World world)
  {
    super(world);
    int i = 1 << random.nextInt(3);
    
    height = 0.0F;
    jumpDelay = (random.nextInt(20) + 10);
    setSize(i);
  }
  
  protected void c() {
    super.c();
    datawatcher.a(16, new Byte((byte)1));
  }
  
  public void setSize(int i)
  {
    datawatcher.watch(16, new Byte((byte)i));
    a(0.6F * i, 0.6F * i);
    setPosition(locX, locY, locZ);
    getAttributeInstance(GenericAttributes.a).setValue(i * i);
    setHealth(getMaxHealth());
    b = i;
  }
  
  public int getSize() {
    return datawatcher.getByte(16);
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    nbttagcompound.setInt("Size", getSize() - 1);
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    setSize(nbttagcompound.getInt("Size") + 1);
  }
  
  protected String bN() {
    return "slime";
  }
  
  protected String bT() {
    return "mob.slime." + (getSize() > 1 ? "big" : "small");
  }
  
  public void h() {
    if ((!world.isStatic) && (world.difficulty == EnumDifficulty.PEACEFUL) && (getSize() > 0)) {
      dead = true;
    }
    
    this.i += (h - this.i) * 0.5F;
    this.j = this.i;
    boolean flag = onGround;
    
    super.h();
    

    if ((onGround) && (!flag)) {
      int i = getSize();
      
      for (int j = 0; j < i * 8; j++) {
        float f = random.nextFloat() * 3.141593F * 2.0F;
        float f1 = random.nextFloat() * 0.5F + 0.5F;
        float f2 = MathHelper.sin(f) * i * 0.5F * f1;
        float f3 = MathHelper.cos(f) * i * 0.5F * f1;
        
        world.addParticle(bN(), locX + f2, boundingBox.b, locZ + f3, 0.0D, 0.0D, 0.0D);
      }
      
      if (bU()) {
        makeSound(bT(), bf(), ((random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F) / 0.8F);
      }
      
      h = -0.5F;
    } else if ((!onGround) && (flag)) {
      h = 1.0F;
    }
    
    bQ();
    if (world.isStatic) {
      int i = getSize();
      a(0.6F * i, 0.6F * i);
    }
  }
  
  protected void bq() {
    w();
    
    Entity entityhuman = world.findNearbyVulnerablePlayer(this, 16.0D);
    EntityTargetEvent event = null;
    
    if ((entityhuman != null) && (!entityhuman.equals(lastTarget))) {
      event = org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callEntityTargetEvent(this, entityhuman, EntityTargetEvent.TargetReason.CLOSEST_PLAYER);
    } else if ((lastTarget != null) && (entityhuman == null)) {
      event = org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callEntityTargetEvent(this, entityhuman, EntityTargetEvent.TargetReason.FORGOT_TARGET);
    }
    
    if ((event != null) && (!event.isCancelled())) {
      entityhuman = event.getTarget() == null ? null : ((CraftEntity)event.getTarget()).getHandle();
    }
    
    lastTarget = entityhuman;
    

    if (entityhuman != null) {
      a(entityhuman, 10.0F, 20.0F);
    }
    
    if ((onGround) && (jumpDelay-- <= 0)) {
      jumpDelay = bP();
      if (entityhuman != null) {
        jumpDelay /= 3;
      }
      
      bd = true;
      if (bW()) {
        makeSound(bT(), bf(), ((random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F) * 0.8F);
      }
      
      be = (1.0F - random.nextFloat() * 2.0F);
      bf = (1 * getSize());
    } else {
      bd = false;
      if (onGround) {
        be = (this.bf = 0.0F);
      }
    }
  }
  
  protected void bQ() {
    h *= 0.6F;
  }
  
  protected int bP() {
    return random.nextInt(20) + 10;
  }
  
  protected EntitySlime bO() {
    return new EntitySlime(world);
  }
  
  public void die() {
    int i = getSize();
    
    if ((!world.isStatic) && (i > 1) && (getHealth() <= 0.0F)) {
      int j = 2 + random.nextInt(3);
      

      SlimeSplitEvent event = new SlimeSplitEvent((org.bukkit.entity.Slime)getBukkitEntity(), j);
      world.getServer().getPluginManager().callEvent(event);
      
      if ((!event.isCancelled()) && (event.getCount() > 0)) {
        j = event.getCount();
      } else {
        super.die();
        return;
      }
      

      for (int k = 0; k < j; k++) {
        float f = (k % 2 - 0.5F) * i / 4.0F;
        float f1 = (k / 2 - 0.5F) * i / 4.0F;
        EntitySlime entityslime = bO();
        
        entityslime.setSize(i / 2);
        entityslime.setPositionRotation(locX + f, locY + 0.5D, locZ + f1, random.nextFloat() * 360.0F, 0.0F);
        world.addEntity(entityslime, org.bukkit.event.entity.CreatureSpawnEvent.SpawnReason.SLIME_SPLIT);
      }
    }
    
    super.die();
  }
  
  public void b_(EntityHuman entityhuman) {
    if (bR()) {
      int i = getSize();
      
      if ((o(entityhuman)) && (e(entityhuman) < 0.6D * i * 0.6D * i) && (entityhuman.damageEntity(DamageSource.mobAttack(this), bS()))) {
        makeSound("mob.attack", 1.0F, (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
      }
    }
  }
  
  protected boolean bR() {
    return getSize() > 1;
  }
  
  protected int bS() {
    return getSize();
  }
  
  protected String aT() {
    return "mob.slime." + (getSize() > 1 ? "big" : "small");
  }
  
  protected String aU() {
    return "mob.slime." + (getSize() > 1 ? "big" : "small");
  }
  
  protected Item getLoot() {
    return getSize() == 1 ? Items.SLIME_BALL : Item.d(0);
  }
  
  public boolean canSpawn() {
    Chunk chunk = world.getChunkAtWorldCoords(MathHelper.floor(locX), MathHelper.floor(locZ));
    
    if ((world.getWorldData().getType() == WorldType.FLAT) && (random.nextInt(4) != 1)) {
      return false;
    }
    if ((getSize() == 1) || (world.difficulty != EnumDifficulty.PEACEFUL)) {
      BiomeBase biomebase = world.getBiome(MathHelper.floor(locX), MathHelper.floor(locZ));
      
      if ((biomebase == BiomeBase.SWAMPLAND) && (locY > 50.0D) && (locY < 70.0D) && (random.nextFloat() < 0.5F) && (random.nextFloat() < world.x()) && (world.getLightLevel(MathHelper.floor(locX), MathHelper.floor(locY), MathHelper.floor(locZ)) <= random.nextInt(8))) {
        return super.canSpawn();
      }
      
      if ((random.nextInt(10) == 0) && (chunk.a(987234911L).nextInt(10) == 0) && (locY < 40.0D)) {
        return super.canSpawn();
      }
    }
    
    return false;
  }
  
  protected float bf()
  {
    return 0.4F * getSize();
  }
  
  public int x() {
    return 0;
  }
  
  protected boolean bW() {
    return getSize() > 0;
  }
  
  protected boolean bU() {
    return getSize() > 2;
  }
}
