package net.minecraft.server.v1_7_R1;

import java.util.Random;
import org.bukkit.block.BlockState;
import org.bukkit.event.block.EntityBlockFormEvent;
import org.bukkit.inventory.ItemStack;

public class EntitySnowman extends EntityGolem implements IRangedEntity
{
  public EntitySnowman(World world)
  {
    super(world);
    a(0.4F, 1.8F);
    getNavigation().a(true);
    goalSelector.a(1, new PathfinderGoalArrowAttack(this, 1.25D, 20, 10.0F));
    goalSelector.a(2, new PathfinderGoalRandomStroll(this, 1.0D));
    goalSelector.a(3, new PathfinderGoalLookAtPlayer(this, EntityHuman.class, 6.0F));
    goalSelector.a(4, new PathfinderGoalRandomLookaround(this));
    targetSelector.a(1, new PathfinderGoalNearestAttackableTarget(this, EntityInsentient.class, 0, true, false, IMonster.a));
  }
  
  public boolean bk() {
    return true;
  }
  
  protected void aD() {
    super.aD();
    getAttributeInstance(GenericAttributes.a).setValue(4.0D);
    getAttributeInstance(GenericAttributes.d).setValue(0.2000000029802322D);
  }
  
  public void e() {
    super.e();
    int i = MathHelper.floor(locX);
    int j = MathHelper.floor(locY);
    int k = MathHelper.floor(locZ);
    
    if (L()) {
      damageEntity(DamageSource.DROWN, 1.0F);
    }
    
    if (world.getBiome(i, k).a(i, j, k) > 1.0F) {
      damageEntity(org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.MELTING, 1.0F);
    }
    
    for (int l = 0; l < 4; l++) {
      i = MathHelper.floor(locX + (l % 2 * 2 - 1) * 0.25F);
      j = MathHelper.floor(locY);
      k = MathHelper.floor(locZ + (l / 2 % 2 * 2 - 1) * 0.25F);
      if ((world.getType(i, j, k).getMaterial() == Material.AIR) && (world.getBiome(i, k).a(i, j, k) < 0.8F) && (Blocks.SNOW.canPlace(world, i, j, k)))
      {
        BlockState blockState = world.getWorld().getBlockAt(i, j, k).getState();
        blockState.setType(org.bukkit.craftbukkit.v1_7_R1.util.CraftMagicNumbers.getMaterial(Blocks.SNOW));
        
        EntityBlockFormEvent event = new EntityBlockFormEvent(getBukkitEntity(), blockState.getBlock(), blockState);
        world.getServer().getPluginManager().callEvent(event);
        
        if (!event.isCancelled()) {
          blockState.update(true);
        }
      }
    }
  }
  
  protected Item getLoot()
  {
    return Items.SNOW_BALL;
  }
  
  protected void dropDeathLoot(boolean flag, int i)
  {
    java.util.List<ItemStack> loot = new java.util.ArrayList();
    int j = random.nextInt(16);
    
    if (j > 0) {
      loot.add(new ItemStack(org.bukkit.craftbukkit.v1_7_R1.util.CraftMagicNumbers.getMaterial(Items.SNOW_BALL), j));
    }
    
    org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callEntityDeathEvent(this, loot);
  }
  
  public void a(EntityLiving entityliving, float f)
  {
    EntitySnowball entitysnowball = new EntitySnowball(world, this);
    double d0 = locX - locX;
    double d1 = locY + entityliving.getHeadHeight() - 1.100000023841858D - locY;
    double d2 = locZ - locZ;
    float f1 = MathHelper.sqrt(d0 * d0 + d2 * d2) * 0.2F;
    
    entitysnowball.shoot(d0, d1 + f1, d2, 1.6F, 12.0F);
    makeSound("random.bow", 1.0F, 1.0F / (aI().nextFloat() * 0.4F + 0.8F));
    world.addEntity(entitysnowball);
  }
}
