package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;



public class EntityTracker
{
  private static final Logger a = ;
  private final WorldServer world;
  private Set c = new HashSet();
  public IntHashMap trackedEntities = new IntHashMap();
  private int e;
  
  public EntityTracker(WorldServer worldserver) {
    world = worldserver;
    e = worldserver.getMinecraftServer().getPlayerList().a();
  }
  
  public void track(Entity entity) {
    if ((entity instanceof EntityPlayer)) {
      addEntity(entity, 512, 2);
      EntityPlayer entityplayer = (EntityPlayer)entity;
      Iterator iterator = c.iterator();
      
      while (iterator.hasNext()) {
        EntityTrackerEntry entitytrackerentry = (EntityTrackerEntry)iterator.next();
        
        if (tracker != entityplayer) {
          entitytrackerentry.updatePlayer(entityplayer);
        }
      }
    } else if ((entity instanceof EntityFishingHook)) {
      addEntity(entity, 64, 5, true);
    } else if ((entity instanceof EntityArrow)) {
      addEntity(entity, 64, 20, false);
    } else if ((entity instanceof EntitySmallFireball)) {
      addEntity(entity, 64, 10, false);
    } else if ((entity instanceof EntityFireball)) {
      addEntity(entity, 64, 10, false);
    } else if ((entity instanceof EntitySnowball)) {
      addEntity(entity, 64, 10, true);
    } else if ((entity instanceof EntityEnderPearl)) {
      addEntity(entity, 64, 10, true);
    } else if ((entity instanceof EntityEnderSignal)) {
      addEntity(entity, 64, 4, true);
    } else if ((entity instanceof EntityEgg)) {
      addEntity(entity, 64, 10, true);
    } else if ((entity instanceof EntityPotion)) {
      addEntity(entity, 64, 10, true);
    } else if ((entity instanceof EntityThrownExpBottle)) {
      addEntity(entity, 64, 10, true);
    } else if ((entity instanceof EntityFireworks)) {
      addEntity(entity, 64, 10, true);
    } else if ((entity instanceof EntityItem)) {
      addEntity(entity, 64, 20, true);
    } else if ((entity instanceof EntityMinecartAbstract)) {
      addEntity(entity, 80, 3, true);
    } else if ((entity instanceof EntityBoat)) {
      addEntity(entity, 80, 3, true);
    } else if ((entity instanceof EntitySquid)) {
      addEntity(entity, 64, 3, true);
    } else if ((entity instanceof EntityWither)) {
      addEntity(entity, 80, 3, false);
    } else if ((entity instanceof EntityBat)) {
      addEntity(entity, 80, 3, false);
    } else if ((entity instanceof IAnimal)) {
      addEntity(entity, 80, 3, true);
    } else if ((entity instanceof EntityEnderDragon)) {
      addEntity(entity, 160, 3, true);
    } else if ((entity instanceof EntityTNTPrimed)) {
      addEntity(entity, 160, 10, true);
    } else if ((entity instanceof EntityFallingBlock)) {
      addEntity(entity, 160, 20, true);
    } else if ((entity instanceof EntityHanging)) {
      addEntity(entity, 160, 2147483647, false);
    } else if ((entity instanceof EntityExperienceOrb)) {
      addEntity(entity, 160, 20, true);
    } else if ((entity instanceof EntityEnderCrystal)) {
      addEntity(entity, 256, 2147483647, false);
    }
  }
  
  public void addEntity(Entity entity, int i, int j) {
    addEntity(entity, i, j, false);
  }
  
  public void addEntity(Entity entity, int i, int j, boolean flag) {
    if (i > e) {
      i = e;
    }
    try
    {
      if (trackedEntities.b(entity.getId())) {
        throw new IllegalStateException("Entity is already tracked!");
      }
      
      EntityTrackerEntry entitytrackerentry = new EntityTrackerEntry(entity, i, j, flag);
      
      c.add(entitytrackerentry);
      trackedEntities.a(entity.getId(), entitytrackerentry);
      entitytrackerentry.scanPlayers(world.players);
    } catch (Throwable throwable) {
      CrashReport crashreport = CrashReport.a(throwable, "Adding entity to track");
      CrashReportSystemDetails crashreportsystemdetails = crashreport.a("Entity To Track");
      
      crashreportsystemdetails.a("Tracking range", i + " blocks");
      crashreportsystemdetails.a("Update interval", new CrashReportEntityTrackerUpdateInterval(this, j));
      entity.a(crashreportsystemdetails);
      CrashReportSystemDetails crashreportsystemdetails1 = crashreport.a("Entity That Is Already Tracked");
      
      trackedEntities.get(entity.getId())).tracker.a(crashreportsystemdetails1);
      try
      {
        throw new ReportedException(crashreport);
      } catch (ReportedException reportedexception) {
        a.error("\"Silently\" catching entity tracking error.", reportedexception);
      }
    }
  }
  
  public void untrackEntity(Entity entity) {
    if ((entity instanceof EntityPlayer)) {
      EntityPlayer entityplayer = (EntityPlayer)entity;
      Iterator iterator = c.iterator();
      
      while (iterator.hasNext()) {
        EntityTrackerEntry entitytrackerentry = (EntityTrackerEntry)iterator.next();
        
        entitytrackerentry.a(entityplayer);
      }
    }
    
    EntityTrackerEntry entitytrackerentry1 = (EntityTrackerEntry)trackedEntities.d(entity.getId());
    
    if (entitytrackerentry1 != null) {
      c.remove(entitytrackerentry1);
      entitytrackerentry1.a();
    }
  }
  
  public void updatePlayers() {
    ArrayList arraylist = new ArrayList();
    Iterator iterator = c.iterator();
    
    while (iterator.hasNext()) {
      EntityTrackerEntry entitytrackerentry = (EntityTrackerEntry)iterator.next();
      
      entitytrackerentry.track(world.players);
      if ((n) && ((tracker instanceof EntityPlayer))) {
        arraylist.add((EntityPlayer)tracker);
      }
    }
    
    for (int i = 0; i < arraylist.size(); i++) {
      EntityPlayer entityplayer = (EntityPlayer)arraylist.get(i);
      Iterator iterator1 = c.iterator();
      
      while (iterator1.hasNext()) {
        EntityTrackerEntry entitytrackerentry1 = (EntityTrackerEntry)iterator1.next();
        
        if (tracker != entityplayer) {
          entitytrackerentry1.updatePlayer(entityplayer);
        }
      }
    }
  }
  
  public void a(Entity entity, Packet packet) {
    EntityTrackerEntry entitytrackerentry = (EntityTrackerEntry)trackedEntities.get(entity.getId());
    
    if (entitytrackerentry != null) {
      entitytrackerentry.broadcast(packet);
    }
  }
  
  public void sendPacketToEntity(Entity entity, Packet packet) {
    EntityTrackerEntry entitytrackerentry = (EntityTrackerEntry)trackedEntities.get(entity.getId());
    
    if (entitytrackerentry != null) {
      entitytrackerentry.broadcastIncludingSelf(packet);
    }
  }
  
  public void untrackPlayer(EntityPlayer entityplayer) {
    Iterator iterator = c.iterator();
    
    while (iterator.hasNext()) {
      EntityTrackerEntry entitytrackerentry = (EntityTrackerEntry)iterator.next();
      
      entitytrackerentry.clear(entityplayer);
    }
  }
  
  public void a(EntityPlayer entityplayer, Chunk chunk) {
    Iterator iterator = c.iterator();
    
    while (iterator.hasNext()) {
      EntityTrackerEntry entitytrackerentry = (EntityTrackerEntry)iterator.next();
      
      if ((tracker != entityplayer) && (tracker.ai == locX) && (tracker.ak == locZ)) {
        entitytrackerentry.updatePlayer(entityplayer);
      }
    }
  }
}
