package net.minecraft.server.v1_7_R1;

import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftPlayer;
import org.bukkit.entity.Player;
import org.bukkit.event.player.PlayerVelocityEvent;
import org.bukkit.plugin.PluginManager;
import org.bukkit.util.Vector;

public class EntityTrackerEntry
{
  private static final Logger p = ;
  public Entity tracker;
  public int b;
  public int c;
  public int xLoc;
  public int yLoc;
  public int zLoc;
  public int yRot;
  public int xRot;
  public int i;
  public double j;
  public double k;
  public double l;
  public int m;
  private double q;
  private double r;
  private double s;
  private boolean isMoving;
  private boolean u;
  private int v;
  private Entity w;
  private boolean x;
  public boolean n;
  public Set trackedPlayers = new HashSet();
  
  public EntityTrackerEntry(Entity entity, int i, int j, boolean flag) {
    tracker = entity;
    b = i;
    c = j;
    u = flag;
    xLoc = MathHelper.floor(locX * 32.0D);
    yLoc = MathHelper.floor(locY * 32.0D);
    zLoc = MathHelper.floor(locZ * 32.0D);
    yRot = MathHelper.d(yaw * 256.0F / 360.0F);
    xRot = MathHelper.d(pitch * 256.0F / 360.0F);
    this.i = MathHelper.d(entity.getHeadRotation() * 256.0F / 360.0F);
  }
  
  public boolean equals(Object object) {
    return tracker.getId() == tracker.getId();
  }
  
  public int hashCode() {
    return tracker.getId();
  }
  
  public void track(List list) {
    n = false;
    if ((!isMoving) || (tracker.e(q, r, s) > 16.0D)) {
      q = tracker.locX;
      r = tracker.locY;
      s = tracker.locZ;
      isMoving = true;
      n = true;
      scanPlayers(list);
    }
    
    if ((w != tracker.vehicle) || ((tracker.vehicle != null) && (m % 60 == 0))) {
      w = tracker.vehicle;
      broadcast(new PacketPlayOutAttachEntity(0, tracker, tracker.vehicle));
    }
    
    if ((tracker instanceof EntityItemFrame)) {
      EntityItemFrame i3 = (EntityItemFrame)tracker;
      ItemStack i4 = i3.getItem();
      
      if ((m % 10 == 0) && (i4 != null) && ((i4.getItem() instanceof ItemWorldMap))) {
        WorldMap i6 = Items.MAP.getSavedMap(i4, tracker.world);
        Iterator i7 = trackedPlayers.iterator();
        
        while (i7.hasNext()) {
          EntityHuman i8 = (EntityHuman)i7.next();
          EntityPlayer i9 = (EntityPlayer)i8;
          
          i6.a(i9, i4);
          Packet j0 = Items.MAP.c(i4, tracker.world, i9);
          
          if (j0 != null) {
            playerConnection.sendPacket(j0);
          }
        }
      }
      
      b();
    } else if ((m % c == 0) || (tracker.am) || (tracker.getDataWatcher().a()))
    {


      if (tracker.vehicle == null) {
        v += 1;
        int i = tracker.at.a(tracker.locX);
        int j = MathHelper.floor(tracker.locY * 32.0D);
        int k = tracker.at.a(tracker.locZ);
        int l = MathHelper.d(tracker.yaw * 256.0F / 360.0F);
        int i1 = MathHelper.d(tracker.pitch * 256.0F / 360.0F);
        int j1 = i - xLoc;
        int k1 = j - yLoc;
        int l1 = k - zLoc;
        Object object = null;
        boolean flag = (Math.abs(j1) >= 4) || (Math.abs(k1) >= 4) || (Math.abs(l1) >= 4) || (m % 60 == 0);
        boolean flag1 = (Math.abs(l - yRot) >= 4) || (Math.abs(i1 - xRot) >= 4);
        

        if (flag) {
          xLoc = i;
          yLoc = j;
          zLoc = k;
        }
        
        if (flag1) {
          yRot = l;
          xRot = i1;
        }
        

        if ((m > 0) || ((tracker instanceof EntityArrow))) {
          if ((j1 >= -128) && (j1 < 128) && (k1 >= -128) && (k1 < 128) && (l1 >= -128) && (l1 < 128) && (v <= 400) && (!x)) {
            if ((flag) && (flag1)) {
              object = new PacketPlayOutRelEntityMoveLook(tracker.getId(), (byte)j1, (byte)k1, (byte)l1, (byte)l, (byte)i1);
            } else if (flag) {
              object = new PacketPlayOutRelEntityMove(tracker.getId(), (byte)j1, (byte)k1, (byte)l1);
            } else if (flag1) {
              object = new PacketPlayOutEntityLook(tracker.getId(), (byte)l, (byte)i1);
            }
          } else {
            v = 0;
            
            if ((tracker instanceof EntityPlayer)) {
              scanPlayers(new java.util.ArrayList(trackedPlayers));
            }
            
            object = new PacketPlayOutEntityTeleport(tracker.getId(), i, j, k, (byte)l, (byte)i1);
          }
        }
        
        if (u) {
          double d0 = tracker.motX - this.j;
          double d1 = tracker.motY - this.k;
          double d2 = tracker.motZ - this.l;
          double d3 = 0.02D;
          double d4 = d0 * d0 + d1 * d1 + d2 * d2;
          
          if ((d4 > d3 * d3) || ((d4 > 0.0D) && (tracker.motX == 0.0D) && (tracker.motY == 0.0D) && (tracker.motZ == 0.0D))) {
            this.j = tracker.motX;
            this.k = tracker.motY;
            this.l = tracker.motZ;
            broadcast(new PacketPlayOutEntityVelocity(tracker.getId(), this.j, this.k, this.l));
          }
        }
        
        if (object != null) {
          broadcast((Packet)object);
        }
        
        b();
        












        x = false;
      } else {
        i = MathHelper.d(tracker.yaw * 256.0F / 360.0F);
        int j = MathHelper.d(tracker.pitch * 256.0F / 360.0F);
        boolean flag2 = (Math.abs(i - yRot) >= 4) || (Math.abs(j - xRot) >= 4);
        
        if (flag2) {
          broadcast(new PacketPlayOutEntityLook(tracker.getId(), (byte)i, (byte)j));
          yRot = i;
          xRot = j;
        }
        
        xLoc = tracker.at.a(tracker.locX);
        yLoc = MathHelper.floor(tracker.locY * 32.0D);
        zLoc = tracker.at.a(tracker.locZ);
        b();
        x = true;
      }
      
      int i = MathHelper.d(tracker.getHeadRotation() * 256.0F / 360.0F);
      if (Math.abs(i - this.i) >= 4) {
        broadcast(new PacketPlayOutEntityHeadRotation(tracker, (byte)i));
        this.i = i;
      }
      
      tracker.am = false;
    }
    
    m += 1;
    if (tracker.velocityChanged)
    {
      boolean cancelled = false;
      
      if ((tracker instanceof EntityPlayer)) {
        Player player = (Player)tracker.getBukkitEntity();
        Vector velocity = player.getVelocity();
        
        PlayerVelocityEvent event = new PlayerVelocityEvent(player, velocity);
        tracker.world.getServer().getPluginManager().callEvent(event);
        
        if (event.isCancelled()) {
          cancelled = true;
        } else if (!velocity.equals(event.getVelocity())) {
          player.setVelocity(velocity);
        }
      }
      
      if (!cancelled) {
        broadcastIncludingSelf(new PacketPlayOutEntityVelocity(tracker));
      }
      

      tracker.velocityChanged = false;
    }
  }
  
  private void b() {
    DataWatcher datawatcher = tracker.getDataWatcher();
    
    if (datawatcher.a()) {
      broadcastIncludingSelf(new PacketPlayOutEntityMetadata(tracker.getId(), datawatcher, false));
    }
    
    if ((tracker instanceof EntityLiving)) {
      AttributeMapServer attributemapserver = (AttributeMapServer)((EntityLiving)tracker).bc();
      Set set = attributemapserver.b();
      
      if (!set.isEmpty())
      {
        if ((tracker instanceof EntityPlayer)) {
          ((EntityPlayer)tracker).getBukkitEntity().injectScaledMaxHealth(set, false);
        }
        
        broadcastIncludingSelf(new PacketPlayOutUpdateAttributes(tracker.getId(), set));
      }
      
      set.clear();
    }
  }
  
  public void broadcast(Packet packet) {
    Iterator iterator = trackedPlayers.iterator();
    
    while (iterator.hasNext()) {
      EntityPlayer entityplayer = (EntityPlayer)iterator.next();
      
      playerConnection.sendPacket(packet);
    }
  }
  
  public void broadcastIncludingSelf(Packet packet) {
    broadcast(packet);
    if ((tracker instanceof EntityPlayer)) {
      tracker).playerConnection.sendPacket(packet);
    }
  }
  
  public void a() {
    Iterator iterator = trackedPlayers.iterator();
    
    while (iterator.hasNext()) {
      EntityPlayer entityplayer = (EntityPlayer)iterator.next();
      
      removeQueue.add(Integer.valueOf(tracker.getId()));
    }
  }
  
  public void a(EntityPlayer entityplayer) {
    if (trackedPlayers.contains(entityplayer)) {
      removeQueue.add(Integer.valueOf(tracker.getId()));
      trackedPlayers.remove(entityplayer);
    }
  }
  
  public void updatePlayer(EntityPlayer entityplayer) {
    if (entityplayer != tracker) {
      double d0 = locX - xLoc / 32;
      double d1 = locZ - zLoc / 32;
      
      if ((d0 >= -b) && (d0 <= b) && (d1 >= -b) && (d1 <= b)) {
        if ((!trackedPlayers.contains(entityplayer)) && ((d(entityplayer)) || (tracker.o)))
        {
          if ((tracker instanceof EntityPlayer)) {
            Player player = ((EntityPlayer)tracker).getBukkitEntity();
            if (!entityplayer.getBukkitEntity().canSee(player)) {
              return;
            }
          }
          
          removeQueue.remove(Integer.valueOf(tracker.getId()));
          

          trackedPlayers.add(entityplayer);
          Packet packet = c();
          
          playerConnection.sendPacket(packet);
          if (!tracker.getDataWatcher().d()) {
            playerConnection.sendPacket(new PacketPlayOutEntityMetadata(tracker.getId(), tracker.getDataWatcher(), true));
          }
          
          if ((tracker instanceof EntityLiving)) {
            AttributeMapServer attributemapserver = (AttributeMapServer)((EntityLiving)tracker).bc();
            Collection collection = attributemapserver.c();
            

            if (tracker.getId() == entityplayer.getId()) {
              ((EntityPlayer)tracker).getBukkitEntity().injectScaledMaxHealth(collection, false);
            }
            
            if (!collection.isEmpty()) {
              playerConnection.sendPacket(new PacketPlayOutUpdateAttributes(tracker.getId(), collection));
            }
          }
          
          j = tracker.motX;
          k = tracker.motY;
          l = tracker.motZ;
          if ((u) && (!(packet instanceof PacketPlayOutSpawnEntityLiving))) {
            playerConnection.sendPacket(new PacketPlayOutEntityVelocity(tracker.getId(), tracker.motX, tracker.motY, tracker.motZ));
          }
          
          if (tracker.vehicle != null) {
            playerConnection.sendPacket(new PacketPlayOutAttachEntity(0, tracker, tracker.vehicle));
          }
          

          if (tracker.passenger != null) {
            playerConnection.sendPacket(new PacketPlayOutAttachEntity(0, tracker.passenger, tracker));
          }
          

          if (((tracker instanceof EntityInsentient)) && (((EntityInsentient)tracker).getLeashHolder() != null)) {
            playerConnection.sendPacket(new PacketPlayOutAttachEntity(1, tracker, ((EntityInsentient)tracker).getLeashHolder()));
          }
          
          if ((tracker instanceof EntityLiving)) {
            for (int i = 0; i < 5; i++) {
              ItemStack itemstack = ((EntityLiving)tracker).getEquipment(i);
              
              if (itemstack != null) {
                playerConnection.sendPacket(new PacketPlayOutEntityEquipment(tracker.getId(), i, itemstack));
              }
            }
          }
          
          if ((tracker instanceof EntityHuman)) {
            EntityHuman entityhuman = (EntityHuman)tracker;
            
            if (entityhuman.isSleeping()) {
              playerConnection.sendPacket(new PacketPlayOutBed(entityhuman, MathHelper.floor(tracker.locX), MathHelper.floor(tracker.locY), MathHelper.floor(tracker.locZ)));
            }
          }
          

          this.i = MathHelper.d(tracker.getHeadRotation() * 256.0F / 360.0F);
          broadcast(new PacketPlayOutEntityHeadRotation(tracker, (byte)this.i));
          

          if ((tracker instanceof EntityLiving)) {
            EntityLiving entityliving = (EntityLiving)tracker;
            Iterator iterator = entityliving.getEffects().iterator();
            
            while (iterator.hasNext()) {
              MobEffect mobeffect = (MobEffect)iterator.next();
              
              playerConnection.sendPacket(new PacketPlayOutEntityEffect(tracker.getId(), mobeffect));
            }
          }
        }
      } else if (trackedPlayers.contains(entityplayer)) {
        trackedPlayers.remove(entityplayer);
        removeQueue.add(Integer.valueOf(tracker.getId()));
      }
    }
  }
  
  private boolean d(EntityPlayer entityplayer) {
    return entityplayer.r().getPlayerChunkMap().a(entityplayer, tracker.ai, tracker.ak);
  }
  
  public void scanPlayers(List list) {
    for (int i = 0; i < list.size(); i++) {
      updatePlayer((EntityPlayer)list.get(i));
    }
  }
  
  private Packet c() {
    if (tracker.dead)
    {

      return null;
    }
    

    if ((tracker instanceof EntityItem))
      return new PacketPlayOutSpawnEntity(tracker, 2, 1);
    if ((tracker instanceof EntityPlayer))
      return new PacketPlayOutNamedEntitySpawn((EntityHuman)tracker);
    if ((tracker instanceof EntityMinecartAbstract)) {
      EntityMinecartAbstract entityminecartabstract = (EntityMinecartAbstract)tracker;
      
      return new PacketPlayOutSpawnEntity(tracker, 10, entityminecartabstract.m()); }
    if ((tracker instanceof EntityBoat))
      return new PacketPlayOutSpawnEntity(tracker, 1);
    if ((!(tracker instanceof IAnimal)) && (!(tracker instanceof EntityEnderDragon))) {
      if ((tracker instanceof EntityFishingHook)) {
        EntityHuman entityhuman = tracker).owner;
        
        return new PacketPlayOutSpawnEntity(tracker, 90, entityhuman != null ? entityhuman.getId() : tracker.getId()); }
      if ((tracker instanceof EntityArrow)) {
        Entity entity = tracker).shooter;
        
        return new PacketPlayOutSpawnEntity(tracker, 60, entity != null ? entity.getId() : tracker.getId()); }
      if ((tracker instanceof EntitySnowball))
        return new PacketPlayOutSpawnEntity(tracker, 61);
      if ((tracker instanceof EntityPotion))
        return new PacketPlayOutSpawnEntity(tracker, 73, ((EntityPotion)tracker).getPotionValue());
      if ((tracker instanceof EntityThrownExpBottle))
        return new PacketPlayOutSpawnEntity(tracker, 75);
      if ((tracker instanceof EntityEnderPearl))
        return new PacketPlayOutSpawnEntity(tracker, 65);
      if ((tracker instanceof EntityEnderSignal))
        return new PacketPlayOutSpawnEntity(tracker, 72);
      if ((tracker instanceof EntityFireworks)) {
        return new PacketPlayOutSpawnEntity(tracker, 76);
      }
      

      if ((tracker instanceof EntityFireball)) {
        EntityFireball entityfireball = (EntityFireball)tracker;
        
        PacketPlayOutSpawnEntity packetplayoutspawnentity = null;
        byte b0 = 63;
        
        if ((tracker instanceof EntitySmallFireball)) {
          b0 = 64;
        } else if ((tracker instanceof EntityWitherSkull)) {
          b0 = 66;
        }
        
        if (shooter != null) {
          packetplayoutspawnentity = new PacketPlayOutSpawnEntity(tracker, b0, tracker).shooter.getId());
        } else {
          packetplayoutspawnentity = new PacketPlayOutSpawnEntity(tracker, b0, 0);
        }
        
        packetplayoutspawnentity.d((int)(dirX * 8000.0D));
        packetplayoutspawnentity.e((int)(dirY * 8000.0D));
        packetplayoutspawnentity.f((int)(dirZ * 8000.0D));
        return packetplayoutspawnentity; }
      if ((tracker instanceof EntityEgg))
        return new PacketPlayOutSpawnEntity(tracker, 62);
      if ((tracker instanceof EntityTNTPrimed))
        return new PacketPlayOutSpawnEntity(tracker, 50);
      if ((tracker instanceof EntityEnderCrystal))
        return new PacketPlayOutSpawnEntity(tracker, 51);
      if ((tracker instanceof EntityFallingBlock)) {
        EntityFallingBlock entityfallingblock = (EntityFallingBlock)tracker;
        
        return new PacketPlayOutSpawnEntity(tracker, 70, Block.b(entityfallingblock.f()) | data << 16); }
      if ((tracker instanceof EntityPainting))
        return new PacketPlayOutSpawnEntityPainting((EntityPainting)tracker);
      if ((tracker instanceof EntityItemFrame)) {
        EntityItemFrame entityitemframe = (EntityItemFrame)tracker;
        
        PacketPlayOutSpawnEntity packetplayoutspawnentity = new PacketPlayOutSpawnEntity(tracker, 71, direction);
        packetplayoutspawnentity.a(MathHelper.d(x * 32));
        packetplayoutspawnentity.b(MathHelper.d(y * 32));
        packetplayoutspawnentity.c(MathHelper.d(z * 32));
        return packetplayoutspawnentity; }
      if ((tracker instanceof EntityLeash)) {
        EntityLeash entityleash = (EntityLeash)tracker;
        
        PacketPlayOutSpawnEntity packetplayoutspawnentity = new PacketPlayOutSpawnEntity(tracker, 77);
        packetplayoutspawnentity.a(MathHelper.d(x * 32));
        packetplayoutspawnentity.b(MathHelper.d(y * 32));
        packetplayoutspawnentity.c(MathHelper.d(z * 32));
        return packetplayoutspawnentity; }
      if ((tracker instanceof EntityExperienceOrb)) {
        return new PacketPlayOutSpawnEntityExperienceOrb((EntityExperienceOrb)tracker);
      }
      throw new IllegalArgumentException("Don't know how to add " + tracker.getClass() + "!");
    }
    

    i = MathHelper.d(tracker.getHeadRotation() * 256.0F / 360.0F);
    return new PacketPlayOutSpawnEntityLiving((EntityLiving)tracker);
  }
  
  public void clear(EntityPlayer entityplayer)
  {
    if (trackedPlayers.contains(entityplayer)) {
      trackedPlayers.remove(entityplayer);
      removeQueue.add(Integer.valueOf(tracker.getId()));
    }
  }
}
