package net.minecraft.server.v1_7_R1;

import java.util.Iterator;
import java.util.List;
import java.util.Random;

public class EntityWitch extends EntityMonster implements IRangedEntity
{
  private static final java.util.UUID bp = java.util.UUID.fromString("5CD17E52-A79A-43D3-A529-90FDE04B181E");
  private static final AttributeModifier bq = new AttributeModifier(bp, "Drinking speed penalty", -0.25D, 0).a(false);
  private static final Item[] br = { Items.GLOWSTONE_DUST, Items.SUGAR, Items.REDSTONE, Items.SPIDER_EYE, Items.GLASS_BOTTLE, Items.SULPHUR, Items.STICK, Items.STICK };
  private int bs;
  
  public EntityWitch(World world) {
    super(world);
    goalSelector.a(1, new PathfinderGoalFloat(this));
    goalSelector.a(2, new PathfinderGoalArrowAttack(this, 1.0D, 60, 10.0F));
    goalSelector.a(2, new PathfinderGoalRandomStroll(this, 1.0D));
    goalSelector.a(3, new PathfinderGoalLookAtPlayer(this, EntityHuman.class, 8.0F));
    goalSelector.a(3, new PathfinderGoalRandomLookaround(this));
    targetSelector.a(1, new PathfinderGoalHurtByTarget(this, false));
    targetSelector.a(2, new PathfinderGoalNearestAttackableTarget(this, EntityHuman.class, 0, true));
  }
  
  protected void c() {
    super.c();
    getDataWatcher().a(21, Byte.valueOf((byte)0));
  }
  
  protected String t() {
    return "mob.witch.idle";
  }
  
  protected String aT() {
    return "mob.witch.hurt";
  }
  
  protected String aU() {
    return "mob.witch.death";
  }
  
  public void a(boolean flag) {
    getDataWatcher().watch(21, Byte.valueOf((byte)(flag ? 1 : 0)));
  }
  
  public boolean bX() {
    return getDataWatcher().getByte(21) == 1;
  }
  
  protected void aD() {
    super.aD();
    getAttributeInstance(GenericAttributes.a).setValue(26.0D);
    getAttributeInstance(GenericAttributes.d).setValue(0.25D);
  }
  
  public boolean bk() {
    return true;
  }
  
  public void e() {
    if (!world.isStatic) {
      if (bX()) {
        if (bs-- <= 0) {
          a(false);
          ItemStack itemstack = be();
          
          setEquipment(0, (ItemStack)null);
          if ((itemstack != null) && (itemstack.getItem() == Items.POTION)) {
            List list = Items.POTION.g(itemstack);
            
            if (list != null) {
              Iterator iterator = list.iterator();
              
              while (iterator.hasNext()) {
                MobEffect mobeffect = (MobEffect)iterator.next();
                
                addEffect(new MobEffect(mobeffect));
              }
            }
          }
          
          getAttributeInstance(GenericAttributes.d).b(bq);
        }
      } else {
        short short1 = -1;
        
        if ((random.nextFloat() < 0.15F) && (a(Material.WATER)) && (!hasEffect(MobEffectList.WATER_BREATHING))) {
          short1 = 8237;
        } else if ((random.nextFloat() < 0.15F) && (isBurning()) && (!hasEffect(MobEffectList.FIRE_RESISTANCE))) {
          short1 = 16307;
        } else if ((random.nextFloat() < 0.05F) && (getHealth() < getMaxHealth())) {
          short1 = 16341;
        } else if ((random.nextFloat() < 0.25F) && (getGoalTarget() != null) && (!hasEffect(MobEffectList.FASTER_MOVEMENT)) && (getGoalTarget().e(this) > 121.0D)) {
          short1 = 16274;
        } else if ((random.nextFloat() < 0.25F) && (getGoalTarget() != null) && (!hasEffect(MobEffectList.FASTER_MOVEMENT)) && (getGoalTarget().e(this) > 121.0D)) {
          short1 = 16274;
        }
        
        if (short1 > -1) {
          setEquipment(0, new ItemStack(Items.POTION, 1, short1));
          bs = be().n();
          a(true);
          AttributeInstance attributeinstance = getAttributeInstance(GenericAttributes.d);
          
          attributeinstance.b(bq);
          attributeinstance.a(bq);
        }
      }
      
      if (random.nextFloat() < 0.00075F) {
        world.broadcastEntityEffect(this, (byte)15);
      }
    }
    
    super.e();
  }
  
  protected float c(DamageSource damagesource, float f) {
    f = super.c(damagesource, f);
    if (damagesource.getEntity() == this) {
      f = 0.0F;
    }
    
    if (damagesource.s()) {
      f = (float)(f * 0.15D);
    }
    
    return f;
  }
  
  protected void dropDeathLoot(boolean flag, int i)
  {
    List<org.bukkit.inventory.ItemStack> loot = new java.util.ArrayList();
    
    int j = random.nextInt(3) + 1;
    
    for (int k = 0; k < j; k++) {
      int l = random.nextInt(3);
      Item item = br[random.nextInt(br.length)];
      
      if (i > 0) {
        l += random.nextInt(i + 1);
      }
      
      if (l > 0) {
        loot.add(new org.bukkit.inventory.ItemStack(org.bukkit.craftbukkit.v1_7_R1.util.CraftMagicNumbers.getMaterial(item), l));
      }
    }
    
    org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callEntityDeathEvent(this, loot);
  }
  
  public void a(EntityLiving entityliving, float f)
  {
    if (!bX()) {
      EntityPotion entitypotion = new EntityPotion(world, this, 32732);
      
      pitch -= -20.0F;
      double d0 = locX + motX - locX;
      double d1 = locY + entityliving.getHeadHeight() - 1.100000023841858D - locY;
      double d2 = locZ + motZ - locZ;
      float f1 = MathHelper.sqrt(d0 * d0 + d2 * d2);
      
      if ((f1 >= 8.0F) && (!entityliving.hasEffect(MobEffectList.SLOWER_MOVEMENT))) {
        entitypotion.setPotionValue(32698);
      } else if ((entityliving.getHealth() >= 8.0F) && (!entityliving.hasEffect(MobEffectList.POISON))) {
        entitypotion.setPotionValue(32660);
      } else if ((f1 <= 3.0F) && (!entityliving.hasEffect(MobEffectList.WEAKNESS)) && (random.nextFloat() < 0.25F)) {
        entitypotion.setPotionValue(32696);
      }
      
      entitypotion.shoot(d0, d1 + f1 * 0.2F, d2, 0.75F, 8.0F);
      world.addEntity(entitypotion);
    }
  }
}
