package net.minecraft.server.v1_7_R1;

import java.util.Iterator;
import java.util.List;
import java.util.Random;
import org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory;
import org.bukkit.event.entity.EntityRegainHealthEvent.RegainReason;
import org.bukkit.event.entity.ExplosionPrimeEvent;
import org.bukkit.inventory.ItemStack;

public class EntityWither extends EntityMonster implements IRangedEntity
{
  private float[] bp = new float[2];
  private float[] bq = new float[2];
  private float[] br = new float[2];
  private float[] bs = new float[2];
  private int[] bt = new int[2];
  private int[] bu = new int[2];
  private int bv;
  private static final IEntitySelector bw = new EntitySelectorNotUndead();
  
  public EntityWither(World world) {
    super(world);
    setHealth(getMaxHealth());
    a(0.9F, 4.0F);
    fireProof = true;
    getNavigation().e(true);
    goalSelector.a(0, new PathfinderGoalFloat(this));
    goalSelector.a(2, new PathfinderGoalArrowAttack(this, 1.0D, 40, 20.0F));
    goalSelector.a(5, new PathfinderGoalRandomStroll(this, 1.0D));
    goalSelector.a(6, new PathfinderGoalLookAtPlayer(this, EntityHuman.class, 8.0F));
    goalSelector.a(7, new PathfinderGoalRandomLookaround(this));
    targetSelector.a(1, new PathfinderGoalHurtByTarget(this, false));
    targetSelector.a(2, new PathfinderGoalNearestAttackableTarget(this, EntityInsentient.class, 0, false, false, bw));
    b = 50;
  }
  
  protected void c() {
    super.c();
    datawatcher.a(17, new Integer(0));
    datawatcher.a(18, new Integer(0));
    datawatcher.a(19, new Integer(0));
    datawatcher.a(20, new Integer(0));
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    nbttagcompound.setInt("Invul", bY());
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    s(nbttagcompound.getInt("Invul"));
  }
  
  protected String t() {
    return "mob.wither.idle";
  }
  
  protected String aT() {
    return "mob.wither.hurt";
  }
  
  protected String aU() {
    return "mob.wither.death";
  }
  
  public void e() {
    motY *= 0.6000000238418579D;
    



    if ((!world.isStatic) && (t(0) > 0)) {
      Entity entity = world.getEntity(t(0));
      
      if (entity != null) {
        if ((locY < locY) || ((!bZ()) && (locY < locY + 5.0D))) {
          if (motY < 0.0D) {
            motY = 0.0D;
          }
          
          motY += (0.5D - motY) * 0.6000000238418579D;
        }
        
        double d3 = locX - locX;
        
        double d0 = locZ - locZ;
        double d1 = d3 * d3 + d0 * d0;
        if (d1 > 9.0D) {
          double d2 = MathHelper.sqrt(d1);
          motX += (d3 / d2 * 0.5D - motX) * 0.6000000238418579D;
          motZ += (d0 / d2 * 0.5D - motZ) * 0.6000000238418579D;
        }
      }
    }
    
    if (motX * motX + motZ * motZ > 0.0500000007450581D) {
      yaw = ((float)Math.atan2(motZ, motX) * 57.295776F - 90.0F);
    }
    
    super.e();
    


    for (int i = 0; i < 2; i++) {
      bs[i] = bq[i];
      br[i] = bp[i];
    }
    


    for (i = 0; i < 2; i++) {
      int j = t(i + 1);
      Entity entity1 = null;
      
      if (j > 0) {
        entity1 = world.getEntity(j);
      }
      
      if (entity1 != null) {
        double d0 = u(i + 1);
        double d1 = v(i + 1);
        double d2 = w(i + 1);
        double d4 = locX - d0;
        double d5 = locY + entity1.getHeadHeight() - d1;
        double d6 = locZ - d2;
        double d7 = MathHelper.sqrt(d4 * d4 + d6 * d6);
        float f = (float)(Math.atan2(d6, d4) * 180.0D / 3.141592741012573D) - 90.0F;
        float f1 = (float)-(Math.atan2(d5, d7) * 180.0D / 3.141592741012573D);
        
        bp[i] = b(bp[i], f1, 40.0F);
        bq[i] = b(bq[i], f, 10.0F);
      } else {
        bq[i] = b(bq[i], aN, 10.0F);
      }
    }
    
    boolean flag = bZ();
    
    for (int j = 0; j < 3; j++) {
      double d8 = u(j);
      double d9 = v(j);
      double d10 = w(j);
      
      world.addParticle("smoke", d8 + random.nextGaussian() * 0.300000011920929D, d9 + random.nextGaussian() * 0.300000011920929D, d10 + random.nextGaussian() * 0.300000011920929D, 0.0D, 0.0D, 0.0D);
      if ((flag) && (world.random.nextInt(4) == 0)) {
        world.addParticle("mobSpell", d8 + random.nextGaussian() * 0.300000011920929D, d9 + random.nextGaussian() * 0.300000011920929D, d10 + random.nextGaussian() * 0.300000011920929D, 0.699999988079071D, 0.699999988079071D, 0.5D);
      }
    }
    
    if (bY() > 0) {
      for (j = 0; j < 3; j++) {
        world.addParticle("mobSpell", locX + random.nextGaussian() * 1.0D, locY + random.nextFloat() * 3.3F, locZ + random.nextGaussian() * 1.0D, 0.699999988079071D, 0.699999988079071D, 0.8999999761581421D);
      }
    }
  }
  

  protected void bn()
  {
    if (bY() > 0) {
      int i = bY() - 1;
      if (i <= 0)
      {
        ExplosionPrimeEvent event = new ExplosionPrimeEvent(getBukkitEntity(), 7.0F, false);
        world.getServer().getPluginManager().callEvent(event);
        
        if (!event.isCancelled()) {
          world.createExplosion(this, locX, locY + getHeadHeight(), locZ, event.getRadius(), event.getFire(), world.getGameRules().getBoolean("mobGriefing"));
        }
        

        world.createExplosion(this, locX, locY + getHeadHeight(), locZ, 7.0F, false, world.getGameRules().getBoolean("mobGriefing"));
        world.b(1013, (int)locX, (int)locY, (int)locZ, 0);
      }
      
      s(i);
      if (ticksLived % 10 == 0) {
        heal(10.0F, EntityRegainHealthEvent.RegainReason.WITHER_SPAWN);
      }
    } else {
      super.bn();
      


      for (int i = 1; i < 3; i++) {
        if (ticksLived >= bt[(i - 1)]) {
          bt[(i - 1)] = (ticksLived + 10 + random.nextInt(10));
          if ((world.difficulty == EnumDifficulty.NORMAL) || (world.difficulty == EnumDifficulty.HARD)) {
            int i1001 = i - 1;
            int i1003 = bu[(i - 1)];
            
            bu[i1001] = (bu[(i - 1)] + 1);
            if (i1003 > 15) {
              float f = 10.0F;
              float f1 = 5.0F;
              double d0 = MathHelper.a(random, locX - f, locX + f);
              double d1 = MathHelper.a(random, locY - f1, locY + f1);
              double d2 = MathHelper.a(random, locZ - f, locZ + f);
              
              a(i + 1, d0, d1, d2, true);
              bu[(i - 1)] = 0;
            }
          }
          
          int j = t(i);
          if (j > 0) {
            Entity entity = world.getEntity(j);
            
            if ((entity != null) && (entity.isAlive()) && (e(entity) <= 900.0D) && (o(entity))) {
              a(i + 1, (EntityLiving)entity);
              bt[(i - 1)] = (ticksLived + 40 + random.nextInt(20));
              bu[(i - 1)] = 0;
            } else {
              b(i, 0);
            }
          } else {
            List list = world.a(EntityLiving.class, boundingBox.grow(20.0D, 8.0D, 20.0D), bw);
            
            for (int i1 = 0; (i1 < 10) && (!list.isEmpty()); i1++) {
              EntityLiving entityliving = (EntityLiving)list.get(random.nextInt(list.size()));
              
              if ((entityliving != this) && (entityliving.isAlive()) && (o(entityliving))) {
                if ((entityliving instanceof EntityHuman)) {
                  if (abilities.isInvulnerable) break;
                  b(i, entityliving.getId()); break;
                }
                
                b(i, entityliving.getId());
                
                break;
              }
              
              list.remove(entityliving);
            }
          }
        }
      }
      
      if (getGoalTarget() != null) {
        b(0, getGoalTarget().getId());
      } else {
        b(0, 0);
      }
      
      if (bv > 0) {
        bv -= 1;
        if ((bv == 0) && (world.getGameRules().getBoolean("mobGriefing"))) {
          i = MathHelper.floor(locY);
          int j = MathHelper.floor(locX);
          int j1 = MathHelper.floor(locZ);
          boolean flag = false;
          
          for (int k1 = -1; k1 <= 1; k1++) {
            for (int l1 = -1; l1 <= 1; l1++) {
              for (int i2 = 0; i2 <= 3; i2++) {
                int j2 = j + k1;
                int k2 = i + i2;
                int l2 = j1 + l1;
                Block block = world.getType(j2, k2, l2);
                
                if ((block.getMaterial() != Material.AIR) && (block != Blocks.BEDROCK) && (block != Blocks.ENDER_PORTAL) && (block != Blocks.ENDER_PORTAL_FRAME) && (block != Blocks.COMMAND))
                {
                  if (!CraftEventFactory.callEntityChangeBlockEvent(this, j2, k2, l2, Blocks.AIR, 0).isCancelled())
                  {



                    flag = (world.setAir(j2, k2, l2, true)) || (flag);
                  }
                }
              }
            }
          }
          if (flag) {
            world.a((EntityHuman)null, 1012, (int)locX, (int)locY, (int)locZ, 0);
          }
        }
      }
      
      if (ticksLived % 20 == 0) {
        heal(1.0F);
      }
    }
  }
  
  public void bX() {
    s(220);
    setHealth(getMaxHealth() / 3.0F);
  }
  
  public void as() {}
  
  public int aV() {
    return 4;
  }
  
  private double u(int i) {
    if (i <= 0) {
      return locX;
    }
    float f = (aN + 180 * (i - 1)) / 180.0F * 3.141593F;
    float f1 = MathHelper.cos(f);
    
    return locX + f1 * 1.3D;
  }
  
  private double v(int i)
  {
    return i <= 0 ? locY + 3.0D : locY + 2.2D;
  }
  
  private double w(int i) {
    if (i <= 0) {
      return locZ;
    }
    float f = (aN + 180 * (i - 1)) / 180.0F * 3.141593F;
    float f1 = MathHelper.sin(f);
    
    return locZ + f1 * 1.3D;
  }
  
  private float b(float f, float f1, float f2)
  {
    float f3 = MathHelper.g(f1 - f);
    
    if (f3 > f2) {
      f3 = f2;
    }
    
    if (f3 < -f2) {
      f3 = -f2;
    }
    
    return f + f3;
  }
  
  private void a(int i, EntityLiving entityliving) {
    a(i, locX, locY + entityliving.getHeadHeight() * 0.5D, locZ, (i == 0) && (random.nextFloat() < 0.001F));
  }
  
  private void a(int i, double d0, double d1, double d2, boolean flag) {
    world.a((EntityHuman)null, 1014, (int)locX, (int)locY, (int)locZ, 0);
    double d3 = u(i);
    double d4 = v(i);
    double d5 = w(i);
    double d6 = d0 - d3;
    double d7 = d1 - d4;
    double d8 = d2 - d5;
    EntityWitherSkull entitywitherskull = new EntityWitherSkull(world, this, d6, d7, d8);
    
    if (flag) {
      entitywitherskull.a(true);
    }
    
    locY = d4;
    locX = d3;
    locZ = d5;
    world.addEntity(entitywitherskull);
  }
  
  public void a(EntityLiving entityliving, float f) {
    a(0, entityliving);
  }
  
  public boolean damageEntity(DamageSource damagesource, float f) {
    if (isInvulnerable())
      return false;
    if (damagesource == DamageSource.DROWN)
      return false;
    if (bY() > 0) {
      return false;
    }
    

    if (bZ()) {
      Entity entity = damagesource.i();
      if ((entity instanceof EntityArrow)) {
        return false;
      }
    }
    
    Entity entity = damagesource.getEntity();
    if ((entity != null) && (!(entity instanceof EntityHuman)) && ((entity instanceof EntityLiving)) && (((EntityLiving)entity).getMonsterType() == getMonsterType())) {
      return false;
    }
    if (bv <= 0) {
      bv = 20;
    }
    
    for (int i = 0; i < bu.length; i++) {
      bu[i] += 3;
    }
    
    return super.damageEntity(damagesource, f);
  }
  


  protected void dropDeathLoot(boolean flag, int i)
  {
    List<ItemStack> loot = new java.util.ArrayList();
    loot.add(new ItemStack(org.bukkit.craftbukkit.v1_7_R1.util.CraftMagicNumbers.getMaterial(Items.NETHER_STAR), 1));
    CraftEventFactory.callEntityDeathEvent(this, loot);
    
    if (!world.isStatic) {
      Iterator iterator = world.a(EntityHuman.class, boundingBox.grow(50.0D, 100.0D, 50.0D)).iterator();
      
      while (iterator.hasNext()) {
        EntityHuman entityhuman = (EntityHuman)iterator.next();
        
        entityhuman.a(AchievementList.J);
      }
    }
  }
  
  protected void w() {
    aV = 0;
  }
  
  protected void b(float f) {}
  
  public void addEffect(MobEffect mobeffect) {}
  
  protected boolean bk() {
    return true;
  }
  
  protected void aD() {
    super.aD();
    getAttributeInstance(GenericAttributes.a).setValue(300.0D);
    getAttributeInstance(GenericAttributes.d).setValue(0.6000000238418579D);
    getAttributeInstance(GenericAttributes.b).setValue(40.0D);
  }
  
  public int bY() {
    return datawatcher.getInt(20);
  }
  
  public void s(int i) {
    datawatcher.watch(20, Integer.valueOf(i));
  }
  
  public int t(int i) {
    return datawatcher.getInt(17 + i);
  }
  
  public void b(int i, int j) {
    datawatcher.watch(17 + i, Integer.valueOf(j));
  }
  
  public boolean bZ() {
    return getHealth() <= getMaxHealth() / 2.0F;
  }
  
  public EnumMonsterType getMonsterType() {
    return EnumMonsterType.UNDEAD;
  }
  
  public void mount(Entity entity) {
    vehicle = null;
  }
}
