package net.minecraft.server.v1_7_R1;

import java.util.Random;

public class EntityWolf extends EntityTameableAnimal {
  private float bq;
  private float br;
  private boolean bs;
  private boolean bt;
  private float bu;
  private float bv;
  
  public EntityWolf(World world) { super(world);
    a(0.6F, 0.8F);
    getNavigation().a(true);
    goalSelector.a(1, new PathfinderGoalFloat(this));
    goalSelector.a(2, bp);
    goalSelector.a(3, new PathfinderGoalLeapAtTarget(this, 0.4F));
    goalSelector.a(4, new PathfinderGoalMeleeAttack(this, 1.0D, true));
    goalSelector.a(5, new PathfinderGoalFollowOwner(this, 1.0D, 10.0F, 2.0F));
    goalSelector.a(6, new PathfinderGoalBreed(this, 1.0D));
    goalSelector.a(7, new PathfinderGoalRandomStroll(this, 1.0D));
    goalSelector.a(8, new PathfinderGoalBeg(this, 8.0F));
    goalSelector.a(9, new PathfinderGoalLookAtPlayer(this, EntityHuman.class, 8.0F));
    goalSelector.a(9, new PathfinderGoalRandomLookaround(this));
    targetSelector.a(1, new PathfinderGoalOwnerHurtByTarget(this));
    targetSelector.a(2, new PathfinderGoalOwnerHurtTarget(this));
    targetSelector.a(3, new PathfinderGoalHurtByTarget(this, true));
    targetSelector.a(4, new PathfinderGoalRandomTargetNonTamed(this, EntitySheep.class, 200, false));
    setTamed(false);
  }
  
  protected void aD() {
    super.aD();
    getAttributeInstance(GenericAttributes.d).setValue(0.300000011920929D);
    if (isTamed()) {
      getAttributeInstance(GenericAttributes.a).setValue(20.0D);
    } else {
      getAttributeInstance(GenericAttributes.a).setValue(8.0D);
    }
  }
  
  public boolean bk() {
    return true;
  }
  
  public void setGoalTarget(EntityLiving entityliving) {
    super.setGoalTarget(entityliving);
    if (entityliving == null) {
      setAngry(false);
    } else if (!isTamed()) {
      setAngry(true);
    }
  }
  
  protected void bp() {
    datawatcher.watch(18, Float.valueOf(getHealth()));
  }
  
  protected void c() {
    super.c();
    datawatcher.a(18, new Float(getHealth()));
    datawatcher.a(19, new Byte((byte)0));
    datawatcher.a(20, new Byte((byte)BlockCloth.b(1)));
  }
  
  protected void a(int i, int j, int k, Block block) {
    makeSound("mob.wolf.step", 0.15F, 1.0F);
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    nbttagcompound.setBoolean("Angry", isAngry());
    nbttagcompound.setByte("CollarColor", (byte)getCollarColor());
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    setAngry(nbttagcompound.getBoolean("Angry"));
    if (nbttagcompound.hasKeyOfType("CollarColor", 99)) {
      setCollarColor(nbttagcompound.getByte("CollarColor"));
    }
  }
  
  protected String t()
  {
    return random.nextInt(3) == 0 ? "mob.wolf.panting" : (isTamed()) && (datawatcher.getFloat(18) < getMaxHealth() / 2.0F) ? "mob.wolf.whine" : isAngry() ? "mob.wolf.growl" : "mob.wolf.bark";
  }
  
  protected String aT() {
    return "mob.wolf.hurt";
  }
  
  protected String aU() {
    return "mob.wolf.death";
  }
  
  protected float bf() {
    return 0.4F;
  }
  
  protected Item getLoot() {
    return Item.d(-1);
  }
  
  public void e() {
    super.e();
    if ((!world.isStatic) && (bs) && (!bt) && (!bQ()) && (onGround)) {
      bt = true;
      bu = 0.0F;
      bv = 0.0F;
      world.broadcastEntityEffect(this, (byte)8);
    }
  }
  
  public void h() {
    super.h();
    br = bq;
    if (ci()) {
      bq += (1.0F - bq) * 0.4F;
    } else {
      bq += (0.0F - bq) * 0.4F;
    }
    
    if (ci()) {
      g = 10;
    }
    
    if (L()) {
      bs = true;
      bt = false;
      bu = 0.0F;
      bv = 0.0F;
    } else if (((bs) || (bt)) && (bt)) {
      if (bu == 0.0F) {
        makeSound("mob.wolf.shake", bf(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
      }
      
      bv = bu;
      bu += 0.05F;
      if (bv >= 2.0F) {
        bs = false;
        bt = false;
        bv = 0.0F;
        bu = 0.0F;
      }
      
      if (bu > 0.4F) {
        float f = (float)boundingBox.b;
        int i = (int)(MathHelper.sin((bu - 0.4F) * 3.141593F) * 7.0F);
        
        for (int j = 0; j < i; j++) {
          float f1 = (random.nextFloat() * 2.0F - 1.0F) * width * 0.5F;
          float f2 = (random.nextFloat() * 2.0F - 1.0F) * width * 0.5F;
          
          world.addParticle("splash", locX + f1, f + 0.8F, locZ + f2, motX, motY, motZ);
        }
      }
    }
  }
  
  public float getHeadHeight() {
    return length * 0.8F;
  }
  
  public int x() {
    return isSitting() ? 20 : super.x();
  }
  
  public boolean damageEntity(DamageSource damagesource, float f) {
    if (isInvulnerable()) {
      return false;
    }
    Entity entity = damagesource.getEntity();
    
    bp.setSitting(false);
    if ((entity != null) && (!(entity instanceof EntityHuman)) && (!(entity instanceof EntityArrow))) {
      f = (f + 1.0F) / 2.0F;
    }
    
    return super.damageEntity(damagesource, f);
  }
  
  public boolean m(Entity entity)
  {
    int i = isTamed() ? 4 : 2;
    
    return entity.damageEntity(DamageSource.mobAttack(this), i);
  }
  
  public void setTamed(boolean flag) {
    super.setTamed(flag);
    if (flag) {
      getAttributeInstance(GenericAttributes.a).setValue(20.0D);
    } else {
      getAttributeInstance(GenericAttributes.a).setValue(8.0D);
    }
  }
  
  public boolean a(EntityHuman entityhuman) {
    ItemStack itemstack = inventory.getItemInHand();
    
    if (isTamed()) {
      if (itemstack != null) {
        if ((itemstack.getItem() instanceof ItemFood)) {
          ItemFood itemfood = (ItemFood)itemstack.getItem();
          
          if ((itemfood.i()) && (datawatcher.getFloat(18) < 20.0F)) {
            if (!abilities.canInstantlyBuild) {
              count -= 1;
            }
            
            heal(itemfood.getNutrition(itemstack));
            if (count <= 0) {
              inventory.setItem(inventory.itemInHandIndex, (ItemStack)null);
            }
            
            return true;
          }
        } else if (itemstack.getItem() == Items.INK_SACK) {
          int i = BlockCloth.b(itemstack.getData());
          
          if (i != getCollarColor()) {
            setCollarColor(i);
            if (!abilities.canInstantlyBuild) { if (--count <= 0) {
                inventory.setItem(inventory.itemInHandIndex, (ItemStack)null);
              }
            }
            return true;
          }
        }
      }
      
      if ((entityhuman.getName().equalsIgnoreCase(getOwnerName())) && (!world.isStatic) && (!c(itemstack))) {
        bp.setSitting(!isSitting());
        bd = false;
        setPathEntity((PathEntity)null);
        setTarget((Entity)null);
        setGoalTarget((EntityLiving)null);
      }
    } else if ((itemstack != null) && (itemstack.getItem() == Items.BONE) && (!isAngry())) {
      if (!abilities.canInstantlyBuild) {
        count -= 1;
      }
      
      if (count <= 0) {
        inventory.setItem(inventory.itemInHandIndex, (ItemStack)null);
      }
      
      if (!world.isStatic)
      {
        if ((random.nextInt(3) == 0) && (!org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callEntityTameEvent(this, entityhuman).isCancelled())) {
          setTamed(true);
          setPathEntity((PathEntity)null);
          setGoalTarget((EntityLiving)null);
          bp.setSitting(true);
          setHealth(getMaxHealth());
          setOwnerName(entityhuman.getName());
          i(true);
          world.broadcastEntityEffect(this, (byte)7);
        } else {
          i(false);
          world.broadcastEntityEffect(this, (byte)6);
        }
      }
      
      return true;
    }
    
    return super.a(entityhuman);
  }
  
  public boolean c(ItemStack itemstack) {
    return !(itemstack.getItem() instanceof ItemFood) ? false : itemstack == null ? false : ((ItemFood)itemstack.getItem()).i();
  }
  
  public int bz() {
    return 8;
  }
  
  public boolean isAngry() {
    return (datawatcher.getByte(16) & 0x2) != 0;
  }
  
  public void setAngry(boolean flag) {
    byte b0 = datawatcher.getByte(16);
    
    if (flag) {
      datawatcher.watch(16, Byte.valueOf((byte)(b0 | 0x2)));
    } else {
      datawatcher.watch(16, Byte.valueOf((byte)(b0 & 0xFFFFFFFD)));
    }
  }
  
  public int getCollarColor() {
    return datawatcher.getByte(20) & 0xF;
  }
  
  public void setCollarColor(int i) {
    datawatcher.watch(20, Byte.valueOf((byte)(i & 0xF)));
  }
  
  public EntityWolf b(EntityAgeable entityageable) {
    EntityWolf entitywolf = new EntityWolf(world);
    String s = getOwnerName();
    
    if ((s != null) && (s.trim().length() > 0)) {
      entitywolf.setOwnerName(s);
      entitywolf.setTamed(true);
    }
    
    return entitywolf;
  }
  
  public void m(boolean flag) {
    if (flag) {
      datawatcher.watch(19, Byte.valueOf((byte)1));
    } else {
      datawatcher.watch(19, Byte.valueOf((byte)0));
    }
  }
  
  public boolean mate(EntityAnimal entityanimal) {
    if (entityanimal == this)
      return false;
    if (!isTamed())
      return false;
    if (!(entityanimal instanceof EntityWolf)) {
      return false;
    }
    EntityWolf entitywolf = (EntityWolf)entityanimal;
    
    return entitywolf.isTamed();
  }
  
  public boolean ci()
  {
    return datawatcher.getByte(19) == 1;
  }
  
  protected boolean isTypeNotPersistent() {
    return !isTamed();
  }
  
  public boolean a(EntityLiving entityliving, EntityLiving entityliving1) {
    if ((!(entityliving instanceof EntityCreeper)) && (!(entityliving instanceof EntityGhast))) {
      if ((entityliving instanceof EntityWolf)) {
        EntityWolf entitywolf = (EntityWolf)entityliving;
        
        if ((entitywolf.isTamed()) && (entitywolf.getOwner() == entityliving1)) {
          return false;
        }
      }
      
      return (!(entityliving instanceof EntityHuman)) || (!(entityliving1 instanceof EntityHuman)) || (((EntityHuman)entityliving1).a((EntityHuman)entityliving));
    }
    return false;
  }
  
  public EntityAgeable createChild(EntityAgeable entityageable)
  {
    return b(entityageable);
  }
}
