package net.minecraft.server.v1_7_R1;

import java.util.Calendar;
import java.util.Random;
import java.util.UUID;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.event.entity.CreatureSpawnEvent.SpawnReason;
import org.bukkit.event.entity.EntityCombustByEntityEvent;
import org.bukkit.event.entity.EntityCombustEvent;
import org.bukkit.plugin.PluginManager;

public class EntityZombie extends EntityMonster
{
  protected static final IAttribute bp = new AttributeRanged("zombie.spawnReinforcements", 0.0D, 0.0D, 1.0D).a("Spawn Reinforcements Chance");
  private static final UUID bq = UUID.fromString("B9766B59-9566-4402-BC1F-2EE2A276D836");
  private static final AttributeModifier br = new AttributeModifier(bq, "Baby speed boost", 0.5D, 1);
  private final PathfinderGoalBreakDoor bs = new PathfinderGoalBreakDoor(this);
  private int bt;
  private boolean bu = false;
  private float bv = -1.0F;
  private float bw;
  private int lastTick = MinecraftServer.currentTick;
  
  public EntityZombie(World world) {
    super(world);
    getNavigation().b(true);
    goalSelector.a(0, new PathfinderGoalFloat(this));
    goalSelector.a(2, new PathfinderGoalMeleeAttack(this, EntityHuman.class, 1.0D, false));
    goalSelector.a(4, new PathfinderGoalMeleeAttack(this, EntityVillager.class, 1.0D, true));
    goalSelector.a(5, new PathfinderGoalMoveTowardsRestriction(this, 1.0D));
    goalSelector.a(6, new PathfinderGoalMoveThroughVillage(this, 1.0D, false));
    goalSelector.a(7, new PathfinderGoalRandomStroll(this, 1.0D));
    goalSelector.a(8, new PathfinderGoalLookAtPlayer(this, EntityHuman.class, 8.0F));
    goalSelector.a(8, new PathfinderGoalRandomLookaround(this));
    targetSelector.a(1, new PathfinderGoalHurtByTarget(this, true));
    targetSelector.a(2, new PathfinderGoalNearestAttackableTarget(this, EntityHuman.class, 0, true));
    targetSelector.a(2, new PathfinderGoalNearestAttackableTarget(this, EntityVillager.class, 0, false));
    a(0.6F, 1.8F);
  }
  
  protected void aD() {
    super.aD();
    getAttributeInstance(GenericAttributes.b).setValue(40.0D);
    getAttributeInstance(GenericAttributes.d).setValue(0.2300000041723251D);
    getAttributeInstance(GenericAttributes.e).setValue(3.0D);
    bc().b(bp).setValue(random.nextDouble() * 0.1000000014901161D);
  }
  
  protected void c() {
    super.c();
    getDataWatcher().a(12, Byte.valueOf((byte)0));
    getDataWatcher().a(13, Byte.valueOf((byte)0));
    getDataWatcher().a(14, Byte.valueOf((byte)0));
  }
  
  public int aV() {
    int i = super.aV() + 2;
    
    if (i > 20) {
      i = 20;
    }
    
    return i;
  }
  
  protected boolean bk() {
    return true;
  }
  
  public boolean bX() {
    return bu;
  }
  
  public void a(boolean flag) {
    if (bu != flag) {
      bu = flag;
      if (flag) {
        goalSelector.a(1, bs);
      } else {
        goalSelector.a(bs);
      }
    }
  }
  
  public boolean isBaby() {
    return getDataWatcher().getByte(12) == 1;
  }
  
  protected int getExpValue(EntityHuman entityhuman) {
    if (isBaby()) {
      b = ((int)(b * 2.5F));
    }
    
    return super.getExpValue(entityhuman);
  }
  
  public void setBaby(boolean flag) {
    getDataWatcher().watch(12, Byte.valueOf((byte)(flag ? 1 : 0)));
    if ((world != null) && (!world.isStatic)) {
      AttributeInstance attributeinstance = getAttributeInstance(GenericAttributes.d);
      
      attributeinstance.b(br);
      if (flag) {
        attributeinstance.a(br);
      }
    }
    
    k(flag);
  }
  
  public boolean isVillager() {
    return getDataWatcher().getByte(13) == 1;
  }
  
  public void setVillager(boolean flag) {
    getDataWatcher().watch(13, Byte.valueOf((byte)(flag ? 1 : 0)));
  }
  
  public void e() {
    if ((world.v()) && (!world.isStatic) && (!isBaby())) {
      float f = d(1.0F);
      
      if ((f > 0.5F) && (random.nextFloat() * 30.0F < (f - 0.4F) * 2.0F) && (world.i(MathHelper.floor(locX), MathHelper.floor(locY), MathHelper.floor(locZ)))) {
        boolean flag = true;
        ItemStack itemstack = getEquipment(4);
        
        if (itemstack != null) {
          if (itemstack.g()) {
            itemstack.setData(itemstack.j() + random.nextInt(2));
            if (itemstack.j() >= itemstack.l()) {
              a(itemstack);
              setEquipment(4, (ItemStack)null);
            }
          }
          
          flag = false;
        }
        
        if (flag)
        {
          EntityCombustEvent event = new EntityCombustEvent(getBukkitEntity(), 8);
          world.getServer().getPluginManager().callEvent(event);
          
          if (!event.isCancelled()) {
            setOnFire(event.getDuration());
          }
        }
      }
    }
    

    super.e();
  }
  
  public boolean damageEntity(DamageSource damagesource, float f) {
    if (!super.damageEntity(damagesource, f)) {
      return false;
    }
    EntityLiving entityliving = getGoalTarget();
    
    if ((entityliving == null) && ((bR() instanceof EntityLiving))) {
      entityliving = (EntityLiving)bR();
    }
    
    if ((entityliving == null) && ((damagesource.getEntity() instanceof EntityLiving))) {
      entityliving = (EntityLiving)damagesource.getEntity();
    }
    
    if ((entityliving != null) && (world.difficulty == EnumDifficulty.HARD) && (random.nextFloat() < getAttributeInstance(bp).getValue())) {
      int i = MathHelper.floor(locX);
      int j = MathHelper.floor(locY);
      int k = MathHelper.floor(locZ);
      EntityZombie entityzombie = new EntityZombie(world);
      
      for (int l = 0; l < 50; l++) {
        int i1 = i + MathHelper.nextInt(random, 7, 40) * MathHelper.nextInt(random, -1, 1);
        int j1 = j + MathHelper.nextInt(random, 7, 40) * MathHelper.nextInt(random, -1, 1);
        int k1 = k + MathHelper.nextInt(random, 7, 40) * MathHelper.nextInt(random, -1, 1);
        
        if ((World.a(world, i1, j1 - 1, k1)) && (world.getLightLevel(i1, j1, k1) < 10)) {
          entityzombie.setPosition(i1, j1, k1);
          if ((world.b(boundingBox)) && (world.getCubes(entityzombie, boundingBox).isEmpty()) && (!world.containsLiquid(boundingBox))) {
            world.addEntity(entityzombie, CreatureSpawnEvent.SpawnReason.REINFORCEMENTS);
            entityzombie.setGoalTarget(entityliving);
            entityzombie.a((GroupDataEntity)null);
            getAttributeInstance(bp).a(new AttributeModifier("Zombie reinforcement caller charge", -0.0500000007450581D, 0));
            entityzombie.getAttributeInstance(bp).a(new AttributeModifier("Zombie reinforcement callee charge", -0.0500000007450581D, 0));
            break;
          }
        }
      }
    }
    
    return true;
  }
  
  public void h()
  {
    if ((!world.isStatic) && (ca())) {
      int i = cc();
      

      int elapsedTicks = MinecraftServer.currentTick - lastTick;
      lastTick = MinecraftServer.currentTick;
      i *= elapsedTicks;
      

      bt -= i;
      if (bt <= 0) {
        cb();
      }
    }
    
    super.h();
  }
  
  public boolean m(Entity entity) {
    boolean flag = super.m(entity);
    
    if (flag) {
      int i = world.difficulty.a();
      
      if ((be() == null) && (isBurning()) && (random.nextFloat() < i * 0.3F))
      {
        EntityCombustByEntityEvent event = new EntityCombustByEntityEvent(getBukkitEntity(), entity.getBukkitEntity(), 2 * i);
        world.getServer().getPluginManager().callEvent(event);
        
        if (!event.isCancelled()) {
          entity.setOnFire(event.getDuration());
        }
      }
    }
    

    return flag;
  }
  
  protected String t() {
    return "mob.zombie.say";
  }
  
  protected String aT() {
    return "mob.zombie.hurt";
  }
  
  protected String aU() {
    return "mob.zombie.death";
  }
  
  protected void a(int i, int j, int k, Block block) {
    makeSound("mob.zombie.step", 0.15F, 1.0F);
  }
  
  protected Item getLoot() {
    return Items.ROTTEN_FLESH;
  }
  
  public EnumMonsterType getMonsterType() {
    return EnumMonsterType.UNDEAD;
  }
  
  protected ItemStack getRareDrop(int i)
  {
    switch (random.nextInt(3)) {
    case 0: 
      return new ItemStack(Items.IRON_INGOT, 1, 0);
    case 1: 
      return new ItemStack(Items.CARROT, 1, 0);
    case 2: 
      return new ItemStack(Items.POTATO, 1, 0);
    }
    return null;
  }
  

  protected void bA()
  {
    super.bA();
    if (random.nextFloat() < (world.difficulty == EnumDifficulty.HARD ? 0.05F : 0.01F)) {
      int i = random.nextInt(3);
      
      if (i == 0) {
        setEquipment(0, new ItemStack(Items.IRON_SWORD));
      } else {
        setEquipment(0, new ItemStack(Items.IRON_SPADE));
      }
    }
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    if (isBaby()) {
      nbttagcompound.setBoolean("IsBaby", true);
    }
    
    if (isVillager()) {
      nbttagcompound.setBoolean("IsVillager", true);
    }
    
    nbttagcompound.setInt("ConversionTime", ca() ? bt : -1);
    nbttagcompound.setBoolean("CanBreakDoors", bX());
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    if (nbttagcompound.getBoolean("IsBaby")) {
      setBaby(true);
    }
    
    if (nbttagcompound.getBoolean("IsVillager")) {
      setVillager(true);
    }
    
    if ((nbttagcompound.hasKeyOfType("ConversionTime", 99)) && (nbttagcompound.getInt("ConversionTime") > -1)) {
      a(nbttagcompound.getInt("ConversionTime"));
    }
    
    a(nbttagcompound.getBoolean("CanBreakDoors"));
  }
  
  public void a(EntityLiving entityliving) {
    super.a(entityliving);
    if (((world.difficulty == EnumDifficulty.NORMAL) || (world.difficulty == EnumDifficulty.HARD)) && ((entityliving instanceof EntityVillager))) {
      if (random.nextBoolean()) {
        return;
      }
      
      EntityZombie entityzombie = new EntityZombie(world);
      
      entityzombie.j(entityliving);
      world.kill(entityliving);
      entityzombie.a((GroupDataEntity)null);
      entityzombie.setVillager(true);
      if (entityliving.isBaby()) {
        entityzombie.setBaby(true);
      }
      
      world.addEntity(entityzombie);
      world.a((EntityHuman)null, 1016, (int)locX, (int)locY, (int)locZ, 0);
    }
  }
  
  public GroupDataEntity a(GroupDataEntity groupdataentity) {
    Object object = super.a(groupdataentity);
    float f = world.b(locX, locY, locZ);
    
    h(random.nextFloat() < 0.55F * f);
    if (object == null) {
      object = new GroupDataZombie(this, world.random.nextFloat() < 0.05F, world.random.nextFloat() < 0.05F, (EmptyClassZombie)null);
    }
    
    if ((object instanceof GroupDataZombie)) {
      GroupDataZombie groupdatazombie = (GroupDataZombie)object;
      
      if (b) {
        setVillager(true);
      }
      
      if (a) {
        setBaby(true);
      }
    }
    
    a(random.nextFloat() < f * 0.1F);
    bA();
    bB();
    if (getEquipment(4) == null) {
      Calendar calendar = world.V();
      
      if ((calendar.get(2) + 1 == 10) && (calendar.get(5) == 31) && (random.nextFloat() < 0.25F)) {
        setEquipment(4, new ItemStack(random.nextFloat() < 0.1F ? Blocks.JACK_O_LANTERN : Blocks.PUMPKIN));
        dropChances[4] = 0.0F;
      }
    }
    
    getAttributeInstance(GenericAttributes.c).a(new AttributeModifier("Random spawn bonus", random.nextDouble() * 0.0500000007450581D, 0));
    double d0 = random.nextDouble() * 1.5D * world.b(locX, locY, locZ);
    
    if (d0 > 1.0D) {
      getAttributeInstance(GenericAttributes.b).a(new AttributeModifier("Random zombie-spawn bonus", d0, 2));
    }
    
    if (random.nextFloat() < f * 0.05F) {
      getAttributeInstance(bp).a(new AttributeModifier("Leader zombie bonus", random.nextDouble() * 0.25D + 0.5D, 0));
      getAttributeInstance(GenericAttributes.a).a(new AttributeModifier("Leader zombie bonus", random.nextDouble() * 3.0D + 1.0D, 2));
      a(true);
    }
    
    return (GroupDataEntity)object;
  }
  
  public boolean a(EntityHuman entityhuman) {
    ItemStack itemstack = entityhuman.bD();
    
    if ((itemstack != null) && (itemstack.getItem() == Items.GOLDEN_APPLE) && (itemstack.getData() == 0) && (isVillager()) && (hasEffect(MobEffectList.WEAKNESS))) {
      if (!abilities.canInstantlyBuild) {
        count -= 1;
      }
      
      if (count <= 0) {
        inventory.setItem(inventory.itemInHandIndex, (ItemStack)null);
      }
      
      if (!world.isStatic) {
        a(random.nextInt(2401) + 3600);
      }
      
      return true;
    }
    return false;
  }
  
  protected void a(int i)
  {
    bt = i;
    getDataWatcher().watch(14, Byte.valueOf((byte)1));
    m(WEAKNESSid);
    addEffect(new MobEffect(INCREASE_DAMAGEid, i, Math.min(world.difficulty.a() - 1, 0)));
    world.broadcastEntityEffect(this, (byte)16);
  }
  
  protected boolean isTypeNotPersistent() {
    return !ca();
  }
  
  public boolean ca() {
    return getDataWatcher().getByte(14) == 1;
  }
  
  protected void cb() {
    EntityVillager entityvillager = new EntityVillager(world);
    
    entityvillager.j(this);
    entityvillager.a((GroupDataEntity)null);
    entityvillager.cb();
    if (isBaby()) {
      entityvillager.setAge(-24000);
    }
    
    world.kill(this);
    world.addEntity(entityvillager);
    entityvillager.addEffect(new MobEffect(CONFUSIONid, 200, 0));
    world.a((EntityHuman)null, 1017, (int)locX, (int)locY, (int)locZ, 0);
  }
  
  protected int cc() {
    int i = 1;
    
    if (random.nextFloat() < 0.01F) {
      int j = 0;
      
      for (int k = (int)locX - 4; (k < (int)locX + 4) && (j < 14); k++) {
        for (int l = (int)locY - 4; (l < (int)locY + 4) && (j < 14); l++) {
          for (int i1 = (int)locZ - 4; (i1 < (int)locZ + 4) && (j < 14); i1++) {
            Block block = world.getType(k, l, i1);
            
            if ((block == Blocks.IRON_FENCE) || (block == Blocks.BED)) {
              if (random.nextFloat() < 0.3F) {
                i++;
              }
              
              j++;
            }
          }
        }
      }
    }
    
    return i;
  }
  
  public void k(boolean flag) {
    a(flag ? 0.5F : 1.0F);
  }
  
  protected final void a(float f, float f1) {
    boolean flag = (bv > 0.0F) && (bw > 0.0F);
    
    bv = f;
    bw = f1;
    if (!flag) {
      a(1.0F);
    }
  }
  
  protected final void a(float f) {
    super.a(bv * f, bw * f);
  }
}
