package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftEntity;
import org.bukkit.entity.TNTPrimed;
import org.bukkit.event.block.BlockIgniteEvent;
import org.bukkit.event.entity.EntityDamageByBlockEvent;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityDamageEvent.DamageCause;
import org.bukkit.event.entity.EntityExplodeEvent;
import org.bukkit.plugin.PluginManager;

public class Explosion
{
  public boolean a;
  public boolean b = true;
  private int i = 16;
  private Random j = new Random();
  private World world;
  public double posX;
  public double posY;
  public double posZ;
  public Entity source;
  public float size;
  public List blocks = new ArrayList();
  private Map l = new java.util.HashMap();
  public boolean wasCanceled = false;
  
  public Explosion(World world, Entity entity, double d0, double d1, double d2, float f) {
    this.world = world;
    source = entity;
    size = ((float)Math.max(f, 0.0D));
    posX = d0;
    posY = d1;
    posZ = d2;
  }
  
  public void a()
  {
    if (size < 0.1F) {
      return;
    }
    

    float f = size;
    HashSet hashset = new HashSet();
    







    for (int i = 0; i < this.i; i++) {
      for (int j = 0; j < this.i; j++) {
        for (int k = 0; k < this.i; k++) {
          if ((i == 0) || (i == this.i - 1) || (j == 0) || (j == this.i - 1) || (k == 0) || (k == this.i - 1)) {
            double d3 = i / (this.i - 1.0F) * 2.0F - 1.0F;
            double d4 = j / (this.i - 1.0F) * 2.0F - 1.0F;
            double d5 = k / (this.i - 1.0F) * 2.0F - 1.0F;
            double d6 = Math.sqrt(d3 * d3 + d4 * d4 + d5 * d5);
            
            d3 /= d6;
            d4 /= d6;
            d5 /= d6;
            float f1 = size * (0.7F + world.random.nextFloat() * 0.6F);
            
            double d0 = posX;
            double d1 = posY;
            double d2 = posZ;
            
            for (float f2 = 0.3F; f1 > 0.0F; f1 -= f2 * 0.75F) {
              int l = MathHelper.floor(d0);
              int i1 = MathHelper.floor(d1);
              int j1 = MathHelper.floor(d2);
              Block block = world.getType(l, i1, j1);
              
              if (block.getMaterial() != Material.AIR) {
                float f3 = source != null ? source.a(this, world, l, i1, j1, block) : block.a(source);
                
                f1 -= (f3 + 0.3F) * f2;
              }
              
              if ((f1 > 0.0F) && ((source == null) || (source.a(this, world, l, i1, j1, block, f1))) && (i1 < 256) && (i1 >= 0)) {
                hashset.add(new ChunkPosition(l, i1, j1));
              }
              
              d0 += d3 * f2;
              d1 += d4 * f2;
              d2 += d5 * f2;
            }
          }
        }
      }
    }
    
    blocks.addAll(hashset);
    size *= 2.0F;
    i = MathHelper.floor(posX - size - 1.0D);
    int j = MathHelper.floor(posX + size + 1.0D);
    int k = MathHelper.floor(posY - size - 1.0D);
    int k1 = MathHelper.floor(posY + size + 1.0D);
    int l1 = MathHelper.floor(posZ - size - 1.0D);
    int i2 = MathHelper.floor(posZ + size + 1.0D);
    List list = world.getEntities(source, AxisAlignedBB.a().a(i, k, l1, j, k1, i2));
    Vec3D vec3d = world.getVec3DPool().create(posX, posY, posZ);
    
    for (int j2 = 0; j2 < list.size(); j2++) {
      Entity entity = (Entity)list.get(j2);
      double d7 = entity.f(posX, posY, posZ) / size;
      
      if (d7 <= 1.0D) {
        double d0 = locX - posX;
        double d1 = locY + entity.getHeadHeight() - posY;
        double d2 = locZ - posZ;
        double d8 = MathHelper.sqrt(d0 * d0 + d1 * d1 + d2 * d2);
        
        if (d8 != 0.0D) {
          d0 /= d8;
          d1 /= d8;
          d2 /= d8;
          double d9 = world.a(vec3d, boundingBox);
          double d10 = (1.0D - d7) * d9;
          

          org.bukkit.entity.Entity damagee = entity == null ? null : entity.getBukkitEntity();
          float damageDone = (int)((d10 * d10 + d10) / 2.0D * 8.0D * size + 1.0D);
          
          if (damagee != null)
          {
            if (source == null) {
              EntityDamageByBlockEvent event = new EntityDamageByBlockEvent(null, damagee, EntityDamageEvent.DamageCause.BLOCK_EXPLOSION, damageDone);
              Bukkit.getPluginManager().callEvent(event);
              
              if (!event.isCancelled()) {
                damagee.setLastDamageCause(event);
                entity.damageEntity(DamageSource.explosion(this), (float)event.getDamage());
                double d11 = EnchantmentProtection.a(entity, d10);
                
                motX += d0 * d11;
                motY += d1 * d11;
                motZ += d2 * d11;
                if ((entity instanceof EntityHuman)) {
                  this.l.put((EntityHuman)entity, world.getVec3DPool().create(d0 * d10, d1 * d10, d2 * d10));
                }
              }
            } else {
              org.bukkit.entity.Entity damager = source.getBukkitEntity();
              EntityDamageEvent.DamageCause damageCause;
              EntityDamageEvent.DamageCause damageCause;
              if ((damager instanceof TNTPrimed)) {
                damageCause = EntityDamageEvent.DamageCause.BLOCK_EXPLOSION;
              } else {
                damageCause = EntityDamageEvent.DamageCause.ENTITY_EXPLOSION;
              }
              
              EntityDamageByEntityEvent event = new EntityDamageByEntityEvent(damager, damagee, damageCause, damageDone);
              Bukkit.getPluginManager().callEvent(event);
              
              if (!event.isCancelled()) {
                entity.getBukkitEntity().setLastDamageCause(event);
                entity.damageEntity(DamageSource.explosion(this), (float)event.getDamage());
                
                motX += d0 * d10;
                motY += d1 * d10;
                motZ += d2 * d10;
                if ((entity instanceof EntityHuman)) {
                  this.l.put((EntityHuman)entity, world.getVec3DPool().create(d0 * d10, d1 * d10, d2 * d10));
                }
              }
            }
          }
        }
      }
    }
    
    size = f;
  }
  
  public void a(boolean flag) {
    world.makeSound(posX, posY, posZ, "random.explode", 4.0F, (1.0F + (world.random.nextFloat() - world.random.nextFloat()) * 0.2F) * 0.7F);
    if ((size >= 2.0F) && (b)) {
      world.addParticle("hugeexplosion", posX, posY, posZ, 1.0D, 0.0D, 0.0D);
    } else {
      world.addParticle("largeexplode", posX, posY, posZ, 1.0D, 0.0D, 0.0D);
    }
    







    if (b)
    {
      org.bukkit.World bworld = world.getWorld();
      org.bukkit.entity.Entity explode = source == null ? null : source.getBukkitEntity();
      Location location = new Location(bworld, posX, posY, posZ);
      
      List<org.bukkit.block.Block> blockList = new ArrayList();
      for (int i1 = blocks.size() - 1; i1 >= 0; i1--) {
        ChunkPosition cpos = (ChunkPosition)blocks.get(i1);
        org.bukkit.block.Block bblock = bworld.getBlockAt(x, y, z);
        if (bblock.getType() != org.bukkit.Material.AIR) {
          blockList.add(bblock);
        }
      }
      
      EntityExplodeEvent event = new EntityExplodeEvent(explode, location, blockList, 0.3F);
      world.getServer().getPluginManager().callEvent(event);
      
      blocks.clear();
      
      for (org.bukkit.block.Block bblock : event.blockList()) {
        ChunkPosition coords = new ChunkPosition(bblock.getX(), bblock.getY(), bblock.getZ());
        blocks.add(coords);
      }
      
      if (event.isCancelled()) {
        wasCanceled = true;
        return;
      }
      

      Iterator iterator = blocks.iterator();
      
      while (iterator.hasNext()) {
        ChunkPosition chunkposition = (ChunkPosition)iterator.next();
        int i = x;
        int j = y;
        int k = z;
        Block block = world.getType(i, j, k);
        if (flag) {
          double d0 = i + world.random.nextFloat();
          double d1 = j + world.random.nextFloat();
          double d2 = k + world.random.nextFloat();
          double d3 = d0 - posX;
          double d4 = d1 - posY;
          double d5 = d2 - posZ;
          double d6 = MathHelper.sqrt(d3 * d3 + d4 * d4 + d5 * d5);
          
          d3 /= d6;
          d4 /= d6;
          d5 /= d6;
          double d7 = 0.5D / (d6 / size + 0.1D);
          
          d7 *= (world.random.nextFloat() * world.random.nextFloat() + 0.3F);
          d3 *= d7;
          d4 *= d7;
          d5 *= d7;
          world.addParticle("explode", (d0 + posX * 1.0D) / 2.0D, (d1 + posY * 1.0D) / 2.0D, (d2 + posZ * 1.0D) / 2.0D, d3, d4, d5);
          world.addParticle("smoke", d0, d1, d2, d3, d4, d5);
        }
        
        if (block.getMaterial() != Material.AIR) {
          if (block.a(this))
          {
            block.dropNaturally(world, i, j, k, world.getData(i, j, k), event.getYield(), 0);
          }
          
          world.setTypeAndData(i, j, k, Blocks.AIR, 0, 3);
          block.wasExploded(world, i, j, k, this);
        }
      }
    }
    
    if (a) {
      Iterator iterator = blocks.iterator();
      
      while (iterator.hasNext()) {
        ChunkPosition chunkposition = (ChunkPosition)iterator.next();
        int i = x;
        int j = y;
        int k = z;
        Block block = world.getType(i, j, k);
        Block block1 = world.getType(i, j - 1, k);
        
        if ((block.getMaterial() == Material.AIR) && (block1.j()) && (this.j.nextInt(3) == 0))
        {
          if (!org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callBlockIgniteEvent(world, i, j, k, this).isCancelled()) {
            world.setTypeUpdate(i, j, k, Blocks.FIRE);
          }
        }
      }
    }
  }
  
  public Map b()
  {
    return l;
  }
  
  public EntityLiving c() {
    return (source instanceof EntityLiving) ? (EntityLiving)source : (source instanceof EntityTNTPrimed) ? ((EntityTNTPrimed)source).getSource() : source == null ? null : null;
  }
}
