package net.minecraft.server.v1_7_R1;

import org.bukkit.event.entity.FoodLevelChangeEvent;

public class FoodMetaData {
  public int foodLevel = 20;
  public float saturationLevel = 5.0F;
  
  public float exhaustionLevel;
  public int foodTickTimer;
  private EntityHuman entityhuman;
  private int e = 20;
  
  public FoodMetaData() { throw new AssertionError("Whoopsie, we missed the bukkit."); }
  
  public FoodMetaData(EntityHuman entityhuman)
  {
    org.apache.commons.lang.Validate.notNull(entityhuman);
    this.entityhuman = entityhuman;
  }
  
  public void eat(int i, float f)
  {
    foodLevel = Math.min(i + foodLevel, 20);
    saturationLevel = Math.min(saturationLevel + i * f * 2.0F, foodLevel);
  }
  
  public void a(ItemFood itemfood, ItemStack itemstack)
  {
    int oldFoodLevel = foodLevel;
    
    FoodLevelChangeEvent event = org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callFoodLevelChangeEvent(entityhuman, itemfood.getNutrition(itemstack) + oldFoodLevel);
    
    if (!event.isCancelled()) {
      eat(event.getFoodLevel() - oldFoodLevel, itemfood.getSaturationModifier(itemstack));
    }
    
    entityhuman).playerConnection.sendPacket(new PacketPlayOutUpdateHealth(((EntityPlayer)entityhuman).getBukkitEntity().getScaledHealth(), entityhuman.getFoodData().foodLevel, entityhuman.getFoodData().saturationLevel));
  }
  
  public void a(EntityHuman entityhuman)
  {
    EnumDifficulty enumdifficulty = world.difficulty;
    
    e = foodLevel;
    if (exhaustionLevel > 4.0F) {
      exhaustionLevel -= 4.0F;
      if (saturationLevel > 0.0F) {
        saturationLevel = Math.max(saturationLevel - 1.0F, 0.0F);
      } else if (enumdifficulty != EnumDifficulty.PEACEFUL)
      {
        FoodLevelChangeEvent event = org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callFoodLevelChangeEvent(entityhuman, Math.max(foodLevel - 1, 0));
        
        if (!event.isCancelled()) {
          foodLevel = event.getFoodLevel();
        }
        
        playerConnection.sendPacket(new PacketPlayOutUpdateHealth(((EntityPlayer)entityhuman).getBukkitEntity().getScaledHealth(), foodLevel, saturationLevel));
      }
    }
    

    if ((world.getGameRules().getBoolean("naturalRegeneration")) && (foodLevel >= 18) && (entityhuman.bP())) {
      foodTickTimer += 1;
      if (foodTickTimer >= 80)
      {
        entityhuman.heal(1.0F, org.bukkit.event.entity.EntityRegainHealthEvent.RegainReason.SATIATED);
        a(3.0F);
        foodTickTimer = 0;
      }
    } else if (foodLevel <= 0) {
      foodTickTimer += 1;
      if (foodTickTimer >= 80) {
        if ((entityhuman.getHealth() > 10.0F) || (enumdifficulty == EnumDifficulty.HARD) || ((entityhuman.getHealth() > 1.0F) && (enumdifficulty == EnumDifficulty.NORMAL))) {
          entityhuman.damageEntity(DamageSource.STARVE, 1.0F);
        }
        
        foodTickTimer = 0;
      }
    } else {
      foodTickTimer = 0;
    }
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    if (nbttagcompound.hasKeyOfType("foodLevel", 99)) {
      foodLevel = nbttagcompound.getInt("foodLevel");
      foodTickTimer = nbttagcompound.getInt("foodTickTimer");
      saturationLevel = nbttagcompound.getFloat("foodSaturationLevel");
      exhaustionLevel = nbttagcompound.getFloat("foodExhaustionLevel");
    }
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    nbttagcompound.setInt("foodLevel", foodLevel);
    nbttagcompound.setInt("foodTickTimer", foodTickTimer);
    nbttagcompound.setFloat("foodSaturationLevel", saturationLevel);
    nbttagcompound.setFloat("foodExhaustionLevel", exhaustionLevel);
  }
  
  public int a() {
    return foodLevel;
  }
  
  public boolean c() {
    return foodLevel < 20;
  }
  
  public void a(float f) {
    exhaustionLevel = Math.min(exhaustionLevel + f, 40.0F);
  }
  
  public float e() {
    return saturationLevel;
  }
}
