package net.minecraft.server.v1_7_R1;

import java.util.Collection;
import java.util.UUID;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;


public class GenericAttributes
{
  private static final Logger f = ;
  public static final IAttribute a = new AttributeRanged("generic.maxHealth", 20.0D, 0.0D, 1.7976931348623157E+308D).a("Max Health").a(true);
  public static final IAttribute b = new AttributeRanged("generic.followRange", 32.0D, 0.0D, 2048.0D).a("Follow Range");
  public static final IAttribute c = new AttributeRanged("generic.knockbackResistance", 0.0D, 0.0D, 1.0D).a("Knockback Resistance");
  public static final IAttribute d = new AttributeRanged("generic.movementSpeed", 0.699999988079071D, 0.0D, 1.7976931348623157E+308D).a("Movement Speed").a(true);
  public static final IAttribute e = new AttributeRanged("generic.attackDamage", 2.0D, 0.0D, 1.7976931348623157E+308D);
  
  public static NBTTagList a(AttributeMapBase paramAttributeMapBase) {
    NBTTagList localNBTTagList = new NBTTagList();
    
    for (AttributeInstance localAttributeInstance : paramAttributeMapBase.a()) {
      localNBTTagList.add(a(localAttributeInstance));
    }
    
    return localNBTTagList;
  }
  
  private static NBTTagCompound a(AttributeInstance paramAttributeInstance) {
    NBTTagCompound localNBTTagCompound = new NBTTagCompound();
    IAttribute localIAttribute = paramAttributeInstance.a();
    
    localNBTTagCompound.setString("Name", localIAttribute.a());
    localNBTTagCompound.setDouble("Base", paramAttributeInstance.b());
    
    Collection localCollection = paramAttributeInstance.c();
    
    if ((localCollection != null) && (!localCollection.isEmpty())) {
      NBTTagList localNBTTagList = new NBTTagList();
      
      for (AttributeModifier localAttributeModifier : localCollection) {
        if (localAttributeModifier.e()) {
          localNBTTagList.add(a(localAttributeModifier));
        }
      }
      
      localNBTTagCompound.set("Modifiers", localNBTTagList);
    }
    
    return localNBTTagCompound;
  }
  
  private static NBTTagCompound a(AttributeModifier paramAttributeModifier) {
    NBTTagCompound localNBTTagCompound = new NBTTagCompound();
    
    localNBTTagCompound.setString("Name", paramAttributeModifier.b());
    localNBTTagCompound.setDouble("Amount", paramAttributeModifier.d());
    localNBTTagCompound.setInt("Operation", paramAttributeModifier.c());
    localNBTTagCompound.setLong("UUIDMost", paramAttributeModifier.a().getMostSignificantBits());
    localNBTTagCompound.setLong("UUIDLeast", paramAttributeModifier.a().getLeastSignificantBits());
    
    return localNBTTagCompound;
  }
  
  public static void a(AttributeMapBase paramAttributeMapBase, NBTTagList paramNBTTagList) {
    for (int i = 0; i < paramNBTTagList.size(); i++) {
      NBTTagCompound localNBTTagCompound = paramNBTTagList.get(i);
      AttributeInstance localAttributeInstance = paramAttributeMapBase.a(localNBTTagCompound.getString("Name"));
      
      if (localAttributeInstance != null) {
        a(localAttributeInstance, localNBTTagCompound);
      } else {
        f.warn("Ignoring unknown attribute '" + localNBTTagCompound.getString("Name") + "'");
      }
    }
  }
  
  private static void a(AttributeInstance paramAttributeInstance, NBTTagCompound paramNBTTagCompound) {
    paramAttributeInstance.setValue(paramNBTTagCompound.getDouble("Base"));
    
    if (paramNBTTagCompound.hasKeyOfType("Modifiers", 9)) {
      NBTTagList localNBTTagList = paramNBTTagCompound.getList("Modifiers", 10);
      
      for (int i = 0; i < localNBTTagList.size(); i++) {
        AttributeModifier localAttributeModifier1 = a(localNBTTagList.get(i));
        AttributeModifier localAttributeModifier2 = paramAttributeInstance.a(localAttributeModifier1.a());
        if (localAttributeModifier2 != null) paramAttributeInstance.b(localAttributeModifier2);
        paramAttributeInstance.a(localAttributeModifier1);
      }
    }
  }
  
  public static AttributeModifier a(NBTTagCompound paramNBTTagCompound) {
    UUID localUUID = new UUID(paramNBTTagCompound.getLong("UUIDMost"), paramNBTTagCompound.getLong("UUIDLeast"));
    return new AttributeModifier(localUUID, paramNBTTagCompound.getString("Name"), paramNBTTagCompound.getDouble("Amount"), paramNBTTagCompound.getInt("Operation"));
  }
}
