package net.minecraft.server.v1_7_R1;

import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map.Entry;
import net.minecraft.util.io.netty.util.concurrent.GenericFutureListener;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;

public class HandshakeListener implements PacketHandshakingInListener
{
  private static final HashMap<InetAddress, Long> throttleTracker = new HashMap();
  private static int throttleCounter = 0;
  
  private final MinecraftServer a;
  private final NetworkManager b;
  
  public HandshakeListener(MinecraftServer minecraftserver, NetworkManager networkmanager)
  {
    a = minecraftserver;
    b = networkmanager;
  }
  
  public void a(PacketHandshakingInSetProtocol packethandshakinginsetprotocol) {
    switch (ProtocolOrdinalWrapper.a[packethandshakinginsetprotocol.c().ordinal()]) {
    case 1: 
      b.a(EnumProtocol.LOGIN);
      

      try
      {
        long currentTime = System.currentTimeMillis();
        long connectionThrottle = getServer()server.getConnectionThrottle();
        InetAddress address = ((InetSocketAddress)b.getSocketAddress()).getAddress();
        
        synchronized (throttleTracker) {
          if ((throttleTracker.containsKey(address)) && (!"127.0.0.1".equals(address.getHostAddress())) && (currentTime - ((Long)throttleTracker.get(address)).longValue() < connectionThrottle)) {
            throttleTracker.put(address, Long.valueOf(currentTime));
            ChatComponentText chatcomponenttext = new ChatComponentText("Connection throttled! Please wait before reconnecting.");
            b.handle(new PacketLoginOutDisconnect(chatcomponenttext), new GenericFutureListener[0]);
            b.a(chatcomponenttext);
            return;
          }
          
          throttleTracker.put(address, Long.valueOf(currentTime));
          throttleCounter += 1;
          if (throttleCounter > 200) {
            throttleCounter = 0;
            

            Iterator iter = throttleTracker.entrySet().iterator();
            while (iter.hasNext()) {
              Map.Entry<InetAddress, Long> entry = (Map.Entry)iter.next();
              if (((Long)entry.getValue()).longValue() > connectionThrottle) {
                iter.remove();
              }
            }
          }
        }
      } catch (Throwable t) {
        org.apache.logging.log4j.LogManager.getLogger().error("Failed to check connection throttle", t);
      }
      

      if (packethandshakinginsetprotocol.d() > 4) {
        ChatComponentText chatcomponenttext = new ChatComponentText("Outdated server! I'm still on 1.7.2");
        b.handle(new PacketLoginOutDisconnect(chatcomponenttext), new GenericFutureListener[0]);
        b.a(chatcomponenttext);
      } else if (packethandshakinginsetprotocol.d() < 4) {
        ChatComponentText chatcomponenttext = new ChatComponentText("Outdated client! Please use 1.7.2");
        b.handle(new PacketLoginOutDisconnect(chatcomponenttext), new GenericFutureListener[0]);
        b.a(chatcomponenttext);
      } else {
        b.a(new LoginListener(a, b));
        b.getPacketListener()).hostname = (b + ":" + c);
      }
      break;
    
    case 2: 
      b.a(EnumProtocol.STATUS);
      b.a(new PacketStatusListener(a, b));
      break;
    
    default: 
      throw new UnsupportedOperationException("Invalid intention " + packethandshakinginsetprotocol.c());
    }
  }
  
  public void a(IChatBaseComponent ichatbasecomponent) {}
  
  public void a(EnumProtocol enumprotocol, EnumProtocol enumprotocol1) {
    if ((enumprotocol1 != EnumProtocol.LOGIN) && (enumprotocol1 != EnumProtocol.STATUS)) {
      throw new UnsupportedOperationException("Invalid state " + enumprotocol1);
    }
  }
  
  public void a() {}
}
