package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.List;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftHumanEntity;
import org.bukkit.entity.HumanEntity;
import org.bukkit.event.inventory.InventoryType;
import org.bukkit.inventory.InventoryHolder;



public class InventoryCrafting
  implements IInventory
{
  private ItemStack[] items;
  private int b;
  private Container c;
  public List<HumanEntity> transaction = new ArrayList();
  public IRecipe currentRecipe;
  public IInventory resultInventory;
  private EntityHuman owner;
  private int maxStack = 64;
  
  public ItemStack[] getContents() {
    return items;
  }
  
  public void onOpen(CraftHumanEntity who) {
    transaction.add(who);
  }
  
  public InventoryType getInvType() {
    return items.length == 4 ? InventoryType.CRAFTING : InventoryType.WORKBENCH;
  }
  
  public void onClose(CraftHumanEntity who) {
    transaction.remove(who);
  }
  
  public List<HumanEntity> getViewers() {
    return transaction;
  }
  
  public InventoryHolder getOwner() {
    return owner.getBukkitEntity();
  }
  
  public void setMaxStackSize(int size) {
    maxStack = size;
    resultInventory.setMaxStackSize(size);
  }
  
  public InventoryCrafting(Container container, int i, int j, EntityHuman player) {
    this(container, i, j);
    owner = player;
  }
  
  public InventoryCrafting(Container container, int i, int j)
  {
    int k = i * j;
    
    items = new ItemStack[k];
    c = container;
    b = i;
  }
  
  public int getSize() {
    return items.length;
  }
  
  public ItemStack getItem(int i) {
    return i >= getSize() ? null : items[i];
  }
  
  public ItemStack b(int i, int j) {
    if ((i >= 0) && (i < b)) {
      int k = i + j * b;
      
      return getItem(k);
    }
    return null;
  }
  
  public String getInventoryName()
  {
    return "container.crafting";
  }
  
  public boolean k_() {
    return false;
  }
  
  public ItemStack splitWithoutUpdate(int i) {
    if (items[i] != null) {
      ItemStack itemstack = items[i];
      
      items[i] = null;
      return itemstack;
    }
    return null;
  }
  
  public ItemStack splitStack(int i, int j)
  {
    if (items[i] != null)
    {

      if (items[i].count <= j) {
        ItemStack itemstack = items[i];
        items[i] = null;
        c.a(this);
        return itemstack;
      }
      ItemStack itemstack = items[i].a(j);
      if (items[i].count == 0) {
        items[i] = null;
      }
      
      c.a(this);
      return itemstack;
    }
    
    return null;
  }
  
  public void setItem(int i, ItemStack itemstack)
  {
    items[i] = itemstack;
    c.a(this);
  }
  
  public int getMaxStackSize() {
    return maxStack;
  }
  
  public void update() {}
  
  public boolean a(EntityHuman entityhuman) {
    return true;
  }
  
  public void startOpen() {}
  
  public void l_() {}
  
  public boolean b(int i, ItemStack itemstack) {
    return true;
  }
}
