package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.List;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftHumanEntity;
import org.bukkit.entity.HumanEntity;
import org.bukkit.inventory.InventoryHolder;



public class InventoryLargeChest
  implements IInventory
{
  private String a;
  public IInventory left;
  public IInventory right;
  public List<HumanEntity> transaction = new ArrayList();
  
  public ItemStack[] getContents() {
    ItemStack[] result = new ItemStack[getSize()];
    for (int i = 0; i < result.length; i++) {
      result[i] = getItem(i);
    }
    return result;
  }
  
  public void onOpen(CraftHumanEntity who) {
    left.onOpen(who);
    right.onOpen(who);
    transaction.add(who);
  }
  
  public void onClose(CraftHumanEntity who) {
    left.onClose(who);
    right.onClose(who);
    transaction.remove(who);
  }
  
  public List<HumanEntity> getViewers() {
    return transaction;
  }
  
  public InventoryHolder getOwner() {
    return null;
  }
  
  public void setMaxStackSize(int size) {
    left.setMaxStackSize(size);
    right.setMaxStackSize(size);
  }
  
  public InventoryLargeChest(String s, IInventory iinventory, IInventory iinventory1)
  {
    a = s;
    if (iinventory == null) {
      iinventory = iinventory1;
    }
    
    if (iinventory1 == null) {
      iinventory1 = iinventory;
    }
    
    left = iinventory;
    right = iinventory1;
  }
  
  public int getSize() {
    return left.getSize() + right.getSize();
  }
  
  public boolean a(IInventory iinventory) {
    return (left == iinventory) || (right == iinventory);
  }
  
  public String getInventoryName() {
    return right.k_() ? right.getInventoryName() : left.k_() ? left.getInventoryName() : a;
  }
  
  public boolean k_() {
    return (left.k_()) || (right.k_());
  }
  
  public ItemStack getItem(int i) {
    return i >= left.getSize() ? right.getItem(i - left.getSize()) : left.getItem(i);
  }
  
  public ItemStack splitStack(int i, int j) {
    return i >= left.getSize() ? right.splitStack(i - left.getSize(), j) : left.splitStack(i, j);
  }
  
  public ItemStack splitWithoutUpdate(int i) {
    return i >= left.getSize() ? right.splitWithoutUpdate(i - left.getSize()) : left.splitWithoutUpdate(i);
  }
  
  public void setItem(int i, ItemStack itemstack) {
    if (i >= left.getSize()) {
      right.setItem(i - left.getSize(), itemstack);
    } else {
      left.setItem(i, itemstack);
    }
  }
  
  public int getMaxStackSize() {
    return Math.min(left.getMaxStackSize(), right.getMaxStackSize());
  }
  
  public void update() {
    left.update();
    right.update();
  }
  
  public boolean a(EntityHuman entityhuman) {
    return (left.a(entityhuman)) && (right.a(entityhuman));
  }
  
  public void startOpen() {
    left.startOpen();
    right.startOpen();
  }
  
  public void l_() {
    left.l_();
    right.l_();
  }
  
  public boolean b(int i, ItemStack itemstack) {
    return true;
  }
}
