package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.List;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftHumanEntity;
import org.bukkit.entity.HumanEntity;
import org.bukkit.inventory.InventoryHolder;

public class InventoryMerchant implements IInventory
{
  private final IMerchant merchant;
  private ItemStack[] itemsInSlots = new ItemStack[3];
  
  private final EntityHuman player;
  
  private MerchantRecipe recipe;
  private int e;
  public List<HumanEntity> transaction = new ArrayList();
  private int maxStack = 64;
  
  public ItemStack[] getContents() {
    return itemsInSlots;
  }
  
  public void onOpen(CraftHumanEntity who) {
    transaction.add(who);
  }
  
  public void onClose(CraftHumanEntity who) {
    transaction.remove(who);
  }
  
  public List<HumanEntity> getViewers() {
    return transaction;
  }
  
  public void setMaxStackSize(int i) {
    maxStack = i;
  }
  
  public InventoryHolder getOwner() {
    return player.getBukkitEntity();
  }
  
  public InventoryMerchant(EntityHuman entityhuman, IMerchant imerchant)
  {
    player = entityhuman;
    merchant = imerchant;
  }
  
  public int getSize() {
    return itemsInSlots.length;
  }
  
  public ItemStack getItem(int i) {
    return itemsInSlots[i];
  }
  
  public ItemStack splitStack(int i, int j) {
    if (itemsInSlots[i] != null)
    {

      if (i == 2) {
        ItemStack itemstack = itemsInSlots[i];
        itemsInSlots[i] = null;
        return itemstack; }
      if (itemsInSlots[i].count <= j) {
        ItemStack itemstack = itemsInSlots[i];
        itemsInSlots[i] = null;
        if (d(i)) {
          h();
        }
        
        return itemstack;
      }
      ItemStack itemstack = itemsInSlots[i].a(j);
      if (itemsInSlots[i].count == 0) {
        itemsInSlots[i] = null;
      }
      
      if (d(i)) {
        h();
      }
      
      return itemstack;
    }
    
    return null;
  }
  
  private boolean d(int i)
  {
    return (i == 0) || (i == 1);
  }
  
  public ItemStack splitWithoutUpdate(int i) {
    if (itemsInSlots[i] != null) {
      ItemStack itemstack = itemsInSlots[i];
      
      itemsInSlots[i] = null;
      return itemstack;
    }
    return null;
  }
  
  public void setItem(int i, ItemStack itemstack)
  {
    itemsInSlots[i] = itemstack;
    if ((itemstack != null) && (count > getMaxStackSize())) {
      count = getMaxStackSize();
    }
    
    if (d(i)) {
      h();
    }
  }
  
  public String getInventoryName() {
    return "mob.villager";
  }
  
  public boolean k_() {
    return false;
  }
  
  public int getMaxStackSize() {
    return maxStack;
  }
  
  public boolean a(EntityHuman entityhuman) {
    return merchant.b() == entityhuman;
  }
  
  public void startOpen() {}
  
  public void l_() {}
  
  public boolean b(int i, ItemStack itemstack) {
    return true;
  }
  
  public void update() {
    h();
  }
  
  public void h() {
    recipe = null;
    ItemStack itemstack = itemsInSlots[0];
    ItemStack itemstack1 = itemsInSlots[1];
    
    if (itemstack == null) {
      itemstack = itemstack1;
      itemstack1 = null;
    }
    
    if (itemstack == null) {
      setItem(2, (ItemStack)null);
    } else {
      MerchantRecipeList merchantrecipelist = merchant.getOffers(player);
      
      if (merchantrecipelist != null) {
        MerchantRecipe merchantrecipe = merchantrecipelist.a(itemstack, itemstack1, e);
        
        if ((merchantrecipe != null) && (!merchantrecipe.g())) {
          recipe = merchantrecipe;
          setItem(2, merchantrecipe.getBuyItem3().cloneItemStack());
        } else if (itemstack1 != null) {
          merchantrecipe = merchantrecipelist.a(itemstack1, itemstack, e);
          if ((merchantrecipe != null) && (!merchantrecipe.g())) {
            recipe = merchantrecipe;
            setItem(2, merchantrecipe.getBuyItem3().cloneItemStack());
          } else {
            setItem(2, (ItemStack)null);
          }
        } else {
          setItem(2, (ItemStack)null);
        }
      }
    }
    
    merchant.a_(getItem(2));
  }
  
  public MerchantRecipe getRecipe() {
    return recipe;
  }
  
  public void c(int i) {
    e = i;
    h();
  }
}
