package net.minecraft.server.v1_7_R1;

import java.util.Random;
import org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack;
import org.bukkit.event.player.PlayerBucketEmptyEvent;
import org.bukkit.event.player.PlayerBucketFillEvent;

public class ItemBucket extends Item
{
  private Block a;
  
  public ItemBucket(Block block)
  {
    maxStackSize = 1;
    a = block;
    a(CreativeModeTab.f);
  }
  
  public ItemStack a(ItemStack itemstack, World world, EntityHuman entityhuman) {
    boolean flag = a == Blocks.AIR;
    MovingObjectPosition movingobjectposition = a(world, entityhuman, flag);
    
    if (movingobjectposition == null) {
      return itemstack;
    }
    if (type == EnumMovingObjectType.BLOCK) {
      int i = b;
      int j = c;
      int k = d;
      
      if (!world.a(entityhuman, i, j, k)) {
        return itemstack;
      }
      
      if (flag) {
        if (!entityhuman.a(i, j, k, face, itemstack)) {
          return itemstack;
        }
        
        Material material = world.getType(i, j, k).getMaterial();
        int l = world.getData(i, j, k);
        
        if ((material == Material.WATER) && (l == 0))
        {
          PlayerBucketFillEvent event = CraftEventFactory.callPlayerBucketFillEvent(entityhuman, i, j, k, -1, itemstack, Items.WATER_BUCKET);
          
          if (event.isCancelled()) {
            return itemstack;
          }
          
          world.setAir(i, j, k);
          return a(itemstack, entityhuman, Items.WATER_BUCKET, event.getItemStack());
        }
        
        if ((material == Material.LAVA) && (l == 0))
        {
          PlayerBucketFillEvent event = CraftEventFactory.callPlayerBucketFillEvent(entityhuman, i, j, k, -1, itemstack, Items.LAVA_BUCKET);
          
          if (event.isCancelled()) {
            return itemstack;
          }
          
          world.setAir(i, j, k);
          return a(itemstack, entityhuman, Items.LAVA_BUCKET, event.getItemStack());
        }
      } else {
        if (a == Blocks.AIR)
        {
          PlayerBucketEmptyEvent event = CraftEventFactory.callPlayerBucketEmptyEvent(entityhuman, i, j, k, face, itemstack);
          
          if (event.isCancelled()) {
            return itemstack;
          }
          
          return CraftItemStack.asNMSCopy(event.getItemStack());
        }
        
        int clickedX = i;int clickedY = j;int clickedZ = k;
        

        if (face == 0) {
          j--;
        }
        
        if (face == 1) {
          j++;
        }
        
        if (face == 2) {
          k--;
        }
        
        if (face == 3) {
          k++;
        }
        
        if (face == 4) {
          i--;
        }
        
        if (face == 5) {
          i++;
        }
        
        if (!entityhuman.a(i, j, k, face, itemstack)) {
          return itemstack;
        }
        

        PlayerBucketEmptyEvent event = CraftEventFactory.callPlayerBucketEmptyEvent(entityhuman, clickedX, clickedY, clickedZ, face, itemstack);
        
        if (event.isCancelled()) {
          return itemstack;
        }
        

        if ((a(world, i, j, k)) && (!abilities.canInstantlyBuild)) {
          return CraftItemStack.asNMSCopy(event.getItemStack());
        }
      }
    }
    
    return itemstack;
  }
  

  private ItemStack a(ItemStack itemstack, EntityHuman entityhuman, Item item, org.bukkit.inventory.ItemStack result)
  {
    if (abilities.canInstantlyBuild)
      return itemstack;
    if (--count <= 0) {
      return CraftItemStack.asNMSCopy(result);
    }
    if (!inventory.pickup(CraftItemStack.asNMSCopy(result))) {
      entityhuman.drop(CraftItemStack.asNMSCopy(result), false);
    }
    
    return itemstack;
  }
  
  public boolean a(World world, int i, int j, int k)
  {
    if (a == Blocks.AIR) {
      return false;
    }
    Material material = world.getType(i, j, k).getMaterial();
    boolean flag = !material.isBuildable();
    
    if ((!world.isEmpty(i, j, k)) && (!flag)) {
      return false;
    }
    if ((worldProvider.f) && (a == Blocks.WATER)) {
      world.makeSound(i + 0.5F, j + 0.5F, k + 0.5F, "random.fizz", 0.5F, 2.6F + (random.nextFloat() - random.nextFloat()) * 0.8F);
      
      for (int l = 0; l < 8; l++) {
        world.addParticle("largesmoke", i + Math.random(), j + Math.random(), k + Math.random(), 0.0D, 0.0D, 0.0D);
      }
    } else {
      if ((!isStatic) && (flag) && (!material.isLiquid())) {
        world.setAir(i, j, k, true);
      }
      
      world.setTypeAndData(i, j, k, a, 0, 3);
    }
    
    return true;
  }
}
