package net.minecraft.server.v1_7_R1;

import java.text.DecimalFormat;
import java.util.Random;
import java.util.UUID;
import net.minecraft.util.com.google.common.collect.HashMultimap;
import net.minecraft.util.com.google.common.collect.Multimap;
import org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory;
import org.bukkit.craftbukkit.v1_7_R1.util.CraftMagicNumbers;

public final class ItemStack
{
  public static final DecimalFormat a = new DecimalFormat("#.###");
  public int count;
  public int c;
  private Item item;
  public NBTTagCompound tag;
  private int damage;
  private EntityItemFrame g;
  
  public ItemStack(Block block) {
    this(block, 1);
  }
  
  public ItemStack(Block block, int i) {
    this(block, i, 0);
  }
  
  public ItemStack(Block block, int i, int j) {
    this(Item.getItemOf(block), i, j);
  }
  
  public ItemStack(Item item) {
    this(item, 1);
  }
  
  public ItemStack(Item item, int i) {
    this(item, i, 0);
  }
  
  public ItemStack(Item item, int i, int j) {
    this.item = item;
    count = i;
    
    setData(j);
  }
  




  public static ItemStack createStack(NBTTagCompound nbttagcompound)
  {
    ItemStack itemstack = new ItemStack();
    
    itemstack.c(nbttagcompound);
    return itemstack.getItem() != null ? itemstack : null;
  }
  
  private ItemStack() {}
  
  public ItemStack a(int i) {
    ItemStack itemstack = new ItemStack(item, i, damage);
    
    if (tag != null) {
      tag = ((NBTTagCompound)tag.clone());
    }
    
    count -= i;
    return itemstack;
  }
  
  public Item getItem() {
    return item;
  }
  
  public boolean placeItem(EntityHuman entityhuman, World world, int i, int j, int k, int l, float f, float f1, float f2) {
    boolean flag = getItem().interactWith(this, entityhuman, world, i, j, k, l, f, f1, f2);
    
    if (flag) {
      entityhuman.a(StatisticList.E[Item.b(item)], 1);
    }
    
    return flag;
  }
  
  public float a(Block block) {
    return getItem().getDestroySpeed(this, block);
  }
  
  public ItemStack a(World world, EntityHuman entityhuman) {
    return getItem().a(this, world, entityhuman);
  }
  
  public ItemStack b(World world, EntityHuman entityhuman) {
    return getItem().b(this, world, entityhuman);
  }
  
  public NBTTagCompound save(NBTTagCompound nbttagcompound) {
    nbttagcompound.setShort("id", (short)Item.b(item));
    nbttagcompound.setByte("Count", (byte)count);
    nbttagcompound.setShort("Damage", (short)damage);
    if (tag != null) {
      nbttagcompound.set("tag", tag.clone());
    }
    
    return nbttagcompound;
  }
  
  public void c(NBTTagCompound nbttagcompound) {
    item = Item.d(nbttagcompound.getShort("id"));
    count = nbttagcompound.getByte("Count");
    damage = nbttagcompound.getShort("Damage");
    if (damage < 0) {
      damage = 0;
    }
    
    if (nbttagcompound.hasKeyOfType("tag", 10))
    {
      tag = ((NBTTagCompound)nbttagcompound.getCompound("tag").clone());
    }
  }
  
  public int getMaxStackSize() {
    return getItem().getMaxStackSize();
  }
  
  public boolean isStackable() {
    return (getMaxStackSize() > 1) && ((!g()) || (!i()));
  }
  
  public boolean g() {
    return item.getMaxDurability() > 0;
  }
  
  public boolean usesData() {
    return item.n();
  }
  
  public boolean i() {
    return (g()) && (damage > 0);
  }
  
  public int j() {
    return damage;
  }
  
  public int getData() {
    return damage;
  }
  

  public void setData(int i)
  {
    if (i == 32767) {
      damage = i;
      return;
    }
    

    if (CraftMagicNumbers.getBlock(CraftMagicNumbers.getId(getItem())) != Blocks.AIR)
    {
      if ((!usesData()) && (!getItem().usesDurability())) {
        i = 0;
      }
    }
    

    damage = i;
    if (damage < -1) {
      damage = 0;
    }
  }
  
  public int l() {
    return item.getMaxDurability();
  }
  
  public boolean isDamaged(int i, Random random) {
    if (!g()) {
      return false;
    }
    if (i > 0) {
      int j = EnchantmentManager.getEnchantmentLevel(DURABILITYid, this);
      int k = 0;
      
      for (int l = 0; (j > 0) && (l < i); l++) {
        if (EnchantmentDurability.a(this, j, random)) {
          k++;
        }
      }
      
      i -= k;
      if (i <= 0) {
        return false;
      }
    }
    
    damage += i;
    return damage > l();
  }
  
  public void damage(int i, EntityLiving entityliving)
  {
    if (((!(entityliving instanceof EntityHuman)) || (!abilities.canInstantlyBuild)) && 
      (g()) && 
      (isDamaged(i, entityliving.aI()))) {
      entityliving.a(this);
      count -= 1;
      if ((entityliving instanceof EntityHuman)) {
        EntityHuman entityhuman = (EntityHuman)entityliving;
        
        entityhuman.a(StatisticList.F[Item.b(item)], 1);
        if ((count == 0) && ((getItem() instanceof ItemBow))) {
          entityhuman.bE();
        }
      }
      
      if (count < 0) {
        count = 0;
      }
      

      if ((count == 0) && ((entityliving instanceof EntityHuman))) {
        CraftEventFactory.callPlayerItemBreakEvent((EntityHuman)entityliving, this);
      }
      

      damage = 0;
    }
  }
  

  public void a(EntityLiving entityliving, EntityHuman entityhuman)
  {
    boolean flag = item.a(this, entityliving, entityhuman);
    
    if (flag) {
      entityhuman.a(StatisticList.E[Item.b(item)], 1);
    }
  }
  
  public void a(World world, Block block, int i, int j, int k, EntityHuman entityhuman) {
    boolean flag = item.a(this, world, block, i, j, k, entityhuman);
    
    if (flag) {
      entityhuman.a(StatisticList.E[Item.b(item)], 1);
    }
  }
  
  public boolean b(Block block) {
    return item.canDestroySpecialBlock(block);
  }
  
  public boolean a(EntityHuman entityhuman, EntityLiving entityliving) {
    return item.a(this, entityhuman, entityliving);
  }
  
  public ItemStack cloneItemStack() {
    ItemStack itemstack = new ItemStack(item, count, damage);
    
    if (tag != null) {
      tag = ((NBTTagCompound)tag.clone());
    }
    
    return itemstack;
  }
  
  public static boolean equals(ItemStack itemstack, ItemStack itemstack1) {
    return (itemstack == null) && (itemstack1 == null);
  }
  
  public static boolean matches(ItemStack itemstack, ItemStack itemstack1) {
    return (itemstack == null) && (itemstack1 == null);
  }
  
  private boolean d(ItemStack itemstack) {
    return count == count;
  }
  
  public boolean doMaterialsMatch(ItemStack itemstack) {
    return (item == item) && (damage == damage);
  }
  
  public String a() {
    return item.a(this);
  }
  
  public static ItemStack b(ItemStack itemstack) {
    return itemstack == null ? null : itemstack.cloneItemStack();
  }
  
  public String toString() {
    return count + "x" + item.getName() + "@" + damage;
  }
  
  public void a(World world, Entity entity, int i, boolean flag) {
    if (c > 0) {
      c -= 1;
    }
    
    item.a(this, world, entity, i, flag);
  }
  
  public void a(World world, EntityHuman entityhuman, int i) {
    entityhuman.a(StatisticList.D[Item.b(item)], i);
    item.d(this, world, entityhuman);
  }
  
  public int n() {
    return getItem().d_(this);
  }
  
  public EnumAnimation o() {
    return getItem().d(this);
  }
  
  public void b(World world, EntityHuman entityhuman, int i) {
    getItem().a(this, world, entityhuman, i);
  }
  
  public boolean hasTag() {
    return tag != null;
  }
  
  public NBTTagCompound getTag() {
    return tag;
  }
  
  public NBTTagList getEnchantments() {
    return tag == null ? null : tag.getList("ench", 10);
  }
  
  public void setTag(NBTTagCompound nbttagcompound) {
    tag = nbttagcompound;
  }
  
  public String getName() {
    String s = getItem().n(this);
    
    if ((tag != null) && (tag.hasKeyOfType("display", 10))) {
      NBTTagCompound nbttagcompound = tag.getCompound("display");
      
      if (nbttagcompound.hasKeyOfType("Name", 8)) {
        s = nbttagcompound.getString("Name");
      }
    }
    
    return s;
  }
  
  public ItemStack c(String s) {
    if (tag == null) {
      tag = new NBTTagCompound();
    }
    
    if (!tag.hasKeyOfType("display", 10)) {
      tag.set("display", new NBTTagCompound());
    }
    
    tag.getCompound("display").setString("Name", s);
    return this;
  }
  
  public void t() {
    if ((tag != null) && 
      (tag.hasKeyOfType("display", 10))) {
      NBTTagCompound nbttagcompound = tag.getCompound("display");
      
      nbttagcompound.remove("Name");
      if (nbttagcompound.isEmpty()) {
        tag.remove("display");
        if (tag.isEmpty()) {
          setTag((NBTTagCompound)null);
        }
      }
    }
  }
  
  public boolean hasName()
  {
    return !tag.hasKeyOfType("display", 10) ? false : tag == null ? false : tag.getCompound("display").hasKeyOfType("Name", 8);
  }
  
  public EnumItemRarity w() {
    return getItem().f(this);
  }
  
  public boolean x() {
    return getItem().e_(this);
  }
  
  public void addEnchantment(Enchantment enchantment, int i) {
    if (tag == null) {
      setTag(new NBTTagCompound());
    }
    
    if (!tag.hasKeyOfType("ench", 9)) {
      tag.set("ench", new NBTTagList());
    }
    
    NBTTagList nbttaglist = tag.getList("ench", 10);
    NBTTagCompound nbttagcompound = new NBTTagCompound();
    
    nbttagcompound.setShort("id", (short)id);
    nbttagcompound.setShort("lvl", (short)(byte)i);
    nbttaglist.add(nbttagcompound);
  }
  
  public boolean hasEnchantments() {
    return (tag != null) && (tag.hasKeyOfType("ench", 9));
  }
  
  public void a(String s, NBTBase nbtbase) {
    if (tag == null) {
      setTag(new NBTTagCompound());
    }
    
    tag.set(s, nbtbase);
  }
  
  public boolean z() {
    return getItem().v();
  }
  
  public boolean A() {
    return g != null;
  }
  
  public void a(EntityItemFrame entityitemframe) {
    g = entityitemframe;
  }
  
  public EntityItemFrame B() {
    return g;
  }
  
  public int getRepairCost() {
    return (hasTag()) && (tag.hasKeyOfType("RepairCost", 3)) ? tag.getInt("RepairCost") : 0;
  }
  
  public void setRepairCost(int i) {
    if (!hasTag()) {
      tag = new NBTTagCompound();
    }
    
    tag.setInt("RepairCost", i);
  }
  
  public Multimap D()
  {
    Object object;
    if ((hasTag()) && (tag.hasKeyOfType("AttributeModifiers", 9))) {
      Object object = HashMultimap.create();
      NBTTagList nbttaglist = tag.getList("AttributeModifiers", 10);
      
      for (int i = 0; i < nbttaglist.size(); i++) {
        NBTTagCompound nbttagcompound = nbttaglist.get(i);
        AttributeModifier attributemodifier = GenericAttributes.a(nbttagcompound);
        
        if ((attributemodifier.a().getLeastSignificantBits() != 0L) && (attributemodifier.a().getMostSignificantBits() != 0L)) {
          ((Multimap)object).put(nbttagcompound.getString("AttributeName"), attributemodifier);
        }
      }
    } else {
      object = getItem().k();
    }
    
    return (Multimap)object;
  }
  
  public void setItem(Item item) {
    this.item = item;
  }
  
  public IChatBaseComponent E() {
    IChatBaseComponent ichatbasecomponent = new ChatComponentText("[").a(getName()).a("]");
    
    if (item != null) {
      NBTTagCompound nbttagcompound = new NBTTagCompound();
      
      save(nbttagcompound);
      ichatbasecomponent.b().a(new ChatHoverable(EnumHoverAction.SHOW_ITEM, new ChatComponentText(nbttagcompound.toString())));
      ichatbasecomponent.b().setColor(w()e);
    }
    
    return ichatbasecomponent;
  }
}
