package net.minecraft.server.v1_7_R1;

import java.security.KeyPair;
import java.security.PrivateKey;
import java.util.Arrays;
import java.util.Random;
import java.util.UUID;
import java.util.concurrent.atomic.AtomicInteger;
import javax.crypto.SecretKey;
import net.minecraft.util.com.google.common.base.Charsets;
import net.minecraft.util.com.mojang.authlib.GameProfile;
import net.minecraft.util.io.netty.util.concurrent.GenericFutureListener;
import net.minecraft.util.org.apache.commons.lang3.Validate;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class LoginListener implements PacketLoginInListener
{
  private static final AtomicInteger b = new AtomicInteger(0);
  private static final Logger c = LogManager.getLogger();
  private static final Random random = new Random();
  private final byte[] e = new byte[4];
  private final MinecraftServer server;
  public final NetworkManager networkManager;
  private EnumProtocolState g;
  private int h;
  private GameProfile i;
  private String j;
  private SecretKey loginKey;
  public String hostname = "";
  
  public LoginListener(MinecraftServer minecraftserver, NetworkManager networkmanager) {
    g = EnumProtocolState.HELLO;
    j = "";
    server = minecraftserver;
    networkManager = networkmanager;
    random.nextBytes(e);
  }
  
  public void a() {
    if (g == EnumProtocolState.READY_TO_ACCEPT) {
      c();
    }
    
    if (h++ == 600) {
      disconnect("Took too long to log in");
    }
  }
  
  public void disconnect(String s) {
    try {
      c.info("Disconnecting " + getName() + ": " + s);
      ChatComponentText chatcomponenttext = new ChatComponentText(s);
      
      networkManager.handle(new PacketLoginOutDisconnect(chatcomponenttext), new GenericFutureListener[0]);
      networkManager.a(chatcomponenttext);
    } catch (Exception exception) {
      c.error("Error whilst disconnecting player", exception);
    }
  }
  
  public void c() {
    if (!i.isComplete()) {
      UUID uuid = UUID.nameUUIDFromBytes(("OfflinePlayer:" + i.getName()).getBytes(Charsets.UTF_8));
      
      i = new GameProfile(uuid.toString().replaceAll("-", ""), i.getName());
    }
    

    EntityPlayer s = server.getPlayerList().attemptLogin(this, i, hostname);
    
    if (s != null)
    {


      g = EnumProtocolState.e;
      networkManager.handle(new PacketLoginOutSuccess(i), new GenericFutureListener[0]);
      server.getPlayerList().a(networkManager, server.getPlayerList().processLogin(i, s));
    }
  }
  
  public void a(IChatBaseComponent ichatbasecomponent) {
    c.info(getName() + " lost connection: " + ichatbasecomponent.c());
  }
  
  public String getName() {
    return i != null ? i.toString() + " (" + networkManager.getSocketAddress().toString() + ")" : String.valueOf(networkManager.getSocketAddress());
  }
  
  public void a(EnumProtocol enumprotocol, EnumProtocol enumprotocol1) {
    Validate.validState((g == EnumProtocolState.e) || (g == EnumProtocolState.HELLO), "Unexpected change in protocol", new Object[0]);
    Validate.validState((enumprotocol1 == EnumProtocol.PLAY) || (enumprotocol1 == EnumProtocol.LOGIN), "Unexpected protocol " + enumprotocol1, new Object[0]);
  }
  
  public void a(PacketLoginInStart packetlogininstart) {
    Validate.validState(g == EnumProtocolState.HELLO, "Unexpected hello packet", new Object[0]);
    i = packetlogininstart.c();
    if ((server.getOnlineMode()) && (!networkManager.c())) {
      g = EnumProtocolState.KEY;
      networkManager.handle(new PacketLoginOutEncryptionBegin(j, server.I().getPublic(), e), new GenericFutureListener[0]);
    } else {
      g = EnumProtocolState.READY_TO_ACCEPT;
    }
  }
  
  public void a(PacketLoginInEncryptionBegin packetlogininencryptionbegin) {
    Validate.validState(g == EnumProtocolState.KEY, "Unexpected key packet", new Object[0]);
    PrivateKey privatekey = server.I().getPrivate();
    
    if (!Arrays.equals(e, packetlogininencryptionbegin.b(privatekey))) {
      throw new IllegalStateException("Invalid nonce!");
    }
    loginKey = packetlogininencryptionbegin.a(privatekey);
    g = EnumProtocolState.AUTHENTICATING;
    networkManager.a(loginKey);
    new ThreadPlayerLookupUUID(this, "User Authenticator #" + b.incrementAndGet()).start();
  }
  
  static String a(LoginListener loginlistener)
  {
    return j;
  }
  
  static MinecraftServer b(LoginListener loginlistener) {
    return server;
  }
  
  static SecretKey c(LoginListener loginlistener) {
    return loginKey;
  }
  
  static GameProfile a(LoginListener loginlistener, GameProfile gameprofile) {
    return loginlistener.i = gameprofile;
  }
  
  static GameProfile d(LoginListener loginlistener) {
    return i;
  }
  
  static Logger e() {
    return c;
  }
  
  static EnumProtocolState a(LoginListener loginlistener, EnumProtocolState enumprotocolstate) {
    return loginlistener.g = enumprotocolstate;
  }
}
