package net.minecraft.server.v1_7_R1;

import java.awt.GraphicsEnvironment;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.net.Proxy;
import java.security.KeyPair;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Queue;
import java.util.Random;
import java.util.UUID;
import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.concurrent.ExecutionException;
import javax.imageio.ImageIO;
import net.minecraft.util.com.mojang.authlib.GameProfile;
import net.minecraft.util.com.mojang.authlib.minecraft.MinecraftSessionService;
import net.minecraft.util.com.mojang.authlib.yggdrasil.YggdrasilAuthenticationService;
import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.org.apache.commons.lang3.Validate;
import org.apache.logging.log4j.Logger;
import org.bukkit.World.Environment;
import org.bukkit.command.ConsoleCommandSender;
import org.bukkit.command.RemoteConsoleCommandSender;
import org.bukkit.craftbukkit.libs.jline.Terminal;
import org.bukkit.craftbukkit.libs.jline.console.ConsoleReader;
import org.bukkit.craftbukkit.libs.joptsimple.OptionSet;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_7_R1.util.Waitable;
import org.bukkit.event.server.RemoteServerCommandEvent;
import org.bukkit.event.world.WorldInitEvent;
import org.bukkit.event.world.WorldLoadEvent;
import org.bukkit.event.world.WorldSaveEvent;
import org.bukkit.generator.ChunkGenerator;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.PluginManager;

public abstract class MinecraftServer implements ICommandListener, Runnable, IMojangStatistics
{
  private static final Logger h = ;
  private static MinecraftServer i;
  public Convertable convertable;
  private final MojangStatisticsGenerator k = new MojangStatisticsGenerator("server", this, ap());
  public File universe;
  private final List m = new ArrayList();
  private final ICommandHandler n;
  public final MethodProfiler methodProfiler = new MethodProfiler();
  private final ServerConnection o;
  private final ServerPing p = new ServerPing();
  private final Random q = new Random();
  private String serverIp;
  private int s = -1;
  public WorldServer[] worldServer;
  private PlayerList t;
  private boolean isRunning = true;
  private boolean isStopped;
  private int ticks;
  protected final Proxy c;
  public String d;
  public int e;
  private boolean onlineMode;
  private boolean spawnAnimals;
  private boolean spawnNPCs;
  private boolean pvpMode;
  private boolean allowFlight;
  private String motd;
  private int D;
  private int E = 0;
  public final long[] f = new long[100];
  public long[][] g;
  private KeyPair F;
  private String G;
  private String H;
  private boolean demoMode;
  private boolean K;
  private boolean L;
  private String M = "";
  private boolean N;
  private long O;
  private String P;
  private boolean Q;
  private boolean R;
  private final MinecraftSessionService S;
  private long T = 0L;
  

  public List<WorldServer> worlds = new ArrayList();
  public CraftServer server;
  public OptionSet options;
  public ConsoleCommandSender console;
  public RemoteConsoleCommandSender remoteConsole;
  public ConsoleReader reader;
  public static int currentTick = (int)(System.currentTimeMillis() / 50L);
  public final Thread primaryThread;
  public Queue<Runnable> processQueue = new ConcurrentLinkedQueue();
  public int autosavePeriod;
  
  public MinecraftServer(OptionSet options, Proxy proxy)
  {
    i = this;
    c = proxy;
    
    o = new ServerConnection(this);
    n = new CommandDispatcher();
    
    S = new YggdrasilAuthenticationService(proxy, UUID.randomUUID().toString()).createMinecraftSessionService();
    

    this.options = options;
    
    if (System.console() == null) {
      System.setProperty("org.bukkit.craftbukkit.libs.jline.terminal", "org.bukkit.craftbukkit.libs.jline.UnsupportedTerminal");
      org.bukkit.craftbukkit.Main.useJline = false;
    }
    try
    {
      reader = new ConsoleReader(System.in, System.out);
      reader.setExpandEvents(false);
    }
    catch (Throwable e) {
      try {
        System.setProperty("org.bukkit.craftbukkit.libs.jline.terminal", "org.bukkit.craftbukkit.libs.jline.UnsupportedTerminal");
        System.setProperty("user.language", "en");
        org.bukkit.craftbukkit.Main.useJline = false;
        reader = new ConsoleReader(System.in, System.out);
        reader.setExpandEvents(false);
      } catch (IOException ex) {
        h.warn((String)null, ex);
      }
    }
    Runtime.getRuntime().addShutdownHook(new org.bukkit.craftbukkit.v1_7_R1.util.ServerShutdownThread(this));
    
    primaryThread = new ThreadServerApplication(this, "Server thread");
  }
  
  public abstract PropertyManager getPropertyManager();
  
  protected abstract boolean init() throws java.net.UnknownHostException;
  
  protected void a(String s)
  {
    if (getConvertable().isConvertable(s)) {
      h.info("Converting map!");
      b("menu.convertingLevel");
      getConvertable().convert(s, new ConvertProgressUpdater(this));
    }
  }
  
  protected synchronized void b(String s) {
    P = s;
  }
  
  protected void a(String s, String s1, long i, WorldType worldtype, String s2) {
    a(s);
    b("menu.loadingLevel");
    worldServer = new WorldServer[3];
    
















    int worldCount = 3;
    
    for (int j = 0; j < worldCount; j++)
    {
      int dimension = 0;
      
      if (j == 1) {
        if (getAllowNether()) {
          dimension = -1;

        }
        

      }
      else if (j == 2) {
        if (server.getAllowEnd()) {
          dimension = 1;
        }
        
      }
      else
      {
        String worldType = World.Environment.getEnvironment(dimension).toString().toLowerCase();
        String name = s + "_" + worldType;
        
        ChunkGenerator gen = server.getGenerator(name);
        WorldSettings worldsettings = new WorldSettings(i, getGamemode(), getGenerateStructures(), isHardcore(), worldtype);
        worldsettings.a(s2);
        WorldServer world;
        if (j == 0) {
          IDataManager idatamanager = new ServerNBTManager(server.getWorldContainer(), s1, true);
          WorldServer world; WorldServer world; if (P()) {
            world = new DemoWorldServer(this, idatamanager, s1, dimension, methodProfiler);
          }
          else {
            world = new WorldServer(this, idatamanager, s1, dimension, worldsettings, methodProfiler, World.Environment.getEnvironment(dimension), gen);
          }
          server.scoreboardManager = new org.bukkit.craftbukkit.v1_7_R1.scoreboard.CraftScoreboardManager(this, world.getScoreboard());
        } else {
          String dim = "DIM" + dimension;
          
          File newWorld = new File(new File(name), dim);
          File oldWorld = new File(new File(s), dim);
          
          if ((!newWorld.isDirectory()) && (oldWorld.isDirectory())) {
            h.info("---- Migration of old " + worldType + " folder required ----");
            h.info("Unfortunately due to the way that Minecraft implemented multiworld support in 1.6, Bukkit requires that you move your " + worldType + " folder to a new location in order to operate correctly.");
            h.info("We will move this folder for you, but it will mean that you need to move it back should you wish to stop using Bukkit in the future.");
            h.info("Attempting to move " + oldWorld + " to " + newWorld + "...");
            
            if (newWorld.exists()) {
              h.warn("A file or folder already exists at " + newWorld + "!");
              h.info("---- Migration of old " + worldType + " folder failed ----");
            } else if (newWorld.getParentFile().mkdirs()) {
              if (oldWorld.renameTo(newWorld)) {
                h.info("Success! To restore " + worldType + " in the future, simply move " + newWorld + " to " + oldWorld);
                try
                {
                  com.google.common.io.Files.copy(new File(new File(s), "level.dat"), new File(new File(name), "level.dat"));
                } catch (IOException exception) {
                  h.warn("Unable to migrate world data.");
                }
                h.info("---- Migration of old " + worldType + " folder complete ----");
              } else {
                h.warn("Could not move folder " + oldWorld + " to " + newWorld + "!");
                h.info("---- Migration of old " + worldType + " folder failed ----");
              }
            } else {
              h.warn("Could not create path for " + newWorld + "!");
              h.info("---- Migration of old " + worldType + " folder failed ----");
            }
          }
          
          IDataManager idatamanager = new ServerNBTManager(server.getWorldContainer(), name, true);
          
          world = new SecondaryWorldServer(this, idatamanager, name, dimension, worldsettings, (WorldServer)worlds.get(0), methodProfiler, World.Environment.getEnvironment(dimension), gen);
        }
        
        if (gen != null) {
          world.getWorld().getPopulators().addAll(gen.getDefaultPopulators(world.getWorld()));
        }
        
        server.getPluginManager().callEvent(new WorldInitEvent(world.getWorld()));
        
        world.addIWorldAccess(new WorldManager(this, world));
        if (!L()) {
          world.getWorldData().setGameType(getGamemode());
        }
        
        worlds.add(world);
        t.setPlayerFileData((WorldServer[])worlds.toArray(new WorldServer[worlds.size()]));
      }
    }
    
    a(getDifficulty());
    g();
  }
  
  protected void g() {
    boolean flag = true;
    boolean flag1 = true;
    boolean flag2 = true;
    boolean flag3 = true;
    int i = 0;
    
    b("menu.generatingTerrain");
    byte b0 = 0;
    

    for (int m = 0; m < worlds.size(); m++) {
      WorldServer worldserver = (WorldServer)worlds.get(m);
      h.info("Preparing start region for level " + m + " (Seed: " + worldserver.getSeed() + ")");
      if (worldserver.getWorld().getKeepSpawnInMemory())
      {


        ChunkCoordinates chunkcoordinates = worldserver.getSpawn();
        long j = ap();
        i = 0;
        
        for (int k = -192; (k <= 192) && (isRunning()); k += 16) {
          for (int l = -192; (l <= 192) && (isRunning()); l += 16) {
            long i1 = ap();
            
            if (i1 - j > 1000L) {
              a_("Preparing spawn area", i * 100 / 625);
              j = i1;
            }
            
            i++;
            chunkProviderServer.getChunkAt(x + k >> 4, z + l >> 4);
          }
        }
      }
    }
    for (WorldServer world : worlds) {
      server.getPluginManager().callEvent(new WorldLoadEvent(world.getWorld()));
    }
    
    m();
  }
  
  public abstract boolean getGenerateStructures();
  
  public abstract EnumGamemode getGamemode();
  
  public abstract EnumDifficulty getDifficulty();
  
  public abstract boolean isHardcore();
  
  public abstract int l();
  
  protected void a_(String s, int i) {
    d = s;
    e = i;
    h.info(s + ": " + i + "%");
  }
  
  protected void m() {
    d = null;
    e = 0;
    
    server.enablePlugins(org.bukkit.plugin.PluginLoadOrder.POSTWORLD);
  }
  
  protected void saveChunks(boolean flag) throws ExceptionWorldConflict {
    if (!L)
    {

      int i = worlds.size();
      
      for (int j = 0; j < i; j++) {
        WorldServer worldserver = (WorldServer)worlds.get(j);
        
        if (worldserver != null) {
          if (!flag) {
            h.info("Saving chunks for level '" + worldserver.getWorldData().getName() + "'/" + worldProvider.getName());
          }
          
          worldserver.save(true, (IProgressUpdate)null);
          worldserver.saveLevel();
          
          WorldSaveEvent event = new WorldSaveEvent(worldserver.getWorld());
          server.getPluginManager().callEvent(event);
        }
      }
    }
  }
  
  public void stop() throws ExceptionWorldConflict
  {
    if (!L) {
      h.info("Stopping server");
      
      if (server != null) {
        server.disablePlugins();
      }
      

      if (ag() != null) {
        ag().b();
      }
      
      if (t != null) {
        h.info("Saving players");
        t.savePlayers();
        t.r();
      }
      
      h.info("Saving worlds");
      saveChunks(false);
      








      if (k.d()) {
        k.e();
      }
    }
  }
  
  public String getServerIp() {
    return serverIp;
  }
  
  public void c(String s) {
    serverIp = s;
  }
  
  public boolean isRunning() {
    return isRunning;
  }
  
  public void safeShutdown() {
    isRunning = false;
  }
  
  public void run() {
    try {
      if (init()) {
        long i = ap();
        long j = 0L;
        
        p.setMOTD(new ChatComponentText(motd));
        p.setServerInfo(new ServerPingServerData("1.7.2", 4));
        a(p);
        
        while (isRunning) {
          long k = ap();
          long l = k - i;
          
          if ((l > 2000L) && (i - O >= 15000L)) {
            if (server.getWarnOnOverload())
              h.warn("Can't keep up! Did the system time change, or is the server overloaded? Running {}ms behind, skipping {} tick(s)", new Object[] { Long.valueOf(l), Long.valueOf(l / 50L) });
            l = 2000L;
            O = i;
          }
          
          if (l < 0L) {
            h.warn("Time ran backwards! Did the system time change?");
            l = 0L;
          }
          
          j += l;
          i = k;
          if (((WorldServer)worlds.get(0)).everyoneDeeplySleeping()) {
            t();
            j = 0L;
          } else {
            while (j > 50L) {
              currentTick = (int)(System.currentTimeMillis() / 50L);
              j -= 50L;
              t();
            }
          }
          
          Thread.sleep(1L);
          N = true;
        }
      } else {
        a((CrashReport)null);
      }
    } catch (Throwable throwable) {
      h.error("Encountered an unexpected exception", throwable);
      CrashReport crashreport = null;
      
      if ((throwable instanceof ReportedException)) {
        crashreport = b(((ReportedException)throwable).a());
      } else {
        crashreport = b(new CrashReport("Exception in server tick loop", throwable));
      }
      
      File file1 = new File(new File(r(), "crash-reports"), "crash-" + new SimpleDateFormat("yyyy-MM-dd_HH.mm.ss").format(new Date()) + "-server.txt");
      
      if (crashreport.a(file1)) {
        h.error("This crash report has been saved to: " + file1.getAbsolutePath());
      } else {
        h.error("We were unable to save this crash report to disk.");
      }
      
      a(crashreport);
    } finally {
      try {
        stop();
        isStopped = true;
      } catch (Throwable throwable1) {
        h.error("Exception stopping the server", throwable1);
      }
      finally {
        try {
          reader.getTerminal().restore();
        }
        catch (Exception e) {}
        
        s();
      }
    }
  }
  
  private void a(ServerPing serverping) {
    File file1 = d("server-icon.png");
    
    if (file1.isFile()) {
      ByteBuf bytebuf = net.minecraft.util.io.netty.buffer.Unpooled.buffer();
      try
      {
        BufferedImage bufferedimage = ImageIO.read(file1);
        
        Validate.validState(bufferedimage.getWidth() == 64, "Must be 64 pixels wide", new Object[0]);
        Validate.validState(bufferedimage.getHeight() == 64, "Must be 64 pixels high", new Object[0]);
        ImageIO.write(bufferedimage, "PNG", new net.minecraft.util.io.netty.buffer.ByteBufOutputStream(bytebuf));
        ByteBuf bytebuf1 = net.minecraft.util.io.netty.handler.codec.base64.Base64.encode(bytebuf);
        
        serverping.setFavicon("data:image/png;base64," + bytebuf1.toString(net.minecraft.util.com.google.common.base.Charsets.UTF_8));
      } catch (Exception exception) {
        h.error("Couldn't load server icon", exception);
      }
    }
  }
  
  protected File r() {
    return new File(".");
  }
  
  protected void a(CrashReport crashreport) {}
  
  protected void s() {}
  
  protected void t() throws ExceptionWorldConflict {
    long i = System.nanoTime();
    
    AxisAlignedBB.a().a();
    ticks += 1;
    if (Q) {
      Q = false;
      methodProfiler.a = true;
      methodProfiler.a();
    }
    
    methodProfiler.a("root");
    u();
    if (i - T >= 5000000000L) {
      T = i;
      p.setPlayerSample(new ServerPingPlayerSample(C(), B()));
      GameProfile[] agameprofile = new GameProfile[Math.min(B(), 12)];
      int j = MathHelper.nextInt(q, 0, B() - agameprofile.length);
      
      for (int k = 0; k < agameprofile.length; k++) {
        agameprofile[k] = ((EntityPlayer)t.players.get(j + k)).getProfile();
      }
      
      java.util.Collections.shuffle(Arrays.asList(agameprofile));
      p.b().a(agameprofile);
    }
    
    if ((autosavePeriod > 0) && (ticks % autosavePeriod == 0)) {
      methodProfiler.a("save");
      t.savePlayers();
      saveChunks(true);
      methodProfiler.b();
    }
    
    methodProfiler.a("tallying");
    f[(ticks % 100)] = (System.nanoTime() - i);
    methodProfiler.b();
    methodProfiler.a("snooper");
    if ((!this.k.d()) && (ticks > 100)) {
      this.k.a();
    }
    
    if (ticks % 6000 == 0) {
      this.k.b();
    }
    
    methodProfiler.b();
    methodProfiler.b();
  }
  
  public void u() {
    methodProfiler.a("levels");
    

    server.getScheduler().mainThreadHeartbeat(ticks);
    

    while (!processQueue.isEmpty()) {
      ((Runnable)processQueue.remove()).run();
    }
    
    org.bukkit.craftbukkit.v1_7_R1.chunkio.ChunkIOExecutor.tick();
    

    if (ticks % 20 == 0) {
      for (int i = 0; i < getPlayerList()players.size(); i++) {
        EntityPlayer entityplayer = (EntityPlayer)getPlayerList()players.get(i);
        playerConnection.sendPacket(new PacketPlayOutUpdateTime(world.getTime(), entityplayer.getPlayerTime(), world.getGameRules().getBoolean("doDaylightCycle")));
      }
    }
    


    for (int i = 0; i < worlds.size(); i++) {
      long j = System.nanoTime();
      

      WorldServer worldserver = (WorldServer)worlds.get(i);
      
      methodProfiler.a(worldserver.getWorldData().getName());
      methodProfiler.a("pools");
      worldserver.getVec3DPool().a();
      methodProfiler.b();
      







      methodProfiler.a("tick");
      

      try
      {
        worldserver.doTick();
      } catch (Throwable throwable) {
        CrashReport crashreport = CrashReport.a(throwable, "Exception ticking world");
        worldserver.a(crashreport);
        throw new ReportedException(crashreport);
      }
      try
      {
        worldserver.tickEntities();
      } catch (Throwable throwable1) {
        CrashReport crashreport = CrashReport.a(throwable1, "Exception ticking world entities");
        worldserver.a(crashreport);
        throw new ReportedException(crashreport);
      }
      
      methodProfiler.b();
      methodProfiler.a("tracker");
      worldserver.getTracker().updatePlayers();
      methodProfiler.b();
      methodProfiler.b();
    }
    



    methodProfiler.c("connection");
    ag().c();
    methodProfiler.c("players");
    t.tick();
    methodProfiler.c("tickables");
    
    for (i = 0; i < m.size(); i++) {
      ((IUpdatePlayerListBox)m.get(i)).a();
    }
    
    methodProfiler.b();
  }
  
  public boolean getAllowNether() {
    return true;
  }
  
  public void a(IUpdatePlayerListBox iupdateplayerlistbox) {
    m.add(iupdateplayerlistbox);
  }
  




































  public static void main(OptionSet options)
  {
    
    



































    try
    {
      DedicatedServer dedicatedserver = new DedicatedServer(options);
      
      if (options.has("port")) {
        int port = ((Integer)options.valueOf("port")).intValue();
        if (port > 0) {
          dedicatedserver.setPort(port);
        }
      }
      
      if (options.has("universe")) {
        universe = ((File)options.valueOf("universe"));
      }
      
      if (options.has("world")) {
        dedicatedserver.k((String)options.valueOf("world"));
      }
      
      primaryThread.start();
    }
    catch (Exception exception)
    {
      h.fatal("Failed to start the minecraft server", exception);
    }
  }
  

  public void w() {}
  
  public File d(String s)
  {
    return new File(r(), s);
  }
  
  public void info(String s) {
    h.info(s);
  }
  
  public void warning(String s) {
    h.warn(s);
  }
  
  public WorldServer getWorldServer(int i)
  {
    for (WorldServer world : worlds) {
      if (dimension == i) {
        return world;
      }
    }
    
    return (WorldServer)worlds.get(0);
  }
  
  public String x()
  {
    return serverIp;
  }
  
  public int y() {
    return s;
  }
  
  public String z() {
    return motd;
  }
  
  public String getVersion() {
    return "1.7.2";
  }
  
  public int B() {
    return t.getPlayerCount();
  }
  
  public int C() {
    return t.getMaxPlayers();
  }
  
  public String[] getPlayers() {
    return t.d();
  }
  
  public String getPlugins()
  {
    StringBuilder result = new StringBuilder();
    Plugin[] plugins = server.getPluginManager().getPlugins();
    
    result.append(server.getName());
    result.append(" on Bukkit ");
    result.append(server.getBukkitVersion());
    
    if ((plugins.length > 0) && (server.getQueryPlugins())) {
      result.append(": ");
      
      for (int i = 0; i < plugins.length; i++) {
        if (i > 0) {
          result.append("; ");
        }
        
        result.append(plugins[i].getDescription().getName());
        result.append(" ");
        result.append(plugins[i].getDescription().getVersion().replaceAll(";", ","));
      }
    }
    
    return result.toString();
  }
  

  public String g(final String s)
  {
    Waitable<String> waitable = new Waitable()
    {
      protected String evaluate() {
        RemoteControlCommandListener.instance.e();
        
        RemoteServerCommandEvent event = new RemoteServerCommandEvent(remoteConsole, s);
        server.getPluginManager().callEvent(event);
        
        ServerCommand servercommand = new ServerCommand(event.getCommand(), RemoteControlCommandListener.instance);
        server.dispatchServerCommand(remoteConsole, servercommand);
        
        return RemoteControlCommandListener.instance.f();
      } };
    processQueue.add(waitable);
    try {
      return (String)waitable.get();
    } catch (ExecutionException e) {
      throw new RuntimeException("Exception processing rcon command " + s, e.getCause());
    } catch (InterruptedException e) {
      Thread.currentThread().interrupt();
      throw new RuntimeException("Interrupted processing rcon command " + s, e);
    }
  }
  
  public boolean isDebugging()
  {
    return getPropertyManager().getBoolean("debug", false);
  }
  
  public void h(String s) {
    h.error(s);
  }
  
  public void i(String s) {
    if (isDebugging()) {
      h.info(s);
    }
  }
  
  public String getServerModName() {
    return server.getName();
  }
  
  public CrashReport b(CrashReport crashreport) {
    crashreport.g().a("Profiler Position", new CrashReportProfilerPosition(this));
    if ((worlds != null) && (worlds.size() > 0) && (worlds.get(0) != null)) {
      crashreport.g().a("Vec3 Pool Size", new CrashReportVec3DPoolSize(this));
    }
    
    if (t != null) {
      crashreport.g().a("Player Count", new CrashReportPlayerCount(this));
    }
    
    return crashreport;
  }
  








































  public List a(ICommandListener icommandlistener, String s)
  {
    return server.tabComplete(icommandlistener, s);
  }
  
  public static MinecraftServer getServer()
  {
    return i;
  }
  
  public String getName() {
    return "Server";
  }
  
  public void sendMessage(IChatBaseComponent ichatbasecomponent) {
    h.info(ichatbasecomponent.c());
  }
  
  public boolean a(int i, String s) {
    return true;
  }
  
  public ICommandHandler getCommandHandler() {
    return n;
  }
  
  public KeyPair I() {
    return F;
  }
  
  public int J() {
    return s;
  }
  
  public void setPort(int i) {
    s = i;
  }
  
  public String K() {
    return G;
  }
  
  public void j(String s) {
    G = s;
  }
  
  public boolean L() {
    return G != null;
  }
  
  public String M() {
    return H;
  }
  
  public void k(String s) {
    H = s;
  }
  
  public void a(KeyPair keypair) {
    F = keypair;
  }
  
  public void a(EnumDifficulty enumdifficulty)
  {
    for (int j = 0; j < worlds.size(); j++) {
      WorldServer worldserver = (WorldServer)worlds.get(j);
      

      if (worldserver != null) {
        if (worldserver.getWorldData().isHardcore()) {
          difficulty = EnumDifficulty.HARD;
          worldserver.setSpawnFlags(true, true);
        } else if (L()) {
          difficulty = enumdifficulty;
          worldserver.setSpawnFlags(difficulty != EnumDifficulty.PEACEFUL, true);
        } else {
          difficulty = enumdifficulty;
          worldserver.setSpawnFlags(getSpawnMonsters(), spawnAnimals);
        }
      }
    }
  }
  
  protected boolean getSpawnMonsters() {
    return true;
  }
  
  public boolean P() {
    return demoMode;
  }
  
  public void b(boolean flag) {
    demoMode = flag;
  }
  
  public void c(boolean flag) {
    K = flag;
  }
  
  public Convertable getConvertable() {
    return convertable;
  }
  
  public void S() {
    L = true;
    getConvertable().d();
    

    for (int i = 0; i < worlds.size(); i++) {
      WorldServer worldserver = (WorldServer)worlds.get(i);
      

      if (worldserver != null) {
        worldserver.saveLevel();
      }
    }
    
    getConvertable().e(((WorldServer)worlds.get(0)).getDataManager().g());
    safeShutdown();
  }
  
  public String getResourcePack() {
    return M;
  }
  
  public void setTexturePack(String s) {
    M = s;
  }
  
  public void a(MojangStatisticsGenerator mojangstatisticsgenerator) {
    mojangstatisticsgenerator.a("whitelist_enabled", Boolean.valueOf(false));
    mojangstatisticsgenerator.a("whitelist_count", Integer.valueOf(0));
    mojangstatisticsgenerator.a("players_current", Integer.valueOf(B()));
    mojangstatisticsgenerator.a("players_max", Integer.valueOf(C()));
    mojangstatisticsgenerator.a("players_seen", Integer.valueOf(t.getSeenPlayers().length));
    mojangstatisticsgenerator.a("uses_auth", Boolean.valueOf(onlineMode));
    mojangstatisticsgenerator.a("gui_state", ai() ? "enabled" : "disabled");
    mojangstatisticsgenerator.a("run_time", Long.valueOf((ap() - mojangstatisticsgenerator.g()) / 60L * 1000L));
    mojangstatisticsgenerator.a("avg_tick_ms", Integer.valueOf((int)(MathHelper.a(f) * 1.0E-006D)));
    int i = 0;
    

    for (int j = 0; j < worlds.size(); j++) {
      WorldServer worldserver = (WorldServer)worlds.get(j);
      if (worldServer != null)
      {
        WorldData worlddata = worldserver.getWorldData();
        
        mojangstatisticsgenerator.a("world[" + i + "][dimension]", Integer.valueOf(worldProvider.dimension));
        mojangstatisticsgenerator.a("world[" + i + "][mode]", worlddata.getGameType());
        mojangstatisticsgenerator.a("world[" + i + "][difficulty]", difficulty);
        mojangstatisticsgenerator.a("world[" + i + "][hardcore]", Boolean.valueOf(worlddata.isHardcore()));
        mojangstatisticsgenerator.a("world[" + i + "][generator_name]", worlddata.getType().name());
        mojangstatisticsgenerator.a("world[" + i + "][generator_version]", Integer.valueOf(worlddata.getType().getVersion()));
        mojangstatisticsgenerator.a("world[" + i + "][height]", Integer.valueOf(D));
        mojangstatisticsgenerator.a("world[" + i + "][chunks_loaded]", Integer.valueOf(worldserver.K().getLoadedChunks()));
        i++;
      }
    }
    
    mojangstatisticsgenerator.a("worlds", Integer.valueOf(i));
  }
  
  public void b(MojangStatisticsGenerator mojangstatisticsgenerator) {
    mojangstatisticsgenerator.a("singleplayer", Boolean.valueOf(L()));
    mojangstatisticsgenerator.a("server_brand", getServerModName());
    mojangstatisticsgenerator.a("gui_supported", GraphicsEnvironment.isHeadless() ? "headless" : "supported");
    mojangstatisticsgenerator.a("dedicated", Boolean.valueOf(V()));
  }
  
  public boolean getSnooperEnabled() {
    return true;
  }
  
  public abstract boolean V();
  
  public boolean getOnlineMode() {
    return server.getOnlineMode();
  }
  
  public void setOnlineMode(boolean flag) {
    onlineMode = flag;
  }
  
  public boolean getSpawnAnimals() {
    return spawnAnimals;
  }
  
  public void setSpawnAnimals(boolean flag) {
    spawnAnimals = flag;
  }
  
  public boolean getSpawnNPCs() {
    return spawnNPCs;
  }
  
  public void setSpawnNPCs(boolean flag) {
    spawnNPCs = flag;
  }
  
  public boolean getPvP() {
    return pvpMode;
  }
  
  public void setPvP(boolean flag) {
    pvpMode = flag;
  }
  
  public boolean getAllowFlight() {
    return allowFlight;
  }
  
  public void setAllowFlight(boolean flag) {
    allowFlight = flag;
  }
  
  public abstract boolean getEnableCommandBlock();
  
  public String getMotd() {
    return motd;
  }
  
  public void setMotd(String s) {
    motd = s;
  }
  
  public int getMaxBuildHeight() {
    return D;
  }
  
  public void c(int i) {
    D = i;
  }
  
  public boolean isStopped() {
    return isStopped;
  }
  
  public PlayerList getPlayerList() {
    return t;
  }
  
  public void a(PlayerList playerlist) {
    t = playerlist;
  }
  
  public void a(EnumGamemode enumgamemode)
  {
    for (int i = 0; i < worlds.size(); i++) {
      ((WorldServer)getServer()worlds.get(i)).getWorldData().setGameType(enumgamemode);
    }
  }
  
  public ServerConnection ag()
  {
    return o;
  }
  
  public boolean ai() {
    return false;
  }
  
  public abstract String a(EnumGamemode paramEnumGamemode, boolean paramBoolean);
  
  public int aj() {
    return ticks;
  }
  
  public void ak() {
    Q = true;
  }
  
  public ChunkCoordinates getChunkCoordinates() {
    return new ChunkCoordinates(0, 0, 0);
  }
  
  public World getWorld() {
    return (World)worlds.get(0);
  }
  
  public int getSpawnProtection() {
    return 16;
  }
  
  public boolean a(World world, int i, int j, int k, EntityHuman entityhuman) {
    return false;
  }
  
  public void setForceGamemode(boolean flag) {
    R = flag;
  }
  
  public boolean getForceGamemode() {
    return R;
  }
  
  public Proxy ao() {
    return c;
  }
  
  public static long ap() {
    return System.currentTimeMillis();
  }
  
  public int aq() {
    return E;
  }
  
  public void d(int i) {
    E = i;
  }
  
  public IChatBaseComponent getScoreboardDisplayName() {
    return new ChatComponentText(getName());
  }
  
  public boolean ar() {
    return true;
  }
  
  public MinecraftSessionService as() {
    return S;
  }
  
  public ServerPing at() {
    return p;
  }
  
  public void au() {
    T = 0L;
  }
  
  public static Logger av() {
    return h;
  }
  
  public static PlayerList a(MinecraftServer minecraftserver) {
    return t;
  }
}
