package net.minecraft.server.v1_7_R1;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.channels.GatheringByteChannel;
import java.nio.channels.ScatteringByteChannel;
import java.nio.charset.Charset;
import net.minecraft.util.com.google.common.base.Charsets;
import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.buffer.ByteBufAllocator;
import net.minecraft.util.io.netty.buffer.ByteBufProcessor;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack;

public class PacketDataSerializer
  extends ByteBuf
{
  private final ByteBuf a;
  
  public PacketDataSerializer(ByteBuf bytebuf)
  {
    a = bytebuf;
  }
  
  public static int a(int i) {
    return (i & 0xF0000000) == 0 ? 4 : (i & 0xFFE00000) == 0 ? 3 : (i & 0xFFFFC000) == 0 ? 2 : (i & 0xFFFFFF80) == 0 ? 1 : 5;
  }
  
  public int a() {
    int i = 0;
    int j = 0;
    
    byte b0;
    do
    {
      b0 = readByte();
      i |= (b0 & 0x7F) << j++ * 7;
      if (j > 5) {
        throw new RuntimeException("VarInt too big");
      }
    } while ((b0 & 0x80) == 128);
    
    return i;
  }
  
  public void b(int i) {
    while ((i & 0xFFFFFF80) != 0) {
      writeByte(i & 0x7F | 0x80);
      i >>>= 7;
    }
    
    writeByte(i);
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    if (nbttagcompound == null) {
      writeShort(-1);
    } else {
      byte[] abyte = NBTCompressedStreamTools.a(nbttagcompound);
      
      writeShort((short)abyte.length);
      writeBytes(abyte);
    }
  }
  
  public NBTTagCompound b() {
    short short1 = readShort();
    
    if (short1 < 0) {
      return null;
    }
    byte[] abyte = new byte[short1];
    
    readBytes(abyte);
    return NBTCompressedStreamTools.a(abyte);
  }
  
  public void a(ItemStack itemstack)
  {
    if ((itemstack == null) || (itemstack.getItem() == null)) {
      writeShort(-1);
    } else {
      writeShort(Item.b(itemstack.getItem()));
      writeByte(count);
      writeShort(itemstack.getData());
      NBTTagCompound nbttagcompound = null;
      
      if ((itemstack.getItem().usesDurability()) || (itemstack.getItem().s())) {
        nbttagcompound = tag;
      }
      
      a(nbttagcompound);
    }
  }
  
  public ItemStack c() {
    ItemStack itemstack = null;
    short short1 = readShort();
    
    if (short1 >= 0) {
      byte b0 = readByte();
      short short2 = readShort();
      
      itemstack = new ItemStack(Item.d(short1), b0, short2);
      tag = b();
      
      if (tag != null) {
        CraftItemStack.setItemMeta(itemstack, CraftItemStack.getItemMeta(itemstack));
      }
    }
    

    return itemstack;
  }
  
  public String c(int i) throws IOException {
    int j = a();
    
    if (j > i * 4)
      throw new IOException("The received encoded string buffer length is longer than maximum allowed (" + j + " > " + i * 4 + ")");
    if (j < 0) {
      throw new IOException("The received encoded string buffer length is less than zero! Weird string!");
    }
    String s = new String(readBytes(j).array(), Charsets.UTF_8);
    
    if (s.length() > i) {
      throw new IOException("The received string length is longer than maximum allowed (" + j + " > " + i + ")");
    }
    return s;
  }
  
  public void a(String s)
    throws IOException
  {
    byte[] abyte = s.getBytes(Charsets.UTF_8);
    
    if (abyte.length > 32767) {
      throw new IOException("String too big (was " + s.length() + " bytes encoded, max " + 32767 + ")");
    }
    b(abyte.length);
    writeBytes(abyte);
  }
  
  public int capacity()
  {
    return a.capacity();
  }
  
  public ByteBuf capacity(int i) {
    return a.capacity(i);
  }
  
  public int maxCapacity() {
    return a.maxCapacity();
  }
  
  public ByteBufAllocator alloc() {
    return a.alloc();
  }
  
  public ByteOrder order() {
    return a.order();
  }
  
  public ByteBuf order(ByteOrder byteorder) {
    return a.order(byteorder);
  }
  
  public ByteBuf unwrap() {
    return a.unwrap();
  }
  
  public boolean isDirect() {
    return a.isDirect();
  }
  
  public int readerIndex() {
    return a.readerIndex();
  }
  
  public ByteBuf readerIndex(int i) {
    return a.readerIndex(i);
  }
  
  public int writerIndex() {
    return a.writerIndex();
  }
  
  public ByteBuf writerIndex(int i) {
    return a.writerIndex(i);
  }
  
  public ByteBuf setIndex(int i, int j) {
    return a.setIndex(i, j);
  }
  
  public int readableBytes() {
    return a.readableBytes();
  }
  
  public int writableBytes() {
    return a.writableBytes();
  }
  
  public int maxWritableBytes() {
    return a.maxWritableBytes();
  }
  
  public boolean isReadable() {
    return a.isReadable();
  }
  
  public boolean isReadable(int i) {
    return a.isReadable(i);
  }
  
  public boolean isWritable() {
    return a.isWritable();
  }
  
  public boolean isWritable(int i) {
    return a.isWritable(i);
  }
  
  public ByteBuf clear() {
    return a.clear();
  }
  
  public ByteBuf markReaderIndex() {
    return a.markReaderIndex();
  }
  
  public ByteBuf resetReaderIndex() {
    return a.resetReaderIndex();
  }
  
  public ByteBuf markWriterIndex() {
    return a.markWriterIndex();
  }
  
  public ByteBuf resetWriterIndex() {
    return a.resetWriterIndex();
  }
  
  public ByteBuf discardReadBytes() {
    return a.discardReadBytes();
  }
  
  public ByteBuf discardSomeReadBytes() {
    return a.discardSomeReadBytes();
  }
  
  public ByteBuf ensureWritable(int i) {
    return a.ensureWritable(i);
  }
  
  public int ensureWritable(int i, boolean flag) {
    return a.ensureWritable(i, flag);
  }
  
  public boolean getBoolean(int i) {
    return a.getBoolean(i);
  }
  
  public byte getByte(int i) {
    return a.getByte(i);
  }
  
  public short getUnsignedByte(int i) {
    return a.getUnsignedByte(i);
  }
  
  public short getShort(int i) {
    return a.getShort(i);
  }
  
  public int getUnsignedShort(int i) {
    return a.getUnsignedShort(i);
  }
  
  public int getMedium(int i) {
    return a.getMedium(i);
  }
  
  public int getUnsignedMedium(int i) {
    return a.getUnsignedMedium(i);
  }
  
  public int getInt(int i) {
    return a.getInt(i);
  }
  
  public long getUnsignedInt(int i) {
    return a.getUnsignedInt(i);
  }
  
  public long getLong(int i) {
    return a.getLong(i);
  }
  
  public char getChar(int i) {
    return a.getChar(i);
  }
  
  public float getFloat(int i) {
    return a.getFloat(i);
  }
  
  public double getDouble(int i) {
    return a.getDouble(i);
  }
  
  public ByteBuf getBytes(int i, ByteBuf bytebuf) {
    return a.getBytes(i, bytebuf);
  }
  
  public ByteBuf getBytes(int i, ByteBuf bytebuf, int j) {
    return a.getBytes(i, bytebuf, j);
  }
  
  public ByteBuf getBytes(int i, ByteBuf bytebuf, int j, int k) {
    return a.getBytes(i, bytebuf, j, k);
  }
  
  public ByteBuf getBytes(int i, byte[] abyte) {
    return a.getBytes(i, abyte);
  }
  
  public ByteBuf getBytes(int i, byte[] abyte, int j, int k) {
    return a.getBytes(i, abyte, j, k);
  }
  
  public ByteBuf getBytes(int i, ByteBuffer bytebuffer) {
    return a.getBytes(i, bytebuffer);
  }
  
  public ByteBuf getBytes(int i, OutputStream outputstream, int j) throws IOException {
    return a.getBytes(i, outputstream, j);
  }
  
  public int getBytes(int i, GatheringByteChannel gatheringbytechannel, int j) throws IOException {
    return a.getBytes(i, gatheringbytechannel, j);
  }
  
  public ByteBuf setBoolean(int i, boolean flag) {
    return a.setBoolean(i, flag);
  }
  
  public ByteBuf setByte(int i, int j) {
    return a.setByte(i, j);
  }
  
  public ByteBuf setShort(int i, int j) {
    return a.setShort(i, j);
  }
  
  public ByteBuf setMedium(int i, int j) {
    return a.setMedium(i, j);
  }
  
  public ByteBuf setInt(int i, int j) {
    return a.setInt(i, j);
  }
  
  public ByteBuf setLong(int i, long j) {
    return a.setLong(i, j);
  }
  
  public ByteBuf setChar(int i, int j) {
    return a.setChar(i, j);
  }
  
  public ByteBuf setFloat(int i, float f) {
    return a.setFloat(i, f);
  }
  
  public ByteBuf setDouble(int i, double d0) {
    return a.setDouble(i, d0);
  }
  
  public ByteBuf setBytes(int i, ByteBuf bytebuf) {
    return a.setBytes(i, bytebuf);
  }
  
  public ByteBuf setBytes(int i, ByteBuf bytebuf, int j) {
    return a.setBytes(i, bytebuf, j);
  }
  
  public ByteBuf setBytes(int i, ByteBuf bytebuf, int j, int k) {
    return a.setBytes(i, bytebuf, j, k);
  }
  
  public ByteBuf setBytes(int i, byte[] abyte) {
    return a.setBytes(i, abyte);
  }
  
  public ByteBuf setBytes(int i, byte[] abyte, int j, int k) {
    return a.setBytes(i, abyte, j, k);
  }
  
  public ByteBuf setBytes(int i, ByteBuffer bytebuffer) {
    return a.setBytes(i, bytebuffer);
  }
  
  public int setBytes(int i, InputStream inputstream, int j) throws IOException {
    return a.setBytes(i, inputstream, j);
  }
  
  public int setBytes(int i, ScatteringByteChannel scatteringbytechannel, int j) throws IOException {
    return a.setBytes(i, scatteringbytechannel, j);
  }
  
  public ByteBuf setZero(int i, int j) {
    return a.setZero(i, j);
  }
  
  public boolean readBoolean() {
    return a.readBoolean();
  }
  
  public byte readByte() {
    return a.readByte();
  }
  
  public short readUnsignedByte() {
    return a.readUnsignedByte();
  }
  
  public short readShort() {
    return a.readShort();
  }
  
  public int readUnsignedShort() {
    return a.readUnsignedShort();
  }
  
  public int readMedium() {
    return a.readMedium();
  }
  
  public int readUnsignedMedium() {
    return a.readUnsignedMedium();
  }
  
  public int readInt() {
    return a.readInt();
  }
  
  public long readUnsignedInt() {
    return a.readUnsignedInt();
  }
  
  public long readLong() {
    return a.readLong();
  }
  
  public char readChar() {
    return a.readChar();
  }
  
  public float readFloat() {
    return a.readFloat();
  }
  
  public double readDouble() {
    return a.readDouble();
  }
  
  public ByteBuf readBytes(int i) {
    return a.readBytes(i);
  }
  
  public ByteBuf readSlice(int i) {
    return a.readSlice(i);
  }
  
  public ByteBuf readBytes(ByteBuf bytebuf) {
    return a.readBytes(bytebuf);
  }
  
  public ByteBuf readBytes(ByteBuf bytebuf, int i) {
    return a.readBytes(bytebuf, i);
  }
  
  public ByteBuf readBytes(ByteBuf bytebuf, int i, int j) {
    return a.readBytes(bytebuf, i, j);
  }
  
  public ByteBuf readBytes(byte[] abyte) {
    return a.readBytes(abyte);
  }
  
  public ByteBuf readBytes(byte[] abyte, int i, int j) {
    return a.readBytes(abyte, i, j);
  }
  
  public ByteBuf readBytes(ByteBuffer bytebuffer) {
    return a.readBytes(bytebuffer);
  }
  
  public ByteBuf readBytes(OutputStream outputstream, int i) throws IOException {
    return a.readBytes(outputstream, i);
  }
  
  public int readBytes(GatheringByteChannel gatheringbytechannel, int i) throws IOException {
    return a.readBytes(gatheringbytechannel, i);
  }
  
  public ByteBuf skipBytes(int i) {
    return a.skipBytes(i);
  }
  
  public ByteBuf writeBoolean(boolean flag) {
    return a.writeBoolean(flag);
  }
  
  public ByteBuf writeByte(int i) {
    return a.writeByte(i);
  }
  
  public ByteBuf writeShort(int i) {
    return a.writeShort(i);
  }
  
  public ByteBuf writeMedium(int i) {
    return a.writeMedium(i);
  }
  
  public ByteBuf writeInt(int i) {
    return a.writeInt(i);
  }
  
  public ByteBuf writeLong(long i) {
    return a.writeLong(i);
  }
  
  public ByteBuf writeChar(int i) {
    return a.writeChar(i);
  }
  
  public ByteBuf writeFloat(float f) {
    return a.writeFloat(f);
  }
  
  public ByteBuf writeDouble(double d0) {
    return a.writeDouble(d0);
  }
  
  public ByteBuf writeBytes(ByteBuf bytebuf) {
    return a.writeBytes(bytebuf);
  }
  
  public ByteBuf writeBytes(ByteBuf bytebuf, int i) {
    return a.writeBytes(bytebuf, i);
  }
  
  public ByteBuf writeBytes(ByteBuf bytebuf, int i, int j) {
    return a.writeBytes(bytebuf, i, j);
  }
  
  public ByteBuf writeBytes(byte[] abyte) {
    return a.writeBytes(abyte);
  }
  
  public ByteBuf writeBytes(byte[] abyte, int i, int j) {
    return a.writeBytes(abyte, i, j);
  }
  
  public ByteBuf writeBytes(ByteBuffer bytebuffer) {
    return a.writeBytes(bytebuffer);
  }
  
  public int writeBytes(InputStream inputstream, int i) throws IOException {
    return a.writeBytes(inputstream, i);
  }
  
  public int writeBytes(ScatteringByteChannel scatteringbytechannel, int i) throws IOException {
    return a.writeBytes(scatteringbytechannel, i);
  }
  
  public ByteBuf writeZero(int i) {
    return a.writeZero(i);
  }
  
  public int indexOf(int i, int j, byte b0) {
    return a.indexOf(i, j, b0);
  }
  
  public int bytesBefore(byte b0) {
    return a.bytesBefore(b0);
  }
  
  public int bytesBefore(int i, byte b0) {
    return a.bytesBefore(i, b0);
  }
  
  public int bytesBefore(int i, int j, byte b0) {
    return a.bytesBefore(i, j, b0);
  }
  
  public int forEachByte(ByteBufProcessor bytebufprocessor) {
    return a.forEachByte(bytebufprocessor);
  }
  
  public int forEachByte(int i, int j, ByteBufProcessor bytebufprocessor) {
    return a.forEachByte(i, j, bytebufprocessor);
  }
  
  public int forEachByteDesc(ByteBufProcessor bytebufprocessor) {
    return a.forEachByteDesc(bytebufprocessor);
  }
  
  public int forEachByteDesc(int i, int j, ByteBufProcessor bytebufprocessor) {
    return a.forEachByteDesc(i, j, bytebufprocessor);
  }
  
  public ByteBuf copy() {
    return a.copy();
  }
  
  public ByteBuf copy(int i, int j) {
    return a.copy(i, j);
  }
  
  public ByteBuf slice() {
    return a.slice();
  }
  
  public ByteBuf slice(int i, int j) {
    return a.slice(i, j);
  }
  
  public ByteBuf duplicate() {
    return a.duplicate();
  }
  
  public int nioBufferCount() {
    return a.nioBufferCount();
  }
  
  public ByteBuffer nioBuffer() {
    return a.nioBuffer();
  }
  
  public ByteBuffer nioBuffer(int i, int j) {
    return a.nioBuffer(i, j);
  }
  
  public ByteBuffer internalNioBuffer(int i, int j) {
    return a.internalNioBuffer(i, j);
  }
  
  public ByteBuffer[] nioBuffers() {
    return a.nioBuffers();
  }
  
  public ByteBuffer[] nioBuffers(int i, int j) {
    return a.nioBuffers(i, j);
  }
  
  public boolean hasArray() {
    return a.hasArray();
  }
  
  public byte[] array() {
    return a.array();
  }
  
  public int arrayOffset() {
    return a.arrayOffset();
  }
  
  public boolean hasMemoryAddress() {
    return a.hasMemoryAddress();
  }
  
  public long memoryAddress() {
    return a.memoryAddress();
  }
  
  public String toString(Charset charset) {
    return a.toString(charset);
  }
  
  public String toString(int i, int j, Charset charset) {
    return a.toString(i, j, charset);
  }
  
  public int hashCode() {
    return a.hashCode();
  }
  
  public boolean equals(Object object) {
    return a.equals(object);
  }
  
  public int compareTo(ByteBuf bytebuf) {
    return a.compareTo(bytebuf);
  }
  
  public String toString() {
    return a.toString();
  }
  
  public ByteBuf retain(int i) {
    return a.retain(i);
  }
  
  public ByteBuf retain() {
    return a.retain();
  }
  
  public int refCnt() {
    return a.refCnt();
  }
  
  public boolean release() {
    return a.release();
  }
  
  public boolean release(int i) {
    return a.release(i);
  }
}
