package net.minecraft.server.v1_7_R1;

import java.io.IOException;
import java.util.List;
import java.util.zip.DataFormatException;
import java.util.zip.Deflater;
import java.util.zip.Inflater;

public class PacketPlayOutMapChunkBulk extends Packet
{
  private int[] a;
  private int[] b;
  private int[] c;
  private int[] d;
  private byte[] buffer;
  private byte[][] inflatedBuffers;
  private int size;
  private boolean h;
  private byte[] buildBuffer = new byte[0];
  
  static final ThreadLocal<Deflater> localDeflater = new ThreadLocal()
  {
    protected Deflater initialValue()
    {
      return new Deflater(6);
    }
  };
  
  public PacketPlayOutMapChunkBulk() {}
  
  public PacketPlayOutMapChunkBulk(List list)
  {
    int i = list.size();
    
    a = new int[i];
    b = new int[i];
    c = new int[i];
    d = new int[i];
    inflatedBuffers = new byte[i][];
    h = ((!list.isEmpty()) && (!get0world.worldProvider.g));
    int j = 0;
    
    for (int k = 0; k < i; k++) {
      Chunk chunk = (Chunk)list.get(k);
      ChunkMap chunkmap = PacketPlayOutMapChunk.a(chunk, true, 65535);
      
      if (buildBuffer.length < j + a.length) {
        byte[] abyte = new byte[j + a.length];
        
        System.arraycopy(buildBuffer, 0, abyte, 0, buildBuffer.length);
        buildBuffer = abyte;
      }
      
      System.arraycopy(a, 0, buildBuffer, j, a.length);
      j += a.length;
      a[k] = locX;
      b[k] = locZ;
      c[k] = b;
      d[k] = c;
      inflatedBuffers[k] = a;
    }
  }
  













  public void compress()
  {
    if (buffer != null) {
      return;
    }
    
    Deflater deflater = (Deflater)localDeflater.get();
    deflater.reset();
    deflater.setInput(buildBuffer);
    deflater.finish();
    
    buffer = new byte[buildBuffer.length + 100];
    size = deflater.deflate(buffer);
  }
  
  public static int c()
  {
    return 5;
  }
  
  public void a(PacketDataSerializer packetdataserializer) throws IOException {
    short short1 = packetdataserializer.readShort();
    
    size = packetdataserializer.readInt();
    h = packetdataserializer.readBoolean();
    a = new int[short1];
    b = new int[short1];
    c = new int[short1];
    d = new int[short1];
    inflatedBuffers = new byte[short1][];
    if (buildBuffer.length < size) {
      buildBuffer = new byte[size];
    }
    
    packetdataserializer.readBytes(buildBuffer, 0, size);
    byte[] abyte = new byte[PacketPlayOutMapChunk.c() * short1];
    Inflater inflater = new Inflater();
    
    inflater.setInput(buildBuffer, 0, size);
    try
    {
      inflater.inflate(abyte);
    } catch (DataFormatException dataformatexception) {
      throw new IOException("Bad compressed data format");
    } finally {
      inflater.end();
    }
    
    int i = 0;
    
    for (int j = 0; j < short1; j++) {
      a[j] = packetdataserializer.readInt();
      b[j] = packetdataserializer.readInt();
      c[j] = packetdataserializer.readShort();
      d[j] = packetdataserializer.readShort();
      int k = 0;
      int l = 0;
      


      for (int i1 = 0; i1 < 16; i1++) {
        k += (c[j] >> i1 & 0x1);
        l += (d[j] >> i1 & 0x1);
      }
      
      i1 = 8192 * k + 256;
      i1 += 2048 * l;
      if (h) {
        i1 += 2048 * k;
      }
      
      inflatedBuffers[j] = new byte[i1];
      System.arraycopy(abyte, i, inflatedBuffers[j], 0, i1);
      i += i1;
    }
  }
  
  public void b(PacketDataSerializer packetdataserializer) throws IOException {
    compress();
    packetdataserializer.writeShort(a.length);
    packetdataserializer.writeInt(size);
    packetdataserializer.writeBoolean(h);
    packetdataserializer.writeBytes(buffer, 0, size);
    
    for (int i = 0; i < a.length; i++) {
      packetdataserializer.writeInt(a[i]);
      packetdataserializer.writeInt(b[i]);
      packetdataserializer.writeShort((short)(c[i] & 0xFFFF));
      packetdataserializer.writeShort((short)(d[i] & 0xFFFF));
    }
  }
  
  public void a(PacketPlayOutListener packetplayoutlistener) {
    packetplayoutlistener.a(this);
  }
  
  public String b() {
    StringBuilder stringbuilder = new StringBuilder();
    
    for (int i = 0; i < a.length; i++) {
      if (i > 0) {
        stringbuilder.append(", ");
      }
      
      stringbuilder.append(String.format("{x=%d, z=%d, sections=%d, adds=%d, data=%d}", new Object[] { Integer.valueOf(a[i]), Integer.valueOf(b[i]), Integer.valueOf(c[i]), Integer.valueOf(d[i]), Integer.valueOf(inflatedBuffers[i].length) }));
    }
    
    return String.format("size=%d, chunks=%d[%s]", new Object[] { Integer.valueOf(size), Integer.valueOf(a.length), stringbuilder });
  }
  
  public void handle(PacketListener packetlistener) {
    a((PacketPlayOutListener)packetlistener);
  }
}
