package net.minecraft.server.v1_7_R1;

import java.util.Random;
import net.minecraft.util.org.apache.commons.lang3.StringUtils;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftEntity;
import org.bukkit.event.entity.EntityTargetEvent.TargetReason;
import org.bukkit.event.entity.EntityTargetLivingEntityEvent;

public abstract class PathfinderGoalTarget extends PathfinderGoal
{
  protected EntityCreature c;
  protected boolean d;
  private boolean a;
  private int b;
  private int e;
  private int f;
  
  public PathfinderGoalTarget(EntityCreature entitycreature, boolean flag)
  {
    this(entitycreature, flag, false);
  }
  
  public PathfinderGoalTarget(EntityCreature entitycreature, boolean flag, boolean flag1) {
    c = entitycreature;
    d = flag;
    a = flag1;
  }
  
  public boolean b() {
    EntityLiving entityliving = c.getGoalTarget();
    
    if (entityliving == null)
      return false;
    if (!entityliving.isAlive()) {
      return false;
    }
    double d0 = f();
    
    if (c.e(entityliving) > d0 * d0) {
      return false;
    }
    if (d) {
      if (c.getEntitySenses().canSee(entityliving)) {
        f = 0;
      } else if (++f > 60) {
        return false;
      }
    }
    
    return (!(entityliving instanceof EntityPlayer)) || (!playerInteractManager.isCreative());
  }
  

  protected double f()
  {
    AttributeInstance attributeinstance = c.getAttributeInstance(GenericAttributes.b);
    
    return attributeinstance == null ? 16.0D : attributeinstance.getValue();
  }
  
  public void c() {
    b = 0;
    e = 0;
    f = 0;
  }
  
  public void d() {
    c.setGoalTarget((EntityLiving)null);
  }
  
  protected boolean a(EntityLiving entityliving, boolean flag) {
    if (entityliving == null)
      return false;
    if (entityliving == c)
      return false;
    if (!entityliving.isAlive())
      return false;
    if (!c.a(entityliving.getClass())) {
      return false;
    }
    if (((c instanceof EntityOwnable)) && (StringUtils.isNotEmpty(((EntityOwnable)c).getOwnerName()))) {
      if (((entityliving instanceof EntityOwnable)) && (((EntityOwnable)c).getOwnerName().equals(((EntityOwnable)entityliving).getOwnerName()))) {
        return false;
      }
      
      if (entityliving == ((EntityOwnable)c).getOwner()) {
        return false;
      }
    } else if (((entityliving instanceof EntityHuman)) && (!flag) && (abilities.isInvulnerable)) {
      return false;
    }
    
    if (!c.b(MathHelper.floor(locX), MathHelper.floor(locY), MathHelper.floor(locZ)))
      return false;
    if ((d) && (!c.getEntitySenses().canSee(entityliving))) {
      return false;
    }
    if (a) {
      if (--e <= 0) {
        b = 0;
      }
      
      if (b == 0) {
        b = (a(entityliving) ? 1 : 2);
      }
      
      if (b == 2) {
        return false;
      }
    }
    

    EntityTargetEvent.TargetReason reason = EntityTargetEvent.TargetReason.RANDOM_TARGET;
    
    if ((this instanceof PathfinderGoalDefendVillage)) {
      reason = EntityTargetEvent.TargetReason.DEFEND_VILLAGE;
    } else if ((this instanceof PathfinderGoalHurtByTarget)) {
      reason = EntityTargetEvent.TargetReason.TARGET_ATTACKED_ENTITY;
    } else if ((this instanceof PathfinderGoalNearestAttackableTarget)) {
      if ((entityliving instanceof EntityHuman)) {
        reason = EntityTargetEvent.TargetReason.CLOSEST_PLAYER;
      }
    } else if ((this instanceof PathfinderGoalOwnerHurtByTarget)) {
      reason = EntityTargetEvent.TargetReason.TARGET_ATTACKED_OWNER;
    } else if ((this instanceof PathfinderGoalOwnerHurtTarget)) {
      reason = EntityTargetEvent.TargetReason.OWNER_ATTACKED_TARGET;
    }
    
    EntityTargetLivingEntityEvent event = org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.callEntityTargetLivingEvent(c, entityliving, reason);
    if ((event.isCancelled()) || (event.getTarget() == null)) {
      c.setGoalTarget(null);
      return false; }
    if (entityliving.getBukkitEntity() != event.getTarget()) {
      c.setGoalTarget((EntityLiving)((CraftEntity)event.getTarget()).getHandle());
    }
    if ((c instanceof EntityCreature)) {
      c.target = ((CraftEntity)event.getTarget()).getHandle();
    }
    

    return true;
  }
  

  private boolean a(EntityLiving entityliving)
  {
    e = (10 + c.aI().nextInt(5));
    PathEntity pathentity = c.getNavigation().a(entityliving);
    
    if (pathentity == null) {
      return false;
    }
    PathPoint pathpoint = pathentity.c();
    
    if (pathpoint == null) {
      return false;
    }
    int i = a - MathHelper.floor(locX);
    int j = c - MathHelper.floor(locZ);
    
    return i * i + j * j <= 2.25D;
  }
}
