package net.minecraft.server.v1_7_R1;

import java.util.List;
import java.util.Queue;

class PlayerChunk
{
  private final List b;
  private final ChunkCoordIntPair location;
  private short[] dirtyBlocks;
  private int dirtyCount;
  private int f;
  private long g;
  final PlayerChunkMap playerChunkMap;
  private boolean loaded = false;
  
  public PlayerChunk(PlayerChunkMap playerchunkmap, int i, int j) {
    playerChunkMap = playerchunkmap;
    b = new java.util.ArrayList();
    dirtyBlocks = new short[64];
    location = new ChunkCoordIntPair(i, j);
    
    a()chunkProviderServer.getChunkAt(i, j, new Runnable() {
      public void run() {
        loaded = true;
      }
    });
  }
  
  public void a(final EntityPlayer entityplayer)
  {
    if (b.contains(entityplayer)) {
      throw new IllegalStateException("Failed to add player. " + entityplayer + " already is in chunk " + location.x + ", " + location.z);
    }
    if (b.isEmpty()) {
      g = PlayerChunkMap.a(playerChunkMap).getTime();
    }
    
    b.add(entityplayer);
    
    if (loaded) {
      chunkCoordIntPairQueue.add(location);
    } else {
      playerChunkMap.a().chunkProviderServer.getChunkAt(location.x, location.z, new Runnable() {
        public void run() {
          entityplayerchunkCoordIntPairQueue.add(location);
        }
      });
    }
  }
  

  public void b(EntityPlayer entityplayer)
  {
    if (b.contains(entityplayer)) {
      Chunk chunk = PlayerChunkMap.a(playerChunkMap).getChunkAt(location.x, location.z);
      
      if (chunk.k()) {
        playerConnection.sendPacket(new PacketPlayOutMapChunk(chunk, true, 0));
      }
      
      b.remove(entityplayer);
      chunkCoordIntPairQueue.remove(location);
      if (b.isEmpty()) {
        long i = location.x + 2147483647L | location.z + 2147483647L << 32;
        
        a(chunk);
        PlayerChunkMap.b(playerChunkMap).remove(i);
        PlayerChunkMap.c(playerChunkMap).remove(this);
        if (dirtyCount > 0) {
          PlayerChunkMap.d(playerChunkMap).remove(this);
        }
        
        playerChunkMap.a().chunkProviderServer.queueUnload(location.x, location.z);
      }
    }
  }
  
  public void a() {
    a(PlayerChunkMap.a(playerChunkMap).getChunkAt(location.x, location.z));
  }
  
  private void a(Chunk chunk) {
    s += PlayerChunkMap.a(playerChunkMap).getTime() - g;
    g = PlayerChunkMap.a(playerChunkMap).getTime();
  }
  
  public void a(int i, int j, int k) {
    if (dirtyCount == 0) {
      PlayerChunkMap.d(playerChunkMap).add(this);
    }
    
    f |= 1 << (j >> 4);
    if (dirtyCount < 64) {
      short short1 = (short)(i << 12 | k << 8 | j);
      
      for (int l = 0; l < dirtyCount; l++) {
        if (dirtyBlocks[l] == short1) {
          return;
        }
      }
      
      dirtyBlocks[(dirtyCount++)] = short1;
    }
  }
  
  public void sendAll(Packet packet) {
    for (int i = 0; i < b.size(); i++) {
      EntityPlayer entityplayer = (EntityPlayer)b.get(i);
      
      if (!chunkCoordIntPairQueue.contains(location)) {
        playerConnection.sendPacket(packet);
      }
    }
  }
  
  public void b() {
    if (dirtyCount != 0)
    {



      if (dirtyCount == 1) {
        int i = location.x * 16 + (dirtyBlocks[0] >> 12 & 0xF);
        int j = dirtyBlocks[0] & 0xFF;
        int k = location.z * 16 + (dirtyBlocks[0] >> 8 & 0xF);
        sendAll(new PacketPlayOutBlockChange(i, j, k, PlayerChunkMap.a(playerChunkMap)));
        if (PlayerChunkMap.a(playerChunkMap).getType(i, j, k).isTileEntity()) {
          sendTileEntity(PlayerChunkMap.a(playerChunkMap).getTileEntity(i, j, k));
        }
      }
      else
      {
        if (dirtyCount == 64) {
          int i = location.x * 16;
          int j = location.z * 16;
          sendAll(new PacketPlayOutMapChunk(PlayerChunkMap.a(playerChunkMap).getChunkAt(location.x, location.z), f == 65535, f));
          
          for (int k = 0; k < 16; k++) {
            if ((f & 1 << k) != 0) {
              int l = k << 4;
              List list = PlayerChunkMap.a(playerChunkMap).getTileEntities(i, l, j, i + 16, l + 16, j + 16);
              
              for (int i1 = 0; i1 < list.size(); i1++) {
                sendTileEntity((TileEntity)list.get(i1));
              }
            }
          }
        }
        sendAll(new PacketPlayOutMultiBlockChange(dirtyCount, dirtyBlocks, PlayerChunkMap.a(playerChunkMap).getChunkAt(location.x, location.z)));
        
        for (int i = 0; i < dirtyCount; i++) {
          int j = location.x * 16 + (dirtyBlocks[i] >> 12 & 0xF);
          int k = dirtyBlocks[i] & 0xFF;
          int l = location.z * 16 + (dirtyBlocks[i] >> 8 & 0xF);
          if (PlayerChunkMap.a(playerChunkMap).getType(j, k, l).isTileEntity()) {
            sendTileEntity(PlayerChunkMap.a(playerChunkMap).getTileEntity(j, k, l));
          }
        }
      }
      

      dirtyCount = 0;
      f = 0;
    }
  }
  
  private void sendTileEntity(TileEntity tileentity) {
    if (tileentity != null) {
      Packet packet = tileentity.getUpdatePacket();
      
      if (packet != null) {
        sendAll(packet);
      }
    }
  }
  
  static ChunkCoordIntPair a(PlayerChunk playerchunk) {
    return location;
  }
  
  static List b(PlayerChunk playerchunk) {
    return b;
  }
}
