package net.minecraft.server.v1_7_R1;

import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Queue;
import java.util.Random;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.atomic.AtomicIntegerFieldUpdater;
import net.minecraft.util.io.netty.buffer.Unpooled;
import net.minecraft.util.io.netty.channel.ChannelConfig;
import net.minecraft.util.io.netty.util.concurrent.GenericFutureListener;
import org.bukkit.Location;
import org.bukkit.command.CommandException;
import org.bukkit.command.ConsoleCommandSender;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftPlayer;
import org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftInventoryView;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack;
import org.bukkit.craftbukkit.v1_7_R1.util.CraftChatMessage;
import org.bukkit.craftbukkit.v1_7_R1.util.LazyPlayerSet;
import org.bukkit.craftbukkit.v1_7_R1.util.Waitable;
import org.bukkit.entity.HumanEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.Event.Result;
import org.bukkit.event.block.Action;
import org.bukkit.event.block.SignChangeEvent;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.CraftItemEvent;
import org.bukkit.event.inventory.InventoryAction;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryCreativeEvent;
import org.bukkit.event.inventory.InventoryType.SlotType;
import org.bukkit.event.player.AsyncPlayerChatEvent;
import org.bukkit.event.player.PlayerAnimationEvent;
import org.bukkit.event.player.PlayerChatEvent;
import org.bukkit.event.player.PlayerCommandPreprocessEvent;
import org.bukkit.event.player.PlayerInteractEntityEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerItemHeldEvent;
import org.bukkit.event.player.PlayerKickEvent;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.event.player.PlayerTeleportEvent;
import org.bukkit.event.player.PlayerTeleportEvent.TeleportCause;
import org.bukkit.event.player.PlayerToggleFlightEvent;
import org.bukkit.event.player.PlayerToggleSneakEvent;
import org.bukkit.event.player.PlayerToggleSprintEvent;
import org.bukkit.inventory.CraftingInventory;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.InventoryView;
import org.bukkit.inventory.Recipe;
import org.bukkit.plugin.PluginManager;
import org.bukkit.util.NumberConversions;

public class PlayerConnection implements PacketPlayInListener
{
  private static final org.apache.logging.log4j.Logger c = ;
  public final NetworkManager networkManager;
  private final MinecraftServer minecraftServer;
  public EntityPlayer player;
  private int e;
  private int f;
  private boolean g;
  private int h;
  private long i;
  private static Random j = new Random();
  private long k;
  private volatile int chatThrottle; private static final AtomicIntegerFieldUpdater chatSpamField = AtomicIntegerFieldUpdater.newUpdater(PlayerConnection.class, "chatThrottle");
  private int x;
  private IntHashMap n = new IntHashMap();
  private double y;
  private double z;
  private double q;
  public boolean checkMovement = true;
  private boolean processedDisconnect;
  private final CraftServer server;
  
  public PlayerConnection(MinecraftServer minecraftserver, NetworkManager networkmanager, EntityPlayer entityplayer) { minecraftServer = minecraftserver;
    networkManager = networkmanager;
    networkmanager.a(this);
    player = entityplayer;
    playerConnection = this;
    

    server = server;
  }
  

  private int lastTick = MinecraftServer.currentTick;
  private int lastDropTick = MinecraftServer.currentTick;
  private int dropCount = 0;
  
  private static final int SURVIVAL_PLACE_DISTANCE_SQUARED = 36;
  
  private static final int CREATIVE_PLACE_DISTANCE_SQUARED = 49;
  private double lastPosX = 1.7976931348623157E+308D;
  private double lastPosY = 1.7976931348623157E+308D;
  private double lastPosZ = 1.7976931348623157E+308D;
  private float lastPitch = 3.4028235E+38F;
  private float lastYaw = 3.4028235E+38F;
  private boolean justTeleported = false;
  

  Long lastPacket;
  

  private Item lastMaterial;
  

  public CraftPlayer getPlayer() { return player == null ? null : player.getBukkitEntity(); }
  
  private static final HashSet<Integer> invalidItems = new HashSet(java.util.Arrays.asList(new Integer[] { Integer.valueOf(8), Integer.valueOf(9), Integer.valueOf(10), Integer.valueOf(11), Integer.valueOf(26), Integer.valueOf(34), Integer.valueOf(36), Integer.valueOf(43), Integer.valueOf(51), Integer.valueOf(52), Integer.valueOf(55), Integer.valueOf(59), Integer.valueOf(60), Integer.valueOf(62), Integer.valueOf(63), Integer.valueOf(64), Integer.valueOf(68), Integer.valueOf(71), Integer.valueOf(74), Integer.valueOf(75), Integer.valueOf(83), Integer.valueOf(90), Integer.valueOf(92), Integer.valueOf(93), Integer.valueOf(94), Integer.valueOf(104), Integer.valueOf(105), Integer.valueOf(115), Integer.valueOf(117), Integer.valueOf(118), Integer.valueOf(119), Integer.valueOf(125), Integer.valueOf(127), Integer.valueOf(132), Integer.valueOf(137), Integer.valueOf(140), Integer.valueOf(141), Integer.valueOf(142), Integer.valueOf(144) }));
  
  public void a()
  {
    g = false;
    e += 1;
    minecraftServer.methodProfiler.a("keepAlive");
    if (e - k > 40L) {
      k = e;
      i = d();
      h = ((int)i);
      sendPacket(new PacketPlayOutKeepAlive(h));
    }
    
    int spam;
    while (((spam = chatThrottle) > 0) && (!chatSpamField.compareAndSet(this, spam, spam - 1))) {}
    






    if (x > 0) {
      x -= 1;
    }
    
    minecraftServer.methodProfiler.c("playerTick");
    minecraftServer.methodProfiler.b();
  }
  
  public NetworkManager b() {
    return networkManager;
  }
  
  public void disconnect(String s)
  {
    String leaveMessage = EnumChatFormat.YELLOW + player.getName() + " left the game.";
    
    PlayerKickEvent event = new PlayerKickEvent(server.getPlayer(player), s, leaveMessage);
    
    if (server.getServer().isRunning()) {
      server.getPluginManager().callEvent(event);
    }
    
    if (event.isCancelled())
    {
      return;
    }
    
    s = event.getReason();
    
    ChatComponentText chatcomponenttext = new ChatComponentText(s);
    
    networkManager.handle(new PacketPlayOutKickDisconnect(chatcomponenttext), new GenericFutureListener[] { new PlayerConnectionFuture(this, chatcomponenttext) });
    a(chatcomponenttext);
    networkManager.g();
  }
  
  public void a(PacketPlayInSteerVehicle packetplayinsteervehicle) {
    player.a(packetplayinsteervehicle.c(), packetplayinsteervehicle.d(), packetplayinsteervehicle.e(), packetplayinsteervehicle.f());
  }
  
  public void a(PacketPlayInFlying packetplayinflying)
  {
    if ((Double.isNaN(x)) || (Double.isNaN(y)) || (Double.isNaN(z)) || (Double.isNaN(stance))) {
      c.warn(this.player.getName() + " was caught trying to crash the server with an invalid position.");
      getPlayer().kickPlayer("Nope!");
      return;
    }
    
    WorldServer worldserver = minecraftServer.getWorldServer(playerdimension);
    
    g = true;
    if (!playerviewingCredits)
    {

      if (!checkMovement) {
        double d0 = packetplayinflying.d() - z;
        if ((packetplayinflying.c() == y) && (d0 * d0 < 0.01D) && (packetplayinflying.e() == q)) {
          checkMovement = true;
        }
      }
      

      Player player = getPlayer();
      Location from = new Location(player.getWorld(), lastPosX, lastPosY, lastPosZ, lastYaw, lastPitch);
      Location to = player.getLocation().clone();
      

      if ((hasPos) && ((!hasPos) || (y != -999.0D) || (stance != -999.0D))) {
        to.setX(x);
        to.setY(y);
        to.setZ(z);
      }
      

      if (hasLook) {
        to.setYaw(yaw);
        to.setPitch(pitch);
      }
      

      double delta = Math.pow(lastPosX - to.getX(), 2.0D) + Math.pow(lastPosY - to.getY(), 2.0D) + Math.pow(lastPosZ - to.getZ(), 2.0D);
      float deltaAngle = Math.abs(lastYaw - to.getYaw()) + Math.abs(lastPitch - to.getPitch());
      
      if (((delta > 0.00390625D) || (deltaAngle > 10.0F)) && (checkMovement) && (!playerdead)) {
        lastPosX = to.getX();
        lastPosY = to.getY();
        lastPosZ = to.getZ();
        lastYaw = to.getYaw();
        lastPitch = to.getPitch();
        

        if (from.getX() != 1.7976931348623157E+308D) {
          PlayerMoveEvent event = new PlayerMoveEvent(player, from, to);
          server.getPluginManager().callEvent(event);
          

          if (event.isCancelled()) {
            playerplayerConnection.sendPacket(new PacketPlayOutPosition(from.getX(), from.getY() + 1.620000004768372D, from.getZ(), from.getYaw(), from.getPitch(), false));
            return;
          }
          



          if ((!to.equals(event.getTo())) && (!event.isCancelled())) {
            this.player.getBukkitEntity().teleport(event.getTo(), PlayerTeleportEvent.TeleportCause.UNKNOWN);
            return;
          }
          


          if ((!from.equals(getPlayer().getLocation())) && (justTeleported)) {
            justTeleported = false;
            return;
          }
        }
      }
      
      if ((checkMovement) && (!playerdead))
      {




        if (playervehicle != null) {
          float f = playeryaw;
          float f1 = playerpitch;
          
          playervehicle.ac();
          double d1 = playerlocX;
          double d2 = playerlocY;
          double d3 = playerlocZ;
          if (packetplayinflying.k()) {
            f = packetplayinflying.g();
            f1 = packetplayinflying.h();
          }
          
          playeronGround = packetplayinflying.i();
          this.player.i();
          playerW = 0.0F;
          this.player.setLocation(d1, d2, d3, f, f1);
          if (playervehicle != null) {
            playervehicle.ac();
          }
          
          minecraftServer.getPlayerList().d(this.player);
          if (checkMovement) {
            y = playerlocX;
            z = playerlocY;
            q = playerlocZ;
          }
          
          worldserver.playerJoinedWorld(this.player);
          return;
        }
        
        if (this.player.isSleeping()) {
          this.player.i();
          this.player.setLocation(y, z, q, playeryaw, playerpitch);
          worldserver.playerJoinedWorld(this.player);
          return;
        }
        
        double d0 = playerlocY;
        y = playerlocX;
        z = playerlocY;
        q = playerlocZ;
        double d1 = playerlocX;
        double d2 = playerlocY;
        double d3 = playerlocZ;
        float f2 = playeryaw;
        float f3 = playerpitch;
        
        if ((packetplayinflying.j()) && (packetplayinflying.d() == -999.0D) && (packetplayinflying.f() == -999.0D)) {
          packetplayinflying.a(false);
        }
        


        if (packetplayinflying.j()) {
          d1 = packetplayinflying.c();
          d2 = packetplayinflying.d();
          d3 = packetplayinflying.e();
          double d4 = packetplayinflying.f() - packetplayinflying.d();
          if ((!this.player.isSleeping()) && ((d4 > 1.65D) || (d4 < 0.1D))) {
            disconnect("Illegal stance");
            c.warn(this.player.getName() + " had an illegal stance: " + d4);
            return;
          }
          
          if ((Math.abs(packetplayinflying.c()) > 32000000.0D) || (Math.abs(packetplayinflying.e()) > 32000000.0D)) {
            disconnect("Illegal position");
            return;
          }
        }
        
        if (packetplayinflying.k()) {
          f2 = packetplayinflying.g();
          f3 = packetplayinflying.h();
        }
        
        this.player.i();
        playerW = 0.0F;
        this.player.setLocation(y, z, q, f2, f3);
        if (!checkMovement) {
          return;
        }
        
        double d4 = d1 - playerlocX;
        double d5 = d2 - playerlocY;
        double d6 = d3 - playerlocZ;
        
        double d7 = Math.max(Math.abs(d4), Math.abs(playermotX));
        double d8 = Math.max(Math.abs(d5), Math.abs(playermotY));
        double d9 = Math.max(Math.abs(d6), Math.abs(playermotZ));
        
        double d10 = d7 * d7 + d8 * d8 + d9 * d9;
        
        if ((d10 > 100.0D) && (checkMovement) && ((!minecraftServer.L()) || (!minecraftServer.K().equals(this.player.getName())))) {
          c.warn(this.player.getName() + " moved too quickly! " + d4 + "," + d5 + "," + d6 + " (" + d7 + ", " + d8 + ", " + d9 + ")");
          a(y, z, q, playeryaw, playerpitch);
          return;
        }
        
        float f4 = 0.0625F;
        boolean flag = worldserver.getCubes(this.player, playerboundingBox.clone().shrink(f4, f4, f4)).isEmpty();
        
        if ((playeronGround) && (!packetplayinflying.i()) && (d5 > 0.0D)) {
          this.player.bj();
        }
        
        this.player.move(d4, d5, d6);
        playeronGround = packetplayinflying.i();
        this.player.checkMovement(d4, d5, d6);
        double d11 = d5;
        
        d4 = d1 - playerlocX;
        d5 = d2 - playerlocY;
        if ((d5 > -0.5D) || (d5 < 0.5D)) {
          d5 = 0.0D;
        }
        
        d6 = d3 - playerlocZ;
        d10 = d4 * d4 + d5 * d5 + d6 * d6;
        boolean flag1 = false;
        
        if ((d10 > 0.0625D) && (!this.player.isSleeping()) && (!playerplayerInteractManager.isCreative())) {
          flag1 = true;
          c.warn(this.player.getName() + " moved wrongly!");
        }
        
        this.player.setLocation(d1, d2, d3, f2, f3);
        boolean flag2 = worldserver.getCubes(this.player, playerboundingBox.clone().shrink(f4, f4, f4)).isEmpty();
        
        if ((flag) && ((flag1) || (!flag2)) && (!this.player.isSleeping())) {
          a(y, z, q, f2, f3);
          return;
        }
        
        AxisAlignedBB axisalignedbb = playerboundingBox.clone().grow(f4, f4, f4).a(0.0D, -0.55D, 0.0D);
        
        if ((!minecraftServer.getAllowFlight()) && (!playerabilities.canFly) && (!worldserver.c(axisalignedbb))) {
          if (d11 >= -0.03125D) {
            this.f += 1;
            if (this.f > 80) {
              c.warn(this.player.getName() + " was kicked for floating too long!");
              disconnect("Flying is not enabled on this server");
            }
          }
        }
        else {
          this.f = 0;
        }
        
        playeronGround = packetplayinflying.i();
        minecraftServer.getPlayerList().d(this.player);
        this.player.b(playerlocY - d0, packetplayinflying.i());
      } else if (e % 20 == 0) {
        a(y, z, q, playeryaw, playerpitch);
      }
    }
  }
  
  public void a(double d0, double d1, double d2, float f, float f1)
  {
    Player player = getPlayer();
    Location from = player.getLocation();
    Location to = new Location(getPlayer().getWorld(), d0, d1, d2, f, f1);
    PlayerTeleportEvent event = new PlayerTeleportEvent(player, from, to, PlayerTeleportEvent.TeleportCause.UNKNOWN);
    server.getPluginManager().callEvent(event);
    
    from = event.getFrom();
    to = event.isCancelled() ? from : event.getTo();
    
    teleport(to);
  }
  


  public void teleport(Location dest)
  {
    double d0 = dest.getX();
    double d1 = dest.getY();
    double d2 = dest.getZ();
    float f = dest.getYaw();
    float f1 = dest.getPitch();
    

    if (Float.isNaN(f)) {
      f = 0.0F;
    }
    
    if (Float.isNaN(f1)) {
      f1 = 0.0F;
    }
    
    lastPosX = d0;
    lastPosY = d1;
    lastPosZ = d2;
    lastYaw = f;
    lastPitch = f1;
    justTeleported = true;
    

    checkMovement = false;
    y = d0;
    z = d1;
    q = d2;
    player.setLocation(d0, d1, d2, f, f1);
    player.playerConnection.sendPacket(new PacketPlayOutPosition(d0, d1 + 1.620000004768372D, d2, f, f1, false));
  }
  
  public void a(PacketPlayInBlockDig packetplayinblockdig) {
    if (player.dead) return;
    WorldServer worldserver = minecraftServer.getWorldServer(player.dimension);
    
    player.w();
    if (packetplayinblockdig.g() == 4)
    {

      if (lastDropTick != MinecraftServer.currentTick) {
        dropCount = 0;
        lastDropTick = MinecraftServer.currentTick;
      }
      else {
        dropCount += 1;
        if (dropCount >= 20) {
          c.warn(player.getName() + " dropped their items too quickly!");
          disconnect("You dropped your items too quickly (Hacking?)");
          return;
        }
      }
      
      player.a(false);
    } else if (packetplayinblockdig.g() == 3) {
      player.a(true);
    } else if (packetplayinblockdig.g() == 5) {
      player.by();
    } else {
      boolean flag = false;
      
      if (packetplayinblockdig.g() == 0) {
        flag = true;
      }
      
      if (packetplayinblockdig.g() == 1) {
        flag = true;
      }
      
      if (packetplayinblockdig.g() == 2) {
        flag = true;
      }
      
      int i = packetplayinblockdig.c();
      int j = packetplayinblockdig.d();
      int k = packetplayinblockdig.e();
      
      if (flag) {
        double d0 = player.locX - (i + 0.5D);
        double d1 = player.locY - (j + 0.5D) + 1.5D;
        double d2 = player.locZ - (k + 0.5D);
        double d3 = d0 * d0 + d1 * d1 + d2 * d2;
        
        if (d3 > 36.0D) {
          return;
        }
        
        if (j >= minecraftServer.getMaxBuildHeight()) {
          return;
        }
      }
      
      if (packetplayinblockdig.g() == 0) {
        if (!minecraftServer.a(worldserver, i, j, k, player)) {
          player.playerInteractManager.dig(i, j, k, packetplayinblockdig.f());
        }
        else {
          CraftEventFactory.callPlayerInteractEvent(player, Action.LEFT_CLICK_BLOCK, i, j, k, packetplayinblockdig.f(), player.inventory.getItemInHand());
          player.playerConnection.sendPacket(new PacketPlayOutBlockChange(i, j, k, worldserver));
          
          TileEntity tileentity = worldserver.getTileEntity(i, j, k);
          if (tileentity != null) {
            player.playerConnection.sendPacket(tileentity.getUpdatePacket());
          }
        }
      }
      else if (packetplayinblockdig.g() == 2) {
        player.playerInteractManager.a(i, j, k);
        if (worldserver.getType(i, j, k).getMaterial() != Material.AIR) {
          player.playerConnection.sendPacket(new PacketPlayOutBlockChange(i, j, k, worldserver));
        }
      } else if (packetplayinblockdig.g() == 1) {
        player.playerInteractManager.c(i, j, k);
        if (worldserver.getType(i, j, k).getMaterial() != Material.AIR) {
          player.playerConnection.sendPacket(new PacketPlayOutBlockChange(i, j, k, worldserver));
        }
      }
    }
  }
  
  public void a(PacketPlayInBlockPlace packetplayinblockplace) {
    WorldServer worldserver = minecraftServer.getWorldServer(player.dimension);
    

    if (player.dead) { return;
    }
    






    if (packetplayinblockplace.getFace() == 255) {
      if ((packetplayinblockplace.getItemStack() != null) && (packetplayinblockplace.getItemStack().getItem() == lastMaterial) && (lastPacket != null) && (timestamp - lastPacket.longValue() < 100L)) {
        lastPacket = null;
      }
    }
    else {
      lastMaterial = (packetplayinblockplace.getItemStack() == null ? null : packetplayinblockplace.getItemStack().getItem());
      lastPacket = Long.valueOf(timestamp);
    }
    


    boolean always = false;
    

    ItemStack itemstack = player.inventory.getItemInHand();
    boolean flag = false;
    int i = packetplayinblockplace.c();
    int j = packetplayinblockplace.d();
    int k = packetplayinblockplace.e();
    int l = packetplayinblockplace.getFace();
    
    player.w();
    if (packetplayinblockplace.getFace() == 255) {
      if (itemstack == null) {
        return;
      }
      

      int itemstackAmount = count;
      PlayerInteractEvent event = CraftEventFactory.callPlayerInteractEvent(player, Action.RIGHT_CLICK_AIR, itemstack);
      if (event.useItemInHand() != Event.Result.DENY) {
        player.playerInteractManager.useItem(player, player.world, itemstack);
      }
      



      always = count != itemstackAmount;
    }
    else if ((packetplayinblockplace.d() >= minecraftServer.getMaxBuildHeight() - 1) && ((packetplayinblockplace.getFace() == 1) || (packetplayinblockplace.d() >= minecraftServer.getMaxBuildHeight()))) {
      ChatMessage chatmessage = new ChatMessage("build.tooHigh", new Object[] { Integer.valueOf(minecraftServer.getMaxBuildHeight()) });
      
      chatmessage.b().setColor(EnumChatFormat.RED);
      player.playerConnection.sendPacket(new PacketPlayOutChat(chatmessage));
      flag = true;
    }
    else {
      Location eyeLoc = getPlayer().getEyeLocation();
      double reachDistance = NumberConversions.square(eyeLoc.getX() - i) + NumberConversions.square(eyeLoc.getY() - j) + NumberConversions.square(eyeLoc.getZ() - k);
      if (reachDistance > (getPlayer().getGameMode() == org.bukkit.GameMode.CREATIVE ? 49 : 36)) {
        return;
      }
      
      player.playerInteractManager.interact(player, worldserver, itemstack, i, j, k, l, packetplayinblockplace.h(), packetplayinblockplace.i(), packetplayinblockplace.j());
      

      flag = true;
    }
    
    if (flag) {
      player.playerConnection.sendPacket(new PacketPlayOutBlockChange(i, j, k, worldserver));
      if (l == 0) {
        j--;
      }
      
      if (l == 1) {
        j++;
      }
      
      if (l == 2) {
        k--;
      }
      
      if (l == 3) {
        k++;
      }
      
      if (l == 4) {
        i--;
      }
      
      if (l == 5) {
        i++;
      }
      
      player.playerConnection.sendPacket(new PacketPlayOutBlockChange(i, j, k, worldserver));
    }
    
    itemstack = player.inventory.getItemInHand();
    if ((itemstack != null) && (count == 0)) {
      player.inventory.items[player.inventory.itemInHandIndex] = null;
      itemstack = null;
    }
    
    if ((itemstack == null) || (itemstack.n() == 0)) {
      player.h = true;
      player.inventory.items[player.inventory.itemInHandIndex] = ItemStack.b(player.inventory.items[player.inventory.itemInHandIndex]);
      Slot slot = player.activeContainer.a(player.inventory, player.inventory.itemInHandIndex);
      
      player.activeContainer.b();
      player.h = false;
      
      if ((!ItemStack.matches(player.inventory.getItemInHand(), packetplayinblockplace.getItemStack())) || (always)) {
        sendPacket(new PacketPlayOutSetSlot(player.activeContainer.windowId, rawSlotIndex, player.inventory.getItemInHand()));
      }
    }
  }
  
  public void a(IChatBaseComponent ichatbasecomponent)
  {
    if (processedDisconnect) {
      return;
    }
    processedDisconnect = true;
    

    c.info(player.getName() + " lost connection: " + ichatbasecomponent.c());
    minecraftServer.au();
    







    player.n();
    String quitMessage = minecraftServer.getPlayerList().disconnect(player);
    if ((quitMessage != null) && (quitMessage.length() > 0)) {
      minecraftServer.getPlayerList().sendMessage(CraftChatMessage.fromString(quitMessage));
    }
    
    if ((minecraftServer.L()) && (player.getName().equals(minecraftServer.K()))) {
      c.info("Stopping singleplayer server as player logged out");
      minecraftServer.safeShutdown();
    }
  }
  
  public void sendPacket(Packet packet) {
    if ((packet instanceof PacketPlayOutChat)) {
      PacketPlayOutChat packetplayoutchat = (PacketPlayOutChat)packet;
      EnumChatVisibility enumchatvisibility = player.getChatFlags();
      
      if (enumchatvisibility == EnumChatVisibility.HIDDEN) {
        return;
      }
      
      if ((enumchatvisibility == EnumChatVisibility.SYSTEM) && (!packetplayoutchat.d())) {
        return;
      }
    }
    

    if (packet == null)
      return;
    if ((packet instanceof PacketPlayOutSpawnPosition)) {
      PacketPlayOutSpawnPosition packet6 = (PacketPlayOutSpawnPosition)packet;
      player.compassTarget = new Location(getPlayer().getWorld(), x, y, z);
    }
    
    try
    {
      networkManager.handle(packet, new GenericFutureListener[0]);
    } catch (Throwable throwable) {
      CrashReport crashreport = CrashReport.a(throwable, "Sending packet");
      CrashReportSystemDetails crashreportsystemdetails = crashreport.a("Packet being sent");
      
      crashreportsystemdetails.a("Packet class", new CrashReportConnectionPacketClass(this, packet));
      throw new ReportedException(crashreport);
    }
  }
  
  public void a(PacketPlayInHeldItemSlot packetplayinhelditemslot)
  {
    if (player.dead) { return;
    }
    if ((packetplayinhelditemslot.c() >= 0) && (packetplayinhelditemslot.c() < PlayerInventory.getHotbarSize())) {
      PlayerItemHeldEvent event = new PlayerItemHeldEvent(getPlayer(), player.inventory.itemInHandIndex, packetplayinhelditemslot.c());
      server.getPluginManager().callEvent(event);
      if (event.isCancelled()) {
        sendPacket(new PacketPlayOutHeldItemSlot(player.inventory.itemInHandIndex));
        player.w();
        return;
      }
      

      player.inventory.itemInHandIndex = packetplayinhelditemslot.c();
      player.w();
    } else {
      c.warn(player.getName() + " tried to set an invalid carried item");
      disconnect("Nope!");
    }
  }
  
  public void a(PacketPlayInChat packetplayinchat) {
    if ((player.dead) || (player.getChatFlags() == EnumChatVisibility.HIDDEN)) {
      ChatMessage chatmessage = new ChatMessage("chat.cannotSend", new Object[0]);
      
      chatmessage.b().setColor(EnumChatFormat.RED);
      sendPacket(new PacketPlayOutChat(chatmessage));
    } else {
      player.w();
      String s = packetplayinchat.c();
      
      s = net.minecraft.util.org.apache.commons.lang3.StringUtils.normalizeSpace(s);
      
      for (int i = 0; i < s.length(); i++) {
        if (!SharedConstants.isAllowedChatCharacter(s.charAt(i)))
        {
          if (packetplayinchat.a()) {
            Waitable waitable = new Waitable()
            {
              protected Object evaluate() {
                disconnect("Illegal characters in chat");
                return null;
              }
              
            };
            minecraftServer.processQueue.add(waitable);
            try
            {
              waitable.get();
            } catch (InterruptedException e) {
              Thread.currentThread().interrupt();
            } catch (ExecutionException e) {
              throw new RuntimeException(e);
            }
          } else {
            disconnect("Illegal characters in chat");
          }
          
          return;
        }
      }
      
      if (s.startsWith("/"))
      {
        try {
          minecraftServer.server.playerCommandState = true;
          handleCommand(s);
        } finally {
          minecraftServer.server.playerCommandState = false;
        }
      } else if (s.isEmpty()) {
        c.warn(player.getName() + " tried to send an empty message");
      } else if (getPlayer().isConversing()) {
        getPlayer().acceptConversationInput(s);
      } else if (player.getChatFlags() == EnumChatVisibility.SYSTEM) {
        ChatMessage chatmessage = new ChatMessage("chat.cannotSend", new Object[0]);
        
        chatmessage.b().setColor(EnumChatFormat.RED);
        sendPacket(new PacketPlayOutChat(chatmessage));
      } else {
        chat(s, packetplayinchat.a());
      }
      







      if ((chatSpamField.addAndGet(this, 20) > 200) && (!minecraftServer.getPlayerList().isOp(player.getName())))
      {
        disconnect("disconnect.spam");
      }
    }
  }
  
  public void chat(String s, boolean async)
  {
    if ((s.isEmpty()) || (this.player.getChatFlags() == EnumChatVisibility.HIDDEN)) {
      return;
    }
    
    if (s.startsWith("/")) {
      handleCommand(s);
    } else if (this.player.getChatFlags() != EnumChatVisibility.SYSTEM)
    {

      Player player = getPlayer();
      AsyncPlayerChatEvent event = new AsyncPlayerChatEvent(async, player, s, new LazyPlayerSet());
      server.getPluginManager().callEvent(event);
      
      if (PlayerChatEvent.getHandlerList().getRegisteredListeners().length != 0)
      {
        final PlayerChatEvent queueEvent = new PlayerChatEvent(player, event.getMessage(), event.getFormat(), event.getRecipients());
        queueEvent.setCancelled(event.isCancelled());
        Waitable waitable = new Waitable()
        {
          protected Object evaluate() {
            org.bukkit.Bukkit.getPluginManager().callEvent(queueEvent);
            
            if (queueEvent.isCancelled()) {
              return null;
            }
            
            String message = String.format(queueEvent.getFormat(), new Object[] { queueEvent.getPlayer().getDisplayName(), queueEvent.getMessage() });
            minecraftServer.console.sendMessage(message);
            if (((LazyPlayerSet)queueEvent.getRecipients()).isLazy()) {
              for (Object player : minecraftServer.getPlayerList().players) {
                ((EntityPlayer)player).sendMessage(CraftChatMessage.fromString(message));
              }
            } else {
              for (Player player : queueEvent.getRecipients()) {
                player.sendMessage(message);
              }
            }
            return null;
          } };
        if (async) {
          minecraftServer.processQueue.add(waitable);
        } else {
          waitable.run();
        }
        try {
          waitable.get();
        } catch (InterruptedException e) {
          Thread.currentThread().interrupt();
        } catch (ExecutionException e) {
          throw new RuntimeException("Exception processing chat event", e.getCause());
        }
      } else {
        if (event.isCancelled()) {
          return;
        }
        
        s = String.format(event.getFormat(), new Object[] { event.getPlayer().getDisplayName(), event.getMessage() });
        minecraftServer.console.sendMessage(s);
        if (((LazyPlayerSet)event.getRecipients()).isLazy()) {
          for (Object recipient : minecraftServer.getPlayerList().players) {
            ((EntityPlayer)recipient).sendMessage(CraftChatMessage.fromString(s));
          }
        } else {
          for (Player recipient : event.getRecipients()) {
            recipient.sendMessage(s);
          }
        }
      }
    }
  }
  

  private void handleCommand(String s)
  {
    CraftPlayer player = getPlayer();
    
    PlayerCommandPreprocessEvent event = new PlayerCommandPreprocessEvent(player, s, new LazyPlayerSet());
    server.getPluginManager().callEvent(event);
    
    if (event.isCancelled()) {
      return;
    }
    try
    {
      c.info(event.getPlayer().getName() + " issued server command: " + event.getMessage());
      if (server.dispatchCommand(event.getPlayer(), event.getMessage().substring(1))) {
        return;
      }
    } catch (CommandException ex) {
      player.sendMessage(org.bukkit.ChatColor.RED + "An internal error occurred while attempting to perform this command");
      java.util.logging.Logger.getLogger(PlayerConnection.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
      return;
    }
  }
  

  public void a(PacketPlayInArmAnimation packetplayinarmanimation)
  {
    if (player.dead) return;
    player.w();
    if (packetplayinarmanimation.d() == 1)
    {
      float f = 1.0F;
      float f1 = player.lastPitch + (player.pitch - player.lastPitch) * f;
      float f2 = player.lastYaw + (player.yaw - player.lastYaw) * f;
      double d0 = player.lastX + (player.locX - player.lastX) * f;
      double d1 = player.lastY + (player.locY - player.lastY) * f + 1.62D - player.height;
      double d2 = player.lastZ + (player.locZ - player.lastZ) * f;
      Vec3D vec3d = player.world.getVec3DPool().create(d0, d1, d2);
      
      float f3 = MathHelper.cos(-f2 * 0.01745329F - 3.141593F);
      float f4 = MathHelper.sin(-f2 * 0.01745329F - 3.141593F);
      float f5 = -MathHelper.cos(-f1 * 0.01745329F);
      float f6 = MathHelper.sin(-f1 * 0.01745329F);
      float f7 = f4 * f5;
      float f8 = f3 * f5;
      double d3 = 5.0D;
      Vec3D vec3d1 = vec3d.add(f7 * d3, f6 * d3, f8 * d3);
      MovingObjectPosition movingobjectposition = player.world.rayTrace(vec3d, vec3d1, false);
      
      if ((movingobjectposition == null) || (type != EnumMovingObjectType.BLOCK)) {
        CraftEventFactory.callPlayerInteractEvent(player, Action.LEFT_CLICK_AIR, player.inventory.getItemInHand());
      }
      

      PlayerAnimationEvent event = new PlayerAnimationEvent(getPlayer());
      server.getPluginManager().callEvent(event);
      
      if (event.isCancelled()) { return;
      }
      
      player.ba();
    }
  }
  
  public void a(PacketPlayInEntityAction packetplayinentityaction)
  {
    if (player.dead) { return;
    }
    player.w();
    if ((packetplayinentityaction.d() == 1) || (packetplayinentityaction.d() == 2)) {
      PlayerToggleSneakEvent event = new PlayerToggleSneakEvent(getPlayer(), packetplayinentityaction.d() == 1);
      server.getPluginManager().callEvent(event);
      
      if (event.isCancelled()) {
        return;
      }
    }
    
    if ((packetplayinentityaction.d() == 4) || (packetplayinentityaction.d() == 5)) {
      PlayerToggleSprintEvent event = new PlayerToggleSprintEvent(getPlayer(), packetplayinentityaction.d() == 4);
      server.getPluginManager().callEvent(event);
      
      if (event.isCancelled()) {
        return;
      }
    }
    

    if (packetplayinentityaction.d() == 1) {
      player.setSneaking(true);
    } else if (packetplayinentityaction.d() == 2) {
      player.setSneaking(false);
    } else if (packetplayinentityaction.d() == 4) {
      player.setSprinting(true);
    } else if (packetplayinentityaction.d() == 5) {
      player.setSprinting(false);
    } else if (packetplayinentityaction.d() == 3) {
      player.a(false, true, true);
    }
    else if (packetplayinentityaction.d() == 6) {
      if ((player.vehicle != null) && ((player.vehicle instanceof EntityHorse))) {
        ((EntityHorse)player.vehicle).w(packetplayinentityaction.e());
      }
    } else if ((packetplayinentityaction.d() == 7) && (player.vehicle != null) && ((player.vehicle instanceof EntityHorse))) {
      ((EntityHorse)player.vehicle).g(player);
    }
  }
  
  public void a(PacketPlayInUseEntity packetplayinuseentity) {
    if (player.dead) return;
    WorldServer worldserver = minecraftServer.getWorldServer(player.dimension);
    Entity entity = packetplayinuseentity.a(worldserver);
    
    player.w();
    if (entity != null) {
      boolean flag = player.o(entity);
      double d0 = 36.0D;
      
      if (!flag) {
        d0 = 9.0D;
      }
      
      if (player.e(entity) < d0) {
        ItemStack itemInHand = player.inventory.getItemInHand();
        if (packetplayinuseentity.c() == EnumEntityUseAction.INTERACT)
        {
          boolean triggerTagUpdate = (itemInHand != null) && (itemInHand.getItem() == Items.NAME_TAG) && ((entity instanceof EntityInsentient));
          boolean triggerChestUpdate = (itemInHand != null) && (itemInHand.getItem() == Item.getItemOf(Blocks.CHEST)) && ((entity instanceof EntityHorse));
          boolean triggerLeashUpdate = (itemInHand != null) && (itemInHand.getItem() == Items.LEASH) && ((entity instanceof EntityInsentient));
          PlayerInteractEntityEvent event = new PlayerInteractEntityEvent(getPlayer(), entity.getBukkitEntity());
          server.getPluginManager().callEvent(event);
          
          if ((triggerLeashUpdate) && ((event.isCancelled()) || (player.inventory.getItemInHand() == null) || (player.inventory.getItemInHand().getItem() != Items.LEASH)))
          {
            sendPacket(new PacketPlayOutAttachEntity(1, entity, ((EntityInsentient)entity).getLeashHolder()));
          }
          
          if ((triggerTagUpdate) && ((event.isCancelled()) || (player.inventory.getItemInHand() == null) || (player.inventory.getItemInHand().getItem() != Items.NAME_TAG)))
          {
            sendPacket(new PacketPlayOutEntityMetadata(entity.getId(), datawatcher, true));
          }
          if ((triggerChestUpdate) && ((event.isCancelled()) || (player.inventory.getItemInHand() == null) || (player.inventory.getItemInHand().getItem() != Item.getItemOf(Blocks.CHEST)))) {
            sendPacket(new PacketPlayOutEntityMetadata(entity.getId(), datawatcher, true));
          }
          
          if (event.isCancelled()) {
            return;
          }
          

          player.p(entity);
          

          if ((itemInHand != null) && (count <= -1)) {
            player.updateInventory(player.activeContainer);
          }
        }
        else if (packetplayinuseentity.c() == EnumEntityUseAction.ATTACK) {
          if (((entity instanceof EntityItem)) || ((entity instanceof EntityExperienceOrb)) || ((entity instanceof EntityArrow)) || (entity == player)) {
            disconnect("Attempting to attack an invalid entity");
            minecraftServer.warning("Player " + player.getName() + " tried to attack an invalid entity");
            return;
          }
          
          player.attack(entity);
          

          if ((itemInHand != null) && (count <= -1)) {
            player.updateInventory(player.activeContainer);
          }
        }
      }
    }
  }
  
  public void a(PacketPlayInClientCommand packetplayinclientcommand)
  {
    player.w();
    EnumClientCommand enumclientcommand = packetplayinclientcommand.c();
    
    switch (ClientCommandOrdinalWrapper.a[enumclientcommand.ordinal()]) {
    case 1: 
      if (player.viewingCredits) {
        minecraftServer.getPlayerList().changeDimension(player, 0, PlayerTeleportEvent.TeleportCause.END_PORTAL);
      } else if (player.r().getWorldData().isHardcore()) {
        if ((minecraftServer.L()) && (player.getName().equals(minecraftServer.K()))) {
          player.playerConnection.disconnect("You have died. Game over, man, it's game over!");
          minecraftServer.S();
        } else {
          BanEntry banentry = new BanEntry(player.getName());
          
          banentry.setReason("Death in Hardcore");
          minecraftServer.getPlayerList().getNameBans().add(banentry);
          player.playerConnection.disconnect("You have died. Game over, man, it's game over!");
        }
      } else {
        if (player.getHealth() > 0.0F) {
          return;
        }
        
        player = minecraftServer.getPlayerList().moveToWorld(player, 0, false);
      }
      break;
    
    case 2: 
      player.x().a(player);
      break;
    
    case 3: 
      player.a(AchievementList.f);
    }
  }
  
  public void a(PacketPlayInCloseWindow packetplayinclosewindow) {
    if (player.dead) { return;
    }
    CraftEventFactory.handleInventoryCloseEvent(player);
    
    player.m();
  }
  
  public void a(PacketPlayInWindowClick packetplayinwindowclick) {
    if (player.dead) { return;
    }
    player.w();
    if ((player.activeContainer.windowId == packetplayinwindowclick.c()) && (player.activeContainer.c(player)))
    {
      if ((packetplayinwindowclick.d() < -1) && (packetplayinwindowclick.d() != -999)) {
        return;
      }
      
      InventoryView inventory = player.activeContainer.getBukkitView();
      InventoryType.SlotType type = CraftInventoryView.getSlotType(inventory, packetplayinwindowclick.d());
      
      InventoryClickEvent event = null;
      ClickType click = ClickType.UNKNOWN;
      InventoryAction action = InventoryAction.UNKNOWN;
      
      ItemStack itemstack = null;
      
      if (packetplayinwindowclick.d() == -1) {
        type = InventoryType.SlotType.OUTSIDE;
        click = packetplayinwindowclick.e() == 0 ? ClickType.WINDOW_BORDER_LEFT : ClickType.WINDOW_BORDER_RIGHT;
        action = InventoryAction.NOTHING;
      } else if (packetplayinwindowclick.h() == 0) {
        if (packetplayinwindowclick.e() == 0) {
          click = ClickType.LEFT;
        } else if (packetplayinwindowclick.e() == 1) {
          click = ClickType.RIGHT;
        }
        if ((packetplayinwindowclick.e() == 0) || (packetplayinwindowclick.e() == 1)) {
          action = InventoryAction.NOTHING;
          if (packetplayinwindowclick.d() == -999) {
            if (player.inventory.getCarried() != null) {
              action = packetplayinwindowclick.e() == 0 ? InventoryAction.DROP_ALL_CURSOR : InventoryAction.DROP_ONE_CURSOR;
            }
          } else {
            Slot slot = player.activeContainer.getSlot(packetplayinwindowclick.d());
            if (slot != null) {
              ItemStack clickedItem = slot.getItem();
              ItemStack cursor = player.inventory.getCarried();
              if (clickedItem == null) {
                if (cursor != null) {
                  action = packetplayinwindowclick.e() == 0 ? InventoryAction.PLACE_ALL : InventoryAction.PLACE_ONE;
                }
              } else if (slot.a(player)) {
                if (cursor == null) {
                  action = packetplayinwindowclick.e() == 0 ? InventoryAction.PICKUP_ALL : InventoryAction.PICKUP_HALF;
                } else if (slot.isAllowed(cursor)) {
                  if ((clickedItem.doMaterialsMatch(cursor)) && (ItemStack.equals(clickedItem, cursor))) {
                    int toPlace = packetplayinwindowclick.e() == 0 ? count : 1;
                    toPlace = Math.min(toPlace, clickedItem.getMaxStackSize() - count);
                    toPlace = Math.min(toPlace, inventory.getMaxStackSize() - count);
                    if (toPlace == 1) {
                      action = InventoryAction.PLACE_ONE;
                    } else if (toPlace == count) {
                      action = InventoryAction.PLACE_ALL;
                    } else if (toPlace < 0) {
                      action = toPlace != -1 ? InventoryAction.PICKUP_SOME : InventoryAction.PICKUP_ONE;
                    } else if (toPlace != 0) {
                      action = InventoryAction.PLACE_SOME;
                    }
                  } else if (count <= slot.a()) {
                    action = InventoryAction.SWAP_WITH_CURSOR;
                  }
                } else if ((cursor.getItem() == clickedItem.getItem()) && ((!cursor.usesData()) || (cursor.getData() == clickedItem.getData())) && (ItemStack.equals(cursor, clickedItem)) && 
                  (count >= 0) && 
                  (count + count <= cursor.getMaxStackSize()))
                {
                  action = InventoryAction.PICKUP_ALL;
                }
                
              }
            }
          }
        }
      }
      else if (packetplayinwindowclick.h() == 1) {
        if (packetplayinwindowclick.e() == 0) {
          click = ClickType.SHIFT_LEFT;
        } else if (packetplayinwindowclick.e() == 1) {
          click = ClickType.SHIFT_RIGHT;
        }
        if ((packetplayinwindowclick.e() == 0) || (packetplayinwindowclick.e() == 1)) {
          if (packetplayinwindowclick.d() < 0) {
            action = InventoryAction.NOTHING;
          } else {
            Slot slot = player.activeContainer.getSlot(packetplayinwindowclick.d());
            if ((slot != null) && (slot.a(player)) && (slot.e())) {
              action = InventoryAction.MOVE_TO_OTHER_INVENTORY;
            } else {
              action = InventoryAction.NOTHING;
            }
          }
        }
      } else if (packetplayinwindowclick.h() == 2) {
        if ((packetplayinwindowclick.e() >= 0) && (packetplayinwindowclick.e() < 9)) {
          click = ClickType.NUMBER_KEY;
          Slot clickedSlot = player.activeContainer.getSlot(packetplayinwindowclick.d());
          if (clickedSlot.a(player)) {
            ItemStack hotbar = player.inventory.getItem(packetplayinwindowclick.e());
            boolean canCleanSwap = (hotbar == null) || ((inventory == player.inventory) && (clickedSlot.isAllowed(hotbar)));
            if (clickedSlot.e()) {
              if (canCleanSwap) {
                action = InventoryAction.HOTBAR_SWAP;
              } else {
                int firstEmptySlot = player.inventory.j();
                if (firstEmptySlot > -1) {
                  action = InventoryAction.HOTBAR_MOVE_AND_READD;
                } else {
                  action = InventoryAction.NOTHING;
                }
              }
            } else if ((!clickedSlot.e()) && (hotbar != null) && (clickedSlot.isAllowed(hotbar))) {
              action = InventoryAction.HOTBAR_SWAP;
            } else {
              action = InventoryAction.NOTHING;
            }
          } else {
            action = InventoryAction.NOTHING;
          }
          
          event = new InventoryClickEvent(inventory, type, packetplayinwindowclick.d(), click, action, packetplayinwindowclick.e());
        }
      } else if (packetplayinwindowclick.h() == 3) {
        if (packetplayinwindowclick.e() == 2) {
          click = ClickType.MIDDLE;
          if (packetplayinwindowclick.d() == -999) {
            action = InventoryAction.NOTHING;
          } else {
            Slot slot = player.activeContainer.getSlot(packetplayinwindowclick.d());
            if ((slot != null) && (slot.e()) && (player.abilities.canInstantlyBuild) && (player.inventory.getCarried() == null)) {
              action = InventoryAction.CLONE_STACK;
            } else {
              action = InventoryAction.NOTHING;
            }
          }
        } else {
          click = ClickType.UNKNOWN;
          action = InventoryAction.UNKNOWN;
        }
      } else if (packetplayinwindowclick.h() == 4) {
        if (packetplayinwindowclick.d() >= 0) {
          if (packetplayinwindowclick.e() == 0) {
            click = ClickType.DROP;
            Slot slot = player.activeContainer.getSlot(packetplayinwindowclick.d());
            if ((slot != null) && (slot.e()) && (slot.a(player)) && (slot.getItem() != null) && (slot.getItem().getItem() != Item.getItemOf(Blocks.AIR))) {
              action = InventoryAction.DROP_ONE_SLOT;
            } else {
              action = InventoryAction.NOTHING;
            }
          } else if (packetplayinwindowclick.e() == 1) {
            click = ClickType.CONTROL_DROP;
            Slot slot = player.activeContainer.getSlot(packetplayinwindowclick.d());
            if ((slot != null) && (slot.e()) && (slot.a(player)) && (slot.getItem() != null) && (slot.getItem().getItem() != Item.getItemOf(Blocks.AIR))) {
              action = InventoryAction.DROP_ALL_SLOT;
            } else {
              action = InventoryAction.NOTHING;
            }
          }
        }
        else {
          click = ClickType.LEFT;
          if (packetplayinwindowclick.e() == 1) {
            click = ClickType.RIGHT;
          }
          action = InventoryAction.NOTHING;
        }
      } else if (packetplayinwindowclick.h() == 5) {
        itemstack = player.activeContainer.clickItem(packetplayinwindowclick.d(), packetplayinwindowclick.e(), 5, player);
      } else if (packetplayinwindowclick.h() == 6) {
        click = ClickType.DOUBLE_CLICK;
        action = InventoryAction.NOTHING;
        if ((packetplayinwindowclick.d() >= 0) && (player.inventory.getCarried() != null)) {
          ItemStack cursor = player.inventory.getCarried();
          action = InventoryAction.NOTHING;
          
          if ((inventory.getTopInventory().contains(org.bukkit.Material.getMaterial(Item.b(cursor.getItem())))) || (inventory.getBottomInventory().contains(org.bukkit.Material.getMaterial(Item.b(cursor.getItem()))))) {
            action = InventoryAction.COLLECT_TO_CURSOR;
          }
        }
      }
      

      if (packetplayinwindowclick.h() != 5) {
        if (click == ClickType.NUMBER_KEY) {
          event = new InventoryClickEvent(inventory, type, packetplayinwindowclick.d(), click, action, packetplayinwindowclick.e());
        } else {
          event = new InventoryClickEvent(inventory, type, packetplayinwindowclick.d(), click, action);
        }
        
        Inventory top = inventory.getTopInventory();
        if ((packetplayinwindowclick.d() == 0) && ((top instanceof CraftingInventory))) {
          Recipe recipe = ((CraftingInventory)top).getRecipe();
          if (recipe != null) {
            if (click == ClickType.NUMBER_KEY) {
              event = new CraftItemEvent(recipe, inventory, type, packetplayinwindowclick.d(), click, action, packetplayinwindowclick.e());
            } else {
              event = new CraftItemEvent(recipe, inventory, type, packetplayinwindowclick.d(), click, action);
            }
          }
        }
        
        server.getPluginManager().callEvent(event);
        
        switch (3.$SwitchMap$org$bukkit$event$Event$Result[event.getResult().ordinal()]) {
        case 1: 
        case 2: 
          itemstack = player.activeContainer.clickItem(packetplayinwindowclick.d(), packetplayinwindowclick.e(), packetplayinwindowclick.h(), player);
          break;
        










        case 3: 
          switch (3.$SwitchMap$org$bukkit$event$inventory$InventoryAction[action.ordinal()])
          {
          case 1: 
          case 2: 
          case 3: 
          case 4: 
          case 5: 
          case 6: 
            player.updateInventory(player.activeContainer);
            break;
          
          case 7: 
          case 8: 
          case 9: 
          case 10: 
          case 11: 
          case 12: 
          case 13: 
            player.playerConnection.sendPacket(new PacketPlayOutSetSlot(-1, -1, player.inventory.getCarried()));
            player.playerConnection.sendPacket(new PacketPlayOutSetSlot(player.activeContainer.windowId, packetplayinwindowclick.d(), player.activeContainer.getSlot(packetplayinwindowclick.d()).getItem()));
            break;
          
          case 14: 
          case 15: 
            player.playerConnection.sendPacket(new PacketPlayOutSetSlot(player.activeContainer.windowId, packetplayinwindowclick.d(), player.activeContainer.getSlot(packetplayinwindowclick.d()).getItem()));
            break;
          
          case 16: 
          case 17: 
          case 18: 
            player.playerConnection.sendPacket(new PacketPlayOutSetSlot(-1, -1, player.inventory.getCarried()));
            break;
          }
          
          

          return;
        }
        
      }
      
      if (ItemStack.matches(packetplayinwindowclick.g(), itemstack)) {
        player.playerConnection.sendPacket(new PacketPlayOutTransaction(packetplayinwindowclick.c(), packetplayinwindowclick.f(), true));
        player.h = true;
        player.activeContainer.b();
        player.broadcastCarriedItem();
        player.h = false;
      } else {
        n.a(player.activeContainer.windowId, Short.valueOf(packetplayinwindowclick.f()));
        player.playerConnection.sendPacket(new PacketPlayOutTransaction(packetplayinwindowclick.c(), packetplayinwindowclick.f(), false));
        player.activeContainer.a(player, false);
        ArrayList arraylist = new ArrayList();
        
        for (int i = 0; i < player.activeContainer.c.size(); i++) {
          arraylist.add(((Slot)player.activeContainer.c.get(i)).getItem());
        }
        
        player.a(player.activeContainer, arraylist);
        

        if ((type == InventoryType.SlotType.RESULT) && (itemstack != null)) {
          player.playerConnection.sendPacket(new PacketPlayOutSetSlot(player.activeContainer.windowId, 0, itemstack));
        }
      }
    }
  }
  
  public void a(PacketPlayInEnchantItem packetplayinenchantitem)
  {
    player.w();
    if ((player.activeContainer.windowId == packetplayinenchantitem.c()) && (player.activeContainer.c(player))) {
      player.activeContainer.a(player, packetplayinenchantitem.d());
      player.activeContainer.b();
    }
  }
  
  public void a(PacketPlayInSetCreativeSlot packetplayinsetcreativeslot) {
    if (playerplayerInteractManager.isCreative()) {
      boolean flag = packetplayinsetcreativeslot.c() < 0;
      ItemStack itemstack = packetplayinsetcreativeslot.d();
      boolean flag1 = (packetplayinsetcreativeslot.c() >= 1) && (packetplayinsetcreativeslot.c() < 36 + PlayerInventory.getHotbarSize());
      
      boolean flag2 = (itemstack == null) || ((itemstack.getItem() != null) && (!invalidItems.contains(Integer.valueOf(Item.b(itemstack.getItem())))));
      boolean flag3 = (itemstack == null) || ((itemstack.getData() >= 0) && (count <= 64) && (count > 0));
      

      if ((flag) || ((flag1) && (!ItemStack.matches(playerdefaultContainer.getSlot(packetplayinsetcreativeslot.c()).getItem(), packetplayinsetcreativeslot.d()))))
      {
        HumanEntity player = this.player.getBukkitEntity();
        InventoryView inventory = new CraftInventoryView(player, player.getInventory(), playerdefaultContainer);
        org.bukkit.inventory.ItemStack item = CraftItemStack.asBukkitCopy(packetplayinsetcreativeslot.d());
        
        InventoryType.SlotType type = InventoryType.SlotType.QUICKBAR;
        if (flag) {
          type = InventoryType.SlotType.OUTSIDE;
        } else if (packetplayinsetcreativeslot.c() < 36) {
          if ((packetplayinsetcreativeslot.c() >= 5) && (packetplayinsetcreativeslot.c() < 9)) {
            type = InventoryType.SlotType.ARMOR;
          } else {
            type = InventoryType.SlotType.CONTAINER;
          }
        }
        InventoryCreativeEvent event = new InventoryCreativeEvent(inventory, type, flag ? -999 : packetplayinsetcreativeslot.c(), item);
        server.getPluginManager().callEvent(event);
        
        itemstack = CraftItemStack.asNMSCopy(event.getCursor());
        
        switch (3.$SwitchMap$org$bukkit$event$Event$Result[event.getResult().ordinal()])
        {
        case 1: 
          flag2 = flag3 = 1;
          break;
        case 2: 
          break;
        
        case 3: 
          if (packetplayinsetcreativeslot.c() >= 0) {
            playerplayerConnection.sendPacket(new PacketPlayOutSetSlot(playerdefaultContainer.windowId, packetplayinsetcreativeslot.c(), playerdefaultContainer.getSlot(packetplayinsetcreativeslot.c()).getItem()));
            playerplayerConnection.sendPacket(new PacketPlayOutSetSlot(-1, -1, null));
          }
          return;
        }
        
      }
      
      if ((flag1) && (flag2) && (flag3)) {
        if (itemstack == null) {
          playerdefaultContainer.setItem(packetplayinsetcreativeslot.c(), (ItemStack)null);
        } else {
          playerdefaultContainer.setItem(packetplayinsetcreativeslot.c(), itemstack);
        }
        
        playerdefaultContainer.a(this.player, true);
      } else if ((flag) && (flag2) && (flag3) && (x < 200)) {
        x += 20;
        EntityItem entityitem = this.player.drop(itemstack, true);
        
        if (entityitem != null) {
          entityitem.e();
        }
      }
    }
  }
  
  public void a(PacketPlayInTransaction packetplayintransaction) {
    if (player.dead) return;
    Short oshort = (Short)n.get(player.activeContainer.windowId);
    
    if ((oshort != null) && (packetplayintransaction.d() == oshort.shortValue()) && (player.activeContainer.windowId == packetplayintransaction.c()) && (!player.activeContainer.c(player))) {
      player.activeContainer.a(player, true);
    }
  }
  
  public void a(PacketPlayInUpdateSign packetplayinupdatesign) {
    if (playerdead) { return;
    }
    this.player.w();
    WorldServer worldserver = minecraftServer.getWorldServer(playerdimension);
    
    if (worldserver.isLoaded(packetplayinupdatesign.c(), packetplayinupdatesign.d(), packetplayinupdatesign.e())) {
      TileEntity tileentity = worldserver.getTileEntity(packetplayinupdatesign.c(), packetplayinupdatesign.d(), packetplayinupdatesign.e());
      
      if ((tileentity instanceof TileEntitySign)) {
        TileEntitySign tileentitysign = (TileEntitySign)tileentity;
        
        if ((!tileentitysign.a()) || (tileentitysign.b() != this.player)) {
          minecraftServer.warning("Player " + this.player.getName() + " just tried to change non-editable sign");
          sendPacket(new PacketPlayOutUpdateSign(packetplayinupdatesign.c(), packetplayinupdatesign.d(), packetplayinupdatesign.e(), lines));
          return;
        }
      }
      



      for (int j = 0; j < 4; j++) {
        boolean flag = true;
        
        if (packetplayinupdatesign.f()[j].length() > 15) {
          flag = false;
        } else {
          for (int i = 0; i < packetplayinupdatesign.f()[j].length(); i++) {
            if (!SharedConstants.isAllowedChatCharacter(packetplayinupdatesign.f()[j].charAt(i))) {
              flag = false;
            }
          }
        }
        
        if (!flag) {
          packetplayinupdatesign.f()[j] = "!?";
        }
      }
      
      if ((tileentity instanceof TileEntitySign)) {
        j = packetplayinupdatesign.c();
        int k = packetplayinupdatesign.d();
        
        int i = packetplayinupdatesign.e();
        TileEntitySign tileentitysign1 = (TileEntitySign)tileentity;
        

        Player player = server.getPlayer(this.player);
        SignChangeEvent event = new SignChangeEvent((org.bukkit.craftbukkit.v1_7_R1.block.CraftBlock)player.getWorld().getBlockAt(j, k, i), server.getPlayer(this.player), packetplayinupdatesign.f());
        server.getPluginManager().callEvent(event);
        
        if (!event.isCancelled()) {
          for (int l = 0; l < 4; l++) {
            lines[l] = event.getLine(l);
            if (lines[l] == null) {
              lines[l] = "";
            }
          }
          isEditable = false;
        }
        


        tileentitysign1.update();
        worldserver.notify(j, k, i);
      }
    }
  }
  
  public void a(PacketPlayInKeepAlive packetplayinkeepalive) {
    if (packetplayinkeepalive.c() == h) {
      int i = (int)(d() - this.i);
      
      player.ping = ((player.ping * 3 + i) / 4);
    }
  }
  
  private long d() {
    return System.nanoTime() / 1000000L;
  }
  
  public void a(PacketPlayInAbilities packetplayinabilities)
  {
    if ((player.abilities.canFly) && (player.abilities.isFlying != packetplayinabilities.d())) {
      PlayerToggleFlightEvent event = new PlayerToggleFlightEvent(server.getPlayer(player), packetplayinabilities.d());
      server.getPluginManager().callEvent(event);
      if (!event.isCancelled()) {
        player.abilities.isFlying = packetplayinabilities.d();
      } else {
        player.updateAbilities();
      }
    }
  }
  
  public void a(PacketPlayInTabComplete packetplayintabcomplete)
  {
    ArrayList arraylist = net.minecraft.util.com.google.common.collect.Lists.newArrayList();
    Iterator iterator = minecraftServer.a(player, packetplayintabcomplete.c()).iterator();
    
    while (iterator.hasNext()) {
      String s = (String)iterator.next();
      
      arraylist.add(s);
    }
    
    player.playerConnection.sendPacket(new PacketPlayOutTabComplete((String[])arraylist.toArray(new String[arraylist.size()])));
  }
  
  public void a(PacketPlayInSettings packetplayinsettings) {
    player.a(packetplayinsettings);
  }
  



  public void a(PacketPlayInCustomPayload packetplayincustompayload)
  {
    if (length <= 0) {
      return;
    }
    ItemStack itemstack;
    ItemStack itemstack1;
    if ("MC|BEdit".equals(packetplayincustompayload.c())) {
      try {
        itemstack = new PacketDataSerializer(Unpooled.wrappedBuffer(packetplayincustompayload.e())).c();
        if (!ItemBookAndQuill.a(itemstack.getTag())) {
          throw new IOException("Invalid book tag!");
        }
        
        itemstack1 = player.inventory.getItemInHand();
        if ((itemstack.getItem() == Items.BOOK_AND_QUILL) && (itemstack.getItem() == itemstack1.getItem())) {
          CraftEventFactory.handleEditBookEvent(player, itemstack);
        }
      }
      catch (Exception exception) {
        c.error("Couldn't handle book info", exception);
        disconnect("Invalid book data!");
      }
    }
    else if ("MC|BSign".equals(packetplayincustompayload.c())) {
      try {
        itemstack = new PacketDataSerializer(Unpooled.wrappedBuffer(packetplayincustompayload.e())).c();
        if (!ItemWrittenBook.a(itemstack.getTag())) {
          throw new IOException("Invalid book tag!");
        }
        
        itemstack1 = player.inventory.getItemInHand();
        if ((itemstack.getItem() == Items.WRITTEN_BOOK) && (itemstack1.getItem() == Items.BOOK_AND_QUILL)) {
          CraftEventFactory.handleEditBookEvent(player, itemstack);
        }
      }
      catch (Exception exception1) {
        c.error("Couldn't sign book", exception1);
        disconnect("Invalid book data!");
      }
    }
    else
    {
      DataInputStream datainputstream;
      int i;
      if ("MC|TrSel".equals(packetplayincustompayload.c())) {
        try {
          datainputstream = new DataInputStream(new ByteArrayInputStream(packetplayincustompayload.e()));
          i = datainputstream.readInt();
          Container container = player.activeContainer;
          
          if ((container instanceof ContainerMerchant)) {
            ((ContainerMerchant)container).e(i);
          }
        }
        catch (Exception exception2) {
          c.error("Couldn't select trade", exception2);
          disconnect("Invalid trade data!");
        }
      }
      else if ("MC|AdvCdm".equals(packetplayincustompayload.c())) {
        if (!minecraftServer.getEnableCommandBlock()) {
          player.sendMessage(new ChatMessage("advMode.notEnabled", new Object[0]));
        } else if ((player.a(2, "")) && (player.abilities.canInstantlyBuild)) {
          try {
            PacketDataSerializer packetdataserializer = new PacketDataSerializer(Unpooled.wrappedBuffer(packetplayincustompayload.e()));
            byte b0 = packetdataserializer.readByte();
            CommandBlockListenerAbstract commandblocklistenerabstract = null;
            
            if (b0 == 0) {
              TileEntity tileentity = player.world.getTileEntity(packetdataserializer.readInt(), packetdataserializer.readInt(), packetdataserializer.readInt());
              
              if ((tileentity instanceof TileEntityCommand)) {
                commandblocklistenerabstract = ((TileEntityCommand)tileentity).a();
              }
            } else if (b0 == 1) {
              Entity entity = player.world.getEntity(packetdataserializer.readInt());
              
              if ((entity instanceof EntityMinecartCommandBlock)) {
                commandblocklistenerabstract = ((EntityMinecartCommandBlock)entity).e();
              }
            }
            
            String s = packetdataserializer.c(packetdataserializer.readableBytes());
            
            if (commandblocklistenerabstract != null) {
              commandblocklistenerabstract.a(s);
              commandblocklistenerabstract.e();
              player.sendMessage(new ChatMessage("advMode.setCommand.success", new Object[] { s }));
            }
          }
          catch (Exception exception3) {
            c.error("Couldn't set command block", exception3);
            disconnect("Invalid CommandBlock data!");
          }
          
        } else {
          player.sendMessage(new ChatMessage("advMode.notAllowed", new Object[0]));
        }
      } else if ("MC|Beacon".equals(packetplayincustompayload.c())) {
        if ((player.activeContainer instanceof ContainerBeacon)) {
          try {
            datainputstream = new DataInputStream(new ByteArrayInputStream(packetplayincustompayload.e()));
            i = datainputstream.readInt();
            int j = datainputstream.readInt();
            ContainerBeacon containerbeacon = (ContainerBeacon)player.activeContainer;
            Slot slot = containerbeacon.getSlot(0);
            
            if (slot.e()) {
              slot.a(1);
              TileEntityBeacon tileentitybeacon = containerbeacon.e();
              
              tileentitybeacon.d(i);
              tileentitybeacon.e(j);
              tileentitybeacon.update();
            }
          }
          catch (Exception exception4) {
            c.error("Couldn't set beacon", exception4);
            disconnect("Invalid beacon data!");
          }
        }
      }
      else if (("MC|ItemName".equals(packetplayincustompayload.c())) && ((player.activeContainer instanceof ContainerAnvil))) {
        ContainerAnvil containeranvil = (ContainerAnvil)player.activeContainer;
        
        if ((packetplayincustompayload.e() != null) && (packetplayincustompayload.e().length >= 1)) {
          String s1 = SharedConstants.a(new String(packetplayincustompayload.e(), net.minecraft.util.com.google.common.base.Charsets.UTF_8));
          
          if (s1.length() <= 30) {
            containeranvil.a(s1);
          }
        } else {
          containeranvil.a("");
        }
        
      }
      else if (packetplayincustompayload.c().equals("REGISTER")) {
        try {
          String channels = new String(packetplayincustompayload.e(), "UTF8");
          for (String channel : channels.split("")) {
            getPlayer().addChannel(channel);
          }
        } catch (UnsupportedEncodingException ex) {
          throw new AssertionError(ex);
        }
      } else if (packetplayincustompayload.c().equals("UNREGISTER")) {
        try {
          String channels = new String(packetplayincustompayload.e(), "UTF8");
          for (String channel : channels.split("")) {
            getPlayer().removeChannel(channel);
          }
        } catch (UnsupportedEncodingException ex) {
          throw new AssertionError(ex);
        }
      } else {
        server.getMessenger().dispatchIncomingMessage(player.getBukkitEntity(), packetplayincustompayload.c(), packetplayincustompayload.e());
      }
    }
  }
  
  public void a(EnumProtocol enumprotocol, EnumProtocol enumprotocol1)
  {
    if (enumprotocol1 != EnumProtocol.PLAY) {
      throw new IllegalStateException("Unexpected change in protocol!");
    }
  }
  
  public final boolean isDisconnected()
  {
    return !NetworkManager.a(networkManager).config().isAutoRead();
  }
}
