package net.minecraft.server.v1_7_R1;

import org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory;
import org.bukkit.event.Event.Result;
import org.bukkit.event.block.Action;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockDamageEvent;
import org.bukkit.event.player.PlayerInteractEvent;

public class PlayerInteractManager
{
  public World world;
  public EntityPlayer player;
  private EnumGamemode gamemode;
  private boolean d;
  private int lastDigTick;
  private int f;
  private int g;
  private int h;
  private int currentTick;
  private boolean j;
  private int k;
  private int l;
  private int m;
  private int n;
  private int o;
  
  public PlayerInteractManager(World world)
  {
    gamemode = EnumGamemode.NONE;
    o = -1;
    this.world = world;
  }
  
  public void setGameMode(EnumGamemode enumgamemode) {
    gamemode = enumgamemode;
    enumgamemode.a(player.abilities);
    player.updateAbilities();
  }
  
  public EnumGamemode getGameMode() {
    return gamemode;
  }
  
  public boolean isCreative() {
    return gamemode.d();
  }
  
  public void b(EnumGamemode enumgamemode) {
    if (gamemode == EnumGamemode.NONE) {
      gamemode = enumgamemode;
    }
    
    setGameMode(gamemode);
  }
  
  public void a() {
    currentTick = MinecraftServer.currentTick;
    


    if (this.j) {
      int j = currentTick - n;
      Block block = world.getType(this.k, l, m);
      
      if (block.getMaterial() == Material.AIR) {
        this.j = false;
      } else {
        float f = block.getDamage(player, player.world, this.k, l, m) * (j + 1);
        int i = (int)(f * 10.0F);
        if (i != o) {
          world.d(player.getId(), this.k, l, m, i);
          o = i;
        }
        
        if (f >= 1.0F) {
          this.j = false;
          breakBlock(this.k, l, m);
        }
      }
    } else if (d) {
      Block block1 = world.getType(this.f, g, h);
      
      if (block1.getMaterial() == Material.AIR) {
        world.d(player.getId(), this.f, g, h, -1);
        o = -1;
        d = false;
      } else {
        int k = currentTick - lastDigTick;
        
        float f = block1.getDamage(player, player.world, this.f, g, h) * (k + 1);
        int i = (int)(f * 10.0F);
        if (i != o) {
          world.d(player.getId(), this.f, g, h, i);
          o = i;
        }
      }
    }
  }
  
  public void dig(int i, int j, int k, int l)
  {
    PlayerInteractEvent event = CraftEventFactory.callPlayerInteractEvent(player, Action.LEFT_CLICK_BLOCK, i, j, k, l, player.inventory.getItemInHand());
    if ((!gamemode.isAdventure()) || (player.d(i, j, k))) {
      if (event.isCancelled())
      {
        player.playerConnection.sendPacket(new PacketPlayOutBlockChange(i, j, k, world));
        
        TileEntity tileentity = world.getTileEntity(i, j, k);
        if (tileentity != null) {
          player.playerConnection.sendPacket(tileentity.getUpdatePacket());
        }
        return;
      }
      
      if (isCreative()) {
        if (!world.douseFire((EntityHuman)null, i, j, k, l)) {
          breakBlock(i, j, k);
        }
      }
      else {
        lastDigTick = currentTick;
        float f = 1.0F;
        Block block = world.getType(i, j, k);
        
        if (event.useInteractedBlock() == Event.Result.DENY)
        {
          if (block == Blocks.WOODEN_DOOR)
          {
            boolean bottom = (world.getData(i, j, k) & 0x8) == 0;
            player.playerConnection.sendPacket(new PacketPlayOutBlockChange(i, j, k, world));
            player.playerConnection.sendPacket(new PacketPlayOutBlockChange(i, j + (bottom ? 1 : -1), k, world));
          } else if (block == Blocks.TRAP_DOOR) {
            player.playerConnection.sendPacket(new PacketPlayOutBlockChange(i, j, k, world));
          }
        } else if (block.getMaterial() != Material.AIR) {
          block.attack(world, i, j, k, player);
          f = block.getDamage(player, player.world, i, j, k);
          
          world.douseFire((EntityHuman)null, i, j, k, l);
        }
        
        if (event.useItemInHand() == Event.Result.DENY)
        {
          if (f > 1.0F) {
            player.playerConnection.sendPacket(new PacketPlayOutBlockChange(i, j, k, world));
          }
          return;
        }
        BlockDamageEvent blockEvent = CraftEventFactory.callBlockDamageEvent(player, i, j, k, player.inventory.getItemInHand(), f >= 1.0F);
        
        if (blockEvent.isCancelled())
        {
          player.playerConnection.sendPacket(new PacketPlayOutBlockChange(i, j, k, world));
          return;
        }
        
        if (blockEvent.getInstaBreak()) {
          f = 2.0F;
        }
        

        if ((block.getMaterial() != Material.AIR) && (f >= 1.0F)) {
          breakBlock(i, j, k);
        } else {
          d = true;
          this.f = i;
          g = j;
          h = k;
          int i1 = (int)(f * 10.0F);
          
          world.d(player.getId(), i, j, k, i1);
          o = i1;
        }
      }
    }
  }
  
  public void a(int i, int j, int k) {
    if ((i == this.f) && (j == g) && (k == h)) {
      currentTick = MinecraftServer.currentTick;
      int l = currentTick - lastDigTick;
      Block block = world.getType(i, j, k);
      
      if (block.getMaterial() != Material.AIR) {
        float f = block.getDamage(player, player.world, i, j, k) * (l + 1);
        
        if (f >= 0.7F) {
          d = false;
          world.d(player.getId(), i, j, k, -1);
          breakBlock(i, j, k);
        } else if (!this.j) {
          d = false;
          this.j = true;
          this.k = i;
          this.l = j;
          m = k;
          n = lastDigTick;
        }
      }
    }
    else {
      player.playerConnection.sendPacket(new PacketPlayOutBlockChange(i, j, k, world));
    }
  }
  
  public void c(int i, int j, int k)
  {
    d = false;
    world.d(player.getId(), f, g, h, -1);
  }
  
  private boolean d(int i, int j, int k) {
    Block block = world.getType(i, j, k);
    int l = world.getData(i, j, k);
    
    block.a(world, i, j, k, l, player);
    boolean flag = world.setAir(i, j, k);
    
    if (flag) {
      block.postBreak(world, i, j, k, l);
    }
    
    return flag;
  }
  
  public boolean breakBlock(int i, int j, int k)
  {
    BlockBreakEvent event = null;
    
    if ((player instanceof EntityPlayer)) {
      org.bukkit.block.Block block = world.getWorld().getBlockAt(i, j, k);
      

      if (world.getTileEntity(i, j, k) == null) {
        PacketPlayOutBlockChange packet = new PacketPlayOutBlockChange(i, j, k, world);
        block = Blocks.AIR;
        data = 0;
        player.playerConnection.sendPacket(packet);
      }
      
      event = new BlockBreakEvent(block, player.getBukkitEntity());
      

      event.setCancelled((gamemode.isAdventure()) && (!player.d(i, j, k)));
      

      event.setCancelled((event.isCancelled()) || ((gamemode.d()) && (player.be() != null) && ((player.be().getItem() instanceof ItemSword))));
      

      Block nmsBlock = world.getType(i, j, k);
      
      if ((nmsBlock != null) && (!event.isCancelled()) && (!isCreative()) && (player.a(nmsBlock)))
      {
        if ((!nmsBlock.E()) || (!EnchantmentManager.hasSilkTouchEnchantment(player))) {
          int data = block.getData();
          int bonusLevel = EnchantmentManager.getBonusBlockLootEnchantmentLevel(player);
          
          event.setExpToDrop(nmsBlock.getExpDrop(world, data, bonusLevel));
        }
      }
      
      world.getServer().getPluginManager().callEvent(event);
      
      if (event.isCancelled())
      {
        player.playerConnection.sendPacket(new PacketPlayOutBlockChange(i, j, k, world));
        
        TileEntity tileentity = world.getTileEntity(i, j, k);
        if (tileentity != null) {
          player.playerConnection.sendPacket(tileentity.getUpdatePacket());
        }
        return false;
      }
    }
    






    Block block = world.getType(i, j, k);
    if (block == Blocks.AIR) return false;
    int l = world.getData(i, j, k);
    

    if ((block == Blocks.SKULL) && (!isCreative())) {
      block.dropNaturally(world, i, j, k, l, 1.0F, 0);
      return d(i, j, k);
    }
    

    world.a(player, 2001, i, j, k, Block.b(block) + (world.getData(i, j, k) << 12));
    boolean flag = d(i, j, k);
    
    if (isCreative()) {
      player.playerConnection.sendPacket(new PacketPlayOutBlockChange(i, j, k, world));
    } else {
      ItemStack itemstack = player.bD();
      boolean flag1 = player.a(block);
      
      if (itemstack != null) {
        itemstack.a(world, block, i, j, k, player);
        if (count == 0) {
          player.bE();
        }
      }
      
      if ((flag) && (flag1)) {
        block.a(world, player, i, j, k, l);
      }
    }
    

    if ((flag) && (event != null)) {
      block.dropExperience(world, i, j, k, event.getExpToDrop());
    }
    

    return flag;
  }
  
  public boolean useItem(EntityHuman entityhuman, World world, ItemStack itemstack)
  {
    int i = count;
    int j = itemstack.getData();
    ItemStack itemstack1 = itemstack.a(world, entityhuman);
    
    if ((itemstack1 == itemstack) && ((itemstack1 == null) || ((count == i) && (itemstack1.n() <= 0) && (itemstack1.getData() == j)))) {
      return false;
    }
    inventory.items[inventory.itemInHandIndex] = itemstack1;
    if (isCreative()) {
      count = i;
      if (itemstack1.g()) {
        itemstack1.setData(j);
      }
    }
    
    if (count == 0) {
      inventory.items[inventory.itemInHandIndex] = null;
    }
    
    if (!entityhuman.bw()) {
      ((EntityPlayer)entityhuman).updateInventory(defaultContainer);
    }
    
    return true;
  }
  

















  public boolean interact(EntityHuman entityhuman, World world, ItemStack itemstack, int i, int j, int k, int l, float f, float f1, float f2)
  {
    Block block = world.getType(i, j, k);
    boolean result = false;
    if (block != Blocks.AIR) {
      PlayerInteractEvent event = CraftEventFactory.callPlayerInteractEvent(entityhuman, Action.RIGHT_CLICK_BLOCK, i, j, k, l, itemstack);
      if (event.useInteractedBlock() == Event.Result.DENY)
      {
        if (block == Blocks.WOODEN_DOOR) {
          boolean bottom = (world.getData(i, j, k) & 0x8) == 0;
          playerConnection.sendPacket(new PacketPlayOutBlockChange(i, j + (bottom ? 1 : -1), k, world));
        }
        result = event.useItemInHand() != Event.Result.ALLOW;
      } else if ((!entityhuman.isSneaking()) || (itemstack == null)) {
        result = block.interact(world, i, j, k, entityhuman, l, f, f1, f2);
      }
      
      if ((itemstack != null) && (!result)) {
        int j1 = itemstack.getData();
        int k1 = count;
        
        result = itemstack.placeItem(entityhuman, world, i, j, k, l, f, f1, f2);
        

        if (isCreative()) {
          itemstack.setData(j1);
          count = k1;
        }
      }
      

      if ((itemstack != null) && (((!result) && (event.useItemInHand() != Event.Result.DENY)) || (event.useItemInHand() == Event.Result.ALLOW))) {
        useItem(entityhuman, world, itemstack);
      }
    }
    return result;
  }
  
  public void a(WorldServer worldserver)
  {
    world = worldserver;
  }
}
