package net.minecraft.server.v1_7_R1;

import java.io.File;
import java.net.InetSocketAddress;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import net.minecraft.util.com.mojang.authlib.GameProfile;
import org.apache.logging.log4j.Logger;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Server;
import org.bukkit.TravelAgent;
import org.bukkit.World.Environment;
import org.bukkit.craftbukkit.libs.jline.console.ConsoleReader;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_7_R1.chunkio.ChunkIOExecutor;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftEntity;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftPlayer;
import org.bukkit.entity.Player;
import org.bukkit.event.player.PlayerChangedWorldEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerLoginEvent;
import org.bukkit.event.player.PlayerLoginEvent.Result;
import org.bukkit.event.player.PlayerPortalEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.event.player.PlayerRespawnEvent;
import org.bukkit.event.player.PlayerTeleportEvent.TeleportCause;
import org.bukkit.plugin.PluginManager;
import org.bukkit.util.Vector;

public abstract class PlayerList
{
  private static final Logger d = ;
  private static final SimpleDateFormat e = new SimpleDateFormat("yyyy-MM-dd 'at' HH:mm:ss z");
  private final MinecraftServer server;
  public final List players = new java.util.concurrent.CopyOnWriteArrayList();
  private final BanList banByName = new BanList(new File("banned-players.txt"));
  private final BanList banByIP = new BanList(new File("banned-ips.txt"));
  private final Set operators = new HashSet();
  private final Set whitelist = new java.util.LinkedHashSet();
  private final Map k = net.minecraft.util.com.google.common.collect.Maps.newHashMap();
  
  public IPlayerFileData playerFileData;
  public boolean hasWhitelist;
  protected int maxPlayers;
  protected int c;
  private EnumGamemode n;
  private boolean o;
  private int p;
  private CraftServer cserver;
  
  public PlayerList(MinecraftServer minecraftserver)
  {
    server = new CraftServer(minecraftserver, this);
    console = org.bukkit.craftbukkit.v1_7_R1.command.ColouredConsoleSender.getInstance();
    reader.addCompleter(new org.bukkit.craftbukkit.v1_7_R1.command.ConsoleCommandCompleter(server));
    cserver = server;
    

    server = minecraftserver;
    banByName.setEnabled(false);
    banByIP.setEnabled(false);
    maxPlayers = 8;
  }
  
  public void a(NetworkManager networkmanager, EntityPlayer entityplayer) {
    NBTTagCompound nbttagcompound = a(entityplayer);
    
    entityplayer.spawnIn(server.getWorldServer(dimension));
    playerInteractManager.a((WorldServer)world);
    String s = "local";
    
    if (networkmanager.getSocketAddress() != null) {
      s = networkmanager.getSocketAddress().toString();
    }
    

    d.info(entityplayer.getName() + "[" + s + "] logged in with entity id " + entityplayer.getId() + " at ([" + world.worldData.getName() + "] " + locX + ", " + locY + ", " + locZ + ")");
    WorldServer worldserver = server.getWorldServer(dimension);
    ChunkCoordinates chunkcoordinates = worldserver.getSpawn();
    
    a(entityplayer, (EntityPlayer)null, worldserver);
    PlayerConnection playerconnection = new PlayerConnection(server, networkmanager, entityplayer);
    

    int maxPlayers = getMaxPlayers();
    if (maxPlayers > 60) {
      maxPlayers = 60;
    }
    playerconnection.sendPacket(new PacketPlayOutLogin(entityplayer.getId(), playerInteractManager.getGameMode(), worldserver.getWorldData().isHardcore(), worldProvider.dimension, difficulty, maxPlayers, worldserver.getWorldData().getType()));
    entityplayer.getBukkitEntity().sendSupportedChannels();
    
    playerconnection.sendPacket(new PacketPlayOutCustomPayload("MC|Brand", getServer().getServerModName().getBytes(net.minecraft.util.com.google.common.base.Charsets.UTF_8)));
    playerconnection.sendPacket(new PacketPlayOutSpawnPosition(x, y, z));
    playerconnection.sendPacket(new PacketPlayOutAbilities(abilities));
    playerconnection.sendPacket(new PacketPlayOutHeldItemSlot(inventory.itemInHandIndex));
    entityplayer.x().d();
    entityplayer.x().b(entityplayer);
    a((ScoreboardServer)worldserver.getScoreboard(), entityplayer);
    server.au();
    





    c(entityplayer);
    playerconnection.a(locX, locY, locZ, yaw, pitch);
    b(entityplayer, worldserver);
    if (server.getResourcePack().length() > 0) {
      entityplayer.a(server.getResourcePack());
    }
    
    Iterator iterator = entityplayer.getEffects().iterator();
    
    while (iterator.hasNext()) {
      MobEffect mobeffect = (MobEffect)iterator.next();
      
      playerconnection.sendPacket(new PacketPlayOutEntityEffect(entityplayer.getId(), mobeffect));
    }
    
    entityplayer.syncInventory();
    if ((nbttagcompound != null) && (nbttagcompound.hasKeyOfType("Riding", 10))) {
      Entity entity = EntityTypes.a(nbttagcompound.getCompound("Riding"), worldserver);
      
      if (entity != null) {
        o = true;
        worldserver.addEntity(entity);
        entityplayer.mount(entity);
        o = false;
      }
    }
  }
  
  public void a(ScoreboardServer scoreboardserver, EntityPlayer entityplayer) {
    HashSet hashset = new HashSet();
    Iterator iterator = scoreboardserver.getTeams().iterator();
    
    while (iterator.hasNext()) {
      ScoreboardTeam scoreboardteam = (ScoreboardTeam)iterator.next();
      
      playerConnection.sendPacket(new PacketPlayOutScoreboardTeam(scoreboardteam, 0));
    }
    
    for (int i = 0; i < 3; i++) {
      ScoreboardObjective scoreboardobjective = scoreboardserver.getObjectiveForSlot(i);
      
      if ((scoreboardobjective != null) && (!hashset.contains(scoreboardobjective))) {
        List list = scoreboardserver.getScoreboardScorePacketsForObjective(scoreboardobjective);
        Iterator iterator1 = list.iterator();
        
        while (iterator1.hasNext()) {
          Packet packet = (Packet)iterator1.next();
          
          playerConnection.sendPacket(packet);
        }
        
        hashset.add(scoreboardobjective);
      }
    }
  }
  
  public void setPlayerFileData(WorldServer[] aworldserver) {
    if (playerFileData != null) return;
    playerFileData = aworldserver[0].getDataManager().getPlayerFileData();
  }
  
  public void a(EntityPlayer entityplayer, WorldServer worldserver) {
    WorldServer worldserver1 = entityplayer.r();
    
    if (worldserver != null) {
      worldserver.getPlayerChunkMap().removePlayer(entityplayer);
    }
    
    worldserver1.getPlayerChunkMap().addPlayer(entityplayer);
    chunkProviderServer.getChunkAt((int)locX >> 4, (int)locZ >> 4);
  }
  
  public int a() {
    return PlayerChunkMap.getFurthestViewableBlock(o());
  }
  
  public NBTTagCompound a(EntityPlayer entityplayer)
  {
    NBTTagCompound nbttagcompound = ((WorldServer)server.worlds.get(0)).getWorldData().i();
    
    NBTTagCompound nbttagcompound1;
    if ((entityplayer.getName().equals(server.K())) && (nbttagcompound != null)) {
      entityplayer.f(nbttagcompound);
      NBTTagCompound nbttagcompound1 = nbttagcompound;
      d.debug("loading single player");
    } else {
      nbttagcompound1 = playerFileData.load(entityplayer);
    }
    
    return nbttagcompound1;
  }
  
  protected void b(EntityPlayer entityplayer) {
    playerFileData.save(entityplayer);
    ServerStatisticManager serverstatisticmanager = (ServerStatisticManager)k.get(entityplayer.getName());
    
    if (serverstatisticmanager != null) {
      serverstatisticmanager.b();
    }
  }
  
  public void c(EntityPlayer entityplayer) {
    cserver.detectListNameConflict(entityplayer);
    
    players.add(entityplayer);
    WorldServer worldserver = server.getWorldServer(dimension);
    

    PlayerJoinEvent playerJoinEvent = new PlayerJoinEvent(cserver.getPlayer(entityplayer), "§e" + entityplayer.getName() + " joined the game.");
    cserver.getPluginManager().callEvent(playerJoinEvent);
    
    String joinMessage = playerJoinEvent.getJoinMessage();
    
    if ((joinMessage != null) && (joinMessage.length() > 0)) {
      for (IChatBaseComponent line : org.bukkit.craftbukkit.v1_7_R1.util.CraftChatMessage.fromString(joinMessage)) {
        server.getPlayerList().sendAll(new PacketPlayOutChat(line));
      }
    }
    cserver.onPlayerJoin(playerJoinEvent.getPlayer());
    
    ChunkIOExecutor.adjustPoolSize(getPlayerCount());
    


    if ((world == worldserver) && (!players.contains(entityplayer))) {
      worldserver.addEntity(entityplayer);
      a(entityplayer, (WorldServer)null);
    }
    


    PacketPlayOutPlayerInfo packet = new PacketPlayOutPlayerInfo(listName, true, 1000);
    for (int i = 0; i < players.size(); i++) {
      EntityPlayer entityplayer1 = (EntityPlayer)players.get(i);
      
      if (entityplayer1.getBukkitEntity().canSee(entityplayer.getBukkitEntity())) {
        playerConnection.sendPacket(packet);
      }
    }
    

    for (int i = 0; i < players.size(); i++) {
      EntityPlayer entityplayer1 = (EntityPlayer)players.get(i);
      

      if (entityplayer.getBukkitEntity().canSee(entityplayer1.getBukkitEntity()))
      {


        playerConnection.sendPacket(new PacketPlayOutPlayerInfo(listName, true, ping));
      }
    }
  }
  
  public void d(EntityPlayer entityplayer) {
    entityplayer.r().getPlayerChunkMap().movePlayer(entityplayer);
  }
  
  public String disconnect(EntityPlayer entityplayer) {
    entityplayer.a(StatisticList.f);
    

    org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory.handleInventoryCloseEvent(entityplayer);
    
    PlayerQuitEvent playerQuitEvent = new PlayerQuitEvent(cserver.getPlayer(entityplayer), "§e" + entityplayer.getName() + " left the game.");
    cserver.getPluginManager().callEvent(playerQuitEvent);
    entityplayer.getBukkitEntity().disconnect(playerQuitEvent.getQuitMessage());
    
    b(entityplayer);
    WorldServer worldserver = entityplayer.r();
    
    if ((vehicle != null) && (!(vehicle instanceof EntityPlayer))) {
      worldserver.removeEntity(vehicle);
      d.debug("removing player mount");
    }
    
    worldserver.kill(entityplayer);
    worldserver.getPlayerChunkMap().removePlayer(entityplayer);
    players.remove(entityplayer);
    k.remove(entityplayer.getName());
    ChunkIOExecutor.adjustPoolSize(getPlayerCount());
    


    PacketPlayOutPlayerInfo packet = new PacketPlayOutPlayerInfo(listName, false, 9999);
    for (int i = 0; i < players.size(); i++) {
      EntityPlayer entityplayer1 = (EntityPlayer)players.get(i);
      
      if (entityplayer1.getBukkitEntity().canSee(entityplayer.getBukkitEntity())) {
        playerConnection.sendPacket(packet);
      }
    }
    
    cserver.getScoreboardManager().removePlayer(entityplayer.getBukkitEntity());
    
    return playerQuitEvent.getQuitMessage();
  }
  




  public EntityPlayer attemptLogin(LoginListener loginlistener, GameProfile gameprofile, String hostname)
  {
    java.net.SocketAddress socketaddress = networkManager.getSocketAddress();
    
    EntityPlayer entity = new EntityPlayer(server, server.getWorldServer(0), gameprofile, new PlayerInteractManager(server.getWorldServer(0)));
    Player player = entity.getBukkitEntity();
    PlayerLoginEvent event = new PlayerLoginEvent(player, hostname, ((InetSocketAddress)socketaddress).getAddress());
    
    if (banByName.isBanned(gameprofile.getName())) {
      BanEntry banentry = (BanEntry)banByName.getEntries().get(gameprofile.getName());
      String s = "You are banned from this server!\nReason: " + banentry.getReason();
      
      if (banentry.getExpires() != null) {
        s = s + "\nYour ban will be removed on " + e.format(banentry.getExpires());
      }
      

      event.disallow(PlayerLoginEvent.Result.KICK_BANNED, s);
    } else if (!isWhitelisted(gameprofile.getName()))
    {
      event.disallow(PlayerLoginEvent.Result.KICK_WHITELIST, "You are not white-listed on this server!");
    } else {
      String s1 = socketaddress.toString();
      
      s1 = s1.substring(s1.indexOf("/") + 1);
      s1 = s1.substring(0, s1.indexOf(":"));
      if (banByIP.isBanned(s1)) {
        BanEntry banentry1 = (BanEntry)banByIP.getEntries().get(s1);
        String s2 = "Your IP address is banned from this server!\nReason: " + banentry1.getReason();
        
        if (banentry1.getExpires() != null) {
          s2 = s2 + "\nYour ban will be removed on " + e.format(banentry1.getExpires());
        }
        

        event.disallow(PlayerLoginEvent.Result.KICK_BANNED, s2);

      }
      else if (players.size() >= maxPlayers) {
        event.disallow(PlayerLoginEvent.Result.KICK_FULL, "The server is full!");
      }
    }
    

    cserver.getPluginManager().callEvent(event);
    if (event.getResult() != PlayerLoginEvent.Result.ALLOWED) {
      loginlistener.disconnect(event.getKickMessage());
      return null;
    }
    
    return entity;
  }
  
  public EntityPlayer processLogin(GameProfile gameprofile, EntityPlayer player)
  {
    ArrayList arraylist = new ArrayList();
    


    for (int i = 0; i < players.size(); i++) {
      EntityPlayer entityplayer = (EntityPlayer)players.get(i);
      if (entityplayer.getName().equalsIgnoreCase(gameprofile.getName())) {
        arraylist.add(entityplayer);
      }
    }
    
    Iterator iterator = arraylist.iterator();
    
    while (iterator.hasNext()) {
      EntityPlayer entityplayer = (EntityPlayer)iterator.next();
      playerConnection.disconnect("You logged in from another location");
    }
    











    return player;
  }
  

  public EntityPlayer moveToWorld(EntityPlayer entityplayer, int i, boolean flag)
  {
    return moveToWorld(entityplayer, i, flag, null, true);
  }
  
  public EntityPlayer moveToWorld(EntityPlayer entityplayer, int i, boolean flag, Location location, boolean avoidSuffocation)
  {
    entityplayer.r().getTracker().untrackPlayer(entityplayer);
    
    entityplayer.r().getPlayerChunkMap().removePlayer(entityplayer);
    players.remove(entityplayer);
    server.getWorldServer(dimension).removeEntity(entityplayer);
    ChunkCoordinates chunkcoordinates = entityplayer.getBed();
    boolean flag1 = entityplayer.isRespawnForced();
    












    EntityPlayer entityplayer1 = entityplayer;
    org.bukkit.World fromWorld = entityplayer1.getBukkitEntity().getWorld();
    viewingCredits = false;
    

    playerConnection = playerConnection;
    entityplayer1.copyTo(entityplayer, flag);
    entityplayer1.d(entityplayer.getId());
    





    if (location == null) {
      boolean isBedSpawn = false;
      CraftWorld cworld = (CraftWorld)server.server.getWorld(spawnWorld);
      if ((cworld != null) && (chunkcoordinates != null)) {
        ChunkCoordinates chunkcoordinates1 = EntityHuman.getBed(cworld.getHandle(), chunkcoordinates, flag1);
        if (chunkcoordinates1 != null) {
          isBedSpawn = true;
          location = new Location(cworld, x + 0.5D, y, z + 0.5D);
        } else {
          entityplayer1.setRespawnPosition(null, true);
          playerConnection.sendPacket(new PacketPlayOutGameStateChange(0, 0.0F));
        }
      }
      
      if (location == null) {
        cworld = (CraftWorld)server.server.getWorlds().get(0);
        chunkcoordinates = cworld.getHandle().getSpawn();
        location = new Location(cworld, x + 0.5D, y, z + 0.5D);
      }
      
      Player respawnPlayer = cserver.getPlayer(entityplayer1);
      PlayerRespawnEvent respawnEvent = new PlayerRespawnEvent(respawnPlayer, location, isBedSpawn);
      cserver.getPluginManager().callEvent(respawnEvent);
      
      location = respawnEvent.getRespawnLocation();
      entityplayer.reset();
    } else {
      location.setWorld(server.getWorldServer(i).getWorld());
    }
    WorldServer worldserver = ((CraftWorld)location.getWorld()).getHandle();
    entityplayer1.setLocation(location.getX(), location.getY(), location.getZ(), location.getYaw(), location.getPitch());
    

    chunkProviderServer.getChunkAt((int)locX >> 4, (int)locZ >> 4);
    
    while ((avoidSuffocation) && (!worldserver.getCubes(entityplayer1, boundingBox).isEmpty())) {
      entityplayer1.setPosition(locX, locY + 1.0D, locZ);
    }
    

    byte actualDimension = (byte)worldserver.getWorld().getEnvironment().getId();
    
    playerConnection.sendPacket(new PacketPlayOutRespawn((byte)(actualDimension >= 0 ? -1 : 0), difficulty, worldserver.getWorldData().getType(), playerInteractManager.getGameMode()));
    playerConnection.sendPacket(new PacketPlayOutRespawn(actualDimension, difficulty, worldserver.getWorldData().getType(), playerInteractManager.getGameMode()));
    entityplayer1.spawnIn(worldserver);
    dead = false;
    playerConnection.teleport(new Location(worldserver.getWorld(), locX, locY, locZ, yaw, pitch));
    entityplayer1.setSneaking(false);
    ChunkCoordinates chunkcoordinates1 = worldserver.getSpawn();
    

    playerConnection.sendPacket(new PacketPlayOutSpawnPosition(x, y, z));
    playerConnection.sendPacket(new PacketPlayOutExperience(exp, expTotal, expLevel));
    b(entityplayer1, worldserver);
    

    if (!playerConnection.isDisconnected()) {
      worldserver.getPlayerChunkMap().addPlayer(entityplayer1);
      worldserver.addEntity(entityplayer1);
      players.add(entityplayer1);
    }
    
    updateClient(entityplayer1);
    entityplayer1.updateAbilities();
    Iterator iterator = entityplayer1.getEffects().iterator();
    
    while (iterator.hasNext()) {
      MobEffect mobeffect = (MobEffect)iterator.next();
      
      playerConnection.sendPacket(new PacketPlayOutEntityEffect(entityplayer1.getId(), mobeffect));
    }
    

    entityplayer1.setHealth(entityplayer1.getHealth());
    


    if (fromWorld != location.getWorld()) {
      PlayerChangedWorldEvent event = new PlayerChangedWorldEvent(entityplayer1.getBukkitEntity(), fromWorld);
      Bukkit.getServer().getPluginManager().callEvent(event);
    }
    

    if (playerConnection.isDisconnected()) {
      b(entityplayer1);
    }
    

    return entityplayer1;
  }
  
  public void changeDimension(EntityPlayer entityplayer, int i, PlayerTeleportEvent.TeleportCause cause)
  {
    WorldServer exitWorld = null;
    if (dimension < 10)
    {
      for (WorldServer world : server.worlds) {
        if (dimension == i) {
          exitWorld = world;
        }
      }
    }
    
    Location enter = entityplayer.getBukkitEntity().getLocation();
    Location exit = null;
    boolean useTravelAgent = false;
    if (exitWorld != null) {
      if ((cause == PlayerTeleportEvent.TeleportCause.END_PORTAL) && (i == 0))
      {
        exit = entityplayer.getBukkitEntity().getBedSpawnLocation();
        if ((exit == null) || (getWorld()getHandle()dimension != 0)) {
          exit = exitWorld.getWorld().getSpawnLocation();
        }
      }
      else {
        exit = calculateTarget(enter, exitWorld);
        useTravelAgent = true;
      }
    }
    
    TravelAgent agent = exit != null ? (TravelAgent)((CraftWorld)exit.getWorld()).getHandle().t() : org.bukkit.craftbukkit.v1_7_R1.CraftTravelAgent.DEFAULT;
    PlayerPortalEvent event = new PlayerPortalEvent(entityplayer.getBukkitEntity(), enter, exit, agent, cause);
    event.useTravelAgent(useTravelAgent);
    Bukkit.getServer().getPluginManager().callEvent(event);
    if ((event.isCancelled()) || (event.getTo() == null)) {
      return;
    }
    
    exit = event.useTravelAgent() ? event.getPortalTravelAgent().findOrCreate(event.getTo()) : event.getTo();
    if (exit == null) {
      return;
    }
    exitWorld = ((CraftWorld)exit.getWorld()).getHandle();
    
    Vector velocity = entityplayer.getBukkitEntity().getVelocity();
    boolean before = chunkProviderServer.forceChunkLoad;
    chunkProviderServer.forceChunkLoad = true;
    exitWorld.t().adjustExit(entityplayer, exit, velocity);
    chunkProviderServer.forceChunkLoad = before;
    
    moveToWorld(entityplayer, dimension, true, exit, false);
    if ((motX != velocity.getX()) || (motY != velocity.getY()) || (motZ != velocity.getZ())) {
      entityplayer.getBukkitEntity().setVelocity(velocity);
    }
  }
  

  public void a(Entity entity, int i, WorldServer worldserver, WorldServer worldserver1)
  {
    Location exit = calculateTarget(entity.getBukkitEntity().getLocation(), worldserver1);
    repositionEntity(entity, exit, true);
  }
  
  public Location calculateTarget(Location enter, World target)
  {
    WorldServer worldserver = ((CraftWorld)enter.getWorld()).getHandle();
    WorldServer worldserver1 = target.getWorld().getHandle();
    int i = dimension;
    
    double y = enter.getY();
    float yaw = enter.getYaw();
    float pitch = enter.getPitch();
    double d0 = enter.getX();
    double d1 = enter.getZ();
    double d2 = 8.0D;
    







    if (dimension == -1) {
      d0 /= d2;
      d1 /= d2;





    }
    else if (dimension == 0) {
      d0 *= d2;
      d1 *= d2;
    }
    else
    {
      ChunkCoordinates chunkcoordinates;
      

      ChunkCoordinates chunkcoordinates;
      

      if (i == 1)
      {
        worldserver1 = (WorldServer)server.worlds.get(0);
        chunkcoordinates = worldserver1.getSpawn();
      } else {
        chunkcoordinates = worldserver1.getDimensionSpawn();
      }
      
      d0 = x;
      y = y;
      d1 = z;
      yaw = 90.0F;
      pitch = 0.0F;
    }
    







    if (i != 1)
    {
      d0 = MathHelper.a((int)d0, -29999872, 29999872);
      d1 = MathHelper.a((int)d1, -29999872, 29999872);
    }
    











    return new Location(worldserver1.getWorld(), d0, y, d1, yaw, pitch);
  }
  
  public void repositionEntity(Entity entity, Location exit, boolean portal)
  {
    int i = dimension;
    WorldServer worldserver = (WorldServer)world;
    WorldServer worldserver1 = ((CraftWorld)exit.getWorld()).getHandle();
    









    methodProfiler.a("moving");
    entity.setPositionRotation(exit.getX(), exit.getY(), exit.getZ(), exit.getYaw(), exit.getPitch());
    if (entity.isAlive()) {
      worldserver.entityJoinedWorld(entity, false);
    }
    

































    methodProfiler.b();
    if (i != 1) {
      methodProfiler.a("placing");
      



      if (entity.isAlive())
      {

        if (portal) {
          Vector velocity = entity.getBukkitEntity().getVelocity();
          worldserver1.t().adjustExit(entity, exit, velocity);
          entity.setPositionRotation(exit.getX(), exit.getY(), exit.getZ(), exit.getYaw(), exit.getPitch());
          if ((motX != velocity.getX()) || (motY != velocity.getY()) || (motZ != velocity.getZ())) {
            entity.getBukkitEntity().setVelocity(velocity);
          }
        }
        worldserver1.addEntity(entity);
        worldserver1.entityJoinedWorld(entity, false);
      }
      
      methodProfiler.b();
    }
    
    entity.spawnIn(worldserver1);
  }
  
  public void tick()
  {
    if (++p > 600) {
      p = 0;
    }
  }
  







  public void sendAll(Packet packet)
  {
    for (int i = 0; i < players.size(); i++) {
      players.get(i)).playerConnection.sendPacket(packet);
    }
  }
  
  public void a(Packet packet, int i) {
    for (int j = 0; j < players.size(); j++) {
      EntityPlayer entityplayer = (EntityPlayer)players.get(j);
      
      if (dimension == i) {
        playerConnection.sendPacket(packet);
      }
    }
  }
  
  public String c() {
    String s = "";
    
    for (int i = 0; i < players.size(); i++) {
      if (i > 0) {
        s = s + ", ";
      }
      
      s = s + ((EntityPlayer)players.get(i)).getName();
    }
    
    return s;
  }
  
  public String[] d() {
    String[] astring = new String[players.size()];
    
    for (int i = 0; i < players.size(); i++) {
      astring[i] = ((EntityPlayer)players.get(i)).getName();
    }
    
    return astring;
  }
  
  public BanList getNameBans() {
    return banByName;
  }
  
  public BanList getIPBans() {
    return banByIP;
  }
  
  public void addOp(String s) {
    operators.add(s.toLowerCase());
    

    Player player = server.server.getPlayerExact(s);
    if (player != null) {
      player.recalculatePermissions();
    }
  }
  
  public void removeOp(String s)
  {
    operators.remove(s.toLowerCase());
    

    Player player = server.server.getPlayerExact(s);
    if (player != null) {
      player.recalculatePermissions();
    }
  }
  
  public boolean isWhitelisted(String s)
  {
    s = s.trim().toLowerCase();
    return (!hasWhitelist) || (operators.contains(s)) || (whitelist.contains(s));
  }
  
  public boolean isOp(String s)
  {
    return (operators.contains(s.trim().toLowerCase())) || ((server.L()) && (((WorldServer)server.worlds.get(0)).getWorldData().allowCommands()) && (server.K().equalsIgnoreCase(s))) || (o);
  }
  
  public EntityPlayer getPlayer(String s) {
    Iterator iterator = players.iterator();
    
    EntityPlayer entityplayer;
    do
    {
      if (!iterator.hasNext()) {
        return null;
      }
      
      entityplayer = (EntityPlayer)iterator.next();
    } while (!entityplayer.getName().equalsIgnoreCase(s));
    
    return entityplayer;
  }
  
  public List a(ChunkCoordinates chunkcoordinates, int i, int j, int k, int l, int i1, int j1, Map map, String s, String s1, World world) {
    if (players.isEmpty()) {
      return null;
    }
    Object object = new ArrayList();
    boolean flag = k < 0;
    boolean flag1 = (s != null) && (s.startsWith("!"));
    boolean flag2 = (s1 != null) && (s1.startsWith("!"));
    int k1 = i * i;
    int l1 = j * j;
    
    k = MathHelper.a(k);
    if (flag1) {
      s = s.substring(1);
    }
    
    if (flag2) {
      s1 = s1.substring(1);
    }
    
    for (int i2 = 0; i2 < players.size(); i2++) {
      EntityPlayer entityplayer = (EntityPlayer)players.get(i2);
      
      if (((world == null) || (world == world)) && ((s == null) || (flag1 != s.equalsIgnoreCase(entityplayer.getName())))) {
        if (s1 != null) {
          ScoreboardTeamBase scoreboardteambase = entityplayer.getScoreboardTeam();
          String s2 = scoreboardteambase == null ? "" : scoreboardteambase.getName();
          
          if (flag2 == s1.equalsIgnoreCase(s2)) {}



        }
        else if ((chunkcoordinates != null) && ((i > 0) || (j > 0))) {
          float f = chunkcoordinates.e(entityplayer.getChunkCoordinates());
          
          if (((i > 0) && (f < k1)) || ((j > 0) && (f > l1))) {}



        }
        else if ((a(entityplayer, map)) && ((l == EnumGamemode.NONE.a()) || (l == playerInteractManager.getGameMode().a())) && ((i1 <= 0) || (expLevel >= i1)) && (expLevel <= j1)) {
          ((List)object).add(entityplayer);
        }
      }
    }
    
    if (chunkcoordinates != null) {
      Collections.sort((List)object, new PlayerDistanceComparator(chunkcoordinates));
    }
    
    if (flag) {
      Collections.reverse((List)object);
    }
    
    if (k > 0) {
      object = ((List)object).subList(0, Math.min(k, ((List)object).size()));
    }
    
    return (List)object;
  }
  
  private boolean a(EntityHuman entityhuman, Map map)
  {
    if ((map != null) && (map.size() != 0)) {
      Iterator iterator = map.entrySet().iterator();
      
      Map.Entry entry;
      boolean flag;
      int i;
      do
      {
        if (!iterator.hasNext()) {
          return true;
        }
        
        entry = (Map.Entry)iterator.next();
        String s = (String)entry.getKey();
        
        flag = false;
        if ((s.endsWith("_min")) && (s.length() > 4)) {
          flag = true;
          s = s.substring(0, s.length() - 4);
        }
        
        Scoreboard scoreboard = entityhuman.getScoreboard();
        ScoreboardObjective scoreboardobjective = scoreboard.getObjective(s);
        
        if (scoreboardobjective == null) {
          return false;
        }
        
        ScoreboardScore scoreboardscore = entityhuman.getScoreboard().getPlayerScoreForObjective(entityhuman.getName(), scoreboardobjective);
        
        i = scoreboardscore.getScore();
        if ((i < ((Integer)entry.getValue()).intValue()) && (flag)) {
          return false;
        }
      } while ((i <= ((Integer)entry.getValue()).intValue()) || (flag));
      
      return false;
    }
    return true;
  }
  
  public void sendPacketNearby(double d0, double d1, double d2, double d3, int i, Packet packet)
  {
    sendPacketNearby((EntityHuman)null, d0, d1, d2, d3, i, packet);
  }
  
  public void sendPacketNearby(EntityHuman entityhuman, double d0, double d1, double d2, double d3, int i, Packet packet) {
    for (int j = 0; j < players.size(); j++) {
      EntityPlayer entityplayer = (EntityPlayer)players.get(j);
      

      if ((entityhuman == null) || (!(entityhuman instanceof EntityPlayer)) || (entityplayer.getBukkitEntity().canSee(((EntityPlayer)entityhuman).getBukkitEntity())))
      {



        if ((entityplayer != entityhuman) && (dimension == i)) {
          double d4 = d0 - locX;
          double d5 = d1 - locY;
          double d6 = d2 - locZ;
          
          if (d4 * d4 + d5 * d5 + d6 * d6 < d3 * d3)
            playerConnection.sendPacket(packet);
        }
      }
    }
  }
  
  public void savePlayers() {
    for (int i = 0; i < players.size(); i++) {
      b((EntityPlayer)players.get(i));
    }
  }
  
  public void addWhitelist(String s) {
    whitelist.add(s);
  }
  
  public void removeWhitelist(String s) {
    whitelist.remove(s);
  }
  
  public Set getWhitelisted() {
    return whitelist;
  }
  
  public Set getOPs() {
    return operators;
  }
  
  public void reloadWhitelist() {}
  
  public void b(EntityPlayer entityplayer, WorldServer worldserver) {
    playerConnection.sendPacket(new PacketPlayOutUpdateTime(worldserver.getTime(), worldserver.getDayTime(), worldserver.getGameRules().getBoolean("doDaylightCycle")));
    if (worldserver.P())
    {



      entityplayer.setPlayerWeather(org.bukkit.WeatherType.DOWNFALL, false);
    }
  }
  
  public void updateClient(EntityPlayer entityplayer)
  {
    entityplayer.updateInventory(defaultContainer);
    entityplayer.getBukkitEntity().updateScaledHealth();
    playerConnection.sendPacket(new PacketPlayOutHeldItemSlot(inventory.itemInHandIndex));
  }
  
  public int getPlayerCount() {
    return players.size();
  }
  
  public int getMaxPlayers() {
    return maxPlayers;
  }
  
  public String[] getSeenPlayers()
  {
    return ((WorldServer)server.worlds.get(0)).getDataManager().getPlayerFileData().getSeenPlayers();
  }
  
  public boolean getHasWhitelist() {
    return hasWhitelist;
  }
  
  public void setHasWhitelist(boolean flag) {
    hasWhitelist = flag;
  }
  
  public List h(String s) {
    ArrayList arraylist = new ArrayList();
    Iterator iterator = players.iterator();
    
    while (iterator.hasNext()) {
      EntityPlayer entityplayer = (EntityPlayer)iterator.next();
      
      if (entityplayer.s().equals(s)) {
        arraylist.add(entityplayer);
      }
    }
    
    return arraylist;
  }
  
  public int o() {
    return c;
  }
  
  public MinecraftServer getServer() {
    return server;
  }
  
  public NBTTagCompound q() {
    return null;
  }
  
  private void a(EntityPlayer entityplayer, EntityPlayer entityplayer1, World world) {
    if (entityplayer1 != null) {
      playerInteractManager.setGameMode(playerInteractManager.getGameMode());
    } else if (n != null) {
      playerInteractManager.setGameMode(n);
    }
    
    playerInteractManager.b(world.getWorldData().getGameType());
  }
  
  public void r() {
    for (int i = 0; i < players.size(); i++) {
      players.get(i)).playerConnection.disconnect(server.server.getShutdownMessage());
    }
  }
  
  public void sendMessage(IChatBaseComponent[] ichatbasecomponent)
  {
    for (IChatBaseComponent component : ichatbasecomponent) {
      sendMessage(component, true);
    }
  }
  
  public void sendMessage(IChatBaseComponent ichatbasecomponent, boolean flag)
  {
    server.sendMessage(ichatbasecomponent);
    sendAll(new PacketPlayOutChat(ichatbasecomponent, flag));
  }
  
  public void sendMessage(IChatBaseComponent ichatbasecomponent) {
    sendMessage(ichatbasecomponent, true);
  }
  
  public ServerStatisticManager i(String s) {
    ServerStatisticManager serverstatisticmanager = (ServerStatisticManager)k.get(s);
    
    if (serverstatisticmanager == null) {
      serverstatisticmanager = new ServerStatisticManager(server, new File(server.getWorldServer(0).getDataManager().getDirectory(), "stats/" + s + ".json"));
      serverstatisticmanager.a();
      k.put(s, serverstatisticmanager);
    }
    
    return serverstatisticmanager;
  }
}
