package net.minecraft.server.v1_7_R1;

import java.math.BigInteger;
import java.net.InetSocketAddress;
import net.minecraft.util.com.mojang.authlib.GameProfile;
import net.minecraft.util.com.mojang.authlib.exceptions.AuthenticationUnavailableException;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.util.Waitable;
import org.bukkit.event.player.AsyncPlayerPreLoginEvent;
import org.bukkit.event.player.PlayerPreLoginEvent;
import org.bukkit.event.player.PlayerPreLoginEvent.Result;

class ThreadPlayerLookupUUID extends Thread
{
  final LoginListener a;
  
  ThreadPlayerLookupUUID(LoginListener loginlistener, String s)
  {
    super(s);
    a = loginlistener;
  }
  
  public void run() {
    try {
      String s = new BigInteger(MinecraftEncryption.a(LoginListener.a(a), LoginListener.b(a).I().getPublic(), LoginListener.c(a))).toString(16);
      
      LoginListener.a(a, LoginListener.b(a).as().hasJoinedServer(new GameProfile((String)null, LoginListener.d(a).getName()), s));
      if (LoginListener.d(a) != null)
      {
        if (!a.networkManager.d()) {
          return;
        }
        
        String playerName = LoginListener.d(a).getName();
        java.net.InetAddress address = ((InetSocketAddress)a.networkManager.getSocketAddress()).getAddress();
        final CraftServer server = ba).server;
        
        AsyncPlayerPreLoginEvent asyncEvent = new AsyncPlayerPreLoginEvent(playerName, address);
        server.getPluginManager().callEvent(asyncEvent);
        
        if (PlayerPreLoginEvent.getHandlerList().getRegisteredListeners().length != 0) {
          final PlayerPreLoginEvent event = new PlayerPreLoginEvent(playerName, address);
          if (asyncEvent.getResult() != PlayerPreLoginEvent.Result.ALLOWED) {
            event.disallow(asyncEvent.getResult(), asyncEvent.getKickMessage());
          }
          Waitable<PlayerPreLoginEvent.Result> waitable = new Waitable()
          {
            protected PlayerPreLoginEvent.Result evaluate() {
              server.getPluginManager().callEvent(event);
              return event.getResult();
            }
          };
          ba).processQueue.add(waitable);
          if (waitable.get() != PlayerPreLoginEvent.Result.ALLOWED) {
            a.disconnect(event.getKickMessage());
            return;
          }
        }
        else if (asyncEvent.getLoginResult() != org.bukkit.event.player.AsyncPlayerPreLoginEvent.Result.ALLOWED) {
          a.disconnect(asyncEvent.getKickMessage());
          return;
        }
        


        LoginListener.e().info("UUID of player " + LoginListener.d(a).getName() + " is " + LoginListener.d(a).getId());
        LoginListener.a(a, EnumProtocolState.READY_TO_ACCEPT);
      } else {
        a.disconnect("Failed to verify username!");
        LoginListener.e().error("Username '" + LoginListener.d(a).getName() + "' tried to join with an invalid session");
      }
    } catch (AuthenticationUnavailableException authenticationunavailableexception) {
      a.disconnect("Authentication servers are down. Please try again later, sorry!");
      LoginListener.e().error("Couldn't verify username because servers are unavailable");
    }
    catch (Exception exception) {
      a.disconnect("Failed to verify username!");
      ba).server.getLogger().log(java.util.logging.Level.WARNING, "Exception verifying " + LoginListener.d(a).getName(), exception);
    }
  }
}
