package net.minecraft.server.v1_7_R1;

import java.util.HashMap;
import java.util.Map;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.bukkit.block.BlockState;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.inventory.InventoryHolder;


public class TileEntity
{
  private static final Logger a = ;
  private static Map i = new HashMap();
  private static Map j = new HashMap();
  protected World world;
  public int x;
  public int y;
  public int z;
  protected boolean f;
  public int g = -1;
  
  public Block h;
  
  private static void a(Class oclass, String s)
  {
    if (i.containsKey(s)) {
      throw new IllegalArgumentException("Duplicate id: " + s);
    }
    i.put(s, oclass);
    j.put(oclass, s);
  }
  
  public World getWorld()
  {
    return world;
  }
  
  public void a(World world) {
    this.world = world;
  }
  
  public boolean o() {
    return world != null;
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    x = nbttagcompound.getInt("x");
    y = nbttagcompound.getInt("y");
    z = nbttagcompound.getInt("z");
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    String s = (String)j.get(getClass());
    
    if (s == null) {
      throw new RuntimeException(getClass() + " is missing a mapping! This is a bug!");
    }
    nbttagcompound.setString("id", s);
    nbttagcompound.setInt("x", x);
    nbttagcompound.setInt("y", y);
    nbttagcompound.setInt("z", z);
  }
  


  public static TileEntity c(NBTTagCompound nbttagcompound)
  {
    TileEntity tileentity = null;
    try
    {
      Class oclass = (Class)i.get(nbttagcompound.getString("id"));
      
      if (oclass != null) {
        tileentity = (TileEntity)oclass.newInstance();
      }
    } catch (Exception exception) {
      exception.printStackTrace();
    }
    
    if (tileentity != null) {
      tileentity.a(nbttagcompound);
    } else {
      a.warn("Skipping BlockEntity with id " + nbttagcompound.getString("id"));
    }
    
    return tileentity;
  }
  
  public int p() {
    if (g == -1) {
      g = world.getData(x, y, z);
    }
    
    return g;
  }
  
  public void update() {
    if (world != null) {
      g = world.getData(x, y, z);
      world.b(x, y, z, this);
      if (q() != Blocks.AIR) {
        world.f(x, y, z, q());
      }
    }
  }
  
  public Block q() {
    if (h == null) {
      h = world.getType(x, y, z);
    }
    
    return h;
  }
  
  public Packet getUpdatePacket() {
    return null;
  }
  
  public boolean r() {
    return f;
  }
  
  public void s() {
    f = true;
  }
  
  public void t() {
    f = false;
  }
  
  public boolean c(int i, int j) {
    return false;
  }
  
  public void u() {
    h = null;
    g = -1;
  }
  
  public void a(CrashReportSystemDetails crashreportsystemdetails) {
    crashreportsystemdetails.a("Name", new CrashReportTileEntityName(this));
    CrashReportSystemDetails.a(crashreportsystemdetails, x, y, z, q(), p());
    crashreportsystemdetails.a("Actual block type", new CrashReportTileEntityType(this));
    crashreportsystemdetails.a("Actual block data value", new CrashReportTileEntityData(this));
  }
  
  static Map v() {
    return j;
  }
  
  static {
    a(TileEntityFurnace.class, "Furnace");
    a(TileEntityChest.class, "Chest");
    a(TileEntityEnderChest.class, "EnderChest");
    a(TileEntityRecordPlayer.class, "RecordPlayer");
    a(TileEntityDispenser.class, "Trap");
    a(TileEntityDropper.class, "Dropper");
    a(TileEntitySign.class, "Sign");
    a(TileEntityMobSpawner.class, "MobSpawner");
    a(TileEntityNote.class, "Music");
    a(TileEntityPiston.class, "Piston");
    a(TileEntityBrewingStand.class, "Cauldron");
    a(TileEntityEnchantTable.class, "EnchantTable");
    a(TileEntityEnderPortal.class, "Airportal");
    a(TileEntityCommand.class, "Control");
    a(TileEntityBeacon.class, "Beacon");
    a(TileEntitySkull.class, "Skull");
    a(TileEntityLightDetector.class, "DLDetector");
    a(TileEntityHopper.class, "Hopper");
    a(TileEntityComparator.class, "Comparator");
    a(TileEntityFlowerPot.class, "FlowerPot");
  }
  
  public InventoryHolder getOwner()
  {
    BlockState state = world.getWorld().getBlockAt(x, y, z).getState();
    if ((state instanceof InventoryHolder)) return (InventoryHolder)state;
    return null;
  }
  
  public void h() {}
}
