package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Random;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftHumanEntity;
import org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory;
import org.bukkit.entity.HumanEntity;

public class TileEntityChest extends TileEntity implements IInventory
{
  private ItemStack[] items = new ItemStack[27];
  public boolean a;
  public TileEntityChest i;
  public TileEntityChest j;
  public TileEntityChest k;
  public TileEntityChest l;
  public float m;
  public float n;
  public int o;
  private int ticks;
  private int r = -1;
  

  private String s;
  

  public List<HumanEntity> transaction = new ArrayList();
  private int maxStack = 64;
  
  public ItemStack[] getContents() {
    return items;
  }
  
  public void onOpen(CraftHumanEntity who) {
    transaction.add(who);
  }
  
  public void onClose(CraftHumanEntity who) {
    transaction.remove(who);
  }
  
  public List<HumanEntity> getViewers() {
    return transaction;
  }
  
  public void setMaxStackSize(int size) {
    maxStack = size;
  }
  
  public int getSize()
  {
    return 27;
  }
  
  public ItemStack getItem(int i) {
    return items[i];
  }
  
  public ItemStack splitStack(int i, int j) {
    if (items[i] != null)
    {

      if (items[i].count <= j) {
        ItemStack itemstack = items[i];
        items[i] = null;
        update();
        return itemstack;
      }
      ItemStack itemstack = items[i].a(j);
      if (items[i].count == 0) {
        items[i] = null;
      }
      
      update();
      return itemstack;
    }
    
    return null;
  }
  
  public ItemStack splitWithoutUpdate(int i)
  {
    if (items[i] != null) {
      ItemStack itemstack = items[i];
      
      items[i] = null;
      return itemstack;
    }
    return null;
  }
  
  public void setItem(int i, ItemStack itemstack)
  {
    items[i] = itemstack;
    if ((itemstack != null) && (count > getMaxStackSize())) {
      count = getMaxStackSize();
    }
    
    update();
  }
  
  public String getInventoryName() {
    return k_() ? s : "container.chest";
  }
  
  public boolean k_() {
    return (s != null) && (s.length() > 0);
  }
  
  public void a(String s) {
    this.s = s;
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    NBTTagList nbttaglist = nbttagcompound.getList("Items", 10);
    
    items = new ItemStack[getSize()];
    if (nbttagcompound.hasKeyOfType("CustomName", 8)) {
      s = nbttagcompound.getString("CustomName");
    }
    
    for (int i = 0; i < nbttaglist.size(); i++) {
      NBTTagCompound nbttagcompound1 = nbttaglist.get(i);
      int j = nbttagcompound1.getByte("Slot") & 0xFF;
      
      if ((j >= 0) && (j < items.length)) {
        items[j] = ItemStack.createStack(nbttagcompound1);
      }
    }
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    NBTTagList nbttaglist = new NBTTagList();
    
    for (int i = 0; i < items.length; i++) {
      if (items[i] != null) {
        NBTTagCompound nbttagcompound1 = new NBTTagCompound();
        
        nbttagcompound1.setByte("Slot", (byte)i);
        items[i].save(nbttagcompound1);
        nbttaglist.add(nbttagcompound1);
      }
    }
    
    nbttagcompound.set("Items", nbttaglist);
    if (k_()) {
      nbttagcompound.setString("CustomName", s);
    }
  }
  
  public int getMaxStackSize() {
    return maxStack;
  }
  
  public boolean a(EntityHuman entityhuman) {
    if (world == null) return true;
    return world.getTileEntity(x, y, z) == this;
  }
  
  public void u() {
    super.u();
    a = false;
  }
  
  private void a(TileEntityChest tileentitychest, int i) {
    if (tileentitychest.r()) {
      a = false;
    } else if (a) {
      switch (i) {
      case 0: 
        if (l != tileentitychest) {
          a = false;
        }
        
        break;
      case 1: 
        if (k != tileentitychest) {
          a = false;
        }
        
        break;
      case 2: 
        if (this.i != tileentitychest) {
          a = false;
        }
        
        break;
      case 3: 
        if (j != tileentitychest)
          a = false;
        break;
      }
    }
  }
  
  public void i() {
    if (!a) {
      a = true;
      i = null;
      j = null;
      k = null;
      l = null;
      if (a(x - 1, y, z)) {
        k = ((TileEntityChest)world.getTileEntity(x - 1, y, z));
      }
      
      if (a(x + 1, y, z)) {
        j = ((TileEntityChest)world.getTileEntity(x + 1, y, z));
      }
      
      if (a(x, y, z - 1)) {
        i = ((TileEntityChest)world.getTileEntity(x, y, z - 1));
      }
      
      if (a(x, y, z + 1)) {
        l = ((TileEntityChest)world.getTileEntity(x, y, z + 1));
      }
      
      if (i != null) {
        i.a(this, 0);
      }
      
      if (l != null) {
        l.a(this, 2);
      }
      
      if (j != null) {
        j.a(this, 1);
      }
      
      if (k != null) {
        k.a(this, 3);
      }
    }
  }
  
  private boolean a(int i, int j, int k) {
    Block block = world.getType(i, j, k);
    
    return ((block instanceof BlockChest)) && (a == j());
  }
  
  public void h() {
    super.h();
    if (world == null) return;
    i();
    ticks += 1;
    

    if ((!world.isStatic) && (o != 0) && ((ticks + x + y + z) % 200 == 0)) {
      o = 0;
      float f = 5.0F;
      List list = world.a(EntityHuman.class, AxisAlignedBB.a().a(x - f, y - f, z - f, x + 1 + f, y + 1 + f, z + 1 + f));
      Iterator iterator = list.iterator();
      
      while (iterator.hasNext()) {
        EntityHuman entityhuman = (EntityHuman)iterator.next();
        
        if ((activeContainer instanceof ContainerChest)) {
          IInventory iinventory = ((ContainerChest)activeContainer).e();
          
          if ((iinventory == this) || (((iinventory instanceof InventoryLargeChest)) && (((InventoryLargeChest)iinventory).a(this)))) {
            o += 1;
          }
        }
      }
    }
    
    n = m;
    float f = 0.1F;
    

    if ((o > 0) && (m == 0.0F) && (i == null) && (k == null)) {
      double d1 = x + 0.5D;
      
      double d0 = z + 0.5D;
      if (l != null) {
        d0 += 0.5D;
      }
      
      if (j != null) {
        d1 += 0.5D;
      }
      
      world.makeSound(d1, y + 0.5D, d0, "random.chestopen", 0.5F, world.random.nextFloat() * 0.1F + 0.9F);
    }
    
    if (((o == 0) && (m > 0.0F)) || ((o > 0) && (m < 1.0F))) {
      float f1 = m;
      
      if (o > 0) {
        m += f;
      } else {
        m -= f;
      }
      
      if (m > 1.0F) {
        m = 1.0F;
      }
      
      float f2 = 0.5F;
      
      if ((m < f2) && (f1 >= f2) && (i == null) && (k == null)) {
        double d0 = x + 0.5D;
        double d2 = z + 0.5D;
        
        if (l != null) {
          d2 += 0.5D;
        }
        
        if (j != null) {
          d0 += 0.5D;
        }
        
        world.makeSound(d0, y + 0.5D, d2, "random.chestclosed", 0.5F, world.random.nextFloat() * 0.1F + 0.9F);
      }
      
      if (m < 0.0F) {
        m = 0.0F;
      }
    }
  }
  
  public boolean c(int i, int j) {
    if (i == 1) {
      o = j;
      return true;
    }
    return super.c(i, j);
  }
  
  public void startOpen()
  {
    if (o < 0) {
      o = 0;
    }
    
    int oldPower = Math.max(0, Math.min(15, o));
    
    o += 1;
    if (world == null) return;
    world.playNote(x, y, z, q(), 1, o);
    

    if (q() == Blocks.TRAPPED_CHEST) {
      int newPower = Math.max(0, Math.min(15, o));
      
      if (oldPower != newPower) {
        CraftEventFactory.callRedstoneChange(world, x, y, z, oldPower, newPower);
      }
    }
    

    world.applyPhysics(x, y, z, q());
    world.applyPhysics(x, y - 1, z, q());
  }
  
  public void l_() {
    if ((q() instanceof BlockChest)) {
      int oldPower = Math.max(0, Math.min(15, o));
      
      o -= 1;
      if (world == null) return;
      world.playNote(x, y, z, q(), 1, o);
      

      if (q() == Blocks.TRAPPED_CHEST) {
        int newPower = Math.max(0, Math.min(15, o));
        
        if (oldPower != newPower) {
          CraftEventFactory.callRedstoneChange(world, x, y, z, oldPower, newPower);
        }
      }
      

      world.applyPhysics(x, y, z, q());
      world.applyPhysics(x, y - 1, z, q());
    }
  }
  
  public boolean b(int i, ItemStack itemstack) {
    return true;
  }
  
  public void s() {
    super.s();
    u();
    i();
  }
  
  public int j() {
    if (r == -1) {
      if ((world == null) || (!(q() instanceof BlockChest))) {
        return 0;
      }
      
      r = q()a;
    }
    
    return r;
  }
}
