package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftHumanEntity;
import org.bukkit.entity.HumanEntity;


public class TileEntityDispenser
  extends TileEntity
  implements IInventory
{
  private ItemStack[] items = new ItemStack[9];
  private Random j = new Random();
  
  protected String a;
  
  public List<HumanEntity> transaction = new ArrayList();
  private int maxStack = 64;
  
  public ItemStack[] getContents() {
    return items;
  }
  
  public void onOpen(CraftHumanEntity who) {
    transaction.add(who);
  }
  
  public void onClose(CraftHumanEntity who) {
    transaction.remove(who);
  }
  
  public List<HumanEntity> getViewers() {
    return transaction;
  }
  
  public void setMaxStackSize(int size) {
    maxStack = size;
  }
  


  public int getSize()
  {
    return 9;
  }
  
  public ItemStack getItem(int i) {
    return items[i];
  }
  
  public ItemStack splitStack(int i, int j) {
    if (items[i] != null)
    {

      if (items[i].count <= j) {
        ItemStack itemstack = items[i];
        items[i] = null;
        update();
        return itemstack;
      }
      ItemStack itemstack = items[i].a(j);
      if (items[i].count == 0) {
        items[i] = null;
      }
      
      update();
      return itemstack;
    }
    
    return null;
  }
  
  public ItemStack splitWithoutUpdate(int i)
  {
    if (items[i] != null) {
      ItemStack itemstack = items[i];
      
      items[i] = null;
      return itemstack;
    }
    return null;
  }
  
  public int i()
  {
    int i = -1;
    int j = 1;
    
    for (int k = 0; k < items.length; k++) {
      if ((items[k] != null) && (this.j.nextInt(j++) == 0) && 
        (items[k].count != 0)) {
        i = k;
      }
    }
    
    return i;
  }
  
  public void setItem(int i, ItemStack itemstack) {
    items[i] = itemstack;
    if ((itemstack != null) && (count > getMaxStackSize())) {
      count = getMaxStackSize();
    }
    
    update();
  }
  
  public int addItem(ItemStack itemstack) {
    for (int i = 0; i < items.length; i++) {
      if ((items[i] == null) || (items[i].getItem() == null)) {
        setItem(i, itemstack);
        return i;
      }
    }
    
    return -1;
  }
  
  public String getInventoryName() {
    return k_() ? a : "container.dispenser";
  }
  
  public void a(String s) {
    a = s;
  }
  
  public boolean k_() {
    return a != null;
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    NBTTagList nbttaglist = nbttagcompound.getList("Items", 10);
    
    items = new ItemStack[getSize()];
    
    for (int i = 0; i < nbttaglist.size(); i++) {
      NBTTagCompound nbttagcompound1 = nbttaglist.get(i);
      int j = nbttagcompound1.getByte("Slot") & 0xFF;
      
      if ((j >= 0) && (j < items.length)) {
        items[j] = ItemStack.createStack(nbttagcompound1);
      }
    }
    
    if (nbttagcompound.hasKeyOfType("CustomName", 8)) {
      a = nbttagcompound.getString("CustomName");
    }
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    NBTTagList nbttaglist = new NBTTagList();
    
    for (int i = 0; i < items.length; i++) {
      if (items[i] != null) {
        NBTTagCompound nbttagcompound1 = new NBTTagCompound();
        
        nbttagcompound1.setByte("Slot", (byte)i);
        items[i].save(nbttagcompound1);
        nbttaglist.add(nbttagcompound1);
      }
    }
    
    nbttagcompound.set("Items", nbttaglist);
    if (k_()) {
      nbttagcompound.setString("CustomName", a);
    }
  }
  
  public int getMaxStackSize() {
    return maxStack;
  }
  
  public boolean a(EntityHuman entityhuman) {
    return world.getTileEntity(x, y, z) == this;
  }
  
  public void startOpen() {}
  
  public void l_() {}
  
  public boolean b(int i, ItemStack itemstack) {
    return true;
  }
}
