package net.minecraft.server.v1_7_R1;

import java.util.List;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftHumanEntity;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack;
import org.bukkit.entity.HumanEntity;
import org.bukkit.event.inventory.FurnaceBurnEvent;
import org.bukkit.event.inventory.FurnaceSmeltEvent;
import org.bukkit.plugin.PluginManager;

public class TileEntityFurnace extends TileEntity implements IWorldInventory
{
  private static final int[] k = { 0 };
  private static final int[] l = { 2, 1 };
  private static final int[] m = { 1 };
  private ItemStack[] items = new ItemStack[3];
  
  public int burnTime;
  
  public int ticksForCurrentFuel;
  public int cookTime;
  private String o;
  private int lastTick = MinecraftServer.currentTick;
  private int maxStack = 64;
  public List<HumanEntity> transaction = new java.util.ArrayList();
  
  public ItemStack[] getContents() {
    return items;
  }
  
  public void onOpen(CraftHumanEntity who) {
    transaction.add(who);
  }
  
  public void onClose(CraftHumanEntity who) {
    transaction.remove(who);
  }
  
  public List<HumanEntity> getViewers() {
    return transaction;
  }
  
  public void setMaxStackSize(int size) {
    maxStack = size;
  }
  


  public int getSize()
  {
    return items.length;
  }
  
  public ItemStack getItem(int i) {
    return items[i];
  }
  
  public ItemStack splitStack(int i, int j) {
    if (items[i] != null)
    {

      if (items[i].count <= j) {
        ItemStack itemstack = items[i];
        items[i] = null;
        return itemstack;
      }
      ItemStack itemstack = items[i].a(j);
      if (items[i].count == 0) {
        items[i] = null;
      }
      
      return itemstack;
    }
    
    return null;
  }
  
  public ItemStack splitWithoutUpdate(int i)
  {
    if (items[i] != null) {
      ItemStack itemstack = items[i];
      
      items[i] = null;
      return itemstack;
    }
    return null;
  }
  
  public void setItem(int i, ItemStack itemstack)
  {
    items[i] = itemstack;
    if ((itemstack != null) && (count > getMaxStackSize())) {
      count = getMaxStackSize();
    }
  }
  
  public String getInventoryName() {
    return k_() ? o : "container.furnace";
  }
  
  public boolean k_() {
    return (o != null) && (o.length() > 0);
  }
  
  public void a(String s) {
    o = s;
  }
  
  public void a(NBTTagCompound nbttagcompound) {
    super.a(nbttagcompound);
    NBTTagList nbttaglist = nbttagcompound.getList("Items", 10);
    
    items = new ItemStack[getSize()];
    
    for (int i = 0; i < nbttaglist.size(); i++) {
      NBTTagCompound nbttagcompound1 = nbttaglist.get(i);
      byte b0 = nbttagcompound1.getByte("Slot");
      
      if ((b0 >= 0) && (b0 < items.length)) {
        items[b0] = ItemStack.createStack(nbttagcompound1);
      }
    }
    
    burnTime = nbttagcompound.getShort("BurnTime");
    cookTime = nbttagcompound.getShort("CookTime");
    ticksForCurrentFuel = fuelTime(items[1]);
    if (nbttagcompound.hasKeyOfType("CustomName", 8)) {
      o = nbttagcompound.getString("CustomName");
    }
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    nbttagcompound.setShort("BurnTime", (short)burnTime);
    nbttagcompound.setShort("CookTime", (short)cookTime);
    NBTTagList nbttaglist = new NBTTagList();
    
    for (int i = 0; i < items.length; i++) {
      if (items[i] != null) {
        NBTTagCompound nbttagcompound1 = new NBTTagCompound();
        
        nbttagcompound1.setByte("Slot", (byte)i);
        items[i].save(nbttagcompound1);
        nbttaglist.add(nbttagcompound1);
      }
    }
    
    nbttagcompound.set("Items", nbttaglist);
    if (k_()) {
      nbttagcompound.setString("CustomName", o);
    }
  }
  
  public int getMaxStackSize() {
    return maxStack;
  }
  
  public boolean isBurning() {
    return burnTime > 0;
  }
  
  public void h() {
    boolean flag = burnTime > 0;
    boolean flag1 = false;
    

    int elapsedTicks = MinecraftServer.currentTick - lastTick;
    lastTick = MinecraftServer.currentTick;
    

    if ((isBurning()) && (canBurn())) {
      cookTime += elapsedTicks;
      if (cookTime >= 200) {
        cookTime %= 200;
        burn();
        flag1 = true;
      }
    } else {
      cookTime = 0;
    }
    

    if (burnTime > 0) {
      burnTime -= elapsedTicks;
    }
    
    if (!world.isStatic)
    {
      if ((burnTime <= 0) && (canBurn()) && (items[1] != null)) {
        CraftItemStack fuel = CraftItemStack.asCraftMirror(items[1]);
        
        FurnaceBurnEvent furnaceBurnEvent = new FurnaceBurnEvent(world.getWorld().getBlockAt(x, y, z), fuel, fuelTime(items[1]));
        world.getServer().getPluginManager().callEvent(furnaceBurnEvent);
        
        if (furnaceBurnEvent.isCancelled()) {
          return;
        }
        
        ticksForCurrentFuel = furnaceBurnEvent.getBurnTime();
        burnTime += ticksForCurrentFuel;
        if ((burnTime > 0) && (furnaceBurnEvent.isBurning()))
        {
          flag1 = true;
          if (items[1] != null) {
            items[1].count -= 1;
            if (items[1].count == 0) {
              Item item = items[1].getItem().t();
              
              items[1] = (item != null ? new ItemStack(item) : null);
            }
          }
        }
      }
      













      if (flag != burnTime > 0) {
        flag1 = true;
        BlockFurnace.a(burnTime > 0, world, x, y, z);
      }
    }
    
    if (flag1) {
      update();
    }
  }
  
  private boolean canBurn() {
    if (items[0] == null) {
      return false;
    }
    ItemStack itemstack = RecipesFurnace.getInstance().getResult(items[0]);
    

    return itemstack != null;
  }
  
  public void burn()
  {
    if (canBurn()) {
      ItemStack itemstack = RecipesFurnace.getInstance().getResult(items[0]);
      

      CraftItemStack source = CraftItemStack.asCraftMirror(items[0]);
      org.bukkit.inventory.ItemStack result = CraftItemStack.asBukkitCopy(itemstack);
      
      FurnaceSmeltEvent furnaceSmeltEvent = new FurnaceSmeltEvent(world.getWorld().getBlockAt(x, y, z), source, result);
      world.getServer().getPluginManager().callEvent(furnaceSmeltEvent);
      
      if (furnaceSmeltEvent.isCancelled()) {
        return;
      }
      
      result = furnaceSmeltEvent.getResult();
      itemstack = CraftItemStack.asNMSCopy(result);
      
      if (itemstack != null) {
        if (items[2] == null) {
          items[2] = itemstack;
        } else if (CraftItemStack.asCraftMirror(items[2]).isSimilar(result)) {
          items[2].count += count;
        } else {
          return;
        }
      }
      

      items[0].count -= 1;
      if (items[0].count <= 0) {
        items[0] = null;
      }
    }
  }
  
  public static int fuelTime(ItemStack itemstack) {
    if (itemstack == null) {
      return 0;
    }
    Item item = itemstack.getItem();
    
    if (((item instanceof ItemBlock)) && (Block.a(item) != Blocks.AIR)) {
      Block block = Block.a(item);
      
      if (block == Blocks.WOOD_STEP) {
        return 150;
      }
      
      if (block.getMaterial() == Material.WOOD) {
        return 300;
      }
      
      if (block == Blocks.COAL_BLOCK) {
        return 16000;
      }
    }
    
    return item == Items.BLAZE_ROD ? 2400 : item == Item.getItemOf(Blocks.SAPLING) ? 100 : item == Items.LAVA_BUCKET ? 20000 : item == Items.COAL ? 1600 : item == Items.STICK ? 100 : ((item instanceof ItemHoe)) && (((ItemHoe)item).i().equals("WOOD")) ? 200 : ((item instanceof ItemSword)) && (((ItemSword)item).j().equals("WOOD")) ? 200 : ((item instanceof ItemTool)) && (((ItemTool)item).j().equals("WOOD")) ? 200 : 0;
  }
  
  public static boolean isFuel(ItemStack itemstack)
  {
    return fuelTime(itemstack) > 0;
  }
  
  public boolean a(EntityHuman entityhuman) {
    return world.getTileEntity(x, y, z) == this;
  }
  
  public void startOpen() {}
  
  public void l_() {}
  
  public boolean b(int i, ItemStack itemstack) {
    return i != 2;
  }
  
  public int[] getSlotsForFace(int i) {
    return i == 1 ? k : i == 0 ? l : m;
  }
  
  public boolean canPlaceItemThroughFace(int i, ItemStack itemstack, int j) {
    return b(i, itemstack);
  }
  
  public boolean canTakeItemThroughFace(int i, ItemStack itemstack, int j) {
    return (j != 0) || (i != 1) || (itemstack.getItem() == Items.BUCKET);
  }
}
