package net.minecraft.server.v1_7_R1;

import java.util.List;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftHumanEntity;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftInventoryDoubleChest;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack;
import org.bukkit.event.inventory.InventoryMoveItemEvent;
import org.bukkit.event.inventory.InventoryPickupItemEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.InventoryHolder;
import org.bukkit.plugin.PluginManager;

public class TileEntityHopper extends TileEntity implements IHopper
{
  private ItemStack[] a = new ItemStack[5];
  private String i;
  private int j = -1;
  

  public List<org.bukkit.entity.HumanEntity> transaction = new java.util.ArrayList();
  private int maxStack = 64;
  
  public ItemStack[] getContents() {
    return a;
  }
  
  public void onOpen(CraftHumanEntity who) {
    transaction.add(who);
  }
  
  public void onClose(CraftHumanEntity who) {
    transaction.remove(who);
  }
  
  public List<org.bukkit.entity.HumanEntity> getViewers() {
    return transaction;
  }
  
  public void setMaxStackSize(int size) {
    maxStack = size;
  }
  


  public void a(NBTTagCompound nbttagcompound)
  {
    super.a(nbttagcompound);
    NBTTagList nbttaglist = nbttagcompound.getList("Items", 10);
    
    a = new ItemStack[getSize()];
    if (nbttagcompound.hasKeyOfType("CustomName", 8)) {
      this.i = nbttagcompound.getString("CustomName");
    }
    
    j = nbttagcompound.getInt("TransferCooldown");
    
    for (int i = 0; i < nbttaglist.size(); i++) {
      NBTTagCompound nbttagcompound1 = nbttaglist.get(i);
      byte b0 = nbttagcompound1.getByte("Slot");
      
      if ((b0 >= 0) && (b0 < a.length)) {
        a[b0] = ItemStack.createStack(nbttagcompound1);
      }
    }
  }
  
  public void b(NBTTagCompound nbttagcompound) {
    super.b(nbttagcompound);
    NBTTagList nbttaglist = new NBTTagList();
    
    for (int i = 0; i < a.length; i++) {
      if (a[i] != null) {
        NBTTagCompound nbttagcompound1 = new NBTTagCompound();
        
        nbttagcompound1.setByte("Slot", (byte)i);
        a[i].save(nbttagcompound1);
        nbttaglist.add(nbttagcompound1);
      }
    }
    
    nbttagcompound.set("Items", nbttaglist);
    nbttagcompound.setInt("TransferCooldown", j);
    if (k_()) {
      nbttagcompound.setString("CustomName", this.i);
    }
  }
  
  public void update() {
    super.update();
  }
  
  public int getSize() {
    return a.length;
  }
  
  public ItemStack getItem(int i) {
    return a[i];
  }
  
  public ItemStack splitStack(int i, int j) {
    if (a[i] != null)
    {

      if (a[i].count <= j) {
        ItemStack itemstack = a[i];
        a[i] = null;
        return itemstack;
      }
      ItemStack itemstack = a[i].a(j);
      if (a[i].count == 0) {
        a[i] = null;
      }
      
      return itemstack;
    }
    
    return null;
  }
  
  public ItemStack splitWithoutUpdate(int i)
  {
    if (a[i] != null) {
      ItemStack itemstack = a[i];
      
      a[i] = null;
      return itemstack;
    }
    return null;
  }
  
  public void setItem(int i, ItemStack itemstack)
  {
    a[i] = itemstack;
    if ((itemstack != null) && (count > getMaxStackSize())) {
      count = getMaxStackSize();
    }
  }
  
  public String getInventoryName() {
    return k_() ? i : "container.hopper";
  }
  
  public boolean k_() {
    return (i != null) && (i.length() > 0);
  }
  
  public void a(String s) {
    i = s;
  }
  
  public int getMaxStackSize() {
    return 64;
  }
  
  public boolean a(EntityHuman entityhuman) {
    return world.getTileEntity(x, y, z) == this;
  }
  
  public void startOpen() {}
  
  public void l_() {}
  
  public boolean b(int i, ItemStack itemstack) {
    return true;
  }
  
  public void h() {
    if ((world != null) && (!world.isStatic)) {
      j -= 1;
      if (!j()) {
        c(0);
        i();
      }
    }
  }
  
  public boolean i() {
    if ((world != null) && (!world.isStatic)) {
      if ((!j()) && (BlockHopper.c(p()))) {
        boolean flag = k();
        
        flag = (suckInItems(this)) || (flag);
        if (flag) {
          c(8);
          update();
          return true;
        }
      }
      
      return false;
    }
    return false;
  }
  
  private boolean k()
  {
    IInventory iinventory = l();
    
    if (iinventory == null) {
      return false;
    }
    for (int i = 0; i < getSize(); i++) {
      if (getItem(i) != null) {
        ItemStack itemstack = getItem(i).cloneItemStack();
        
        CraftItemStack oitemstack = CraftItemStack.asCraftMirror(splitStack(i, 1));
        
        Inventory destinationInventory;
        Inventory destinationInventory;
        if ((iinventory instanceof InventoryLargeChest)) {
          destinationInventory = new CraftInventoryDoubleChest((InventoryLargeChest)iinventory);
        } else {
          destinationInventory = iinventory.getOwner().getInventory();
        }
        
        InventoryMoveItemEvent event = new InventoryMoveItemEvent(getOwner().getInventory(), oitemstack.clone(), destinationInventory, true);
        getWorld().getServer().getPluginManager().callEvent(event);
        if (event.isCancelled()) {
          setItem(i, itemstack);
          c(8);
          return false;
        }
        ItemStack itemstack1 = addItem(iinventory, CraftItemStack.asNMSCopy(event.getItem()), Facing.OPPOSITE_FACING[BlockHopper.b(p())]);
        
        if ((itemstack1 == null) || (count == 0)) {
          if (event.getItem().equals(oitemstack)) {
            iinventory.update();
          } else {
            setItem(i, itemstack);
          }
          
          return true;
        }
        
        setItem(i, itemstack);
      }
    }
    
    return false;
  }
  
  public static boolean suckInItems(IHopper ihopper)
  {
    IInventory iinventory = getSourceInventory(ihopper);
    
    if (iinventory != null) {
      byte b0 = 0;
      
      if (((iinventory instanceof IWorldInventory)) && (b0 > -1)) {
        IWorldInventory iworldinventory = (IWorldInventory)iinventory;
        int[] aint = iworldinventory.getSlotsForFace(b0);
        
        for (int i = 0; i < aint.length; i++) {
          if (tryTakeInItemFromSlot(ihopper, iinventory, aint[i], b0)) {
            return true;
          }
        }
      } else {
        int j = iinventory.getSize();
        
        for (int k = 0; k < j; k++) {
          if (tryTakeInItemFromSlot(ihopper, iinventory, k, b0)) {
            return true;
          }
        }
      }
    } else {
      EntityItem entityitem = getEntityItemAt(ihopper.getWorld(), ihopper.x(), ihopper.aD() + 1.0D, ihopper.aE());
      
      if (entityitem != null) {
        return addEntityItem(ihopper, entityitem);
      }
    }
    
    return false;
  }
  
  private static boolean tryTakeInItemFromSlot(IHopper ihopper, IInventory iinventory, int i, int j) {
    ItemStack itemstack = iinventory.getItem(i);
    
    if ((itemstack != null) && (canTakeItemFromInventory(iinventory, itemstack, i, j))) {
      ItemStack itemstack1 = itemstack.cloneItemStack();
      
      CraftItemStack oitemstack = CraftItemStack.asCraftMirror(iinventory.splitStack(i, 1));
      
      Inventory sourceInventory;
      Inventory sourceInventory;
      if ((iinventory instanceof InventoryLargeChest)) {
        sourceInventory = new CraftInventoryDoubleChest((InventoryLargeChest)iinventory);
      } else {
        sourceInventory = iinventory.getOwner().getInventory();
      }
      
      InventoryMoveItemEvent event = new InventoryMoveItemEvent(sourceInventory, oitemstack.clone(), ihopper.getOwner().getInventory(), false);
      
      ihopper.getWorld().getServer().getPluginManager().callEvent(event);
      if (event.isCancelled()) {
        iinventory.setItem(i, itemstack1);
        
        if ((ihopper instanceof TileEntityHopper)) {
          ((TileEntityHopper)ihopper).c(8);
        } else if ((ihopper instanceof EntityMinecartHopper)) {
          ((EntityMinecartHopper)ihopper).l(4);
        }
        
        return false;
      }
      ItemStack itemstack2 = addItem(ihopper, CraftItemStack.asNMSCopy(event.getItem()), -1);
      
      if ((itemstack2 == null) || (count == 0)) {
        if (event.getItem().equals(oitemstack)) {
          iinventory.update();
        } else {
          iinventory.setItem(i, itemstack1);
        }
        

        return true;
      }
      
      iinventory.setItem(i, itemstack1);
    }
    
    return false;
  }
  
  public static boolean addEntityItem(IInventory iinventory, EntityItem entityitem) {
    boolean flag = false;
    
    if (entityitem == null) {
      return false;
    }
    
    InventoryPickupItemEvent event = new InventoryPickupItemEvent(iinventory.getOwner().getInventory(), (org.bukkit.entity.Item)entityitem.getBukkitEntity());
    world.getServer().getPluginManager().callEvent(event);
    if (event.isCancelled()) {
      return false;
    }
    

    ItemStack itemstack = entityitem.getItemStack().cloneItemStack();
    ItemStack itemstack1 = addItem(iinventory, itemstack, -1);
    
    if ((itemstack1 != null) && (count != 0)) {
      entityitem.setItemStack(itemstack1);
    } else {
      flag = true;
      entityitem.die();
    }
    
    return flag;
  }
  
  public static ItemStack addItem(IInventory iinventory, ItemStack itemstack, int i)
  {
    if (((iinventory instanceof IWorldInventory)) && (i > -1)) {
      IWorldInventory iworldinventory = (IWorldInventory)iinventory;
      int[] aint = iworldinventory.getSlotsForFace(i);
      
      for (int j = 0; (j < aint.length) && (itemstack != null) && (count > 0); j++) {
        itemstack = tryMoveInItem(iinventory, itemstack, aint[j], i);
      }
    } else {
      int k = iinventory.getSize();
      
      for (int l = 0; (l < k) && (itemstack != null) && (count > 0); l++) {
        itemstack = tryMoveInItem(iinventory, itemstack, l, i);
      }
    }
    
    if ((itemstack != null) && (count == 0)) {
      itemstack = null;
    }
    
    return itemstack;
  }
  
  private static boolean canPlaceItemInInventory(IInventory iinventory, ItemStack itemstack, int i, int j) {
    return iinventory.b(i, itemstack);
  }
  
  private static boolean canTakeItemFromInventory(IInventory iinventory, ItemStack itemstack, int i, int j) {
    return (!(iinventory instanceof IWorldInventory)) || (((IWorldInventory)iinventory).canTakeItemThroughFace(i, itemstack, j));
  }
  
  private static ItemStack tryMoveInItem(IInventory iinventory, ItemStack itemstack, int i, int j) {
    ItemStack itemstack1 = iinventory.getItem(i);
    
    if (canPlaceItemInInventory(iinventory, itemstack, i, j)) {
      boolean flag = false;
      
      if (itemstack1 == null) {
        iinventory.setItem(i, itemstack);
        itemstack = null;
        flag = true;
      } else if (canMergeItems(itemstack1, itemstack)) {
        int k = itemstack.getMaxStackSize() - count;
        int l = Math.min(count, k);
        
        count -= l;
        count += l;
        flag = l > 0;
      }
      
      if (flag) {
        if ((iinventory instanceof TileEntityHopper)) {
          ((TileEntityHopper)iinventory).c(8);
          iinventory.update();
        }
        
        iinventory.update();
      }
    }
    
    return itemstack;
  }
  
  private IInventory l() {
    int i = BlockHopper.b(p());
    
    return getInventoryAt(getWorld(), x + Facing.b[i], y + Facing.c[i], z + Facing.d[i]);
  }
  
  public static IInventory getSourceInventory(IHopper ihopper) {
    return getInventoryAt(ihopper.getWorld(), ihopper.x(), ihopper.aD() + 1.0D, ihopper.aE());
  }
  
  public static EntityItem getEntityItemAt(World world, double d0, double d1, double d2) {
    List list = world.a(EntityItem.class, AxisAlignedBB.a().a(d0, d1, d2, d0 + 1.0D, d1 + 1.0D, d2 + 1.0D), IEntitySelector.a);
    
    return list.size() > 0 ? (EntityItem)list.get(0) : null;
  }
  
  public static IInventory getInventoryAt(World world, double d0, double d1, double d2) {
    IInventory iinventory = null;
    int i = MathHelper.floor(d0);
    int j = MathHelper.floor(d1);
    int k = MathHelper.floor(d2);
    TileEntity tileentity = world.getTileEntity(i, j, k);
    
    if ((tileentity != null) && ((tileentity instanceof IInventory))) {
      iinventory = (IInventory)tileentity;
      if ((iinventory instanceof TileEntityChest)) {
        Block block = world.getType(i, j, k);
        
        if ((block instanceof BlockChest)) {
          iinventory = ((BlockChest)block).m(world, i, j, k);
        }
      }
    }
    
    if (iinventory == null) {
      List list = world.getEntities((Entity)null, AxisAlignedBB.a().a(d0, d1, d2, d0 + 1.0D, d1 + 1.0D, d2 + 1.0D), IEntitySelector.b);
      
      if ((list != null) && (list.size() > 0)) {
        iinventory = (IInventory)list.get(random.nextInt(list.size()));
      }
    }
    
    return iinventory;
  }
  
  private static boolean canMergeItems(ItemStack itemstack, ItemStack itemstack1) {
    return count > itemstack.getMaxStackSize() ? false : itemstack.getData() != itemstack1.getData() ? false : itemstack.getItem() != itemstack1.getItem() ? false : ItemStack.equals(itemstack, itemstack1);
  }
  
  public double x() {
    return x;
  }
  
  public double aD() {
    return y;
  }
  
  public double aE() {
    return z;
  }
  
  public void c(int i) {
    j = i;
  }
  
  public boolean j() {
    return j > 0;
  }
}
