package net.minecraft.server.v1_7_R1;

public class Vec3D
{
  public static final Vec3DPool a = new Vec3DPool(-1, -1);
  public final Vec3DPool b;
  public double c;
  public double d;
  public double e;
  public Vec3D next;
  
  public static Vec3D a(double d0, double d1, double d2) {
    return new Vec3D(a, d0, d1, d2);
  }
  
  protected Vec3D(Vec3DPool vec3dpool, double d0, double d1, double d2) {
    if (d0 == -0.0D) {
      d0 = 0.0D;
    }
    
    if (d1 == -0.0D) {
      d1 = 0.0D;
    }
    
    if (d2 == -0.0D) {
      d2 = 0.0D;
    }
    
    c = d0;
    d = d1;
    e = d2;
    b = vec3dpool;
  }
  
  protected Vec3D b(double d0, double d1, double d2) {
    c = d0;
    d = d1;
    e = d2;
    return this;
  }
  
  public Vec3D a() {
    double d0 = MathHelper.sqrt(c * c + d * d + e * e);
    
    return d0 < 0.0001D ? b.create(0.0D, 0.0D, 0.0D) : b.create(c / d0, d / d0, e / d0);
  }
  
  public double b(Vec3D vec3d) {
    return c * c + d * d + e * e;
  }
  
  public Vec3D add(double d0, double d1, double d2) {
    return b.create(c + d0, d + d1, e + d2);
  }
  
  public double d(Vec3D vec3d) {
    double d0 = c - c;
    double d1 = d - d;
    double d2 = e - e;
    
    return MathHelper.sqrt(d0 * d0 + d1 * d1 + d2 * d2);
  }
  
  public double distanceSquared(Vec3D vec3d) {
    double d0 = c - c;
    double d1 = d - d;
    double d2 = e - e;
    
    return d0 * d0 + d1 * d1 + d2 * d2;
  }
  
  public double d(double d0, double d1, double d2) {
    double d3 = d0 - c;
    double d4 = d1 - d;
    double d5 = d2 - e;
    
    return d3 * d3 + d4 * d4 + d5 * d5;
  }
  
  public double b() {
    return MathHelper.sqrt(c * c + d * d + e * e);
  }
  
  public Vec3D b(Vec3D vec3d, double d0) {
    double d1 = c - c;
    double d2 = d - d;
    double d3 = e - e;
    
    if (d1 * d1 < 1.000000011686097E-007D) {
      return null;
    }
    double d4 = (d0 - c) / d1;
    
    return (d4 >= 0.0D) && (d4 <= 1.0D) ? b.create(c + d1 * d4, d + d2 * d4, e + d3 * d4) : null;
  }
  
  public Vec3D c(Vec3D vec3d, double d0)
  {
    double d1 = c - c;
    double d2 = d - d;
    double d3 = e - e;
    
    if (d2 * d2 < 1.000000011686097E-007D) {
      return null;
    }
    double d4 = (d0 - d) / d2;
    
    return (d4 >= 0.0D) && (d4 <= 1.0D) ? b.create(c + d1 * d4, d + d2 * d4, e + d3 * d4) : null;
  }
  
  public Vec3D d(Vec3D vec3d, double d0)
  {
    double d1 = c - c;
    double d2 = d - d;
    double d3 = e - e;
    
    if (d3 * d3 < 1.000000011686097E-007D) {
      return null;
    }
    double d4 = (d0 - e) / d3;
    
    return (d4 >= 0.0D) && (d4 <= 1.0D) ? b.create(c + d1 * d4, d + d2 * d4, e + d3 * d4) : null;
  }
  
  public String toString()
  {
    return "(" + c + ", " + d + ", " + e + ")";
  }
  
  public void a(float f) {
    float f1 = MathHelper.cos(f);
    float f2 = MathHelper.sin(f);
    double d0 = c;
    double d1 = d * f1 + e * f2;
    double d2 = e * f1 - d * f2;
    
    c = d0;
    d = d1;
    e = d2;
  }
  
  public void b(float f) {
    float f1 = MathHelper.cos(f);
    float f2 = MathHelper.sin(f);
    double d0 = c * f1 + e * f2;
    double d1 = d;
    double d2 = e * f1 - c * f2;
    
    c = d0;
    d = d1;
    e = d2;
  }
}
