package net.minecraft.server.v1_7_R1;



public class Vec3DPool
{
  private final int a;
  

  private final int b;
  
  private Vec3D freelist = null;
  private Vec3D alloclist = null;
  private Vec3D freelisthead = null;
  private Vec3D alloclisthead = null;
  private int total_size = 0;
  private int position;
  private int largestSize;
  private int resizeTime;
  
  public Vec3DPool(int i, int j)
  {
    a = i;
    b = j;
  }
  
  public final Vec3D create(double d0, double d1, double d2) {
    if (resizeTime == 0) { return Vec3D.a(d0, d1, d2);
    }
    Vec3D vec3d;
    if (freelist == null) {
      Vec3D vec3d = new Vec3D(this, d0, d1, d2);
      total_size += 1;
    }
    else {
      vec3d = freelist;
      freelist = next;
      
      vec3d.b(d0, d1, d2);
    }
    

    if (alloclist == null) {
      alloclisthead = vec3d;
    }
    next = alloclist;
    alloclist = vec3d;
    
    position += 1;
    return vec3d;
  }
  
  public void release(Vec3D v)
  {
    if (alloclist == v) {
      alloclist = next;
      
      if (freelist == null) freelisthead = v;
      next = freelist;
      freelist = v;
      position -= 1;
    }
  }
  
  public void a()
  {
    if (position > largestSize) {
      largestSize = position;
    }
    


    if (alloclist != null) {
      if (freelist == null) {
        freelist = alloclist;
        freelisthead = alloclisthead;
      }
      else {
        alloclisthead.next = freelist;
        freelist = alloclist;
        freelisthead = alloclisthead;
      }
      alloclist = null;
    }
    if ((resizeTime++ & 0xFF) == 0) {
      int newSize = total_size - (total_size >> 3);
      if (newSize > largestSize) {
        for (int i = total_size; i > newSize; i--) {
          freelist = freelist.next;
        }
        total_size = newSize;
      }
      largestSize = 0;
    }
    

    position = 0;
  }
  
  public int c()
  {
    return total_size;
  }
  
  public int d() {
    return position;
  }
  
  private boolean e() {
    return (b < 0) || (a < 0);
  }
}
