package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Random;
import java.util.Set;
import org.bukkit.Bukkit;
import org.bukkit.World.Environment;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_7_R1.event.CraftEventFactory;
import org.bukkit.craftbukkit.v1_7_R1.util.CraftMagicNumbers;
import org.bukkit.craftbukkit.v1_7_R1.util.LongHash;
import org.bukkit.craftbukkit.v1_7_R1.util.LongHashSet;
import org.bukkit.entity.Projectile;
import org.bukkit.event.Cancellable;
import org.bukkit.event.block.BlockCanBuildEvent;
import org.bukkit.event.block.BlockPhysicsEvent;
import org.bukkit.event.entity.CreatureSpawnEvent.SpawnReason;
import org.bukkit.event.weather.ThunderChangeEvent;
import org.bukkit.event.weather.WeatherChangeEvent;
import org.bukkit.generator.ChunkGenerator;
import org.bukkit.plugin.PluginManager;

public abstract class World implements IBlockAccess
{
  public boolean d;
  public List entityList = new ArrayList();
  protected List f = new ArrayList();
  public Set tileEntityList = new HashSet();
  private List a = new ArrayList();
  private List b = new ArrayList();
  public List players = new ArrayList();
  public List i = new ArrayList();
  private long c = 16777215L;
  public int j;
  protected int k = new Random().nextInt();
  protected final int l = 1013904223;
  protected float m;
  protected float n;
  protected float o;
  protected float p;
  public int q;
  public EnumDifficulty difficulty;
  public Random random = new Random();
  public WorldProvider worldProvider;
  protected List u = new ArrayList();
  public IChunkProvider chunkProvider;
  protected final IDataManager dataManager;
  public WorldData worldData;
  public boolean isLoading;
  public PersistentCollection worldMaps;
  public final PersistentVillage villages;
  protected final VillageSiege siegeManager = new VillageSiege(this);
  public final MethodProfiler methodProfiler;
  private final Vec3DPool J = new Vec3DPool(300, 2000);
  private final Calendar K = Calendar.getInstance();
  public Scoreboard scoreboard = new Scoreboard();
  
  public boolean isStatic;
  protected LongHashSet chunkTickList = new LongHashSet();
  
  private int L;
  public boolean allowMonsters;
  public boolean allowAnimals;
  public boolean callingPlaceEvent = false;
  public long ticksPerAnimalSpawns;
  public long ticksPerMonsterSpawns;
  public boolean populating;
  private ArrayList M;
  private boolean N;
  int[] I;
  private final CraftWorld world;
  public boolean pvpMode;
  
  public BiomeBase getBiome(int i, int j) { if (isLoaded(i, 0, j)) {
      Chunk chunk = getChunkAtWorldCoords(i, j);
      try
      {
        return chunk.a(i & 0xF, j & 0xF, worldProvider.e);
      } catch (Throwable throwable) {
        CrashReport crashreport = CrashReport.a(throwable, "Getting biome");
        CrashReportSystemDetails crashreportsystemdetails = crashreport.a("Coordinates of biome request");
        
        crashreportsystemdetails.a("Location", new CrashReportWorldLocation(this, i, j));
        throw new ReportedException(crashreport);
      }
    }
    return worldProvider.e.getBiome(i, j);
  }
  
  public WorldChunkManager getWorldChunkManager()
  {
    return worldProvider.e;
  }
  



  public boolean keepSpawnInMemory = true;
  public ChunkGenerator generator;
  Chunk lastChunkAccessed;
  int lastXAccessed = -2147483648;
  int lastZAccessed = -2147483648;
  final Object chunkLock = new Object();
  
  public CraftWorld getWorld() {
    return world;
  }
  
  public CraftServer getServer() {
    return (CraftServer)Bukkit.getServer();
  }
  
  public World(IDataManager idatamanager, String s, WorldSettings worldsettings, WorldProvider worldprovider, MethodProfiler methodprofiler, ChunkGenerator gen, World.Environment env)
  {
    generator = gen;
    world = new CraftWorld((WorldServer)this, gen, env);
    ticksPerAnimalSpawns = getServer().getTicksPerAnimalSpawns();
    ticksPerMonsterSpawns = getServer().getTicksPerMonsterSpawns();
    

    L = random.nextInt(12000);
    allowMonsters = true;
    allowAnimals = true;
    M = new ArrayList();
    I = new int[32768];
    dataManager = idatamanager;
    methodProfiler = methodprofiler;
    worldMaps = new PersistentCollection(idatamanager);
    worldData = idatamanager.getWorldData();
    if (worldprovider != null) {
      worldProvider = worldprovider;
    } else if ((worldData != null) && (worldData.j() != 0)) {
      worldProvider = WorldProvider.byDimension(worldData.j());
    } else {
      worldProvider = WorldProvider.byDimension(0);
    }
    
    if (worldData == null) {
      worldData = new WorldData(worldsettings, s);
    } else {
      worldData.setName(s);
    }
    
    worldProvider.a(this);
    chunkProvider = j();
    if (!worldData.isInitialized()) {
      try {
        a(worldsettings);
      } catch (Throwable throwable) {
        CrashReport crashreport = CrashReport.a(throwable, "Exception initializing level");
        try
        {
          a(crashreport);
        }
        catch (Throwable throwable1) {}
        

        throw new ReportedException(crashreport);
      }
      
      worldData.d(true);
    }
    
    PersistentVillage persistentvillage = (PersistentVillage)worldMaps.get(PersistentVillage.class, "villages");
    
    if (persistentvillage == null) {
      villages = new PersistentVillage(this);
      worldMaps.a("villages", villages);
    } else {
      villages = persistentvillage;
      villages.a(this);
    }
    
    A();
    a();
    
    getServer().addWorld(world);
  }
  
  protected abstract IChunkProvider j();
  
  protected void a(WorldSettings worldsettings) {
    worldData.d(true);
  }
  

  public Block b(int i, int j)
  {
    for (int k = 63; !isEmpty(i, k + 1, j); k++) {}
    


    return getType(i, k, j);
  }
  
  public Block getType(int i, int j, int k) {
    if ((i >= -30000000) && (k >= -30000000) && (i < 30000000) && (k < 30000000) && (j >= 0) && (j < 256)) {
      Chunk chunk = null;
      try
      {
        chunk = getChunkAt(i >> 4, k >> 4);
        return chunk.getType(i & 0xF, j, k & 0xF);
      } catch (Throwable throwable) {
        CrashReport crashreport = CrashReport.a(throwable, "Exception getting block type in world");
        CrashReportSystemDetails crashreportsystemdetails = crashreport.a("Requested block coordinates");
        
        crashreportsystemdetails.a("Found chunk", Boolean.valueOf(chunk == null));
        crashreportsystemdetails.a("Location", CrashReportSystemDetails.a(i, j, k));
        throw new ReportedException(crashreport);
      }
    }
    return Blocks.AIR;
  }
  
  public boolean isEmpty(int i, int j, int k)
  {
    return getType(i, j, k).getMaterial() == Material.AIR;
  }
  
  public boolean isLoaded(int i, int j, int k) {
    return (j >= 0) && (j < 256) ? isChunkLoaded(i >> 4, k >> 4) : false;
  }
  
  public boolean areChunksLoaded(int i, int j, int k, int l) {
    return b(i - l, j - l, k - l, i + l, j + l, k + l);
  }
  
  public boolean b(int i, int j, int k, int l, int i1, int j1) {
    if ((i1 >= 0) && (j < 256)) {
      i >>= 4;
      k >>= 4;
      l >>= 4;
      j1 >>= 4;
      
      for (int k1 = i; k1 <= l; k1++) {
        for (int l1 = k; l1 <= j1; l1++)
        {
          if ((!isChunkLoaded(k1, l1)) || (chunkProviderServer.unloadQueue.contains(k1, l1))) {
            return false;
          }
        }
      }
      
      return true;
    }
    return false;
  }
  
  protected boolean isChunkLoaded(int i, int j)
  {
    return chunkProvider.isChunkLoaded(i, j);
  }
  
  public Chunk getChunkAtWorldCoords(int i, int j) {
    return getChunkAt(i >> 4, j >> 4);
  }
  
  public Chunk getChunkAt(int i, int j)
  {
    Chunk result = null;
    synchronized (chunkLock) {
      if ((lastChunkAccessed == null) || (lastXAccessed != i) || (lastZAccessed != j)) {
        lastChunkAccessed = chunkProvider.getOrCreateChunk(i, j);
        lastXAccessed = i;
        lastZAccessed = j;
      }
      result = lastChunkAccessed;
    }
    return result;
  }
  
  public boolean setTypeAndData(int i, int j, int k, Block block, int l, int i1)
  {
    if ((i >= -30000000) && (k >= -30000000) && (i < 30000000) && (k < 30000000)) {
      if (j < 0)
        return false;
      if (j >= 256) {
        return false;
      }
      Chunk chunk = getChunkAt(i >> 4, k >> 4);
      Block block1 = null;
      
      if ((i1 & 0x1) != 0) {
        block1 = chunk.getType(i & 0xF, j, k & 0xF);
      }
      
      boolean flag = chunk.a(i & 0xF, j, k & 0xF, block, l);
      
      methodProfiler.a("checkLight");
      t(i, j, k);
      methodProfiler.b();
      if (flag) {
        if (((i1 & 0x2) != 0) && ((!isStatic) || ((i1 & 0x4) == 0)) && (chunk.k())) {
          notify(i, j, k);
        }
        
        if ((!isStatic) && ((i1 & 0x1) != 0)) {
          update(i, j, k, block1);
          if (block.M()) {
            f(i, j, k, block);
          }
        }
      }
      
      return flag;
    }
    
    return false;
  }
  
  public int getData(int i, int j, int k)
  {
    if ((i >= -30000000) && (k >= -30000000) && (i < 30000000) && (k < 30000000)) {
      if (j < 0)
        return 0;
      if (j >= 256) {
        return 0;
      }
      Chunk chunk = getChunkAt(i >> 4, k >> 4);
      
      i &= 0xF;
      k &= 0xF;
      return chunk.getData(i, j, k);
    }
    
    return 0;
  }
  
  public boolean setData(int i, int j, int k, int l, int i1)
  {
    if ((i >= -30000000) && (k >= -30000000) && (i < 30000000) && (k < 30000000)) {
      if (j < 0)
        return false;
      if (j >= 256) {
        return false;
      }
      Chunk chunk = getChunkAt(i >> 4, k >> 4);
      int j1 = i & 0xF;
      int k1 = k & 0xF;
      boolean flag = chunk.a(j1, j, k1, l);
      
      if (flag) {
        Block block = chunk.getType(j1, j, k1);
        
        if (((i1 & 0x2) != 0) && ((!isStatic) || ((i1 & 0x4) == 0)) && (chunk.k())) {
          notify(i, j, k);
        }
        
        if ((!isStatic) && ((i1 & 0x1) != 0)) {
          update(i, j, k, block);
          if (block.M()) {
            f(i, j, k, block);
          }
        }
      }
      
      return flag;
    }
    
    return false;
  }
  
  public boolean setAir(int i, int j, int k)
  {
    return setTypeAndData(i, j, k, Blocks.AIR, 0, 3);
  }
  
  public boolean setAir(int i, int j, int k, boolean flag) {
    Block block = getType(i, j, k);
    
    if (block.getMaterial() == Material.AIR) {
      return false;
    }
    int l = getData(i, j, k);
    
    triggerEffect(2001, i, j, k, Block.b(block) + (l << 12));
    if (flag) {
      block.b(this, i, j, k, l, 0);
    }
    
    return setTypeAndData(i, j, k, Blocks.AIR, 0, 3);
  }
  
  public boolean setTypeUpdate(int i, int j, int k, Block block)
  {
    return setTypeAndData(i, j, k, block, 0, 3);
  }
  
  public void notify(int i, int j, int k) {
    for (int l = 0; l < u.size(); l++) {
      ((IWorldAccess)u.get(l)).a(i, j, k);
    }
  }
  
  public void update(int i, int j, int k, Block block)
  {
    if (populating) {
      return;
    }
    
    applyPhysics(i, j, k, block);
  }
  

  public void b(int i, int j, int k, int l)
  {
    if (k > l) {
      int i1 = l;
      l = k;
      k = i1;
    }
    
    if (!worldProvider.g) {
      for (int i1 = k; i1 <= l; i1++) {
        c(EnumSkyBlock.SKY, i, i1, j);
      }
    }
    
    c(i, k, j, i, l, j);
  }
  
  public void c(int i, int j, int k, int l, int i1, int j1) {
    for (int k1 = 0; k1 < u.size(); k1++) {
      ((IWorldAccess)u.get(k1)).a(i, j, k, l, i1, j1);
    }
  }
  
  public void applyPhysics(int i, int j, int k, Block block) {
    e(i - 1, j, k, block);
    e(i + 1, j, k, block);
    e(i, j - 1, k, block);
    e(i, j + 1, k, block);
    e(i, j, k - 1, block);
    e(i, j, k + 1, block);
  }
  
  public void b(int i, int j, int k, Block block, int l) {
    if (l != 4) {
      e(i - 1, j, k, block);
    }
    
    if (l != 5) {
      e(i + 1, j, k, block);
    }
    
    if (l != 0) {
      e(i, j - 1, k, block);
    }
    
    if (l != 1) {
      e(i, j + 1, k, block);
    }
    
    if (l != 2) {
      e(i, j, k - 1, block);
    }
    
    if (l != 3) {
      e(i, j, k + 1, block);
    }
  }
  
  public void e(int i, int j, int k, Block block) {
    if (!isStatic) {
      Block block1 = getType(i, j, k);
      
      try
      {
        CraftWorld world = ((WorldServer)this).getWorld();
        if (world != null) {
          BlockPhysicsEvent event = new BlockPhysicsEvent(world.getBlockAt(i, j, k), CraftMagicNumbers.getId(block));
          getServer().getPluginManager().callEvent(event);
          
          if (event.isCancelled()) {
            return;
          }
        }
        

        block1.doPhysics(this, i, j, k, block);
      } catch (Throwable throwable) {
        CrashReport crashreport = CrashReport.a(throwable, "Exception while updating neighbours");
        CrashReportSystemDetails crashreportsystemdetails = crashreport.a("Block being updated");
        
        int l;
        try
        {
          l = getData(i, j, k);
        } catch (Throwable throwable1) {
          l = -1;
        }
        
        crashreportsystemdetails.a("Source block type", new CrashReportSourceBlockType(this, block));
        CrashReportSystemDetails.a(crashreportsystemdetails, i, j, k, block1, l);
        throw new ReportedException(crashreport);
      }
    }
  }
  
  public boolean a(int i, int j, int k, Block block) {
    return false;
  }
  
  public boolean i(int i, int j, int k) {
    return getChunkAt(i >> 4, k >> 4).d(i & 0xF, j, k & 0xF);
  }
  
  public int j(int i, int j, int k) {
    if (j < 0) {
      return 0;
    }
    if (j >= 256) {
      j = 255;
    }
    
    return getChunkAt(i >> 4, k >> 4).b(i & 0xF, j, k & 0xF, 0);
  }
  
  public int getLightLevel(int i, int j, int k)
  {
    return b(i, j, k, true);
  }
  
  public int b(int i, int j, int k, boolean flag) {
    if ((i >= -30000000) && (k >= -30000000) && (i < 30000000) && (k < 30000000)) {
      if ((flag) && (getType(i, j, k).n())) {
        int l = b(i, j + 1, k, false);
        int i1 = b(i + 1, j, k, false);
        int j1 = b(i - 1, j, k, false);
        int k1 = b(i, j, k + 1, false);
        int l1 = b(i, j, k - 1, false);
        
        if (i1 > l) {
          l = i1;
        }
        
        if (j1 > l) {
          l = j1;
        }
        
        if (k1 > l) {
          l = k1;
        }
        
        if (l1 > l) {
          l = l1;
        }
        
        return l; }
      if (j < 0) {
        return 0;
      }
      if (j >= 256) {
        j = 255;
      }
      
      Chunk chunk = getChunkAt(i >> 4, k >> 4);
      
      i &= 0xF;
      k &= 0xF;
      return chunk.b(i, j, k, this.j);
    }
    
    return 15;
  }
  
  public int getHighestBlockYAt(int i, int j)
  {
    if ((i >= -30000000) && (j >= -30000000) && (i < 30000000) && (j < 30000000)) {
      if (!isChunkLoaded(i >> 4, j >> 4)) {
        return 0;
      }
      Chunk chunk = getChunkAt(i >> 4, j >> 4);
      
      return chunk.b(i & 0xF, j & 0xF);
    }
    
    return 64;
  }
  
  public int g(int i, int j)
  {
    if ((i >= -30000000) && (j >= -30000000) && (i < 30000000) && (j < 30000000)) {
      if (!isChunkLoaded(i >> 4, j >> 4)) {
        return 0;
      }
      Chunk chunk = getChunkAt(i >> 4, j >> 4);
      
      return r;
    }
    
    return 64;
  }
  
  public int b(EnumSkyBlock enumskyblock, int i, int j, int k)
  {
    if (j < 0) {
      j = 0;
    }
    
    if (j >= 256) {
      j = 255;
    }
    
    if ((i >= -30000000) && (k >= -30000000) && (i < 30000000) && (k < 30000000)) {
      int l = i >> 4;
      int i1 = k >> 4;
      
      if (!isChunkLoaded(l, i1)) {
        return c;
      }
      Chunk chunk = getChunkAt(l, i1);
      
      return chunk.getBrightness(enumskyblock, i & 0xF, j, k & 0xF);
    }
    
    return c;
  }
  
  public void b(EnumSkyBlock enumskyblock, int i, int j, int k, int l)
  {
    if ((i >= -30000000) && (k >= -30000000) && (i < 30000000) && (k < 30000000) && 
      (j >= 0) && 
      (j < 256) && 
      (isChunkLoaded(i >> 4, k >> 4))) {
      Chunk chunk = getChunkAt(i >> 4, k >> 4);
      
      chunk.a(enumskyblock, i & 0xF, j, k & 0xF, l);
      
      for (int i1 = 0; i1 < u.size(); i1++) {
        ((IWorldAccess)u.get(i1)).b(i, j, k);
      }
    }
  }
  


  public void m(int i, int j, int k)
  {
    for (int l = 0; l < u.size(); l++) {
      ((IWorldAccess)u.get(l)).b(i, j, k);
    }
  }
  
  public float n(int i, int j, int k) {
    return worldProvider.h[getLightLevel(i, j, k)];
  }
  
  public boolean v() {
    return j < 4;
  }
  
  public MovingObjectPosition a(Vec3D vec3d, Vec3D vec3d1) {
    return rayTrace(vec3d, vec3d1, false, false, false);
  }
  
  public MovingObjectPosition rayTrace(Vec3D vec3d, Vec3D vec3d1, boolean flag) {
    return rayTrace(vec3d, vec3d1, flag, false, false);
  }
  
  public MovingObjectPosition rayTrace(Vec3D vec3d, Vec3D vec3d1, boolean flag, boolean flag1, boolean flag2) {
    if ((!Double.isNaN(c)) && (!Double.isNaN(d)) && (!Double.isNaN(e))) {
      if ((!Double.isNaN(c)) && (!Double.isNaN(d)) && (!Double.isNaN(e))) {
        int i = MathHelper.floor(c);
        int j = MathHelper.floor(d);
        int k = MathHelper.floor(e);
        int l = MathHelper.floor(c);
        int i1 = MathHelper.floor(d);
        int j1 = MathHelper.floor(e);
        Block block = getType(l, i1, j1);
        int k1 = getData(l, i1, j1);
        
        if (((!flag1) || (block.a(this, l, i1, j1) != null)) && (block.a(k1, flag))) {
          MovingObjectPosition movingobjectposition = block.a(this, l, i1, j1, vec3d, vec3d1);
          
          if (movingobjectposition != null) {
            return movingobjectposition;
          }
        }
        
        MovingObjectPosition movingobjectposition1 = null;
        
        k1 = 200;
        
        while (k1-- >= 0) {
          if ((Double.isNaN(c)) || (Double.isNaN(d)) || (Double.isNaN(e))) {
            return null;
          }
          
          if ((l == i) && (i1 == j) && (j1 == k)) {
            return flag2 ? movingobjectposition1 : null;
          }
          
          boolean flag3 = true;
          boolean flag4 = true;
          boolean flag5 = true;
          double d0 = 999.0D;
          double d1 = 999.0D;
          double d2 = 999.0D;
          
          if (i > l) {
            d0 = l + 1.0D;
          } else if (i < l) {
            d0 = l + 0.0D;
          } else {
            flag3 = false;
          }
          
          if (j > i1) {
            d1 = i1 + 1.0D;
          } else if (j < i1) {
            d1 = i1 + 0.0D;
          } else {
            flag4 = false;
          }
          
          if (k > j1) {
            d2 = j1 + 1.0D;
          } else if (k < j1) {
            d2 = j1 + 0.0D;
          } else {
            flag5 = false;
          }
          
          double d3 = 999.0D;
          double d4 = 999.0D;
          double d5 = 999.0D;
          double d6 = c - c;
          double d7 = d - d;
          double d8 = e - e;
          
          if (flag3) {
            d3 = (d0 - c) / d6;
          }
          
          if (flag4) {
            d4 = (d1 - d) / d7;
          }
          
          if (flag5) {
            d5 = (d2 - e) / d8;
          }
          
          boolean flag6 = false;
          
          byte b0;
          if ((d3 < d4) && (d3 < d5)) { byte b0;
            byte b0; if (i > l) {
              b0 = 4;
            } else {
              b0 = 5;
            }
            
            c = d0;
            d += d7 * d3;
            e += d8 * d3;
          } else if (d4 < d5) { byte b0;
            byte b0; if (j > i1) {
              b0 = 0;
            } else {
              b0 = 1;
            }
            
            c += d6 * d4;
            d = d1;
            e += d8 * d4;
          } else { byte b0;
            if (k > j1) {
              b0 = 2;
            } else {
              b0 = 3;
            }
            
            c += d6 * d5;
            d += d7 * d5;
            e = d2;
          }
          
          Vec3D vec3d2 = getVec3DPool().create(c, d, e);
          
          l = (int)(vec3d2.c = MathHelper.floor(c));
          if (b0 == 5) {
            l--;
            c += 1.0D;
          }
          
          i1 = (int)(vec3d2.d = MathHelper.floor(d));
          if (b0 == 1) {
            i1--;
            d += 1.0D;
          }
          
          j1 = (int)(vec3d2.e = MathHelper.floor(e));
          if (b0 == 3) {
            j1--;
            e += 1.0D;
          }
          
          Block block1 = getType(l, i1, j1);
          int l1 = getData(l, i1, j1);
          
          if ((!flag1) || (block1.a(this, l, i1, j1) != null)) {
            if (block1.a(l1, flag)) {
              MovingObjectPosition movingobjectposition2 = block1.a(this, l, i1, j1, vec3d, vec3d1);
              
              if (movingobjectposition2 != null) {
                b.release(vec3d2);
                return movingobjectposition2;
              }
            } else {
              movingobjectposition1 = new MovingObjectPosition(l, i1, j1, b0, vec3d, false);
            }
          }
          b.release(vec3d2);
        }
        
        return flag2 ? movingobjectposition1 : null;
      }
      return null;
    }
    
    return null;
  }
  
  public void makeSound(Entity entity, String s, float f, float f1)
  {
    for (int i = 0; i < u.size(); i++) {
      ((IWorldAccess)u.get(i)).a(s, locX, locY - height, locZ, f, f1);
    }
  }
  
  public void a(EntityHuman entityhuman, String s, float f, float f1) {
    for (int i = 0; i < u.size(); i++) {
      ((IWorldAccess)u.get(i)).a(entityhuman, s, locX, locY - height, locZ, f, f1);
    }
  }
  
  public void makeSound(double d0, double d1, double d2, String s, float f, float f1) {
    for (int i = 0; i < u.size(); i++) {
      ((IWorldAccess)u.get(i)).a(s, d0, d1, d2, f, f1);
    }
  }
  
  public void a(double d0, double d1, double d2, String s, float f, float f1, boolean flag) {}
  
  public void a(String s, int i, int j, int k) {
    for (int l = 0; l < u.size(); l++) {
      ((IWorldAccess)u.get(l)).a(s, i, j, k);
    }
  }
  
  public void addParticle(String s, double d0, double d1, double d2, double d3, double d4, double d5) {
    for (int i = 0; i < u.size(); i++) {
      ((IWorldAccess)u.get(i)).a(s, d0, d1, d2, d3, d4, d5);
    }
  }
  
  public boolean strikeLightning(Entity entity) {
    i.add(entity);
    return true;
  }
  
  public boolean addEntity(Entity entity)
  {
    return addEntity(entity, CreatureSpawnEvent.SpawnReason.DEFAULT);
  }
  
  public boolean addEntity(Entity entity, CreatureSpawnEvent.SpawnReason spawnReason) {
    if (entity == null) { return false;
    }
    
    int i = MathHelper.floor(locX / 16.0D);
    int j = MathHelper.floor(locZ / 16.0D);
    boolean flag = o;
    
    if ((entity instanceof EntityHuman)) {
      flag = true;
    }
    

    Cancellable event = null;
    if (((entity instanceof EntityLiving)) && (!(entity instanceof EntityPlayer))) {
      boolean isAnimal = ((entity instanceof EntityAnimal)) || ((entity instanceof EntityWaterAnimal)) || ((entity instanceof EntityGolem));
      boolean isMonster = ((entity instanceof EntityMonster)) || ((entity instanceof EntityGhast)) || ((entity instanceof EntitySlime));
      
      if ((spawnReason != CreatureSpawnEvent.SpawnReason.CUSTOM) && (
        ((isAnimal) && (!allowAnimals)) || ((isMonster) && (!allowMonsters)))) {
        dead = true;
        return false;
      }
      

      event = CraftEventFactory.callCreatureSpawnEvent((EntityLiving)entity, spawnReason);
    } else if ((entity instanceof EntityItem)) {
      event = CraftEventFactory.callItemSpawnEvent((EntityItem)entity);
    } else if ((entity.getBukkitEntity() instanceof Projectile))
    {
      event = CraftEventFactory.callProjectileLaunchEvent(entity);
    }
    
    if ((event != null) && ((event.isCancelled()) || (dead))) {
      dead = true;
      return false;
    }
    

    if ((!flag) && (!isChunkLoaded(i, j))) {
      dead = true;
      return false;
    }
    if ((entity instanceof EntityHuman)) {
      EntityHuman entityhuman = (EntityHuman)entity;
      
      players.add(entityhuman);
      everyoneSleeping();
    }
    
    getChunkAt(i, j).a(entity);
    entityList.add(entity);
    a(entity);
    return true;
  }
  
  protected void a(Entity entity)
  {
    for (int i = 0; i < u.size(); i++) {
      ((IWorldAccess)u.get(i)).a(entity);
    }
    
    valid = true;
  }
  
  protected void b(Entity entity) {
    for (int i = 0; i < u.size(); i++) {
      ((IWorldAccess)u.get(i)).b(entity);
    }
    
    valid = false;
  }
  
  public void kill(Entity entity) {
    if (passenger != null) {
      passenger.mount((Entity)null);
    }
    
    if (vehicle != null) {
      entity.mount((Entity)null);
    }
    
    entity.die();
    if ((entity instanceof EntityHuman)) {
      players.remove(entity);
      everyoneSleeping();
    }
  }
  
  public void removeEntity(Entity entity) {
    entity.die();
    if ((entity instanceof EntityHuman)) {
      players.remove(entity);
      everyoneSleeping();
    }
    
    int i = ai;
    int j = ak;
    
    if ((ah) && (isChunkLoaded(i, j))) {
      getChunkAt(i, j).b(entity);
    }
    
    entityList.remove(entity);
    b(entity);
  }
  
  public void addIWorldAccess(IWorldAccess iworldaccess) {
    u.add(iworldaccess);
  }
  
  public List getCubes(Entity entity, AxisAlignedBB axisalignedbb) {
    M.clear();
    int i = MathHelper.floor(a);
    int j = MathHelper.floor(d + 1.0D);
    int k = MathHelper.floor(b);
    int l = MathHelper.floor(e + 1.0D);
    int i1 = MathHelper.floor(c);
    int j1 = MathHelper.floor(f + 1.0D);
    
    for (int k1 = i; k1 < j; k1++) {
      for (int l1 = i1; l1 < j1; l1++) {
        if (isLoaded(k1, 64, l1)) {
          for (int i2 = k - 1; i2 < l; i2++) {
            Block block;
            Block block;
            if ((k1 >= -30000000) && (k1 < 30000000) && (l1 >= -30000000) && (l1 < 30000000)) {
              block = getType(k1, i2, l1);
            } else {
              block = Blocks.STONE;
            }
            
            block.a(this, k1, i2, l1, axisalignedbb, M, entity);
          }
        }
      }
    }
    
    double d0 = 0.25D;
    List list = getEntities(entity, axisalignedbb.grow(d0, d0, d0));
    
    for (int j2 = 0; j2 < list.size(); j2++) {
      AxisAlignedBB axisalignedbb1 = ((Entity)list.get(j2)).J();
      
      if ((axisalignedbb1 != null) && (axisalignedbb1.b(axisalignedbb))) {
        M.add(axisalignedbb1);
      }
      
      axisalignedbb1 = entity.g((Entity)list.get(j2));
      if ((axisalignedbb1 != null) && (axisalignedbb1.b(axisalignedbb))) {
        M.add(axisalignedbb1);
      }
    }
    
    return M;
  }
  
  public List a(AxisAlignedBB axisalignedbb) {
    M.clear();
    int i = MathHelper.floor(a);
    int j = MathHelper.floor(d + 1.0D);
    int k = MathHelper.floor(b);
    int l = MathHelper.floor(e + 1.0D);
    int i1 = MathHelper.floor(c);
    int j1 = MathHelper.floor(f + 1.0D);
    
    for (int k1 = i; k1 < j; k1++) {
      for (int l1 = i1; l1 < j1; l1++) {
        if (isLoaded(k1, 64, l1)) {
          for (int i2 = k - 1; i2 < l; i2++) {
            Block block;
            Block block;
            if ((k1 >= -30000000) && (k1 < 30000000) && (l1 >= -30000000) && (l1 < 30000000)) {
              block = getType(k1, i2, l1);
            } else {
              block = Blocks.BEDROCK;
            }
            
            block.a(this, k1, i2, l1, axisalignedbb, M, (Entity)null);
          }
        }
      }
    }
    
    return M;
  }
  
  public int a(float f) {
    float f1 = c(f);
    float f2 = 1.0F - (MathHelper.cos(f1 * 3.141593F * 2.0F) * 2.0F + 0.5F);
    
    if (f2 < 0.0F) {
      f2 = 0.0F;
    }
    
    if (f2 > 1.0F) {
      f2 = 1.0F;
    }
    
    f2 = 1.0F - f2;
    f2 = (float)(f2 * (1.0D - j(f) * 5.0F / 16.0D));
    f2 = (float)(f2 * (1.0D - h(f) * 5.0F / 16.0D));
    f2 = 1.0F - f2;
    return (int)(f2 * 11.0F);
  }
  
  public float c(float f) {
    return worldProvider.a(worldData.getDayTime(), f);
  }
  
  public float x() {
    return WorldProvider.a[worldProvider.a(worldData.getDayTime())];
  }
  
  public float d(float f) {
    float f1 = c(f);
    
    return f1 * 3.141593F * 2.0F;
  }
  
  public int h(int i, int j) {
    return getChunkAtWorldCoords(i, j).d(i & 0xF, j & 0xF);
  }
  
  public int i(int i, int j) {
    Chunk chunk = getChunkAtWorldCoords(i, j);
    int k = chunk.h() + 15;
    
    i &= 0xF;
    
    for (j &= 0xF; k > 0; k--) {
      Block block = chunk.getType(i, k, j);
      
      if ((block.getMaterial().isSolid()) && (block.getMaterial() != Material.LEAVES)) {
        return k + 1;
      }
    }
    
    return -1;
  }
  
  public void a(int i, int j, int k, Block block, int l) {}
  
  public void a(int i, int j, int k, Block block, int l, int i1) {}
  
  public void b(int i, int j, int k, Block block, int l, int i1) {}
  
  public void tickEntities() {
    methodProfiler.a("entities");
    methodProfiler.a("global");
    





    for (int i = 0; i < this.i.size(); i++) {
      Entity entity = (Entity)this.i.get(i);
      
      if (entity != null)
      {


        ChunkProviderServer chunkProviderServer = chunkProviderServer;
        if (!unloadQueue.contains(MathHelper.floor(locX) >> 4, MathHelper.floor(locZ) >> 4))
        {

          try
          {

            ticksLived += 1;
            entity.h();
          } catch (Throwable throwable) {
            CrashReport crashreport = CrashReport.a(throwable, "Ticking entity");
            CrashReportSystemDetails crashreportsystemdetails = crashreport.a("Entity being ticked");
            if (entity == null) {
              crashreportsystemdetails.a("Entity", "~~NULL~~");
            } else {
              entity.a(crashreportsystemdetails);
            }
            
            throw new ReportedException(crashreport);
          }
          
          if (dead)
            this.i.remove(i--);
        }
      }
    }
    methodProfiler.c("remove");
    entityList.removeAll(f);
    



    for (i = 0; i < f.size(); i++) {
      Entity entity = (Entity)f.get(i);
      int j = ai;
      int k = ak;
      if ((ah) && (isChunkLoaded(j, k))) {
        getChunkAt(j, k).b(entity);
      }
    }
    
    for (i = 0; i < f.size(); i++) {
      b((Entity)f.get(i));
    }
    
    f.clear();
    methodProfiler.c("regular");
    
    for (i = 0; i < entityList.size(); i++) {
      Entity entity = (Entity)entityList.get(i);
      

      ChunkProviderServer chunkProviderServer = chunkProviderServer;
      if (!unloadQueue.contains(MathHelper.floor(locX) >> 4, MathHelper.floor(locZ) >> 4))
      {



        if (vehicle != null) {
          if ((vehicle.dead) || (vehicle.passenger != entity))
          {


            vehicle.passenger = null;
            vehicle = null;
          }
        } else {
          methodProfiler.a("tick");
          if (!dead) {
            try {
              playerJoinedWorld(entity);
            } catch (Throwable throwable1) {
              CrashReport crashreport = CrashReport.a(throwable1, "Ticking entity");
              CrashReportSystemDetails crashreportsystemdetails = crashreport.a("Entity being ticked");
              entity.a(crashreportsystemdetails);
              throw new ReportedException(crashreport);
            }
          }
          
          methodProfiler.b();
          methodProfiler.a("remove");
          if (dead) {
            int j = ai;
            int k = ak;
            if ((ah) && (isChunkLoaded(j, k))) {
              getChunkAt(j, k).b(entity);
            }
            
            entityList.remove(i--);
            b(entity);
          }
          
          methodProfiler.b();
        } }
    }
    methodProfiler.c("blockEntities");
    N = true;
    Iterator iterator = tileEntityList.iterator();
    
    while (iterator.hasNext()) {
      TileEntity tileentity = (TileEntity)iterator.next();
      
      ChunkProviderServer chunkProviderServer = chunkProviderServer;
      if (!unloadQueue.contains(x >> 4, z >> 4))
      {



        if ((!tileentity.r()) && (tileentity.o()) && (isLoaded(x, y, z))) {
          try {
            tileentity.h();
          } catch (Throwable throwable2) {
            CrashReport crashreport = CrashReport.a(throwable2, "Ticking block entity");
            CrashReportSystemDetails crashreportsystemdetails = crashreport.a("Block entity being ticked");
            tileentity.a(crashreportsystemdetails);
            throw new ReportedException(crashreport);
          }
        }
        
        if (tileentity.r()) {
          iterator.remove();
          if (isChunkLoaded(x >> 4, z >> 4)) {
            Chunk chunk = getChunkAt(x >> 4, z >> 4);
            
            if (chunk != null) {
              chunk.f(x & 0xF, y, z & 0xF);
            }
          }
        }
      }
    }
    N = false;
    if (!b.isEmpty()) {
      tileEntityList.removeAll(b);
      b.clear();
    }
    
    methodProfiler.c("pendingBlockEntities");
    if (!a.isEmpty()) {
      for (int l = 0; l < a.size(); l++) {
        TileEntity tileentity1 = (TileEntity)a.get(l);
        
        if (!tileentity1.r())
        {





          if (isChunkLoaded(x >> 4, z >> 4)) {
            Chunk chunk1 = getChunkAt(x >> 4, z >> 4);
            
            if (chunk1 != null) {
              chunk1.a(x & 0xF, y, z & 0xF, tileentity1);
              
              if (!tileEntityList.contains(tileentity1)) {
                tileEntityList.add(tileentity1);
              }
            }
          }
          

          notify(x, y, z);
        }
      }
      
      a.clear();
    }
    
    methodProfiler.b();
    methodProfiler.b();
  }
  
  public void a(Collection collection) {
    if (N) {
      a.addAll(collection);
    } else {
      tileEntityList.addAll(collection);
    }
  }
  
  public void playerJoinedWorld(Entity entity) {
    entityJoinedWorld(entity, true);
  }
  
  public void entityJoinedWorld(Entity entity, boolean flag) {
    int i = MathHelper.floor(locX);
    int j = MathHelper.floor(locZ);
    byte b0 = 32;
    
    if ((!flag) || (b(i - b0, 0, j - b0, i + b0, 0, j + b0))) {
      T = locX;
      U = locY;
      V = locZ;
      lastYaw = yaw;
      lastPitch = pitch;
      if ((flag) && (ah)) {
        ticksLived += 1;
        if (vehicle != null) {
          entity.ab();
        } else {
          entity.h();
        }
      }
      
      methodProfiler.a("chunkCheck");
      if ((Double.isNaN(locX)) || (Double.isInfinite(locX))) {
        locX = T;
      }
      
      if ((Double.isNaN(locY)) || (Double.isInfinite(locY))) {
        locY = U;
      }
      
      if ((Double.isNaN(locZ)) || (Double.isInfinite(locZ))) {
        locZ = V;
      }
      
      if ((Double.isNaN(pitch)) || (Double.isInfinite(pitch))) {
        pitch = lastPitch;
      }
      
      if ((Double.isNaN(yaw)) || (Double.isInfinite(yaw))) {
        yaw = lastYaw;
      }
      
      int k = MathHelper.floor(locX / 16.0D);
      int l = MathHelper.floor(locY / 16.0D);
      int i1 = MathHelper.floor(locZ / 16.0D);
      
      if ((!ah) || (ai != k) || (aj != l) || (ak != i1)) {
        if ((ah) && (isChunkLoaded(ai, ak))) {
          getChunkAt(ai, ak).a(entity, aj);
        }
        
        if (isChunkLoaded(k, i1)) {
          ah = true;
          getChunkAt(k, i1).a(entity);
        } else {
          ah = false;
        }
      }
      
      methodProfiler.b();
      if ((flag) && (ah) && (passenger != null)) {
        if ((!passenger.dead) && (passenger.vehicle == entity)) {
          playerJoinedWorld(passenger);
        } else {
          passenger.vehicle = null;
          passenger = null;
        }
      }
    }
  }
  
  public boolean b(AxisAlignedBB axisalignedbb) {
    return a(axisalignedbb, (Entity)null);
  }
  
  public boolean a(AxisAlignedBB axisalignedbb, Entity entity) {
    List list = getEntities((Entity)null, axisalignedbb);
    
    for (int i = 0; i < list.size(); i++) {
      Entity entity1 = (Entity)list.get(i);
      
      if ((!dead) && (l) && (entity1 != entity)) {
        return false;
      }
    }
    
    return true;
  }
  
  public boolean c(AxisAlignedBB axisalignedbb) {
    int i = MathHelper.floor(a);
    int j = MathHelper.floor(d + 1.0D);
    int k = MathHelper.floor(b);
    int l = MathHelper.floor(e + 1.0D);
    int i1 = MathHelper.floor(c);
    int j1 = MathHelper.floor(f + 1.0D);
    
    if (a < 0.0D) {
      i--;
    }
    
    if (b < 0.0D) {
      k--;
    }
    
    if (c < 0.0D) {
      i1--;
    }
    
    for (int k1 = i; k1 < j; k1++) {
      for (int l1 = k; l1 < l; l1++) {
        for (int i2 = i1; i2 < j1; i2++) {
          Block block = getType(k1, l1, i2);
          
          if (block.getMaterial() != Material.AIR) {
            return true;
          }
        }
      }
    }
    
    return false;
  }
  
  public boolean containsLiquid(AxisAlignedBB axisalignedbb) {
    int i = MathHelper.floor(a);
    int j = MathHelper.floor(d + 1.0D);
    int k = MathHelper.floor(b);
    int l = MathHelper.floor(e + 1.0D);
    int i1 = MathHelper.floor(c);
    int j1 = MathHelper.floor(f + 1.0D);
    
    if (a < 0.0D) {
      i--;
    }
    
    if (b < 0.0D) {
      k--;
    }
    
    if (c < 0.0D) {
      i1--;
    }
    
    for (int k1 = i; k1 < j; k1++) {
      for (int l1 = k; l1 < l; l1++) {
        for (int i2 = i1; i2 < j1; i2++) {
          Block block = getType(k1, l1, i2);
          
          if (block.getMaterial().isLiquid()) {
            return true;
          }
        }
      }
    }
    
    return false;
  }
  
  public boolean e(AxisAlignedBB axisalignedbb) {
    int i = MathHelper.floor(a);
    int j = MathHelper.floor(d + 1.0D);
    int k = MathHelper.floor(b);
    int l = MathHelper.floor(e + 1.0D);
    int i1 = MathHelper.floor(c);
    int j1 = MathHelper.floor(f + 1.0D);
    
    if (b(i, k, i1, j, l, j1)) {
      for (int k1 = i; k1 < j; k1++) {
        for (int l1 = k; l1 < l; l1++) {
          for (int i2 = i1; i2 < j1; i2++) {
            Block block = getType(k1, l1, i2);
            
            if ((block == Blocks.FIRE) || (block == Blocks.LAVA) || (block == Blocks.STATIONARY_LAVA)) {
              return true;
            }
          }
        }
      }
    }
    
    return false;
  }
  
  public boolean a(AxisAlignedBB axisalignedbb, Material material, Entity entity) {
    int i = MathHelper.floor(a);
    int j = MathHelper.floor(d + 1.0D);
    int k = MathHelper.floor(b);
    int l = MathHelper.floor(e + 1.0D);
    int i1 = MathHelper.floor(c);
    int j1 = MathHelper.floor(f + 1.0D);
    
    if (!b(i, k, i1, j, l, j1)) {
      return false;
    }
    boolean flag = false;
    Vec3D vec3d = getVec3DPool().create(0.0D, 0.0D, 0.0D);
    
    for (int k1 = i; k1 < j; k1++) {
      for (int l1 = k; l1 < l; l1++) {
        for (int i2 = i1; i2 < j1; i2++) {
          Block block = getType(k1, l1, i2);
          
          if (block.getMaterial() == material) {
            double d0 = l1 + 1 - BlockFluids.b(getData(k1, l1, i2));
            
            if (l >= d0) {
              flag = true;
              block.a(this, k1, l1, i2, entity, vec3d);
            }
          }
        }
      }
    }
    
    if ((vec3d.b() > 0.0D) && (entity.aC())) {
      vec3d = vec3d.a();
      double d1 = 0.014D;
      
      motX += c * d1;
      motY += d * d1;
      motZ += e * d1;
    }
    b.release(vec3d);
    
    return flag;
  }
  
  public boolean a(AxisAlignedBB axisalignedbb, Material material)
  {
    int i = MathHelper.floor(a);
    int j = MathHelper.floor(d + 1.0D);
    int k = MathHelper.floor(b);
    int l = MathHelper.floor(e + 1.0D);
    int i1 = MathHelper.floor(c);
    int j1 = MathHelper.floor(f + 1.0D);
    
    for (int k1 = i; k1 < j; k1++) {
      for (int l1 = k; l1 < l; l1++) {
        for (int i2 = i1; i2 < j1; i2++) {
          if (getType(k1, l1, i2).getMaterial() == material) {
            return true;
          }
        }
      }
    }
    
    return false;
  }
  
  public boolean b(AxisAlignedBB axisalignedbb, Material material) {
    int i = MathHelper.floor(a);
    int j = MathHelper.floor(d + 1.0D);
    int k = MathHelper.floor(b);
    int l = MathHelper.floor(e + 1.0D);
    int i1 = MathHelper.floor(c);
    int j1 = MathHelper.floor(f + 1.0D);
    
    for (int k1 = i; k1 < j; k1++) {
      for (int l1 = k; l1 < l; l1++) {
        for (int i2 = i1; i2 < j1; i2++) {
          Block block = getType(k1, l1, i2);
          
          if (block.getMaterial() == material) {
            int j2 = getData(k1, l1, i2);
            double d0 = l1 + 1;
            
            if (j2 < 8) {
              d0 = l1 + 1 - j2 / 8.0D;
            }
            
            if (d0 >= b) {
              return true;
            }
          }
        }
      }
    }
    
    return false;
  }
  
  public Explosion explode(Entity entity, double d0, double d1, double d2, float f, boolean flag) {
    return createExplosion(entity, d0, d1, d2, f, false, flag);
  }
  
  public Explosion createExplosion(Entity entity, double d0, double d1, double d2, float f, boolean flag, boolean flag1) {
    Explosion explosion = new Explosion(this, entity, d0, d1, d2, f);
    
    a = flag;
    b = flag1;
    explosion.a();
    explosion.a(true);
    return explosion;
  }
  
  public float a(Vec3D vec3d, AxisAlignedBB axisalignedbb) {
    double d0 = 1.0D / ((d - a) * 2.0D + 1.0D);
    double d1 = 1.0D / ((e - b) * 2.0D + 1.0D);
    double d2 = 1.0D / ((f - c) * 2.0D + 1.0D);
    int i = 0;
    int j = 0;
    
    Vec3D vec3d2 = b.create(0.0D, 0.0D, 0.0D);
    for (float f = 0.0F; f <= 1.0F; f = (float)(f + d0)) {
      for (float f1 = 0.0F; f1 <= 1.0F; f1 = (float)(f1 + d1)) {
        for (float f2 = 0.0F; f2 <= 1.0F; f2 = (float)(f2 + d2)) {
          double d3 = a + (d - a) * f;
          double d4 = b + (e - b) * f1;
          double d5 = c + (f - c) * f2;
          
          if (a(vec3d2.b(d3, d4, d5), vec3d) == null) {
            i++;
          }
          
          j++;
        }
      }
    }
    b.release(vec3d2);
    
    return i / j;
  }
  
  public boolean douseFire(EntityHuman entityhuman, int i, int j, int k, int l) {
    if (l == 0) {
      j--;
    }
    
    if (l == 1) {
      j++;
    }
    
    if (l == 2) {
      k--;
    }
    
    if (l == 3) {
      k++;
    }
    
    if (l == 4) {
      i--;
    }
    
    if (l == 5) {
      i++;
    }
    
    if (getType(i, j, k) == Blocks.FIRE) {
      a(entityhuman, 1004, i, j, k, 0);
      setAir(i, j, k);
      return true;
    }
    return false;
  }
  
  public TileEntity getTileEntity(int i, int j, int k)
  {
    if ((j >= 0) && (j < 256)) {
      TileEntity tileentity = null;
      


      if (N) {
        for (int l = 0; l < a.size(); l++) {
          TileEntity tileentity1 = (TileEntity)a.get(l);
          if ((!tileentity1.r()) && (x == i) && (y == j) && (z == k)) {
            tileentity = tileentity1;
            break;
          }
        }
      }
      
      if (tileentity == null) {
        Chunk chunk = getChunkAt(i >> 4, k >> 4);
        
        if (chunk != null) {
          tileentity = chunk.e(i & 0xF, j, k & 0xF);
        }
      }
      
      if (tileentity == null) {
        for (int l = 0; l < a.size(); l++) {
          TileEntity tileentity1 = (TileEntity)a.get(l);
          if ((!tileentity1.r()) && (x == i) && (y == j) && (z == k)) {
            tileentity = tileentity1;
            break;
          }
        }
      }
      
      return tileentity;
    }
    return null;
  }
  
  public void setTileEntity(int i, int j, int k, TileEntity tileentity)
  {
    if ((tileentity != null) && (!tileentity.r())) {
      if (N) {
        x = i;
        y = j;
        z = k;
        Iterator iterator = a.iterator();
        
        while (iterator.hasNext()) {
          TileEntity tileentity1 = (TileEntity)iterator.next();
          
          if ((x == i) && (y == j) && (z == k)) {
            tileentity1.s();
            iterator.remove();
          }
        }
        
        a.add(tileentity);
      } else {
        tileEntityList.add(tileentity);
        Chunk chunk = getChunkAt(i >> 4, k >> 4);
        
        if (chunk != null) {
          chunk.a(i & 0xF, j, k & 0xF, tileentity);
        }
      }
    }
  }
  
  public void p(int i, int j, int k) {
    TileEntity tileentity = getTileEntity(i, j, k);
    
    if ((tileentity != null) && (N)) {
      tileentity.s();
      a.remove(tileentity);
    } else {
      if (tileentity != null) {
        a.remove(tileentity);
        tileEntityList.remove(tileentity);
      }
      
      Chunk chunk = getChunkAt(i >> 4, k >> 4);
      
      if (chunk != null) {
        chunk.f(i & 0xF, j, k & 0xF);
      }
    }
  }
  
  public void a(TileEntity tileentity) {
    b.add(tileentity);
  }
  
  public boolean q(int i, int j, int k) {
    AxisAlignedBB axisalignedbb = getType(i, j, k).a(this, i, j, k);
    
    return (axisalignedbb != null) && (axisalignedbb.b() >= 1.0D);
  }
  
  public static boolean a(IBlockAccess iblockaccess, int i, int j, int k) {
    Block block = iblockaccess.getType(i, j, k);
    int l = iblockaccess.getData(i, j, k);
    
    return (block.getMaterial().k()) && (block.d());
  }
  
  public boolean c(int i, int j, int k, boolean flag) {
    if ((i >= -30000000) && (k >= -30000000) && (i < 30000000) && (k < 30000000)) {
      Chunk chunk = chunkProvider.getOrCreateChunk(i >> 4, k >> 4);
      
      if ((chunk != null) && (!chunk.isEmpty())) {
        Block block = getType(i, j, k);
        
        return (block.getMaterial().k()) && (block.d());
      }
      return flag;
    }
    
    return flag;
  }
  
  public void A()
  {
    int i = a(1.0F);
    
    if (i != j) {
      j = i;
    }
  }
  
  public void setSpawnFlags(boolean flag, boolean flag1) {
    allowMonsters = flag;
    allowAnimals = flag1;
  }
  
  public void doTick() {
    o();
  }
  
  private void a() {
    if (worldData.hasStorm()) {
      n = 1.0F;
      if (worldData.isThundering()) {
        p = 1.0F;
      }
    }
  }
  
  protected void o() {
    if ((!worldProvider.g) && 
      (!isStatic)) {
      int i = worldData.getThunderDuration();
      
      if (i <= 0) {
        if (worldData.isThundering()) {
          worldData.setThunderDuration(random.nextInt(12000) + 3600);
        } else {
          worldData.setThunderDuration(random.nextInt(168000) + 12000);
        }
      } else {
        i--;
        worldData.setThunderDuration(i);
        if (i <= 0)
        {
          ThunderChangeEvent thunder = new ThunderChangeEvent(getWorld(), !worldData.isThundering());
          getServer().getPluginManager().callEvent(thunder);
          if (!thunder.isCancelled()) {
            worldData.setThundering(!worldData.isThundering());
          }
        }
      }
      

      o = p;
      if (worldData.isThundering()) {
        p = ((float)(p + 0.01D));
      } else {
        p = ((float)(p - 0.01D));
      }
      
      p = MathHelper.a(p, 0.0F, 1.0F);
      int j = worldData.getWeatherDuration();
      
      if (j <= 0) {
        if (worldData.hasStorm()) {
          worldData.setWeatherDuration(random.nextInt(12000) + 12000);
        } else {
          worldData.setWeatherDuration(random.nextInt(168000) + 12000);
        }
      } else {
        j--;
        worldData.setWeatherDuration(j);
        if (j <= 0)
        {
          WeatherChangeEvent weather = new WeatherChangeEvent(getWorld(), !worldData.hasStorm());
          getServer().getPluginManager().callEvent(weather);
          
          if (!weather.isCancelled()) {
            worldData.setStorm(!worldData.hasStorm());
          }
        }
      }
      

      m = n;
      if (worldData.hasStorm()) {
        n = ((float)(n + 0.01D));
      } else {
        n = ((float)(n - 0.01D));
      }
      
      n = MathHelper.a(n, 0.0F, 1.0F);
    }
  }
  

  protected void B()
  {
    methodProfiler.a("buildList");
    





    for (int i = 0; i < players.size(); i++) {
      EntityHuman entityhuman = (EntityHuman)players.get(i);
      int j = MathHelper.floor(locX / 16.0D);
      int k = MathHelper.floor(locZ / 16.0D);
      byte b0 = 7;
      
      for (int l = -b0; l <= b0; l++) {
        for (int i1 = -b0; i1 <= b0; i1++)
        {
          ChunkProviderServer chunkProviderServer = world).chunkProviderServer;
          if (!unloadQueue.contains(l + j, i1 + k))
          {



            chunkTickList.add(LongHash.toLong(l + j, i1 + k));
          }
        }
      }
    }
    methodProfiler.b();
    if (L > 0) {
      L -= 1;
    }
    
    methodProfiler.a("playerCheckLight");
    if (!players.isEmpty()) {
      i = random.nextInt(players.size());
      EntityHuman entityhuman = (EntityHuman)players.get(i);
      int j = MathHelper.floor(locX) + random.nextInt(11) - 5;
      int k = MathHelper.floor(locY) + random.nextInt(11) - 5;
      int j1 = MathHelper.floor(locZ) + random.nextInt(11) - 5;
      
      t(j, k, j1);
    }
    
    methodProfiler.b();
  }
  
  protected void a(int i, int j, Chunk chunk) {
    methodProfiler.c("moodSound");
    if ((L == 0) && (!isStatic)) {
      this.k = (this.k * 3 + 1013904223);
      int k = this.k >> 2;
      int l = k & 0xF;
      int i1 = k >> 8 & 0xF;
      int j1 = k >> 16 & 0xFF;
      Block block = chunk.getType(l, j1, i1);
      
      l += i;
      i1 += j;
      if ((block.getMaterial() == Material.AIR) && (j(l, j1, i1) <= random.nextInt(8)) && (b(EnumSkyBlock.SKY, l, j1, i1) <= 0)) {
        EntityHuman entityhuman = findNearbyPlayer(l + 0.5D, j1 + 0.5D, i1 + 0.5D, 8.0D);
        
        if ((entityhuman != null) && (entityhuman.e(l + 0.5D, j1 + 0.5D, i1 + 0.5D) > 4.0D)) {
          makeSound(l + 0.5D, j1 + 0.5D, i1 + 0.5D, "ambient.cave.cave", 0.7F, 0.8F + random.nextFloat() * 0.2F);
          L = (random.nextInt(12000) + 6000);
        }
      }
    }
    
    methodProfiler.c("checkLight");
    chunk.o();
  }
  
  protected void g() {
    B();
  }
  
  public boolean r(int i, int j, int k) {
    return d(i, j, k, false);
  }
  
  public boolean s(int i, int j, int k) {
    return d(i, j, k, true);
  }
  
  public boolean d(int i, int j, int k, boolean flag) {
    BiomeBase biomebase = getBiome(i, k);
    float f = biomebase.a(i, j, k);
    
    if (f > 0.15F) {
      return false;
    }
    if ((j >= 0) && (j < 256) && (b(EnumSkyBlock.BLOCK, i, j, k) < 10)) {
      Block block = getType(i, j, k);
      
      if (((block == Blocks.STATIONARY_WATER) || (block == Blocks.WATER)) && (getData(i, j, k) == 0)) {
        if (!flag) {
          return true;
        }
        
        boolean flag1 = true;
        
        if ((flag1) && (getType(i - 1, j, k).getMaterial() != Material.WATER)) {
          flag1 = false;
        }
        
        if ((flag1) && (getType(i + 1, j, k).getMaterial() != Material.WATER)) {
          flag1 = false;
        }
        
        if ((flag1) && (getType(i, j, k - 1).getMaterial() != Material.WATER)) {
          flag1 = false;
        }
        
        if ((flag1) && (getType(i, j, k + 1).getMaterial() != Material.WATER)) {
          flag1 = false;
        }
        
        if (!flag1) {
          return true;
        }
      }
    }
    
    return false;
  }
  
  public boolean e(int i, int j, int k, boolean flag)
  {
    BiomeBase biomebase = getBiome(i, k);
    float f = biomebase.a(i, j, k);
    
    if (f > 0.15F)
      return false;
    if (!flag) {
      return true;
    }
    if ((j >= 0) && (j < 256) && (b(EnumSkyBlock.BLOCK, i, j, k) < 10)) {
      Block block = getType(i, j, k);
      
      if ((block.getMaterial() == Material.AIR) && (Blocks.SNOW.canPlace(this, i, j, k))) {
        return true;
      }
    }
    
    return false;
  }
  
  public boolean t(int i, int j, int k)
  {
    boolean flag = false;
    
    if (!worldProvider.g) {
      flag |= c(EnumSkyBlock.SKY, i, j, k);
    }
    
    flag |= c(EnumSkyBlock.BLOCK, i, j, k);
    return flag;
  }
  
  private int a(int i, int j, int k, EnumSkyBlock enumskyblock) {
    if ((enumskyblock == EnumSkyBlock.SKY) && (i(i, j, k))) {
      return 15;
    }
    Block block = getType(i, j, k);
    int l = enumskyblock == EnumSkyBlock.SKY ? 0 : block.m();
    int i1 = block.k();
    
    if ((i1 >= 15) && (block.m() > 0)) {
      i1 = 1;
    }
    
    if (i1 < 1) {
      i1 = 1;
    }
    
    if (i1 >= 15)
      return 0;
    if (l >= 14) {
      return l;
    }
    for (int j1 = 0; j1 < 6; j1++) {
      int k1 = i + Facing.b[j1];
      int l1 = j + Facing.c[j1];
      int i2 = k + Facing.d[j1];
      int j2 = b(enumskyblock, k1, l1, i2) - i1;
      
      if (j2 > l) {
        l = j2;
      }
      
      if (l >= 14) {
        return l;
      }
    }
    
    return l;
  }
  

  public boolean c(EnumSkyBlock enumskyblock, int i, int j, int k)
  {
    if (!areChunksLoaded(i, j, k, 17)) {
      return false;
    }
    int l = 0;
    int i1 = 0;
    
    methodProfiler.a("getBrightness");
    int j1 = b(enumskyblock, i, j, k);
    int k1 = a(i, j, k, enumskyblock);
    









    if (k1 > j1) {
      I[(i1++)] = 133152;
    } else if (k1 < j1) {
      I[(i1++)] = (0x20820 | j1 << 18);
      
      while (l < i1) {
        int l1 = I[(l++)];
        int i2 = (l1 & 0x3F) - 32 + i;
        int j2 = (l1 >> 6 & 0x3F) - 32 + j;
        int k2 = (l1 >> 12 & 0x3F) - 32 + k;
        int l2 = l1 >> 18 & 0xF;
        int i3 = b(enumskyblock, i2, j2, k2);
        if (i3 == l2) {
          b(enumskyblock, i2, j2, k2, 0);
          if (l2 > 0) {
            int j3 = MathHelper.a(i2 - i);
            int l3 = MathHelper.a(j2 - j);
            int k3 = MathHelper.a(k2 - k);
            if (j3 + l3 + k3 < 17) {
              for (int i4 = 0; i4 < 6; i4++) {
                int j4 = i2 + Facing.b[i4];
                int k4 = j2 + Facing.c[i4];
                int l4 = k2 + Facing.d[i4];
                int i5 = Math.max(1, getType(j4, k4, l4).k());
                
                i3 = b(enumskyblock, j4, k4, l4);
                if ((i3 == l2 - i5) && (i1 < I.length)) {
                  I[(i1++)] = (j4 - i + 32 | k4 - j + 32 << 6 | l4 - k + 32 << 12 | l2 - i5 << 18);
                }
              }
            }
          }
        }
      }
      
      l = 0;
    }
    
    methodProfiler.b();
    methodProfiler.a("checkedPosition < toCheckCount");
    
    while (l < i1) {
      int l1 = I[(l++)];
      int i2 = (l1 & 0x3F) - 32 + i;
      int j2 = (l1 >> 6 & 0x3F) - 32 + j;
      int k2 = (l1 >> 12 & 0x3F) - 32 + k;
      int l2 = b(enumskyblock, i2, j2, k2);
      int i3 = a(i2, j2, k2, enumskyblock);
      if (i3 != l2) {
        b(enumskyblock, i2, j2, k2, i3);
        if (i3 > l2) {
          int j3 = Math.abs(i2 - i);
          int l3 = Math.abs(j2 - j);
          int k3 = Math.abs(k2 - k);
          boolean flag = i1 < I.length - 6;
          
          if ((j3 + l3 + k3 < 17) && (flag)) {
            if (b(enumskyblock, i2 - 1, j2, k2) < i3) {
              I[(i1++)] = (i2 - 1 - i + 32 + (j2 - j + 32 << 6) + (k2 - k + 32 << 12));
            }
            
            if (b(enumskyblock, i2 + 1, j2, k2) < i3) {
              I[(i1++)] = (i2 + 1 - i + 32 + (j2 - j + 32 << 6) + (k2 - k + 32 << 12));
            }
            
            if (b(enumskyblock, i2, j2 - 1, k2) < i3) {
              I[(i1++)] = (i2 - i + 32 + (j2 - 1 - j + 32 << 6) + (k2 - k + 32 << 12));
            }
            
            if (b(enumskyblock, i2, j2 + 1, k2) < i3) {
              I[(i1++)] = (i2 - i + 32 + (j2 + 1 - j + 32 << 6) + (k2 - k + 32 << 12));
            }
            
            if (b(enumskyblock, i2, j2, k2 - 1) < i3) {
              I[(i1++)] = (i2 - i + 32 + (j2 - j + 32 << 6) + (k2 - 1 - k + 32 << 12));
            }
            
            if (b(enumskyblock, i2, j2, k2 + 1) < i3) {
              I[(i1++)] = (i2 - i + 32 + (j2 - j + 32 << 6) + (k2 + 1 - k + 32 << 12));
            }
          }
        }
      }
    }
    
    methodProfiler.b();
    return true;
  }
  
  public boolean a(boolean flag)
  {
    return false;
  }
  
  public List a(Chunk chunk, boolean flag) {
    return null;
  }
  
  public List getEntities(Entity entity, AxisAlignedBB axisalignedbb) {
    return getEntities(entity, axisalignedbb, (IEntitySelector)null);
  }
  
  public List getEntities(Entity entity, AxisAlignedBB axisalignedbb, IEntitySelector ientityselector) {
    ArrayList arraylist = new ArrayList();
    int i = MathHelper.floor((a - 2.0D) / 16.0D);
    int j = MathHelper.floor((d + 2.0D) / 16.0D);
    int k = MathHelper.floor((c - 2.0D) / 16.0D);
    int l = MathHelper.floor((f + 2.0D) / 16.0D);
    
    for (int i1 = i; i1 <= j; i1++) {
      for (int j1 = k; j1 <= l; j1++) {
        if (isChunkLoaded(i1, j1)) {
          getChunkAt(i1, j1).a(entity, axisalignedbb, arraylist, ientityselector);
        }
      }
    }
    
    return arraylist;
  }
  
  public List a(Class oclass, AxisAlignedBB axisalignedbb) {
    return a(oclass, axisalignedbb, (IEntitySelector)null);
  }
  
  public List a(Class oclass, AxisAlignedBB axisalignedbb, IEntitySelector ientityselector) {
    int i = MathHelper.floor((a - 2.0D) / 16.0D);
    int j = MathHelper.floor((d + 2.0D) / 16.0D);
    int k = MathHelper.floor((c - 2.0D) / 16.0D);
    int l = MathHelper.floor((f + 2.0D) / 16.0D);
    ArrayList arraylist = new ArrayList();
    
    for (int i1 = i; i1 <= j; i1++) {
      for (int j1 = k; j1 <= l; j1++) {
        if (isChunkLoaded(i1, j1)) {
          getChunkAt(i1, j1).a(oclass, axisalignedbb, arraylist, ientityselector);
        }
      }
    }
    
    return arraylist;
  }
  
  public Entity a(Class oclass, AxisAlignedBB axisalignedbb, Entity entity) {
    List list = a(oclass, axisalignedbb);
    Entity entity1 = null;
    double d0 = 1.7976931348623157E+308D;
    
    for (int i = 0; i < list.size(); i++) {
      Entity entity2 = (Entity)list.get(i);
      
      if (entity2 != entity) {
        double d1 = entity.e(entity2);
        
        if (d1 <= d0) {
          entity1 = entity2;
          d0 = d1;
        }
      }
    }
    
    return entity1;
  }
  
  public abstract Entity getEntity(int paramInt);
  
  public void b(int i, int j, int k, TileEntity tileentity) {
    if (isLoaded(i, j, k)) {
      getChunkAtWorldCoords(i, k).e();
    }
  }
  
  public int a(Class oclass) {
    int i = 0;
    
    for (int j = 0; j < entityList.size(); j++) {
      Entity entity = (Entity)entityList.get(j);
      

      if ((entity instanceof EntityInsentient)) {
        EntityInsentient entityinsentient = (EntityInsentient)entity;
        if ((entityinsentient.isTypeNotPersistent()) && (entityinsentient.isPersistent())) {}



      }
      else if (oclass.isAssignableFrom(entity.getClass()))
      {

        i++;
      }
    }
    
    return i;
  }
  

  public void a(List list)
  {
    Entity entity = null;
    
    for (int i = 0; i < list.size(); i++) {
      entity = (Entity)list.get(i);
      if (entity != null)
      {

        entityList.add(entity);
        
        a((Entity)list.get(i));
      }
    }
  }
  
  public void b(List list) { f.addAll(list); }
  
  public boolean mayPlace(Block block, int i, int j, int k, boolean flag, int l, Entity entity, ItemStack itemstack)
  {
    Block block1 = getType(i, j, k);
    AxisAlignedBB axisalignedbb = flag ? null : block.a(this, i, j, k);
    

    boolean defaultReturn = (axisalignedbb == null) || (a(axisalignedbb, entity));
    

    BlockCanBuildEvent event = new BlockCanBuildEvent(getWorld().getBlockAt(i, j, k), CraftMagicNumbers.getId(block), defaultReturn);
    getServer().getPluginManager().callEvent(event);
    
    return event.isBuildable();
  }
  
  public PathEntity findPath(Entity entity, Entity entity1, float f, boolean flag, boolean flag1, boolean flag2, boolean flag3)
  {
    methodProfiler.a("pathfind");
    int i = MathHelper.floor(locX);
    int j = MathHelper.floor(locY + 1.0D);
    int k = MathHelper.floor(locZ);
    int l = (int)(f + 16.0F);
    int i1 = i - l;
    int j1 = j - l;
    int k1 = k - l;
    int l1 = i + l;
    int i2 = j + l;
    int j2 = k + l;
    ChunkCache chunkcache = new ChunkCache(this, i1, j1, k1, l1, i2, j2, 0);
    PathEntity pathentity = new Pathfinder(chunkcache, flag, flag1, flag2, flag3).a(entity, entity1, f);
    
    methodProfiler.b();
    return pathentity;
  }
  
  public PathEntity a(Entity entity, int i, int j, int k, float f, boolean flag, boolean flag1, boolean flag2, boolean flag3) {
    methodProfiler.a("pathfind");
    int l = MathHelper.floor(locX);
    int i1 = MathHelper.floor(locY);
    int j1 = MathHelper.floor(locZ);
    int k1 = (int)(f + 8.0F);
    int l1 = l - k1;
    int i2 = i1 - k1;
    int j2 = j1 - k1;
    int k2 = l + k1;
    int l2 = i1 + k1;
    int i3 = j1 + k1;
    ChunkCache chunkcache = new ChunkCache(this, l1, i2, j2, k2, l2, i3, 0);
    PathEntity pathentity = new Pathfinder(chunkcache, flag, flag1, flag2, flag3).a(entity, i, j, k, f);
    
    methodProfiler.b();
    return pathentity;
  }
  
  public int getBlockPower(int i, int j, int k, int l) {
    return getType(i, j, k).c(this, i, j, k, l);
  }
  
  public int getBlockPower(int i, int j, int k) {
    byte b0 = 0;
    int l = Math.max(b0, getBlockPower(i, j - 1, k, 0));
    
    if (l >= 15) {
      return l;
    }
    l = Math.max(l, getBlockPower(i, j + 1, k, 1));
    if (l >= 15) {
      return l;
    }
    l = Math.max(l, getBlockPower(i, j, k - 1, 2));
    if (l >= 15) {
      return l;
    }
    l = Math.max(l, getBlockPower(i, j, k + 1, 3));
    if (l >= 15) {
      return l;
    }
    l = Math.max(l, getBlockPower(i - 1, j, k, 4));
    if (l >= 15) {
      return l;
    }
    l = Math.max(l, getBlockPower(i + 1, j, k, 5));
    return l >= 15 ? l : l;
  }
  




  public boolean isBlockFacePowered(int i, int j, int k, int l)
  {
    return getBlockFacePower(i, j, k, l) > 0;
  }
  
  public int getBlockFacePower(int i, int j, int k, int l) {
    return getType(i, j, k).r() ? getBlockPower(i, j, k) : getType(i, j, k).b(this, i, j, k, l);
  }
  
  public boolean isBlockIndirectlyPowered(int i, int j, int k) {
    return getBlockFacePower(i, j - 1, k, 0) > 0;
  }
  
  public int getHighestNeighborSignal(int i, int j, int k) {
    int l = 0;
    
    for (int i1 = 0; i1 < 6; i1++) {
      int j1 = getBlockFacePower(i + Facing.b[i1], j + Facing.c[i1], k + Facing.d[i1], i1);
      
      if (j1 >= 15) {
        return 15;
      }
      
      if (j1 > l) {
        l = j1;
      }
    }
    
    return l;
  }
  
  public EntityHuman findNearbyPlayer(Entity entity, double d0) {
    return findNearbyPlayer(locX, locY, locZ, d0);
  }
  
  public EntityHuman findNearbyPlayer(double d0, double d1, double d2, double d3) {
    double d4 = -1.0D;
    EntityHuman entityhuman = null;
    
    for (int i = 0; i < players.size(); i++) {
      EntityHuman entityhuman1 = (EntityHuman)players.get(i);
      
      if ((entityhuman1 != null) && (!dead))
      {


        double d5 = entityhuman1.e(d0, d1, d2);
        
        if (((d3 < 0.0D) || (d5 < d3 * d3)) && ((d4 == -1.0D) || (d5 < d4))) {
          d4 = d5;
          entityhuman = entityhuman1;
        }
      }
    }
    return entityhuman;
  }
  
  public EntityHuman findNearbyVulnerablePlayer(Entity entity, double d0) {
    return findNearbyVulnerablePlayer(locX, locY, locZ, d0);
  }
  
  public EntityHuman findNearbyVulnerablePlayer(double d0, double d1, double d2, double d3) {
    double d4 = -1.0D;
    EntityHuman entityhuman = null;
    
    for (int i = 0; i < players.size(); i++) {
      EntityHuman entityhuman1 = (EntityHuman)players.get(i);
      
      if ((entityhuman1 != null) && (!dead))
      {



        if ((!abilities.isInvulnerable) && (entityhuman1.isAlive())) {
          double d5 = entityhuman1.e(d0, d1, d2);
          double d6 = d3;
          
          if (entityhuman1.isSneaking()) {
            d6 = d3 * 0.800000011920929D;
          }
          
          if (entityhuman1.isInvisible()) {
            float f = entityhuman1.bC();
            
            if (f < 0.1F) {
              f = 0.1F;
            }
            
            d6 *= 0.7F * f;
          }
          
          if (((d3 < 0.0D) || (d5 < d6 * d6)) && ((d4 == -1.0D) || (d5 < d4))) {
            d4 = d5;
            entityhuman = entityhuman1;
          }
        }
      }
    }
    return entityhuman;
  }
  
  public EntityHuman a(String s) {
    for (int i = 0; i < players.size(); i++) {
      if (s.equals(((EntityHuman)players.get(i)).getName())) {
        return (EntityHuman)players.get(i);
      }
    }
    
    return null;
  }
  
  public void F() throws ExceptionWorldConflict {
    dataManager.checkSession();
  }
  
  public long getSeed() {
    return worldData.getSeed();
  }
  
  public long getTime() {
    return worldData.getTime();
  }
  
  public long getDayTime() {
    return worldData.getDayTime();
  }
  
  public void setDayTime(long i) {
    worldData.setDayTime(i);
  }
  
  public ChunkCoordinates getSpawn() {
    return new ChunkCoordinates(worldData.c(), worldData.d(), worldData.e());
  }
  
  public void x(int i, int j, int k) {
    worldData.setSpawn(i, j, k);
  }
  
  public boolean a(EntityHuman entityhuman, int i, int j, int k) {
    return true;
  }
  
  public void broadcastEntityEffect(Entity entity, byte b0) {}
  
  public IChunkProvider K() {
    return chunkProvider;
  }
  
  public void playNote(int i, int j, int k, Block block, int l, int i1) {
    block.a(this, i, j, k, l, i1);
  }
  
  public IDataManager getDataManager() {
    return dataManager;
  }
  
  public WorldData getWorldData() {
    return worldData;
  }
  
  public GameRules getGameRules() {
    return worldData.getGameRules();
  }
  

  public void everyoneSleeping() {}
  

  public void checkSleepStatus()
  {
    if (!isStatic) {
      everyoneSleeping();
    }
  }
  
  public float h(float f)
  {
    return (o + (p - o) * f) * j(f);
  }
  
  public float j(float f) {
    return m + (n - m) * f;
  }
  
  public boolean O() {
    return h(1.0F) > 0.9D;
  }
  
  public boolean P() {
    return j(1.0F) > 0.2D;
  }
  
  public boolean isRainingAt(int i, int j, int k) {
    if (!P())
      return false;
    if (!i(i, j, k))
      return false;
    if (h(i, k) > j) {
      return false;
    }
    BiomeBase biomebase = getBiome(i, k);
    
    return e(i, j, k, false) ? false : biomebase.d() ? false : biomebase.e();
  }
  
  public boolean z(int i, int j, int k)
  {
    BiomeBase biomebase = getBiome(i, k);
    
    return biomebase.f();
  }
  
  public void a(String s, PersistentBase persistentbase) {
    worldMaps.a(s, persistentbase);
  }
  
  public PersistentBase a(Class oclass, String s) {
    return worldMaps.get(oclass, s);
  }
  
  public int b(String s) {
    return worldMaps.a(s);
  }
  
  public void b(int i, int j, int k, int l, int i1) {
    for (int j1 = 0; j1 < u.size(); j1++) {
      ((IWorldAccess)u.get(j1)).a(i, j, k, l, i1);
    }
  }
  
  public void triggerEffect(int i, int j, int k, int l, int i1) {
    a((EntityHuman)null, i, j, k, l, i1);
  }
  
  public void a(EntityHuman entityhuman, int i, int j, int k, int l, int i1) {
    try {
      for (int j1 = 0; j1 < u.size(); j1++) {
        ((IWorldAccess)u.get(j1)).a(entityhuman, i, j, k, l, i1);
      }
    } catch (Throwable throwable) {
      CrashReport crashreport = CrashReport.a(throwable, "Playing level event");
      CrashReportSystemDetails crashreportsystemdetails = crashreport.a("Level event being played");
      
      crashreportsystemdetails.a("Block coordinates", CrashReportSystemDetails.a(j, k, l));
      crashreportsystemdetails.a("Event source", entityhuman);
      crashreportsystemdetails.a("Event type", Integer.valueOf(i));
      crashreportsystemdetails.a("Event data", Integer.valueOf(i1));
      throw new ReportedException(crashreport);
    }
  }
  
  public int getHeight() {
    return 256;
  }
  
  public int R() {
    return worldProvider.g ? 128 : 256;
  }
  
  public Random A(int i, int j, int k) {
    long l = i * 341873128712L + j * 132897987541L + getWorldData().getSeed() + k;
    
    random.setSeed(l);
    return random;
  }
  
  public ChunkPosition b(String s, int i, int j, int k) {
    return K().findNearestMapFeature(this, s, i, j, k);
  }
  
  public CrashReportSystemDetails a(CrashReport crashreport) {
    CrashReportSystemDetails crashreportsystemdetails = crashreport.a("Affected level", 1);
    
    crashreportsystemdetails.a("Level name", worldData == null ? "????" : worldData.getName());
    crashreportsystemdetails.a("All players", new CrashReportPlayers(this));
    crashreportsystemdetails.a("Chunk stats", new CrashReportChunkStats(this));
    try
    {
      worldData.a(crashreportsystemdetails);
    } catch (Throwable throwable) {
      crashreportsystemdetails.a("Level Data Unobtainable", throwable);
    }
    
    return crashreportsystemdetails;
  }
  
  public void d(int i, int j, int k, int l, int i1) {
    for (int j1 = 0; j1 < u.size(); j1++) {
      IWorldAccess iworldaccess = (IWorldAccess)u.get(j1);
      
      iworldaccess.b(i, j, k, l, i1);
    }
  }
  
  public Vec3DPool getVec3DPool() {
    return J;
  }
  
  public Calendar V() {
    if (getTime() % 600L == 0L) {
      K.setTimeInMillis(MinecraftServer.ap());
    }
    
    return K;
  }
  
  public Scoreboard getScoreboard() {
    return scoreboard;
  }
  
  public void f(int i, int j, int k, Block block) {
    for (int l = 0; l < 4; l++) {
      int i1 = i + Direction.a[l];
      int j1 = k + Direction.b[l];
      Block block1 = getType(i1, j, j1);
      
      if (Blocks.REDSTONE_COMPARATOR_OFF.e(block1)) {
        block1.doPhysics(this, i1, j, j1, block);
      } else if (block1.r()) {
        i1 += Direction.a[l];
        j1 += Direction.b[l];
        Block block2 = getType(i1, j, j1);
        
        if (Blocks.REDSTONE_COMPARATOR_OFF.e(block2)) {
          block2.doPhysics(this, i1, j, j1, block);
        }
      }
    }
  }
  
  public float b(double d0, double d1, double d2) {
    return B(MathHelper.floor(d0), MathHelper.floor(d1), MathHelper.floor(d2));
  }
  
  public float B(int i, int j, int k) {
    float f = 0.0F;
    boolean flag = difficulty == EnumDifficulty.HARD;
    
    if (isLoaded(i, j, k)) {
      float f1 = x();
      
      f += MathHelper.a((float)getChunkAtWorldCoords, s / 3600000.0F, 0.0F, 1.0F) * (flag ? 1.0F : 0.75F);
      f += f1 * 0.25F;
    }
    
    if ((difficulty == EnumDifficulty.EASY) || (difficulty == EnumDifficulty.PEACEFUL)) {
      f *= difficulty.a() / 2.0F;
    }
    
    return MathHelper.a(f, 0.0F, flag ? 1.5F : 1.0F);
  }
  
  public void X() {
    Iterator iterator = u.iterator();
    
    while (iterator.hasNext()) {
      IWorldAccess iworldaccess = (IWorldAccess)iterator.next();
      
      iworldaccess.b();
    }
  }
}
