package net.minecraft.server.v1_7_R1;

import java.util.Random;

public class WorldGenJungleTree extends WorldGenMegaTreeAbstract implements BlockSapling.TreeGenerator
{
  public WorldGenJungleTree(boolean flag, int i, int j, int k, int l)
  {
    super(flag, i, j, k, l);
  }
  
  public boolean a(World world, Random random, int i, int j, int k)
  {
    return generate(new org.bukkit.craftbukkit.v1_7_R1.CraftBlockChangeDelegate((org.bukkit.BlockChangeDelegate)world), random, i, j, k);
  }
  
  public boolean generate(org.bukkit.craftbukkit.v1_7_R1.CraftBlockChangeDelegate world, Random random, int i, int j, int k)
  {
    int l = a(random);
    
    if (!a(world, random, i, j, k, l)) {
      return false;
    }
    c(world, i, k, j + l, 2, random);
    
    for (int i1 = j + l - 2 - random.nextInt(4); i1 > j + l / 2; i1 -= 2 + random.nextInt(4)) {
      float f = random.nextFloat() * 3.141593F * 2.0F;
      int j1 = i + (int)(0.5F + MathHelper.cos(f) * 4.0F);
      int k1 = k + (int)(0.5F + MathHelper.sin(f) * 4.0F);
      


      for (int l1 = 0; l1 < 5; l1++) {
        j1 = i + (int)(1.5F + MathHelper.cos(f) * l1);
        k1 = k + (int)(1.5F + MathHelper.sin(f) * l1);
        setTypeAndData(world, j1, i1 - 3 + l1 / 2, k1, Blocks.LOG, b);
      }
      
      l1 = 1 + random.nextInt(2);
      int i2 = i1;
      
      for (int j2 = i1 - l1; j2 <= i2; j2++) {
        int k2 = j2 - i2;
        
        b(world, j1, j2, k1, 1 - k2, random);
      }
    }
    
    for (int l2 = 0; l2 < l; l2++) {
      Block block = world.getType(i, j + l2, k);
      
      if ((block.getMaterial() == Material.AIR) || (block.getMaterial() == Material.LEAVES)) {
        setTypeAndData(world, i, j + l2, k, Blocks.LOG, b);
        if (l2 > 0) {
          if ((random.nextInt(3) > 0) && (world.isEmpty(i - 1, j + l2, k))) {
            setTypeAndData(world, i - 1, j + l2, k, Blocks.VINE, 8);
          }
          
          if ((random.nextInt(3) > 0) && (world.isEmpty(i, j + l2, k - 1))) {
            setTypeAndData(world, i, j + l2, k - 1, Blocks.VINE, 1);
          }
        }
      }
      
      if (l2 < l - 1) {
        block = world.getType(i + 1, j + l2, k);
        if ((block.getMaterial() == Material.AIR) || (block.getMaterial() == Material.LEAVES)) {
          setTypeAndData(world, i + 1, j + l2, k, Blocks.LOG, b);
          if (l2 > 0) {
            if ((random.nextInt(3) > 0) && (world.isEmpty(i + 2, j + l2, k))) {
              setTypeAndData(world, i + 2, j + l2, k, Blocks.VINE, 2);
            }
            
            if ((random.nextInt(3) > 0) && (world.isEmpty(i + 1, j + l2, k - 1))) {
              setTypeAndData(world, i + 1, j + l2, k - 1, Blocks.VINE, 1);
            }
          }
        }
        
        block = world.getType(i + 1, j + l2, k + 1);
        if ((block.getMaterial() == Material.AIR) || (block.getMaterial() == Material.LEAVES)) {
          setTypeAndData(world, i + 1, j + l2, k + 1, Blocks.LOG, b);
          if (l2 > 0) {
            if ((random.nextInt(3) > 0) && (world.isEmpty(i + 2, j + l2, k + 1))) {
              setTypeAndData(world, i + 2, j + l2, k + 1, Blocks.VINE, 2);
            }
            
            if ((random.nextInt(3) > 0) && (world.isEmpty(i + 1, j + l2, k + 2))) {
              setTypeAndData(world, i + 1, j + l2, k + 2, Blocks.VINE, 4);
            }
          }
        }
        
        block = world.getType(i, j + l2, k + 1);
        if ((block.getMaterial() == Material.AIR) || (block.getMaterial() == Material.LEAVES)) {
          setTypeAndData(world, i, j + l2, k + 1, Blocks.LOG, b);
          if (l2 > 0) {
            if ((random.nextInt(3) > 0) && (world.isEmpty(i - 1, j + l2, k + 1))) {
              setTypeAndData(world, i - 1, j + l2, k + 1, Blocks.VINE, 8);
            }
            
            if ((random.nextInt(3) > 0) && (world.isEmpty(i, j + l2, k + 2))) {
              setTypeAndData(world, i, j + l2, k + 2, Blocks.VINE, 4);
            }
          }
        }
      }
    }
    
    return true;
  }
  

  private void c(org.bukkit.craftbukkit.v1_7_R1.CraftBlockChangeDelegate world, int i, int j, int k, int l, Random random)
  {
    byte b0 = 2;
    
    for (int i1 = k - b0; i1 <= k; i1++) {
      int j1 = i1 - k;
      
      a(world, i, i1, j, l + 1 - j1, random);
    }
  }
}
