package net.minecraft.server.v1_7_R1;

import java.util.Random;
import org.bukkit.craftbukkit.v1_7_R1.CraftBlockChangeDelegate;

public class WorldGenSwampTree extends WorldGenTreeAbstract implements BlockSapling.TreeGenerator
{
  public WorldGenSwampTree()
  {
    super(false);
  }
  
  public boolean a(World world, Random random, int i, int j, int k)
  {
    return generate(new CraftBlockChangeDelegate((org.bukkit.BlockChangeDelegate)world), random, i, j, k);
  }
  


  public boolean generate(CraftBlockChangeDelegate world, Random random, int i, int j, int k)
  {
    for (int l = random.nextInt(4) + 5; world.getType(i, j - 1, k).getMaterial() == Material.WATER; j--) {}
    


    boolean flag = true;
    
    if ((j >= 1) && (j + l + 1 <= 256))
    {


      for (int k1 = j; k1 <= j + 1 + l; k1++) {
        byte b0 = 1;
        
        if (k1 == j) {
          b0 = 0;
        }
        
        if (k1 >= j + 1 + l - 2) {
          b0 = 3;
        }
        
        for (int i1 = i - b0; (i1 <= i + b0) && (flag); i1++) {
          for (int j1 = k - b0; (j1 <= k + b0) && (flag); j1++) {
            if ((k1 >= 0) && (k1 < 256)) {
              Block block = world.getType(i1, k1, j1);
              
              if ((block.getMaterial() != Material.AIR) && (block.getMaterial() != Material.LEAVES)) {
                if ((block != Blocks.STATIONARY_WATER) && (block != Blocks.WATER)) {
                  flag = false;
                } else if (k1 > j) {
                  flag = false;
                }
              }
            } else {
              flag = false;
            }
          }
        }
      }
      
      if (!flag) {
        return false;
      }
      Block block1 = world.getType(i, j - 1, k);
      
      if (((block1 == Blocks.GRASS) || (block1 == Blocks.DIRT)) && (j < 256 - l - 1)) {
        setType(world, i, j - 1, k, Blocks.DIRT);
        




        for (int j2 = j - 3 + l; j2 <= j + l; j2++) {
          int i1 = j2 - (j + l);
          int j1 = 2 - i1 / 2;
          
          for (int i2 = i - j1; i2 <= i + j1; i2++) {
            int l1 = i2 - i;
            
            for (int k2 = k - j1; k2 <= k + j1; k2++) {
              int l2 = k2 - k;
              
              if (((Math.abs(l1) != j1) || (Math.abs(l2) != j1) || ((random.nextInt(2) != 0) && (i1 != 0))) && (!world.getType(i2, j2, k2).j())) {
                setType(world, i2, j2, k2, Blocks.LEAVES);
              }
            }
          }
        }
        
        for (j2 = 0; j2 < l; j2++) {
          Block block2 = world.getType(i, j + j2, k);
          
          if ((block2.getMaterial() == Material.AIR) || (block2.getMaterial() == Material.LEAVES) || (block2 == Blocks.WATER) || (block2 == Blocks.STATIONARY_WATER)) {
            setType(world, i, j + j2, k, Blocks.LOG);
          }
        }
        
        for (j2 = j - 3 + l; j2 <= j + l; j2++) {
          int i1 = j2 - (j + l);
          int j1 = 2 - i1 / 2;
          
          for (int i2 = i - j1; i2 <= i + j1; i2++) {
            for (int l1 = k - j1; l1 <= k + j1; l1++) {
              if (world.getType(i2, j2, l1).getMaterial() == Material.LEAVES) {
                if ((random.nextInt(4) == 0) && (world.getType(i2 - 1, j2, l1).getMaterial() == Material.AIR)) {
                  a(world, i2 - 1, j2, l1, 8);
                }
                
                if ((random.nextInt(4) == 0) && (world.getType(i2 + 1, j2, l1).getMaterial() == Material.AIR)) {
                  a(world, i2 + 1, j2, l1, 2);
                }
                
                if ((random.nextInt(4) == 0) && (world.getType(i2, j2, l1 - 1).getMaterial() == Material.AIR)) {
                  a(world, i2, j2, l1 - 1, 1);
                }
                
                if ((random.nextInt(4) == 0) && (world.getType(i2, j2, l1 + 1).getMaterial() == Material.AIR)) {
                  a(world, i2, j2, l1 + 1, 4);
                }
              }
            }
          }
        }
        
        return true;
      }
      return false;
    }
    

    return false;
  }
  

  private void a(CraftBlockChangeDelegate world, int i, int j, int k, int l)
  {
    setTypeAndData(world, i, j, k, Blocks.VINE, l);
    int i1 = 4;
    for (;;)
    {
      j--;
      if ((world.getType(i, j, k).getMaterial() != Material.AIR) || (i1 <= 0)) {
        return;
      }
      
      setTypeAndData(world, i, j, k, Blocks.VINE, l);
      i1--;
    }
  }
}
