package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import org.bukkit.Bukkit;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_7_R1.map.CraftMapView;



public class WorldMap
  extends PersistentBase
{
  public int centerX;
  public int centerZ;
  public byte map;
  public byte scale;
  public byte[] colors = new byte[16384];
  public List f = new ArrayList();
  private Map i = new HashMap();
  public Map g = new LinkedHashMap();
  
  public final CraftMapView mapView;
  
  private CraftServer server;
  private UUID uniqueId = null;
  
  public WorldMap(String s)
  {
    super(s);
    
    mapView = new CraftMapView(this);
    server = ((CraftServer)Bukkit.getServer());
  }
  

  public void a(NBTTagCompound nbttagcompound)
  {
    byte dimension = nbttagcompound.getByte("dimension");
    
    if (dimension >= 10) {
      long least = nbttagcompound.getLong("UUIDLeast");
      long most = nbttagcompound.getLong("UUIDMost");
      
      if ((least != 0L) && (most != 0L)) {
        uniqueId = new UUID(most, least);
        
        CraftWorld world = (CraftWorld)server.getWorld(uniqueId);
        
        if (world == null)
        {

          dimension = 127;
        } else {
          dimension = (byte)getHandle()dimension;
        }
      }
    }
    
    map = dimension;
    
    centerX = nbttagcompound.getInt("xCenter");
    centerZ = nbttagcompound.getInt("zCenter");
    scale = nbttagcompound.getByte("scale");
    if (scale < 0) {
      scale = 0;
    }
    
    if (scale > 4) {
      scale = 4;
    }
    
    short short1 = nbttagcompound.getShort("width");
    short short2 = nbttagcompound.getShort("height");
    
    if ((short1 == 128) && (short2 == 128)) {
      colors = nbttagcompound.getByteArray("colors");
    } else {
      byte[] abyte = nbttagcompound.getByteArray("colors");
      
      colors = new byte[16384];
      int i = (128 - short1) / 2;
      int j = (128 - short2) / 2;
      
      for (int k = 0; k < short2; k++) {
        int l = k + j;
        
        if ((l >= 0) || (l < 128)) {
          for (int i1 = 0; i1 < short1; i1++) {
            int j1 = i1 + i;
            
            if ((j1 >= 0) || (j1 < 128)) {
              colors[(j1 + l * 128)] = abyte[(i1 + k * short1)];
            }
          }
        }
      }
    }
  }
  
  public void b(NBTTagCompound nbttagcompound)
  {
    if (map >= 10) {
      if (uniqueId == null) {
        for (org.bukkit.World world : server.getWorlds()) {
          CraftWorld cWorld = (CraftWorld)world;
          if (getHandle()dimension == map) {
            uniqueId = cWorld.getUID();
            break;
          }
        }
      }
      

      if (uniqueId != null) {
        nbttagcompound.setLong("UUIDLeast", uniqueId.getLeastSignificantBits());
        nbttagcompound.setLong("UUIDMost", uniqueId.getMostSignificantBits());
      }
    }
    
    nbttagcompound.setByte("dimension", map);
    nbttagcompound.setInt("xCenter", centerX);
    nbttagcompound.setInt("zCenter", centerZ);
    nbttagcompound.setByte("scale", scale);
    nbttagcompound.setShort("width", (short)128);
    nbttagcompound.setShort("height", (short)128);
    nbttagcompound.setByteArray("colors", colors);
  }
  
  public void a(EntityHuman entityhuman, ItemStack itemstack) {
    if (!this.i.containsKey(entityhuman)) {
      WorldMapHumanTracker worldmaphumantracker = new WorldMapHumanTracker(this, entityhuman);
      
      this.i.put(entityhuman, worldmaphumantracker);
      f.add(worldmaphumantracker);
    }
    
    if (!inventory.c(itemstack)) {
      g.remove(entityhuman.getName());
    }
    
    for (int i = 0; i < f.size(); i++) {
      WorldMapHumanTracker worldmaphumantracker1 = (WorldMapHumanTracker)f.get(i);
      
      if ((!trackee.dead) && ((trackee.inventory.c(itemstack)) || (itemstack.A()))) {
        if ((!itemstack.A()) && (trackee.dimension == map)) {
          a(0, trackee.world, trackee.getName(), trackee.locX, trackee.locZ, trackee.yaw);
        }
      } else {
        this.i.remove(trackee);
        f.remove(worldmaphumantracker1);
      }
    }
    
    if (itemstack.A()) {
      a(1, world, "frame-" + itemstack.B().getId(), B()x, B()z, B()direction * 90);
    }
  }
  
  private void a(int i, World world, String s, double d0, double d1, double d2) {
    int j = 1 << scale;
    float f = (float)(d0 - centerX) / j;
    float f1 = (float)(d1 - centerZ) / j;
    byte b0 = (byte)(int)(f * 2.0F + 0.5D);
    byte b1 = (byte)(int)(f1 * 2.0F + 0.5D);
    byte b2 = 63;
    
    byte b3;
    if ((f >= -b2) && (f1 >= -b2) && (f <= b2) && (f1 <= b2)) {
      d2 += (d2 < 0.0D ? -8.0D : 8.0D);
      byte b3 = (byte)(int)(d2 * 16.0D / 360.0D);
      if (map < 0) {
        int k = (int)(world.getWorldData().getDayTime() / 10L);
        
        b3 = (byte)(k * k * 34187121 + k * 121 >> 15 & 0xF);
      }
    } else {
      if ((Math.abs(f) >= 320.0F) || (Math.abs(f1) >= 320.0F)) {
        g.remove(s);
        return;
      }
      
      i = 6;
      b3 = 0;
      if (f <= -b2) {
        b0 = (byte)(int)(b2 * 2 + 2.5D);
      }
      
      if (f1 <= -b2) {
        b1 = (byte)(int)(b2 * 2 + 2.5D);
      }
      
      if (f >= b2) {
        b0 = (byte)(b2 * 2 + 1);
      }
      
      if (f1 >= b2) {
        b1 = (byte)(b2 * 2 + 1);
      }
    }
    
    g.put(s, new WorldMapDecoration(this, (byte)i, b0, b1, b3));
  }
  
  public byte[] getUpdatePacket(ItemStack itemstack, World world, EntityHuman entityhuman) {
    WorldMapHumanTracker worldmaphumantracker = (WorldMapHumanTracker)i.get(entityhuman);
    
    return worldmaphumantracker == null ? null : worldmaphumantracker.a(itemstack);
  }
  
  public void flagDirty(int i, int j, int k) {
    super.c();
    
    for (int l = 0; l < f.size(); l++) {
      WorldMapHumanTracker worldmaphumantracker = (WorldMapHumanTracker)f.get(l);
      
      if ((b[i] < 0) || (b[i] > j)) {
        b[i] = j;
      }
      
      if ((c[i] < 0) || (c[i] < k)) {
        c[i] = k;
      }
    }
  }
  
  public WorldMapHumanTracker a(EntityHuman entityhuman) {
    WorldMapHumanTracker worldmaphumantracker = (WorldMapHumanTracker)i.get(entityhuman);
    
    if (worldmaphumantracker == null) {
      worldmaphumantracker = new WorldMapHumanTracker(this, entityhuman);
      i.put(entityhuman, worldmaphumantracker);
      f.add(worldmaphumantracker);
    }
    
    return worldmaphumantracker;
  }
}
