package net.minecraft.util.com.google.common.cache;

import java.util.concurrent.ExecutionException;
import net.minecraft.util.com.google.common.annotations.Beta;
import net.minecraft.util.com.google.common.base.Preconditions;
import net.minecraft.util.com.google.common.collect.ImmutableMap;































@Beta
public abstract class ForwardingLoadingCache<K, V>
  extends ForwardingCache<K, V>
  implements LoadingCache<K, V>
{
  protected abstract LoadingCache<K, V> delegate();
  
  public V get(K key)
    throws ExecutionException
  {
    return delegate().get(key);
  }
  
  public V getUnchecked(K key)
  {
    return delegate().getUnchecked(key);
  }
  
  public ImmutableMap<K, V> getAll(Iterable<? extends K> keys) throws ExecutionException
  {
    return delegate().getAll(keys);
  }
  
  public V apply(K key)
  {
    return delegate().apply(key);
  }
  
  public void refresh(K key)
  {
    delegate().refresh(key);
  }
  


  @Beta
  public static abstract class SimpleForwardingLoadingCache<K, V>
    extends ForwardingLoadingCache<K, V>
  {
    private final LoadingCache<K, V> delegate;
    


    protected SimpleForwardingLoadingCache(LoadingCache<K, V> delegate)
    {
      this.delegate = ((LoadingCache)Preconditions.checkNotNull(delegate));
    }
    
    protected final LoadingCache<K, V> delegate()
    {
      return delegate;
    }
  }
}
