package net.minecraft.util.com.google.common.cache;

import java.util.concurrent.atomic.AtomicLong;
import net.minecraft.util.com.google.common.annotations.GwtCompatible;
import net.minecraft.util.com.google.common.base.Supplier;





















@GwtCompatible(emulated=true)
final class LongAddables
{
  private static final Supplier<LongAddable> SUPPLIER;
  
  static
  {
    Supplier<LongAddable> supplier;
    try
    {
      new LongAdder();
      supplier = new Supplier()
      {
        public LongAddable get() {
          return new LongAdder();
        }
      };
    } catch (Throwable t) {
      supplier = new Supplier()
      {
        public LongAddable get() {
          return new LongAddables.PureJavaLongAddable(null);
        }
      };
    }
    SUPPLIER = supplier;
  }
  
  public static LongAddable create() {
    return (LongAddable)SUPPLIER.get();
  }
  
  private static final class PureJavaLongAddable extends AtomicLong implements LongAddable
  {
    public void increment() {
      getAndIncrement();
    }
    
    public void add(long x)
    {
      getAndAdd(x);
    }
    
    public long sum()
    {
      return get();
    }
  }
}
