package net.minecraft.util.com.google.common.cache;

import java.util.concurrent.Executor;
import net.minecraft.util.com.google.common.annotations.Beta;
import net.minecraft.util.com.google.common.base.Preconditions;



































@Beta
public final class RemovalListeners
{
  public static <K, V> RemovalListener<K, V> asynchronous(final RemovalListener<K, V> listener, Executor executor)
  {
    Preconditions.checkNotNull(listener);
    Preconditions.checkNotNull(executor);
    new RemovalListener()
    {
      public void onRemoval(final RemovalNotification<K, V> notification) {
        val$executor.execute(new Runnable()
        {
          public void run() {
            val$listener.onRemoval(notification);
          }
        });
      }
    };
  }
}
