package net.minecraft.util.com.google.common.collect;

import java.util.Map.Entry;
import javax.annotation.Nullable;
import net.minecraft.util.com.google.common.annotations.GwtCompatible;
import net.minecraft.util.com.google.common.base.Objects;


























@GwtCompatible
abstract class AbstractMapEntry<K, V>
  implements Map.Entry<K, V>
{
  public abstract K getKey();
  
  public abstract V getValue();
  
  public V setValue(V value)
  {
    throw new UnsupportedOperationException();
  }
  
  public boolean equals(@Nullable Object object) {
    if ((object instanceof Map.Entry)) {
      Map.Entry<?, ?> that = (Map.Entry)object;
      return (Objects.equal(getKey(), that.getKey())) && (Objects.equal(getValue(), that.getValue()));
    }
    
    return false;
  }
  
  public int hashCode() {
    K k = getKey();
    V v = getValue();
    return (k == null ? 0 : k.hashCode()) ^ (v == null ? 0 : v.hashCode());
  }
  


  public String toString()
  {
    return getKey() + "=" + getValue();
  }
}
