package net.minecraft.util.com.google.common.collect;

import java.util.Collection;
import java.util.Set;
import javax.annotation.Nullable;
import net.minecraft.util.com.google.common.annotations.GwtCompatible;
import net.minecraft.util.com.google.common.base.Preconditions;










































@GwtCompatible
public abstract class ForwardingSet<E>
  extends ForwardingCollection<E>
  implements Set<E>
{
  protected abstract Set<E> delegate();
  
  public boolean equals(@Nullable Object object)
  {
    return (object == this) || (delegate().equals(object));
  }
  
  public int hashCode() {
    return delegate().hashCode();
  }
  








  protected boolean standardRemoveAll(Collection<?> collection)
  {
    return Sets.removeAllImpl(this, (Collection)Preconditions.checkNotNull(collection));
  }
  






  protected boolean standardEquals(@Nullable Object object)
  {
    return Sets.equalsImpl(this, object);
  }
  






  protected int standardHashCode()
  {
    return Sets.hashCodeImpl(this);
  }
}
