package net.minecraft.util.com.google.common.collect;

import java.util.Comparator;
import javax.annotation.Nullable;
import net.minecraft.util.com.google.common.annotations.GwtCompatible;
import net.minecraft.util.com.google.common.annotations.GwtIncompatible;






















@GwtCompatible(emulated=true)
final class ImmutableSortedAsList<E>
  extends RegularImmutableAsList<E>
  implements SortedIterable<E>
{
  ImmutableSortedAsList(ImmutableSortedSet<E> backingSet, ImmutableList<E> backingList)
  {
    super(backingSet, backingList);
  }
  
  ImmutableSortedSet<E> delegateCollection()
  {
    return (ImmutableSortedSet)super.delegateCollection();
  }
  
  public Comparator<? super E> comparator() {
    return delegateCollection().comparator();
  }
  


  @GwtIncompatible("ImmutableSortedSet.indexOf")
  public int indexOf(@Nullable Object target)
  {
    int index = delegateCollection().indexOf(target);
    





    return (index >= 0) && (get(index).equals(target)) ? index : -1;
  }
  
  @GwtIncompatible("ImmutableSortedSet.indexOf")
  public int lastIndexOf(@Nullable Object target) {
    return indexOf(target);
  }
  

  public boolean contains(Object target)
  {
    return indexOf(target) >= 0;
  }
  





  @GwtIncompatible("super.subListUnchecked does not exist; inherited subList is valid if slow")
  ImmutableList<E> subListUnchecked(int fromIndex, int toIndex)
  {
    return new RegularImmutableSortedSet(super.subListUnchecked(fromIndex, toIndex), comparator()).asList();
  }
}
