package net.minecraft.util.com.google.common.collect;

import java.io.Serializable;
import net.minecraft.util.com.google.common.annotations.GwtCompatible;
import net.minecraft.util.com.google.common.base.Preconditions;



















@GwtCompatible(serializable=true)
final class NaturalOrdering
  extends Ordering<Comparable>
  implements Serializable
{
  static final NaturalOrdering INSTANCE = new NaturalOrdering();
  private static final long serialVersionUID = 0L;
  
  public int compare(Comparable left, Comparable right) { Preconditions.checkNotNull(left);
    Preconditions.checkNotNull(right);
    return left.compareTo(right);
  }
  
  public <S extends Comparable> Ordering<S> reverse() {
    return ReverseNaturalOrdering.INSTANCE;
  }
  
  private Object readResolve()
  {
    return INSTANCE;
  }
  
  public String toString() {
    return "Ordering.natural()";
  }
}
