package net.minecraft.util.com.google.common.collect;

import java.util.ListIterator;
import net.minecraft.util.com.google.common.annotations.GwtCompatible;























@GwtCompatible
abstract class TransformedListIterator<F, T>
  extends TransformedIterator<F, T>
  implements ListIterator<T>
{
  TransformedListIterator(ListIterator<? extends F> backingIterator)
  {
    super(backingIterator);
  }
  
  private ListIterator<? extends F> backingIterator() {
    return Iterators.cast(backingIterator);
  }
  
  public final boolean hasPrevious()
  {
    return backingIterator().hasPrevious();
  }
  
  public final T previous()
  {
    return transform(backingIterator().previous());
  }
  
  public final int nextIndex()
  {
    return backingIterator().nextIndex();
  }
  
  public final int previousIndex()
  {
    return backingIterator().previousIndex();
  }
  
  public void set(T element)
  {
    throw new UnsupportedOperationException();
  }
  
  public void add(T element)
  {
    throw new UnsupportedOperationException();
  }
}
