package net.minecraft.util.com.google.common.escape;

import java.util.Collections;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import net.minecraft.util.com.google.common.annotations.Beta;
import net.minecraft.util.com.google.common.annotations.GwtCompatible;
import net.minecraft.util.com.google.common.annotations.VisibleForTesting;
import net.minecraft.util.com.google.common.base.Preconditions;





































@Beta
@GwtCompatible
public final class ArrayBasedEscaperMap
{
  private final char[][] replacementArray;
  
  public static ArrayBasedEscaperMap create(Map<Character, String> replacements)
  {
    return new ArrayBasedEscaperMap(createReplacementArray(replacements));
  }
  



  private ArrayBasedEscaperMap(char[][] replacementArray)
  {
    this.replacementArray = replacementArray;
  }
  
  char[][] getReplacementArray()
  {
    return replacementArray;
  }
  


  @VisibleForTesting
  static char[][] createReplacementArray(Map<Character, String> map)
  {
    Preconditions.checkNotNull(map);
    if (map.isEmpty()) {
      return EMPTY_REPLACEMENT_ARRAY;
    }
    char max = ((Character)Collections.max(map.keySet())).charValue();
    char[][] replacements = new char[max + '\001'][];
    for (Iterator i$ = map.keySet().iterator(); i$.hasNext();) { char c = ((Character)i$.next()).charValue();
      replacements[c] = ((String)map.get(Character.valueOf(c))).toCharArray();
    }
    return replacements;
  }
  

  private static final char[][] EMPTY_REPLACEMENT_ARRAY = new char[0][0];
}
