package net.minecraft.util.com.google.common.io;

import java.io.File;
import java.io.FilenameFilter;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.annotation.Nullable;
import net.minecraft.util.com.google.common.annotations.Beta;
import net.minecraft.util.com.google.common.base.Preconditions;






























@Beta
public final class PatternFilenameFilter
  implements FilenameFilter
{
  private final Pattern pattern;
  
  public PatternFilenameFilter(String patternStr)
  {
    this(Pattern.compile(patternStr));
  }
  



  public PatternFilenameFilter(Pattern pattern)
  {
    this.pattern = ((Pattern)Preconditions.checkNotNull(pattern));
  }
  
  public boolean accept(@Nullable File dir, String fileName) {
    return pattern.matcher(fileName).matches();
  }
}
