package net.minecraft.util.com.google.common.primitives;

import javax.annotation.CheckForNull;
import net.minecraft.util.com.google.common.base.Preconditions;
























final class AndroidInteger
{
  @CheckForNull
  static Integer tryParse(String string)
  {
    return tryParse(string, 10);
  }
  


  @CheckForNull
  static Integer tryParse(String string, int radix)
  {
    Preconditions.checkNotNull(string);
    Preconditions.checkArgument(radix >= 2, "Invalid radix %s, min radix is %s", new Object[] { Integer.valueOf(radix), Integer.valueOf(2) });
    
    Preconditions.checkArgument(radix <= 36, "Invalid radix %s, max radix is %s", new Object[] { Integer.valueOf(radix), Integer.valueOf(36) });
    
    int length = string.length();int i = 0;
    if (length == 0) {
      return null;
    }
    boolean negative = string.charAt(i) == '-';
    if (negative) { i++; if (i == length)
        return null;
    }
    return tryParse(string, i, radix, negative);
  }
  
  @CheckForNull
  private static Integer tryParse(String string, int offset, int radix, boolean negative)
  {
    int max = -2147483648 / radix;
    int result = 0;int length = string.length();
    while (offset < length) {
      int digit = Character.digit(string.charAt(offset++), radix);
      if (digit == -1) {
        return null;
      }
      if (max > result) {
        return null;
      }
      int next = result * radix - digit;
      if (next > result) {
        return null;
      }
      result = next;
    }
    if (!negative) {
      result = -result;
      if (result < 0) {
        return null;
      }
    }
    
    if ((result > 2147483647) || (result < -2147483648)) {
      return null;
    }
    return Integer.valueOf(result);
  }
}
