package net.minecraft.util.com.google.common.reflect;

import java.lang.reflect.Type;
import java.lang.reflect.TypeVariable;
import javax.annotation.Nullable;
import net.minecraft.util.com.google.common.annotations.Beta;
import net.minecraft.util.com.google.common.base.Preconditions;































@Beta
public abstract class TypeParameter<T>
  extends TypeCapture<T>
{
  final TypeVariable<?> typeVariable;
  
  protected TypeParameter()
  {
    Type type = capture();
    Preconditions.checkArgument(type instanceof TypeVariable, "%s should be a type variable.", new Object[] { type });
    typeVariable = ((TypeVariable)type);
  }
  
  public final int hashCode() {
    return typeVariable.hashCode();
  }
  
  public final boolean equals(@Nullable Object o) {
    if ((o instanceof TypeParameter)) {
      TypeParameter<?> that = (TypeParameter)o;
      return typeVariable.equals(typeVariable);
    }
    return false;
  }
  
  public String toString() {
    return typeVariable.toString();
  }
}
