package net.minecraft.util.com.google.common.util.concurrent;

import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;
import net.minecraft.util.com.google.common.annotations.Beta;
import net.minecraft.util.com.google.common.base.Preconditions;































@Beta
public abstract class ForwardingCheckedFuture<V, X extends Exception>
  extends ForwardingListenableFuture<V>
  implements CheckedFuture<V, X>
{
  public V checkedGet()
    throws Exception
  {
    return delegate().checkedGet();
  }
  
  public V checkedGet(long timeout, TimeUnit unit) throws TimeoutException, Exception
  {
    return delegate().checkedGet(timeout, unit);
  }
  


  protected abstract CheckedFuture<V, X> delegate();
  


  @Beta
  public static abstract class SimpleForwardingCheckedFuture<V, X extends Exception>
    extends ForwardingCheckedFuture<V, X>
  {
    private final CheckedFuture<V, X> delegate;
    


    protected SimpleForwardingCheckedFuture(CheckedFuture<V, X> delegate)
    {
      this.delegate = ((CheckedFuture)Preconditions.checkNotNull(delegate));
    }
    
    protected final CheckedFuture<V, X> delegate()
    {
      return delegate;
    }
  }
}
