package net.minecraft.util.com.google.common.util.concurrent;

import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;
import net.minecraft.util.com.google.common.base.Preconditions;
import net.minecraft.util.com.google.common.collect.ForwardingObject;































public abstract class ForwardingFuture<V>
  extends ForwardingObject
  implements Future<V>
{
  protected abstract Future<V> delegate();
  
  public boolean cancel(boolean mayInterruptIfRunning)
  {
    return delegate().cancel(mayInterruptIfRunning);
  }
  
  public boolean isCancelled()
  {
    return delegate().isCancelled();
  }
  
  public boolean isDone()
  {
    return delegate().isDone();
  }
  
  public V get() throws InterruptedException, ExecutionException
  {
    return delegate().get();
  }
  
  public V get(long timeout, TimeUnit unit)
    throws InterruptedException, ExecutionException, TimeoutException
  {
    return delegate().get(timeout, unit);
  }
  




  public static abstract class SimpleForwardingFuture<V>
    extends ForwardingFuture<V>
  {
    private final Future<V> delegate;
    




    protected SimpleForwardingFuture(Future<V> delegate)
    {
      this.delegate = ((Future)Preconditions.checkNotNull(delegate));
    }
    
    protected final Future<V> delegate()
    {
      return delegate;
    }
  }
}
