package net.minecraft.util.com.mojang.authlib;

import net.minecraft.util.org.apache.commons.lang3.StringUtils;








public class GameProfile
{
  private final String id;
  private final String name;
  
  public GameProfile(String id, String name)
  {
    if ((StringUtils.isBlank(id)) && (StringUtils.isBlank(name))) { throw new IllegalArgumentException("Name and ID cannot both be blank");
    }
    this.id = id;
    this.name = name;
  }
  






  public String getId()
  {
    return id;
  }
  






  public String getName()
  {
    return name;
  }
  






  public boolean isComplete()
  {
    return (StringUtils.isNotBlank(getId())) && (StringUtils.isNotBlank(getName()));
  }
  
  public boolean equals(Object o)
  {
    if (this == o) return true;
    if ((o == null) || (getClass() != o.getClass())) { return false;
    }
    GameProfile that = (GameProfile)o;
    
    if (!id.equals(id)) return false;
    if (!name.equals(name)) { return false;
    }
    return true;
  }
  
  public int hashCode()
  {
    int result = id.hashCode();
    result = 31 * result + name.hashCode();
    return result;
  }
  
  public String toString()
  {
    return "GameProfile{id='" + id + '\'' + ", name='" + name + '\'' + '}';
  }
}
