package net.minecraft.util.com.mojang.authlib.legacy;

import java.net.Proxy;
import net.minecraft.util.com.mojang.authlib.Agent;
import net.minecraft.util.com.mojang.authlib.HttpAuthenticationService;
import net.minecraft.util.org.apache.commons.lang3.Validate;







public class LegacyAuthenticationService
  extends HttpAuthenticationService
{
  protected LegacyAuthenticationService(Proxy proxy)
  {
    super(proxy);
  }
  









  public LegacyUserAuthentication createUserAuthentication(Agent agent)
  {
    Validate.notNull(agent);
    if (agent != Agent.MINECRAFT) throw new IllegalArgumentException("Legacy authentication cannot handle anything but Minecraft");
    return new LegacyUserAuthentication(this);
  }
  
  public LegacyMinecraftSessionService createMinecraftSessionService()
  {
    return new LegacyMinecraftSessionService(this);
  }
}
