package net.minecraft.util.gnu.trove.decorator;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;
import java.util.AbstractSet;
import java.util.Iterator;
import java.util.Set;
import net.minecraft.util.gnu.trove.iterator.TCharIterator;
import net.minecraft.util.gnu.trove.set.TCharSet;





















































public class TCharSetDecorator
  extends AbstractSet<Character>
  implements Set<Character>, Externalizable
{
  static final long serialVersionUID = 1L;
  protected TCharSet _set;
  
  public TCharSetDecorator() {}
  
  public TCharSetDecorator(TCharSet set)
  {
    _set = set;
  }
  





  public TCharSet getSet()
  {
    return _set;
  }
  





  public boolean add(Character value)
  {
    return (value != null) && (_set.add(value.charValue()));
  }
  







  public boolean equals(Object other)
  {
    if (_set.equals(other))
      return true;
    if ((other instanceof Set)) {
      Set that = (Set)other;
      if (that.size() != _set.size()) {
        return false;
      }
      Iterator it = that.iterator();
      for (int i = that.size(); i-- > 0;) {
        Object val = it.next();
        if ((val instanceof Character)) {
          char v = ((Character)val).charValue();
          if (!_set.contains(v))
          {

            return false;
          }
        } else {
          return false;
        }
      }
      return true;
    }
    
    return false;
  }
  




  public void clear()
  {
    _set.clear();
  }
  






  public boolean remove(Object value)
  {
    return ((value instanceof Character)) && (_set.remove(((Character)value).charValue()));
  }
  





  public Iterator<Character> iterator()
  {
    new Iterator() {
      private final TCharIterator it = _set.iterator();
      
      public Character next() {
        return Character.valueOf(it.next());
      }
      
      public boolean hasNext() {
        return it.hasNext();
      }
      
      public void remove() {
        it.remove();
      }
    };
  }
  





  public int size()
  {
    return _set.size();
  }
  





  public boolean isEmpty()
  {
    return _set.size() == 0;
  }
  




  public boolean contains(Object o)
  {
    if (!(o instanceof Character)) return false;
    return _set.contains(((Character)o).charValue());
  }
  



  public void readExternal(ObjectInput in)
    throws IOException, ClassNotFoundException
  {
    in.readByte();
    

    _set = ((TCharSet)in.readObject());
  }
  

  public void writeExternal(ObjectOutput out)
    throws IOException
  {
    out.writeByte(0);
    

    out.writeObject(_set);
  }
}
