package net.minecraft.util.gnu.trove.decorator;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;
import java.util.AbstractSet;
import java.util.Iterator;
import java.util.Set;
import net.minecraft.util.gnu.trove.iterator.TIntIterator;
import net.minecraft.util.gnu.trove.set.TIntSet;





















































public class TIntSetDecorator
  extends AbstractSet<Integer>
  implements Set<Integer>, Externalizable
{
  static final long serialVersionUID = 1L;
  protected TIntSet _set;
  
  public TIntSetDecorator() {}
  
  public TIntSetDecorator(TIntSet set)
  {
    _set = set;
  }
  





  public TIntSet getSet()
  {
    return _set;
  }
  





  public boolean add(Integer value)
  {
    return (value != null) && (_set.add(value.intValue()));
  }
  







  public boolean equals(Object other)
  {
    if (_set.equals(other))
      return true;
    if ((other instanceof Set)) {
      Set that = (Set)other;
      if (that.size() != _set.size()) {
        return false;
      }
      Iterator it = that.iterator();
      for (int i = that.size(); i-- > 0;) {
        Object val = it.next();
        if ((val instanceof Integer)) {
          int v = ((Integer)val).intValue();
          if (!_set.contains(v))
          {

            return false;
          }
        } else {
          return false;
        }
      }
      return true;
    }
    
    return false;
  }
  




  public void clear()
  {
    _set.clear();
  }
  






  public boolean remove(Object value)
  {
    return ((value instanceof Integer)) && (_set.remove(((Integer)value).intValue()));
  }
  





  public Iterator<Integer> iterator()
  {
    new Iterator() {
      private final TIntIterator it = _set.iterator();
      
      public Integer next() {
        return Integer.valueOf(it.next());
      }
      
      public boolean hasNext() {
        return it.hasNext();
      }
      
      public void remove() {
        it.remove();
      }
    };
  }
  





  public int size()
  {
    return _set.size();
  }
  





  public boolean isEmpty()
  {
    return _set.size() == 0;
  }
  




  public boolean contains(Object o)
  {
    if (!(o instanceof Integer)) return false;
    return _set.contains(((Integer)o).intValue());
  }
  



  public void readExternal(ObjectInput in)
    throws IOException, ClassNotFoundException
  {
    in.readByte();
    

    _set = ((TIntSet)in.readObject());
  }
  

  public void writeExternal(ObjectOutput out)
    throws IOException
  {
    out.writeByte(0);
    

    out.writeObject(_set);
  }
}
