package net.minecraft.util.gnu.trove.impl;

import java.io.PrintStream;




















public class Constants
{
  private static final boolean VERBOSE = System.getProperty("gnu.trove.verbose", null) != null;
  
  public static final int DEFAULT_CAPACITY = 10;
  public static final float DEFAULT_LOAD_FACTOR = 0.5F;
  public static final byte DEFAULT_BYTE_NO_ENTRY_VALUE;
  public static final short DEFAULT_SHORT_NO_ENTRY_VALUE;
  public static final char DEFAULT_CHAR_NO_ENTRY_VALUE;
  public static final int DEFAULT_INT_NO_ENTRY_VALUE;
  public static final long DEFAULT_LONG_NO_ENTRY_VALUE;
  public static final float DEFAULT_FLOAT_NO_ENTRY_VALUE;
  public static final double DEFAULT_DOUBLE_NO_ENTRY_VALUE;
  
  static
  {
    String property = System.getProperty("gnu.trove.no_entry.byte", "0");
    byte value; byte value; if ("MAX_VALUE".equalsIgnoreCase(property)) { value = 127; } else { byte value;
      if ("MIN_VALUE".equalsIgnoreCase(property)) value = -128; else
        value = Byte.valueOf(property).byteValue();
    }
    if (value > 127) { value = 127;
    } else if (value < -128) value = -128;
    DEFAULT_BYTE_NO_ENTRY_VALUE = value;
    if (VERBOSE) {
      System.out.println("DEFAULT_BYTE_NO_ENTRY_VALUE: " + DEFAULT_BYTE_NO_ENTRY_VALUE);
    }
    







    String property = System.getProperty("gnu.trove.no_entry.short", "0");
    short value; short value; if ("MAX_VALUE".equalsIgnoreCase(property)) { value = 32767; } else { short value;
      if ("MIN_VALUE".equalsIgnoreCase(property)) value = -32768; else
        value = Short.valueOf(property).shortValue();
    }
    if (value > 32767) { value = 32767;
    } else if (value < -32768) value = -32768;
    DEFAULT_SHORT_NO_ENTRY_VALUE = value;
    if (VERBOSE) {
      System.out.println("DEFAULT_SHORT_NO_ENTRY_VALUE: " + DEFAULT_SHORT_NO_ENTRY_VALUE);
    }
    







    String property = System.getProperty("gnu.trove.no_entry.char", "");
    char value; char value; if ("MAX_VALUE".equalsIgnoreCase(property)) { value = 65535; } else { char value;
      if ("MIN_VALUE".equalsIgnoreCase(property)) value = '\000'; else
        value = property.toCharArray()[0];
    }
    if (value > 65535) { value = 65535;
    } else if (value < 0) value = '\000';
    DEFAULT_CHAR_NO_ENTRY_VALUE = value;
    if (VERBOSE) {
      System.out.println("DEFAULT_CHAR_NO_ENTRY_VALUE: " + Integer.valueOf(value));
    }
    







    String property = System.getProperty("gnu.trove.no_entry.int", "0");
    int value; int value; if ("MAX_VALUE".equalsIgnoreCase(property)) { value = 2147483647; } else { int value;
      if ("MIN_VALUE".equalsIgnoreCase(property)) value = -2147483648; else
        value = Integer.valueOf(property).intValue(); }
    DEFAULT_INT_NO_ENTRY_VALUE = value;
    if (VERBOSE) {
      System.out.println("DEFAULT_INT_NO_ENTRY_VALUE: " + DEFAULT_INT_NO_ENTRY_VALUE);
    }
    







    String property = System.getProperty("gnu.trove.no_entry.long", "0");
    long value; long value; if ("MAX_VALUE".equalsIgnoreCase(property)) { value = 9223372036854775807L; } else { long value;
      if ("MIN_VALUE".equalsIgnoreCase(property)) value = -9223372036854775808L; else
        value = Long.valueOf(property).longValue(); }
    DEFAULT_LONG_NO_ENTRY_VALUE = value;
    if (VERBOSE) {
      System.out.println("DEFAULT_LONG_NO_ENTRY_VALUE: " + DEFAULT_LONG_NO_ENTRY_VALUE);
    }
    







    String property = System.getProperty("gnu.trove.no_entry.float", "0");
    float value; float value; if ("MAX_VALUE".equalsIgnoreCase(property)) { value = 3.4028235E+38F; } else { float value;
      if ("MIN_VALUE".equalsIgnoreCase(property)) { value = 1.4E-45F;
      } else { float value;
        if ("MIN_NORMAL".equalsIgnoreCase(property)) { value = 1.175494E-038F; } else { float value;
          if ("NEGATIVE_INFINITY".equalsIgnoreCase(property)) { value = (1.0F / -1.0F); } else { float value;
            if ("POSITIVE_INFINITY".equalsIgnoreCase(property)) { value = (1.0F / 1.0F);
            } else
              value = Float.valueOf(property).floatValue(); } } } }
    DEFAULT_FLOAT_NO_ENTRY_VALUE = value;
    if (VERBOSE) {
      System.out.println("DEFAULT_FLOAT_NO_ENTRY_VALUE: " + DEFAULT_FLOAT_NO_ENTRY_VALUE);
    }
    







    String property = System.getProperty("gnu.trove.no_entry.double", "0");
    double value; double value; if ("MAX_VALUE".equalsIgnoreCase(property)) { value = 1.7976931348623157E+308D; } else { double value;
      if ("MIN_VALUE".equalsIgnoreCase(property)) { value = 4.9E-324D;
      } else { double value;
        if ("MIN_NORMAL".equalsIgnoreCase(property)) { value = 2.225073858507201E-308D; } else { double value;
          if ("NEGATIVE_INFINITY".equalsIgnoreCase(property)) { value = (-1.0D / 0.0D); } else { double value;
            if ("POSITIVE_INFINITY".equalsIgnoreCase(property)) { value = (1.0D / 0.0D);
            } else
              value = Double.valueOf(property).doubleValue(); } } } }
    DEFAULT_DOUBLE_NO_ENTRY_VALUE = value;
    if (VERBOSE) {
      System.out.println("DEFAULT_DOUBLE_NO_ENTRY_VALUE: " + DEFAULT_DOUBLE_NO_ENTRY_VALUE);
    }
  }
}
