package net.minecraft.util.gnu.trove.impl.unmodifiable;

import java.io.Serializable;
import java.util.Map;
import net.minecraft.util.gnu.trove.TCollections;
import net.minecraft.util.gnu.trove.TIntCollection;
import net.minecraft.util.gnu.trove.function.TIntFunction;
import net.minecraft.util.gnu.trove.iterator.TIntIntIterator;
import net.minecraft.util.gnu.trove.map.TIntIntMap;
import net.minecraft.util.gnu.trove.procedure.TIntIntProcedure;
import net.minecraft.util.gnu.trove.procedure.TIntProcedure;
import net.minecraft.util.gnu.trove.set.TIntSet;





































public class TUnmodifiableIntIntMap
  implements TIntIntMap, Serializable
{
  private static final long serialVersionUID = -1034234728574286014L;
  private final TIntIntMap m;
  
  public TUnmodifiableIntIntMap(TIntIntMap m)
  {
    if (m == null)
      throw new NullPointerException();
    this.m = m;
  }
  
  public int size() { return m.size(); }
  public boolean isEmpty() { return m.isEmpty(); }
  public boolean containsKey(int key) { return m.containsKey(key); }
  public boolean containsValue(int val) { return m.containsValue(val); }
  public int get(int key) { return m.get(key); }
  
  public int put(int key, int value) { throw new UnsupportedOperationException(); }
  public int remove(int key) { throw new UnsupportedOperationException(); }
  public void putAll(TIntIntMap m) { throw new UnsupportedOperationException(); }
  public void putAll(Map<? extends Integer, ? extends Integer> map) { throw new UnsupportedOperationException(); }
  public void clear() { throw new UnsupportedOperationException(); }
  
  private transient TIntSet keySet = null;
  private transient TIntCollection values = null;
  
  public TIntSet keySet() {
    if (keySet == null)
      keySet = TCollections.unmodifiableSet(m.keySet());
    return keySet; }
  
  public int[] keys() { return m.keys(); }
  public int[] keys(int[] array) { return m.keys(array); }
  
  public TIntCollection valueCollection() {
    if (values == null)
      values = TCollections.unmodifiableCollection(m.valueCollection());
    return values; }
  
  public int[] values() { return m.values(); }
  public int[] values(int[] array) { return m.values(array); }
  
  public boolean equals(Object o) { return (o == this) || (m.equals(o)); }
  public int hashCode() { return m.hashCode(); }
  public String toString() { return m.toString(); }
  public int getNoEntryKey() { return m.getNoEntryKey(); }
  public int getNoEntryValue() { return m.getNoEntryValue(); }
  
  public boolean forEachKey(TIntProcedure procedure) {
    return m.forEachKey(procedure);
  }
  
  public boolean forEachValue(TIntProcedure procedure) { return m.forEachValue(procedure); }
  
  public boolean forEachEntry(TIntIntProcedure procedure) {
    return m.forEachEntry(procedure);
  }
  
  public TIntIntIterator iterator() {
    new TIntIntIterator() {
      TIntIntIterator iter = m.iterator();
      
      public int key() { return iter.key(); }
      public int value() { return iter.value(); }
      public void advance() { iter.advance(); }
      public boolean hasNext() { return iter.hasNext(); }
      public int setValue(int val) { throw new UnsupportedOperationException(); }
      public void remove() { throw new UnsupportedOperationException(); }
    };
  }
  
  public int putIfAbsent(int key, int value) { throw new UnsupportedOperationException(); }
  public void transformValues(TIntFunction function) { throw new UnsupportedOperationException(); }
  public boolean retainEntries(TIntIntProcedure procedure) { throw new UnsupportedOperationException(); }
  public boolean increment(int key) { throw new UnsupportedOperationException(); }
  public boolean adjustValue(int key, int amount) { throw new UnsupportedOperationException(); }
  public int adjustOrPutValue(int key, int adjust_amount, int put_amount) { throw new UnsupportedOperationException(); }
}
