package net.minecraft.util.gnu.trove.impl.unmodifiable;

import java.io.Serializable;
import java.util.Map;
import net.minecraft.util.gnu.trove.TByteCollection;
import net.minecraft.util.gnu.trove.TCollections;
import net.minecraft.util.gnu.trove.function.TByteFunction;
import net.minecraft.util.gnu.trove.iterator.TShortByteIterator;
import net.minecraft.util.gnu.trove.map.TShortByteMap;
import net.minecraft.util.gnu.trove.procedure.TByteProcedure;
import net.minecraft.util.gnu.trove.procedure.TShortByteProcedure;
import net.minecraft.util.gnu.trove.procedure.TShortProcedure;
import net.minecraft.util.gnu.trove.set.TShortSet;




































public class TUnmodifiableShortByteMap
  implements TShortByteMap, Serializable
{
  private static final long serialVersionUID = -1034234728574286014L;
  private final TShortByteMap m;
  
  public TUnmodifiableShortByteMap(TShortByteMap m)
  {
    if (m == null)
      throw new NullPointerException();
    this.m = m;
  }
  
  public int size() { return m.size(); }
  public boolean isEmpty() { return m.isEmpty(); }
  public boolean containsKey(short key) { return m.containsKey(key); }
  public boolean containsValue(byte val) { return m.containsValue(val); }
  public byte get(short key) { return m.get(key); }
  
  public byte put(short key, byte value) { throw new UnsupportedOperationException(); }
  public byte remove(short key) { throw new UnsupportedOperationException(); }
  public void putAll(TShortByteMap m) { throw new UnsupportedOperationException(); }
  public void putAll(Map<? extends Short, ? extends Byte> map) { throw new UnsupportedOperationException(); }
  public void clear() { throw new UnsupportedOperationException(); }
  
  private transient TShortSet keySet = null;
  private transient TByteCollection values = null;
  
  public TShortSet keySet() {
    if (keySet == null)
      keySet = TCollections.unmodifiableSet(m.keySet());
    return keySet; }
  
  public short[] keys() { return m.keys(); }
  public short[] keys(short[] array) { return m.keys(array); }
  
  public TByteCollection valueCollection() {
    if (values == null)
      values = TCollections.unmodifiableCollection(m.valueCollection());
    return values; }
  
  public byte[] values() { return m.values(); }
  public byte[] values(byte[] array) { return m.values(array); }
  
  public boolean equals(Object o) { return (o == this) || (m.equals(o)); }
  public int hashCode() { return m.hashCode(); }
  public String toString() { return m.toString(); }
  public short getNoEntryKey() { return m.getNoEntryKey(); }
  public byte getNoEntryValue() { return m.getNoEntryValue(); }
  
  public boolean forEachKey(TShortProcedure procedure) {
    return m.forEachKey(procedure);
  }
  
  public boolean forEachValue(TByteProcedure procedure) { return m.forEachValue(procedure); }
  
  public boolean forEachEntry(TShortByteProcedure procedure) {
    return m.forEachEntry(procedure);
  }
  
  public TShortByteIterator iterator() {
    new TShortByteIterator() {
      TShortByteIterator iter = m.iterator();
      
      public short key() { return iter.key(); }
      public byte value() { return iter.value(); }
      public void advance() { iter.advance(); }
      public boolean hasNext() { return iter.hasNext(); }
      public byte setValue(byte val) { throw new UnsupportedOperationException(); }
      public void remove() { throw new UnsupportedOperationException(); }
    };
  }
  
  public byte putIfAbsent(short key, byte value) { throw new UnsupportedOperationException(); }
  public void transformValues(TByteFunction function) { throw new UnsupportedOperationException(); }
  public boolean retainEntries(TShortByteProcedure procedure) { throw new UnsupportedOperationException(); }
  public boolean increment(short key) { throw new UnsupportedOperationException(); }
  public boolean adjustValue(short key, byte amount) { throw new UnsupportedOperationException(); }
  public byte adjustOrPutValue(short key, byte adjust_amount, byte put_amount) { throw new UnsupportedOperationException(); }
}
