package net.minecraft.util.gnu.trove.map;

import java.util.Map;
import net.minecraft.util.gnu.trove.TFloatCollection;
import net.minecraft.util.gnu.trove.function.TFloatFunction;
import net.minecraft.util.gnu.trove.iterator.TCharFloatIterator;
import net.minecraft.util.gnu.trove.procedure.TCharFloatProcedure;
import net.minecraft.util.gnu.trove.procedure.TCharProcedure;
import net.minecraft.util.gnu.trove.procedure.TFloatProcedure;
import net.minecraft.util.gnu.trove.set.TCharSet;

public abstract interface TCharFloatMap
{
  public abstract char getNoEntryKey();
  
  public abstract float getNoEntryValue();
  
  public abstract float put(char paramChar, float paramFloat);
  
  public abstract float putIfAbsent(char paramChar, float paramFloat);
  
  public abstract void putAll(Map<? extends Character, ? extends Float> paramMap);
  
  public abstract void putAll(TCharFloatMap paramTCharFloatMap);
  
  public abstract float get(char paramChar);
  
  public abstract void clear();
  
  public abstract boolean isEmpty();
  
  public abstract float remove(char paramChar);
  
  public abstract int size();
  
  public abstract TCharSet keySet();
  
  public abstract char[] keys();
  
  public abstract char[] keys(char[] paramArrayOfChar);
  
  public abstract TFloatCollection valueCollection();
  
  public abstract float[] values();
  
  public abstract float[] values(float[] paramArrayOfFloat);
  
  public abstract boolean containsValue(float paramFloat);
  
  public abstract boolean containsKey(char paramChar);
  
  public abstract TCharFloatIterator iterator();
  
  public abstract boolean forEachKey(TCharProcedure paramTCharProcedure);
  
  public abstract boolean forEachValue(TFloatProcedure paramTFloatProcedure);
  
  public abstract boolean forEachEntry(TCharFloatProcedure paramTCharFloatProcedure);
  
  public abstract void transformValues(TFloatFunction paramTFloatFunction);
  
  public abstract boolean retainEntries(TCharFloatProcedure paramTCharFloatProcedure);
  
  public abstract boolean increment(char paramChar);
  
  public abstract boolean adjustValue(char paramChar, float paramFloat);
  
  public abstract float adjustOrPutValue(char paramChar, float paramFloat1, float paramFloat2);
}
