package net.minecraft.util.gnu.trove.map;

import java.util.Map;
import net.minecraft.util.gnu.trove.TCharCollection;
import net.minecraft.util.gnu.trove.function.TCharFunction;
import net.minecraft.util.gnu.trove.iterator.TDoubleCharIterator;
import net.minecraft.util.gnu.trove.procedure.TCharProcedure;
import net.minecraft.util.gnu.trove.procedure.TDoubleCharProcedure;
import net.minecraft.util.gnu.trove.procedure.TDoubleProcedure;
import net.minecraft.util.gnu.trove.set.TDoubleSet;

public abstract interface TDoubleCharMap
{
  public abstract double getNoEntryKey();
  
  public abstract char getNoEntryValue();
  
  public abstract char put(double paramDouble, char paramChar);
  
  public abstract char putIfAbsent(double paramDouble, char paramChar);
  
  public abstract void putAll(Map<? extends Double, ? extends Character> paramMap);
  
  public abstract void putAll(TDoubleCharMap paramTDoubleCharMap);
  
  public abstract char get(double paramDouble);
  
  public abstract void clear();
  
  public abstract boolean isEmpty();
  
  public abstract char remove(double paramDouble);
  
  public abstract int size();
  
  public abstract TDoubleSet keySet();
  
  public abstract double[] keys();
  
  public abstract double[] keys(double[] paramArrayOfDouble);
  
  public abstract TCharCollection valueCollection();
  
  public abstract char[] values();
  
  public abstract char[] values(char[] paramArrayOfChar);
  
  public abstract boolean containsValue(char paramChar);
  
  public abstract boolean containsKey(double paramDouble);
  
  public abstract TDoubleCharIterator iterator();
  
  public abstract boolean forEachKey(TDoubleProcedure paramTDoubleProcedure);
  
  public abstract boolean forEachValue(TCharProcedure paramTCharProcedure);
  
  public abstract boolean forEachEntry(TDoubleCharProcedure paramTDoubleCharProcedure);
  
  public abstract void transformValues(TCharFunction paramTCharFunction);
  
  public abstract boolean retainEntries(TDoubleCharProcedure paramTDoubleCharProcedure);
  
  public abstract boolean increment(double paramDouble);
  
  public abstract boolean adjustValue(double paramDouble, char paramChar);
  
  public abstract char adjustOrPutValue(double paramDouble, char paramChar1, char paramChar2);
}
