package net.minecraft.util.io.netty.buffer;

import net.minecraft.util.io.netty.util.internal.PlatformDependent;





















public final class UnpooledByteBufAllocator
  extends AbstractByteBufAllocator
{
  public static final UnpooledByteBufAllocator DEFAULT = new UnpooledByteBufAllocator(PlatformDependent.directBufferPreferred());
  






  public UnpooledByteBufAllocator(boolean preferDirect)
  {
    super(preferDirect);
  }
  
  protected ByteBuf newHeapBuffer(int initialCapacity, int maxCapacity)
  {
    return new UnpooledHeapByteBuf(this, initialCapacity, maxCapacity);
  }
  
  protected ByteBuf newDirectBuffer(int initialCapacity, int maxCapacity)
  {
    if (PlatformDependent.hasUnsafe()) {
      return new UnpooledUnsafeDirectByteBuf(this, initialCapacity, maxCapacity);
    }
    return new UnpooledDirectByteBuf(this, initialCapacity, maxCapacity);
  }
  

  public boolean isDirectBufferPooled()
  {
    return false;
  }
}
