package net.minecraft.util.io.netty.channel;

import java.net.SocketAddress;
import net.minecraft.util.io.netty.util.ReferenceCountUtil;


























public abstract class AbstractServerChannel
  extends AbstractChannel
  implements ServerChannel
{
  private static final ChannelMetadata METADATA = new ChannelMetadata(false);
  


  protected AbstractServerChannel()
  {
    super(null);
  }
  
  public ChannelMetadata metadata()
  {
    return METADATA;
  }
  
  public SocketAddress remoteAddress()
  {
    return null;
  }
  
  protected SocketAddress remoteAddress0()
  {
    return null;
  }
  
  protected void doDisconnect() throws Exception
  {
    throw new UnsupportedOperationException();
  }
  
  protected AbstractChannel.AbstractUnsafe newUnsafe()
  {
    return new DefaultServerUnsafe(null);
  }
  


  protected void doWrite(ChannelOutboundBuffer in) throws Exception { throw new UnsupportedOperationException(); }
  
  private final class DefaultServerUnsafe extends AbstractChannel.AbstractUnsafe {
    private DefaultServerUnsafe() { super(); }
    
    public void write(Object msg, ChannelPromise promise) {
      ReferenceCountUtil.release(msg);
      reject(promise);
    }
    


    public void flush() {}
    

    public void connect(SocketAddress remoteAddress, SocketAddress localAddress, ChannelPromise promise)
    {
      reject(promise);
    }
    
    private void reject(ChannelPromise promise) {
      promise.setFailure(new UnsupportedOperationException());
    }
  }
}
