package net.minecraft.util.io.netty.channel;

import net.minecraft.util.io.netty.util.internal.logging.InternalLogger;
import net.minecraft.util.io.netty.util.internal.logging.InternalLoggerFactory;











































@ChannelHandler.Sharable
public abstract class ChannelInitializer<C extends Channel>
  extends ChannelInboundHandlerAdapter
{
  private static final InternalLogger logger = InternalLoggerFactory.getInstance(ChannelInitializer.class);
  




  protected abstract void initChannel(C paramC)
    throws Exception;
  



  public final void channelRegistered(ChannelHandlerContext ctx)
    throws Exception
  {
    boolean removed = false;
    boolean success = false;
    try {
      initChannel(ctx.channel());
      ctx.pipeline().remove(this);
      removed = true;
      ctx.fireChannelRegistered();
      success = true;
    } catch (Throwable t) {
      logger.warn("Failed to initialize a channel. Closing: " + ctx.channel(), t);
    } finally {
      if (!removed) {
        ctx.pipeline().remove(this);
      }
      if (!success) {
        ctx.close();
      }
    }
  }
}
