package net.minecraft.util.io.netty.channel;

import net.minecraft.util.io.netty.util.concurrent.EventExecutor;
import net.minecraft.util.io.netty.util.internal.PlatformDependent;

























final class FailedChannelFuture
  extends CompleteChannelFuture
{
  private final Throwable cause;
  
  public FailedChannelFuture(Channel channel, EventExecutor executor, Throwable cause)
  {
    super(channel, executor);
    if (cause == null) {
      throw new NullPointerException("cause");
    }
    this.cause = cause;
  }
  
  public Throwable cause()
  {
    return cause;
  }
  
  public boolean isSuccess()
  {
    return false;
  }
  
  public ChannelFuture sync()
  {
    PlatformDependent.throwException(cause);
    return this;
  }
  
  public ChannelFuture syncUninterruptibly()
  {
    PlatformDependent.throwException(cause);
    return this;
  }
}
