package net.minecraft.util.io.netty.channel;

import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.buffer.ByteBufAllocator;
















public class FixedRecvByteBufAllocator
  implements RecvByteBufAllocator
{
  private final RecvByteBufAllocator.Handle handle;
  
  private static final class HandleImpl
    implements RecvByteBufAllocator.Handle
  {
    private final int bufferSize;
    
    HandleImpl(int bufferSize)
    {
      this.bufferSize = bufferSize;
    }
    
    public ByteBuf allocate(ByteBufAllocator alloc)
    {
      return alloc.ioBuffer(bufferSize);
    }
    
    public int guess()
    {
      return bufferSize;
    }
    



    public void record(int actualReadBytes) {}
  }
  



  public FixedRecvByteBufAllocator(int bufferSize)
  {
    if (bufferSize <= 0) {
      throw new IllegalArgumentException("bufferSize must greater than 0: " + bufferSize);
    }
    

    handle = new HandleImpl(bufferSize);
  }
  
  public RecvByteBufAllocator.Handle newHandle()
  {
    return handle;
  }
}
