package net.minecraft.util.io.netty.channel;

import java.util.concurrent.ThreadFactory;
import net.minecraft.util.io.netty.util.concurrent.SingleThreadEventExecutor;






















public abstract class SingleThreadEventLoop
  extends SingleThreadEventExecutor
  implements EventLoop
{
  protected SingleThreadEventLoop(EventLoopGroup parent, ThreadFactory threadFactory, boolean addTaskWakesUp)
  {
    super(parent, threadFactory, addTaskWakesUp);
  }
  
  public EventLoopGroup parent()
  {
    return (EventLoopGroup)super.parent();
  }
  
  public EventLoop next()
  {
    return (EventLoop)super.next();
  }
  
  public ChannelFuture register(Channel channel)
  {
    return register(channel, channel.newPromise());
  }
  
  public ChannelFuture register(Channel channel, ChannelPromise promise)
  {
    if (channel == null) {
      throw new NullPointerException("channel");
    }
    if (promise == null) {
      throw new NullPointerException("promise");
    }
    
    channel.unsafe().register(this, promise);
    return promise;
  }
}
