package net.minecraft.util.io.netty.channel.group;

import java.util.Iterator;
import net.minecraft.util.io.netty.channel.Channel;
import net.minecraft.util.io.netty.channel.ChannelFuture;
import net.minecraft.util.io.netty.util.concurrent.Future;
import net.minecraft.util.io.netty.util.concurrent.GenericFutureListener;

public abstract interface ChannelGroupFuture
  extends Future<Void>, Iterable<ChannelFuture>
{
  public abstract ChannelGroup group();
  
  public abstract ChannelFuture find(Channel paramChannel);
  
  public abstract boolean isSuccess();
  
  public abstract ChannelGroupException cause();
  
  public abstract boolean isPartialSuccess();
  
  public abstract boolean isPartialFailure();
  
  public abstract ChannelGroupFuture addListener(GenericFutureListener<? extends Future<? super Void>> paramGenericFutureListener);
  
  public abstract ChannelGroupFuture addListeners(GenericFutureListener<? extends Future<? super Void>>... paramVarArgs);
  
  public abstract ChannelGroupFuture removeListener(GenericFutureListener<? extends Future<? super Void>> paramGenericFutureListener);
  
  public abstract ChannelGroupFuture removeListeners(GenericFutureListener<? extends Future<? super Void>>... paramVarArgs);
  
  public abstract ChannelGroupFuture await()
    throws InterruptedException;
  
  public abstract ChannelGroupFuture awaitUninterruptibly();
  
  public abstract ChannelGroupFuture syncUninterruptibly();
  
  public abstract ChannelGroupFuture sync()
    throws InterruptedException;
  
  public abstract Iterator<ChannelFuture> iterator();
}
