package net.minecraft.util.io.netty.channel.local;

import java.net.SocketAddress;
import net.minecraft.util.io.netty.channel.Channel;




















public final class LocalAddress
  extends SocketAddress
  implements Comparable<LocalAddress>
{
  private static final long serialVersionUID = 4644331421130916435L;
  public static final LocalAddress ANY = new LocalAddress("ANY");
  

  private final String id;
  

  private final String strVal;
  

  LocalAddress(Channel channel)
  {
    StringBuilder buf = new StringBuilder(16);
    buf.append("local:E");
    buf.append(Long.toHexString(channel.hashCode() & 0xFFFFFFFF | 0x0));
    buf.setCharAt(7, ':');
    id = buf.substring(6);
    strVal = buf.toString();
  }
  


  public LocalAddress(String id)
  {
    if (id == null) {
      throw new NullPointerException("id");
    }
    id = id.trim().toLowerCase();
    if (id.isEmpty()) {
      throw new IllegalArgumentException("empty id");
    }
    this.id = id;
    strVal = ("local:" + id);
  }
  


  public String id()
  {
    return id;
  }
  
  public int hashCode()
  {
    return id.hashCode();
  }
  
  public boolean equals(Object o)
  {
    if (!(o instanceof LocalAddress)) {
      return false;
    }
    
    return id.equals(id);
  }
  
  public int compareTo(LocalAddress o)
  {
    return id.compareTo(id);
  }
  
  public String toString()
  {
    return strVal;
  }
}
