package net.minecraft.util.io.netty.channel.local;

import java.net.SocketAddress;
import java.util.concurrent.ConcurrentMap;
import net.minecraft.util.io.netty.channel.Channel;
import net.minecraft.util.io.netty.channel.ChannelException;
import net.minecraft.util.io.netty.util.internal.PlatformDependent;

















final class LocalChannelRegistry
{
  private static final ConcurrentMap<LocalAddress, Channel> boundChannels = ;
  
  static LocalAddress register(Channel channel, LocalAddress oldLocalAddress, SocketAddress localAddress)
  {
    if (oldLocalAddress != null) {
      throw new ChannelException("already bound");
    }
    if (!(localAddress instanceof LocalAddress)) {
      throw new ChannelException("unsupported address type: " + localAddress.getClass().getSimpleName());
    }
    

    LocalAddress addr = (LocalAddress)localAddress;
    if (LocalAddress.ANY.equals(addr)) {
      addr = new LocalAddress(channel);
    }
    
    Channel boundChannel = (Channel)boundChannels.putIfAbsent(addr, channel);
    if (boundChannel != null) {
      throw new ChannelException("address already in use by: " + boundChannel);
    }
    return addr;
  }
  
  static Channel get(SocketAddress localAddress) {
    return (Channel)boundChannels.get(localAddress);
  }
  
  static void unregister(LocalAddress localAddress) {
    boundChannels.remove(localAddress);
  }
}
