package net.minecraft.util.io.netty.channel.oio;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import net.minecraft.util.io.netty.channel.Channel;
import net.minecraft.util.io.netty.channel.Channel.Unsafe;
import net.minecraft.util.io.netty.channel.ChannelPipeline;


















public abstract class AbstractOioMessageChannel
  extends AbstractOioChannel
{
  private final List<Object> readBuf = new ArrayList();
  
  protected AbstractOioMessageChannel(Channel parent) {
    super(parent);
  }
  
  protected void doRead()
  {
    ChannelPipeline pipeline = pipeline();
    boolean closed = false;
    Throwable exception = null;
    try {
      int localReadAmount = doReadMessages(readBuf);
      if (localReadAmount < 0) {
        closed = true;
      }
    } catch (Throwable t) {
      exception = t;
    }
    
    int size = readBuf.size();
    for (int i = 0; i < size; i++) {
      pipeline.fireChannelRead(readBuf.get(i));
    }
    readBuf.clear();
    pipeline.fireChannelReadComplete();
    
    if (exception != null) {
      if ((exception instanceof IOException)) {
        closed = true;
      }
      
      pipeline().fireExceptionCaught(exception);
    }
    
    if ((closed) && 
      (isOpen())) {
      unsafe().close(unsafe().voidPromise());
    }
  }
  
  protected abstract int doReadMessages(List<Object> paramList)
    throws Exception;
}
