package net.minecraft.util.io.netty.channel.sctp;

import com.sun.nio.sctp.Association;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.util.Set;
import net.minecraft.util.io.netty.channel.Channel;
import net.minecraft.util.io.netty.channel.ChannelFuture;
import net.minecraft.util.io.netty.channel.ChannelPromise;

public abstract interface SctpChannel
  extends Channel
{
  public abstract SctpServerChannel parent();
  
  public abstract Association association();
  
  public abstract InetSocketAddress localAddress();
  
  public abstract Set<InetSocketAddress> allLocalAddresses();
  
  public abstract SctpChannelConfig config();
  
  public abstract InetSocketAddress remoteAddress();
  
  public abstract Set<InetSocketAddress> allRemoteAddresses();
  
  public abstract ChannelFuture bindAddress(InetAddress paramInetAddress);
  
  public abstract ChannelFuture bindAddress(InetAddress paramInetAddress, ChannelPromise paramChannelPromise);
  
  public abstract ChannelFuture unbindAddress(InetAddress paramInetAddress);
  
  public abstract ChannelFuture unbindAddress(InetAddress paramInetAddress, ChannelPromise paramChannelPromise);
}
