package net.minecraft.util.io.netty.handler.codec;

import java.util.List;
import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.channel.ChannelHandlerContext;




































public class FixedLengthFrameDecoder
  extends ByteToMessageDecoder
{
  private final int frameLength;
  
  public FixedLengthFrameDecoder(int frameLength)
  {
    if (frameLength <= 0) {
      throw new IllegalArgumentException("frameLength must be a positive integer: " + frameLength);
    }
    
    this.frameLength = frameLength;
  }
  
  protected final void decode(ChannelHandlerContext ctx, ByteBuf in, List<Object> out) throws Exception
  {
    Object decoded = decode(ctx, in);
    if (decoded != null) {
      out.add(decoded);
    }
  }
  







  protected Object decode(ChannelHandlerContext ctx, ByteBuf in)
    throws Exception
  {
    if (in.readableBytes() < frameLength) {
      return null;
    }
    return in.readBytes(frameLength);
  }
}
