package net.minecraft.util.io.netty.handler.codec.base64;

import java.util.List;
import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.channel.ChannelHandler.Sharable;
import net.minecraft.util.io.netty.channel.ChannelHandlerContext;
import net.minecraft.util.io.netty.handler.codec.MessageToMessageDecoder;




































@ChannelHandler.Sharable
public class Base64Decoder
  extends MessageToMessageDecoder<ByteBuf>
{
  private final Base64Dialect dialect;
  
  public Base64Decoder()
  {
    this(Base64Dialect.STANDARD);
  }
  
  public Base64Decoder(Base64Dialect dialect) {
    if (dialect == null) {
      throw new NullPointerException("dialect");
    }
    this.dialect = dialect;
  }
  
  protected void decode(ChannelHandlerContext ctx, ByteBuf msg, List<Object> out) throws Exception
  {
    out.add(Base64.decode(msg, msg.readerIndex(), msg.readableBytes(), dialect));
  }
}
