package net.minecraft.util.io.netty.handler.codec.http;

import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.buffer.Unpooled;
import net.minecraft.util.io.netty.handler.codec.DecoderResult;














final class ComposedLastHttpContent
  implements LastHttpContent
{
  private final HttpHeaders trailingHeaders;
  private DecoderResult result;
  
  ComposedLastHttpContent(HttpHeaders trailingHeaders)
  {
    this.trailingHeaders = trailingHeaders;
  }
  
  public HttpHeaders trailingHeaders() {
    return trailingHeaders;
  }
  
  public LastHttpContent copy()
  {
    LastHttpContent content = new DefaultLastHttpContent(Unpooled.EMPTY_BUFFER);
    content.trailingHeaders().set(trailingHeaders());
    return content;
  }
  
  public LastHttpContent retain(int increment)
  {
    return this;
  }
  
  public LastHttpContent retain()
  {
    return this;
  }
  
  public HttpContent duplicate()
  {
    return copy();
  }
  
  public ByteBuf content()
  {
    return Unpooled.EMPTY_BUFFER;
  }
  
  public DecoderResult getDecoderResult()
  {
    return result;
  }
  
  public void setDecoderResult(DecoderResult result)
  {
    this.result = result;
  }
  
  public int refCnt()
  {
    return 1;
  }
  
  public boolean release()
  {
    return false;
  }
  
  public boolean release(int decrement)
  {
    return false;
  }
}
