package net.minecraft.util.io.netty.handler.codec.http;

import java.util.Map.Entry;
import net.minecraft.util.io.netty.util.internal.StringUtil;


















public abstract class DefaultHttpMessage
  extends DefaultHttpObject
  implements HttpMessage
{
  private HttpVersion version;
  private final HttpHeaders headers = new DefaultHttpHeaders();
  


  protected DefaultHttpMessage(HttpVersion version)
  {
    if (version == null) {
      throw new NullPointerException("version");
    }
    this.version = version;
  }
  
  public HttpHeaders headers()
  {
    return headers;
  }
  
  public HttpVersion getProtocolVersion()
  {
    return version;
  }
  
  public String toString()
  {
    StringBuilder buf = new StringBuilder();
    buf.append(getClass().getSimpleName());
    buf.append("(version: ");
    buf.append(getProtocolVersion().text());
    buf.append(", keepAlive: ");
    buf.append(HttpHeaders.isKeepAlive(this));
    buf.append(')');
    buf.append(StringUtil.NEWLINE);
    appendHeaders(buf);
    

    buf.setLength(buf.length() - StringUtil.NEWLINE.length());
    return buf.toString();
  }
  
  public HttpMessage setProtocolVersion(HttpVersion version)
  {
    if (version == null) {
      throw new NullPointerException("version");
    }
    this.version = version;
    return this;
  }
  
  void appendHeaders(StringBuilder buf) {
    for (Map.Entry<String, String> e : headers()) {
      buf.append((String)e.getKey());
      buf.append(": ");
      buf.append((String)e.getValue());
      buf.append(StringUtil.NEWLINE);
    }
  }
}
