package net.minecraft.util.io.netty.handler.codec.http;

import net.minecraft.util.io.netty.util.internal.StringUtil;























public class DefaultHttpRequest
  extends DefaultHttpMessage
  implements HttpRequest
{
  private HttpMethod method;
  private String uri;
  
  public DefaultHttpRequest(HttpVersion httpVersion, HttpMethod method, String uri)
  {
    super(httpVersion);
    if (method == null) {
      throw new NullPointerException("getMethod");
    }
    if (uri == null) {
      throw new NullPointerException("getUri");
    }
    this.method = method;
    this.uri = uri;
  }
  
  public HttpMethod getMethod()
  {
    return method;
  }
  
  public String getUri()
  {
    return uri;
  }
  
  public HttpRequest setMethod(HttpMethod method)
  {
    if (method == null) {
      throw new NullPointerException("method");
    }
    this.method = method;
    return this;
  }
  
  public HttpRequest setUri(String uri)
  {
    if (uri == null) {
      throw new NullPointerException("method");
    }
    this.uri = uri;
    return this;
  }
  
  public HttpRequest setProtocolVersion(HttpVersion version)
  {
    super.setProtocolVersion(version);
    return this;
  }
  
  public String toString()
  {
    StringBuilder buf = new StringBuilder();
    buf.append(getClass().getSimpleName());
    buf.append(", decodeResult: ");
    buf.append(getDecoderResult());
    buf.append(')');
    buf.append(StringUtil.NEWLINE);
    buf.append(getMethod().toString());
    buf.append(' ');
    buf.append(getUri());
    buf.append(' ');
    buf.append(getProtocolVersion().text());
    buf.append(StringUtil.NEWLINE);
    appendHeaders(buf);
    

    buf.setLength(buf.length() - StringUtil.NEWLINE.length());
    return buf.toString();
  }
}
