package net.minecraft.util.io.netty.handler.codec.http;

import net.minecraft.util.io.netty.util.internal.StringUtil;






















public class DefaultHttpResponse
  extends DefaultHttpMessage
  implements HttpResponse
{
  private HttpResponseStatus status;
  
  public DefaultHttpResponse(HttpVersion version, HttpResponseStatus status)
  {
    super(version);
    if (status == null) {
      throw new NullPointerException("status");
    }
    this.status = status;
  }
  
  public HttpResponseStatus getStatus()
  {
    return status;
  }
  
  public HttpResponse setStatus(HttpResponseStatus status)
  {
    if (status == null) {
      throw new NullPointerException("status");
    }
    this.status = status;
    return this;
  }
  
  public HttpResponse setProtocolVersion(HttpVersion version)
  {
    super.setProtocolVersion(version);
    return this;
  }
  
  public String toString()
  {
    StringBuilder buf = new StringBuilder();
    buf.append(getClass().getSimpleName());
    buf.append("(decodeResult: ");
    buf.append(getDecoderResult());
    buf.append(')');
    buf.append(StringUtil.NEWLINE);
    buf.append(getProtocolVersion().text());
    buf.append(' ');
    buf.append(getStatus().toString());
    buf.append(StringUtil.NEWLINE);
    appendHeaders(buf);
    

    buf.setLength(buf.length() - StringUtil.NEWLINE.length());
    return buf.toString();
  }
}
