package net.minecraft.util.io.netty.handler.codec.http;

import java.util.Map.Entry;
import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.buffer.Unpooled;
import net.minecraft.util.io.netty.util.internal.StringUtil;


















public class DefaultLastHttpContent
  extends DefaultHttpContent
  implements LastHttpContent
{
  private final HttpHeaders trailingHeaders = new DefaultHttpHeaders()
  {
    void validateHeaderName0(String name) {
      super.validateHeaderName0(name);
      if ((name.equalsIgnoreCase("Content-Length")) || (name.equalsIgnoreCase("Transfer-Encoding")) || (name.equalsIgnoreCase("Trailer")))
      {

        throw new IllegalArgumentException("prohibited trailing header: " + name);
      }
    }
  };
  
  public DefaultLastHttpContent()
  {
    this(Unpooled.buffer(0));
  }
  
  public DefaultLastHttpContent(ByteBuf content) {
    super(content);
  }
  
  public LastHttpContent copy()
  {
    DefaultLastHttpContent copy = new DefaultLastHttpContent(content().copy());
    copy.trailingHeaders().set(trailingHeaders());
    return copy;
  }
  
  public LastHttpContent duplicate()
  {
    DefaultLastHttpContent copy = new DefaultLastHttpContent(content().duplicate());
    copy.trailingHeaders().set(trailingHeaders());
    return copy;
  }
  
  public LastHttpContent retain(int increment)
  {
    super.retain(increment);
    return this;
  }
  
  public LastHttpContent retain()
  {
    super.retain();
    return this;
  }
  
  public HttpHeaders trailingHeaders()
  {
    return trailingHeaders;
  }
  
  public String toString()
  {
    StringBuilder buf = new StringBuilder(super.toString());
    buf.append(StringUtil.NEWLINE);
    appendHeaders(buf);
    

    buf.setLength(buf.length() - StringUtil.NEWLINE.length());
    return buf.toString();
  }
  
  private void appendHeaders(StringBuilder buf) {
    for (Map.Entry<String, String> e : trailingHeaders()) {
      buf.append((String)e.getKey());
      buf.append(": ");
      buf.append((String)e.getValue());
      buf.append(StringUtil.NEWLINE);
    }
  }
}
