package net.minecraft.util.io.netty.handler.codec.http;

import net.minecraft.util.io.netty.channel.ChannelHandler;
import net.minecraft.util.io.netty.channel.embedded.EmbeddedChannel;
import net.minecraft.util.io.netty.handler.codec.compression.ZlibCodecFactory;
import net.minecraft.util.io.netty.handler.codec.compression.ZlibWrapper;

















public class HttpContentDecompressor
  extends HttpContentDecoder
{
  protected EmbeddedChannel newContentDecoder(String contentEncoding)
    throws Exception
  {
    if (("gzip".equalsIgnoreCase(contentEncoding)) || ("x-gzip".equalsIgnoreCase(contentEncoding))) {
      return new EmbeddedChannel(new ChannelHandler[] { ZlibCodecFactory.newZlibDecoder(ZlibWrapper.GZIP) });
    }
    if (("deflate".equalsIgnoreCase(contentEncoding)) || ("x-deflate".equalsIgnoreCase(contentEncoding)))
    {
      return new EmbeddedChannel(new ChannelHandler[] { ZlibCodecFactory.newZlibDecoder(ZlibWrapper.ZLIB_OR_NONE) });
    }
    

    return null;
  }
}
