package net.minecraft.util.io.netty.handler.codec.http;

import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.util.CharsetUtil;




















public class HttpRequestEncoder
  extends HttpObjectEncoder<HttpRequest>
{
  private static final char SLASH = '/';
  private static final byte[] CRLF = { 13, 10 };
  
  public boolean acceptOutboundMessage(Object msg) throws Exception
  {
    return (super.acceptOutboundMessage(msg)) && (!(msg instanceof HttpResponse));
  }
  
  protected void encodeInitialLine(ByteBuf buf, HttpRequest request) throws Exception
  {
    encodeAscii(request.getMethod().toString(), buf);
    buf.writeByte(32);
    


    String uri = request.getUri();
    
    if (uri.length() == 0) {
      uri = uri + '/';
    } else {
      int start = uri.indexOf("://");
      if ((start != -1) && (uri.charAt(0) != '/')) {
        int startIndex = start + 3;
        if (uri.lastIndexOf('/') <= startIndex) {
          uri = uri + '/';
        }
      }
    }
    
    buf.writeBytes(uri.getBytes(CharsetUtil.UTF_8));
    
    buf.writeByte(32);
    encodeAscii(request.getProtocolVersion().toString(), buf);
    buf.writeBytes(CRLF);
  }
}
