package net.minecraft.util.io.netty.handler.codec.http.websocketx;

import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.buffer.Unpooled;
import net.minecraft.util.io.netty.util.CharsetUtil;





















public class ContinuationWebSocketFrame
  extends WebSocketFrame
{
  private String aggregatedText;
  
  public ContinuationWebSocketFrame()
  {
    super(Unpooled.buffer(0));
  }
  





  public ContinuationWebSocketFrame(ByteBuf binaryData)
  {
    super(binaryData);
  }
  









  public ContinuationWebSocketFrame(boolean finalFragment, int rsv, ByteBuf binaryData)
  {
    super(finalFragment, rsv, binaryData);
  }
  













  public ContinuationWebSocketFrame(boolean finalFragment, int rsv, ByteBuf binaryData, String aggregatedText)
  {
    super(finalFragment, rsv, binaryData);
    this.aggregatedText = aggregatedText;
  }
  









  public ContinuationWebSocketFrame(boolean finalFragment, int rsv, String text)
  {
    this(finalFragment, rsv, fromText(text), null);
  }
  


  public String text()
  {
    return content().toString(CharsetUtil.UTF_8);
  }
  





  private static ByteBuf fromText(String text)
  {
    if ((text == null) || (text.isEmpty())) {
      return Unpooled.EMPTY_BUFFER;
    }
    return Unpooled.copiedBuffer(text, CharsetUtil.UTF_8);
  }
  



  public String aggregatedText()
  {
    return aggregatedText;
  }
  
  public ContinuationWebSocketFrame copy()
  {
    return new ContinuationWebSocketFrame(isFinalFragment(), rsv(), content().copy(), aggregatedText());
  }
  
  public ContinuationWebSocketFrame duplicate()
  {
    return new ContinuationWebSocketFrame(isFinalFragment(), rsv(), content().duplicate(), aggregatedText());
  }
  
  public ContinuationWebSocketFrame retain()
  {
    super.retain();
    return this;
  }
  
  public ContinuationWebSocketFrame retain(int increment)
  {
    super.retain(increment);
    return this;
  }
}
