package net.minecraft.util.io.netty.handler.codec.http.websocketx;

import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.buffer.Unpooled;
import net.minecraft.util.io.netty.util.CharsetUtil;




















public class TextWebSocketFrame
  extends WebSocketFrame
{
  public TextWebSocketFrame()
  {
    super(Unpooled.buffer(0));
  }
  





  public TextWebSocketFrame(String text)
  {
    super(fromText(text));
  }
  





  public TextWebSocketFrame(ByteBuf binaryData)
  {
    super(binaryData);
  }
  









  public TextWebSocketFrame(boolean finalFragment, int rsv, String text)
  {
    super(finalFragment, rsv, fromText(text));
  }
  
  private static ByteBuf fromText(String text) {
    if ((text == null) || (text.isEmpty())) {
      return Unpooled.EMPTY_BUFFER;
    }
    return Unpooled.copiedBuffer(text, CharsetUtil.UTF_8);
  }
  










  public TextWebSocketFrame(boolean finalFragment, int rsv, ByteBuf binaryData)
  {
    super(finalFragment, rsv, binaryData);
  }
  


  public String text()
  {
    return content().toString(CharsetUtil.UTF_8);
  }
  
  public TextWebSocketFrame copy()
  {
    return new TextWebSocketFrame(isFinalFragment(), rsv(), content().copy());
  }
  
  public TextWebSocketFrame duplicate()
  {
    return new TextWebSocketFrame(isFinalFragment(), rsv(), content().duplicate());
  }
  
  public TextWebSocketFrame retain()
  {
    super.retain();
    return this;
  }
  
  public TextWebSocketFrame retain(int increment)
  {
    super.retain(increment);
    return this;
  }
}
