package net.minecraft.util.io.netty.handler.codec.http.websocketx;

import java.net.URI;
import java.util.List;
import net.minecraft.util.io.netty.channel.ChannelHandlerContext;
import net.minecraft.util.io.netty.channel.ChannelPipeline;
import net.minecraft.util.io.netty.handler.codec.http.HttpHeaders;




































public class WebSocketClientProtocolHandler
  extends WebSocketProtocolHandler
{
  private final WebSocketClientHandshaker handshaker;
  private final boolean handleCloseFrames;
  
  public static enum ClientHandshakeStateEvent
  {
    HANDSHAKE_ISSUED, 
    



    HANDSHAKE_COMPLETE;
    








    private ClientHandshakeStateEvent() {}
  }
  








  public WebSocketClientProtocolHandler(URI webSocketURL, WebSocketVersion version, String subprotocol, boolean allowExtensions, HttpHeaders customHeaders, int maxFramePayloadLength, boolean handleCloseFrames)
  {
    this(WebSocketClientHandshakerFactory.newHandshaker(webSocketURL, version, subprotocol, allowExtensions, customHeaders, maxFramePayloadLength), handleCloseFrames);
  }
  

















  public WebSocketClientProtocolHandler(URI webSocketURL, WebSocketVersion version, String subprotocol, boolean allowExtensions, HttpHeaders customHeaders, int maxFramePayloadLength)
  {
    this(webSocketURL, version, subprotocol, allowExtensions, customHeaders, maxFramePayloadLength, true);
  }
  









  public WebSocketClientProtocolHandler(WebSocketClientHandshaker handshaker, boolean handleCloseFrames)
  {
    this.handshaker = handshaker;
    this.handleCloseFrames = handleCloseFrames;
  }
  






  public WebSocketClientProtocolHandler(WebSocketClientHandshaker handshaker)
  {
    this(handshaker, true);
  }
  
  protected void decode(ChannelHandlerContext ctx, WebSocketFrame frame, List<Object> out) throws Exception
  {
    if ((handleCloseFrames) && ((frame instanceof CloseWebSocketFrame))) {
      ctx.close();
      return;
    }
    super.decode(ctx, frame, out);
  }
  
  public void handlerAdded(ChannelHandlerContext ctx)
  {
    ChannelPipeline cp = ctx.pipeline();
    if (cp.get(WebSocketClientProtocolHandshakeHandler.class) == null)
    {
      ctx.pipeline().addBefore(ctx.name(), WebSocketClientProtocolHandshakeHandler.class.getName(), new WebSocketClientProtocolHandshakeHandler(handshaker));
    }
  }
}
