package net.minecraft.util.io.netty.handler.codec.http.websocketx;

import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.buffer.DefaultByteBufHolder;

























public abstract class WebSocketFrame
  extends DefaultByteBufHolder
{
  private final boolean finalFragment;
  private final int rsv;
  
  protected WebSocketFrame(ByteBuf binaryData)
  {
    this(true, 0, binaryData);
  }
  
  protected WebSocketFrame(boolean finalFragment, int rsv, ByteBuf binaryData) {
    super(binaryData);
    this.finalFragment = finalFragment;
    this.rsv = rsv;
  }
  



  public boolean isFinalFragment()
  {
    return finalFragment;
  }
  


  public int rsv()
  {
    return rsv;
  }
  

  public abstract WebSocketFrame copy();
  

  public abstract WebSocketFrame duplicate();
  
  public String toString()
  {
    return getClass().getSimpleName() + "(data: " + content().toString() + ')';
  }
  
  public WebSocketFrame retain()
  {
    super.retain();
    return this;
  }
  
  public WebSocketFrame retain(int increment)
  {
    super.retain(increment);
    return this;
  }
}
