package net.minecraft.util.io.netty.handler.codec.http.websocketx;

import java.util.List;
import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.channel.Channel;
import net.minecraft.util.io.netty.channel.ChannelHandlerContext;
import net.minecraft.util.io.netty.handler.codec.MessageToMessageDecoder;













abstract class WebSocketProtocolHandler
  extends MessageToMessageDecoder<WebSocketFrame>
{
  protected void decode(ChannelHandlerContext ctx, WebSocketFrame frame, List<Object> out)
    throws Exception
  {
    if ((frame instanceof PingWebSocketFrame)) {
      frame.content().retain();
      ctx.channel().writeAndFlush(new PongWebSocketFrame(frame.content()));
      return;
    }
    if ((frame instanceof PongWebSocketFrame))
    {
      return;
    }
    
    out.add(frame.retain());
  }
  
  public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception
  {
    ctx.close();
  }
}
