package net.minecraft.util.io.netty.handler.codec.marshalling;

import net.minecraft.util.io.netty.channel.ChannelHandlerContext;
import net.minecraft.util.io.netty.util.Attribute;
import net.minecraft.util.io.netty.util.AttributeKey;
import org.jboss.marshalling.MarshallerFactory;
import org.jboss.marshalling.MarshallingConfiguration;
import org.jboss.marshalling.Unmarshaller;


























public class ContextBoundUnmarshallerProvider
  extends DefaultUnmarshallerProvider
{
  private static final AttributeKey<Unmarshaller> UNMARSHALLER = new AttributeKey(ContextBoundUnmarshallerProvider.class.getName() + ".unmarshaller");
  
  public ContextBoundUnmarshallerProvider(MarshallerFactory factory, MarshallingConfiguration config)
  {
    super(factory, config);
  }
  
  public Unmarshaller getUnmarshaller(ChannelHandlerContext ctx) throws Exception
  {
    Attribute<Unmarshaller> attr = ctx.attr(UNMARSHALLER);
    Unmarshaller unmarshaller = (Unmarshaller)attr.get();
    if (unmarshaller == null) {
      unmarshaller = super.getUnmarshaller(ctx);
      attr.set(unmarshaller);
    }
    return unmarshaller;
  }
}
