package net.minecraft.util.io.netty.handler.codec.marshalling;

import net.minecraft.util.io.netty.channel.ChannelHandlerContext;
import org.jboss.marshalling.MarshallerFactory;
import org.jboss.marshalling.MarshallingConfiguration;
import org.jboss.marshalling.Unmarshaller;




















public class ThreadLocalUnmarshallerProvider
  implements UnmarshallerProvider
{
  private final ThreadLocal<Unmarshaller> unmarshallers = new ThreadLocal();
  

  private final MarshallerFactory factory;
  

  private final MarshallingConfiguration config;
  


  public ThreadLocalUnmarshallerProvider(MarshallerFactory factory, MarshallingConfiguration config)
  {
    this.factory = factory;
    this.config = config;
  }
  
  public Unmarshaller getUnmarshaller(ChannelHandlerContext ctx) throws Exception
  {
    Unmarshaller unmarshaller = (Unmarshaller)unmarshallers.get();
    if (unmarshaller == null) {
      unmarshaller = factory.createUnmarshaller(config);
      unmarshallers.set(unmarshaller);
    }
    return unmarshaller;
  }
}
