package net.minecraft.util.io.netty.handler.codec.protobuf;

import com.google.protobuf.MessageLite;
import com.google.protobuf.MessageLite.Builder;
import com.google.protobuf.MessageLiteOrBuilder;
import java.util.List;
import net.minecraft.util.io.netty.buffer.Unpooled;
import net.minecraft.util.io.netty.channel.ChannelHandler.Sharable;
import net.minecraft.util.io.netty.channel.ChannelHandlerContext;
import net.minecraft.util.io.netty.handler.codec.MessageToMessageEncoder;















































@ChannelHandler.Sharable
public class ProtobufEncoder
  extends MessageToMessageEncoder<MessageLiteOrBuilder>
{
  protected void encode(ChannelHandlerContext ctx, MessageLiteOrBuilder msg, List<Object> out)
    throws Exception
  {
    if ((msg instanceof MessageLite)) {
      out.add(Unpooled.wrappedBuffer(((MessageLite)msg).toByteArray()));
      return;
    }
    if ((msg instanceof MessageLite.Builder)) {
      out.add(Unpooled.wrappedBuffer(((MessageLite.Builder)msg).build().toByteArray()));
    }
  }
}
