package net.minecraft.util.io.netty.handler.codec.protobuf;

import com.google.protobuf.CodedOutputStream;
import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.buffer.ByteBufOutputStream;
import net.minecraft.util.io.netty.channel.ChannelHandler.Sharable;
import net.minecraft.util.io.netty.channel.ChannelHandlerContext;
import net.minecraft.util.io.netty.handler.codec.MessageToByteEncoder;





























@ChannelHandler.Sharable
public class ProtobufVarint32LengthFieldPrepender
  extends MessageToByteEncoder<ByteBuf>
{
  protected void encode(ChannelHandlerContext ctx, ByteBuf msg, ByteBuf out)
    throws Exception
  {
    int bodyLen = msg.readableBytes();
    int headerLen = CodedOutputStream.computeRawVarint32Size(bodyLen);
    out.ensureWritable(headerLen + bodyLen);
    
    CodedOutputStream headerOut = CodedOutputStream.newInstance(new ByteBufOutputStream(out));
    
    headerOut.writeRawVarint32(bodyLen);
    headerOut.flush();
    
    out.writeBytes(msg, msg.readerIndex(), bodyLen);
  }
}
