package net.minecraft.util.io.netty.handler.codec.rtsp;

import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.handler.codec.http.FullHttpRequest;
import net.minecraft.util.io.netty.handler.codec.http.HttpMethod;
import net.minecraft.util.io.netty.handler.codec.http.HttpRequest;
import net.minecraft.util.io.netty.handler.codec.http.HttpVersion;
import net.minecraft.util.io.netty.util.CharsetUtil;



















public class RtspRequestEncoder
  extends RtspObjectEncoder<HttpRequest>
{
  private static final byte[] CRLF = { 13, 10 };
  
  public boolean acceptOutboundMessage(Object msg) throws Exception
  {
    return msg instanceof FullHttpRequest;
  }
  
  protected void encodeInitialLine(ByteBuf buf, HttpRequest request)
    throws Exception
  {
    encodeAscii(request.getMethod().toString(), buf);
    buf.writeByte(32);
    buf.writeBytes(request.getUri().getBytes(CharsetUtil.UTF_8));
    buf.writeByte(32);
    encodeAscii(request.getProtocolVersion().toString(), buf);
    buf.writeBytes(CRLF);
  }
}
