package net.minecraft.util.io.netty.handler.codec.rtsp;

import net.minecraft.util.io.netty.handler.codec.http.DefaultHttpResponse;
import net.minecraft.util.io.netty.handler.codec.http.HttpMessage;
import net.minecraft.util.io.netty.handler.codec.http.HttpResponseStatus;













































public class RtspResponseDecoder
  extends RtspObjectDecoder
{
  private static final HttpResponseStatus UNKNOWN_STATUS = new HttpResponseStatus(999, "Unknown");
  





  public RtspResponseDecoder() {}
  




  public RtspResponseDecoder(int maxInitialLineLength, int maxHeaderSize, int maxContentLength)
  {
    super(maxInitialLineLength, maxHeaderSize, maxContentLength);
  }
  
  protected HttpMessage createMessage(String[] initialLine) throws Exception
  {
    return new DefaultHttpResponse(RtspVersions.valueOf(initialLine[0]), new HttpResponseStatus(Integer.valueOf(initialLine[1]).intValue(), initialLine[2]));
  }
  


  protected HttpMessage createInvalidMessage()
  {
    return new DefaultHttpResponse(RtspVersions.RTSP_1_0, UNKNOWN_STATUS);
  }
  
  protected boolean isDecodingRequest()
  {
    return false;
  }
}
