package net.minecraft.util.io.netty.handler.codec.sctp;

import java.util.List;
import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.channel.ChannelHandlerContext;
import net.minecraft.util.io.netty.channel.sctp.SctpMessage;
import net.minecraft.util.io.netty.handler.codec.MessageToMessageEncoder;























public class SctpOutboundByteStreamHandler
  extends MessageToMessageEncoder<ByteBuf>
{
  private final int streamIdentifier;
  private final int protocolIdentifier;
  
  public SctpOutboundByteStreamHandler(int streamIdentifier, int protocolIdentifier)
  {
    this.streamIdentifier = streamIdentifier;
    this.protocolIdentifier = protocolIdentifier;
  }
  
  protected void encode(ChannelHandlerContext ctx, ByteBuf msg, List<Object> out) throws Exception
  {
    out.add(new SctpMessage(streamIdentifier, protocolIdentifier, msg.retain()));
  }
}
