package net.minecraft.util.io.netty.handler.codec.serialization;

import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.buffer.ByteBufInputStream;
import net.minecraft.util.io.netty.channel.ChannelHandlerContext;
import net.minecraft.util.io.netty.handler.codec.LengthFieldBasedFrameDecoder;


































public class ObjectDecoder
  extends LengthFieldBasedFrameDecoder
{
  private final ClassResolver classResolver;
  
  public ObjectDecoder(ClassResolver classResolver)
  {
    this(1048576, classResolver);
  }
  









  public ObjectDecoder(int maxObjectSize, ClassResolver classResolver)
  {
    super(maxObjectSize, 0, 4, 0, 4);
    this.classResolver = classResolver;
  }
  
  protected Object decode(ChannelHandlerContext ctx, ByteBuf in) throws Exception
  {
    ByteBuf frame = (ByteBuf)super.decode(ctx, in);
    if (frame == null) {
      return null;
    }
    
    return new CompactObjectInputStream(new ByteBufInputStream(frame), classResolver).readObject();
  }
  

  protected ByteBuf extractFrame(ChannelHandlerContext ctx, ByteBuf buffer, int index, int length)
  {
    return buffer.slice(index, length);
  }
}
