package net.minecraft.util.io.netty.handler.codec.serialization;

import java.io.ObjectOutputStream;
import java.io.Serializable;
import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.buffer.ByteBufOutputStream;
import net.minecraft.util.io.netty.channel.ChannelHandler.Sharable;
import net.minecraft.util.io.netty.channel.ChannelHandlerContext;
import net.minecraft.util.io.netty.handler.codec.MessageToByteEncoder;
























@ChannelHandler.Sharable
public class ObjectEncoder
  extends MessageToByteEncoder<Serializable>
{
  private static final byte[] LENGTH_PLACEHOLDER = new byte[4];
  
  protected void encode(ChannelHandlerContext ctx, Serializable msg, ByteBuf out) throws Exception
  {
    int startIdx = out.writerIndex();
    
    ByteBufOutputStream bout = new ByteBufOutputStream(out);
    bout.write(LENGTH_PLACEHOLDER);
    ObjectOutputStream oout = new CompactObjectOutputStream(bout);
    oout.writeObject(msg);
    oout.flush();
    oout.close();
    
    int endIdx = out.writerIndex();
    
    out.setInt(startIdx, endIdx - startIdx - 4);
  }
}
