package net.minecraft.util.io.netty.handler.codec.socks;

import java.nio.charset.CharsetEncoder;
import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.util.CharsetUtil;





















public final class SocksAuthRequest
  extends SocksRequest
{
  private static final CharsetEncoder asciiEncoder = CharsetUtil.getEncoder(CharsetUtil.US_ASCII);
  private static final SocksSubnegotiationVersion SUBNEGOTIATION_VERSION = SocksSubnegotiationVersion.AUTH_PASSWORD;
  private final String username;
  private final String password;
  
  public SocksAuthRequest(String username, String password) {
    super(SocksRequestType.AUTH);
    if (username == null) {
      throw new NullPointerException("username");
    }
    if (password == null) {
      throw new NullPointerException("username");
    }
    if ((!asciiEncoder.canEncode(username)) || (!asciiEncoder.canEncode(password))) {
      throw new IllegalArgumentException(" username: " + username + " or password: " + password + " values should be in pure ascii");
    }
    
    if (username.length() > 255) {
      throw new IllegalArgumentException(username + " exceeds 255 char limit");
    }
    if (password.length() > 255) {
      throw new IllegalArgumentException(password + " exceeds 255 char limit");
    }
    this.username = username;
    this.password = password;
  }
  




  public String username()
  {
    return username;
  }
  




  public String password()
  {
    return password;
  }
  
  public void encodeAsByteBuf(ByteBuf byteBuf)
  {
    byteBuf.writeByte(SUBNEGOTIATION_VERSION.byteValue());
    byteBuf.writeByte(username.length());
    byteBuf.writeBytes(username.getBytes(CharsetUtil.US_ASCII));
    byteBuf.writeByte(password.length());
    byteBuf.writeBytes(password.getBytes(CharsetUtil.US_ASCII));
  }
}
