package net.minecraft.util.io.netty.handler.codec.socks;

import java.util.List;
import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.channel.ChannelHandlerContext;
import net.minecraft.util.io.netty.channel.ChannelPipeline;
import net.minecraft.util.io.netty.handler.codec.ReplayingDecoder;
import net.minecraft.util.io.netty.util.CharsetUtil;













public class SocksAuthRequestDecoder
  extends ReplayingDecoder<State>
{
  private static final String name = "SOCKS_AUTH_REQUEST_DECODER";
  private SocksSubnegotiationVersion version;
  private int fieldLength;
  private String username;
  private String password;
  
  public static String getName()
  {
    return "SOCKS_AUTH_REQUEST_DECODER";
  }
  




  private SocksRequest msg = SocksCommonUtils.UNKNOWN_SOCKS_REQUEST;
  
  public SocksAuthRequestDecoder() {
    super(State.CHECK_PROTOCOL_VERSION);
  }
  
  protected void decode(ChannelHandlerContext ctx, ByteBuf byteBuf, List<Object> out) throws Exception
  {
    switch (1.$SwitchMap$io$netty$handler$codec$socks$SocksAuthRequestDecoder$State[((State)state()).ordinal()]) {
    case 1: 
      version = SocksSubnegotiationVersion.fromByte(byteBuf.readByte());
      if (version == SocksSubnegotiationVersion.AUTH_PASSWORD)
      {

        checkpoint(State.READ_USERNAME); }
      break;
    case 2: 
      fieldLength = byteBuf.readByte();
      username = byteBuf.readBytes(fieldLength).toString(CharsetUtil.US_ASCII);
      checkpoint(State.READ_PASSWORD);
    
    case 3: 
      fieldLength = byteBuf.readByte();
      password = byteBuf.readBytes(fieldLength).toString(CharsetUtil.US_ASCII);
      msg = new SocksAuthRequest(username, password);
    }
    
    ctx.pipeline().remove(this);
    out.add(msg);
  }
  
  static enum State {
    CHECK_PROTOCOL_VERSION, 
    READ_USERNAME, 
    READ_PASSWORD;
    
    private State() {}
  }
}
