package net.minecraft.util.io.netty.handler.codec.socks;

import net.minecraft.util.io.netty.buffer.ByteBuf;




















public final class SocksAuthResponse
  extends SocksResponse
{
  private static final SocksSubnegotiationVersion SUBNEGOTIATION_VERSION = SocksSubnegotiationVersion.AUTH_PASSWORD;
  private final SocksAuthStatus authStatus;
  
  public SocksAuthResponse(SocksAuthStatus authStatus) {
    super(SocksResponseType.AUTH);
    if (authStatus == null) {
      throw new NullPointerException("authStatus");
    }
    this.authStatus = authStatus;
  }
  




  public SocksAuthStatus authStatus()
  {
    return authStatus;
  }
  
  public void encodeAsByteBuf(ByteBuf byteBuf)
  {
    byteBuf.writeByte(SUBNEGOTIATION_VERSION.byteValue());
    byteBuf.writeByte(authStatus.byteValue());
  }
}
