package net.minecraft.util.io.netty.handler.codec.socks;

import net.minecraft.util.io.netty.buffer.ByteBuf;






















public final class SocksCmdResponse
  extends SocksResponse
{
  private final SocksCmdStatus cmdStatus;
  private final SocksAddressType addressType;
  private static final byte[] IPv4_HOSTNAME_ZEROED = { 0, 0, 0, 0 };
  private static final byte[] IPv6_HOSTNAME_ZEROED = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
  


  public SocksCmdResponse(SocksCmdStatus cmdStatus, SocksAddressType addressType)
  {
    super(SocksResponseType.CMD);
    if (cmdStatus == null) {
      throw new NullPointerException("cmdStatus");
    }
    if (addressType == null) {
      throw new NullPointerException("addressType");
    }
    this.cmdStatus = cmdStatus;
    this.addressType = addressType;
  }
  




  public SocksCmdStatus cmdStatus()
  {
    return cmdStatus;
  }
  




  public SocksAddressType addressType()
  {
    return addressType;
  }
  
  public void encodeAsByteBuf(ByteBuf byteBuf)
  {
    byteBuf.writeByte(protocolVersion().byteValue());
    byteBuf.writeByte(cmdStatus.byteValue());
    byteBuf.writeByte(0);
    byteBuf.writeByte(addressType.byteValue());
    switch (1.$SwitchMap$io$netty$handler$codec$socks$SocksAddressType[addressType.ordinal()]) {
    case 1: 
      byteBuf.writeBytes(IPv4_HOSTNAME_ZEROED);
      byteBuf.writeShort(0);
      break;
    
    case 2: 
      byteBuf.writeByte(1);
      byteBuf.writeByte(0);
      byteBuf.writeShort(0);
      break;
    
    case 3: 
      byteBuf.writeBytes(IPv6_HOSTNAME_ZEROED);
      byteBuf.writeShort(0);
    }
  }
}
