package net.minecraft.util.io.netty.handler.codec.socks;

import java.util.Collections;
import java.util.List;
import net.minecraft.util.io.netty.buffer.ByteBuf;




















public final class SocksInitRequest
  extends SocksRequest
{
  private final List<SocksAuthScheme> authSchemes;
  
  public SocksInitRequest(List<SocksAuthScheme> authSchemes)
  {
    super(SocksRequestType.INIT);
    if (authSchemes == null) {
      throw new NullPointerException("authSchemes");
    }
    this.authSchemes = authSchemes;
  }
  




  public List<SocksAuthScheme> authSchemes()
  {
    return Collections.unmodifiableList(authSchemes);
  }
  
  public void encodeAsByteBuf(ByteBuf byteBuf)
  {
    byteBuf.writeByte(protocolVersion().byteValue());
    byteBuf.writeByte(authSchemes.size());
    for (SocksAuthScheme authScheme : authSchemes) {
      byteBuf.writeByte(authScheme.byteValue());
    }
  }
}
