package net.minecraft.util.io.netty.handler.codec.spdy;

import net.minecraft.util.io.netty.util.internal.StringUtil;






















public class DefaultSpdyGoAwayFrame
  implements SpdyGoAwayFrame
{
  private int lastGoodStreamId;
  private SpdySessionStatus status;
  
  public DefaultSpdyGoAwayFrame(int lastGoodStreamId)
  {
    this(lastGoodStreamId, 0);
  }
  





  public DefaultSpdyGoAwayFrame(int lastGoodStreamId, int statusCode)
  {
    this(lastGoodStreamId, SpdySessionStatus.valueOf(statusCode));
  }
  





  public DefaultSpdyGoAwayFrame(int lastGoodStreamId, SpdySessionStatus status)
  {
    setLastGoodStreamId(lastGoodStreamId);
    setStatus(status);
  }
  
  public int getLastGoodStreamId()
  {
    return lastGoodStreamId;
  }
  
  public SpdyGoAwayFrame setLastGoodStreamId(int lastGoodStreamId)
  {
    if (lastGoodStreamId < 0) {
      throw new IllegalArgumentException("Last-good-stream-ID cannot be negative: " + lastGoodStreamId);
    }
    
    this.lastGoodStreamId = lastGoodStreamId;
    return this;
  }
  
  public SpdySessionStatus getStatus()
  {
    return status;
  }
  
  public SpdyGoAwayFrame setStatus(SpdySessionStatus status)
  {
    this.status = status;
    return this;
  }
  
  public String toString()
  {
    StringBuilder buf = new StringBuilder();
    buf.append(getClass().getSimpleName());
    buf.append(StringUtil.NEWLINE);
    buf.append("--> Last-good-stream-ID = ");
    buf.append(getLastGoodStreamId());
    buf.append(StringUtil.NEWLINE);
    buf.append("--> Status: ");
    buf.append(getStatus().toString());
    return buf.toString();
  }
}
