package net.minecraft.util.io.netty.handler.codec.spdy;

import net.minecraft.util.io.netty.util.internal.StringUtil;























public class DefaultSpdyRstStreamFrame
  extends DefaultSpdyStreamFrame
  implements SpdyRstStreamFrame
{
  private SpdyStreamStatus status;
  
  public DefaultSpdyRstStreamFrame(int streamId, int statusCode)
  {
    this(streamId, SpdyStreamStatus.valueOf(statusCode));
  }
  





  public DefaultSpdyRstStreamFrame(int streamId, SpdyStreamStatus status)
  {
    super(streamId);
    setStatus(status);
  }
  
  public SpdyRstStreamFrame setStreamId(int streamId)
  {
    super.setStreamId(streamId);
    return this;
  }
  
  public SpdyRstStreamFrame setLast(boolean last)
  {
    super.setLast(last);
    return this;
  }
  
  public SpdyStreamStatus getStatus()
  {
    return status;
  }
  
  public SpdyRstStreamFrame setStatus(SpdyStreamStatus status)
  {
    this.status = status;
    return this;
  }
  
  public String toString()
  {
    StringBuilder buf = new StringBuilder();
    buf.append(getClass().getSimpleName());
    buf.append(StringUtil.NEWLINE);
    buf.append("--> Stream-ID = ");
    buf.append(getStreamId());
    buf.append(StringUtil.NEWLINE);
    buf.append("--> Status: ");
    buf.append(getStatus().toString());
    return buf.toString();
  }
}
