package net.minecraft.util.io.netty.handler.codec.spdy;

import net.minecraft.util.io.netty.util.internal.StringUtil;

























public class DefaultSpdySynStreamFrame
  extends DefaultSpdyHeadersFrame
  implements SpdySynStreamFrame
{
  private int associatedToStreamId;
  private byte priority;
  private boolean unidirectional;
  
  public DefaultSpdySynStreamFrame(int streamId, int associatedToStreamId, byte priority)
  {
    super(streamId);
    setAssociatedToStreamId(associatedToStreamId);
    setPriority(priority);
  }
  
  public SpdySynStreamFrame setStreamId(int streamId)
  {
    super.setStreamId(streamId);
    return this;
  }
  
  public SpdySynStreamFrame setLast(boolean last)
  {
    super.setLast(last);
    return this;
  }
  
  public SpdySynStreamFrame setInvalid()
  {
    super.setInvalid();
    return this;
  }
  
  public int getAssociatedToStreamId()
  {
    return associatedToStreamId;
  }
  
  public SpdySynStreamFrame setAssociatedToStreamId(int associatedToStreamId)
  {
    if (associatedToStreamId < 0) {
      throw new IllegalArgumentException("Associated-To-Stream-ID cannot be negative: " + associatedToStreamId);
    }
    

    this.associatedToStreamId = associatedToStreamId;
    return this;
  }
  
  public byte getPriority()
  {
    return priority;
  }
  
  public SpdySynStreamFrame setPriority(byte priority)
  {
    if ((priority < 0) || (priority > 7)) {
      throw new IllegalArgumentException("Priority must be between 0 and 7 inclusive: " + priority);
    }
    
    this.priority = priority;
    return this;
  }
  
  public boolean isUnidirectional()
  {
    return unidirectional;
  }
  
  public SpdySynStreamFrame setUnidirectional(boolean unidirectional)
  {
    this.unidirectional = unidirectional;
    return this;
  }
  
  public String toString()
  {
    StringBuilder buf = new StringBuilder();
    buf.append(getClass().getSimpleName());
    buf.append("(last: ");
    buf.append(isLast());
    buf.append("; unidirectional: ");
    buf.append(isUnidirectional());
    buf.append(')');
    buf.append(StringUtil.NEWLINE);
    buf.append("--> Stream-ID = ");
    buf.append(getStreamId());
    buf.append(StringUtil.NEWLINE);
    if (associatedToStreamId != 0) {
      buf.append("--> Associated-To-Stream-ID = ");
      buf.append(getAssociatedToStreamId());
      buf.append(StringUtil.NEWLINE);
    }
    buf.append("--> Priority = ");
    buf.append(getPriority());
    buf.append(StringUtil.NEWLINE);
    buf.append("--> Headers:");
    buf.append(StringUtil.NEWLINE);
    appendHeaders(buf);
    

    buf.setLength(buf.length() - StringUtil.NEWLINE.length());
    return buf.toString();
  }
}
