package net.minecraft.util.io.netty.handler.codec.spdy;

import net.minecraft.util.io.netty.util.internal.StringUtil;























public class DefaultSpdyWindowUpdateFrame
  implements SpdyWindowUpdateFrame
{
  private int streamId;
  private int deltaWindowSize;
  
  public DefaultSpdyWindowUpdateFrame(int streamId, int deltaWindowSize)
  {
    setStreamId(streamId);
    setDeltaWindowSize(deltaWindowSize);
  }
  
  public int getStreamId()
  {
    return streamId;
  }
  
  public SpdyWindowUpdateFrame setStreamId(int streamId)
  {
    if (streamId < 0) {
      throw new IllegalArgumentException("Stream-ID cannot be negative: " + streamId);
    }
    
    this.streamId = streamId;
    return this;
  }
  
  public int getDeltaWindowSize()
  {
    return deltaWindowSize;
  }
  
  public SpdyWindowUpdateFrame setDeltaWindowSize(int deltaWindowSize)
  {
    if (deltaWindowSize <= 0) {
      throw new IllegalArgumentException("Delta-Window-Size must be positive: " + deltaWindowSize);
    }
    

    this.deltaWindowSize = deltaWindowSize;
    return this;
  }
  
  public String toString()
  {
    StringBuilder buf = new StringBuilder();
    buf.append(getClass().getSimpleName());
    buf.append(StringUtil.NEWLINE);
    buf.append("--> Stream-ID = ");
    buf.append(getStreamId());
    buf.append(StringUtil.NEWLINE);
    buf.append("--> Delta-Window-Size = ");
    buf.append(getDeltaWindowSize());
    return buf.toString();
  }
}
