package net.minecraft.util.io.netty.handler.codec.spdy;

import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.channel.ChannelHandlerContext;
import net.minecraft.util.io.netty.util.internal.PlatformDependent;

















abstract class SpdyHeaderBlockEncoder
{
  static SpdyHeaderBlockEncoder newInstance(int version, int compressionLevel, int windowBits, int memLevel)
  {
    if (PlatformDependent.javaVersion() >= 7) {
      return new SpdyHeaderBlockZlibEncoder(version, compressionLevel);
    }
    
    return new SpdyHeaderBlockJZlibEncoder(version, compressionLevel, windowBits, memLevel);
  }
  
  abstract ByteBuf encode(ChannelHandlerContext paramChannelHandlerContext, SpdyHeadersFrame paramSpdyHeadersFrame)
    throws Exception;
  
  abstract void end();
}
