package net.minecraft.util.io.netty.handler.codec.spdy;

import java.util.zip.DataFormatException;
import java.util.zip.Inflater;
import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.buffer.Unpooled;


















class SpdyHeaderBlockZlibDecoder
  extends SpdyHeaderBlockRawDecoder
{
  private final int version;
  private final byte[] out = new byte[8192];
  private final Inflater decompressor = new Inflater();
  private ByteBuf decompressed;
  
  public SpdyHeaderBlockZlibDecoder(int version, int maxHeaderSize)
  {
    super(version, maxHeaderSize);
    this.version = version;
  }
  
  void decode(ByteBuf encoded, SpdyHeadersFrame frame) throws Exception
  {
    setInput(encoded);
    int numBytes;
    do
    {
      numBytes = decompress(frame);
    } while ((!decompressed.isReadable()) && (numBytes > 0));
  }
  
  private void setInput(ByteBuf compressed) {
    byte[] in = new byte[compressed.readableBytes()];
    compressed.readBytes(in);
    decompressor.setInput(in);
  }
  
  private int decompress(SpdyHeadersFrame frame) throws Exception {
    if (decompressed == null) {
      decompressed = Unpooled.buffer(8192);
    }
    try {
      int numBytes = decompressor.inflate(out);
      if ((numBytes == 0) && (decompressor.needsDictionary())) {
        if (version < 3) {
          decompressor.setDictionary(SpdyCodecUtil.SPDY2_DICT);
        } else {
          decompressor.setDictionary(SpdyCodecUtil.SPDY_DICT);
        }
        numBytes = decompressor.inflate(out);
      }
      if (frame != null) {
        decompressed.writeBytes(out, 0, numBytes);
        super.decode(decompressed, frame);
        decompressed.discardReadBytes();
      }
      return numBytes;
    } catch (DataFormatException e) {
      throw new SpdyProtocolException("Received invalid header block", e);
    }
  }
  

  public void reset()
  {
    decompressed = null;
    super.reset();
  }
  
  public void end()
  {
    decompressed = null;
    decompressor.end();
    super.end();
  }
}
