package net.minecraft.util.io.netty.handler.codec.string;

import java.nio.charset.Charset;
import java.util.List;
import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.channel.ChannelHandler.Sharable;
import net.minecraft.util.io.netty.channel.ChannelHandlerContext;
import net.minecraft.util.io.netty.handler.codec.MessageToMessageDecoder;















































@ChannelHandler.Sharable
public class StringDecoder
  extends MessageToMessageDecoder<ByteBuf>
{
  private final Charset charset;
  
  public StringDecoder()
  {
    this(Charset.defaultCharset());
  }
  


  public StringDecoder(Charset charset)
  {
    if (charset == null) {
      throw new NullPointerException("charset");
    }
    this.charset = charset;
  }
  
  protected void decode(ChannelHandlerContext ctx, ByteBuf msg, List<Object> out) throws Exception
  {
    out.add(msg.toString(charset));
  }
}
