package net.minecraft.util.io.netty.handler.codec.string;

import java.nio.charset.Charset;
import java.util.List;
import net.minecraft.util.io.netty.buffer.Unpooled;
import net.minecraft.util.io.netty.channel.ChannelHandler.Sharable;
import net.minecraft.util.io.netty.channel.ChannelHandlerContext;
import net.minecraft.util.io.netty.handler.codec.MessageToMessageEncoder;











































@ChannelHandler.Sharable
public class StringEncoder
  extends MessageToMessageEncoder<CharSequence>
{
  private final Charset charset;
  
  public StringEncoder()
  {
    this(Charset.defaultCharset());
  }
  


  public StringEncoder(Charset charset)
  {
    if (charset == null) {
      throw new NullPointerException("charset");
    }
    this.charset = charset;
  }
  
  protected void encode(ChannelHandlerContext ctx, CharSequence msg, List<Object> out) throws Exception
  {
    if (msg.length() == 0) {
      return;
    }
    
    out.add(Unpooled.copiedBuffer(msg, charset));
  }
}
