package net.minecraft.util.io.netty.handler.traffic;

import java.util.concurrent.ScheduledExecutorService;
import net.minecraft.util.io.netty.channel.ChannelHandler.Sharable;
import net.minecraft.util.io.netty.util.concurrent.EventExecutor;















































@ChannelHandler.Sharable
public class GlobalTrafficShapingHandler
  extends AbstractTrafficShapingHandler
{
  void createGlobalTrafficCounter(ScheduledExecutorService executor)
  {
    if (executor == null) {
      throw new NullPointerException("executor");
    }
    TrafficCounter tc = new TrafficCounter(this, executor, "GlobalTC", checkInterval);
    
    setTrafficCounter(tc);
    tc.start();
  }
  













  public GlobalTrafficShapingHandler(ScheduledExecutorService executor, long writeLimit, long readLimit, long checkInterval)
  {
    super(writeLimit, readLimit, checkInterval);
    createGlobalTrafficCounter(executor);
  }
  










  public GlobalTrafficShapingHandler(ScheduledExecutorService executor, long writeLimit, long readLimit)
  {
    super(writeLimit, readLimit);
    createGlobalTrafficCounter(executor);
  }
  








  public GlobalTrafficShapingHandler(ScheduledExecutorService executor, long checkInterval)
  {
    super(checkInterval);
    createGlobalTrafficCounter(executor);
  }
  





  public GlobalTrafficShapingHandler(EventExecutor executor)
  {
    createGlobalTrafficCounter(executor);
  }
  


  public final void release()
  {
    if (trafficCounter != null) {
      trafficCounter.stop();
    }
  }
}
