package net.minecraft.util.io.netty.util.internal;

import java.util.ArrayList;
import java.util.Formatter;
import java.util.List;





















public final class StringUtil
{
  public static final String NEWLINE;
  private static final String EMPTY_STRING = "";
  
  static
  {
    String newLine;
    try
    {
      newLine = new Formatter().format("%n", new Object[0]).toString();
    } catch (Exception e) {
      newLine = "\n";
    }
    
    NEWLINE = newLine;
  }
  





  public static String[] split(String value, char delim)
  {
    int end = value.length();
    List<String> res = new ArrayList();
    
    int start = 0;
    for (int i = 0; i < end; i++) {
      if (value.charAt(i) == delim) {
        if (start == i) {
          res.add("");
        } else {
          res.add(value.substring(start, i));
        }
        start = i + 1;
      }
    }
    
    if (start == 0) {
      res.add(value);
    }
    else if (start != end)
    {
      res.add(value.substring(start, end));
    }
    else {
      for (int i = res.size() - 1; i >= 0; i--) {
        if (!((String)res.get(i)).isEmpty()) break;
        res.remove(i);
      }
    }
    




    return (String[])res.toArray(new String[res.size()]);
  }
  


  public static String simpleClassName(Object o)
  {
    return simpleClassName(o.getClass());
  }
  



  public static String simpleClassName(Class<?> clazz)
  {
    Package pkg = clazz.getPackage();
    if (pkg != null) {
      return clazz.getName().substring(pkg.getName().length() + 1);
    }
    return clazz.getName();
  }
}
