package net.minecraft.util.org.apache.commons.io.output;

import java.io.IOException;
import java.io.OutputStream;
import java.io.Serializable;
import java.util.UUID;
import net.minecraft.util.org.apache.commons.io.TaggedIOException;


























































public class TaggedOutputStream
  extends ProxyOutputStream
{
  private final Serializable tag = UUID.randomUUID();
  




  public TaggedOutputStream(OutputStream proxy)
  {
    super(proxy);
  }
  






  public boolean isCauseOf(Exception exception)
  {
    return TaggedIOException.isTaggedWith(exception, tag);
  }
  








  public void throwIfCauseOf(Exception exception)
    throws IOException
  {
    TaggedIOException.throwCauseIfTaggedWith(exception, tag);
  }
  





  protected void handleIOException(IOException e)
    throws IOException
  {
    throw new TaggedIOException(e, tag);
  }
}
