package net.minecraft.util.org.apache.commons.lang3;


















































public class CharSequenceUtils
{
  public static CharSequence subSequence(CharSequence cs, int start)
  {
    return cs == null ? null : cs.subSequence(start, cs.length());
  }
  









  static int indexOf(CharSequence cs, int searchChar, int start)
  {
    if ((cs instanceof String)) {
      return ((String)cs).indexOf(searchChar, start);
    }
    int sz = cs.length();
    if (start < 0) {
      start = 0;
    }
    for (int i = start; i < sz; i++) {
      if (cs.charAt(i) == searchChar) {
        return i;
      }
    }
    return -1;
  }
  








  static int indexOf(CharSequence cs, CharSequence searchChar, int start)
  {
    return cs.toString().indexOf(searchChar.toString(), start);
  }
  

















  static int lastIndexOf(CharSequence cs, int searchChar, int start)
  {
    if ((cs instanceof String)) {
      return ((String)cs).lastIndexOf(searchChar, start);
    }
    int sz = cs.length();
    if (start < 0) {
      return -1;
    }
    if (start >= sz) {
      start = sz - 1;
    }
    for (int i = start; i >= 0; i--) {
      if (cs.charAt(i) == searchChar) {
        return i;
      }
    }
    return -1;
  }
  








  static int lastIndexOf(CharSequence cs, CharSequence searchChar, int start)
  {
    return cs.toString().lastIndexOf(searchChar.toString(), start);
  }
  














  static char[] toCharArray(CharSequence cs)
  {
    if ((cs instanceof String)) {
      return ((String)cs).toCharArray();
    }
    int sz = cs.length();
    char[] array = new char[cs.length()];
    for (int i = 0; i < sz; i++) {
      array[i] = cs.charAt(i);
    }
    return array;
  }
  












  static boolean regionMatches(CharSequence cs, boolean ignoreCase, int thisStart, CharSequence substring, int start, int length)
  {
    if (((cs instanceof String)) && ((substring instanceof String))) {
      return ((String)cs).regionMatches(ignoreCase, thisStart, (String)substring, start, length);
    }
    
    return cs.toString().regionMatches(ignoreCase, thisStart, substring.toString(), start, length);
  }
}
