package org.apache.commons.lang.mutable;

import java.io.Serializable;
import org.apache.commons.lang.BooleanUtils;












































public class MutableBoolean
  implements Mutable, Serializable, Comparable
{
  private static final long serialVersionUID = -4830728138360036487L;
  private boolean value;
  
  public MutableBoolean() {}
  
  public MutableBoolean(boolean value)
  {
    this.value = value;
  }
  








  public MutableBoolean(Boolean value)
  {
    this.value = value.booleanValue();
  }
  





  public boolean booleanValue()
  {
    return value;
  }
  










  public int compareTo(Object obj)
  {
    MutableBoolean other = (MutableBoolean)obj;
    boolean anotherVal = value;
    return value ? 1 : value == anotherVal ? 0 : -1;
  }
  









  public boolean equals(Object obj)
  {
    if ((obj instanceof MutableBoolean)) {
      return value == ((MutableBoolean)obj).booleanValue();
    }
    return false;
  }
  





  public Object getValue()
  {
    return BooleanUtils.toBooleanObject(value);
  }
  





  public int hashCode()
  {
    return value ? Boolean.TRUE.hashCode() : Boolean.FALSE.hashCode();
  }
  





  public void setValue(boolean value)
  {
    this.value = value;
  }
  









  public void setValue(Object value)
  {
    setValue(((Boolean)value).booleanValue());
  }
  




  public String toString()
  {
    return String.valueOf(value);
  }
}
