package org.apache.commons.lang.mutable;











public class MutableByte
  extends Number
  implements Comparable, Mutable
{
  private static final long serialVersionUID = -1585823265L;
  









  private byte value;
  










  public MutableByte() {}
  









  public MutableByte(byte value)
  {
    this.value = value;
  }
  








  public MutableByte(Number value)
  {
    this.value = value.byteValue();
  }
  





  public Object getValue()
  {
    return new Byte(value);
  }
  





  public void setValue(byte value)
  {
    this.value = value;
  }
  









  public void setValue(Object value)
  {
    setValue(((Number)value).byteValue());
  }
  






  public byte byteValue()
  {
    return value;
  }
  




  public int intValue()
  {
    return value;
  }
  




  public long longValue()
  {
    return value;
  }
  




  public float floatValue()
  {
    return value;
  }
  




  public double doubleValue()
  {
    return value;
  }
  





  public Byte toByte()
  {
    return new Byte(byteValue());
  }
  





  public void increment()
  {
    value = ((byte)(value + 1));
  }
  




  public void decrement()
  {
    value = ((byte)(value - 1));
  }
  








  public void add(byte operand)
  {
    value = ((byte)(value + operand));
  }
  









  public void add(Number operand)
  {
    value = ((byte)(value + operand.byteValue()));
  }
  







  public void subtract(byte operand)
  {
    value = ((byte)(value - operand));
  }
  









  public void subtract(Number operand)
  {
    value = ((byte)(value - operand.byteValue()));
  }
  









  public boolean equals(Object obj)
  {
    if ((obj instanceof MutableByte)) {
      return value == ((MutableByte)obj).byteValue();
    }
    return false;
  }
  




  public int hashCode()
  {
    return value;
  }
  







  public int compareTo(Object obj)
  {
    MutableByte other = (MutableByte)obj;
    byte anotherVal = value;
    return value == anotherVal ? 0 : value < anotherVal ? -1 : 1;
  }
  




  public String toString()
  {
    return String.valueOf(value);
  }
}
