package org.apache.commons.lang.mutable;

import org.apache.commons.lang.math.NumberUtils;








































public class MutableDouble
  extends Number
  implements Comparable, Mutable
{
  private static final long serialVersionUID = 1587163916L;
  private double value;
  
  public MutableDouble() {}
  
  public MutableDouble(double value)
  {
    this.value = value;
  }
  








  public MutableDouble(Number value)
  {
    this.value = value.doubleValue();
  }
  





  public Object getValue()
  {
    return new Double(value);
  }
  





  public void setValue(double value)
  {
    this.value = value;
  }
  









  public void setValue(Object value)
  {
    setValue(((Number)value).doubleValue());
  }
  






  public int intValue()
  {
    return (int)value;
  }
  




  public long longValue()
  {
    return value;
  }
  




  public float floatValue()
  {
    return (float)value;
  }
  




  public double doubleValue()
  {
    return value;
  }
  




  public boolean isNaN()
  {
    return Double.isNaN(value);
  }
  




  public boolean isInfinite()
  {
    return Double.isInfinite(value);
  }
  





  public Double toDouble()
  {
    return new Double(doubleValue());
  }
  





  public void increment()
  {
    value += 1.0D;
  }
  




  public void decrement()
  {
    value -= 1.0D;
  }
  








  public void add(double operand)
  {
    value += operand;
  }
  









  public void add(Number operand)
  {
    value += operand.doubleValue();
  }
  







  public void subtract(double operand)
  {
    value -= operand;
  }
  









  public void subtract(Number operand)
  {
    value -= operand.doubleValue();
  }
  






























  public boolean equals(Object obj)
  {
    return ((obj instanceof MutableDouble)) && (Double.doubleToLongBits(value) == Double.doubleToLongBits(value));
  }
  





  public int hashCode()
  {
    long bits = Double.doubleToLongBits(value);
    return (int)(bits ^ bits >>> 32);
  }
  







  public int compareTo(Object obj)
  {
    MutableDouble other = (MutableDouble)obj;
    double anotherVal = value;
    return NumberUtils.compare(value, anotherVal);
  }
  




  public String toString()
  {
    return String.valueOf(value);
  }
}
