package org.apache.commons.lang.mutable;











public class MutableInt
  extends Number
  implements Comparable, Mutable
{
  private static final long serialVersionUID = 512176391864L;
  









  private int value;
  










  public MutableInt() {}
  









  public MutableInt(int value)
  {
    this.value = value;
  }
  








  public MutableInt(Number value)
  {
    this.value = value.intValue();
  }
  





  public Object getValue()
  {
    return new Integer(value);
  }
  





  public void setValue(int value)
  {
    this.value = value;
  }
  









  public void setValue(Object value)
  {
    setValue(((Number)value).intValue());
  }
  





  public void increment()
  {
    value += 1;
  }
  




  public void decrement()
  {
    value -= 1;
  }
  








  public void add(int operand)
  {
    value += operand;
  }
  









  public void add(Number operand)
  {
    value += operand.intValue();
  }
  







  public void subtract(int operand)
  {
    value -= operand;
  }
  









  public void subtract(Number operand)
  {
    value -= operand.intValue();
  }
  






  public int intValue()
  {
    return value;
  }
  




  public long longValue()
  {
    return value;
  }
  




  public float floatValue()
  {
    return value;
  }
  




  public double doubleValue()
  {
    return value;
  }
  





  public Integer toInteger()
  {
    return new Integer(intValue());
  }
  









  public boolean equals(Object obj)
  {
    if ((obj instanceof MutableInt)) {
      return value == ((MutableInt)obj).intValue();
    }
    return false;
  }
  




  public int hashCode()
  {
    return value;
  }
  







  public int compareTo(Object obj)
  {
    MutableInt other = (MutableInt)obj;
    int anotherVal = value;
    return value == anotherVal ? 0 : value < anotherVal ? -1 : 1;
  }
  




  public String toString()
  {
    return String.valueOf(value);
  }
}
