package org.apache.commons.lang.mutable;











public class MutableLong
  extends Number
  implements Comparable, Mutable
{
  private static final long serialVersionUID = 62986528375L;
  









  private long value;
  










  public MutableLong() {}
  









  public MutableLong(long value)
  {
    this.value = value;
  }
  








  public MutableLong(Number value)
  {
    this.value = value.longValue();
  }
  





  public Object getValue()
  {
    return new Long(value);
  }
  





  public void setValue(long value)
  {
    this.value = value;
  }
  









  public void setValue(Object value)
  {
    setValue(((Number)value).longValue());
  }
  





  public void increment()
  {
    value += 1L;
  }
  




  public void decrement()
  {
    value -= 1L;
  }
  








  public void add(long operand)
  {
    value += operand;
  }
  









  public void add(Number operand)
  {
    value += operand.longValue();
  }
  







  public void subtract(long operand)
  {
    value -= operand;
  }
  









  public void subtract(Number operand)
  {
    value -= operand.longValue();
  }
  






  public int intValue()
  {
    return (int)value;
  }
  




  public long longValue()
  {
    return value;
  }
  




  public float floatValue()
  {
    return (float)value;
  }
  




  public double doubleValue()
  {
    return value;
  }
  





  public Long toLong()
  {
    return new Long(longValue());
  }
  









  public boolean equals(Object obj)
  {
    if ((obj instanceof MutableLong)) {
      return value == ((MutableLong)obj).longValue();
    }
    return false;
  }
  




  public int hashCode()
  {
    return (int)(value ^ value >>> 32);
  }
  







  public int compareTo(Object obj)
  {
    MutableLong other = (MutableLong)obj;
    long anotherVal = value;
    return value == anotherVal ? 0 : value < anotherVal ? -1 : 1;
  }
  




  public String toString()
  {
    return String.valueOf(value);
  }
}
