package org.apache.commons.lang.mutable;

import java.io.Serializable;









































public class MutableObject
  implements Mutable, Serializable
{
  private static final long serialVersionUID = 86241875189L;
  private Object value;
  
  public MutableObject() {}
  
  public MutableObject(Object value)
  {
    this.value = value;
  }
  





  public Object getValue()
  {
    return value;
  }
  





  public void setValue(Object value)
  {
    this.value = value;
  }
  









  public boolean equals(Object obj)
  {
    if ((obj instanceof MutableObject)) {
      Object other = value;
      return (value == other) || ((value != null) && (value.equals(other)));
    }
    return false;
  }
  




  public int hashCode()
  {
    return value == null ? 0 : value.hashCode();
  }
  




  public String toString()
  {
    return value == null ? "null" : value.toString();
  }
}
