package org.apache.logging.log4j.core.appender.rolling.helper;

import java.io.IOException;
import java.util.List;
import org.apache.logging.log4j.Logger;































public class CompositeAction
  extends AbstractAction
{
  private final Action[] actions;
  private final boolean stopOnError;
  
  public CompositeAction(List<Action> actions, boolean stopOnError)
  {
    this.actions = new Action[actions.size()];
    actions.toArray(this.actions);
    this.stopOnError = stopOnError;
  }
  


  public void run()
  {
    try
    {
      execute();
    } catch (IOException ex) {
      LOGGER.warn("Exception during file rollover.", ex);
    }
  }
  





  public boolean execute()
    throws IOException
  {
    if (stopOnError) {
      for (Action action : actions) {
        if (!action.execute()) {
          return false;
        }
      }
      
      return true;
    }
    boolean status = true;
    IOException exception = null;
    
    for (Action action : actions) {
      try {
        status &= action.execute();
      } catch (IOException ex) {
        status = false;
        
        if (exception == null) {
          exception = ex;
        }
      }
    }
    
    if (exception != null) {
      throw exception;
    }
    
    return status;
  }
}
