package org.apache.logging.log4j.core.config;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.logging.log4j.core.config.plugins.PluginType;





















public class Node
{
  private final Node parent;
  private final String name;
  private String value;
  private final PluginType<?> type;
  private final Map<String, String> attributes = new HashMap();
  private final List<Node> children = new ArrayList();
  



  private Object object;
  




  public Node(Node parent, String name, PluginType<?> type)
  {
    this.parent = parent;
    this.name = name;
    this.type = type;
  }
  
  public Node() {
    parent = null;
    name = null;
    type = null;
  }
  
  public Node(Node node) {
    parent = parent;
    name = name;
    type = type;
    attributes.putAll(node.getAttributes());
    value = node.getValue();
    for (Node child : node.getChildren()) {
      children.add(new Node(child));
    }
    object = object;
  }
  
  public Map<String, String> getAttributes() {
    return attributes;
  }
  
  public List<Node> getChildren() {
    return children;
  }
  
  public boolean hasChildren() {
    return children.size() > 0;
  }
  
  public String getValue() {
    return value;
  }
  
  public void setValue(String value) {
    this.value = value;
  }
  
  public Node getParent() {
    return parent;
  }
  
  public String getName() {
    return name;
  }
  
  public boolean isRoot() {
    return parent == null;
  }
  
  public void setObject(Object obj) {
    object = obj;
  }
  
  public Object getObject() {
    return object;
  }
  
  public PluginType<?> getType() {
    return type;
  }
  
  public String toString()
  {
    if (object == null) {
      return "null";
    }
    return type.getPluginClass().getName() + " with name " + name;
  }
}
