package org.apache.logging.log4j.core.config.plugins;

import java.io.Serializable;






















public class PluginType<T>
  implements Serializable
{
  private static final long serialVersionUID = 4743255148794846612L;
  private final Class<T> pluginClass;
  private final String elementName;
  private final boolean printObject;
  private final boolean deferChildren;
  
  public PluginType(Class<T> clazz, String name, boolean printObj, boolean deferChildren)
  {
    pluginClass = clazz;
    elementName = name;
    printObject = printObj;
    this.deferChildren = deferChildren;
  }
  
  public Class<T> getPluginClass() {
    return pluginClass;
  }
  
  public String getElementName() {
    return elementName;
  }
  
  public boolean isObjectPrintable() {
    return printObject;
  }
  
  public boolean isDeferChildren() {
    return deferChildren;
  }
}
