package org.apache.logging.log4j.core.jmx;

import javax.management.ObjectName;
import org.apache.logging.log4j.core.Appender;
import org.apache.logging.log4j.core.helpers.Assert;



























public class AppenderAdmin
  implements AppenderAdminMBean
{
  private final String contextName;
  private final Appender appender;
  private final ObjectName objectName;
  
  public AppenderAdmin(String contextName, Appender appender)
  {
    this.contextName = ((String)Assert.isNotNull(contextName, "contextName"));
    this.appender = ((Appender)Assert.isNotNull(appender, "appender"));
    try {
      String ctxName = Server.escape(this.contextName);
      String configName = Server.escape(appender.getName());
      String name = String.format("org.apache.logging.log4j2:type=LoggerContext,ctx=%s,sub=Appender,name=%s", new Object[] { ctxName, configName });
      objectName = new ObjectName(name);
    } catch (Exception e) {
      throw new IllegalStateException(e);
    }
  }
  





  public ObjectName getObjectName()
  {
    return objectName;
  }
  
  public String getName()
  {
    return appender.getName();
  }
  
  public String getLayout()
  {
    return String.valueOf(appender.getLayout());
  }
  
  public boolean isExceptionSuppressed()
  {
    return appender.ignoreExceptions();
  }
  
  public String getErrorHandler()
  {
    return String.valueOf(appender.getHandler());
  }
}
