package org.apache.logging.log4j.core.lookup;

import java.util.Map;
import org.apache.logging.log4j.core.LogEvent;
import org.apache.logging.log4j.core.config.plugins.Plugin;
import org.apache.logging.log4j.message.MapMessage;


























@Plugin(name="map", category="Lookup")
public class MapLookup
  implements StrLookup
{
  private final Map<String, String> map;
  
  public MapLookup(Map<String, String> map)
  {
    this.map = map;
  }
  


  public MapLookup()
  {
    map = null;
  }
  









  public String lookup(String key)
  {
    if (map == null) {
      return null;
    }
    String obj = (String)map.get(key);
    if (obj == null) {
      return null;
    }
    return obj;
  }
  
  public String lookup(LogEvent event, String key)
  {
    if ((map == null) && (!(event.getMessage() instanceof MapMessage))) {
      return null;
    }
    if ((map != null) && (map.containsKey(key))) {
      String obj = (String)map.get(key);
      if (obj != null) {
        return obj;
      }
    }
    if ((event.getMessage() instanceof MapMessage)) {
      return ((MapMessage)event.getMessage()).get(key);
    }
    return null;
  }
}
