package org.apache.logging.log4j.core.net;

import org.apache.logging.log4j.Level;
























public class Priority
{
  private final Facility facility;
  private final Severity severity;
  
  public Priority(Facility facility, Severity severity)
  {
    this.facility = facility;
    this.severity = severity;
  }
  





  public static int getPriority(Facility facility, Level level)
  {
    return (facility.getCode() << 3) + Severity.getSeverity(level).getCode();
  }
  



  public Facility getFacility()
  {
    return facility;
  }
  



  public Severity getSeverity()
  {
    return severity;
  }
  



  public int getValue()
  {
    return facility.getCode() << 3 + severity.getCode();
  }
  
  public String toString()
  {
    return Integer.toString(getValue());
  }
}
