package org.apache.logging.log4j.core.net;

import org.apache.logging.log4j.Level;
































public enum Severity
{
  EMERG(0), 
  
  ALERT(1), 
  
  CRITICAL(2), 
  
  ERROR(3), 
  
  WARNING(4), 
  
  NOTICE(5), 
  
  INFO(6), 
  
  DEBUG(7);
  
  private final int code;
  
  private Severity(int code) {
    this.code = code;
  }
  



  public int getCode()
  {
    return code;
  }
  




  public boolean isEqual(String name)
  {
    return name().equalsIgnoreCase(name);
  }
  




  public static Severity getSeverity(Level level)
  {
    switch (1.$SwitchMap$org$apache$logging$log4j$Level[level.ordinal()]) {
    case 1: 
      return DEBUG;
    case 2: 
      return DEBUG;
    case 3: 
      return DEBUG;
    case 4: 
      return INFO;
    case 5: 
      return WARNING;
    case 6: 
      return ERROR;
    case 7: 
      return ALERT;
    case 8: 
      return EMERG;
    }
    return DEBUG;
  }
}
