package org.apache.logging.log4j.core.pattern;

import org.apache.logging.log4j.core.LogEvent;
import org.apache.logging.log4j.core.config.Configuration;
import org.apache.logging.log4j.core.lookup.StrSubstitutor;



























public final class LiteralPatternConverter
  extends LogEventPatternConverter
  implements ArrayPatternConverter
{
  private final String literal;
  private final Configuration config;
  private final boolean substitute;
  
  public LiteralPatternConverter(Configuration config, String literal)
  {
    super("Literal", "literal");
    this.literal = literal;
    this.config = config;
    substitute = ((config != null) && (literal.contains("${")));
  }
  



  public void format(LogEvent event, StringBuilder toAppendTo)
  {
    toAppendTo.append(substitute ? config.getStrSubstitutor().replace(event, literal) : literal);
  }
  


  public void format(Object obj, StringBuilder output)
  {
    output.append(substitute ? config.getStrSubstitutor().replace(literal) : literal);
  }
  



  public void format(StringBuilder output, Object... objects)
  {
    output.append(substitute ? config.getStrSubstitutor().replace(literal) : literal);
  }
  
  public String getLiteral() {
    return literal;
  }
}
