package org.apache.logging.log4j.core.pattern;

import org.apache.logging.log4j.core.LogEvent;



















public class PatternFormatter
{
  private final LogEventPatternConverter converter;
  private final FormattingInfo field;
  
  public PatternFormatter(LogEventPatternConverter converter, FormattingInfo field)
  {
    this.converter = converter;
    this.field = field;
  }
  
  public void format(LogEvent event, StringBuilder buf) {
    int startField = buf.length();
    converter.format(event, buf);
    field.format(startField, buf);
  }
  
  public LogEventPatternConverter getConverter() {
    return converter;
  }
  
  public FormattingInfo getFormattingInfo() {
    return field;
  }
  








  public boolean handlesThrowable()
  {
    return converter.handlesThrowable();
  }
  





  public String toString()
  {
    StringBuilder sb = new StringBuilder();
    sb.append(super.toString());
    sb.append("[converter=");
    sb.append(converter);
    sb.append(", field=");
    sb.append(field);
    sb.append("]");
    return sb.toString();
  }
}
