package org.apache.logging.log4j.core.pattern;

import java.lang.management.ManagementFactory;
import java.lang.management.RuntimeMXBean;
import org.apache.logging.log4j.core.LogEvent;
import org.apache.logging.log4j.core.config.plugins.Plugin;





















@Plugin(name="RelativeTimePatternConverter", category="Converter")
@ConverterKeys({"r", "relative"})
public class RelativeTimePatternConverter
  extends LogEventPatternConverter
{
  private long lastTimestamp = -9223372036854775808L;
  private final long startTime = ManagementFactory.getRuntimeMXBean().getStartTime();
  
  private String relative;
  

  public RelativeTimePatternConverter()
  {
    super("Time", "time");
  }
  






  public static RelativeTimePatternConverter newInstance(String[] options)
  {
    return new RelativeTimePatternConverter();
  }
  



  public void format(LogEvent event, StringBuilder toAppendTo)
  {
    long timestamp = event.getMillis();
    
    synchronized (this) {
      if (timestamp != lastTimestamp) {
        lastTimestamp = timestamp;
        relative = Long.toString(timestamp - startTime);
      }
    }
    toAppendTo.append(relative);
  }
}
