package org.apache.logging.log4j.core.web;

import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.servlet.UnavailableException;





















public class Log4jServletContextListener
  implements ServletContextListener
{
  private ServletContext servletContext;
  private Log4jWebInitializer initializer;
  
  public void contextInitialized(ServletContextEvent event)
  {
    servletContext = event.getServletContext();
    servletContext.log("Log4jServletContextListener ensuring that Log4j starts up properly.");
    
    initializer = Log4jWebInitializerImpl.getLog4jWebInitializer(servletContext);
    try {
      initializer.initialize();
      initializer.setLoggerContext();
    } catch (UnavailableException e) {
      throw new RuntimeException("Failed to initialize Log4j properly.", e);
    }
  }
  
  public void contextDestroyed(ServletContextEvent event)
  {
    if ((servletContext == null) || (initializer == null)) {
      throw new IllegalStateException("Context destroyed before it was initialized.");
    }
    servletContext.log("Log4jServletContextListener ensuring that Log4j shuts down properly.");
    
    initializer.clearLoggerContext();
    initializer.deinitialize();
  }
}
