package org.apache.logging.log4j.message;

import java.util.ResourceBundle;





















public class LocalizedMessageFactory
  extends AbstractMessageFactory
{
  private final ResourceBundle bundle;
  private final String bundleId;
  
  public LocalizedMessageFactory(ResourceBundle bundle)
  {
    this.bundle = bundle;
    bundleId = null;
  }
  
  public LocalizedMessageFactory(String bundleId)
  {
    bundle = null;
    this.bundleId = bundleId;
  }
  










  public Message newMessage(String message, Object... params)
  {
    if (bundle == null) {
      return new LocalizedMessage(bundleId, message, params);
    }
    return new LocalizedMessage(bundle, message, params);
  }
}
