package org.apache.logging.log4j.message;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;























public class ObjectMessage
  implements Message
{
  private static final long serialVersionUID = -5903272448334166185L;
  private transient Object obj;
  
  public ObjectMessage(Object obj)
  {
    if (obj == null) {
      obj = "null";
    }
    this.obj = obj;
  }
  




  public String getFormattedMessage()
  {
    return obj.toString();
  }
  




  public String getFormat()
  {
    return obj.toString();
  }
  




  public Object[] getParameters()
  {
    return new Object[] { obj };
  }
  
  public boolean equals(Object o)
  {
    if (this == o) {
      return true;
    }
    if ((o == null) || (getClass() != o.getClass())) {
      return false;
    }
    
    ObjectMessage that = (ObjectMessage)o;
    
    return obj != null ? obj.equals(obj) : obj == null;
  }
  
  public int hashCode()
  {
    return obj != null ? obj.hashCode() : 0;
  }
  
  public String toString()
  {
    return "ObjectMessage[obj=" + obj.toString() + "]";
  }
  
  private void writeObject(ObjectOutputStream out) throws IOException {
    out.defaultWriteObject();
    if ((obj instanceof Serializable)) {
      out.writeObject(obj);
    } else {
      out.writeObject(obj.toString());
    }
  }
  
  private void readObject(ObjectInputStream in) throws IOException, ClassNotFoundException {
    in.defaultReadObject();
    obj = in.readObject();
  }
  





  public Throwable getThrowable()
  {
    return (obj instanceof Throwable) ? (Throwable)obj : null;
  }
}
