package org.apache.logging.log4j.spi;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;






















public class MutableThreadContextStack
  implements ThreadContextStack
{
  private static final long serialVersionUID = 50505011L;
  private final List<String> list;
  
  public MutableThreadContextStack(List<String> list)
  {
    this.list = new ArrayList(list);
  }
  
  private MutableThreadContextStack(MutableThreadContextStack stack) {
    list = new ArrayList(list);
  }
  
  public String pop()
  {
    if (list.isEmpty()) {
      return null;
    }
    int last = list.size() - 1;
    String result = (String)list.remove(last);
    return result;
  }
  
  public String peek()
  {
    if (list.isEmpty()) {
      return null;
    }
    int last = list.size() - 1;
    return (String)list.get(last);
  }
  
  public void push(String message)
  {
    list.add(message);
  }
  
  public int getDepth()
  {
    return list.size();
  }
  
  public List<String> asList()
  {
    return list;
  }
  
  public void trim(int depth)
  {
    if (depth < 0) {
      throw new IllegalArgumentException("Maximum stack depth cannot be negative");
    }
    if (list == null) {
      return;
    }
    List<String> copy = new ArrayList(list.size());
    int count = Math.min(depth, list.size());
    for (int i = 0; i < count; i++) {
      copy.add(list.get(i));
    }
    list.clear();
    list.addAll(copy);
  }
  
  public ThreadContextStack copy()
  {
    return new MutableThreadContextStack(this);
  }
  
  public void clear()
  {
    list.clear();
  }
  
  public int size()
  {
    return list.size();
  }
  
  public boolean isEmpty()
  {
    return list.isEmpty();
  }
  
  public boolean contains(Object o)
  {
    return list.contains(o);
  }
  
  public Iterator<String> iterator()
  {
    return list.iterator();
  }
  
  public Object[] toArray()
  {
    return list.toArray();
  }
  
  public <T> T[] toArray(T[] ts)
  {
    return list.toArray(ts);
  }
  
  public boolean add(String s)
  {
    return list.add(s);
  }
  
  public boolean remove(Object o)
  {
    return list.remove(o);
  }
  
  public boolean containsAll(Collection<?> objects)
  {
    return list.containsAll(objects);
  }
  
  public boolean addAll(Collection<? extends String> strings)
  {
    return list.addAll(strings);
  }
  
  public boolean removeAll(Collection<?> objects)
  {
    return list.removeAll(objects);
  }
  
  public boolean retainAll(Collection<?> objects)
  {
    return list.retainAll(objects);
  }
  
  public String toString()
  {
    return String.valueOf(list);
  }
}
