package org.bukkit.command.defaults;

import org.bukkit.command.CommandSender;

public class MeCommand extends VanillaCommand
{
  public MeCommand()
  {
    super("me");
    description = "Performs the specified action in chat";
    usageMessage = "/me <action>";
    setPermission("bukkit.command.me");
  }
  
  public boolean execute(CommandSender sender, String currentAlias, String[] args)
  {
    if (!testPermission(sender)) return true;
    if (args.length < 1) {
      sender.sendMessage(org.bukkit.ChatColor.RED + "Usage: " + usageMessage);
      return false;
    }
    
    StringBuilder message = new StringBuilder();
    message.append(sender.getName());
    
    for (String arg : args) {
      message.append(" ");
      message.append(arg);
    }
    
    org.bukkit.Bukkit.broadcastMessage("* " + message.toString());
    
    return true;
  }
}
