package org.bukkit.command.defaults;

import com.google.common.collect.ImmutableList;
import java.util.List;
import org.apache.commons.lang.Validate;
import org.bukkit.Bukkit;
import org.bukkit.World;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;

public class SaveOffCommand extends VanillaCommand
{
  public SaveOffCommand()
  {
    super("save-off");
    description = "Disables server autosaving";
    usageMessage = "/save-off";
    setPermission("bukkit.command.save.disable");
  }
  
  public boolean execute(CommandSender sender, String currentAlias, String[] args)
  {
    if (!testPermission(sender)) { return true;
    }
    for (World world : Bukkit.getWorlds()) {
      world.setAutoSave(false);
    }
    
    Command.broadcastCommandMessage(sender, "Disabled level saving..");
    return true;
  }
  
  public List<String> tabComplete(CommandSender sender, String alias, String[] args) throws IllegalArgumentException
  {
    Validate.notNull(sender, "Sender cannot be null");
    Validate.notNull(args, "Arguments cannot be null");
    Validate.notNull(alias, "Alias cannot be null");
    
    return ImmutableList.of();
  }
}
