package org.bukkit.craftbukkit.libs.com.google.gson;

import java.io.IOException;
import java.io.Reader;
import java.io.StringReader;
import java.io.StringWriter;
import java.io.Writer;
import org.bukkit.craftbukkit.libs.com.google.gson.internal.bind.JsonTreeReader;
import org.bukkit.craftbukkit.libs.com.google.gson.internal.bind.JsonTreeWriter;
import org.bukkit.craftbukkit.libs.com.google.gson.stream.JsonReader;
import org.bukkit.craftbukkit.libs.com.google.gson.stream.JsonToken;
import org.bukkit.craftbukkit.libs.com.google.gson.stream.JsonWriter;























































































































public abstract class TypeAdapter<T>
{
  public abstract void write(JsonWriter paramJsonWriter, T paramT)
    throws IOException;
  
  final void toJson(Writer out, T value)
    throws IOException
  {
    JsonWriter writer = new JsonWriter(out);
    write(writer, value);
  }
  







































  public final TypeAdapter<T> nullSafe()
  {
    new TypeAdapter() {
      public void write(JsonWriter out, T value) throws IOException {
        if (value == null) {
          out.nullValue();
        } else
          TypeAdapter.this.write(out, value);
      }
      
      public T read(JsonReader reader) throws IOException {
        if (reader.peek() == JsonToken.NULL) {
          reader.nextNull();
          return null;
        }
        return TypeAdapter.this.read(reader);
      }
    };
  }
  







  final String toJson(T value)
    throws IOException
  {
    StringWriter stringWriter = new StringWriter();
    toJson(stringWriter, value);
    return stringWriter.toString();
  }
  




  final JsonElement toJsonTree(T value)
  {
    try
    {
      JsonTreeWriter jsonWriter = new JsonTreeWriter();
      jsonWriter.setLenient(true);
      write(jsonWriter, value);
      return jsonWriter.get();
    } catch (IOException e) {
      throw new JsonIOException(e);
    }
  }
  






  public abstract T read(JsonReader paramJsonReader)
    throws IOException;
  





  final T fromJson(Reader in)
    throws IOException
  {
    JsonReader reader = new JsonReader(in);
    reader.setLenient(true);
    return read(reader);
  }
  






  final T fromJson(String json)
    throws IOException
  {
    return fromJson(new StringReader(json));
  }
  



  final T fromJsonTree(JsonElement jsonTree)
  {
    try
    {
      JsonReader jsonReader = new JsonTreeReader(jsonTree);
      jsonReader.setLenient(true);
      return read(jsonReader);
    } catch (IOException e) {
      throw new JsonIOException(e);
    }
  }
}
