package org.bukkit.craftbukkit.libs.com.google.gson.internal;

import java.math.BigInteger;



















public final class LazilyParsedNumber
  extends Number
{
  private final String value;
  
  public LazilyParsedNumber(String value)
  {
    this.value = value;
  }
  
  public int intValue()
  {
    try {
      return Integer.parseInt(value);
    } catch (NumberFormatException e) {
      try {
        return (int)Long.parseLong(value);
      } catch (NumberFormatException nfe) {} }
    return new BigInteger(value).intValue();
  }
  

  public long longValue()
  {
    try
    {
      return Long.parseLong(value);
    } catch (NumberFormatException e) {}
    return new BigInteger(value).longValue();
  }
  

  public float floatValue()
  {
    return Float.parseFloat(value);
  }
  
  public double doubleValue()
  {
    return Double.parseDouble(value);
  }
  
  public String toString()
  {
    return value;
  }
}
