package org.bukkit.craftbukkit.libs.jline;

import java.io.PrintStream;
import org.bukkit.craftbukkit.libs.jline.internal.Log;
import org.bukkit.craftbukkit.libs.jline.internal.TerminalLineSettings;





















public class UnixTerminal
  extends TerminalSupport
{
  private final TerminalLineSettings settings = new TerminalLineSettings();
  
  public UnixTerminal() throws Exception {
    super(true);
  }
  
  protected TerminalLineSettings getSettings() {
    return settings;
  }
  



  public void init()
    throws Exception
  {
    super.init();
    
    setAnsiSupported(true);
    

    settings.set("-icanon min 1");
    
    setEchoEnabled(false);
  }
  




  public void restore()
    throws Exception
  {
    settings.restore();
    super.restore();
    

    System.out.println();
  }
  



  public int getWidth()
  {
    int w = settings.getProperty("columns");
    return w < 1 ? 80 : w;
  }
  



  public int getHeight()
  {
    int h = settings.getProperty("rows");
    return h < 1 ? 24 : h;
  }
  
  public synchronized void setEchoEnabled(boolean enabled)
  {
    try {
      if (enabled) {
        settings.set("echo");
      }
      else {
        settings.set("-echo");
      }
      super.setEchoEnabled(enabled);
    }
    catch (Exception e) {
      Log.error(new Object[] { "Failed to ", enabled ? "enable" : "disable", " echo: ", e });
    }
  }
}
