package org.bukkit.craftbukkit.libs.jline.console;















public class CursorBuffer
{
  private boolean overTyping = false;
  
  public int cursor = 0;
  
  public final StringBuilder buffer = new StringBuilder();
  
  public boolean isOverTyping() {
    return overTyping;
  }
  
  public void setOverTyping(boolean b) {
    overTyping = b;
  }
  
  public int length() {
    return buffer.length();
  }
  
  public char nextChar() {
    if (cursor == buffer.length()) {
      return '\000';
    }
    return buffer.charAt(cursor);
  }
  
  public char current()
  {
    if (cursor <= 0) {
      return '\000';
    }
    
    return buffer.charAt(cursor - 1);
  }
  






  public void write(char c)
  {
    buffer.insert(cursor++, c);
    if ((isOverTyping()) && (cursor < buffer.length())) {
      buffer.deleteCharAt(cursor);
    }
  }
  


  public void write(CharSequence str)
  {
    assert (str != null);
    
    if (buffer.length() == 0) {
      buffer.append(str);
    }
    else {
      buffer.insert(cursor, str);
    }
    
    cursor += str.length();
    
    if ((isOverTyping()) && (cursor < buffer.length())) {
      buffer.delete(cursor, cursor + str.length());
    }
  }
  
  public boolean clear() {
    if (buffer.length() == 0) {
      return false;
    }
    
    buffer.delete(0, buffer.length());
    cursor = 0;
    return true;
  }
  
  public String toString()
  {
    return buffer.toString();
  }
}
