package org.bukkit.craftbukkit.libs.jline.console.completer;

import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import java.util.SortedSet;
import java.util.TreeSet;


























public class StringsCompleter
  implements Completer
{
  private final SortedSet<String> strings = new TreeSet();
  

  public StringsCompleter() {}
  
  public StringsCompleter(Collection<String> strings)
  {
    assert (strings != null);
    getStrings().addAll(strings);
  }
  
  public StringsCompleter(String... strings) {
    this(Arrays.asList(strings));
  }
  
  public Collection<String> getStrings() {
    return strings;
  }
  
  public int complete(String buffer, int cursor, List<CharSequence> candidates)
  {
    assert (candidates != null);
    
    if (buffer == null) {
      candidates.addAll(strings);
    }
    else {
      for (String match : strings.tailSet(buffer)) {
        if (!match.startsWith(buffer)) {
          break;
        }
        
        candidates.add(match);
      }
    }
    
    if (candidates.size() == 1) {
      candidates.set(0, candidates.get(0) + " ");
    }
    
    return candidates.isEmpty() ? -1 : 0;
  }
}
