package org.bukkit.craftbukkit.libs.jline.internal;

import java.io.PrintStream;




























public final class Log
{
  public static enum Level
  {
    TRACE, 
    DEBUG, 
    INFO, 
    WARN, 
    ERROR;
    
    private Level() {} }
  
  public static final boolean DEBUG = Boolean.getBoolean(Log.class.getName() + ".debug");
  

  public static final boolean TRACE = Boolean.getBoolean(Log.class.getName() + ".trace");
  
  private static PrintStream output = System.err;
  
  public static PrintStream getOutput() {
    return output;
  }
  
  public static void setOutput(PrintStream out) {
    assert (out != null);
    output = out;
  }
  
  private static void print(Object message) {
    if ((message instanceof Throwable)) {
      ((Throwable)message).printStackTrace(output);
    }
    else if (message.getClass().isArray()) {
      Object[] array = (Object[])message;
      
      for (int i = 0; i < array.length; i++) {
        output.print(array[i]);
        if (i + 1 < array.length) {
          output.print(",");
        }
      }
    }
    else {
      output.print(message);
    }
  }
  
  private static void log(Level level, Object[] messages)
  {
    synchronized (output) {
      output.format("[%s] ", new Object[] { level });
      
      for (Object message : messages) {
        print(message);
      }
      
      output.println();
      output.flush();
    }
  }
  
  public static void trace(Object... messages) {
    if (TRACE) {
      log(Level.TRACE, messages);
    }
  }
  
  public static void debug(Object... messages) {
    if ((TRACE) || (DEBUG)) {
      log(Level.DEBUG, messages);
    }
  }
  
  public static void warn(Object... messages) {
    log(Level.WARN, messages);
  }
  
  public static void error(Object... messages) {
    log(Level.ERROR, messages);
  }
}
