package org.bukkit.craftbukkit.v1_7_R1;

import com.google.common.base.CaseFormat;
import com.google.common.collect.BiMap;
import com.google.common.collect.ImmutableBiMap;
import com.google.common.collect.ImmutableBiMap.Builder;
import com.google.common.collect.ImmutableMap;
import com.google.common.collect.ImmutableMap.Builder;
import net.minecraft.server.v1_7_R1.EntityTypes;
import net.minecraft.server.v1_7_R1.MonsterEggInfo;
import net.minecraft.server.v1_7_R1.StatisticList;
import org.bukkit.Material;
import org.bukkit.entity.EntityType;

public class CraftStatistic
{
  private static final BiMap<String, org.bukkit.Statistic> statistics;
  private static final BiMap<String, org.bukkit.Achievement> achievements;
  
  static
  {
    ImmutableMap<String, org.bukkit.Achievement> specialCases = ImmutableMap.builder().put("achievement.buildWorkBench", org.bukkit.Achievement.BUILD_WORKBENCH).put("achievement.diamonds", org.bukkit.Achievement.GET_DIAMONDS).put("achievement.portal", org.bukkit.Achievement.NETHER_PORTAL).put("achievement.ghast", org.bukkit.Achievement.GHAST_RETURN).put("achievement.theEnd", org.bukkit.Achievement.END_PORTAL).put("achievement.theEnd2", org.bukkit.Achievement.THE_END).put("achievement.blazeRod", org.bukkit.Achievement.GET_BLAZE_ROD).put("achievement.potion", org.bukkit.Achievement.BREW_POTION).build();
    








    ImmutableBiMap.Builder<String, org.bukkit.Statistic> statisticBuilder = ImmutableBiMap.builder();
    ImmutableBiMap.Builder<String, org.bukkit.Achievement> achievementBuilder = ImmutableBiMap.builder();
    for (org.bukkit.Statistic statistic : org.bukkit.Statistic.values()) {
      if (statistic == org.bukkit.Statistic.PLAY_ONE_TICK) {
        statisticBuilder.put("stat.playOneMinute", statistic);
      } else {
        statisticBuilder.put("stat." + CaseFormat.UPPER_UNDERSCORE.to(CaseFormat.LOWER_CAMEL, statistic.name()), statistic);
      }
    }
    for (org.bukkit.Achievement achievement : org.bukkit.Achievement.values()) {
      if (!specialCases.values().contains(achievement))
      {

        achievementBuilder.put("achievement." + CaseFormat.UPPER_UNDERSCORE.to(CaseFormat.LOWER_CAMEL, achievement.name()), achievement);
      }
    }
    achievementBuilder.putAll(specialCases);
    
    statistics = statisticBuilder.build();
    achievements = achievementBuilder.build();
  }
  

  public static org.bukkit.Achievement getBukkitAchievement(net.minecraft.server.v1_7_R1.Achievement achievement)
  {
    return getBukkitAchievementByName(e);
  }
  
  public static org.bukkit.Achievement getBukkitAchievementByName(String name) {
    return (org.bukkit.Achievement)achievements.get(name);
  }
  
  public static org.bukkit.Statistic getBukkitStatistic(net.minecraft.server.v1_7_R1.Statistic statistic) {
    return getBukkitStatisticByName(e);
  }
  
  public static org.bukkit.Statistic getBukkitStatisticByName(String name) {
    if (name.startsWith("stat.killEntity")) {
      name = "stat.killEntity";
    }
    if (name.startsWith("stat.entityKilledBy")) {
      name = "stat.entityKilledBy";
    }
    if (name.startsWith("stat.breakItem")) {
      name = "stat.breakItem";
    }
    if (name.startsWith("stat.useItem")) {
      name = "stat.useItem";
    }
    if (name.startsWith("stat.mineBlock")) {
      name = "stat.mineBlock";
    }
    if (name.startsWith("stat.craftItem")) {
      name = "stat.craftItem";
    }
    return (org.bukkit.Statistic)statistics.get(name);
  }
  
  public static net.minecraft.server.v1_7_R1.Statistic getNMSStatistic(org.bukkit.Statistic statistic) {
    return StatisticList.a((String)statistics.inverse().get(statistic));
  }
  
  public static net.minecraft.server.v1_7_R1.Achievement getNMSAchievement(org.bukkit.Achievement achievement) {
    return (net.minecraft.server.v1_7_R1.Achievement)StatisticList.a((String)achievements.inverse().get(achievement));
  }
  
  public static net.minecraft.server.v1_7_R1.Statistic getMaterialStatistic(org.bukkit.Statistic stat, Material material) {
    try {
      if (stat == org.bukkit.Statistic.MINE_BLOCK) {
        return StatisticList.C[material.getId()];
      }
      if (stat == org.bukkit.Statistic.CRAFT_ITEM) {
        return StatisticList.D[material.getId()];
      }
      if (stat == org.bukkit.Statistic.USE_ITEM) {
        return StatisticList.E[material.getId()];
      }
      if (stat == org.bukkit.Statistic.BREAK_ITEM) {
        return StatisticList.F[material.getId()];
      }
    } catch (ArrayIndexOutOfBoundsException e) {
      return null;
    }
    return null;
  }
  
  public static net.minecraft.server.v1_7_R1.Statistic getEntityStatistic(org.bukkit.Statistic stat, EntityType entity) {
    MonsterEggInfo monsteregginfo = (MonsterEggInfo)EntityTypes.a.get(Integer.valueOf(entity.getTypeId()));
    
    if (monsteregginfo != null) {
      return d;
    }
    return null;
  }
  
  public static EntityType getEntityTypeFromStatistic(net.minecraft.server.v1_7_R1.Statistic statistic) {
    String statisticString = e;
    return EntityType.fromName(statisticString.substring(statisticString.lastIndexOf(".") + 1));
  }
  
  public static Material getMaterialFromStatistic(net.minecraft.server.v1_7_R1.Statistic statistic) {
    String statisticString = statistic.e;
    int id;
    try {
      id = Integer.valueOf(statisticString.substring(statisticString.lastIndexOf(".") + 1)).intValue();
    } catch (NumberFormatException e) {
      return null;
    }
    return Material.getMaterial(id);
  }
}
