package org.bukkit.craftbukkit.v1_7_R1;

import net.minecraft.server.v1_7_R1.ChunkCoordinates;
import net.minecraft.server.v1_7_R1.ChunkProviderServer;
import net.minecraft.server.v1_7_R1.PortalTravelAgent;
import net.minecraft.server.v1_7_R1.WorldServer;
import org.bukkit.Location;
import org.bukkit.TravelAgent;

public class CraftTravelAgent extends PortalTravelAgent implements TravelAgent
{
  public static TravelAgent DEFAULT = null;
  
  private int searchRadius = 128;
  private int creationRadius = 16;
  private boolean canCreatePortal = true;
  
  public CraftTravelAgent(WorldServer worldserver) {
    super(worldserver);
    if ((DEFAULT == null) && (dimension == 0)) {
      DEFAULT = this;
    }
  }
  
  public Location findOrCreate(Location target) {
    WorldServer worldServer = ((CraftWorld)target.getWorld()).getHandle();
    boolean before = chunkProviderServer.forceChunkLoad;
    chunkProviderServer.forceChunkLoad = true;
    
    Location found = findPortal(target);
    if (found == null) {
      if ((getCanCreatePortal()) && (createPortal(target))) {
        found = findPortal(target);
      } else {
        found = target;
      }
    }
    
    chunkProviderServer.forceChunkLoad = before;
    return found;
  }
  
  public Location findPortal(Location location) {
    PortalTravelAgent pta = ((CraftWorld)location.getWorld()).getHandle().t();
    ChunkCoordinates found = pta.findPortal(location.getX(), location.getY(), location.getZ(), getSearchRadius());
    return found != null ? new Location(location.getWorld(), x, y, z, location.getYaw(), location.getPitch()) : null;
  }
  
  public boolean createPortal(Location location) {
    PortalTravelAgent pta = ((CraftWorld)location.getWorld()).getHandle().t();
    return pta.createPortal(location.getX(), location.getY(), location.getZ(), getCreationRadius());
  }
  
  public TravelAgent setSearchRadius(int radius) {
    searchRadius = radius;
    return this;
  }
  
  public int getSearchRadius() {
    return searchRadius;
  }
  
  public TravelAgent setCreationRadius(int radius) {
    creationRadius = (radius < 2 ? 0 : radius);
    return this;
  }
  
  public int getCreationRadius() {
    return creationRadius;
  }
  
  public boolean getCanCreatePortal() {
    return canCreatePortal;
  }
  
  public void setCanCreatePortal(boolean create) {
    canCreatePortal = create;
  }
}
