package org.bukkit.craftbukkit.v1_7_R1;

import java.io.ByteArrayOutputStream;
import org.apache.logging.log4j.Level;
import org.apache.logging.log4j.Logger;

public class LoggerOutputStream extends ByteArrayOutputStream
{
  private final String separator = System.getProperty("line.separator");
  private final Logger logger;
  private final Level level;
  
  public LoggerOutputStream(Logger logger, Level level)
  {
    this.logger = logger;
    this.level = level;
  }
  
  public void flush() throws java.io.IOException
  {
    synchronized (this) {
      super.flush();
      String record = toString();
      super.reset();
      
      if ((record.length() > 0) && (!record.equals(separator))) {
        logger.log(level, record);
      }
    }
  }
}
