package org.bukkit.craftbukkit.v1_7_R1.block;

import net.minecraft.server.v1_7_R1.TileEntityBeacon;
import org.bukkit.block.Block;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftInventoryBeacon;
import org.bukkit.inventory.Inventory;

public class CraftBeacon extends CraftBlockState implements org.bukkit.block.Beacon
{
  private final CraftWorld world;
  private final TileEntityBeacon beacon;
  
  public CraftBeacon(Block block)
  {
    super(block);
    
    world = ((CraftWorld)block.getWorld());
    beacon = ((TileEntityBeacon)world.getTileEntityAt(getX(), getY(), getZ()));
  }
  
  public Inventory getInventory() {
    return new CraftInventoryBeacon(beacon);
  }
  
  public boolean update(boolean force, boolean applyPhysics)
  {
    boolean result = super.update(force, applyPhysics);
    
    if (result) {
      beacon.update();
    }
    
    return result;
  }
}
