package org.bukkit.craftbukkit.v1_7_R1.block;

import net.minecraft.server.v1_7_R1.TileEntityBrewingStand;
import org.bukkit.block.Block;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.inventory.BrewerInventory;

public class CraftBrewingStand extends CraftBlockState implements org.bukkit.block.BrewingStand
{
  private final TileEntityBrewingStand brewingStand;
  
  public CraftBrewingStand(Block block)
  {
    super(block);
    
    brewingStand = ((TileEntityBrewingStand)((CraftWorld)block.getWorld()).getTileEntityAt(getX(), getY(), getZ()));
  }
  
  public BrewerInventory getInventory() {
    return new org.bukkit.craftbukkit.v1_7_R1.inventory.CraftInventoryBrewer(brewingStand);
  }
  
  public boolean update(boolean force, boolean applyPhysics)
  {
    boolean result = super.update(force, applyPhysics);
    
    if (result) {
      brewingStand.update();
    }
    
    return result;
  }
  
  public int getBrewingTime() {
    return brewingStand.brewTime;
  }
  
  public void setBrewingTime(int brewTime) {
    brewingStand.brewTime = brewTime;
  }
}
