package org.bukkit.craftbukkit.v1_7_R1.block;

import net.minecraft.server.v1_7_R1.TileEntityChest;
import net.minecraft.server.v1_7_R1.WorldServer;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftInventory;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftInventoryDoubleChest;

public class CraftChest extends CraftBlockState implements org.bukkit.block.Chest
{
  private final CraftWorld world;
  private final TileEntityChest chest;
  
  public CraftChest(Block block)
  {
    super(block);
    
    world = ((CraftWorld)block.getWorld());
    chest = ((TileEntityChest)world.getTileEntityAt(getX(), getY(), getZ()));
  }
  
  public org.bukkit.inventory.Inventory getBlockInventory() {
    return new CraftInventory(chest);
  }
  
  public org.bukkit.inventory.Inventory getInventory() {
    int x = getX();
    int y = getY();
    int z = getZ();
    
    CraftInventory inventory = new CraftInventory(chest);
    int id;
    if (world.getBlockTypeIdAt(x, y, z) == Material.CHEST.getId()) {
      id = Material.CHEST.getId(); } else { int id;
      if (world.getBlockTypeIdAt(x, y, z) == Material.TRAPPED_CHEST.getId()) {
        id = Material.TRAPPED_CHEST.getId();
      } else
        throw new IllegalStateException("CraftChest is not a chest but is instead " + world.getBlockAt(x, y, z));
    }
    int id;
    if (world.getBlockTypeIdAt(x - 1, y, z) == id) {
      CraftInventory left = new CraftInventory((TileEntityChest)world.getHandle().getTileEntity(x - 1, y, z));
      inventory = new CraftInventoryDoubleChest(left, inventory);
    }
    if (world.getBlockTypeIdAt(x + 1, y, z) == id) {
      CraftInventory right = new CraftInventory((TileEntityChest)world.getHandle().getTileEntity(x + 1, y, z));
      inventory = new CraftInventoryDoubleChest(inventory, right);
    }
    if (world.getBlockTypeIdAt(x, y, z - 1) == id) {
      CraftInventory left = new CraftInventory((TileEntityChest)world.getHandle().getTileEntity(x, y, z - 1));
      inventory = new CraftInventoryDoubleChest(left, inventory);
    }
    if (world.getBlockTypeIdAt(x, y, z + 1) == id) {
      CraftInventory right = new CraftInventory((TileEntityChest)world.getHandle().getTileEntity(x, y, z + 1));
      inventory = new CraftInventoryDoubleChest(inventory, right);
    }
    return inventory;
  }
  
  public boolean update(boolean force, boolean applyPhysics)
  {
    boolean result = super.update(force, applyPhysics);
    
    if (result) {
      chest.update();
    }
    
    return result;
  }
}
