package org.bukkit.craftbukkit.v1_7_R1.block;

import net.minecraft.server.v1_7_R1.MobSpawnerAbstract;
import net.minecraft.server.v1_7_R1.TileEntityMobSpawner;
import org.bukkit.block.Block;
import org.bukkit.entity.CreatureType;
import org.bukkit.entity.EntityType;

public class CraftCreatureSpawner extends CraftBlockState implements org.bukkit.block.CreatureSpawner
{
  private final TileEntityMobSpawner spawner;
  
  public CraftCreatureSpawner(Block block)
  {
    super(block);
    
    spawner = ((TileEntityMobSpawner)((org.bukkit.craftbukkit.v1_7_R1.CraftWorld)block.getWorld()).getTileEntityAt(getX(), getY(), getZ()));
  }
  
  @Deprecated
  public CreatureType getCreatureType() {
    return CreatureType.fromName(spawner.a().getMobName());
  }
  
  public EntityType getSpawnedType() {
    return EntityType.fromName(spawner.a().getMobName());
  }
  
  @Deprecated
  public void setCreatureType(CreatureType creatureType) {
    spawner.a().a(creatureType.getName());
  }
  
  public void setSpawnedType(EntityType entityType) {
    if ((entityType == null) || (entityType.getName() == null)) {
      throw new IllegalArgumentException("Can't spawn EntityType " + entityType + " from mobspawners!");
    }
    
    spawner.a().a(entityType.getName());
  }
  
  @Deprecated
  public String getCreatureTypeId() {
    return spawner.a().getMobName();
  }
  
  @Deprecated
  public void setCreatureTypeId(String creatureName) {
    setCreatureTypeByName(creatureName);
  }
  
  public String getCreatureTypeName() {
    return spawner.a().getMobName();
  }
  
  public void setCreatureTypeByName(String creatureType)
  {
    EntityType type = EntityType.fromName(creatureType);
    if (type == null) {
      return;
    }
    setSpawnedType(type);
  }
  
  public int getDelay() {
    return spawner.a().spawnDelay;
  }
  
  public void setDelay(int delay) {
    spawner.a().spawnDelay = delay;
  }
}
