package org.bukkit.craftbukkit.v1_7_R1.block;

import net.minecraft.server.v1_7_R1.BlockDispenser;
import net.minecraft.server.v1_7_R1.TileEntityDispenser;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.Dispenser;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftInventory;
import org.bukkit.craftbukkit.v1_7_R1.projectiles.CraftBlockProjectileSource;
import org.bukkit.inventory.Inventory;
import org.bukkit.projectiles.BlockProjectileSource;

public class CraftDispenser extends CraftBlockState implements Dispenser
{
  private final CraftWorld world;
  private final TileEntityDispenser dispenser;
  
  public CraftDispenser(Block block)
  {
    super(block);
    
    world = ((CraftWorld)block.getWorld());
    dispenser = ((TileEntityDispenser)world.getTileEntityAt(getX(), getY(), getZ()));
  }
  
  public Inventory getInventory() {
    return new CraftInventory(dispenser);
  }
  
  public BlockProjectileSource getBlockProjectileSource() {
    Block block = getBlock();
    
    if (block.getType() != Material.DISPENSER) {
      return null;
    }
    
    return new CraftBlockProjectileSource(dispenser);
  }
  
  public boolean dispense() {
    Block block = getBlock();
    
    if (block.getType() == Material.DISPENSER) {
      BlockDispenser dispense = (BlockDispenser)net.minecraft.server.v1_7_R1.Blocks.DISPENSER;
      
      dispense.dispense(world.getHandle(), getX(), getY(), getZ());
      return true;
    }
    return false;
  }
  

  public boolean update(boolean force, boolean applyPhysics)
  {
    boolean result = super.update(force, applyPhysics);
    
    if (result) {
      dispenser.update();
    }
    
    return result;
  }
}
