package org.bukkit.craftbukkit.v1_7_R1.block;

import net.minecraft.server.v1_7_R1.BlockDropper;
import net.minecraft.server.v1_7_R1.TileEntityDropper;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.Dropper;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftInventory;
import org.bukkit.inventory.Inventory;

public class CraftDropper extends CraftBlockState implements Dropper
{
  private final CraftWorld world;
  private final TileEntityDropper dropper;
  
  public CraftDropper(Block block)
  {
    super(block);
    
    world = ((CraftWorld)block.getWorld());
    dropper = ((TileEntityDropper)world.getTileEntityAt(getX(), getY(), getZ()));
  }
  
  public Inventory getInventory() {
    return new CraftInventory(dropper);
  }
  
  public void drop() {
    Block block = getBlock();
    
    if (block.getType() == Material.DROPPER) {
      BlockDropper drop = (BlockDropper)net.minecraft.server.v1_7_R1.Blocks.DROPPER;
      
      drop.dispense(world.getHandle(), getX(), getY(), getZ());
    }
  }
  
  public boolean update(boolean force, boolean applyPhysics)
  {
    boolean result = super.update(force, applyPhysics);
    
    if (result) {
      dropper.update();
    }
    
    return result;
  }
}
