package org.bukkit.craftbukkit.v1_7_R1.block;

import net.minecraft.server.v1_7_R1.TileEntityFurnace;
import org.bukkit.block.Block;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftInventoryFurnace;

public class CraftFurnace extends CraftBlockState implements org.bukkit.block.Furnace
{
  private final TileEntityFurnace furnace;
  
  public CraftFurnace(Block block)
  {
    super(block);
    
    furnace = ((TileEntityFurnace)((CraftWorld)block.getWorld()).getTileEntityAt(getX(), getY(), getZ()));
  }
  
  public org.bukkit.inventory.FurnaceInventory getInventory() {
    return new CraftInventoryFurnace(furnace);
  }
  
  public boolean update(boolean force, boolean applyPhysics)
  {
    boolean result = super.update(force, applyPhysics);
    
    if (result) {
      furnace.update();
    }
    
    return result;
  }
  
  public short getBurnTime() {
    return (short)furnace.burnTime;
  }
  
  public void setBurnTime(short burnTime) {
    furnace.burnTime = burnTime;
  }
  
  public short getCookTime() {
    return (short)furnace.cookTime;
  }
  
  public void setCookTime(short cookTime) {
    furnace.cookTime = cookTime;
  }
}
