package org.bukkit.craftbukkit.v1_7_R1.block;

import net.minecraft.server.v1_7_R1.BlockJukeBox;
import net.minecraft.server.v1_7_R1.ItemStack;
import net.minecraft.server.v1_7_R1.TileEntityRecordPlayer;
import net.minecraft.server.v1_7_R1.WorldServer;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_7_R1.util.CraftMagicNumbers;

public class CraftJukebox extends CraftBlockState implements org.bukkit.block.Jukebox
{
  private final CraftWorld world;
  private final TileEntityRecordPlayer jukebox;
  
  public CraftJukebox(Block block)
  {
    super(block);
    
    world = ((CraftWorld)block.getWorld());
    jukebox = ((TileEntityRecordPlayer)world.getTileEntityAt(getX(), getY(), getZ()));
  }
  
  public Material getPlaying()
  {
    ItemStack record = jukebox.getRecord();
    if (record == null) {
      return Material.AIR;
    }
    return CraftMagicNumbers.getMaterial(record.getItem());
  }
  
  public void setPlaying(Material record)
  {
    if ((record == null) || (CraftMagicNumbers.getItem(record) == null)) {
      record = Material.AIR;
      jukebox.setRecord(null);
    } else {
      jukebox.setRecord(new ItemStack(CraftMagicNumbers.getItem(record), 1));
    }
    jukebox.update();
    if (record == Material.AIR) {
      world.getHandle().setData(getX(), getY(), getZ(), 0, 3);
    } else {
      world.getHandle().setData(getX(), getY(), getZ(), 1, 3);
    }
    world.playEffect(getLocation(), org.bukkit.Effect.RECORD_PLAY, record.getId());
  }
  
  public boolean isPlaying() {
    return getRawData() == 1;
  }
  
  public boolean eject() {
    boolean result = isPlaying();
    ((BlockJukeBox)net.minecraft.server.v1_7_R1.Blocks.JUKEBOX).dropRecord(world.getHandle(), getX(), getY(), getZ());
    return result;
  }
}
