package org.bukkit.craftbukkit.v1_7_R1.block;

import net.minecraft.server.v1_7_R1.TileEntityNote;
import net.minecraft.server.v1_7_R1.WorldServer;
import org.bukkit.Instrument;
import org.bukkit.Material;
import org.bukkit.Note;
import org.bukkit.block.Block;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;

public class CraftNoteBlock extends CraftBlockState implements org.bukkit.block.NoteBlock
{
  private final CraftWorld world;
  private final TileEntityNote note;
  
  public CraftNoteBlock(Block block)
  {
    super(block);
    
    world = ((CraftWorld)block.getWorld());
    note = ((TileEntityNote)world.getTileEntityAt(getX(), getY(), getZ()));
  }
  
  public Note getNote() {
    return new Note(note.note);
  }
  
  public byte getRawNote() {
    return note.note;
  }
  
  public void setNote(Note n) {
    note.note = n.getId();
  }
  
  public void setRawNote(byte n) {
    note.note = n;
  }
  
  public boolean play() {
    Block block = getBlock();
    
    if (block.getType() == Material.NOTE_BLOCK) {
      note.play(world.getHandle(), getX(), getY(), getZ());
      return true;
    }
    return false;
  }
  

  public boolean play(byte instrument, byte note)
  {
    Block block = getBlock();
    
    if (block.getType() == Material.NOTE_BLOCK) {
      world.getHandle().playNote(getX(), getY(), getZ(), org.bukkit.craftbukkit.v1_7_R1.util.CraftMagicNumbers.getBlock(block), instrument, note);
      return true;
    }
    return false;
  }
  

  public boolean play(Instrument instrument, Note note)
  {
    Block block = getBlock();
    
    if (block.getType() == Material.NOTE_BLOCK) {
      world.getHandle().playNote(getX(), getY(), getZ(), org.bukkit.craftbukkit.v1_7_R1.util.CraftMagicNumbers.getBlock(block), instrument.getType(), note.getId());
      return true;
    }
    return false;
  }
}
