package org.bukkit.craftbukkit.v1_7_R1.chunkio;

import java.util.concurrent.atomic.AtomicInteger;
import net.minecraft.server.v1_7_R1.Chunk;
import net.minecraft.server.v1_7_R1.ChunkProviderServer;
import net.minecraft.server.v1_7_R1.ChunkRegionLoader;
import net.minecraft.server.v1_7_R1.NBTTagCompound;
import net.minecraft.server.v1_7_R1.WorldServer;
import org.bukkit.Server;
import org.bukkit.event.world.ChunkLoadEvent;

class ChunkIOProvider implements org.bukkit.craftbukkit.v1_7_R1.util.AsynchronousExecutor.CallBackProvider<QueuedChunk, Chunk, Runnable, RuntimeException>
{
  private final AtomicInteger threadNumber = new AtomicInteger(1);
  
  public Chunk callStage1(QueuedChunk queuedChunk) throws RuntimeException
  {
    ChunkRegionLoader loader = loader;
    Object[] data = loader.loadChunk(world, x, z);
    
    if (data != null) {
      compound = ((NBTTagCompound)data[1]);
      return (Chunk)data[0];
    }
    
    return null;
  }
  
  public void callStage2(QueuedChunk queuedChunk, Chunk chunk) throws RuntimeException
  {
    if (chunk == null)
    {
      provider.originalGetChunkAt(x, z);
      return;
    }
    
    loader.loadEntities(chunk, compound.getCompound("Level"), world);
    p = provider.world.getTime();
    provider.chunks.put(org.bukkit.craftbukkit.v1_7_R1.util.LongHash.toLong(x, z), chunk);
    chunk.addEntities();
    
    if (provider.chunkProvider != null) {
      provider.chunkProvider.recreateStructures(x, z);
    }
    
    Server server = provider.world.getServer();
    if (server != null) {
      server.getPluginManager().callEvent(new ChunkLoadEvent(bukkitChunk, false));
    }
    
    chunk.a(provider, provider, x, z);
  }
  
  public void callStage3(QueuedChunk queuedChunk, Chunk chunk, Runnable runnable) throws RuntimeException {
    runnable.run();
  }
  
  public Thread newThread(Runnable runnable) {
    Thread thread = new Thread(runnable, "Chunk I/O Executor Thread-" + threadNumber.getAndIncrement());
    thread.setDaemon(true);
    return thread;
  }
}
