package org.bukkit.craftbukkit.v1_7_R1.chunkio;

import net.minecraft.server.v1_7_R1.ChunkRegionLoader;
import net.minecraft.server.v1_7_R1.World;

class QueuedChunk
{
  final int x;
  final int z;
  final ChunkRegionLoader loader;
  final World world;
  final net.minecraft.server.v1_7_R1.ChunkProviderServer provider;
  net.minecraft.server.v1_7_R1.NBTTagCompound compound;
  
  public QueuedChunk(int x, int z, ChunkRegionLoader loader, World world, net.minecraft.server.v1_7_R1.ChunkProviderServer provider)
  {
    this.x = x;
    this.z = z;
    this.loader = loader;
    this.world = world;
    this.provider = provider;
  }
  
  public int hashCode()
  {
    return x * 31 + z * 29 ^ world.hashCode();
  }
  
  public boolean equals(Object object)
  {
    if ((object instanceof QueuedChunk)) {
      QueuedChunk other = (QueuedChunk)object;
      return (x == x) && (z == z) && (world == world);
    }
    
    return false;
  }
}
