package org.bukkit.craftbukkit.v1_7_R1.command;

import net.minecraft.server.v1_7_R1.ChunkCoordinates;
import net.minecraft.server.v1_7_R1.TileEntityCommandListener;
import net.minecraft.server.v1_7_R1.World;
import org.bukkit.block.Block;
import org.bukkit.command.BlockCommandSender;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;

public class CraftBlockCommandSender extends ServerCommandSender implements BlockCommandSender
{
  private final TileEntityCommandListener commandBlock;
  
  public CraftBlockCommandSender(TileEntityCommandListener commandBlockListenerAbstract)
  {
    commandBlock = commandBlockListenerAbstract;
  }
  
  public Block getBlock() {
    return commandBlock.getWorld().getWorld().getBlockAt(commandBlock.getChunkCoordinates().x, commandBlock.getChunkCoordinates().y, commandBlock.getChunkCoordinates().z);
  }
  

  public void sendMessage(String message) {}
  
  public void sendMessage(String[] messages) {}
  
  public String getName()
  {
    return commandBlock.getName();
  }
  
  public boolean isOp() {
    return true;
  }
  
  public void setOp(boolean value) {
    throw new UnsupportedOperationException("Cannot change operator status of a block");
  }
}
