package org.bukkit.craftbukkit.v1_7_R1.enchantments;

import org.bukkit.enchantments.EnchantmentTarget;
import org.bukkit.enchantments.EnchantmentWrapper;
import org.bukkit.inventory.ItemStack;

public class CraftEnchantment extends org.bukkit.enchantments.Enchantment
{
  private final net.minecraft.server.v1_7_R1.Enchantment target;
  
  public CraftEnchantment(net.minecraft.server.v1_7_R1.Enchantment target)
  {
    super(id);
    this.target = target;
  }
  
  public int getMaxLevel()
  {
    return target.getMaxLevel();
  }
  
  public int getStartLevel()
  {
    return target.getStartLevel();
  }
  
  public EnchantmentTarget getItemTarget()
  {
    switch (1.$SwitchMap$net$minecraft$server$EnchantmentSlotType[target.slot.ordinal()]) {
    case 1: 
      return EnchantmentTarget.ALL;
    case 2: 
      return EnchantmentTarget.ARMOR;
    case 3: 
      return EnchantmentTarget.ARMOR_FEET;
    case 4: 
      return EnchantmentTarget.ARMOR_HEAD;
    case 5: 
      return EnchantmentTarget.ARMOR_LEGS;
    case 6: 
      return EnchantmentTarget.ARMOR_TORSO;
    case 7: 
      return EnchantmentTarget.TOOL;
    case 8: 
      return EnchantmentTarget.WEAPON;
    case 9: 
      return EnchantmentTarget.BOW;
    case 10: 
      return EnchantmentTarget.FISHING_ROD;
    }
    return null;
  }
  

  public boolean canEnchantItem(ItemStack item)
  {
    return target.canEnchant(org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack.asNMSCopy(item));
  }
  
  public String getName()
  {
    switch (target.id) {
    case 0: 
      return "PROTECTION_ENVIRONMENTAL";
    case 1: 
      return "PROTECTION_FIRE";
    case 2: 
      return "PROTECTION_FALL";
    case 3: 
      return "PROTECTION_EXPLOSIONS";
    case 4: 
      return "PROTECTION_PROJECTILE";
    case 5: 
      return "OXYGEN";
    case 6: 
      return "WATER_WORKER";
    case 7: 
      return "THORNS";
    case 16: 
      return "DAMAGE_ALL";
    case 17: 
      return "DAMAGE_UNDEAD";
    case 18: 
      return "DAMAGE_ARTHROPODS";
    case 19: 
      return "KNOCKBACK";
    case 20: 
      return "FIRE_ASPECT";
    case 21: 
      return "LOOT_BONUS_MOBS";
    case 32: 
      return "DIG_SPEED";
    case 33: 
      return "SILK_TOUCH";
    case 34: 
      return "DURABILITY";
    case 35: 
      return "LOOT_BONUS_BLOCKS";
    case 48: 
      return "ARROW_DAMAGE";
    case 49: 
      return "ARROW_KNOCKBACK";
    case 50: 
      return "ARROW_FIRE";
    case 51: 
      return "ARROW_INFINITE";
    case 61: 
      return "LUCK";
    case 62: 
      return "LURE";
    }
    return "UNKNOWN_ENCHANT_" + target.id;
  }
  
  public static net.minecraft.server.v1_7_R1.Enchantment getRaw(org.bukkit.enchantments.Enchantment enchantment)
  {
    if ((enchantment instanceof EnchantmentWrapper)) {
      enchantment = ((EnchantmentWrapper)enchantment).getEnchantment();
    }
    
    if ((enchantment instanceof CraftEnchantment)) {
      return target;
    }
    
    return null;
  }
  
  public boolean conflictsWith(org.bukkit.enchantments.Enchantment other)
  {
    if ((other instanceof EnchantmentWrapper)) {
      other = ((EnchantmentWrapper)other).getEnchantment();
    }
    if (!(other instanceof CraftEnchantment)) {
      return false;
    }
    CraftEnchantment ench = (CraftEnchantment)other;
    return !target.a(target);
  }
}
