package org.bukkit.craftbukkit.v1_7_R1.entity;

import net.minecraft.server.v1_7_R1.EntityArrow;
import org.apache.commons.lang.Validate;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.entity.Arrow;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.LivingEntity;
import org.bukkit.projectiles.ProjectileSource;

public class CraftArrow extends AbstractProjectile implements Arrow
{
  public CraftArrow(CraftServer server, EntityArrow entity)
  {
    super(server, entity);
  }
  
  public void setKnockbackStrength(int knockbackStrength) {
    Validate.isTrue(knockbackStrength >= 0, "Knockback cannot be negative");
    getHandle().a(knockbackStrength);
  }
  
  public int getKnockbackStrength() {
    return getHandle()aw;
  }
  
  public boolean isCritical() {
    return getHandle().f();
  }
  
  public void setCritical(boolean critical) {
    getHandle().a(critical);
  }
  
  public ProjectileSource getShooter() {
    return getHandle()projectileSource;
  }
  
  public void setShooter(ProjectileSource shooter) {
    if ((shooter instanceof LivingEntity)) {
      getHandle()shooter = ((CraftLivingEntity)shooter).getHandle();
    } else {
      getHandle()shooter = null;
    }
    getHandle()projectileSource = shooter;
  }
  
  public EntityArrow getHandle()
  {
    return (EntityArrow)entity;
  }
  
  public String toString()
  {
    return "CraftArrow";
  }
  
  public EntityType getType() {
    return EntityType.ARROW;
  }
}
