package org.bukkit.craftbukkit.v1_7_R1.entity;

import net.minecraft.server.v1_7_R1.EntityEnderman;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.util.CraftMagicNumbers;
import org.bukkit.entity.EntityType;
import org.bukkit.material.MaterialData;

public class CraftEnderman extends CraftMonster implements org.bukkit.entity.Enderman
{
  public CraftEnderman(CraftServer server, EntityEnderman entity)
  {
    super(server, entity);
  }
  
  public MaterialData getCarriedMaterial() {
    return CraftMagicNumbers.getMaterial(getHandle().getCarried()).getNewData((byte)getHandle().getCarriedData());
  }
  
  public void setCarriedMaterial(MaterialData data) {
    getHandle().setCarried(CraftMagicNumbers.getBlock(data.getItemTypeId()));
    getHandle().setCarriedData(data.getData());
  }
  
  public EntityEnderman getHandle()
  {
    return (EntityEnderman)entity;
  }
  
  public String toString()
  {
    return "CraftEnderman";
  }
  
  public EntityType getType() {
    return EntityType.ENDERMAN;
  }
}
