package org.bukkit.craftbukkit.v1_7_R1.entity;

import java.util.List;
import net.minecraft.server.v1_7_R1.EntityArrow;
import net.minecraft.server.v1_7_R1.EntityComplexPart;
import net.minecraft.server.v1_7_R1.EntityEnderDragon;
import net.minecraft.server.v1_7_R1.EntityFireball;
import net.minecraft.server.v1_7_R1.EntityHorse;
import org.bukkit.EntityEffect;
import org.bukkit.Location;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.metadata.EntityMetadataStore;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.player.PlayerTeleportEvent.TeleportCause;
import org.bukkit.metadata.MetadataValue;
import org.bukkit.util.Vector;

public abstract class CraftEntity implements org.bukkit.entity.Entity
{
  protected final CraftServer server;
  protected net.minecraft.server.v1_7_R1.Entity entity;
  private EntityDamageEvent lastDamageEvent;
  
  public CraftEntity(CraftServer server, net.minecraft.server.v1_7_R1.Entity entity)
  {
    this.server = server;
    this.entity = entity;
  }
  


  public static CraftEntity getEntity(CraftServer server, net.minecraft.server.v1_7_R1.Entity entity)
  {
    if ((entity instanceof net.minecraft.server.v1_7_R1.EntityLiving))
    {
      if ((entity instanceof net.minecraft.server.v1_7_R1.EntityHuman)) {
        if ((entity instanceof net.minecraft.server.v1_7_R1.EntityPlayer)) return new CraftPlayer(server, (net.minecraft.server.v1_7_R1.EntityPlayer)entity);
        return new CraftHumanEntity(server, (net.minecraft.server.v1_7_R1.EntityHuman)entity);
      }
      if ((entity instanceof net.minecraft.server.v1_7_R1.EntityCreature))
      {
        if ((entity instanceof net.minecraft.server.v1_7_R1.EntityAnimal)) {
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityChicken)) return new CraftChicken(server, (net.minecraft.server.v1_7_R1.EntityChicken)entity);
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityCow)) {
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntityMushroomCow)) return new CraftMushroomCow(server, (net.minecraft.server.v1_7_R1.EntityMushroomCow)entity);
            return new CraftCow(server, (net.minecraft.server.v1_7_R1.EntityCow)entity);
          }
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityPig)) return new CraftPig(server, (net.minecraft.server.v1_7_R1.EntityPig)entity);
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityTameableAnimal)) {
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntityWolf)) return new CraftWolf(server, (net.minecraft.server.v1_7_R1.EntityWolf)entity);
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntityOcelot)) return new CraftOcelot(server, (net.minecraft.server.v1_7_R1.EntityOcelot)entity);
          } else {
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntitySheep)) return new CraftSheep(server, (net.minecraft.server.v1_7_R1.EntitySheep)entity);
            if ((entity instanceof EntityHorse)) return new CraftHorse(server, (EntityHorse)entity);
            return new CraftAnimals(server, (net.minecraft.server.v1_7_R1.EntityAnimal)entity);
          }
        } else {
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityMonster)) {
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntityZombie)) {
              if ((entity instanceof net.minecraft.server.v1_7_R1.EntityPigZombie)) return new CraftPigZombie(server, (net.minecraft.server.v1_7_R1.EntityPigZombie)entity);
              return new CraftZombie(server, (net.minecraft.server.v1_7_R1.EntityZombie)entity);
            }
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntityCreeper)) return new CraftCreeper(server, (net.minecraft.server.v1_7_R1.EntityCreeper)entity);
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntityEnderman)) return new CraftEnderman(server, (net.minecraft.server.v1_7_R1.EntityEnderman)entity);
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntitySilverfish)) return new CraftSilverfish(server, (net.minecraft.server.v1_7_R1.EntitySilverfish)entity);
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntityGiantZombie)) return new CraftGiant(server, (net.minecraft.server.v1_7_R1.EntityGiantZombie)entity);
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntitySkeleton)) return new CraftSkeleton(server, (net.minecraft.server.v1_7_R1.EntitySkeleton)entity);
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntityBlaze)) return new CraftBlaze(server, (net.minecraft.server.v1_7_R1.EntityBlaze)entity);
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntityWitch)) return new CraftWitch(server, (net.minecraft.server.v1_7_R1.EntityWitch)entity);
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntityWither)) return new CraftWither(server, (net.minecraft.server.v1_7_R1.EntityWither)entity);
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntitySpider)) {
              if ((entity instanceof net.minecraft.server.v1_7_R1.EntityCaveSpider)) return new CraftCaveSpider(server, (net.minecraft.server.v1_7_R1.EntityCaveSpider)entity);
              return new CraftSpider(server, (net.minecraft.server.v1_7_R1.EntitySpider)entity);
            }
            
            return new CraftMonster(server, (net.minecraft.server.v1_7_R1.EntityMonster)entity);
          }
          
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityWaterAnimal)) {
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntitySquid)) return new CraftSquid(server, (net.minecraft.server.v1_7_R1.EntitySquid)entity);
            return new CraftWaterMob(server, (net.minecraft.server.v1_7_R1.EntityWaterAnimal)entity);
          }
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityGolem)) {
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntitySnowman)) return new CraftSnowman(server, (net.minecraft.server.v1_7_R1.EntitySnowman)entity);
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntityIronGolem)) return new CraftIronGolem(server, (net.minecraft.server.v1_7_R1.EntityIronGolem)entity);
          } else {
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntityVillager)) return new CraftVillager(server, (net.minecraft.server.v1_7_R1.EntityVillager)entity);
            return new CraftCreature(server, (net.minecraft.server.v1_7_R1.EntityCreature)entity);
          }
        }
      } else { if ((entity instanceof net.minecraft.server.v1_7_R1.EntitySlime)) {
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityMagmaCube)) return new CraftMagmaCube(server, (net.minecraft.server.v1_7_R1.EntityMagmaCube)entity);
          return new CraftSlime(server, (net.minecraft.server.v1_7_R1.EntitySlime)entity);
        }
        
        if ((entity instanceof net.minecraft.server.v1_7_R1.EntityFlying)) {
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityGhast)) return new CraftGhast(server, (net.minecraft.server.v1_7_R1.EntityGhast)entity);
          return new CraftFlying(server, (net.minecraft.server.v1_7_R1.EntityFlying)entity);
        }
        if ((entity instanceof EntityEnderDragon)) {
          return new CraftEnderDragon(server, (EntityEnderDragon)entity);
        }
        
        if ((entity instanceof net.minecraft.server.v1_7_R1.EntityAmbient)) {
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityBat)) return new CraftBat(server, (net.minecraft.server.v1_7_R1.EntityBat)entity);
          return new CraftAmbient(server, (net.minecraft.server.v1_7_R1.EntityAmbient)entity);
        }
        return new CraftLivingEntity(server, (net.minecraft.server.v1_7_R1.EntityLiving)entity);
      }
    } else { if ((entity instanceof EntityComplexPart)) {
        EntityComplexPart part = (EntityComplexPart)entity;
        if ((owner instanceof EntityEnderDragon)) return new CraftEnderDragonPart(server, (EntityComplexPart)entity);
        return new CraftComplexPart(server, (EntityComplexPart)entity);
      }
      if ((entity instanceof net.minecraft.server.v1_7_R1.EntityExperienceOrb)) return new CraftExperienceOrb(server, (net.minecraft.server.v1_7_R1.EntityExperienceOrb)entity);
      if ((entity instanceof EntityArrow)) return new CraftArrow(server, (EntityArrow)entity);
      if ((entity instanceof net.minecraft.server.v1_7_R1.EntityBoat)) return new CraftBoat(server, (net.minecraft.server.v1_7_R1.EntityBoat)entity);
      if ((entity instanceof net.minecraft.server.v1_7_R1.EntityProjectile)) {
        if ((entity instanceof net.minecraft.server.v1_7_R1.EntityEgg)) return new CraftEgg(server, (net.minecraft.server.v1_7_R1.EntityEgg)entity);
        if ((entity instanceof net.minecraft.server.v1_7_R1.EntitySnowball)) return new CraftSnowball(server, (net.minecraft.server.v1_7_R1.EntitySnowball)entity);
        if ((entity instanceof net.minecraft.server.v1_7_R1.EntityPotion)) return new CraftThrownPotion(server, (net.minecraft.server.v1_7_R1.EntityPotion)entity);
        if ((entity instanceof net.minecraft.server.v1_7_R1.EntityEnderPearl)) return new CraftEnderPearl(server, (net.minecraft.server.v1_7_R1.EntityEnderPearl)entity);
        if ((entity instanceof net.minecraft.server.v1_7_R1.EntityThrownExpBottle)) return new CraftThrownExpBottle(server, (net.minecraft.server.v1_7_R1.EntityThrownExpBottle)entity);
      } else {
        if ((entity instanceof net.minecraft.server.v1_7_R1.EntityFallingBlock)) return new CraftFallingSand(server, (net.minecraft.server.v1_7_R1.EntityFallingBlock)entity);
        if ((entity instanceof EntityFireball)) {
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntitySmallFireball)) return new CraftSmallFireball(server, (net.minecraft.server.v1_7_R1.EntitySmallFireball)entity);
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityLargeFireball)) return new CraftLargeFireball(server, (net.minecraft.server.v1_7_R1.EntityLargeFireball)entity);
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityWitherSkull)) return new CraftWitherSkull(server, (net.minecraft.server.v1_7_R1.EntityWitherSkull)entity);
          return new CraftFireball(server, (EntityFireball)entity);
        }
        if ((entity instanceof net.minecraft.server.v1_7_R1.EntityEnderSignal)) return new CraftEnderSignal(server, (net.minecraft.server.v1_7_R1.EntityEnderSignal)entity);
        if ((entity instanceof net.minecraft.server.v1_7_R1.EntityEnderCrystal)) return new CraftEnderCrystal(server, (net.minecraft.server.v1_7_R1.EntityEnderCrystal)entity);
        if ((entity instanceof net.minecraft.server.v1_7_R1.EntityFishingHook)) return new CraftFish(server, (net.minecraft.server.v1_7_R1.EntityFishingHook)entity);
        if ((entity instanceof net.minecraft.server.v1_7_R1.EntityItem)) return new CraftItem(server, (net.minecraft.server.v1_7_R1.EntityItem)entity);
        if ((entity instanceof net.minecraft.server.v1_7_R1.EntityWeather)) {
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityLightning)) return new CraftLightningStrike(server, (net.minecraft.server.v1_7_R1.EntityLightning)entity);
          return new CraftWeather(server, (net.minecraft.server.v1_7_R1.EntityWeather)entity);
        }
        if ((entity instanceof net.minecraft.server.v1_7_R1.EntityMinecartAbstract)) {
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityMinecartFurnace)) return new CraftMinecartFurnace(server, (net.minecraft.server.v1_7_R1.EntityMinecartFurnace)entity);
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityMinecartChest)) return new CraftMinecartChest(server, (net.minecraft.server.v1_7_R1.EntityMinecartChest)entity);
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityMinecartTNT)) return new CraftMinecartTNT(server, (net.minecraft.server.v1_7_R1.EntityMinecartTNT)entity);
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityMinecartHopper)) return new CraftMinecartHopper(server, (net.minecraft.server.v1_7_R1.EntityMinecartHopper)entity);
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityMinecartMobSpawner)) return new CraftMinecartMobSpawner(server, (net.minecraft.server.v1_7_R1.EntityMinecartMobSpawner)entity);
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityMinecartRideable)) return new CraftMinecartRideable(server, (net.minecraft.server.v1_7_R1.EntityMinecartRideable)entity);
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityMinecartCommandBlock)) return new CraftMinecartCommand(server, (net.minecraft.server.v1_7_R1.EntityMinecartCommandBlock)entity);
        } else { if ((entity instanceof net.minecraft.server.v1_7_R1.EntityHanging)) {
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntityPainting)) return new CraftPainting(server, (net.minecraft.server.v1_7_R1.EntityPainting)entity);
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntityItemFrame)) return new CraftItemFrame(server, (net.minecraft.server.v1_7_R1.EntityItemFrame)entity);
            if ((entity instanceof net.minecraft.server.v1_7_R1.EntityLeash)) return new CraftLeash(server, (net.minecraft.server.v1_7_R1.EntityLeash)entity);
            return new CraftHanging(server, (net.minecraft.server.v1_7_R1.EntityHanging)entity);
          }
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityTNTPrimed)) return new CraftTNTPrimed(server, (net.minecraft.server.v1_7_R1.EntityTNTPrimed)entity);
          if ((entity instanceof net.minecraft.server.v1_7_R1.EntityFireworks)) return new CraftFirework(server, (net.minecraft.server.v1_7_R1.EntityFireworks)entity);
        } } }
    throw new AssertionError("Unknown entity " + entity == null ? null : entity.getClass());
  }
  
  public Location getLocation() {
    return new Location(getWorld(), entity.locX, entity.locY, entity.locZ, entity.yaw, entity.pitch);
  }
  
  public Location getLocation(Location loc) {
    if (loc != null) {
      loc.setWorld(getWorld());
      loc.setX(entity.locX);
      loc.setY(entity.locY);
      loc.setZ(entity.locZ);
      loc.setYaw(entity.yaw);
      loc.setPitch(entity.pitch);
    }
    
    return loc;
  }
  
  public Vector getVelocity() {
    return new Vector(entity.motX, entity.motY, entity.motZ);
  }
  
  public void setVelocity(Vector vel) {
    entity.motX = vel.getX();
    entity.motY = vel.getY();
    entity.motZ = vel.getZ();
    entity.velocityChanged = true;
  }
  
  public boolean isOnGround() {
    if ((entity instanceof EntityArrow)) {
      return ((EntityArrow)entity).isInGround();
    }
    return entity.onGround;
  }
  
  public org.bukkit.World getWorld() {
    return entity.world.getWorld();
  }
  
  public boolean teleport(Location location) {
    return teleport(location, PlayerTeleportEvent.TeleportCause.PLUGIN);
  }
  
  public boolean teleport(Location location, PlayerTeleportEvent.TeleportCause cause) {
    if ((entity.vehicle != null) || (entity.passenger != null) || (entity.dead)) {
      return false;
    }
    
    entity.world = ((org.bukkit.craftbukkit.v1_7_R1.CraftWorld)location.getWorld()).getHandle();
    entity.setLocation(location.getX(), location.getY(), location.getZ(), location.getYaw(), location.getPitch());
    
    return true;
  }
  
  public boolean teleport(org.bukkit.entity.Entity destination) {
    return teleport(destination.getLocation());
  }
  
  public boolean teleport(org.bukkit.entity.Entity destination, PlayerTeleportEvent.TeleportCause cause) {
    return teleport(destination.getLocation(), cause);
  }
  
  public List<org.bukkit.entity.Entity> getNearbyEntities(double x, double y, double z)
  {
    List<net.minecraft.server.v1_7_R1.Entity> notchEntityList = entity.world.getEntities(entity, entity.boundingBox.grow(x, y, z));
    List<org.bukkit.entity.Entity> bukkitEntityList = new java.util.ArrayList(notchEntityList.size());
    
    for (net.minecraft.server.v1_7_R1.Entity e : notchEntityList) {
      bukkitEntityList.add(e.getBukkitEntity());
    }
    return bukkitEntityList;
  }
  
  public int getEntityId() {
    return entity.getId();
  }
  
  public int getFireTicks() {
    return entity.fireTicks;
  }
  
  public int getMaxFireTicks() {
    return entity.maxFireTicks;
  }
  
  public void setFireTicks(int ticks) {
    entity.fireTicks = ticks;
  }
  
  public void remove() {
    entity.dead = true;
  }
  
  public boolean isDead() {
    return !entity.isAlive();
  }
  
  public boolean isValid() {
    return (entity.isAlive()) && (entity.valid);
  }
  
  public org.bukkit.Server getServer() {
    return server;
  }
  
  public Vector getMomentum() {
    return getVelocity();
  }
  
  public void setMomentum(Vector value) {
    setVelocity(value);
  }
  
  public org.bukkit.entity.Entity getPassenger() {
    return isEmpty() ? null : getHandle()passenger.getBukkitEntity();
  }
  
  public boolean setPassenger(org.bukkit.entity.Entity passenger) {
    if ((passenger instanceof CraftEntity)) {
      ((CraftEntity)passenger).getHandle().setPassengerOf(getHandle());
      return true;
    }
    return false;
  }
  
  public boolean isEmpty()
  {
    return getHandle()passenger == null;
  }
  
  public boolean eject() {
    if (getHandle()passenger == null) {
      return false;
    }
    
    getHandle()passenger.setPassengerOf(null);
    return true;
  }
  
  public float getFallDistance() {
    return getHandle()fallDistance;
  }
  
  public void setFallDistance(float distance) {
    getHandle()fallDistance = distance;
  }
  
  public void setLastDamageCause(EntityDamageEvent event) {
    lastDamageEvent = event;
  }
  
  public EntityDamageEvent getLastDamageCause() {
    return lastDamageEvent;
  }
  
  public java.util.UUID getUniqueId() {
    return getHandle()uniqueID;
  }
  
  public int getTicksLived() {
    return getHandle()ticksLived;
  }
  
  public void setTicksLived(int value) {
    if (value <= 0) {
      throw new IllegalArgumentException("Age must be at least 1 tick");
    }
    getHandle()ticksLived = value;
  }
  
  public net.minecraft.server.v1_7_R1.Entity getHandle() {
    return entity;
  }
  
  public void playEffect(EntityEffect type) {
    getHandle()world.broadcastEntityEffect(getHandle(), type.getData());
  }
  
  public void setHandle(net.minecraft.server.v1_7_R1.Entity entity) {
    this.entity = entity;
  }
  
  public String toString()
  {
    return "CraftEntity{id=" + getEntityId() + '}';
  }
  
  public boolean equals(Object obj)
  {
    if (obj == null) {
      return false;
    }
    if (getClass() != obj.getClass()) {
      return false;
    }
    CraftEntity other = (CraftEntity)obj;
    return getEntityId() == other.getEntityId();
  }
  
  public int hashCode()
  {
    int hash = 7;
    hash = 29 * hash + getEntityId();
    return hash;
  }
  
  public void setMetadata(String metadataKey, MetadataValue newMetadataValue) {
    server.getEntityMetadata().setMetadata(this, metadataKey, newMetadataValue);
  }
  
  public List<MetadataValue> getMetadata(String metadataKey) {
    return server.getEntityMetadata().getMetadata(this, metadataKey);
  }
  
  public boolean hasMetadata(String metadataKey) {
    return server.getEntityMetadata().hasMetadata(this, metadataKey);
  }
  
  public void removeMetadata(String metadataKey, org.bukkit.plugin.Plugin owningPlugin) {
    server.getEntityMetadata().removeMetadata(this, metadataKey, owningPlugin);
  }
  
  public boolean isInsideVehicle() {
    return getHandle()vehicle != null;
  }
  
  public boolean leaveVehicle() {
    if (getHandle()vehicle == null) {
      return false;
    }
    
    getHandle().setPassengerOf(null);
    return true;
  }
  
  public org.bukkit.entity.Entity getVehicle() {
    if (getHandle()vehicle == null) {
      return null;
    }
    
    return getHandle()vehicle.getBukkitEntity();
  }
}
