package org.bukkit.craftbukkit.v1_7_R1.entity;

import net.minecraft.server.v1_7_R1.EntityFallingBlock;
import org.bukkit.Material;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.util.CraftMagicNumbers;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.FallingSand;

public class CraftFallingSand extends CraftEntity implements FallingSand
{
  public CraftFallingSand(CraftServer server, EntityFallingBlock entity)
  {
    super(server, entity);
  }
  
  public EntityFallingBlock getHandle()
  {
    return (EntityFallingBlock)entity;
  }
  
  public String toString()
  {
    return "CraftFallingSand";
  }
  
  public EntityType getType() {
    return EntityType.FALLING_BLOCK;
  }
  
  public Material getMaterial() {
    return Material.getMaterial(getBlockId());
  }
  
  public int getBlockId() {
    return CraftMagicNumbers.getId(getHandle()id);
  }
  
  public byte getBlockData() {
    return (byte)getHandle()data;
  }
  
  public boolean getDropItem() {
    return getHandle()dropItem;
  }
  
  public void setDropItem(boolean drop) {
    getHandle()dropItem = drop;
  }
}
