package org.bukkit.craftbukkit.v1_7_R1.entity;

import net.minecraft.server.v1_7_R1.EntityFireball;
import net.minecraft.server.v1_7_R1.MathHelper;
import org.apache.commons.lang.Validate;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Fireball;
import org.bukkit.projectiles.ProjectileSource;
import org.bukkit.util.Vector;

public class CraftFireball extends AbstractProjectile implements Fireball
{
  public CraftFireball(CraftServer server, EntityFireball entity)
  {
    super(server, entity);
  }
  
  public float getYield() {
    return getHandle()bukkitYield;
  }
  
  public boolean isIncendiary() {
    return getHandle()isIncendiary;
  }
  
  public void setIsIncendiary(boolean isIncendiary) {
    getHandle()isIncendiary = isIncendiary;
  }
  
  public void setYield(float yield) {
    getHandle()bukkitYield = yield;
  }
  
  public ProjectileSource getShooter() {
    return getHandle()projectileSource;
  }
  
  public void setShooter(ProjectileSource shooter) {
    if ((shooter instanceof CraftLivingEntity)) {
      getHandle()shooter = ((CraftLivingEntity)shooter).getHandle();
    } else {
      getHandle()shooter = null;
    }
    getHandle()projectileSource = shooter;
  }
  
  public Vector getDirection() {
    return new Vector(getHandle()dirX, getHandle()dirY, getHandle()dirZ);
  }
  
  public void setDirection(Vector direction) {
    Validate.notNull(direction, "Direction can not be null");
    double x = direction.getX();
    double y = direction.getY();
    double z = direction.getZ();
    double magnitude = MathHelper.sqrt(x * x + y * y + z * z);
    getHandle()dirX = (x / magnitude);
    getHandle()dirY = (y / magnitude);
    getHandle()dirZ = (z / magnitude);
  }
  
  public EntityFireball getHandle()
  {
    return (EntityFireball)entity;
  }
  
  public String toString()
  {
    return "CraftFireball";
  }
  
  public EntityType getType() {
    return EntityType.UNKNOWN;
  }
}
