package org.bukkit.craftbukkit.v1_7_R1.entity;

import java.util.Random;
import net.minecraft.server.v1_7_R1.DataWatcher;
import net.minecraft.server.v1_7_R1.EntityFireworks;
import net.minecraft.server.v1_7_R1.ItemStack;
import net.minecraft.server.v1_7_R1.Items;
import org.bukkit.Material;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Firework;
import org.bukkit.inventory.meta.FireworkMeta;

public class CraftFirework
  extends CraftEntity implements Firework
{
  private static final int FIREWORK_ITEM_INDEX = 8;
  private final Random random = new Random();
  private final CraftItemStack item;
  
  public CraftFirework(CraftServer server, EntityFireworks entity) {
    super(server, entity);
    
    ItemStack item = getHandle().getDataWatcher().getItemStack(8);
    
    if (item == null) {
      item = new ItemStack(Items.FIREWORKS);
      getHandle().getDataWatcher().watch(8, item);
    }
    
    this.item = CraftItemStack.asCraftMirror(item);
    

    if (this.item.getType() != Material.FIREWORK) {
      this.item.setType(Material.FIREWORK);
    }
  }
  
  public EntityFireworks getHandle()
  {
    return (EntityFireworks)entity;
  }
  
  public String toString()
  {
    return "CraftFirework";
  }
  
  public EntityType getType()
  {
    return EntityType.FIREWORK;
  }
  
  public FireworkMeta getFireworkMeta()
  {
    return (FireworkMeta)item.getItemMeta();
  }
  
  public void setFireworkMeta(FireworkMeta meta)
  {
    item.setItemMeta(meta);
    

    getHandle()expectedLifespan = (10 * (1 + meta.getPower()) + random.nextInt(6) + random.nextInt(7));
    
    getHandle().getDataWatcher().h(8);
  }
  
  public void detonate()
  {
    getHandle()expectedLifespan = 0;
  }
}
