package org.bukkit.craftbukkit.v1_7_R1.entity;

import net.minecraft.server.v1_7_R1.EntityFishingHook;
import net.minecraft.server.v1_7_R1.EntityHuman;
import net.minecraft.server.v1_7_R1.MathHelper;
import net.minecraft.server.v1_7_R1.World;
import org.apache.commons.lang.Validate;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Fish;
import org.bukkit.projectiles.ProjectileSource;

public class CraftFish extends AbstractProjectile implements Fish
{
  private double biteChance = -1.0D;
  
  public CraftFish(CraftServer server, EntityFishingHook entity) {
    super(server, entity);
  }
  
  public ProjectileSource getShooter() {
    if (getHandle()owner != null) {
      return getHandle()owner.getBukkitEntity();
    }
    
    return null;
  }
  
  public void setShooter(ProjectileSource shooter) {
    if ((shooter instanceof CraftHumanEntity)) {
      getHandle()owner = ((EntityHuman)entity);
    }
  }
  
  public EntityFishingHook getHandle()
  {
    return (EntityFishingHook)entity;
  }
  
  public String toString()
  {
    return "CraftFish";
  }
  
  public EntityType getType() {
    return EntityType.FISHING_HOOK;
  }
  
  public double getBiteChance() {
    EntityFishingHook hook = getHandle();
    
    if (biteChance == -1.0D) {
      if (world.isRainingAt(MathHelper.floor(locX), MathHelper.floor(locY) + 1, MathHelper.floor(locZ))) {
        return 0.003333333333333334D;
      }
      return 0.002D;
    }
    return biteChance;
  }
  
  public void setBiteChance(double chance) {
    Validate.isTrue((chance >= 0.0D) && (chance <= 1.0D), "The bite chance must be between 0 and 1.");
    biteChance = chance;
  }
}
