package org.bukkit.craftbukkit.v1_7_R1.entity;

import net.minecraft.server.v1_7_R1.EntityHanging;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;

public class CraftHanging extends CraftEntity implements org.bukkit.entity.Hanging
{
  public CraftHanging(CraftServer server, EntityHanging entity)
  {
    super(server, entity);
  }
  
  public BlockFace getAttachedFace() {
    return getFacing().getOppositeFace();
  }
  
  public void setFacingDirection(BlockFace face) {
    setFacingDirection(face, false);
  }
  
  public boolean setFacingDirection(BlockFace face, boolean force) {
    Block block = getLocation().getBlock().getRelative(getAttachedFace()).getRelative(face.getOppositeFace()).getRelative(getFacing());
    EntityHanging hanging = getHandle();
    int x = x;int y = y;int z = z;int dir = direction;
    x = block.getX();
    y = block.getY();
    z = block.getZ();
    switch (1.$SwitchMap$org$bukkit$block$BlockFace[face.ordinal()]) {
    case 1: 
    default: 
      getHandle().setDirection(0);
      break;
    case 2: 
      getHandle().setDirection(1);
      break;
    case 3: 
      getHandle().setDirection(2);
      break;
    case 4: 
      getHandle().setDirection(3);
    }
    
    if ((!force) && (!hanging.survives()))
    {
      x = x;
      y = y;
      z = z;
      hanging.setDirection(dir);
      return false;
    }
    return true;
  }
  
  public BlockFace getFacing() {
    switch (getHandle()direction) {
    case 0: 
    default: 
      return BlockFace.SOUTH;
    case 1: 
      return BlockFace.WEST;
    case 2: 
      return BlockFace.NORTH;
    }
    return BlockFace.EAST;
  }
  

  public EntityHanging getHandle()
  {
    return (EntityHanging)entity;
  }
  
  public String toString()
  {
    return "CraftHanging";
  }
  
  public org.bukkit.entity.EntityType getType() {
    return org.bukkit.entity.EntityType.UNKNOWN;
  }
}
