package org.bukkit.craftbukkit.v1_7_R1.entity;

import net.minecraft.server.v1_7_R1.Entity;
import net.minecraft.server.v1_7_R1.EntityItem;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack;
import org.bukkit.entity.EntityType;
import org.bukkit.inventory.ItemStack;

public class CraftItem extends CraftEntity implements org.bukkit.entity.Item
{
  private final EntityItem item;
  
  public CraftItem(CraftServer server, Entity entity, EntityItem item)
  {
    super(server, entity);
    this.item = item;
  }
  
  public CraftItem(CraftServer server, EntityItem entity) {
    this(server, entity, entity);
  }
  
  public ItemStack getItemStack() {
    return CraftItemStack.asCraftMirror(item.getItemStack());
  }
  
  public void setItemStack(ItemStack stack) {
    item.setItemStack(CraftItemStack.asNMSCopy(stack));
  }
  
  public int getPickupDelay() {
    return item.pickupDelay;
  }
  
  public void setPickupDelay(int delay) {
    item.pickupDelay = delay;
  }
  
  public String toString()
  {
    return "CraftItem";
  }
  
  public EntityType getType() {
    return EntityType.DROPPED_ITEM;
  }
}
