package org.bukkit.craftbukkit.v1_7_R1.entity;

import net.minecraft.server.v1_7_R1.EntityPainting;
import net.minecraft.server.v1_7_R1.EnumArt;
import net.minecraft.server.v1_7_R1.WorldServer;
import org.bukkit.Art;
import org.bukkit.block.BlockFace;
import org.bukkit.craftbukkit.v1_7_R1.CraftArt;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.craftbukkit.v1_7_R1.CraftWorld;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Painting;

public class CraftPainting extends CraftHanging implements Painting
{
  public CraftPainting(CraftServer server, EntityPainting entity)
  {
    super(server, entity);
  }
  
  public Art getArt() {
    EnumArt art = getHandle()art;
    return CraftArt.NotchToBukkit(art);
  }
  
  public boolean setArt(Art art) {
    return setArt(art, false);
  }
  
  public boolean setArt(Art art, boolean force) {
    EntityPainting painting = getHandle();
    EnumArt oldArt = art;
    art = CraftArt.BukkitToNotch(art);
    painting.setDirection(direction);
    if ((!force) && (!painting.survives()))
    {
      art = oldArt;
      painting.setDirection(direction);
      return false;
    }
    update();
    return true;
  }
  
  public boolean setFacingDirection(BlockFace face, boolean force) {
    if (super.setFacingDirection(face, force)) {
      update();
      return true;
    }
    
    return false;
  }
  
  private void update() {
    WorldServer world = ((CraftWorld)getWorld()).getHandle();
    EntityPainting painting = new EntityPainting(world);
    x = getHandle()x;
    y = getHandle()y;
    z = getHandle()z;
    art = getHandle()art;
    painting.setDirection(getHandle()direction);
    getHandle().die();
    getHandle()velocityChanged = true;
    world.addEntity(painting);
    entity = painting;
  }
  
  public EntityPainting getHandle()
  {
    return (EntityPainting)entity;
  }
  
  public String toString()
  {
    return "CraftPainting{art=" + getArt() + "}";
  }
  
  public EntityType getType() {
    return EntityType.PAINTING;
  }
}
