package org.bukkit.craftbukkit.v1_7_R1.entity;

import net.minecraft.server.v1_7_R1.EntitySkeleton;
import org.apache.commons.lang.Validate;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Skeleton.SkeletonType;

public class CraftSkeleton extends CraftMonster implements org.bukkit.entity.Skeleton
{
  public CraftSkeleton(CraftServer server, EntitySkeleton entity)
  {
    super(server, entity);
  }
  
  public EntitySkeleton getHandle()
  {
    return (EntitySkeleton)entity;
  }
  
  public String toString()
  {
    return "CraftSkeleton";
  }
  
  public EntityType getType() {
    return EntityType.SKELETON;
  }
  
  public Skeleton.SkeletonType getSkeletonType() {
    return Skeleton.SkeletonType.getType(getHandle().getSkeletonType());
  }
  
  public void setSkeletonType(Skeleton.SkeletonType type) {
    Validate.notNull(type);
    getHandle().setSkeletonType(type.getId());
  }
}
