package org.bukkit.craftbukkit.v1_7_R1.entity;

import net.minecraft.server.v1_7_R1.EntityLiving;
import net.minecraft.server.v1_7_R1.EntityTNTPrimed;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.TNTPrimed;

public class CraftTNTPrimed extends CraftEntity implements TNTPrimed
{
  public CraftTNTPrimed(CraftServer server, EntityTNTPrimed entity)
  {
    super(server, entity);
  }
  
  public float getYield() {
    return getHandle()yield;
  }
  
  public boolean isIncendiary() {
    return getHandle()isIncendiary;
  }
  
  public void setIsIncendiary(boolean isIncendiary) {
    getHandle()isIncendiary = isIncendiary;
  }
  
  public void setYield(float yield) {
    getHandle()yield = yield;
  }
  
  public int getFuseTicks() {
    return getHandle()fuseTicks;
  }
  
  public void setFuseTicks(int fuseTicks) {
    getHandle()fuseTicks = fuseTicks;
  }
  
  public EntityTNTPrimed getHandle()
  {
    return (EntityTNTPrimed)entity;
  }
  
  public String toString()
  {
    return "CraftTNTPrimed";
  }
  
  public EntityType getType() {
    return EntityType.PRIMED_TNT;
  }
  
  public Entity getSource() {
    EntityLiving source = getHandle().getSource();
    
    if (source != null) {
      Entity bukkitEntity = source.getBukkitEntity();
      
      if (bukkitEntity.isValid()) {
        return bukkitEntity;
      }
    }
    
    return null;
  }
}
