package org.bukkit.craftbukkit.v1_7_R1.entity;

import net.minecraft.server.v1_7_R1.EntityTameableAnimal;
import org.bukkit.craftbukkit.v1_7_R1.CraftServer;
import org.bukkit.entity.AnimalTamer;

public class CraftTameableAnimal extends CraftAnimals implements org.bukkit.entity.Tameable, org.bukkit.entity.Creature
{
  public CraftTameableAnimal(CraftServer server, EntityTameableAnimal entity)
  {
    super(server, entity);
  }
  
  public EntityTameableAnimal getHandle()
  {
    return (EntityTameableAnimal)super.getHandle();
  }
  
  public AnimalTamer getOwner() {
    if ("".equals(getOwnerName())) { return null;
    }
    AnimalTamer owner = getServer().getPlayerExact(getOwnerName());
    if (owner == null) {
      owner = getServer().getOfflinePlayer(getOwnerName());
    }
    
    return owner;
  }
  
  public String getOwnerName() {
    return getHandle().getOwnerName();
  }
  
  public boolean isTamed() {
    return getHandle().isTamed();
  }
  
  public void setOwner(AnimalTamer tamer) {
    if (tamer != null) {
      setTamed(true);
      getHandle().setPathEntity(null);
      setOwnerName(tamer.getName());
    } else {
      setTamed(false);
      setOwnerName("");
    }
  }
  
  public void setOwnerName(String ownerName) {
    getHandle().setOwnerName(ownerName == null ? "" : ownerName);
  }
  
  public void setTamed(boolean tame) {
    getHandle().setTamed(tame);
    if (!tame) {
      setOwnerName("");
    }
  }
  
  public boolean isSitting() {
    return getHandle().isSitting();
  }
  
  public void setSitting(boolean sitting) {
    getHandle().getGoalSit().setSitting(sitting);
  }
  
  public String toString()
  {
    return getClass().getSimpleName() + "{owner=" + getOwner() + ",tamed=" + isTamed() + "}";
  }
}
