package org.bukkit.craftbukkit.v1_7_R1.help;

import org.bukkit.ChatColor;
import org.bukkit.command.CommandSender;
import org.bukkit.help.HelpMap;
import org.bukkit.help.HelpTopic;

public class CommandAliasHelpTopic extends HelpTopic
{
  private final String aliasFor;
  private final HelpMap helpMap;
  
  public CommandAliasHelpTopic(String alias, String aliasFor, HelpMap helpMap)
  {
    this.aliasFor = ("/" + aliasFor);
    this.helpMap = helpMap;
    name = ("/" + alias);
    org.apache.commons.lang.Validate.isTrue(!name.equals(this.aliasFor), "Command " + name + " cannot be alias for itself");
    shortText = (ChatColor.YELLOW + "Alias for " + ChatColor.WHITE + this.aliasFor);
  }
  
  public String getFullText(CommandSender forWho)
  {
    StringBuilder sb = new StringBuilder(shortText);
    HelpTopic aliasForTopic = helpMap.getHelpTopic(aliasFor);
    if (aliasForTopic != null) {
      sb.append("\n");
      sb.append(aliasForTopic.getFullText(forWho));
    }
    return sb.toString();
  }
  
  public boolean canSee(CommandSender commandSender)
  {
    if (amendedPermission == null) {
      HelpTopic aliasForTopic = helpMap.getHelpTopic(aliasFor);
      if (aliasForTopic != null) {
        return aliasForTopic.canSee(commandSender);
      }
      return false;
    }
    
    return commandSender.hasPermission(amendedPermission);
  }
}
