package org.bukkit.craftbukkit.v1_7_R1.inventory;

import java.util.ArrayList;
import java.util.List;
import net.minecraft.server.v1_7_R1.EntityHuman;
import net.minecraft.server.v1_7_R1.IInventory;
import net.minecraft.server.v1_7_R1.ItemStack;
import org.apache.commons.lang.Validate;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftHumanEntity;
import org.bukkit.entity.HumanEntity;
import org.bukkit.event.inventory.InventoryType;
import org.bukkit.inventory.InventoryHolder;

public class CraftInventoryCustom extends CraftInventory
{
  public CraftInventoryCustom(InventoryHolder owner, InventoryType type)
  {
    super(new MinecraftInventory(owner, type));
  }
  
  public CraftInventoryCustom(InventoryHolder owner, int size) {
    super(new MinecraftInventory(owner, size));
  }
  
  public CraftInventoryCustom(InventoryHolder owner, int size, String title) {
    super(new MinecraftInventory(owner, size, title));
  }
  
  static class MinecraftInventory implements IInventory {
    private final ItemStack[] items;
    private int maxStack = 64;
    private final List<HumanEntity> viewers;
    private final String title;
    private InventoryType type;
    private final InventoryHolder owner;
    
    public MinecraftInventory(InventoryHolder owner, InventoryType type) {
      this(owner, type.getDefaultSize(), type.getDefaultTitle());
      this.type = type;
    }
    
    public MinecraftInventory(InventoryHolder owner, int size) {
      this(owner, size, "Chest");
    }
    
    public MinecraftInventory(InventoryHolder owner, int size, String title) {
      Validate.notNull(title, "Title cannot be null");
      Validate.isTrue(title.length() <= 32, "Title cannot be longer than 32 characters");
      items = new ItemStack[size];
      this.title = title;
      viewers = new ArrayList();
      this.owner = owner;
      type = InventoryType.CHEST;
    }
    
    public int getSize() {
      return items.length;
    }
    
    public ItemStack getItem(int i) {
      return items[i];
    }
    
    public ItemStack splitStack(int i, int j) {
      ItemStack stack = getItem(i);
      
      if (stack == null) return null;
      ItemStack result; ItemStack result; if (count <= j) {
        setItem(i, null);
        result = stack;
      } else {
        result = CraftItemStack.copyNMSStack(stack, j);
        count -= j;
      }
      update();
      return result;
    }
    
    public ItemStack splitWithoutUpdate(int i) {
      ItemStack stack = getItem(i);
      
      if (stack == null) return null;
      ItemStack result; ItemStack result; if (count <= 1) {
        setItem(i, null);
        result = stack;
      } else {
        result = CraftItemStack.copyNMSStack(stack, 1);
        count -= 1;
      }
      return result;
    }
    
    public void setItem(int i, ItemStack itemstack) {
      items[i] = itemstack;
      if ((itemstack != null) && (getMaxStackSize() > 0) && (count > getMaxStackSize())) {
        count = getMaxStackSize();
      }
    }
    
    public String getInventoryName() {
      return title;
    }
    
    public int getMaxStackSize() {
      return maxStack;
    }
    
    public void setMaxStackSize(int size) {
      maxStack = size;
    }
    
    public void update() {}
    
    public boolean a(EntityHuman entityhuman) {
      return true;
    }
    
    public ItemStack[] getContents() {
      return items;
    }
    
    public void onOpen(CraftHumanEntity who) {
      viewers.add(who);
    }
    
    public void onClose(CraftHumanEntity who) {
      viewers.remove(who);
    }
    
    public List<HumanEntity> getViewers() {
      return viewers;
    }
    
    public InventoryType getType() {
      return type;
    }
    
    public void l_() {}
    
    public InventoryHolder getOwner() {
      return owner;
    }
    
    public void startOpen() {}
    
    public boolean k_() {
      return false;
    }
    
    public boolean b(int i, ItemStack itemstack) {
      return true;
    }
  }
}
