package org.bukkit.craftbukkit.v1_7_R1.inventory;

import net.minecraft.server.v1_7_R1.IInventory;
import net.minecraft.server.v1_7_R1.InventoryLargeChest;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

public class CraftInventoryDoubleChest extends CraftInventory implements org.bukkit.inventory.DoubleChestInventory
{
  private final CraftInventory left;
  private final CraftInventory right;
  
  public CraftInventoryDoubleChest(CraftInventory left, CraftInventory right)
  {
    super(new InventoryLargeChest("Large chest", left.getInventory(), right.getInventory()));
    this.left = left;
    this.right = right;
  }
  
  public CraftInventoryDoubleChest(InventoryLargeChest largeChest) {
    super(largeChest);
    if ((left instanceof InventoryLargeChest)) {
      left = new CraftInventoryDoubleChest((InventoryLargeChest)left);
    } else {
      left = new CraftInventory(left);
    }
    if ((right instanceof InventoryLargeChest)) {
      right = new CraftInventoryDoubleChest((InventoryLargeChest)right);
    } else {
      right = new CraftInventory(right);
    }
  }
  
  public Inventory getLeftSide() {
    return left;
  }
  
  public Inventory getRightSide() {
    return right;
  }
  
  public void setContents(ItemStack[] items)
  {
    if (getInventory().getContents().length < items.length) {
      throw new IllegalArgumentException("Invalid inventory size; expected " + getInventory().getContents().length + " or less");
    }
    ItemStack[] leftItems = new ItemStack[left.getSize()];ItemStack[] rightItems = new ItemStack[right.getSize()];
    System.arraycopy(items, 0, leftItems, 0, Math.min(left.getSize(), items.length));
    left.setContents(leftItems);
    if (items.length >= left.getSize()) {
      System.arraycopy(items, left.getSize(), rightItems, 0, Math.min(right.getSize(), items.length - left.getSize()));
      right.setContents(rightItems);
    }
  }
  
  public org.bukkit.block.DoubleChest getHolder()
  {
    return new org.bukkit.block.DoubleChest(this);
  }
}
