package org.bukkit.craftbukkit.v1_7_R1.inventory;

import net.minecraft.server.v1_7_R1.Container;
import net.minecraft.server.v1_7_R1.Slot;
import org.bukkit.GameMode;
import org.bukkit.craftbukkit.v1_7_R1.entity.CraftHumanEntity;
import org.bukkit.entity.HumanEntity;
import org.bukkit.event.inventory.InventoryType;
import org.bukkit.event.inventory.InventoryType.SlotType;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.InventoryView;

public class CraftInventoryView extends InventoryView
{
  private final Container container;
  private final CraftHumanEntity player;
  private final CraftInventory viewing;
  
  public CraftInventoryView(HumanEntity player, Inventory viewing, Container container)
  {
    this.player = ((CraftHumanEntity)player);
    this.viewing = ((CraftInventory)viewing);
    this.container = container;
  }
  
  public Inventory getTopInventory()
  {
    return viewing;
  }
  
  public Inventory getBottomInventory()
  {
    return player.getInventory();
  }
  
  public HumanEntity getPlayer()
  {
    return player;
  }
  
  public InventoryType getType()
  {
    InventoryType type = viewing.getType();
    if ((type == InventoryType.CRAFTING) && (player.getGameMode() == GameMode.CREATIVE)) {
      return InventoryType.CREATIVE;
    }
    return type;
  }
  
  public void setItem(int slot, org.bukkit.inventory.ItemStack item)
  {
    net.minecraft.server.v1_7_R1.ItemStack stack = CraftItemStack.asNMSCopy(item);
    if (slot != -999) {
      container.getSlot(slot).set(stack);
    } else {
      player.getHandle().drop(stack, false);
    }
  }
  
  public org.bukkit.inventory.ItemStack getItem(int slot)
  {
    if (slot == -999) {
      return null;
    }
    return CraftItemStack.asCraftMirror(container.getSlot(slot).getItem());
  }
  
  public boolean isInTop(int rawSlot) {
    return rawSlot < viewing.getSize();
  }
  
  public Container getHandle() {
    return container;
  }
  
  public static InventoryType.SlotType getSlotType(InventoryView inventory, int slot) {
    InventoryType.SlotType type = InventoryType.SlotType.CONTAINER;
    if ((slot >= 0) && (slot < inventory.getTopInventory().getSize())) {}
    switch (1.$SwitchMap$org$bukkit$event$inventory$InventoryType[inventory.getType().ordinal()]) {
    case 1: 
      if (slot == 2) {
        type = InventoryType.SlotType.RESULT;
      } else if (slot == 1) {
        type = InventoryType.SlotType.FUEL;
      }
      break;
    case 2: 
      if (slot == 3) {
        type = InventoryType.SlotType.FUEL;
      } else {
        type = InventoryType.SlotType.CRAFTING;
      }
      break;
    case 3: 
      type = InventoryType.SlotType.CRAFTING;
      break;
    case 4: 
    case 5: 
      if (slot == 0) {
        type = InventoryType.SlotType.RESULT;
      } else {
        type = InventoryType.SlotType.CRAFTING;
      }
      break;
    case 6: 
      if (slot == 2) {
        type = InventoryType.SlotType.RESULT;
      } else {
        type = InventoryType.SlotType.CRAFTING;
      }
      break;
    case 7: 
      type = InventoryType.SlotType.CRAFTING;
      break;
    case 8: 
      if (slot == 2) {
        type = InventoryType.SlotType.RESULT;
      } else {
        type = InventoryType.SlotType.CRAFTING;
      }
      break;
    default: 
      break;
      

      if (slot == -999) {
        type = InventoryType.SlotType.OUTSIDE;
      } else if ((inventory.getType() == InventoryType.CRAFTING) && (slot < 9)) {
        type = InventoryType.SlotType.ARMOR;
      } else if (slot >= inventory.countSlots() - 9)
        type = InventoryType.SlotType.QUICKBAR;
      break;
    }
    return type;
  }
}
