package org.bukkit.craftbukkit.v1_7_R1.inventory;

import java.util.Iterator;
import java.util.Set;
import net.minecraft.server.v1_7_R1.IRecipe;
import net.minecraft.server.v1_7_R1.ItemStack;
import net.minecraft.server.v1_7_R1.RecipesFurnace;
import org.bukkit.inventory.Recipe;

public class RecipeIterator implements Iterator<Recipe>
{
  private final Iterator<IRecipe> recipes;
  private final Iterator<ItemStack> smeltingCustom;
  private final Iterator<ItemStack> smeltingVanilla;
  private Iterator<?> removeFrom = null;
  
  public RecipeIterator() {
    recipes = net.minecraft.server.v1_7_R1.CraftingManager.getInstance().getRecipes().iterator();
    smeltingCustom = getInstance()customRecipes.keySet().iterator();
    smeltingVanilla = getInstance()recipes.keySet().iterator();
  }
  
  public boolean hasNext() {
    return (recipes.hasNext()) || (smeltingCustom.hasNext()) || (smeltingVanilla.hasNext());
  }
  
  public Recipe next() {
    if (recipes.hasNext()) {
      removeFrom = recipes;
      return ((IRecipe)recipes.next()).toBukkitRecipe(); }
    ItemStack item;
    ItemStack item;
    if (smeltingCustom.hasNext()) {
      removeFrom = smeltingCustom;
      item = (ItemStack)smeltingCustom.next();
    } else {
      removeFrom = smeltingVanilla;
      item = (ItemStack)smeltingVanilla.next();
    }
    
    CraftItemStack stack = CraftItemStack.asCraftMirror(RecipesFurnace.getInstance().getResult(item));
    
    return new CraftFurnaceRecipe(stack, CraftItemStack.asCraftMirror(item));
  }
  
  public void remove()
  {
    if (removeFrom == null) {
      throw new IllegalStateException();
    }
    removeFrom.remove();
  }
}
