package org.bukkit.craftbukkit.v1_7_R1.map;

import java.util.Map;
import net.minecraft.server.v1_7_R1.WorldMap;
import net.minecraft.server.v1_7_R1.WorldMapDecoration;
import org.bukkit.entity.Player;
import org.bukkit.map.MapCanvas;
import org.bukkit.map.MapCursorCollection;
import org.bukkit.map.MapRenderer;
import org.bukkit.map.MapView;

public class CraftMapRenderer extends MapRenderer
{
  private final WorldMap worldMap;
  
  public CraftMapRenderer(CraftMapView mapView, WorldMap worldMap)
  {
    super(false);
    this.worldMap = worldMap;
  }
  

  public void render(MapView map, MapCanvas canvas, Player player)
  {
    for (int x = 0; x < 128; x++) {
      for (int y = 0; y < 128; y++) {
        canvas.setPixel(x, y, worldMap.colors[(y * 128 + x)]);
      }
    }
    

    MapCursorCollection cursors = canvas.getCursors();
    while (cursors.size() > 0) {
      cursors.removeCursor(cursors.getCursor(0));
    }
    
    for (Object key : worldMap.g.keySet())
    {
      Player other = org.bukkit.Bukkit.getPlayerExact((String)key);
      if ((other == null) || (player.canSee(other)))
      {


        WorldMapDecoration decoration = (WorldMapDecoration)worldMap.g.get(key);
        cursors.addCursor(locX, locY, (byte)(rotation & 0xF), type);
      }
    }
  }
}
