package org.bukkit.craftbukkit.v1_7_R1.scheduler;

import org.bukkit.plugin.Plugin;

class CraftAsyncDebugger
{
  private CraftAsyncDebugger next = null;
  private final int expiry;
  private final Plugin plugin;
  private final Class<? extends Runnable> clazz;
  
  CraftAsyncDebugger(int expiry, Plugin plugin, Class<? extends Runnable> clazz) {
    this.expiry = expiry;
    this.plugin = plugin;
    this.clazz = clazz;
  }
  
  final CraftAsyncDebugger getNextHead(int time)
  {
    CraftAsyncDebugger current = this;
    CraftAsyncDebugger next; while ((time > expiry) && ((next = next) != null)) {
      current = next;
    }
    return current;
  }
  
  final CraftAsyncDebugger setNext(CraftAsyncDebugger next) {
    return this.next = next;
  }
  
  StringBuilder debugTo(StringBuilder string) {
    for (CraftAsyncDebugger next = this; next != null; next = next) {
      string.append(plugin.getDescription().getName()).append(':').append(clazz.getName()).append('@').append(expiry).append(',');
    }
    return string;
  }
}
