package org.bukkit.craftbukkit.v1_7_R1.scheduler;

import org.bukkit.Bukkit;
import org.bukkit.plugin.Plugin;
import org.bukkit.scheduler.BukkitScheduler;
import org.bukkit.scheduler.BukkitTask;

class CraftTask implements BukkitTask, Runnable
{
  private volatile CraftTask next = null;
  

  private volatile long period;
  
  private long nextRun;
  
  private final Runnable task;
  
  private final Plugin plugin;
  
  private final int id;
  

  CraftTask()
  {
    this(null, null, -1, -1L);
  }
  
  CraftTask(Runnable task) {
    this(null, task, -1, -1L);
  }
  
  CraftTask(Plugin plugin, Runnable task, int id, long period) {
    this.plugin = plugin;
    this.task = task;
    this.id = id;
    this.period = period;
  }
  
  public final int getTaskId() {
    return id;
  }
  
  public final Plugin getOwner() {
    return plugin;
  }
  
  public boolean isSync() {
    return true;
  }
  
  public void run() {
    task.run();
  }
  
  long getPeriod() {
    return period;
  }
  
  void setPeriod(long period) {
    this.period = period;
  }
  
  long getNextRun() {
    return nextRun;
  }
  
  void setNextRun(long nextRun) {
    this.nextRun = nextRun;
  }
  
  CraftTask getNext() {
    return next;
  }
  
  void setNext(CraftTask next) {
    this.next = next;
  }
  
  Class<? extends Runnable> getTaskClass() {
    return task.getClass();
  }
  
  public void cancel() {
    Bukkit.getScheduler().cancelTask(id);
  }
  




  boolean cancel0()
  {
    setPeriod(-2L);
    return true;
  }
}
