package org.bukkit.craftbukkit.v1_7_R1.scoreboard;

import java.util.Collection;
import java.util.Map;
import net.minecraft.server.v1_7_R1.Scoreboard;
import net.minecraft.server.v1_7_R1.ScoreboardScore;
import org.bukkit.Bukkit;
import org.bukkit.OfflinePlayer;
import org.bukkit.scoreboard.Objective;
import org.bukkit.scoreboard.Score;





final class CraftScore
  implements Score
{
  private final String playerName;
  private final CraftObjective objective;
  
  CraftScore(CraftObjective objective, String playerName)
  {
    this.objective = objective;
    this.playerName = playerName;
  }
  
  public OfflinePlayer getPlayer() {
    return Bukkit.getOfflinePlayer(playerName);
  }
  
  public Objective getObjective() {
    return objective;
  }
  
  public int getScore() throws IllegalStateException {
    Scoreboard board = objective.checkState().board;
    
    if (board.getPlayers().contains(playerName)) {
      Map<String, ScoreboardScore> scores = board.getPlayerObjectives(playerName);
      ScoreboardScore score = (ScoreboardScore)scores.get(objective.getHandle());
      if (score != null) {
        return score.getScore();
      }
    }
    return 0;
  }
  
  public void setScore(int score) throws IllegalStateException {
    objective.checkState().board.getPlayerScoreForObjective(playerName, objective.getHandle()).setScore(score);
  }
  
  public CraftScoreboard getScoreboard() {
    return objective.getScoreboard();
  }
}
