package org.bukkit.craftbukkit.v1_7_R1.util;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import net.minecraft.server.v1_7_R1.Blocks;
import net.minecraft.server.v1_7_R1.Item;
import net.minecraft.server.v1_7_R1.MojangsonParser;
import net.minecraft.server.v1_7_R1.NBTTagCompound;
import net.minecraft.server.v1_7_R1.RegistryMaterials;
import net.minecraft.server.v1_7_R1.StatisticList;
import org.bukkit.Achievement;
import org.bukkit.Material;
import org.bukkit.UnsafeValues;
import org.bukkit.craftbukkit.v1_7_R1.CraftStatistic;
import org.bukkit.craftbukkit.v1_7_R1.inventory.CraftItemStack;
import org.bukkit.util.StringUtil;




public final class CraftMagicNumbers
  implements UnsafeValues
{
  public static final UnsafeValues INSTANCE = new CraftMagicNumbers();
  

  public static net.minecraft.server.v1_7_R1.Block getBlock(org.bukkit.block.Block block)
  {
    return getBlock(block.getType());
  }
  
  @Deprecated
  public static net.minecraft.server.v1_7_R1.Block getBlock(int id)
  {
    return getBlock(Material.getMaterial(id));
  }
  
  @Deprecated
  public static int getId(net.minecraft.server.v1_7_R1.Block block)
  {
    return net.minecraft.server.v1_7_R1.Block.b(block);
  }
  
  public static Material getMaterial(net.minecraft.server.v1_7_R1.Block block) {
    return Material.getMaterial(net.minecraft.server.v1_7_R1.Block.b(block));
  }
  
  public static Item getItem(Material material)
  {
    Item item = Item.d(material.getId());
    return item;
  }
  
  @Deprecated
  public static Item getItem(int id)
  {
    return Item.d(id);
  }
  
  @Deprecated
  public static int getId(Item item)
  {
    return Item.b(item);
  }
  
  public static Material getMaterial(Item item)
  {
    Material material = Material.getMaterial(Item.b(item));
    
    if (material == null) {
      return Material.AIR;
    }
    
    return material;
  }
  
  public static net.minecraft.server.v1_7_R1.Block getBlock(Material material)
  {
    net.minecraft.server.v1_7_R1.Block block = net.minecraft.server.v1_7_R1.Block.e(material.getId());
    
    if (block == null) {
      return Blocks.AIR;
    }
    
    return block;
  }
  
  public Material getMaterialFromInternalName(String name)
  {
    return getMaterial((Item)Item.REGISTRY.a(name));
  }
  
  public List<String> tabCompleteInternalMaterialName(String token, List<String> completions)
  {
    return (List)StringUtil.copyPartialMatches(token, Item.REGISTRY.b(), completions);
  }
  
  public org.bukkit.inventory.ItemStack modifyItemStack(org.bukkit.inventory.ItemStack stack, String arguments)
  {
    net.minecraft.server.v1_7_R1.ItemStack nmsStack = CraftItemStack.asNMSCopy(stack);
    
    nmsStack.setTag((NBTTagCompound)MojangsonParser.a(arguments));
    
    stack.setItemMeta(CraftItemStack.getItemMeta(nmsStack));
    
    return stack;
  }
  
  public org.bukkit.Statistic getStatisticFromInternalName(String name)
  {
    return CraftStatistic.getBukkitStatisticByName(name);
  }
  
  public Achievement getAchievementFromInternalName(String name)
  {
    return CraftStatistic.getBukkitAchievementByName(name);
  }
  
  public List<String> tabCompleteInternalStatisticOrAchievementName(String token, List<String> completions)
  {
    List<String> matches = new ArrayList();
    Iterator iterator = StatisticList.b.iterator();
    while (iterator.hasNext()) {
      String statistic = next()e;
      if (statistic.startsWith(token)) {
        matches.add(statistic);
      }
    }
    return matches;
  }
}
