package org.bukkit.craftbukkit.v1_7_R1.util;

import java.util.HashSet;
import java.util.List;
import net.minecraft.server.v1_7_R1.EntityPlayer;
import net.minecraft.server.v1_7_R1.MinecraftServer;
import net.minecraft.server.v1_7_R1.PlayerList;
import org.bukkit.entity.Player;

public class LazyPlayerSet extends LazyHashSet<Player>
{
  HashSet<Player> makeReference()
  {
    if (this.reference != null) {
      throw new IllegalStateException("Reference already created!");
    }
    List<EntityPlayer> players = getServer()getPlayerList()players;
    HashSet<Player> reference = new HashSet(players.size());
    for (EntityPlayer player : players) {
      reference.add(player.getBukkitEntity());
    }
    return reference;
  }
}
