package org.bukkit.craftbukkit.v1_7_R1.util;

import java.io.IOException;
import java.io.OutputStream;
import java.util.logging.Logger;
import org.bukkit.craftbukkit.libs.jline.console.ConsoleReader;
import org.bukkit.craftbukkit.libs.jline.console.CursorBuffer;

public class TerminalConsoleWriterThread implements Runnable
{
  private final ConsoleReader reader;
  private final OutputStream output;
  
  public TerminalConsoleWriterThread(OutputStream output, ConsoleReader reader)
  {
    this.output = output;
    this.reader = reader;
  }
  

  public void run()
  {
    for (;;)
    {
      String message = net.minecraft.util.com.mojang.util.QueueLogAppender.getNextLogEvent("TerminalConsole");
      if (message != null)
      {
        try
        {

          if (org.bukkit.craftbukkit.Main.useJline) {
            reader.print("\r");
            reader.flush();
            output.write(message.getBytes());
            output.flush();
            try
            {
              reader.drawLine();
            } catch (Throwable ex) {
              reader.getCursorBuffer().clear();
            }
            reader.flush();
          } else {
            output.write(message.getBytes());
            output.flush();
          }
        } catch (IOException ex) {
          Logger.getLogger(TerminalConsoleWriterThread.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
      }
    }
  }
}
