package org.bukkit.craftbukkit.v1_7_R1.util;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;
import java.util.logging.Logger;

public final class Versioning
{
  public static String getBukkitVersion()
  {
    String result = "Unknown-Version";
    
    InputStream stream = org.bukkit.Bukkit.class.getClassLoader().getResourceAsStream("META-INF/maven/org.bukkit/bukkit/pom.properties");
    Properties properties = new Properties();
    
    if (stream != null) {
      try {
        properties.load(stream);
        
        result = properties.getProperty("version");
      } catch (IOException ex) {
        Logger.getLogger(Versioning.class.getName()).log(java.util.logging.Level.SEVERE, "Could not get Bukkit version!", ex);
      }
    }
    
    return result;
  }
}
