package org.bukkit.event.block;

import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.event.Cancellable;
import org.bukkit.event.HandlerList;





public class BlockFromToEvent
  extends BlockEvent
  implements Cancellable
{
  private static final HandlerList handlers = new HandlerList();
  protected Block to;
  protected BlockFace face;
  protected boolean cancel;
  
  public BlockFromToEvent(Block block, BlockFace face) {
    super(block);
    this.face = face;
    cancel = false;
  }
  
  public BlockFromToEvent(Block block, Block toBlock) {
    super(block);
    to = toBlock;
    face = BlockFace.SELF;
    cancel = false;
  }
  




  public BlockFace getFace()
  {
    return face;
  }
  




  public Block getToBlock()
  {
    if (to == null) {
      to = block.getRelative(face);
    }
    return to;
  }
  
  public boolean isCancelled() {
    return cancel;
  }
  
  public void setCancelled(boolean cancel) {
    this.cancel = cancel;
  }
  
  public HandlerList getHandlers()
  {
    return handlers;
  }
  
  public static HandlerList getHandlerList() {
    return handlers;
  }
}
