package org.bukkit.event.block;

import org.bukkit.block.Block;
import org.bukkit.block.BlockState;
import org.bukkit.entity.Player;
import org.bukkit.event.Cancellable;
import org.bukkit.event.HandlerList;
import org.bukkit.inventory.ItemStack;



public class BlockPlaceEvent
  extends BlockEvent
  implements Cancellable
{
  private static final HandlerList handlers = new HandlerList();
  protected boolean cancel;
  protected boolean canBuild;
  protected Block placedAgainst;
  protected BlockState replacedBlockState;
  protected ItemStack itemInHand;
  protected Player player;
  
  public BlockPlaceEvent(Block placedBlock, BlockState replacedBlockState, Block placedAgainst, ItemStack itemInHand, Player thePlayer, boolean canBuild) {
    super(placedBlock);
    this.placedAgainst = placedAgainst;
    this.itemInHand = itemInHand;
    player = thePlayer;
    this.replacedBlockState = replacedBlockState;
    this.canBuild = canBuild;
    cancel = false;
  }
  
  public boolean isCancelled() {
    return cancel;
  }
  
  public void setCancelled(boolean cancel) {
    this.cancel = cancel;
  }
  




  public Player getPlayer()
  {
    return player;
  }
  





  public Block getBlockPlaced()
  {
    return getBlock();
  }
  





  public BlockState getBlockReplacedState()
  {
    return replacedBlockState;
  }
  




  public Block getBlockAgainst()
  {
    return placedAgainst;
  }
  





  public ItemStack getItemInHand()
  {
    return itemInHand;
  }
  








  public boolean canBuild()
  {
    return canBuild;
  }
  





  public void setBuild(boolean canBuild)
  {
    this.canBuild = canBuild;
  }
  
  public HandlerList getHandlers()
  {
    return handlers;
  }
  
  public static HandlerList getHandlerList() {
    return handlers;
  }
}
