package org.bukkit.event.entity;

import org.bukkit.Location;
import org.bukkit.entity.CreatureType;
import org.bukkit.entity.Entity;
import org.bukkit.entity.LivingEntity;
import org.bukkit.event.Cancellable;
import org.bukkit.event.HandlerList;



public class CreatureSpawnEvent
  extends EntityEvent
  implements Cancellable
{
  private static final HandlerList handlers = new HandlerList();
  private boolean canceled;
  private final SpawnReason spawnReason;
  
  public CreatureSpawnEvent(LivingEntity spawnee, SpawnReason spawnReason) {
    super(spawnee);
    this.spawnReason = spawnReason;
  }
  
  @Deprecated
  public CreatureSpawnEvent(Entity spawnee, CreatureType type, Location loc, SpawnReason reason) {
    super(spawnee);
    spawnReason = reason;
  }
  
  public boolean isCancelled() {
    return canceled;
  }
  
  public void setCancelled(boolean cancel) {
    canceled = cancel;
  }
  
  public LivingEntity getEntity()
  {
    return (LivingEntity)entity;
  }
  




  public Location getLocation()
  {
    return getEntity().getLocation();
  }
  






  @Deprecated
  public CreatureType getCreatureType()
  {
    return CreatureType.fromEntityType(getEntityType());
  }
  





  public SpawnReason getSpawnReason()
  {
    return spawnReason;
  }
  
  public HandlerList getHandlers()
  {
    return handlers;
  }
  
  public static HandlerList getHandlerList() {
    return handlers;
  }
  






  public static enum SpawnReason
  {
    NATURAL, 
    



    JOCKEY, 
    


    CHUNK_GEN, 
    


    SPAWNER, 
    


    EGG, 
    


    SPAWNER_EGG, 
    


    LIGHTNING, 
    




    BED, 
    



    BUILD_SNOWMAN, 
    


    BUILD_IRONGOLEM, 
    


    BUILD_WITHER, 
    


    VILLAGE_DEFENSE, 
    


    VILLAGE_INVASION, 
    


    BREEDING, 
    


    SLIME_SPLIT, 
    


    REINFORCEMENTS, 
    


    NETHER_PORTAL, 
    


    DISPENSE_EGG, 
    


    CUSTOM, 
    


    DEFAULT;
    
    private SpawnReason() {}
  }
}
