package org.bukkit.event.entity;

import org.bukkit.entity.Entity;
import org.bukkit.event.Cancellable;
import org.bukkit.event.HandlerList;
import org.bukkit.util.NumberConversions;

public class EntityRegainHealthEvent
  extends EntityEvent
  implements Cancellable
{
  private static final HandlerList handlers = new HandlerList();
  private boolean cancelled;
  private double amount;
  private final RegainReason regainReason;
  
  @Deprecated
  public EntityRegainHealthEvent(Entity entity, int amount, RegainReason regainReason) {
    this(entity, amount, regainReason);
  }
  
  public EntityRegainHealthEvent(Entity entity, double amount, RegainReason regainReason) {
    super(entity);
    this.amount = amount;
    this.regainReason = regainReason;
  }
  




  public double getAmount()
  {
    return amount;
  }
  




  @Deprecated
  public int getAmount()
  {
    return NumberConversions.ceil(getAmount());
  }
  




  public void setAmount(double amount)
  {
    this.amount = amount;
  }
  




  @Deprecated
  public void setAmount(int amount)
  {
    setAmount(amount);
  }
  
  public boolean isCancelled() {
    return cancelled;
  }
  
  public void setCancelled(boolean cancel) {
    cancelled = cancel;
  }
  





  public RegainReason getRegainReason()
  {
    return regainReason;
  }
  
  public HandlerList getHandlers()
  {
    return handlers;
  }
  
  public static HandlerList getHandlerList() {
    return handlers;
  }
  







  public static enum RegainReason
  {
    REGEN, 
    



    SATIATED, 
    


    EATING, 
    


    ENDER_CRYSTAL, 
    


    MAGIC, 
    


    MAGIC_REGEN, 
    


    WITHER_SPAWN, 
    


    WITHER, 
    


    CUSTOM;
    
    private RegainReason() {}
  }
}
