package org.bukkit.event.entity;

import org.bukkit.entity.LightningStrike;
import org.bukkit.entity.Pig;
import org.bukkit.entity.PigZombie;
import org.bukkit.event.Cancellable;
import org.bukkit.event.HandlerList;

public class PigZapEvent
  extends EntityEvent
  implements Cancellable
{
  private static final HandlerList handlers = new HandlerList();
  private boolean canceled;
  private final PigZombie pigzombie;
  private final LightningStrike bolt;
  
  public PigZapEvent(Pig pig, LightningStrike bolt, PigZombie pigzombie) {
    super(pig);
    this.bolt = bolt;
    this.pigzombie = pigzombie;
  }
  
  public boolean isCancelled() {
    return canceled;
  }
  
  public void setCancelled(boolean cancel) {
    canceled = cancel;
  }
  
  public Pig getEntity()
  {
    return (Pig)entity;
  }
  




  public LightningStrike getLightning()
  {
    return bolt;
  }
  





  public PigZombie getPigZombie()
  {
    return pigzombie;
  }
  
  public HandlerList getHandlers()
  {
    return handlers;
  }
  
  public static HandlerList getHandlerList() {
    return handlers;
  }
}
