package org.bukkit.event.entity;

import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.event.Cancellable;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;

public class PlayerLeashEntityEvent
  extends Event
  implements Cancellable
{
  private static final HandlerList handlers = new HandlerList();
  private final Entity leashHolder;
  private final Entity entity;
  private boolean cancelled = false;
  private final Player player;
  
  public PlayerLeashEntityEvent(Entity what, Entity leashHolder, Player leasher) {
    this.leashHolder = leashHolder;
    entity = what;
    player = leasher;
  }
  




  public Entity getLeashHolder()
  {
    return leashHolder;
  }
  




  public Entity getEntity()
  {
    return entity;
  }
  




  public final Player getPlayer()
  {
    return player;
  }
  
  public HandlerList getHandlers()
  {
    return handlers;
  }
  
  public static HandlerList getHandlerList() {
    return handlers;
  }
  
  public boolean isCancelled() {
    return cancelled;
  }
  
  public void setCancelled(boolean cancel) {
    cancelled = cancel;
  }
}
