package org.bukkit.event.player;

import org.bukkit.entity.Player;
import org.bukkit.event.Cancellable;
import org.bukkit.event.HandlerList;

public class PlayerItemHeldEvent
  extends PlayerEvent
  implements Cancellable
{
  private static final HandlerList handlers = new HandlerList();
  private boolean cancel = false;
  private final int previous;
  private final int current;
  
  public PlayerItemHeldEvent(Player player, int previous, int current) {
    super(player);
    this.previous = previous;
    this.current = current;
  }
  




  public int getPreviousSlot()
  {
    return previous;
  }
  




  public int getNewSlot()
  {
    return current;
  }
  
  public boolean isCancelled() {
    return cancel;
  }
  
  public void setCancelled(boolean cancel) {
    this.cancel = cancel;
  }
  
  public HandlerList getHandlers()
  {
    return handlers;
  }
  
  public static HandlerList getHandlerList() {
    return handlers;
  }
}
