package org.bukkit.event.player;

import org.bukkit.entity.Player;
import org.bukkit.event.Cancellable;
import org.bukkit.event.HandlerList;

public class PlayerKickEvent
  extends PlayerEvent
  implements Cancellable
{
  private static final HandlerList handlers = new HandlerList();
  private String leaveMessage;
  private String kickReason;
  private Boolean cancel;
  
  public PlayerKickEvent(Player playerKicked, String kickReason, String leaveMessage) {
    super(playerKicked);
    this.kickReason = kickReason;
    this.leaveMessage = leaveMessage;
    cancel = Boolean.valueOf(false);
  }
  




  public String getReason()
  {
    return kickReason;
  }
  




  public String getLeaveMessage()
  {
    return leaveMessage;
  }
  
  public boolean isCancelled() {
    return cancel.booleanValue();
  }
  
  public void setCancelled(boolean cancel) {
    this.cancel = Boolean.valueOf(cancel);
  }
  




  public void setReason(String kickReason)
  {
    this.kickReason = kickReason;
  }
  




  public void setLeaveMessage(String leaveMessage)
  {
    this.leaveMessage = leaveMessage;
  }
  
  public HandlerList getHandlers()
  {
    return handlers;
  }
  
  public static HandlerList getHandlerList() {
    return handlers;
  }
}
