package org.bukkit.event.weather;

import org.bukkit.World;
import org.bukkit.event.Cancellable;
import org.bukkit.event.HandlerList;

public class ThunderChangeEvent
  extends WeatherEvent
  implements Cancellable
{
  private static final HandlerList handlers = new HandlerList();
  private boolean canceled;
  private final boolean to;
  
  public ThunderChangeEvent(World world, boolean to) {
    super(world);
    this.to = to;
  }
  
  public boolean isCancelled() {
    return canceled;
  }
  
  public void setCancelled(boolean cancel) {
    canceled = cancel;
  }
  




  public boolean toThunderState()
  {
    return to;
  }
  
  public HandlerList getHandlers()
  {
    return handlers;
  }
  
  public static HandlerList getHandlerList() {
    return handlers;
  }
}
