package org.bukkit.material;

import org.bukkit.Material;
import org.bukkit.block.BlockFace;

public class Sign
  extends MaterialData implements Attachable
{
  public Sign()
  {
    super(Material.SIGN_POST);
  }
  



  @Deprecated
  public Sign(int type)
  {
    super(type);
  }
  
  public Sign(Material type) {
    super(type);
  }
  



  @Deprecated
  public Sign(int type, byte data)
  {
    super(type, data);
  }
  



  @Deprecated
  public Sign(Material type, byte data)
  {
    super(type, data);
  }
  





  public boolean isWallSign()
  {
    return getItemType() == Material.WALL_SIGN;
  }
  




  public BlockFace getAttachedFace()
  {
    if (isWallSign()) {
      byte data = getData();
      
      switch (data) {
      case 2: 
        return BlockFace.SOUTH;
      
      case 3: 
        return BlockFace.NORTH;
      
      case 4: 
        return BlockFace.EAST;
      
      case 5: 
        return BlockFace.WEST;
      }
      
      return null;
    }
    return BlockFace.DOWN;
  }
  





  public BlockFace getFacing()
  {
    byte data = getData();
    
    if (!isWallSign()) {
      switch (data) {
      case 0: 
        return BlockFace.SOUTH;
      
      case 1: 
        return BlockFace.SOUTH_SOUTH_WEST;
      
      case 2: 
        return BlockFace.SOUTH_WEST;
      
      case 3: 
        return BlockFace.WEST_SOUTH_WEST;
      
      case 4: 
        return BlockFace.WEST;
      
      case 5: 
        return BlockFace.WEST_NORTH_WEST;
      
      case 6: 
        return BlockFace.NORTH_WEST;
      
      case 7: 
        return BlockFace.NORTH_NORTH_WEST;
      
      case 8: 
        return BlockFace.NORTH;
      
      case 9: 
        return BlockFace.NORTH_NORTH_EAST;
      
      case 10: 
        return BlockFace.NORTH_EAST;
      
      case 11: 
        return BlockFace.EAST_NORTH_EAST;
      
      case 12: 
        return BlockFace.EAST;
      
      case 13: 
        return BlockFace.EAST_SOUTH_EAST;
      
      case 14: 
        return BlockFace.SOUTH_EAST;
      
      case 15: 
        return BlockFace.SOUTH_SOUTH_EAST;
      }
      
      return null;
    }
    return getAttachedFace().getOppositeFace();
  }
  

  public void setFacingDirection(BlockFace face)
  {
    byte data;
    if (isWallSign()) { byte data;
      switch (1.$SwitchMap$org$bukkit$block$BlockFace[face.ordinal()]) {
      case 1: 
        data = 2;
        break;
      
      case 2: 
        data = 3;
        break;
      
      case 3: 
        data = 4;
        break;
      
      case 4: 
      default: 
        data = 5; break;
      }
    } else {
      switch (1.$SwitchMap$org$bukkit$block$BlockFace[face.ordinal()]) {
      case 2: 
        data = 0;
        break;
      
      case 5: 
        data = 1;
        break;
      
      case 6: 
        data = 2;
        break;
      
      case 7: 
        data = 3;
        break;
      
      case 3: 
        data = 4;
        break;
      
      case 8: 
        data = 5;
        break;
      
      case 9: 
        data = 6;
        break;
      
      case 10: 
        data = 7;
        break;
      
      case 1: 
        data = 8;
        break;
      
      case 11: 
        data = 9;
        break;
      
      case 12: 
        data = 10;
        break;
      
      case 13: 
        data = 11;
        break;
      
      case 4: 
        data = 12;
        break;
      
      case 14: 
        data = 13;
        break;
      
      case 15: 
        data = 15;
        break;
      
      case 16: 
      default: 
        data = 14;
      }
      
    }
    setData(data);
  }
  
  public String toString()
  {
    return super.toString() + " facing " + getFacing();
  }
  
  public Sign clone()
  {
    return (Sign)super.clone();
  }
}
