package org.bukkit.util;

import java.util.Map;
import org.bukkit.configuration.serialization.SerializableAs;








@SerializableAs("BlockVector")
public class BlockVector
  extends Vector
{
  public BlockVector()
  {
    x = 0.0D;
    y = 0.0D;
    z = 0.0D;
  }
  




  public BlockVector(Vector vec)
  {
    x = vec.getX();
    y = vec.getY();
    z = vec.getZ();
  }
  






  public BlockVector(int x, int y, int z)
  {
    this.x = x;
    this.y = y;
    this.z = z;
  }
  






  public BlockVector(double x, double y, double z)
  {
    this.x = x;
    this.y = y;
    this.z = z;
  }
  






  public BlockVector(float x, float y, float z)
  {
    this.x = x;
    this.y = y;
    this.z = z;
  }
  






  public boolean equals(Object obj)
  {
    if (!(obj instanceof BlockVector)) {
      return false;
    }
    BlockVector other = (BlockVector)obj;
    
    return ((int)other.getX() == (int)x) && ((int)other.getY() == (int)y) && ((int)other.getZ() == (int)z);
  }
  






  public int hashCode()
  {
    return Integer.valueOf((int)x).hashCode() >> 13 ^ Integer.valueOf((int)y).hashCode() >> 7 ^ Integer.valueOf((int)z).hashCode();
  }
  





  public BlockVector clone()
  {
    return (BlockVector)super.clone();
  }
  
  public static BlockVector deserialize(Map<String, Object> args) {
    double x = 0.0D;
    double y = 0.0D;
    double z = 0.0D;
    
    if (args.containsKey("x")) {
      x = ((Double)args.get("x")).doubleValue();
    }
    if (args.containsKey("y")) {
      y = ((Double)args.get("y")).doubleValue();
    }
    if (args.containsKey("z")) {
      z = ((Double)args.get("z")).doubleValue();
    }
    
    return new BlockVector(x, y, z);
  }
}
