package org.json.simple.parser;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;

class Yylex
{
  public static final int YYEOF = -1;
  private static final int ZZ_BUFFERSIZE = 16384;
  public static final int YYINITIAL = 0;
  public static final int STRING_BEGIN = 2;
  private static final int[] ZZ_LEXSTATE = { 0, 0, 1, 1 };
  private static final String ZZ_CMAP_PACKED = "";
  private static final char[] ZZ_CMAP = zzUnpackCMap("");
  private static final int[] ZZ_ACTION = zzUnpackAction();
  private static final String ZZ_ACTION_PACKED_0 = "";
  private static final int[] ZZ_ROWMAP = zzUnpackRowMap();
  private static final String ZZ_ROWMAP_PACKED_0 = "";
  private static final int[] ZZ_TRANS = { 2, 2, 3, 4, 2, 2, 2, 5, 2, 6, 2, 2, 7, 8, 2, 9, 2, 2, 2, 2, 2, 10, 11, 12, 13, 14, 15, 16, 16, 16, 16, 16, 16, 16, 16, 17, 18, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, 19, 20, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 20, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 21, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 22, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 23, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 16, 16, 16, 16, 16, 16, 16, 16, -1, -1, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, -1, -1, -1, -1, -1, -1, -1, -1, 24, 25, 26, 27, 28, 29, 30, 31, 32, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 33, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 34, 35, -1, -1, 34, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 36, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 37, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 38, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 39, -1, 39, -1, 39, -1, -1, -1, -1, -1, 39, 39, -1, -1, -1, -1, 39, 39, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 33, -1, 20, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 20, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 35, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 38, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 40, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 41, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, -1, 42, -1, 42, -1, -1, -1, -1, -1, 42, 42, -1, -1, -1, -1, 42, 42, -1, -1, -1, -1, -1, -1, -1, -1, -1, 43, -1, 43, -1, 43, -1, -1, -1, -1, -1, 43, 43, -1, -1, -1, -1, 43, 43, -1, -1, -1, -1, -1, -1, -1, -1, -1, 44, -1, 44, -1, 44, -1, -1, -1, -1, -1, 44, 44, -1, -1, -1, -1, 44, 44, -1, -1, -1, -1, -1, -1, -1, -1 };
  private static final int ZZ_UNKNOWN_ERROR = 0;
  private static final int ZZ_NO_MATCH = 1;
  private static final int ZZ_PUSHBACK_2BIG = 2;
  private static final String[] ZZ_ERROR_MSG = { "Unkown internal scanner error", "Error: could not match input", "Error: pushback value was too large" };
  private static final int[] ZZ_ATTRIBUTE = zzUnpackAttribute();
  private static final String ZZ_ATTRIBUTE_PACKED_0 = "";
  private Reader zzReader;
  private int zzState;
  private int zzLexicalState = 0;
  private char[] zzBuffer = new char[16384];
  private int zzMarkedPos;
  private int zzCurrentPos;
  private int zzStartRead;
  private int zzEndRead;
  private int yyline;
  private int yychar;
  private int yycolumn;
  private boolean zzAtBOL = true;
  private boolean zzAtEOF;
  private StringBuffer sb = new StringBuffer();
  
  private static int[] zzUnpackAction()
  {
    int[] arrayOfInt = new int[45];
    int i = 0;
    i = zzUnpackAction("", i, arrayOfInt);
    return arrayOfInt;
  }
  
  private static int zzUnpackAction(String paramString, int paramInt, int[] paramArrayOfInt)
  {
    int i = 0;
    int j = paramInt;
    int k = paramString.length();
    while (i < k)
    {
      int m = paramString.charAt(i++);
      int n = paramString.charAt(i++);
      do
      {
        paramArrayOfInt[(j++)] = n;
        m--;
      } while (m > 0);
    }
    return j;
  }
  
  private static int[] zzUnpackRowMap()
  {
    int[] arrayOfInt = new int[45];
    int i = 0;
    i = zzUnpackRowMap("", i, arrayOfInt);
    return arrayOfInt;
  }
  
  private static int zzUnpackRowMap(String paramString, int paramInt, int[] paramArrayOfInt)
  {
    int i = 0;
    int j = paramInt;
    int k = paramString.length();
    while (i < k)
    {
      int m = paramString.charAt(i++) << '\020';
      paramArrayOfInt[(j++)] = (m | paramString.charAt(i++));
    }
    return j;
  }
  
  private static int[] zzUnpackAttribute()
  {
    int[] arrayOfInt = new int[45];
    int i = 0;
    i = zzUnpackAttribute("", i, arrayOfInt);
    return arrayOfInt;
  }
  
  private static int zzUnpackAttribute(String paramString, int paramInt, int[] paramArrayOfInt)
  {
    int i = 0;
    int j = paramInt;
    int k = paramString.length();
    while (i < k)
    {
      int m = paramString.charAt(i++);
      int n = paramString.charAt(i++);
      do
      {
        paramArrayOfInt[(j++)] = n;
        m--;
      } while (m > 0);
    }
    return j;
  }
  
  int getPosition()
  {
    return yychar;
  }
  
  Yylex(Reader paramReader)
  {
    zzReader = paramReader;
  }
  
  Yylex(InputStream paramInputStream)
  {
    this(new InputStreamReader(paramInputStream));
  }
  
  private static char[] zzUnpackCMap(String paramString)
  {
    char[] arrayOfChar = new char[65536];
    int i = 0;
    int j = 0;
    while (i < 90)
    {
      int k = paramString.charAt(i++);
      int m = paramString.charAt(i++);
      do
      {
        arrayOfChar[(j++)] = m;
        k--;
      } while (k > 0);
    }
    return arrayOfChar;
  }
  
  private boolean zzRefill()
    throws IOException
  {
    if (zzStartRead > 0)
    {
      System.arraycopy(zzBuffer, zzStartRead, zzBuffer, 0, zzEndRead - zzStartRead);
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }
    if (zzCurrentPos >= zzBuffer.length)
    {
      char[] arrayOfChar = new char[zzCurrentPos * 2];
      System.arraycopy(zzBuffer, 0, arrayOfChar, 0, zzBuffer.length);
      zzBuffer = arrayOfChar;
    }
    int i = zzReader.read(zzBuffer, zzEndRead, zzBuffer.length - zzEndRead);
    if (i > 0)
    {
      zzEndRead += i;
      return false;
    }
    if (i == 0)
    {
      int j = zzReader.read();
      if (j == -1) {
        return true;
      }
      zzBuffer[(zzEndRead++)] = ((char)j);
      return false;
    }
    return true;
  }
  
  public final void yyclose()
    throws IOException
  {
    zzAtEOF = true;
    zzEndRead = zzStartRead;
    if (zzReader != null) {
      zzReader.close();
    }
  }
  
  public final void yyreset(Reader paramReader)
  {
    zzReader = paramReader;
    zzAtBOL = true;
    zzAtEOF = false;
    zzEndRead = (this.zzStartRead = 0);
    zzCurrentPos = (this.zzMarkedPos = 0);
    yyline = (this.yychar = this.yycolumn = 0);
    zzLexicalState = 0;
  }
  
  public final int yystate()
  {
    return zzLexicalState;
  }
  
  public final void yybegin(int paramInt)
  {
    zzLexicalState = paramInt;
  }
  
  public final String yytext()
  {
    return new String(zzBuffer, zzStartRead, zzMarkedPos - zzStartRead);
  }
  
  public final char yycharat(int paramInt)
  {
    return zzBuffer[(zzStartRead + paramInt)];
  }
  
  public final int yylength()
  {
    return zzMarkedPos - zzStartRead;
  }
  
  private void zzScanError(int paramInt)
  {
    String str;
    try
    {
      str = ZZ_ERROR_MSG[paramInt];
    }
    catch (ArrayIndexOutOfBoundsException localArrayIndexOutOfBoundsException)
    {
      str = ZZ_ERROR_MSG[0];
    }
    throw new Error(str);
  }
  
  public void yypushback(int paramInt)
  {
    if (paramInt > yylength()) {
      zzScanError(2);
    }
    zzMarkedPos -= paramInt;
  }
  
  public Yytoken yylex()
    throws IOException, ParseException
  {
    int i = zzEndRead;
    char[] arrayOfChar1 = zzBuffer;
    char[] arrayOfChar2 = ZZ_CMAP;
    int[] arrayOfInt1 = ZZ_TRANS;
    int[] arrayOfInt2 = ZZ_ROWMAP;
    int[] arrayOfInt3 = ZZ_ATTRIBUTE;
    for (;;)
    {
      int j = zzMarkedPos;
      yychar += j - zzStartRead;
      int k = -1;
      int m = this.zzCurrentPos = this.zzStartRead = j;
      zzState = ZZ_LEXSTATE[zzLexicalState];
      int n;
      for (;;)
      {
        if (m < i)
        {
          n = arrayOfChar1[(m++)];
        }
        else
        {
          if (zzAtEOF)
          {
            n = -1;
            break;
          }
          zzCurrentPos = m;
          zzMarkedPos = j;
          boolean bool = zzRefill();
          m = zzCurrentPos;
          j = zzMarkedPos;
          arrayOfChar1 = zzBuffer;
          i = zzEndRead;
          if (bool)
          {
            n = -1;
            break;
          }
          n = arrayOfChar1[(m++)];
        }
        int i1 = arrayOfInt1[(arrayOfInt2[zzState] + arrayOfChar2[n])];
        if (i1 == -1) {
          break;
        }
        zzState = i1;
        int i3 = arrayOfInt3[zzState];
        if ((i3 & 0x1) == 1)
        {
          k = zzState;
          j = m;
          if ((i3 & 0x8) == 8) {
            break;
          }
        }
      }
      zzMarkedPos = j;
      Object localObject;
      switch (k < 0 ? k : ZZ_ACTION[k])
      {
      case 11: 
        sb.append(yytext());
      case 25: 
        break;
      case 4: 
        sb.delete(0, sb.length());
        yybegin(2);
      case 26: 
        break;
      case 16: 
        sb.append('\b');
      case 27: 
        break;
      case 6: 
        return new Yytoken(2, null);
      case 28: 
        break;
      case 23: 
        localObject = Boolean.valueOf(yytext());
        return new Yytoken(0, localObject);
      case 29: 
        break;
      case 22: 
        return new Yytoken(0, null);
      case 30: 
        break;
      case 13: 
        yybegin(0);
        return new Yytoken(0, sb.toString());
      case 31: 
        break;
      case 12: 
        sb.append('\\');
      case 32: 
        break;
      case 21: 
        localObject = Double.valueOf(yytext());
        return new Yytoken(0, localObject);
      case 33: 
        break;
      case 1: 
        throw new ParseException(yychar, 0, new Character(yycharat(0)));
      case 34: 
        break;
      case 8: 
        return new Yytoken(4, null);
      case 35: 
        break;
      case 19: 
        sb.append('\r');
      case 36: 
        break;
      case 15: 
        sb.append('/');
      case 37: 
        break;
      case 10: 
        return new Yytoken(6, null);
      case 38: 
        break;
      case 14: 
        sb.append('"');
      case 39: 
        break;
      case 5: 
        return new Yytoken(1, null);
      case 40: 
        break;
      case 17: 
        sb.append('\f');
      case 41: 
        break;
      case 24: 
        try
        {
          int i2 = Integer.parseInt(yytext().substring(2), 16);
          sb.append((char)i2);
        }
        catch (Exception localException)
        {
          throw new ParseException(yychar, 2, localException);
        }
      case 42: 
        break;
      case 20: 
        sb.append('\t');
      case 43: 
        break;
      case 7: 
        return new Yytoken(3, null);
      case 44: 
        break;
      case 2: 
        Long localLong = Long.valueOf(yytext());
        return new Yytoken(0, localLong);
      case 45: 
        break;
      case 18: 
        sb.append('\n');
      case 46: 
        break;
      case 9: 
        return new Yytoken(5, null);
      case 47: 
        break;
      case 3: 
      case 48: 
        break;
      default: 
        if ((n == -1) && (zzStartRead == zzCurrentPos))
        {
          zzAtEOF = true;
          return null;
        }
        zzScanError(1);
      }
    }
  }
}
