package org.sqlite;

import java.io.Reader;
import java.io.StringReader;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.Statement;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.Calendar;




















final class RS
  extends Unused
  implements ResultSet, ResultSetMetaData, Codes
{
  private final Stmt stmt;
  private final DB db;
  boolean open = false;
  int maxRows;
  String[] cols = null;
  String[] colsMeta = null;
  boolean[][] meta = (boolean[][])null;
  
  private int limitRows;
  private int row = 0;
  private int lastCol;
  
  RS(Stmt stmt) {
    this.stmt = stmt;
    db = db;
  }
  

  boolean isOpen()
  {
    return open;
  }
  
  void checkOpen() throws SQLException
  {
    if (!open) {
      throw new SQLException("ResultSet closed");
    }
  }
  
  private int checkCol(int col) throws SQLException {
    if (colsMeta == null)
      throw new IllegalStateException("SQLite JDBC: inconsistent internal state");
    if ((col < 1) || (col > colsMeta.length))
      throw new SQLException("column " + col + " out of bounds [1," + colsMeta.length + "]");
    col--;return col;
  }
  
  private int markCol(int col) throws SQLException
  {
    checkOpen();
    checkCol(col);
    lastCol = col;
    col--;return col;
  }
  
  private void checkMeta() throws SQLException {
    checkCol(1);
    if (meta == null) {
      meta = db.column_metadata(stmt.pointer);
    }
  }
  
  public void close() throws SQLException
  {
    cols = null;
    colsMeta = null;
    meta = ((boolean[][])null);
    open = false;
    limitRows = 0;
    row = 0;
    lastCol = -1;
    
    if (stmt == null)
      return;
    if ((stmt != null) && (stmt.pointer != 0L)) {
      db.reset(stmt.pointer);
    }
  }
  
  public int findColumn(String col) throws SQLException {
    checkOpen();
    int c = -1;
    for (int i = 0; i < cols.length; i++) {
      if ((col.equalsIgnoreCase(cols[i])) || ((cols[i].toUpperCase().endsWith(col.toUpperCase())) && (cols[i].charAt(cols[i].length() - col.length()) == '.')))
      {

        if (c == -1) {
          c = i;
        } else
          throw new SQLException("ambiguous column: '" + col + "'");
      }
    }
    if (c == -1) {
      throw new SQLException("no such column: '" + col + "'");
    }
    return c + 1;
  }
  
  public boolean next() throws SQLException {
    if (!open)
      return false;
    lastCol = -1;
    

    if (row == 0) {
      row += 1;
      return true;
    }
    

    if ((maxRows != 0) && (row > maxRows)) {
      return false;
    }
    
    int statusCode = db.step(stmt.pointer);
    switch (statusCode) {
    case 101: 
      close();
      return false;
    case 100: 
      row += 1;
      return true;
    }
    
    db.throwex(statusCode);
    return false;
  }
  
  public int getType() throws SQLException
  {
    return 1003;
  }
  
  public int getFetchSize() throws SQLException {
    return limitRows;
  }
  
  public void setFetchSize(int rows) throws SQLException {
    if ((0 > rows) || ((maxRows != 0) && (rows > maxRows)))
      throw new SQLException("fetch size " + rows + " out of bounds " + maxRows);
    limitRows = rows;
  }
  
  public int getFetchDirection() throws SQLException {
    checkOpen();
    return 1000;
  }
  
  public void setFetchDirection(int d) throws SQLException {
    checkOpen();
    if (d != 1000)
      throw new SQLException("only FETCH_FORWARD direction supported");
  }
  
  public boolean isAfterLast() throws SQLException {
    return !open;
  }
  
  public boolean isBeforeFirst() throws SQLException {
    return (open) && (row == 0);
  }
  
  public boolean isFirst() throws SQLException {
    return row == 1;
  }
  
  public boolean isLast() throws SQLException {
    throw new SQLException("function not yet implemented for SQLite");
  }
  
  protected void finalize() throws SQLException
  {
    close();
  }
  
  public int getRow() throws SQLException {
    return row;
  }
  
  public boolean wasNull() throws SQLException {
    return db.column_type(stmt.pointer, markCol(lastCol)) == 5;
  }
  
  public boolean getBoolean(int col)
    throws SQLException
  {
    return getInt(col) != 0;
  }
  
  public boolean getBoolean(String col) throws SQLException {
    return getBoolean(findColumn(col));
  }
  
  public byte getByte(int col) throws SQLException {
    return (byte)getInt(col);
  }
  
  public byte getByte(String col) throws SQLException {
    return getByte(findColumn(col));
  }
  
  public byte[] getBytes(int col) throws SQLException {
    return db.column_blob(stmt.pointer, markCol(col));
  }
  
  public byte[] getBytes(String col) throws SQLException {
    return getBytes(findColumn(col));
  }
  
  public Reader getCharacterStream(int col) throws SQLException {
    return new StringReader(getString(col));
  }
  
  public Reader getCharacterStream(String col) throws SQLException {
    return getCharacterStream(findColumn(col));
  }
  
  public java.sql.Date getDate(int col) throws SQLException {
    if (db.column_type(stmt.pointer, markCol(col)) == 5)
      return null;
    return new java.sql.Date(db.column_long(stmt.pointer, markCol(col)));
  }
  
  public java.sql.Date getDate(int col, Calendar cal) throws SQLException {
    if (db.column_type(stmt.pointer, markCol(col)) == 5)
      return null;
    if (cal == null)
      return getDate(col);
    cal.setTimeInMillis(db.column_long(stmt.pointer, markCol(col)));
    return new java.sql.Date(cal.getTime().getTime());
  }
  
  public java.sql.Date getDate(String col) throws SQLException {
    return getDate(findColumn(col), Calendar.getInstance());
  }
  
  public java.sql.Date getDate(String col, Calendar cal) throws SQLException {
    return getDate(findColumn(col), cal);
  }
  
  public double getDouble(int col) throws SQLException {
    if (db.column_type(stmt.pointer, markCol(col)) == 5)
      return 0.0D;
    return db.column_double(stmt.pointer, markCol(col));
  }
  
  public double getDouble(String col) throws SQLException {
    return getDouble(findColumn(col));
  }
  
  public float getFloat(int col) throws SQLException {
    if (db.column_type(stmt.pointer, markCol(col)) == 5)
      return 0.0F;
    return (float)db.column_double(stmt.pointer, markCol(col));
  }
  
  public float getFloat(String col) throws SQLException {
    return getFloat(findColumn(col));
  }
  
  public int getInt(int col) throws SQLException {
    return db.column_int(stmt.pointer, markCol(col));
  }
  
  public int getInt(String col) throws SQLException {
    return getInt(findColumn(col));
  }
  
  public long getLong(int col) throws SQLException {
    return db.column_long(stmt.pointer, markCol(col));
  }
  
  public long getLong(String col) throws SQLException {
    return getLong(findColumn(col));
  }
  
  public short getShort(int col) throws SQLException {
    return (short)getInt(col);
  }
  
  public short getShort(String col) throws SQLException {
    return getShort(findColumn(col));
  }
  
  public String getString(int col) throws SQLException {
    return db.column_text(stmt.pointer, markCol(col));
  }
  
  public String getString(String col) throws SQLException {
    return getString(findColumn(col));
  }
  
  public Time getTime(int col) throws SQLException {
    if (db.column_type(stmt.pointer, markCol(col)) == 5)
      return null;
    return new Time(db.column_long(stmt.pointer, markCol(col)));
  }
  
  public Time getTime(int col, Calendar cal) throws SQLException {
    if (cal == null)
      return getTime(col);
    if (db.column_type(stmt.pointer, markCol(col)) == 5)
      return null;
    cal.setTimeInMillis(db.column_long(stmt.pointer, markCol(col)));
    return new Time(cal.getTime().getTime());
  }
  
  public Time getTime(String col) throws SQLException {
    return getTime(findColumn(col));
  }
  
  public Time getTime(String col, Calendar cal) throws SQLException {
    return getTime(findColumn(col), cal);
  }
  
  public Timestamp getTimestamp(int col) throws SQLException {
    if (db.column_type(stmt.pointer, markCol(col)) == 5)
      return null;
    return new Timestamp(db.column_long(stmt.pointer, markCol(col)));
  }
  
  public Timestamp getTimestamp(int col, Calendar cal) throws SQLException {
    if (cal == null)
      return getTimestamp(col);
    if (db.column_type(stmt.pointer, markCol(col)) == 5)
      return null;
    cal.setTimeInMillis(db.column_long(stmt.pointer, markCol(col)));
    return new Timestamp(cal.getTime().getTime());
  }
  
  public Timestamp getTimestamp(String col) throws SQLException {
    return getTimestamp(findColumn(col));
  }
  
  public Timestamp getTimestamp(String c, Calendar ca) throws SQLException {
    return getTimestamp(findColumn(c), ca);
  }
  
  public Object getObject(int col) throws SQLException {
    switch (db.column_type(stmt.pointer, checkCol(col))) {
    case 1: 
      long val = getLong(col);
      if ((val > 2147483647L) || (val < -2147483648L)) {
        return new Long(val);
      }
      return new Integer((int)val);
    case 2: 
      return new Double(getDouble(col));
    case 4: 
      return getBytes(col);
    case 5: 
      return null;
    }
    
    return getString(col);
  }
  
  public Object getObject(String col) throws SQLException
  {
    return getObject(findColumn(col));
  }
  
  public Statement getStatement() {
    return stmt;
  }
  
  public String getCursorName() throws SQLException {
    return null;
  }
  
  public SQLWarning getWarnings() throws SQLException {
    return null;
  }
  

  public void clearWarnings()
    throws SQLException
  {}
  
  public ResultSetMetaData getMetaData()
    throws SQLException
  {
    return this;
  }
  
  public String getCatalogName(int col) throws SQLException {
    return db.column_table_name(stmt.pointer, checkCol(col));
  }
  
  public String getColumnClassName(int col) throws SQLException {
    checkCol(col);
    return "java.lang.Object";
  }
  
  public int getColumnCount() throws SQLException {
    checkCol(1);
    return colsMeta.length;
  }
  
  public int getColumnDisplaySize(int col) throws SQLException {
    return 2147483647;
  }
  
  public String getColumnLabel(int col) throws SQLException {
    return getColumnName(col);
  }
  
  public String getColumnName(int col) throws SQLException {
    return db.column_name(stmt.pointer, checkCol(col));
  }
  
  public int getColumnType(int col) throws SQLException {
    switch (db.column_type(stmt.pointer, checkCol(col))) {
    case 1: 
      return 4;
    case 2: 
      return 6;
    case 4: 
      return 2004;
    case 5: 
      return 0;
    }
    
    return 12;
  }
  
  public String getColumnTypeName(int col) throws SQLException
  {
    switch (db.column_type(stmt.pointer, checkCol(col))) {
    case 1: 
      return "integer";
    case 2: 
      return "float";
    case 4: 
      return "blob";
    case 5: 
      return "null";
    }
    
    return "text";
  }
  
  public int getPrecision(int col) throws SQLException
  {
    return 0;
  }
  
  public int getScale(int col) throws SQLException {
    return 0;
  }
  
  public String getSchemaName(int col) throws SQLException {
    return "";
  }
  
  public String getTableName(int col) throws SQLException {
    return db.column_table_name(stmt.pointer, checkCol(col));
  }
  
  public int isNullable(int col) throws SQLException {
    checkMeta();
    return meta[checkCol(col)][1] != 0 ? 0 : 1;
  }
  
  public boolean isAutoIncrement(int col) throws SQLException {
    checkMeta();
    return meta[checkCol(col)][2];
  }
  
  public boolean isCaseSensitive(int col) throws SQLException {
    return true;
  }
  
  public boolean isCurrency(int col) throws SQLException {
    return false;
  }
  
  public boolean isDefinitelyWritable(int col) throws SQLException {
    return true;
  }
  
  public boolean isReadOnly(int col) throws SQLException {
    return false;
  }
  
  public boolean isSearchable(int col) throws SQLException {
    return true;
  }
  
  public boolean isSigned(int col) throws SQLException {
    return false;
  }
  
  public boolean isWritable(int col) throws SQLException {
    return true;
  }
  
  public int getConcurrency() throws SQLException {
    return 1007;
  }
  
  public boolean rowDeleted() throws SQLException {
    return false;
  }
  
  public boolean rowInserted() throws SQLException {
    return false;
  }
  
  public boolean rowUpdated() throws SQLException {
    return false;
  }
}
