package org.yaml.snakeyaml.events;

import java.util.Map;
import org.yaml.snakeyaml.error.Mark;






















public final class DocumentStartEvent
  extends Event
{
  private final boolean explicit;
  private final Integer[] version;
  private final Map<String, String> tags;
  
  public DocumentStartEvent(Mark startMark, Mark endMark, boolean explicit, Integer[] version, Map<String, String> tags)
  {
    super(startMark, endMark);
    this.explicit = explicit;
    this.version = version;
    this.tags = tags;
  }
  
  public boolean getExplicit() {
    return explicit;
  }
  







  public Integer[] getVersion()
  {
    return version;
  }
  





  public Map<String, String> getTags()
  {
    return tags;
  }
  
  public boolean is(Event.ID id)
  {
    return Event.ID.DocumentStart == id;
  }
}
