package com.avaje.ebeaninternal.api;

import com.avaje.ebean.Transaction;
import com.avaje.ebean.bean.PersistenceContext;
import com.avaje.ebeaninternal.server.lucene.LIndexUpdateFuture;
import com.avaje.ebeaninternal.server.persist.BatchControl;
import com.avaje.ebeaninternal.server.transaction.TransactionLogBuffer;
import java.sql.Connection;

public abstract interface SpiTransaction
  extends Transaction
{
  public abstract boolean isLogSql();
  
  public abstract boolean isLogSummary();
  
  public abstract void logInternal(String paramString);
  
  public abstract void addIndexUpdateFuture(LIndexUpdateFuture paramLIndexUpdateFuture);
  
  public abstract TransactionLogBuffer getLogBuffer();
  
  public abstract void registerBean(Integer paramInteger);
  
  public abstract void unregisterBean(Integer paramInteger);
  
  public abstract boolean isRegisteredBean(Integer paramInteger);
  
  public abstract String getId();
  
  public abstract int getBatchSize();
  
  public abstract int depth(int paramInt);
  
  public abstract boolean isExplicit();
  
  public abstract TransactionEvent getEvent();
  
  public abstract boolean isPersistCascade();
  
  public abstract boolean isBatchThisRequest();
  
  public abstract BatchControl getBatchControl();
  
  public abstract void setBatchControl(BatchControl paramBatchControl);
  
  public abstract PersistenceContext getPersistenceContext();
  
  public abstract void setPersistenceContext(PersistenceContext paramPersistenceContext);
  
  public abstract Connection getInternalConnection();
}
