package com.avaje.ebeaninternal.server.lucene;

import com.avaje.ebeaninternal.server.el.ElPropertyValue;
import java.util.Set;
import org.apache.lucene.document.Document;
import org.apache.lucene.queryParser.QueryParser;

public abstract interface LIndexField
{
  public abstract String getName();
  
  public abstract DocFieldWriter createDocFieldWriter();
  
  public abstract void addIndexResolvePropertyNames(Set<String> paramSet);
  
  public abstract void addIndexRestorePropertyNames(Set<String> paramSet);
  
  public abstract void addIndexRequiredPropertyNames(Set<String> paramSet);
  
  public abstract String getSortableProperty();
  
  public abstract int getSortType();
  
  public abstract boolean isIndexed();
  
  public abstract boolean isStored();
  
  public abstract boolean isBeanProperty();
  
  public abstract ElPropertyValue getElBeanProperty();
  
  public abstract void readValue(Document paramDocument, Object paramObject);
  
  public abstract QueryParser createQueryParser();
  
  public abstract int getPropertyOrder();
}
