package com.avaje.ebeaninternal.server.lucene;

import com.avaje.ebean.Query.UseIndex;
import com.avaje.ebean.config.lucene.IndexDefn;
import com.avaje.ebeaninternal.api.SpiEbeanServer;
import com.avaje.ebeaninternal.api.SpiTransaction;
import com.avaje.ebeaninternal.server.cluster.LuceneClusterIndexSync;
import com.avaje.ebeaninternal.server.deploy.BeanDescriptor;
import com.avaje.ebeaninternal.server.transaction.IndexEvent;
import com.avaje.ebeaninternal.server.transaction.RemoteTransactionEvent;
import java.io.IOException;

public abstract interface LuceneIndexManager
{
  public abstract void start();
  
  public abstract void shutdown();
  
  public abstract boolean isLuceneAvailable();
  
  public abstract LuceneClusterIndexSync getClusterIndexSync();
  
  public abstract void processEvent(RemoteTransactionEvent paramRemoteTransactionEvent, SpiTransaction paramSpiTransaction);
  
  public abstract void processEvent(IndexEvent paramIndexEvent);
  
  public abstract Query.UseIndex getDefaultUseIndex();
  
  public abstract LIndex create(IndexDefn<?> paramIndexDefn, BeanDescriptor<?> paramBeanDescriptor)
    throws IOException;
  
  public abstract LIndex getIndex(String paramString);
  
  public abstract SpiEbeanServer getServer();
  
  public abstract void setServer(SpiEbeanServer paramSpiEbeanServer);
  
  public abstract void addIndex(LIndex paramLIndex)
    throws IOException;
  
  public abstract String getIndexDirectory(String paramString);
  
  public abstract void notifyCluster(IndexEvent paramIndexEvent);
}
