package net.minecraft.server.v1_7_R1;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.regex.Pattern;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class BanEntry
{
  private static final Logger b = ;
  

  public static final SimpleDateFormat a = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss Z");
  
  private final String c;
  
  private Date d = new Date();
  private String e = "(Unknown)";
  private Date f;
  private String g = "Banned by an operator.";
  
  public BanEntry(String paramString) {
    c = paramString;
  }
  
  public String getName() {
    return c;
  }
  
  public Date getCreated() {
    return d;
  }
  
  public void setCreated(Date paramDate) {
    d = (paramDate != null ? paramDate : new Date());
  }
  
  public String getSource() {
    return e;
  }
  
  public void setSource(String paramString) {
    e = paramString;
  }
  
  public Date getExpires() {
    return f;
  }
  
  public void setExpires(Date paramDate) {
    f = paramDate;
  }
  
  public boolean hasExpired() {
    if (f == null) return false;
    return f.before(new Date());
  }
  
  public String getReason() {
    return g;
  }
  
  public void setReason(String paramString) {
    g = paramString;
  }
  
  public String g() {
    StringBuilder localStringBuilder = new StringBuilder();
    
    localStringBuilder.append(getName());
    localStringBuilder.append("|");
    
    localStringBuilder.append(a.format(getCreated()));
    localStringBuilder.append("|");
    
    localStringBuilder.append(getSource());
    localStringBuilder.append("|");
    
    localStringBuilder.append(getExpires() == null ? "Forever" : a.format(getExpires()));
    localStringBuilder.append("|");
    
    localStringBuilder.append(getReason());
    
    return localStringBuilder.toString();
  }
  
  public static BanEntry c(String paramString) {
    if (paramString.trim().length() < 2) { return null;
    }
    String[] arrayOfString = paramString.trim().split(Pattern.quote("|"), 5);
    BanEntry localBanEntry = new BanEntry(arrayOfString[0].trim());
    int i = 0;
    
    if (arrayOfString.length <= ++i) return localBanEntry;
    try {
      localBanEntry.setCreated(a.parse(arrayOfString[i].trim()));
    } catch (ParseException localParseException1) {
      b.warn("Could not read creation date format for ban entry '" + localBanEntry.getName() + "' (was: '" + arrayOfString[i] + "')", localParseException1);
    }
    
    if (arrayOfString.length <= ++i) return localBanEntry;
    localBanEntry.setSource(arrayOfString[i].trim());
    
    if (arrayOfString.length <= ++i) return localBanEntry;
    try {
      String str = arrayOfString[i].trim();
      if ((!str.equalsIgnoreCase("Forever")) && (str.length() > 0)) {
        localBanEntry.setExpires(a.parse(str));
      }
    } catch (ParseException localParseException2) {
      b.warn("Could not read expiry date format for ban entry '" + localBanEntry.getName() + "' (was: '" + arrayOfString[i] + "')", localParseException2);
    }
    
    if (arrayOfString.length <= ++i) return localBanEntry;
    localBanEntry.setReason(arrayOfString[i].trim());
    
    return localBanEntry;
  }
}
