package net.minecraft.server.v1_7_R1;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import org.apache.logging.log4j.Logger;

public class BanList
{
  private static final Logger a = ;
  private final InsensitiveStringMap b = new InsensitiveStringMap();
  private final File c;
  private boolean d = true;
  
  public BanList(File paramFile) {
    c = paramFile;
  }
  



  public boolean isEnabled()
  {
    return d;
  }
  
  public void setEnabled(boolean paramBoolean) {
    d = paramBoolean;
  }
  
  public java.util.Map getEntries() {
    removeExpired();
    return b;
  }
  
  public boolean isBanned(String paramString) {
    if (!isEnabled()) { return false;
    }
    removeExpired();
    return b.containsKey(paramString);
  }
  
  public void add(BanEntry paramBanEntry) {
    b.put(paramBanEntry.getName(), paramBanEntry);
    save();
  }
  
  public void remove(String paramString) {
    b.remove(paramString);
    save();
  }
  



  public void removeExpired()
  {
    Iterator localIterator = b.values().iterator();
    
    while (localIterator.hasNext()) {
      BanEntry localBanEntry = (BanEntry)localIterator.next();
      
      if (localBanEntry.hasExpired()) {
        localIterator.remove();
      }
    }
  }
  
  public void load() {
    if (!c.isFile())
      return;
    BufferedReader localBufferedReader;
    try {
      localBufferedReader = new BufferedReader(new java.io.FileReader(c));
    } catch (FileNotFoundException localFileNotFoundException) {
      throw new Error();
    }
    
    try
    {
      String str;
      while ((str = localBufferedReader.readLine()) != null) {
        if (!str.startsWith("#")) {
          BanEntry localBanEntry = BanEntry.c(str);
          
          if (localBanEntry != null) {
            b.put(localBanEntry.getName(), localBanEntry);
          }
        }
      }
    } catch (IOException localIOException) {
      a.error("Could not load ban list", localIOException);
    }
  }
  
  public void save() {
    save(true);
  }
  
  public void save(boolean paramBoolean) {
    removeExpired();
    try
    {
      PrintWriter localPrintWriter = new PrintWriter(new java.io.FileWriter(c, false));
      
      if (paramBoolean) {
        localPrintWriter.println("# Updated " + new SimpleDateFormat().format(new Date()) + " by Minecraft " + "1.7.2");
        localPrintWriter.println("# victim name | ban date | banned by | banned until | reason");
        localPrintWriter.println();
      }
      
      for (BanEntry localBanEntry : b.values()) {
        localPrintWriter.println(localBanEntry.g());
      }
      
      localPrintWriter.close();
    } catch (IOException localIOException) {
      a.error("Could not save ban list", localIOException);
    }
  }
}
