package net.minecraft.server.v1_7_R1;

import java.util.Arrays;
import java.util.IllegalFormatException;
import java.util.Iterator;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import net.minecraft.util.com.google.common.collect.Iterators;
import net.minecraft.util.com.google.common.collect.Lists;

public class ChatMessage
  extends ChatBaseComponent
{
  private final String d;
  private final Object[] e;
  private final Object f = new Object();
  private long g = -1L;
  
  List b = Lists.newArrayList();
  

  public static final Pattern c = Pattern.compile("%(?:(\\d+)\\$)?([A-Za-z%]|$)");
  
  public ChatMessage(String paramString, Object... paramVarArgs) {
    d = paramString;
    e = paramVarArgs;
    
    for (Object localObject : paramVarArgs) {
      if ((localObject instanceof IChatBaseComponent)) {
        ((IChatBaseComponent)localObject).b().a(b());
      }
    }
  }
  
  synchronized void g()
  {
    synchronized (f) {
      long l = LocaleI18n.a();
      if (l == g) {
        return;
      }
      g = l;
      b.clear();
    }
    try
    {
      b(LocaleI18n.get(d));
    } catch (ChatMessageException localChatMessageException1) {
      b.clear();
      try {
        b(LocaleI18n.b(d));
      } catch (ChatMessageException localChatMessageException2) {
        throw localChatMessageException1;
      }
    }
  }
  
  protected void b(String paramString) {
    int i = 0;
    Matcher localMatcher = c.matcher(paramString);
    
    int j = 0;
    int k = 0;
    try
    {
      while (localMatcher.find(k)) {
        int m = localMatcher.start();
        int n = localMatcher.end();
        

        if (m > k) {
          localObject1 = new ChatComponentText(String.format(paramString.substring(k, m), new Object[0]));
          ((ChatComponentText)localObject1).b().a(b());
          b.add(localObject1);
        }
        
        Object localObject1 = localMatcher.group(2);
        String str = paramString.substring(m, n);
        
        Object localObject2;
        if (("%".equals(localObject1)) && ("%%".equals(str))) {
          localObject2 = new ChatComponentText("%");
          ((ChatComponentText)localObject2).b().a(b());
          b.add(localObject2);
        } else if ("s".equals(localObject1)) {
          localObject2 = localMatcher.group(1);
          int i1 = localObject2 != null ? Integer.parseInt((String)localObject2) - 1 : j++;
          b.add(a(i1));
        } else {
          throw new ChatMessageException(this, "Unsupported format: '" + str + "'");
        }
        
        k = n;
      }
      

      if (k < paramString.length()) {
        ChatComponentText localChatComponentText = new ChatComponentText(String.format(paramString.substring(k), new Object[0]));
        localChatComponentText.b().a(b());
        b.add(localChatComponentText);
      }
    } catch (IllegalFormatException localIllegalFormatException) {
      throw new ChatMessageException(this, localIllegalFormatException);
    }
  }
  
  private IChatBaseComponent a(int paramInt) {
    if (paramInt >= e.length) {
      throw new ChatMessageException(this, paramInt);
    }
    
    Object localObject1 = e[paramInt];
    
    Object localObject2;
    if ((localObject1 instanceof IChatBaseComponent)) {
      localObject2 = (IChatBaseComponent)localObject1;
    } else {
      localObject2 = new ChatComponentText(localObject1.toString());
      ((IChatBaseComponent)localObject2).b().a(b());
    }
    
    return localObject2;
  }
  
  public IChatBaseComponent setChatModifier(ChatModifier paramChatModifier)
  {
    super.setChatModifier(paramChatModifier);
    
    for (Object localObject2 : e) {
      if ((localObject2 instanceof IChatBaseComponent)) {
        ((IChatBaseComponent)localObject2).b().a(b());
      }
    }
    
    if (g > -1L) {
      for (??? = b.iterator(); ((Iterator)???).hasNext();) { IChatBaseComponent localIChatBaseComponent = (IChatBaseComponent)((Iterator)???).next();
        localIChatBaseComponent.b().a(paramChatModifier);
      }
    }
    
    return this;
  }
  
  public Iterator iterator()
  {
    g();
    
    return Iterators.concat(a(b), a(a));
  }
  
  public String e()
  {
    g();
    
    StringBuilder localStringBuilder = new StringBuilder();
    
    for (IChatBaseComponent localIChatBaseComponent : b) {
      localStringBuilder.append(localIChatBaseComponent.e());
    }
    
    return localStringBuilder.toString();
  }
  
  public ChatMessage h()
  {
    Object[] arrayOfObject = new Object[e.length];
    
    for (int i = 0; i < e.length; i++) {
      if ((e[i] instanceof IChatBaseComponent)) {
        arrayOfObject[i] = ((IChatBaseComponent)e[i]).f();
      } else {
        arrayOfObject[i] = e[i];
      }
    }
    
    ChatMessage localChatMessage = new ChatMessage(d, arrayOfObject);
    localChatMessage.setChatModifier(b().clone());
    for (IChatBaseComponent localIChatBaseComponent : a()) {
      localChatMessage.a(localIChatBaseComponent.f());
    }
    return localChatMessage;
  }
  
  public boolean equals(Object paramObject)
  {
    if (this == paramObject) { return true;
    }
    if ((paramObject instanceof ChatMessage)) {
      ChatMessage localChatMessage = (ChatMessage)paramObject;
      return (Arrays.equals(e, e)) && (d.equals(d)) && (super.equals(paramObject));
    }
    
    return false;
  }
  
  public int hashCode()
  {
    int i = super.hashCode();
    i = 31 * i + d.hashCode();
    i = 31 * i + Arrays.hashCode(e);
    return i;
  }
  
  public String toString()
  {
    return "TranslatableComponent{key='" + d + '\'' + ", args=" + Arrays.toString(e) + ", siblings=" + a + ", style=" + b() + '}';
  }
  




  public String i()
  {
    return d;
  }
  
  public Object[] j() {
    return e;
  }
}
