package net.minecraft.server.v1_7_R1;


public class ChunkCache
  implements IBlockAccess
{
  private int a;
  
  private int b;
  
  private Chunk[][] c;
  
  private boolean d;
  
  private World e;
  
  public ChunkCache(World paramWorld, int paramInt1, int paramInt2, int paramInt3, int paramInt4, int paramInt5, int paramInt6, int paramInt7)
  {
    e = paramWorld;
    
    a = (paramInt1 - paramInt7 >> 4);
    b = (paramInt3 - paramInt7 >> 4);
    int i = paramInt4 + paramInt7 >> 4;
    int j = paramInt6 + paramInt7 >> 4;
    
    c = new Chunk[i - a + 1][j - b + 1];
    
    d = true;
    int m; Chunk localChunk; for (int k = a; k <= i; k++) {
      for (m = b; m <= j; m++) {
        localChunk = paramWorld.getChunkAt(k, m);
        if (localChunk != null) {
          c[(k - a)][(m - b)] = localChunk;
        }
      }
    }
    for (k = paramInt1 >> 4; k <= paramInt4 >> 4; k++) {
      for (m = paramInt3 >> 4; m <= paramInt6 >> 4; m++) {
        localChunk = c[(k - a)][(m - b)];
        if ((localChunk != null) && 
          (!localChunk.c(paramInt2, paramInt5))) {
          d = false;
        }
      }
    }
  }
  






  public Block getType(int paramInt1, int paramInt2, int paramInt3)
  {
    Block localBlock = Blocks.AIR;
    if ((paramInt2 >= 0) && 
      (paramInt2 < 256))
    {
      int i = (paramInt1 >> 4) - a;
      int j = (paramInt3 >> 4) - b;
      
      if ((i >= 0) && (i < c.length) && (j >= 0) && (j < c[i].length))
      {
        Chunk localChunk = c[i][j];
        if (localChunk != null) {
          localBlock = localChunk.getType(paramInt1 & 0xF, paramInt2, paramInt3 & 0xF);
        }
      }
    }
    
    return localBlock;
  }
  
  public TileEntity getTileEntity(int paramInt1, int paramInt2, int paramInt3)
  {
    int i = (paramInt1 >> 4) - a;
    int j = (paramInt3 >> 4) - b;
    
    return c[i][j].e(paramInt1 & 0xF, paramInt2, paramInt3 & 0xF);
  }
  


























































  public int getData(int paramInt1, int paramInt2, int paramInt3)
  {
    if (paramInt2 < 0) return 0;
    if (paramInt2 >= 256) return 0;
    int i = (paramInt1 >> 4) - a;
    int j = (paramInt3 >> 4) - b;
    
    return c[i][j].getData(paramInt1 & 0xF, paramInt2, paramInt3 & 0xF);
  }
  










  public Vec3DPool getVec3DPool()
  {
    return e.getVec3DPool();
  }
  




















































  public int getBlockPower(int paramInt1, int paramInt2, int paramInt3, int paramInt4)
  {
    return getType(paramInt1, paramInt2, paramInt3).c(this, paramInt1, paramInt2, paramInt3, paramInt4);
  }
}
