package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;












public class ChunkProviderFlat
  implements IChunkProvider
{
  private World a;
  private Random b;
  private final Block[] c = new Block[256];
  private final byte[] d = new byte[256];
  private final WorldGenFlatInfo e;
  private final List f = new ArrayList();
  private final boolean g;
  private final boolean h;
  private WorldGenLakes i;
  private WorldGenLakes j;
  
  public ChunkProviderFlat(World paramWorld, long paramLong, boolean paramBoolean, String paramString) {
    a = paramWorld;
    b = new Random(paramLong);
    e = WorldGenFlatInfo.a(paramString);
    Object localObject2;
    if (paramBoolean) {
      localObject1 = e.b();
      
      if (((Map)localObject1).containsKey("village")) {
        localObject2 = (Map)((Map)localObject1).get("village");
        if (!((Map)localObject2).containsKey("size")) ((Map)localObject2).put("size", "1");
        f.add(new WorldGenVillage((Map)localObject2));
      }
      
      if (((Map)localObject1).containsKey("biome_1")) f.add(new WorldGenLargeFeature((Map)((Map)localObject1).get("biome_1")));
      if (((Map)localObject1).containsKey("mineshaft")) f.add(new WorldGenMineshaft((Map)((Map)localObject1).get("mineshaft")));
      if (((Map)localObject1).containsKey("stronghold")) { f.add(new WorldGenStronghold((Map)((Map)localObject1).get("stronghold")));
      }
    }
    g = e.b().containsKey("decoration");
    if (e.b().containsKey("lake")) i = new WorldGenLakes(Blocks.STATIONARY_WATER);
    if (e.b().containsKey("lava_lake")) j = new WorldGenLakes(Blocks.STATIONARY_LAVA);
    h = e.b().containsKey("dungeon");
    
    for (Object localObject1 = e.c().iterator(); ((Iterator)localObject1).hasNext();) { localObject2 = (WorldGenFlatLayerInfo)((Iterator)localObject1).next();
      for (int k = ((WorldGenFlatLayerInfo)localObject2).d(); k < ((WorldGenFlatLayerInfo)localObject2).d() + ((WorldGenFlatLayerInfo)localObject2).a(); k++) {
        c[k] = ((WorldGenFlatLayerInfo)localObject2).b();
        d[k] = ((byte)((WorldGenFlatLayerInfo)localObject2).c());
      }
    }
  }
  

  public Chunk getChunkAt(int paramInt1, int paramInt2)
  {
    return getOrCreateChunk(paramInt1, paramInt2);
  }
  

  public Chunk getOrCreateChunk(int paramInt1, int paramInt2)
  {
    Chunk localChunk = new Chunk(a, paramInt1, paramInt2);
    Object localObject2;
    for (int k = 0; k < c.length; k++) {
      localObject1 = c[k];
      if (localObject1 != null) {
        m = k >> 4;
        localObject2 = localChunk.i()[m];
        
        if (localObject2 == null) {
          localObject2 = new ChunkSection(k, !a.worldProvider.g);
          localChunk.i()[m] = localObject2;
        }
        
        for (int n = 0; n < 16; n++) {
          for (int i1 = 0; i1 < 16; i1++) {
            ((ChunkSection)localObject2).setTypeId(n, k & 0xF, i1, (Block)localObject1);
            ((ChunkSection)localObject2).setData(n, k & 0xF, i1, d[k]);
          }
        }
      }
    }
    localChunk.initLighting();
    
    BiomeBase[] arrayOfBiomeBase = a.getWorldChunkManager().getBiomeBlock(null, paramInt1 * 16, paramInt2 * 16, 16, 16);
    Object localObject1 = localChunk.m();
    
    for (int m = 0; m < localObject1.length; m++) {
      localObject1[m] = ((byte)id);
    }
    
    for (Iterator localIterator = f.iterator(); localIterator.hasNext();) { localObject2 = (StructureGenerator)localIterator.next();
      ((WorldGenBase)localObject2).a(this, a, paramInt1, paramInt2, null);
    }
    
    localChunk.initLighting();
    
    return localChunk;
  }
  
  public boolean isChunkLoaded(int paramInt1, int paramInt2)
  {
    return true;
  }
  
  public void getChunkAt(IChunkProvider paramIChunkProvider, int paramInt1, int paramInt2)
  {
    int k = paramInt1 * 16;
    int m = paramInt2 * 16;
    BiomeBase localBiomeBase = a.getBiome(k + 16, m + 16);
    boolean bool1 = false;
    
    b.setSeed(a.getSeed());
    long l1 = b.nextLong() / 2L * 2L + 1L;
    long l2 = b.nextLong() / 2L * 2L + 1L;
    b.setSeed(paramInt1 * l1 + paramInt2 * l2 ^ a.getSeed());
    
    for (StructureGenerator localStructureGenerator : f) {
      boolean bool2 = localStructureGenerator.a(a, b, paramInt1, paramInt2);
      if ((localStructureGenerator instanceof WorldGenVillage)) bool1 |= bool2; }
    int n;
    int i1;
    int i2; if ((i != null) && (!bool1) && (b.nextInt(4) == 0)) {
      n = k + b.nextInt(16) + 8;
      i1 = b.nextInt(256);
      i2 = m + b.nextInt(16) + 8;
      i.a(a, b, n, i1, i2);
    }
    
    if ((j != null) && (!bool1) && (b.nextInt(8) == 0)) {
      n = k + b.nextInt(16) + 8;
      i1 = b.nextInt(b.nextInt(248) + 8);
      i2 = m + b.nextInt(16) + 8;
      if ((i1 < 63) || (b.nextInt(10) == 0)) {
        j.a(a, b, n, i1, i2);
      }
    }
    
    if (h) {
      for (n = 0; n < 8; n++) {
        i1 = k + b.nextInt(16) + 8;
        i2 = b.nextInt(256);
        int i3 = m + b.nextInt(16) + 8;
        new WorldGenDungeons().a(a, b, i1, i2, i3);
      }
    }
    
    if (g) {
      localBiomeBase.a(a, b, k, m);
    }
  }
  
  public boolean saveChunks(boolean paramBoolean, IProgressUpdate paramIProgressUpdate)
  {
    return true;
  }
  

  public void b() {}
  

  public boolean unloadChunks()
  {
    return false;
  }
  
  public boolean canSave()
  {
    return true;
  }
  

  public String getName()
  {
    return "FlatLevelSource";
  }
  
  public List getMobsFor(EnumCreatureType paramEnumCreatureType, int paramInt1, int paramInt2, int paramInt3)
  {
    BiomeBase localBiomeBase = a.getBiome(paramInt1, paramInt3);
    return localBiomeBase.getMobs(paramEnumCreatureType);
  }
  
  public ChunkPosition findNearestMapFeature(World paramWorld, String paramString, int paramInt1, int paramInt2, int paramInt3)
  {
    if ("Stronghold".equals(paramString)) {
      for (StructureGenerator localStructureGenerator : f) {
        if ((localStructureGenerator instanceof WorldGenStronghold)) {
          return localStructureGenerator.getNearestGeneratedFeature(paramWorld, paramInt1, paramInt2, paramInt3);
        }
      }
    }
    return null;
  }
  
  public int getLoadedChunks()
  {
    return 0;
  }
  
  public void recreateStructures(int paramInt1, int paramInt2)
  {
    for (StructureGenerator localStructureGenerator : f) {
      localStructureGenerator.a(this, a, paramInt1, paramInt2, null);
    }
  }
}
