package net.minecraft.server.v1_7_R1;









public class DamageSource
{
  public static DamageSource FIRE = new DamageSource("inFire").n();
  public static DamageSource BURN = new DamageSource("onFire").k().n();
  public static DamageSource LAVA = new DamageSource("lava").n();
  public static DamageSource STUCK = new DamageSource("inWall").k();
  public static DamageSource DROWN = new DamageSource("drown").k();
  public static DamageSource STARVE = new DamageSource("starve").k().m();
  public static DamageSource CACTUS = new DamageSource("cactus");
  public static DamageSource FALL = new DamageSource("fall").k();
  public static DamageSource OUT_OF_WORLD = new DamageSource("outOfWorld").k().l();
  public static DamageSource GENERIC = new DamageSource("generic").k();
  public static DamageSource MAGIC = new DamageSource("magic").k().t();
  public static DamageSource WITHER = new DamageSource("wither").k();
  public static DamageSource ANVIL = new DamageSource("anvil");
  public static DamageSource FALLING_BLOCK = new DamageSource("fallingBlock");
  private boolean p;
  
  public static DamageSource mobAttack(EntityLiving paramEntityLiving) { return new EntityDamageSource("mob", paramEntityLiving); }
  
  public static DamageSource playerAttack(EntityHuman paramEntityHuman)
  {
    return new EntityDamageSource("player", paramEntityHuman);
  }
  
  public static DamageSource arrow(EntityArrow paramEntityArrow, Entity paramEntity) {
    return new EntityDamageSourceIndirect("arrow", paramEntityArrow, paramEntity).b();
  }
  
  public static DamageSource fireball(EntityFireball paramEntityFireball, Entity paramEntity) {
    if (paramEntity == null) {
      return new EntityDamageSourceIndirect("onFire", paramEntityFireball, paramEntityFireball).n().b();
    }
    return new EntityDamageSourceIndirect("fireball", paramEntityFireball, paramEntity).n().b();
  }
  
  public static DamageSource projectile(Entity paramEntity1, Entity paramEntity2) {
    return new EntityDamageSourceIndirect("thrown", paramEntity1, paramEntity2).b();
  }
  
  public static DamageSource b(Entity paramEntity1, Entity paramEntity2) {
    return new EntityDamageSourceIndirect("indirectMagic", paramEntity1, paramEntity2).k().t();
  }
  
  public static DamageSource a(Entity paramEntity) {
    return new EntityDamageSource("thorns", paramEntity).t();
  }
  
  public static DamageSource explosion(Explosion paramExplosion) {
    if ((paramExplosion != null) && (paramExplosion.c() != null)) {
      return new EntityDamageSource("explosion.player", paramExplosion.c()).q().d();
    }
    return new DamageSource("explosion").q().d();
  }
  

  private boolean q;
  
  private boolean r;
  
  private float s = 0.3F;
  private boolean t;
  private boolean u;
  private boolean v;
  private boolean w;
  private boolean x;
  public String translationIndex;
  
  public boolean a() { return u; }
  
  public DamageSource b()
  {
    u = true;
    return this;
  }
  
  public boolean c() {
    return x;
  }
  
  public DamageSource d() {
    x = true;
    return this;
  }
  
  public boolean ignoresArmor() {
    return p;
  }
  
  public float f() {
    return s;
  }
  
  public boolean ignoresInvulnerability() {
    return q;
  }
  
  public boolean h() {
    return r;
  }
  

  protected DamageSource(String paramString)
  {
    translationIndex = paramString;
  }
  
  public Entity i() {
    return getEntity();
  }
  
  public Entity getEntity() {
    return null;
  }
  
  protected DamageSource k() {
    p = true;
    
    s = 0.0F;
    return this;
  }
  
  protected DamageSource l() {
    q = true;
    return this;
  }
  
  protected DamageSource m() {
    r = true;
    
    s = 0.0F;
    return this;
  }
  
  protected DamageSource n() {
    t = true;
    return this;
  }
  
  public IChatBaseComponent getLocalizedDeathMessage(EntityLiving paramEntityLiving) {
    EntityLiving localEntityLiving = paramEntityLiving.aX();
    String str1 = "death.attack." + translationIndex;
    String str2 = str1 + ".player";
    
    if ((localEntityLiving != null) && (LocaleI18n.c(str2))) {
      return new ChatMessage(str2, new Object[] { paramEntityLiving.getScoreboardDisplayName(), localEntityLiving.getScoreboardDisplayName() });
    }
    return new ChatMessage(str1, new Object[] { paramEntityLiving.getScoreboardDisplayName() });
  }
  
  public boolean o()
  {
    return t;
  }
  
  public String p() {
    return translationIndex;
  }
  
  public DamageSource q() {
    v = true;
    return this;
  }
  
  public boolean r() {
    return v;
  }
  
  public boolean s() {
    return w;
  }
  
  public DamageSource t() {
    w = true;
    return this;
  }
}
