package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReadWriteLock;
import java.util.concurrent.locks.ReentrantReadWriteLock;
import net.minecraft.util.org.apache.commons.lang3.ObjectUtils;












public class DataWatcher
{
  private final Entity a;
  private boolean b = true;
  
  private static final HashMap c = new HashMap();
  
  static {
    c.put(Byte.class, Integer.valueOf(0));
    c.put(Short.class, Integer.valueOf(1));
    c.put(Integer.class, Integer.valueOf(2));
    c.put(Float.class, Integer.valueOf(3));
    c.put(String.class, Integer.valueOf(4));
    c.put(ItemStack.class, Integer.valueOf(5));
    c.put(ChunkCoordinates.class, Integer.valueOf(6));
  }
  







  private final Map d = new HashMap();
  private boolean e;
  private ReadWriteLock f = new ReentrantReadWriteLock();
  
  public DataWatcher(Entity paramEntity) {
    a = paramEntity;
  }
  
  public void a(int paramInt, Object paramObject) {
    Integer localInteger = (Integer)c.get(paramObject.getClass());
    if (localInteger == null) {
      throw new IllegalArgumentException("Unknown data type: " + paramObject.getClass());
    }
    if (paramInt > 31) {
      throw new IllegalArgumentException("Data value id is too big with " + paramInt + "! (Max is " + 31 + ")");
    }
    if (d.containsKey(Integer.valueOf(paramInt))) {
      throw new IllegalArgumentException("Duplicate id value for " + paramInt + "!");
    }
    
    WatchableObject localWatchableObject = new WatchableObject(localInteger.intValue(), paramInt, paramObject);
    f.writeLock().lock();
    d.put(Integer.valueOf(paramInt), localWatchableObject);
    f.writeLock().unlock();
    b = false;
  }
  
  public void a(int paramInt1, int paramInt2) {
    WatchableObject localWatchableObject = new WatchableObject(paramInt2, paramInt1, null);
    f.writeLock().lock();
    d.put(Integer.valueOf(paramInt1), localWatchableObject);
    f.writeLock().unlock();
    b = false;
  }
  
  public byte getByte(int paramInt) {
    return ((Byte)i(paramInt).b()).byteValue();
  }
  
  public short getShort(int paramInt) {
    return ((Short)i(paramInt).b()).shortValue();
  }
  
  public int getInt(int paramInt) {
    return ((Integer)i(paramInt).b()).intValue();
  }
  
  public float getFloat(int paramInt) {
    return ((Float)i(paramInt).b()).floatValue();
  }
  
  public String getString(int paramInt) {
    return (String)i(paramInt).b();
  }
  
  public ItemStack getItemStack(int paramInt) {
    return (ItemStack)i(paramInt).b();
  }
  
  private WatchableObject i(int paramInt)
  {
    f.readLock().lock();
    WatchableObject localWatchableObject;
    try {
      localWatchableObject = (WatchableObject)d.get(Integer.valueOf(paramInt));
    } catch (Throwable localThrowable) {
      CrashReport localCrashReport = CrashReport.a(localThrowable, "Getting synched entity data");
      CrashReportSystemDetails localCrashReportSystemDetails = localCrashReport.a("Synched entity data");
      
      localCrashReportSystemDetails.a("Data ID", Integer.valueOf(paramInt));
      throw new ReportedException(localCrashReport);
    }
    
    f.readLock().unlock();
    return localWatchableObject;
  }
  




  public void watch(int paramInt, Object paramObject)
  {
    WatchableObject localWatchableObject = i(paramInt);
    

    if (ObjectUtils.notEqual(paramObject, localWatchableObject.b())) {
      localWatchableObject.a(paramObject);
      a.i(paramInt);
      localWatchableObject.a(true);
      e = true;
    }
  }
  
  public void h(int paramInt) {
    WatchableObject.a(i(paramInt), true);
    e = true;
  }
  
  public boolean a() {
    return e;
  }
  
  public static void a(List paramList, PacketDataSerializer paramPacketDataSerializer) {
    if (paramList != null) {
      for (WatchableObject localWatchableObject : paramList) {
        a(paramPacketDataSerializer, localWatchableObject);
      }
    }
    

    paramPacketDataSerializer.writeByte(127);
  }
  
  public List b() {
    ArrayList localArrayList = null;
    
    if (e) {
      f.readLock().lock();
      for (WatchableObject localWatchableObject : d.values()) {
        if (localWatchableObject.d()) {
          localWatchableObject.a(false);
          
          if (localArrayList == null) {
            localArrayList = new ArrayList();
          }
          localArrayList.add(localWatchableObject);
        }
      }
      f.readLock().unlock();
    }
    e = false;
    
    return localArrayList;
  }
  
  public void a(PacketDataSerializer paramPacketDataSerializer) {
    f.readLock().lock();
    for (WatchableObject localWatchableObject : d.values()) {
      a(paramPacketDataSerializer, localWatchableObject);
    }
    f.readLock().unlock();
    

    paramPacketDataSerializer.writeByte(127);
  }
  
  public List c() {
    ArrayList localArrayList = null;
    
    f.readLock().lock();
    for (WatchableObject localWatchableObject : d.values()) {
      if (localArrayList == null) {
        localArrayList = new ArrayList();
      }
      localArrayList.add(localWatchableObject);
    }
    f.readLock().unlock();
    
    return localArrayList;
  }
  
  private static void a(PacketDataSerializer paramPacketDataSerializer, WatchableObject paramWatchableObject)
  {
    int i = (paramWatchableObject.c() << 5 | paramWatchableObject.a() & 0x1F) & 0xFF;
    paramPacketDataSerializer.writeByte(i);
    
    Object localObject;
    switch (paramWatchableObject.c()) {
    case 0: 
      paramPacketDataSerializer.writeByte(((Byte)paramWatchableObject.b()).byteValue());
      break;
    case 1: 
      paramPacketDataSerializer.writeShort(((Short)paramWatchableObject.b()).shortValue());
      break;
    case 2: 
      paramPacketDataSerializer.writeInt(((Integer)paramWatchableObject.b()).intValue());
      break;
    case 3: 
      paramPacketDataSerializer.writeFloat(((Float)paramWatchableObject.b()).floatValue());
      break;
    case 4: 
      paramPacketDataSerializer.a((String)paramWatchableObject.b());
      break;
    case 5: 
      localObject = (ItemStack)paramWatchableObject.b();
      paramPacketDataSerializer.a((ItemStack)localObject);
      
      break;
    case 6: 
      localObject = (ChunkCoordinates)paramWatchableObject.b();
      paramPacketDataSerializer.writeInt(x);
      paramPacketDataSerializer.writeInt(y);
      paramPacketDataSerializer.writeInt(z);
    }
  }
  
  public static List b(PacketDataSerializer paramPacketDataSerializer)
  {
    ArrayList localArrayList = null;
    
    int i = paramPacketDataSerializer.readByte();
    
    while (i != 127)
    {
      if (localArrayList == null) {
        localArrayList = new ArrayList();
      }
      

      int j = (i & 0xE0) >> 5;
      int k = i & 0x1F;
      
      WatchableObject localWatchableObject = null;
      switch (j) {
      case 0: 
        localWatchableObject = new WatchableObject(j, k, Byte.valueOf(paramPacketDataSerializer.readByte()));
        break;
      case 1: 
        localWatchableObject = new WatchableObject(j, k, Short.valueOf(paramPacketDataSerializer.readShort()));
        break;
      case 2: 
        localWatchableObject = new WatchableObject(j, k, Integer.valueOf(paramPacketDataSerializer.readInt()));
        break;
      case 3: 
        localWatchableObject = new WatchableObject(j, k, Float.valueOf(paramPacketDataSerializer.readFloat()));
        break;
      case 4: 
        localWatchableObject = new WatchableObject(j, k, paramPacketDataSerializer.c(32767));
        break;
      case 5: 
        localWatchableObject = new WatchableObject(j, k, paramPacketDataSerializer.c());
        break;
      case 6: 
        int m = paramPacketDataSerializer.readInt();
        int n = paramPacketDataSerializer.readInt();
        int i1 = paramPacketDataSerializer.readInt();
        localWatchableObject = new WatchableObject(j, k, new ChunkCoordinates(m, n, i1));
      }
      
      localArrayList.add(localWatchableObject);
      
      i = paramPacketDataSerializer.readByte();
    }
    
    return localArrayList;
  }
  



















  public boolean d()
  {
    return b;
  }
  
  public void e() {
    e = false;
  }
}
