package net.minecraft.server.v1_7_R1;

import java.io.BufferedReader;
import java.io.PrintWriter;
import java.util.Set;
import org.apache.logging.log4j.Logger;

public class DedicatedPlayerList extends PlayerList
{
  private static final Logger d = ;
  private java.io.File e;
  private java.io.File f;
  
  public DedicatedPlayerList(DedicatedServer paramDedicatedServer) { super(paramDedicatedServer);
    
    e = paramDedicatedServer.d("ops.txt");
    f = paramDedicatedServer.d("white-list.txt");
    c = paramDedicatedServer.a("view-distance", 10);
    maxPlayers = paramDedicatedServer.a("max-players", 20);
    setHasWhitelist(paramDedicatedServer.a("white-list", false));
    
    if (!paramDedicatedServer.L()) {
      getNameBans().setEnabled(true);
      getIPBans().setEnabled(true);
    }
    
    getNameBans().load();
    getNameBans().save();
    getIPBans().load();
    getIPBans().save();
    t();
    v();
    u();
    if (!f.exists()) {
      w();
    }
  }
  
  public void setHasWhitelist(boolean paramBoolean)
  {
    super.setHasWhitelist(paramBoolean);
    getServer().a("white-list", Boolean.valueOf(paramBoolean));
    getServer().a();
  }
  
  public void addOp(String paramString)
  {
    super.addOp(paramString);
    u();
  }
  
  public void removeOp(String paramString)
  {
    super.removeOp(paramString);
    u();
  }
  
  public void removeWhitelist(String paramString)
  {
    super.removeWhitelist(paramString);
    w();
  }
  
  public void addWhitelist(String paramString)
  {
    super.addWhitelist(paramString);
    w();
  }
  
  public void reloadWhitelist()
  {
    v();
  }
  
  private void t() {
    try {
      getOPs().clear();
      BufferedReader localBufferedReader = new BufferedReader(new java.io.FileReader(e));
      String str = "";
      while ((str = localBufferedReader.readLine()) != null) {
        getOPs().add(str.trim().toLowerCase());
      }
      localBufferedReader.close();
    } catch (Exception localException) {
      d.warn("Failed to load operators list: " + localException);
    }
  }
  
  private void u() {
    try {
      PrintWriter localPrintWriter = new PrintWriter(new java.io.FileWriter(e, false));
      for (String str : getOPs()) {
        localPrintWriter.println(str);
      }
      localPrintWriter.close();
    } catch (Exception localException) {
      d.warn("Failed to save operators list: " + localException);
    }
  }
  
  private void v() {
    try {
      getWhitelisted().clear();
      BufferedReader localBufferedReader = new BufferedReader(new java.io.FileReader(f));
      String str = "";
      while ((str = localBufferedReader.readLine()) != null) {
        getWhitelisted().add(str.trim().toLowerCase());
      }
      localBufferedReader.close();
    } catch (Exception localException) {
      d.warn("Failed to load white-list: " + localException);
    }
  }
  
  private void w() {
    try {
      PrintWriter localPrintWriter = new PrintWriter(new java.io.FileWriter(f, false));
      for (String str : getWhitelisted()) {
        localPrintWriter.println(str);
      }
      localPrintWriter.close();
    } catch (Exception localException) {
      d.warn("Failed to save white-list: " + localException);
    }
  }
  
  public boolean isWhitelisted(String paramString)
  {
    paramString = paramString.trim().toLowerCase();
    return (!getHasWhitelist()) || (isOp(paramString)) || (getWhitelisted().contains(paramString));
  }
  
  public DedicatedServer getServer()
  {
    return (DedicatedServer)super.getServer();
  }
}
