package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;

public class EnchantmentManager
{
  private static final Random random = new Random();
  
  public static int getEnchantmentLevel(int paramInt, ItemStack paramItemStack) {
    if (paramItemStack == null) {
      return 0;
    }
    NBTTagList localNBTTagList = paramItemStack.getEnchantments();
    if (localNBTTagList == null) {
      return 0;
    }
    for (int i = 0; i < localNBTTagList.size(); i++) {
      int j = localNBTTagList.get(i).getShort("id");
      int k = localNBTTagList.get(i).getShort("lvl");
      
      if (j == paramInt) {
        return k;
      }
    }
    return 0;
  }
  
  public static Map a(ItemStack paramItemStack) {
    LinkedHashMap localLinkedHashMap = new LinkedHashMap();
    NBTTagList localNBTTagList = paramItemStack.getItem() == Items.ENCHANTED_BOOK ? Items.ENCHANTED_BOOK.g(paramItemStack) : paramItemStack.getEnchantments();
    
    if (localNBTTagList != null) {
      for (int i = 0; i < localNBTTagList.size(); i++) {
        int j = localNBTTagList.get(i).getShort("id");
        int k = localNBTTagList.get(i).getShort("lvl");
        
        localLinkedHashMap.put(Integer.valueOf(j), Integer.valueOf(k));
      }
    }
    
    return localLinkedHashMap;
  }
  
  public static void a(Map paramMap, ItemStack paramItemStack) {
    NBTTagList localNBTTagList = new NBTTagList();
    
    for (Iterator localIterator = paramMap.keySet().iterator(); localIterator.hasNext();) { int i = ((Integer)localIterator.next()).intValue();
      NBTTagCompound localNBTTagCompound = new NBTTagCompound();
      
      localNBTTagCompound.setShort("id", (short)i);
      localNBTTagCompound.setShort("lvl", (short)((Integer)paramMap.get(Integer.valueOf(i))).intValue());
      
      localNBTTagList.add(localNBTTagCompound);
      
      if (paramItemStack.getItem() == Items.ENCHANTED_BOOK) {
        Items.ENCHANTED_BOOK.a(paramItemStack, new EnchantmentInstance(i, ((Integer)paramMap.get(Integer.valueOf(i))).intValue()));
      }
    }
    
    if (localNBTTagList.size() > 0) {
      if (paramItemStack.getItem() != Items.ENCHANTED_BOOK) {
        paramItemStack.a("ench", localNBTTagList);
      }
    } else if (paramItemStack.hasTag()) {
      paramItemStack.getTag().remove("ench");
    }
  }
  
  public static int getEnchantmentLevel(int paramInt, ItemStack[] paramArrayOfItemStack) {
    if (paramArrayOfItemStack == null) return 0;
    int i = 0;
    for (ItemStack localItemStack : paramArrayOfItemStack) {
      int m = getEnchantmentLevel(paramInt, localItemStack);
      if (m > i) {
        i = m;
      }
    }
    return i;
  }
  



  private static void a(EnchantmentModifier paramEnchantmentModifier, ItemStack paramItemStack)
  {
    if (paramItemStack == null) {
      return;
    }
    NBTTagList localNBTTagList = paramItemStack.getEnchantments();
    if (localNBTTagList == null) {
      return;
    }
    for (int i = 0; i < localNBTTagList.size(); i++) {
      int j = localNBTTagList.get(i).getShort("id");
      int k = localNBTTagList.get(i).getShort("lvl");
      
      if (Enchantment.byId[j] != null) {
        paramEnchantmentModifier.a(Enchantment.byId[j], k);
      }
    }
  }
  
  private static void a(EnchantmentModifier paramEnchantmentModifier, ItemStack[] paramArrayOfItemStack) {
    for (ItemStack localItemStack : paramArrayOfItemStack) {
      a(paramEnchantmentModifier, localItemStack);
    }
  }
  










  private static final EnchantmentModifierProtection b = new EnchantmentModifierProtection(null);
  






  public static int a(ItemStack[] paramArrayOfItemStack, DamageSource paramDamageSource)
  {
    ba = 0;
    bb = paramDamageSource;
    
    a(b, paramArrayOfItemStack);
    
    if (ba > 25) {
      ba = 25;
    }
    

    return (ba + 1 >> 1) + random.nextInt((ba >> 1) + 1);
  }
  










  private static final EnchantmentModifierDamage c = new EnchantmentModifierDamage(null);
  
  public static float a(EntityLiving paramEntityLiving1, EntityLiving paramEntityLiving2) {
    ca = 0.0F;
    cb = paramEntityLiving2;
    
    a(c, paramEntityLiving1.be());
    
    return ca;
  }
  










  private static final EnchantmentModifierThorns d = new EnchantmentModifierThorns(null);
  
  public static void a(EntityLiving paramEntityLiving, Entity paramEntity) {
    db = paramEntity;
    da = paramEntityLiving;
    a(d, paramEntityLiving.getEquipment());
    if ((paramEntity instanceof EntityHuman)) { a(d, paramEntityLiving.be());
    }
  }
  









  private static final EnchantmentModifierArthropods e = new EnchantmentModifierArthropods(null);
  
  public static void b(EntityLiving paramEntityLiving, Entity paramEntity) {
    ea = paramEntityLiving;
    eb = paramEntity;
    a(e, paramEntityLiving.getEquipment());
    if ((paramEntityLiving instanceof EntityHuman)) a(e, paramEntityLiving.be());
  }
  
  public static int getKnockbackEnchantmentLevel(EntityLiving paramEntityLiving1, EntityLiving paramEntityLiving2) {
    return getEnchantmentLevel(KNOCKBACKid, paramEntityLiving1.be());
  }
  
  public static int getFireAspectEnchantmentLevel(EntityLiving paramEntityLiving) {
    return getEnchantmentLevel(FIRE_ASPECTid, paramEntityLiving.be());
  }
  
  public static int getOxygenEnchantmentLevel(EntityLiving paramEntityLiving) {
    return getEnchantmentLevel(OXYGENid, paramEntityLiving.getEquipment());
  }
  
  public static int getDigSpeedEnchantmentLevel(EntityLiving paramEntityLiving) {
    return getEnchantmentLevel(DIG_SPEEDid, paramEntityLiving.be());
  }
  



  public static boolean hasSilkTouchEnchantment(EntityLiving paramEntityLiving)
  {
    return getEnchantmentLevel(SILK_TOUCHid, paramEntityLiving.be()) > 0;
  }
  
  public static int getBonusBlockLootEnchantmentLevel(EntityLiving paramEntityLiving) {
    return getEnchantmentLevel(LOOT_BONUS_BLOCKSid, paramEntityLiving.be());
  }
  
  public static int getLuckEnchantmentLevel(EntityLiving paramEntityLiving) {
    return getEnchantmentLevel(LUCKid, paramEntityLiving.be());
  }
  
  public static int getLureEnchantmentLevel(EntityLiving paramEntityLiving) {
    return getEnchantmentLevel(LUREid, paramEntityLiving.be());
  }
  
  public static int getBonusMonsterLootEnchantmentLevel(EntityLiving paramEntityLiving) {
    return getEnchantmentLevel(LOOT_BONUS_MOBSid, paramEntityLiving.be());
  }
  
  public static boolean hasWaterWorkerEnchantment(EntityLiving paramEntityLiving) {
    return getEnchantmentLevel(WATER_WORKERid, paramEntityLiving.getEquipment()) > 0;
  }
  



  public static ItemStack a(Enchantment paramEnchantment, EntityLiving paramEntityLiving)
  {
    for (ItemStack localItemStack : paramEntityLiving.getEquipment()) {
      if ((localItemStack != null) && (getEnchantmentLevel(id, localItemStack) > 0)) {
        return localItemStack;
      }
    }
    
    return null;
  }
  










  public static int a(Random paramRandom, int paramInt1, int paramInt2, ItemStack paramItemStack)
  {
    Item localItem = paramItemStack.getItem();
    int i = localItem.c();
    
    if (i <= 0)
    {
      return 0;
    }
    
    if (paramInt2 > 15) {
      paramInt2 = 15;
    }
    int j = paramRandom.nextInt(8) + 1 + (paramInt2 >> 1) + paramRandom.nextInt(paramInt2 + 1);
    if (paramInt1 == 0) {
      return Math.max(j / 3, 1);
    }
    if (paramInt1 == 1) {
      return j * 2 / 3 + 1;
    }
    return Math.max(j, paramInt2 * 2);
  }
  
  public static ItemStack a(Random paramRandom, ItemStack paramItemStack, int paramInt) {
    List localList = b(paramRandom, paramItemStack, paramInt);
    int i = paramItemStack.getItem() == Items.BOOK ? 1 : 0;
    
    if (i != 0) { paramItemStack.setItem(Items.ENCHANTED_BOOK);
    }
    if (localList != null) {
      for (EnchantmentInstance localEnchantmentInstance : localList) {
        if (i != 0) {
          Items.ENCHANTED_BOOK.a(paramItemStack, localEnchantmentInstance);
        } else {
          paramItemStack.addEnchantment(enchantment, level);
        }
      }
    }
    
    return paramItemStack;
  }
  






  public static List b(Random paramRandom, ItemStack paramItemStack, int paramInt)
  {
    Item localItem = paramItemStack.getItem();
    int i = localItem.c();
    
    if (i <= 0) {
      return null;
    }
    i /= 2;
    i = 1 + paramRandom.nextInt((i >> 1) + 1) + paramRandom.nextInt((i >> 1) + 1);
    
    int j = i + paramInt;
    

    float f = (paramRandom.nextFloat() + paramRandom.nextFloat() - 1.0F) * 0.15F;
    int k = (int)(j * (1.0F + f) + 0.5F);
    if (k < 1) {
      k = 1;
    }
    
    ArrayList localArrayList = null;
    
    Map localMap = b(k, paramItemStack);
    if ((localMap != null) && (!localMap.isEmpty()))
    {
      EnchantmentInstance localEnchantmentInstance1 = (EnchantmentInstance)WeightedRandom.a(paramRandom, localMap.values());
      
      if (localEnchantmentInstance1 != null) {
        localArrayList = new ArrayList();
        localArrayList.add(localEnchantmentInstance1);
        
        int m = k;
        while (paramRandom.nextInt(50) <= m)
        {

          Iterator localIterator1 = localMap.keySet().iterator();
          Object localObject; while (localIterator1.hasNext()) {
            localObject = (Integer)localIterator1.next();
            int n = 1;
            for (EnchantmentInstance localEnchantmentInstance2 : localArrayList) {
              if (!enchantment.a(Enchantment.byId[localObject.intValue()])) {
                n = 0;
                break;
              }
            }
            if (n == 0) {
              localIterator1.remove();
            }
          }
          
          if (!localMap.isEmpty()) {
            localObject = (EnchantmentInstance)WeightedRandom.a(paramRandom, localMap.values());
            localArrayList.add(localObject);
          }
          
          m >>= 1;
        }
      }
    }
    
    return localArrayList;
  }
  
  public static Map b(int paramInt, ItemStack paramItemStack) {
    Item localItem = paramItemStack.getItem();
    HashMap localHashMap = null;
    int i = paramItemStack.getItem() == Items.BOOK ? 1 : 0;
    
    for (Enchantment localEnchantment : Enchantment.byId) {
      if (localEnchantment != null)
      {



        if ((slot.canEnchant(localItem)) || (i != 0))
        {


          for (int m = localEnchantment.getStartLevel(); m <= localEnchantment.getMaxLevel(); m++)
            if ((paramInt >= localEnchantment.a(m)) && (paramInt <= localEnchantment.b(m)))
            {
              if (localHashMap == null) {
                localHashMap = new HashMap();
              }
              
              localHashMap.put(Integer.valueOf(id), new EnchantmentInstance(localEnchantment, m));
            }
        }
      }
    }
    return localHashMap;
  }
}
