package net.minecraft.server.v1_7_R1;

import java.util.Random;








public abstract class EntityTameableAnimal
  extends EntityAnimal
  implements EntityOwnable
{
  protected PathfinderGoalSit bp = new PathfinderGoalSit(this);
  
  public EntityTameableAnimal(World paramWorld) {
    super(paramWorld);
  }
  
  protected void c()
  {
    super.c();
    datawatcher.a(16, Byte.valueOf((byte)0));
    datawatcher.a(17, "");
  }
  
  public void b(NBTTagCompound paramNBTTagCompound)
  {
    super.b(paramNBTTagCompound);
    if (getOwnerName() == null) {
      paramNBTTagCompound.setString("Owner", "");
    } else {
      paramNBTTagCompound.setString("Owner", getOwnerName());
    }
    paramNBTTagCompound.setBoolean("Sitting", isSitting());
  }
  
  public void a(NBTTagCompound paramNBTTagCompound)
  {
    super.a(paramNBTTagCompound);
    String str = paramNBTTagCompound.getString("Owner");
    if (str.length() > 0) {
      setOwnerName(str);
      setTamed(true);
    }
    bp.setSitting(paramNBTTagCompound.getBoolean("Sitting"));
    setSitting(paramNBTTagCompound.getBoolean("Sitting"));
  }
  
  protected void i(boolean paramBoolean) {
    String str = "heart";
    if (!paramBoolean) {
      str = "smoke";
    }
    for (int i = 0; i < 7; i++) {
      double d1 = random.nextGaussian() * 0.02D;
      double d2 = random.nextGaussian() * 0.02D;
      double d3 = random.nextGaussian() * 0.02D;
      world.addParticle(str, locX + random.nextFloat() * width * 2.0F - width, locY + 0.5D + random.nextFloat() * length, locZ + random.nextFloat() * width * 2.0F - width, d1, d2, d3);
    }
  }
  










  public boolean isTamed()
  {
    return (datawatcher.getByte(16) & 0x4) != 0;
  }
  
  public void setTamed(boolean paramBoolean) {
    int i = datawatcher.getByte(16);
    if (paramBoolean) {
      datawatcher.watch(16, Byte.valueOf((byte)(i | 0x4)));
    } else {
      datawatcher.watch(16, Byte.valueOf((byte)(i & 0xFFFFFFFB)));
    }
  }
  
  public boolean isSitting() {
    return (datawatcher.getByte(16) & 0x1) != 0;
  }
  
  public void setSitting(boolean paramBoolean) {
    int i = datawatcher.getByte(16);
    if (paramBoolean) {
      datawatcher.watch(16, Byte.valueOf((byte)(i | 0x1)));
    } else {
      datawatcher.watch(16, Byte.valueOf((byte)(i & 0xFFFFFFFE)));
    }
  }
  
  public String getOwnerName()
  {
    return datawatcher.getString(17);
  }
  
  public void setOwnerName(String paramString) {
    datawatcher.watch(17, paramString);
  }
  
  public EntityLiving getOwner()
  {
    return world.a(getOwnerName());
  }
  
  public PathfinderGoalSit getGoalSit() {
    return bp;
  }
  
  public boolean a(EntityLiving paramEntityLiving1, EntityLiving paramEntityLiving2) {
    return true;
  }
  
  public ScoreboardTeamBase getScoreboardTeam()
  {
    if (isTamed()) {
      EntityLiving localEntityLiving = getOwner();
      if (localEntityLiving != null) {
        return localEntityLiving.getScoreboardTeam();
      }
    }
    return super.getScoreboardTeam();
  }
  
  public boolean c(EntityLiving paramEntityLiving)
  {
    if (isTamed()) {
      EntityLiving localEntityLiving = getOwner();
      if (paramEntityLiving == localEntityLiving) {
        return true;
      }
      if (localEntityLiving != null) {
        return localEntityLiving.c(paramEntityLiving);
      }
    }
    return super.c(paramEntityLiving);
  }
}
