package net.minecraft.server.v1_7_R1;

import java.net.InetSocketAddress;
import net.minecraft.util.com.google.common.base.Charsets;
import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.buffer.Unpooled;
import net.minecraft.util.io.netty.channel.Channel;
import net.minecraft.util.io.netty.channel.ChannelFutureListener;
import net.minecraft.util.io.netty.channel.ChannelHandlerContext;
import net.minecraft.util.io.netty.channel.ChannelInboundHandlerAdapter;
import net.minecraft.util.io.netty.channel.ChannelPipeline;
import org.apache.logging.log4j.Logger;

public class LegacyPingHandler extends ChannelInboundHandlerAdapter
{
  private static final Logger a = ;
  
  private ServerConnection b;
  
  public LegacyPingHandler(ServerConnection paramServerConnection)
  {
    b = paramServerConnection;
  }
  
  public void channelRead(ChannelHandlerContext paramChannelHandlerContext, Object paramObject)
  {
    ByteBuf localByteBuf = (ByteBuf)paramObject;
    
    localByteBuf.markReaderIndex();
    
    int i = 1;
    try {
      if (localByteBuf.readUnsignedByte() != 254) {
        return;
      }
      
      InetSocketAddress localInetSocketAddress = (InetSocketAddress)paramChannelHandlerContext.channel().remoteAddress();
      MinecraftServer localMinecraftServer = b.d();
      
      int j = localByteBuf.readableBytes();
      String str1; switch (j) {
      case 0: 
        a.debug("Ping: (<1.3.x) from {}:{}", new Object[] { localInetSocketAddress.getAddress(), Integer.valueOf(localInetSocketAddress.getPort()) });
        
        str1 = String.format("%s§%d§%d", new Object[] { localMinecraftServer.getMotd(), Integer.valueOf(localMinecraftServer.B()), Integer.valueOf(localMinecraftServer.C()) });
        a(paramChannelHandlerContext, a(str1));
        
        break;
      
      case 1: 
        if (localByteBuf.readUnsignedByte() != 1) {
          return;
        }
        
        a.debug("Ping: (1.4-1.5.x) from {}:{}", new Object[] { localInetSocketAddress.getAddress(), Integer.valueOf(localInetSocketAddress.getPort()) });
        
        str1 = String.format("", new Object[] { Integer.valueOf(127), localMinecraftServer.getVersion(), localMinecraftServer.getMotd(), Integer.valueOf(localMinecraftServer.B()), Integer.valueOf(localMinecraftServer.C()) });
        a(paramChannelHandlerContext, a(str1));
        
        break;
      
      default: 
        boolean bool = localByteBuf.readUnsignedByte() == 1;
        bool &= localByteBuf.readUnsignedByte() == 250;
        bool &= "MC|PingHost".equals(new String(localByteBuf.readBytes(localByteBuf.readShort() * 2).array(), Charsets.UTF_16BE));
        int k = localByteBuf.readUnsignedShort();
        bool &= localByteBuf.readUnsignedByte() >= 73;
        bool &= 3 + localByteBuf.readBytes(localByteBuf.readShort() * 2).array().length + 4 == k;
        bool &= localByteBuf.readInt() <= 65535;
        bool &= localByteBuf.readableBytes() == 0;
        
        if (!bool) {
          return;
        }
        
        a.debug("Ping: (1.6) from {}:{}", new Object[] { localInetSocketAddress.getAddress(), Integer.valueOf(localInetSocketAddress.getPort()) });
        
        String str2 = String.format("", new Object[] { Integer.valueOf(127), localMinecraftServer.getVersion(), localMinecraftServer.getMotd(), Integer.valueOf(localMinecraftServer.B()), Integer.valueOf(localMinecraftServer.C()) });
        a(paramChannelHandlerContext, a(str2));
      }
      
      localByteBuf.release();
      i = 0;
    }
    catch (RuntimeException localRuntimeException) {}finally {
      if (i != 0) {
        localByteBuf.resetReaderIndex();
        paramChannelHandlerContext.channel().pipeline().remove("legacy_query");
        paramChannelHandlerContext.fireChannelRead(paramObject);
      }
    }
  }
  
  private void a(ChannelHandlerContext paramChannelHandlerContext, ByteBuf paramByteBuf) {
    paramChannelHandlerContext.pipeline().firstContext().writeAndFlush(paramByteBuf).addListener(ChannelFutureListener.CLOSE);
  }
  
  private ByteBuf a(String paramString) {
    ByteBuf localByteBuf = Unpooled.buffer();
    localByteBuf.writeByte(255);
    
    char[] arrayOfChar1 = paramString.toCharArray();
    localByteBuf.writeShort(arrayOfChar1.length);
    for (int k : arrayOfChar1) {
      localByteBuf.writeChar(k);
    }
    
    return localByteBuf;
  }
}
