package net.minecraft.server.v1_7_R1;


public class MerchantRecipe
{
  private ItemStack buyingItem1;
  
  private ItemStack buyingItem2;
  
  private ItemStack sellingItem;
  private int uses;
  private int maxUses;
  
  public MerchantRecipe(NBTTagCompound paramNBTTagCompound)
  {
    a(paramNBTTagCompound);
  }
  
  public MerchantRecipe(ItemStack paramItemStack1, ItemStack paramItemStack2, ItemStack paramItemStack3) {
    buyingItem1 = paramItemStack1;
    buyingItem2 = paramItemStack2;
    sellingItem = paramItemStack3;
    maxUses = 7;
  }
  
  public MerchantRecipe(ItemStack paramItemStack1, ItemStack paramItemStack2) {
    this(paramItemStack1, null, paramItemStack2);
  }
  
  public MerchantRecipe(ItemStack paramItemStack, Item paramItem) {
    this(paramItemStack, new ItemStack(paramItem));
  }
  



  public ItemStack getBuyItem1()
  {
    return buyingItem1;
  }
  
  public ItemStack getBuyItem2() {
    return buyingItem2;
  }
  
  public boolean hasSecondItem() {
    return buyingItem2 != null;
  }
  
  public ItemStack getBuyItem3() {
    return sellingItem;
  }
  
  public boolean a(MerchantRecipe paramMerchantRecipe) {
    if ((buyingItem1.getItem() != buyingItem1.getItem()) || (sellingItem.getItem() != sellingItem.getItem())) {
      return false;
    }
    return ((buyingItem2 == null) && (buyingItem2 == null)) || ((buyingItem2 != null) && (buyingItem2 != null) && (buyingItem2.getItem() == buyingItem2.getItem()));
  }
  
  public boolean b(MerchantRecipe paramMerchantRecipe)
  {
    return (a(paramMerchantRecipe)) && ((buyingItem1.count < buyingItem1.count) || ((buyingItem2 != null) && (buyingItem2.count < buyingItem2.count)));
  }
  



  public void f()
  {
    uses += 1;
  }
  
  public void a(int paramInt) {
    maxUses += paramInt;
  }
  
  public boolean g() {
    return uses >= maxUses;
  }
  



  public void a(NBTTagCompound paramNBTTagCompound)
  {
    NBTTagCompound localNBTTagCompound1 = paramNBTTagCompound.getCompound("buy");
    buyingItem1 = ItemStack.createStack(localNBTTagCompound1);
    NBTTagCompound localNBTTagCompound2 = paramNBTTagCompound.getCompound("sell");
    sellingItem = ItemStack.createStack(localNBTTagCompound2);
    if (paramNBTTagCompound.hasKeyOfType("buyB", 10)) {
      buyingItem2 = ItemStack.createStack(paramNBTTagCompound.getCompound("buyB"));
    }
    if (paramNBTTagCompound.hasKeyOfType("uses", 99)) {
      uses = paramNBTTagCompound.getInt("uses");
    }
    if (paramNBTTagCompound.hasKeyOfType("maxUses", 99)) {
      maxUses = paramNBTTagCompound.getInt("maxUses");
    } else {
      maxUses = 7;
    }
  }
  
  public NBTTagCompound i() {
    NBTTagCompound localNBTTagCompound = new NBTTagCompound();
    localNBTTagCompound.set("buy", buyingItem1.save(new NBTTagCompound()));
    localNBTTagCompound.set("sell", sellingItem.save(new NBTTagCompound()));
    if (buyingItem2 != null) {
      localNBTTagCompound.set("buyB", buyingItem2.save(new NBTTagCompound()));
    }
    localNBTTagCompound.setInt("uses", uses);
    localNBTTagCompound.setInt("maxUses", maxUses);
    return localNBTTagCompound;
  }
}
