package net.minecraft.server.v1_7_R1;

import java.io.PrintStream;









public class MobEffect
{
  private int effectId;
  private int duration;
  private int amplification;
  private boolean splash;
  private boolean ambient;
  
  public MobEffect(int paramInt1, int paramInt2)
  {
    this(paramInt1, paramInt2, 0);
  }
  
  public MobEffect(int paramInt1, int paramInt2, int paramInt3) {
    this(paramInt1, paramInt2, paramInt3, false);
  }
  
  public MobEffect(int paramInt1, int paramInt2, int paramInt3, boolean paramBoolean) {
    effectId = paramInt1;
    duration = paramInt2;
    amplification = paramInt3;
    ambient = paramBoolean;
  }
  
  public MobEffect(MobEffect paramMobEffect) {
    effectId = effectId;
    duration = duration;
    amplification = amplification;
  }
  
  public void a(MobEffect paramMobEffect) {
    if (effectId != effectId) {
      System.err.println("This method should only be called for matching effects!");
    }
    if (amplification > amplification) {
      amplification = amplification;
      duration = duration;
    } else if ((amplification == amplification) && (duration < duration)) {
      duration = duration;
    } else if ((!ambient) && (ambient)) {
      ambient = ambient;
    }
  }
  
  public int getEffectId() {
    return effectId;
  }
  
  public int getDuration() {
    return duration;
  }
  
  public int getAmplifier() {
    return amplification;
  }
  



  public void setSplash(boolean paramBoolean)
  {
    splash = paramBoolean;
  }
  
  public boolean isAmbient() {
    return ambient;
  }
  





  public boolean tick(EntityLiving paramEntityLiving)
  {
    if (duration > 0) {
      if (MobEffectList.byId[effectId].a(duration, amplification)) {
        b(paramEntityLiving);
      }
      h();
    }
    return duration > 0;
  }
  
  private int h() {
    return --duration;
  }
  
  public void b(EntityLiving paramEntityLiving) {
    if (duration > 0) {
      MobEffectList.byId[effectId].tick(paramEntityLiving, amplification);
    }
  }
  
  public String f() {
    return MobEffectList.byId[effectId].a();
  }
  
  public int hashCode()
  {
    return effectId;
  }
  
  public String toString()
  {
    String str = "";
    if (getAmplifier() > 0) {
      str = f() + " x " + (getAmplifier() + 1) + ", Duration: " + getDuration();
    } else {
      str = f() + ", Duration: " + getDuration();
    }
    if (splash) {
      str = str + ", Splash: true";
    }
    if (MobEffectList.byId[effectId].i()) {
      return "(" + str + ")";
    }
    return str;
  }
  
  public boolean equals(Object paramObject)
  {
    if (!(paramObject instanceof MobEffect)) {
      return false;
    }
    MobEffect localMobEffect = (MobEffect)paramObject;
    return (effectId == effectId) && (amplification == amplification) && (duration == duration) && (splash == splash) && (ambient == ambient);
  }
  
  public NBTTagCompound a(NBTTagCompound paramNBTTagCompound) {
    paramNBTTagCompound.setByte("Id", (byte)getEffectId());
    paramNBTTagCompound.setByte("Amplifier", (byte)getAmplifier());
    paramNBTTagCompound.setInt("Duration", getDuration());
    paramNBTTagCompound.setBoolean("Ambient", isAmbient());
    return paramNBTTagCompound;
  }
  
  public static MobEffect b(NBTTagCompound paramNBTTagCompound) {
    int i = paramNBTTagCompound.getByte("Id");
    if ((i < 0) || (i >= MobEffectList.byId.length) || (MobEffectList.byId[i] == null)) {
      return null;
    }
    int j = paramNBTTagCompound.getByte("Amplifier");
    int k = paramNBTTagCompound.getInt("Duration");
    boolean bool = paramNBTTagCompound.getBoolean("Ambient");
    return new MobEffect(i, k, j, bool);
  }
}
