package net.minecraft.server.v1_7_R1;

import java.io.DataInput;
import java.io.DataOutput;











public abstract class NBTBase
{
  public static final String[] a = { "END", "BYTE", "SHORT", "INT", "LONG", "FLOAT", "DOUBLE", "BYTE[]", "STRING", "LIST", "COMPOUND", "INT[]" };
  





  abstract void write(DataOutput paramDataOutput);
  





  abstract void load(DataInput paramDataInput, int paramInt);
  




  public abstract String toString();
  




  public abstract byte getTypeId();
  




  protected static NBTBase createTag(byte paramByte)
  {
    switch (paramByte) {
    case 0: 
      return new NBTTagEnd();
    case 1: 
      return new NBTTagByte();
    case 2: 
      return new NBTTagShort();
    case 3: 
      return new NBTTagInt();
    case 4: 
      return new NBTTagLong();
    case 5: 
      return new NBTTagFloat();
    case 6: 
      return new NBTTagDouble();
    case 7: 
      return new NBTTagByteArray();
    case 11: 
      return new NBTTagIntArray();
    case 8: 
      return new NBTTagString();
    case 9: 
      return new NBTTagList();
    case 10: 
      return new NBTTagCompound();
    }
    return null;
  }
  
  public static String getTagName(int paramInt) {
    switch (paramInt) {
    case 0: 
      return "TAG_End";
    case 1: 
      return "TAG_Byte";
    case 2: 
      return "TAG_Short";
    case 3: 
      return "TAG_Int";
    case 4: 
      return "TAG_Long";
    case 5: 
      return "TAG_Float";
    case 6: 
      return "TAG_Double";
    case 7: 
      return "TAG_Byte_Array";
    case 11: 
      return "TAG_Int_Array";
    case 8: 
      return "TAG_String";
    case 9: 
      return "TAG_List";
    case 10: 
      return "TAG_Compound";
    case 99: 
      return "Any Numeric Tag";
    }
    return "UNKNOWN";
  }
  
  public abstract NBTBase clone();
  
  public boolean equals(Object paramObject)
  {
    if (!(paramObject instanceof NBTBase)) {
      return false;
    }
    NBTBase localNBTBase = (NBTBase)paramObject;
    if (getTypeId() != localNBTBase.getTypeId()) {
      return false;
    }
    return true;
  }
  
  public int hashCode()
  {
    return getTypeId();
  }
  
  protected String a_() {
    return toString();
  }
}
