package net.minecraft.server.v1_7_R1;

import java.io.DataInput;

public class NBTTagByteArray extends NBTBase
{
  private byte[] data;
  
  NBTTagByteArray() {}
  
  public NBTTagByteArray(byte[] paramArrayOfByte)
  {
    data = paramArrayOfByte;
  }
  
  void write(java.io.DataOutput paramDataOutput)
  {
    paramDataOutput.writeInt(data.length);
    paramDataOutput.write(data);
  }
  
  void load(DataInput paramDataInput, int paramInt)
  {
    int i = paramDataInput.readInt();
    data = new byte[i];
    paramDataInput.readFully(data);
  }
  
  public byte getTypeId()
  {
    return 7;
  }
  
  public String toString()
  {
    return "[" + data.length + " bytes]";
  }
  
  public NBTBase clone()
  {
    byte[] arrayOfByte = new byte[data.length];
    System.arraycopy(data, 0, arrayOfByte, 0, data.length);
    return new NBTTagByteArray(arrayOfByte);
  }
  
  public boolean equals(Object paramObject)
  {
    if (super.equals(paramObject)) {
      return java.util.Arrays.equals(data, data);
    }
    return false;
  }
  
  public int hashCode()
  {
    return super.hashCode() ^ java.util.Arrays.hashCode(data);
  }
  
  public byte[] c() {
    return data;
  }
}
