package net.minecraft.server.v1_7_R1;

import java.io.DataInput;
import java.io.DataOutput;

public class NBTTagDouble
  extends NBTNumber
{
  private double data;
  
  NBTTagDouble() {}
  
  public NBTTagDouble(double paramDouble)
  {
    data = paramDouble;
  }
  
  void write(DataOutput paramDataOutput)
  {
    paramDataOutput.writeDouble(data);
  }
  
  void load(DataInput paramDataInput, int paramInt)
  {
    data = paramDataInput.readDouble();
  }
  
  public byte getTypeId()
  {
    return 6;
  }
  
  public String toString()
  {
    return "" + data + "d";
  }
  
  public NBTBase clone()
  {
    return new NBTTagDouble(data);
  }
  
  public boolean equals(Object paramObject)
  {
    if (super.equals(paramObject)) {
      NBTTagDouble localNBTTagDouble = (NBTTagDouble)paramObject;
      return data == data;
    }
    return false;
  }
  
  public int hashCode()
  {
    long l = Double.doubleToLongBits(data);
    return super.hashCode() ^ (int)(l ^ l >>> 32);
  }
  
  public long c()
  {
    return Math.floor(data);
  }
  
  public int d()
  {
    return MathHelper.floor(data);
  }
  
  public short e()
  {
    return (short)(MathHelper.floor(data) & 0xFFFF);
  }
  
  public byte f()
  {
    return (byte)(MathHelper.floor(data) & 0xFF);
  }
  
  public double g()
  {
    return data;
  }
  
  public float h()
  {
    return (float)data;
  }
}
