package net.minecraft.server.v1_7_R1;

import java.io.DataInput;
import java.io.DataOutput;

public class NBTTagFloat
  extends NBTNumber
{
  private float data;
  
  NBTTagFloat() {}
  
  public NBTTagFloat(float paramFloat)
  {
    data = paramFloat;
  }
  
  void write(DataOutput paramDataOutput)
  {
    paramDataOutput.writeFloat(data);
  }
  
  void load(DataInput paramDataInput, int paramInt)
  {
    data = paramDataInput.readFloat();
  }
  
  public byte getTypeId()
  {
    return 5;
  }
  
  public String toString()
  {
    return "" + data + "f";
  }
  
  public NBTBase clone()
  {
    return new NBTTagFloat(data);
  }
  
  public boolean equals(Object paramObject)
  {
    if (super.equals(paramObject)) {
      NBTTagFloat localNBTTagFloat = (NBTTagFloat)paramObject;
      return data == data;
    }
    return false;
  }
  
  public int hashCode()
  {
    return super.hashCode() ^ Float.floatToIntBits(data);
  }
  
  public long c()
  {
    return data;
  }
  
  public int d()
  {
    return MathHelper.d(data);
  }
  
  public short e()
  {
    return (short)(MathHelper.d(data) & 0xFFFF);
  }
  
  public byte f()
  {
    return (byte)(MathHelper.d(data) & 0xFF);
  }
  
  public double g()
  {
    return data;
  }
  
  public float h()
  {
    return data;
  }
}
