package net.minecraft.server.v1_7_R1;

import java.io.DataInput;
import java.io.DataOutput;

public class NBTTagInt extends NBTNumber
{
  private int data;
  
  NBTTagInt() {}
  
  public NBTTagInt(int paramInt)
  {
    data = paramInt;
  }
  
  void write(DataOutput paramDataOutput)
  {
    paramDataOutput.writeInt(data);
  }
  
  void load(DataInput paramDataInput, int paramInt)
  {
    data = paramDataInput.readInt();
  }
  
  public byte getTypeId()
  {
    return 3;
  }
  
  public String toString()
  {
    return "" + data;
  }
  
  public NBTBase clone()
  {
    return new NBTTagInt(data);
  }
  
  public boolean equals(Object paramObject)
  {
    if (super.equals(paramObject)) {
      NBTTagInt localNBTTagInt = (NBTTagInt)paramObject;
      return data == data;
    }
    return false;
  }
  
  public int hashCode()
  {
    return super.hashCode() ^ data;
  }
  
  public long c()
  {
    return data;
  }
  
  public int d()
  {
    return data;
  }
  
  public short e()
  {
    return (short)(data & 0xFFFF);
  }
  
  public byte f()
  {
    return (byte)(data & 0xFF);
  }
  
  public double g()
  {
    return data;
  }
  
  public float h()
  {
    return data;
  }
}
