package net.minecraft.server.v1_7_R1;

import java.io.DataInput;

public class NBTTagIntArray extends NBTBase
{
  private int[] data;
  
  NBTTagIntArray() {}
  
  public NBTTagIntArray(int[] paramArrayOfInt)
  {
    data = paramArrayOfInt;
  }
  
  void write(java.io.DataOutput paramDataOutput)
  {
    paramDataOutput.writeInt(data.length);
    for (int i = 0; i < data.length; i++) {
      paramDataOutput.writeInt(data[i]);
    }
  }
  
  void load(DataInput paramDataInput, int paramInt)
  {
    int i = paramDataInput.readInt();
    data = new int[i];
    for (int j = 0; j < i; j++) {
      data[j] = paramDataInput.readInt();
    }
  }
  
  public byte getTypeId()
  {
    return 11;
  }
  
  public String toString()
  {
    String str = "[";
    for (int k : data) {
      str = str + k + ",";
    }
    return str + "]";
  }
  
  public NBTBase clone()
  {
    int[] arrayOfInt = new int[data.length];
    System.arraycopy(data, 0, arrayOfInt, 0, data.length);
    return new NBTTagIntArray(arrayOfInt);
  }
  
  public boolean equals(Object paramObject)
  {
    if (super.equals(paramObject)) {
      return java.util.Arrays.equals(data, data);
    }
    return false;
  }
  
  public int hashCode()
  {
    return super.hashCode() ^ java.util.Arrays.hashCode(data);
  }
  
  public int[] c() {
    return data;
  }
}
