package net.minecraft.server.v1_7_R1;

import java.io.DataInput;
import java.io.DataOutput;

public class NBTTagLong extends NBTNumber
{
  private long data;
  
  NBTTagLong() {}
  
  public NBTTagLong(long paramLong)
  {
    data = paramLong;
  }
  
  void write(DataOutput paramDataOutput)
  {
    paramDataOutput.writeLong(data);
  }
  
  void load(DataInput paramDataInput, int paramInt)
  {
    data = paramDataInput.readLong();
  }
  
  public byte getTypeId()
  {
    return 4;
  }
  
  public String toString()
  {
    return "" + data + "L";
  }
  
  public NBTBase clone()
  {
    return new NBTTagLong(data);
  }
  
  public boolean equals(Object paramObject)
  {
    if (super.equals(paramObject)) {
      NBTTagLong localNBTTagLong = (NBTTagLong)paramObject;
      return data == data;
    }
    return false;
  }
  
  public int hashCode()
  {
    return super.hashCode() ^ (int)(data ^ data >>> 32);
  }
  
  public long c()
  {
    return data;
  }
  
  public int d()
  {
    return (int)(data & 0xFFFFFFFF);
  }
  
  public short e()
  {
    return (short)(int)(data & 0xFFFF);
  }
  
  public byte f()
  {
    return (byte)(int)(data & 0xFF);
  }
  
  public double g()
  {
    return data;
  }
  
  public float h()
  {
    return (float)data;
  }
}
