package net.minecraft.server.v1_7_R1;

import java.io.DataInput;

public class NBTTagString extends NBTBase {
  private String data;
  
  public NBTTagString() {
    data = "";
  }
  
  public NBTTagString(String paramString) {
    data = paramString;
    if (paramString == null) throw new IllegalArgumentException("Empty string not allowed");
  }
  
  void write(java.io.DataOutput paramDataOutput)
  {
    paramDataOutput.writeUTF(data);
  }
  
  void load(DataInput paramDataInput, int paramInt)
  {
    data = paramDataInput.readUTF();
  }
  
  public byte getTypeId()
  {
    return 8;
  }
  
  public String toString()
  {
    return "\"" + data + "\"";
  }
  
  public NBTBase clone()
  {
    return new NBTTagString(data);
  }
  
  public boolean equals(Object paramObject)
  {
    if (super.equals(paramObject)) {
      NBTTagString localNBTTagString = (NBTTagString)paramObject;
      return ((data == null) && (data == null)) || ((data != null) && (data.equals(data)));
    }
    return false;
  }
  
  public int hashCode()
  {
    return super.hashCode() ^ data.hashCode();
  }
  
  public String a_()
  {
    return data;
  }
}
