package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;







public class PersistentVillage
  extends PersistentBase
{
  private World world;
  private final List b = new ArrayList();
  private final List c = new ArrayList();
  private final List villages = new ArrayList();
  private int time;
  
  public PersistentVillage(String paramString) {
    super(paramString);
  }
  
  public PersistentVillage(World paramWorld) {
    super("villages");
    world = paramWorld;
    c();
  }
  
  public void a(World paramWorld) {
    world = paramWorld;
    
    for (Village localVillage : villages) {
      localVillage.a(paramWorld);
    }
  }
  
  public void a(int paramInt1, int paramInt2, int paramInt3) {
    if (b.size() > 64) return;
    if (!d(paramInt1, paramInt2, paramInt3)) b.add(new ChunkCoordinates(paramInt1, paramInt2, paramInt3));
  }
  
  public void tick() {
    time += 1;
    for (Village localVillage : villages)
      localVillage.tick(time);
    e();
    f();
    g();
    
    if (time % 400 == 0) {
      c();
    }
  }
  
  private void e() {
    for (Iterator localIterator = villages.iterator(); localIterator.hasNext();) {
      Village localVillage = (Village)localIterator.next();
      if (localVillage.isAbandoned()) {
        localIterator.remove();
        c();
      }
    }
  }
  
  public List getVillages() {
    return villages;
  }
  
  public Village getClosestVillage(int paramInt1, int paramInt2, int paramInt3, int paramInt4) {
    Object localObject = null;
    float f1 = 3.4028235E+38F;
    for (Village localVillage : villages)
    {
      float f2 = localVillage.getCenter().e(paramInt1, paramInt2, paramInt3);
      if (f2 < f1)
      {
        float f3 = paramInt4 + localVillage.getSize();
        if (f2 <= f3 * f3)
        {
          localObject = localVillage;
          f1 = f2;
        } } }
    return localObject;
  }
  
  private void f() {
    if (b.isEmpty()) return;
    a((ChunkCoordinates)b.remove(0));
  }
  
  private void g()
  {
    for (int i = 0; i < c.size(); i++) {
      VillageDoor localVillageDoor = (VillageDoor)c.get(i);
      int j = 0;
      for (Object localObject = villages.iterator(); ((Iterator)localObject).hasNext();) { Village localVillage = (Village)((Iterator)localObject).next();
        int k = (int)localVillage.getCenter().e(locX, locY, locZ);
        int m = 32 + localVillage.getSize();
        if (k <= m * m) {
          localVillage.addDoor(localVillageDoor);
          j = 1;
        }
      }
      if (j == 0)
      {

        localObject = new Village(world);
        ((Village)localObject).addDoor(localVillageDoor);
        villages.add(localObject);
        c();
      } }
    c.clear();
  }
  
  private void a(ChunkCoordinates paramChunkCoordinates) {
    int i = 16;int j = 4;int k = 16;
    for (int m = x - i; m < x + i; m++) {
      for (int n = y - j; n < y + j; n++) {
        for (int i1 = z - k; i1 < z + k; i1++)
          if (e(m, n, i1))
          {
            VillageDoor localVillageDoor = b(m, n, i1);
            if (localVillageDoor == null) c(m, n, i1); else
              addedTime = time;
          }
      }
    }
  }
  
  private VillageDoor b(int paramInt1, int paramInt2, int paramInt3) {
    Object localObject;
    for (Iterator localIterator = c.iterator(); localIterator.hasNext(); 
        return localObject)
    {
      localObject = (VillageDoor)localIterator.next();
      if ((locX != paramInt1) || (locZ != paramInt3) || (Math.abs(locY - paramInt2) > 1)) {} }
    for (localIterator = villages.iterator(); localIterator.hasNext();) { localObject = (Village)localIterator.next();
      VillageDoor localVillageDoor = ((Village)localObject).e(paramInt1, paramInt2, paramInt3);
      if (localVillageDoor != null) return localVillageDoor;
    }
    return null;
  }
  
  private void c(int paramInt1, int paramInt2, int paramInt3) {
    int i = ((BlockDoor)Blocks.WOODEN_DOOR).e(world, paramInt1, paramInt2, paramInt3);
    int j; int k; if ((i == 0) || (i == 2)) {
      j = 0;
      for (k = -5; k < 0; k++)
        if (world.i(paramInt1 + k, paramInt2, paramInt3)) j--;
      for (k = 1; k <= 5; k++)
        if (world.i(paramInt1 + k, paramInt2, paramInt3)) j++;
      if (j != 0) c.add(new VillageDoor(paramInt1, paramInt2, paramInt3, j > 0 ? -2 : 2, 0, time));
    } else {
      j = 0;
      for (k = -5; k < 0; k++)
        if (world.i(paramInt1, paramInt2, paramInt3 + k)) j--;
      for (k = 1; k <= 5; k++)
        if (world.i(paramInt1, paramInt2, paramInt3 + k)) j++;
      if (j != 0) c.add(new VillageDoor(paramInt1, paramInt2, paramInt3, 0, j > 0 ? -2 : 2, time));
    }
  }
  
  private boolean d(int paramInt1, int paramInt2, int paramInt3) {
    for (Iterator localIterator = b.iterator(); localIterator.hasNext(); 
        return true)
    {
      ChunkCoordinates localChunkCoordinates = (ChunkCoordinates)localIterator.next();
      if ((x != paramInt1) || (y != paramInt2) || (z != paramInt3)) {} }
    return false;
  }
  
  private boolean e(int paramInt1, int paramInt2, int paramInt3) {
    return world.getType(paramInt1, paramInt2, paramInt3) == Blocks.WOODEN_DOOR;
  }
  

  public void a(NBTTagCompound paramNBTTagCompound)
  {
    time = paramNBTTagCompound.getInt("Tick");
    
    NBTTagList localNBTTagList = paramNBTTagCompound.getList("Villages", 10);
    for (int i = 0; i < localNBTTagList.size(); i++) {
      NBTTagCompound localNBTTagCompound = localNBTTagList.get(i);
      Village localVillage = new Village();
      localVillage.a(localNBTTagCompound);
      villages.add(localVillage);
    }
  }
  

  public void b(NBTTagCompound paramNBTTagCompound)
  {
    paramNBTTagCompound.setInt("Tick", time);
    NBTTagList localNBTTagList = new NBTTagList();
    for (Village localVillage : villages) {
      NBTTagCompound localNBTTagCompound = new NBTTagCompound();
      localVillage.b(localNBTTagCompound);
      localNBTTagList.add(localNBTTagCompound);
    }
    paramNBTTagCompound.set("Villages", localNBTTagList);
  }
}
