package net.minecraft.server.v1_7_R1;

import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;








public class PlayerSelector
{
  private static final Pattern a = Pattern.compile("^@([parf])(?:\\[([\\w=,!-]*)\\])?$");
  private static final Pattern b = Pattern.compile("\\G([-!]?[\\w-]*)(?:$|,)");
  private static final Pattern c = Pattern.compile("\\G(\\w+)=([-!]?[\\w-]*)(?:$|,)");
  



















  public static EntityPlayer getPlayer(ICommandListener paramICommandListener, String paramString)
  {
    EntityPlayer[] arrayOfEntityPlayer = getPlayers(paramICommandListener, paramString);
    
    if ((arrayOfEntityPlayer == null) || (arrayOfEntityPlayer.length != 1)) { return null;
    }
    return arrayOfEntityPlayer[0];
  }
  
  public static IChatBaseComponent getPlayerNames(ICommandListener paramICommandListener, String paramString) {
    EntityPlayer[] arrayOfEntityPlayer = getPlayers(paramICommandListener, paramString);
    if ((arrayOfEntityPlayer == null) || (arrayOfEntityPlayer.length == 0)) return null;
    IChatBaseComponent[] arrayOfIChatBaseComponent = new IChatBaseComponent[arrayOfEntityPlayer.length];
    
    for (int i = 0; i < arrayOfIChatBaseComponent.length; i++) {
      arrayOfIChatBaseComponent[i] = arrayOfEntityPlayer[i].getScoreboardDisplayName();
    }
    
    return CommandAbstract.a(arrayOfIChatBaseComponent);
  }
  
  public static EntityPlayer[] getPlayers(ICommandListener paramICommandListener, String paramString) {
    Matcher localMatcher = a.matcher(paramString);
    
    if (localMatcher.matches()) {
      Map localMap1 = h(localMatcher.group(2));
      String str1 = localMatcher.group(1);
      int i = c(str1);
      int j = d(str1);
      int k = f(str1);
      int m = e(str1);
      int n = g(str1);
      int i1 = EnumGamemode.NONE.a();
      ChunkCoordinates localChunkCoordinates = paramICommandListener.getChunkCoordinates();
      Map localMap2 = a(localMap1);
      String str2 = null;
      String str3 = null;
      int i2 = 0;
      
      if (localMap1.containsKey("rm")) {
        i = MathHelper.a((String)localMap1.get("rm"), i);
        i2 = 1;
      }
      if (localMap1.containsKey("r")) {
        j = MathHelper.a((String)localMap1.get("r"), j);
        i2 = 1;
      }
      if (localMap1.containsKey("lm")) {
        k = MathHelper.a((String)localMap1.get("lm"), k);
      }
      if (localMap1.containsKey("l")) {
        m = MathHelper.a((String)localMap1.get("l"), m);
      }
      if (localMap1.containsKey("x")) {
        x = MathHelper.a((String)localMap1.get("x"), x);
        i2 = 1;
      }
      if (localMap1.containsKey("y")) {
        y = MathHelper.a((String)localMap1.get("y"), y);
        i2 = 1;
      }
      if (localMap1.containsKey("z")) {
        z = MathHelper.a((String)localMap1.get("z"), z);
        i2 = 1;
      }
      if (localMap1.containsKey("m")) {
        i1 = MathHelper.a((String)localMap1.get("m"), i1);
      }
      if (localMap1.containsKey("c")) {
        n = MathHelper.a((String)localMap1.get("c"), n);
      }
      if (localMap1.containsKey("team")) {
        str3 = (String)localMap1.get("team");
      }
      if (localMap1.containsKey("name")) {
        str2 = (String)localMap1.get("name");
      }
      
      World localWorld = i2 != 0 ? paramICommandListener.getWorld() : null;
      List localList;
      if ((str1.equals("p")) || (str1.equals("a"))) {
        localList = MinecraftServer.getServer().getPlayerList().a(localChunkCoordinates, i, j, n, i1, k, m, localMap2, str2, str3, localWorld);
        return (localList == null) || (localList.isEmpty()) ? new EntityPlayer[0] : (EntityPlayer[])localList.toArray(new EntityPlayer[0]); }
      if (str1.equals("r")) {
        localList = MinecraftServer.getServer().getPlayerList().a(localChunkCoordinates, i, j, 0, i1, k, m, localMap2, str2, str3, localWorld);
        Collections.shuffle(localList);
        localList = localList.subList(0, Math.min(n, localList.size()));
        return (localList == null) || (localList.isEmpty()) ? new EntityPlayer[0] : (EntityPlayer[])localList.toArray(new EntityPlayer[0]);
      }
      return null;
    }
    
    return null;
  }
  
  public static Map a(Map paramMap)
  {
    HashMap localHashMap = new HashMap();
    
    for (String str1 : paramMap.keySet()) {
      if ((str1.startsWith("score_")) && (str1.length() > "score_".length())) {
        String str2 = str1.substring("score_".length());
        localHashMap.put(str2, Integer.valueOf(MathHelper.a((String)paramMap.get(str1), 1)));
      }
    }
    
    return localHashMap;
  }
  
  public static boolean isList(String paramString) {
    Matcher localMatcher = a.matcher(paramString);
    
    if (localMatcher.matches()) {
      Map localMap = h(localMatcher.group(2));
      String str = localMatcher.group(1);
      int i = g(str);
      if (localMap.containsKey("c")) i = MathHelper.a((String)localMap.get("c"), i);
      return i != 1;
    }
    
    return false;
  }
  
  public static boolean isPattern(String paramString1, String paramString2) {
    Matcher localMatcher = a.matcher(paramString1);
    
    if (localMatcher.matches()) {
      String str = localMatcher.group(1);
      if ((paramString2 != null) && (!paramString2.equals(str))) { return false;
      }
      return true;
    }
    
    return false;
  }
  
  public static boolean isPattern(String paramString) {
    return isPattern(paramString, null);
  }
  
  private static final int c(String paramString) {
    return 0;
  }
  
  private static final int d(String paramString) {
    return 0;
  }
  
  private static final int e(String paramString) {
    return 2147483647;
  }
  
  private static final int f(String paramString) {
    return 0;
  }
  
  private static final int g(String paramString) {
    if (paramString.equals("a")) {
      return 0;
    }
    return 1;
  }
  
  private static Map h(String paramString)
  {
    HashMap localHashMap = new HashMap();
    if (paramString == null) return localHashMap;
    Matcher localMatcher = b.matcher(paramString);
    int i = 0;
    int j = -1;
    
    while (localMatcher.find()) {
      String str = null;
      
      switch (i++) {
      case 0: 
        str = "x";
        break;
      case 1: 
        str = "y";
        break;
      case 2: 
        str = "z";
        break;
      case 3: 
        str = "r";
      }
      
      
      if ((str != null) && (localMatcher.group(1).length() > 0)) localHashMap.put(str, localMatcher.group(1));
      j = localMatcher.end();
    }
    
    if (j < paramString.length()) {
      localMatcher = c.matcher(j == -1 ? paramString : paramString.substring(j));
      
      while (localMatcher.find()) {
        localHashMap.put(localMatcher.group(1), localMatcher.group(2));
      }
    }
    
    return localHashMap;
  }
}
