package net.minecraft.server.v1_7_R1;

import java.net.DatagramSocket;
import java.net.ServerSocket;
import java.util.Iterator;
import java.util.List;
import java.util.concurrent.atomic.AtomicInteger;

public abstract class RemoteConnectionThread implements Runnable
{
  private static final AtomicInteger h = new AtomicInteger(0);
  protected boolean running;
  protected IMinecraftServer server;
  protected final String c;
  protected Thread thread;
  protected int e = 5;
  protected List f = new java.util.ArrayList();
  protected List g = new java.util.ArrayList();
  
  protected RemoteConnectionThread(IMinecraftServer paramIMinecraftServer, String paramString) {
    server = paramIMinecraftServer;
    c = paramString;
    if (server.isDebugging()) {
      warning("Debugging is enabled, performance maybe reduced!");
    }
  }
  


  public synchronized void a()
  {
    thread = new Thread(this, c + " #" + h.incrementAndGet());
    thread.start();
    running = true;
  }
  


































  public boolean c()
  {
    return running;
  }
  
  protected void debug(String paramString) {
    server.i(paramString);
  }
  
  protected void info(String paramString) {
    server.info(paramString);
  }
  
  protected void warning(String paramString) {
    server.warning(paramString);
  }
  
  protected void error(String paramString) {
    server.h(paramString);
  }
  
  protected int d() {
    return server.B();
  }
  
  protected void a(DatagramSocket paramDatagramSocket) {
    debug("registerSocket: " + paramDatagramSocket);
    f.add(paramDatagramSocket);
  }
  








  protected boolean a(DatagramSocket paramDatagramSocket, boolean paramBoolean)
  {
    debug("closeSocket: " + paramDatagramSocket);
    if (null == paramDatagramSocket) {
      return false;
    }
    
    boolean bool = false;
    if (!paramDatagramSocket.isClosed()) {
      paramDatagramSocket.close();
      bool = true;
    }
    
    if (paramBoolean) {
      f.remove(paramDatagramSocket);
    }
    
    return bool;
  }
  
  protected boolean b(ServerSocket paramServerSocket) {
    return a(paramServerSocket, true);
  }
  
  protected boolean a(ServerSocket paramServerSocket, boolean paramBoolean) {
    debug("closeSocket: " + paramServerSocket);
    if (null == paramServerSocket) {
      return false;
    }
    
    boolean bool = false;
    try {
      if (!paramServerSocket.isClosed()) {
        paramServerSocket.close();
        bool = true;
      }
    } catch (java.io.IOException localIOException) {
      warning("IO: " + localIOException.getMessage());
    }
    
    if (paramBoolean) {
      g.remove(paramServerSocket);
    }
    
    return bool;
  }
  
  protected void e() {
    a(false);
  }
  
  protected void a(boolean paramBoolean) {
    int i = 0;
    for (Iterator localIterator = f.iterator(); localIterator.hasNext();) { localObject = (DatagramSocket)localIterator.next();
      if (a((DatagramSocket)localObject, false))
        i++;
    }
    Object localObject;
    f.clear();
    
    for (localIterator = g.iterator(); localIterator.hasNext();) { localObject = (ServerSocket)localIterator.next();
      if (a((ServerSocket)localObject, false)) {
        i++;
      }
    }
    g.clear();
    
    if ((paramBoolean) && (0 < i)) {
      warning("Force closed " + i + " sockets");
    }
  }
}
