package net.minecraft.server.v1_7_R1;

import java.io.IOException;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketTimeoutException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;

public class RemoteControlListener extends RemoteConnectionThread
{
  private int h;
  private int i;
  private String j;
  private ServerSocket k;
  private String l;
  private Map m;
  
  public RemoteControlListener(IMinecraftServer paramIMinecraftServer)
  {
    super(paramIMinecraftServer, "RCON Listener");
    h = paramIMinecraftServer.a("rcon.port", 0);
    l = paramIMinecraftServer.a("rcon.password", "");
    j = paramIMinecraftServer.x();
    i = paramIMinecraftServer.y();
    if (0 == h)
    {
      h = (i + 10);
      info("Setting default rcon port to " + h);
      paramIMinecraftServer.a("rcon.port", Integer.valueOf(h));
      if (0 == l.length()) {
        paramIMinecraftServer.a("rcon.password", "");
      }
      paramIMinecraftServer.a();
    }
    
    if (0 == j.length()) {
      j = "0.0.0.0";
    }
    
    f();
    k = null;
  }
  
  private void f() {
    m = new HashMap();
  }
  
  private void g() {
    Iterator localIterator = m.entrySet().iterator();
    while (localIterator.hasNext()) {
      Map.Entry localEntry = (Map.Entry)localIterator.next();
      if (!((RemoteControlSession)localEntry.getValue()).c()) {
        localIterator.remove();
      }
    }
  }
  
  public void run()
  {
    info("RCON running on " + j + ":" + h);
    try {
      while (running) {
        try
        {
          Socket localSocket = k.accept();
          localSocket.setSoTimeout(500);
          RemoteControlSession localRemoteControlSession = new RemoteControlSession(server, localSocket);
          localRemoteControlSession.a();
          m.put(localSocket.getRemoteSocketAddress(), localRemoteControlSession);
          

          g();
        }
        catch (SocketTimeoutException localSocketTimeoutException) {
          g();
        } catch (IOException localIOException) {
          if (running) {
            info("IO: " + localIOException.getMessage());
          }
        }
      }
    } finally {
      b(k);
    }
  }
  
  public void a()
  {
    if (0 == l.length()) {
      warning("No rcon password set in '" + server.b() + "', rcon disabled!");
      return;
    }
    
    if ((0 >= h) || (65535 < h)) {
      warning("Invalid rcon port " + h + " found in '" + server.b() + "', rcon disabled!");
      return;
    }
    
    if (running) {
      return;
    }
    try
    {
      k = new ServerSocket(h, 0, InetAddress.getByName(j));
      k.setSoTimeout(500);
      super.a();
    } catch (IOException localIOException) {
      warning("Unable to initialise rcon on " + j + ":" + h + " : " + localIOException.getMessage());
    }
  }
}
