package net.minecraft.server.v1_7_R1;

import java.io.File;
import java.io.IOException;
import java.lang.reflect.Constructor;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import net.minecraft.util.com.google.common.collect.Maps;
import net.minecraft.util.com.google.common.collect.Sets;
import net.minecraft.util.com.google.gson.JsonElement;
import net.minecraft.util.com.google.gson.JsonObject;
import net.minecraft.util.com.google.gson.JsonParseException;
import net.minecraft.util.com.google.gson.JsonParser;
import net.minecraft.util.com.google.gson.JsonPrimitive;
import net.minecraft.util.org.apache.commons.io.FileUtils;
import org.apache.logging.log4j.Logger;

public class ServerStatisticManager extends StatisticManager
{
  private static final Logger b = ;
  
  private final MinecraftServer c;
  private final File d;
  private final Set e = Sets.newHashSet();
  private int f = -300;
  private boolean g = false;
  
  public ServerStatisticManager(MinecraftServer paramMinecraftServer, File paramFile) {
    c = paramMinecraftServer;
    d = paramFile;
  }
  
  public void a() {
    if (d.isFile()) {
      try {
        a.clear();
        a.putAll(a(FileUtils.readFileToString(d)));
      } catch (IOException localIOException) {
        b.error("Couldn't read statistics file " + d, localIOException);
      } catch (JsonParseException localJsonParseException) {
        b.error("Couldn't parse statistics file " + d, localJsonParseException);
      }
    }
  }
  
  public void b() {
    try {
      FileUtils.writeStringToFile(d, a(a));
    } catch (IOException localIOException) {
      b.error("Couldn't save stats", localIOException);
    }
  }
  
  public void a(EntityHuman paramEntityHuman, Statistic paramStatistic, int paramInt)
  {
    int i = paramStatistic.d() ? a(paramStatistic) : 0;
    super.a(paramEntityHuman, paramStatistic, paramInt);
    e.add(paramStatistic);
    
    if ((paramStatistic.d()) && (i == 0) && (paramInt > 0)) {
      g = true;
      if (c.ar()) {
        c.getPlayerList().sendMessage(new ChatMessage("chat.type.achievement", new Object[] { paramEntityHuman.getScoreboardDisplayName(), paramStatistic.j() }));
      }
    }
  }
  
  public Set c() {
    HashSet localHashSet = Sets.newHashSet(e);
    e.clear();
    g = false;
    return localHashSet;
  }
  
  public Map a(String paramString) {
    JsonElement localJsonElement = new JsonParser().parse(paramString);
    if (!localJsonElement.isJsonObject()) return Maps.newHashMap();
    JsonObject localJsonObject1 = localJsonElement.getAsJsonObject();
    HashMap localHashMap = Maps.newHashMap();
    
    for (Map.Entry localEntry : localJsonObject1.entrySet()) {
      Statistic localStatistic = StatisticList.a((String)localEntry.getKey());
      
      if (localStatistic != null) {
        StatisticWrapper localStatisticWrapper = new StatisticWrapper();
        
        if ((((JsonElement)localEntry.getValue()).isJsonPrimitive()) && (((JsonElement)localEntry.getValue()).getAsJsonPrimitive().isNumber())) {
          localStatisticWrapper.a(((JsonElement)localEntry.getValue()).getAsInt());
        } else if (((JsonElement)localEntry.getValue()).isJsonObject()) {
          JsonObject localJsonObject2 = ((JsonElement)localEntry.getValue()).getAsJsonObject();
          
          if ((localJsonObject2.has("value")) && (localJsonObject2.get("value").isJsonPrimitive()) && (localJsonObject2.get("value").getAsJsonPrimitive().isNumber())) {
            localStatisticWrapper.a(localJsonObject2.getAsJsonPrimitive("value").getAsInt());
          }
          
          if ((localJsonObject2.has("progress")) && (localStatistic.l() != null)) {
            try {
              Constructor localConstructor = localStatistic.l().getConstructor(new Class[0]);
              IJsonStatistic localIJsonStatistic = (IJsonStatistic)localConstructor.newInstance(new Object[0]);
              localStatisticWrapper.a(localIJsonStatistic);
            } catch (Throwable localThrowable) {
              b.warn("Invalid statistic progress in " + d, localThrowable);
            }
          }
        }
        
        localHashMap.put(localStatistic, localStatisticWrapper);
      } else {
        b.warn("Invalid statistic in " + d + ": Don't know what " + (String)localEntry.getKey() + " is");
      }
    }
    
    return localHashMap;
  }
  
  public static String a(Map paramMap) {
    JsonObject localJsonObject1 = new JsonObject();
    
    for (Map.Entry localEntry : paramMap.entrySet()) {
      if (((StatisticWrapper)localEntry.getValue()).b() != null) {
        JsonObject localJsonObject2 = new JsonObject();
        
        localJsonObject2.addProperty("value", Integer.valueOf(((StatisticWrapper)localEntry.getValue()).a()));
        try
        {
          localJsonObject2.add("progress", ((StatisticWrapper)localEntry.getValue()).b().a());
        } catch (Throwable localThrowable) {
          b.warn("Couldn't save statistic " + ((Statistic)localEntry.getKey()).e() + ": error serializing progress", localThrowable);
        }
        
        localJsonObject1.add(getKey()e, localJsonObject2);
      } else {
        localJsonObject1.addProperty(getKey()e, Integer.valueOf(((StatisticWrapper)localEntry.getValue()).a()));
      }
    }
    

    return localJsonObject1.toString();
  }
  
  public void d() {
    for (Statistic localStatistic : a.keySet()) {
      e.add(localStatistic);
    }
  }
  
  public void a(EntityPlayer paramEntityPlayer) {
    int i = c.aj();
    HashMap localHashMap = Maps.newHashMap();
    
    if ((g) || (i - f > 300)) {
      f = i;
      
      for (Statistic localStatistic : c()) {
        localHashMap.put(localStatistic, Integer.valueOf(a(localStatistic)));
      }
    }
    
    playerConnection.sendPacket(new PacketPlayOutStatistic(localHashMap));
  }
  
  public void b(EntityPlayer paramEntityPlayer) {
    HashMap localHashMap = Maps.newHashMap();
    
    for (Achievement localAchievement : AchievementList.e) {
      if (a(localAchievement)) {
        localHashMap.put(localAchievement, Integer.valueOf(a(localAchievement)));
        e.remove(localAchievement);
      }
    }
    
    playerConnection.sendPacket(new PacketPlayOutStatistic(localHashMap));
  }
  
  public boolean e() {
    return g;
  }
}
