package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Random;




public class WorldGenLargeFeature
  extends StructureGenerator
{
  private static List e = Arrays.asList(new BiomeBase[] { BiomeBase.DESERT, BiomeBase.DESERT_HILLS, BiomeBase.JUNGLE, BiomeBase.JUNGLE_HILLS, BiomeBase.SWAMPLAND });
  
  private List f = new ArrayList();
  private int g = 32;
  private int h = 8;
  

  public WorldGenLargeFeature()
  {
    f.add(new BiomeMeta(EntityWitch.class, 1, 1, 1));
  }
  
  public WorldGenLargeFeature(Map paramMap) {
    this();
    
    for (Map.Entry localEntry : paramMap.entrySet()) {
      if (((String)localEntry.getKey()).equals("distance")) {
        g = MathHelper.a((String)localEntry.getValue(), g, h + 1);
      }
    }
  }
  
  public String a()
  {
    return "Temple";
  }
  

  protected boolean a(int paramInt1, int paramInt2)
  {
    int i = paramInt1;
    int j = paramInt2;
    if (paramInt1 < 0) paramInt1 -= g - 1;
    if (paramInt2 < 0) { paramInt2 -= g - 1;
    }
    int k = paramInt1 / g;
    int m = paramInt2 / g;
    Random localRandom = c.A(k, m, 14357617);
    k *= g;
    m *= g;
    k += localRandom.nextInt(g - h);
    m += localRandom.nextInt(g - h);
    paramInt1 = i;
    paramInt2 = j;
    BiomeBase localBiomeBase1;
    if ((paramInt1 == k) && (paramInt2 == m)) {
      localBiomeBase1 = c.getWorldChunkManager().getBiome(paramInt1 * 16 + 8, paramInt2 * 16 + 8);
      for (BiomeBase localBiomeBase2 : e) {
        if (localBiomeBase1 == localBiomeBase2) {
          return true;
        }
      }
    }
    
    return false;
  }
  

  protected StructureStart b(int paramInt1, int paramInt2)
  {
    return new WorldGenLargeFeatureStart(c, b, paramInt1, paramInt2);
  }
  

























  public boolean a(int paramInt1, int paramInt2, int paramInt3)
  {
    StructureStart localStructureStart = c(paramInt1, paramInt2, paramInt3);
    if ((localStructureStart == null) || (!(localStructureStart instanceof WorldGenLargeFeatureStart)) || (a.isEmpty())) {
      return false;
    }
    StructurePiece localStructurePiece = (StructurePiece)a.getFirst();
    return localStructurePiece instanceof WorldGenWitchHut;
  }
  
  public List b() {
    return f;
  }
}
