package net.minecraft.server.v1_7_R1;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Random;




public class WorldGenStronghold
  extends StructureGenerator
{
  private List e;
  private boolean f;
  private ChunkCoordIntPair[] g = new ChunkCoordIntPair[3];
  private double h = 32.0D;
  private int i = 3;
  
  public WorldGenStronghold()
  {
    e = new ArrayList();
    for (BiomeBase localBiomeBase : BiomeBase.n()) {
      if ((localBiomeBase != null) && (am > 0.0F)) {
        e.add(localBiomeBase);
      }
    }
  }
  
  public WorldGenStronghold(Map paramMap) {
    this();
    for (Map.Entry localEntry : paramMap.entrySet()) {
      if (((String)localEntry.getKey()).equals("distance")) {
        h = MathHelper.a((String)localEntry.getValue(), h, 1.0D);
      } else if (((String)localEntry.getKey()).equals("count")) {
        g = new ChunkCoordIntPair[MathHelper.a((String)localEntry.getValue(), g.length, 1)];
      } else if (((String)localEntry.getKey()).equals("spread")) {
        i = MathHelper.a((String)localEntry.getValue(), i, 1);
      }
    }
  }
  
  public String a()
  {
    return "Stronghold";
  }
  
  protected boolean a(int paramInt1, int paramInt2)
  {
    Object localObject1;
    if (!f) {
      localObject1 = new Random();
      
      ((Random)localObject1).setSeed(c.getSeed());
      
      double d1 = ((Random)localObject1).nextDouble() * 3.141592653589793D * 2.0D;
      int j = 1;
      
      for (int k = 0; k < g.length; k++) {
        double d2 = (1.25D * j + ((Random)localObject1).nextDouble()) * (h * j);
        int m = (int)Math.round(Math.cos(d1) * d2);
        int n = (int)Math.round(Math.sin(d1) * d2);
        
        ChunkPosition localChunkPosition = c.getWorldChunkManager().a((m << 4) + 8, (n << 4) + 8, 112, e, (Random)localObject1);
        if (localChunkPosition != null) {
          m = x >> 4;
          n = z >> 4;
        }
        
        g[k] = new ChunkCoordIntPair(m, n);
        
        d1 += 6.283185307179586D * j / i;
        
        if (k == i) {
          j += 2 + ((Random)localObject1).nextInt(5);
          i += 1 + ((Random)localObject1).nextInt(2);
        }
      }
      
      f = true;
    }
    for (Object localObject2 : g) {
      if ((paramInt1 == x) && (paramInt2 == z)) {
        return true;
      }
    }
    return false;
  }
  
  protected List o_()
  {
    ArrayList localArrayList = new ArrayList();
    for (ChunkCoordIntPair localChunkCoordIntPair : g) {
      if (localChunkCoordIntPair != null) {
        localArrayList.add(localChunkCoordIntPair.a(64));
      }
    }
    return localArrayList;
  }
  
  protected StructureStart b(int paramInt1, int paramInt2)
  {
    WorldGenStronghold2Start localWorldGenStronghold2Start = new WorldGenStronghold2Start(c, b, paramInt1, paramInt2);
    
    while ((localWorldGenStronghold2Start.b().isEmpty()) || (b()get0b == null))
    {
      localWorldGenStronghold2Start = new WorldGenStronghold2Start(c, b, paramInt1, paramInt2);
    }
    
    return localWorldGenStronghold2Start;
  }
}
