package net.minecraft.util.com.google.common.reflect;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;
import javax.annotation.Nullable;
import net.minecraft.util.com.google.common.annotations.Beta;


































@Beta
public abstract class AbstractInvocationHandler
  implements InvocationHandler
{
  private static final Object[] NO_ARGS = new Object[0];
  













  public final Object invoke(Object proxy, Method method, @Nullable Object[] args)
    throws Throwable
  {
    if (args == null) {
      args = NO_ARGS;
    }
    if ((args.length == 0) && (method.getName().equals("hashCode"))) {
      return Integer.valueOf(hashCode());
    }
    if ((args.length == 1) && (method.getName().equals("equals")) && (method.getParameterTypes()[0] == Object.class))
    {

      Object arg = args[0];
      return Boolean.valueOf((proxy.getClass().isInstance(arg)) && (equals(Proxy.getInvocationHandler(arg))));
    }
    if ((args.length == 0) && (method.getName().equals("toString"))) {
      return toString();
    }
    return handleInvocation(proxy, method, args);
  }
  








  protected abstract Object handleInvocation(Object paramObject, Method paramMethod, Object[] paramArrayOfObject)
    throws Throwable;
  







  public boolean equals(Object obj)
  {
    return super.equals(obj);
  }
  



  public int hashCode()
  {
    return super.hashCode();
  }
  




  public String toString()
  {
    return super.toString();
  }
}
