package net.minecraft.util.com.mojang.authlib;

import java.util.Map;
import net.minecraft.util.com.mojang.authlib.exceptions.AuthenticationException;

public abstract interface UserAuthentication
{
  public abstract boolean canLogIn();
  
  public abstract void logIn()
    throws AuthenticationException;
  
  public abstract void logOut();
  
  public abstract boolean isLoggedIn();
  
  public abstract boolean canPlayOnline();
  
  public abstract GameProfile[] getAvailableProfiles();
  
  public abstract GameProfile getSelectedProfile();
  
  public abstract void selectGameProfile(GameProfile paramGameProfile)
    throws AuthenticationException;
  
  public abstract void loadFromStorage(Map<String, String> paramMap);
  
  public abstract Map<String, String> saveForStorage();
  
  public abstract void setUsername(String paramString);
  
  public abstract void setPassword(String paramString);
  
  public abstract String getAuthenticatedToken();
  
  public abstract String getUserID();
}
