package net.minecraft.util.gnu.trove.map;

import java.util.Map;
import net.minecraft.util.gnu.trove.TIntCollection;
import net.minecraft.util.gnu.trove.function.TIntFunction;
import net.minecraft.util.gnu.trove.iterator.TDoubleIntIterator;
import net.minecraft.util.gnu.trove.procedure.TDoubleIntProcedure;
import net.minecraft.util.gnu.trove.procedure.TDoubleProcedure;
import net.minecraft.util.gnu.trove.procedure.TIntProcedure;
import net.minecraft.util.gnu.trove.set.TDoubleSet;

public abstract interface TDoubleIntMap
{
  public abstract double getNoEntryKey();
  
  public abstract int getNoEntryValue();
  
  public abstract int put(double paramDouble, int paramInt);
  
  public abstract int putIfAbsent(double paramDouble, int paramInt);
  
  public abstract void putAll(Map<? extends Double, ? extends Integer> paramMap);
  
  public abstract void putAll(TDoubleIntMap paramTDoubleIntMap);
  
  public abstract int get(double paramDouble);
  
  public abstract void clear();
  
  public abstract boolean isEmpty();
  
  public abstract int remove(double paramDouble);
  
  public abstract int size();
  
  public abstract TDoubleSet keySet();
  
  public abstract double[] keys();
  
  public abstract double[] keys(double[] paramArrayOfDouble);
  
  public abstract TIntCollection valueCollection();
  
  public abstract int[] values();
  
  public abstract int[] values(int[] paramArrayOfInt);
  
  public abstract boolean containsValue(int paramInt);
  
  public abstract boolean containsKey(double paramDouble);
  
  public abstract TDoubleIntIterator iterator();
  
  public abstract boolean forEachKey(TDoubleProcedure paramTDoubleProcedure);
  
  public abstract boolean forEachValue(TIntProcedure paramTIntProcedure);
  
  public abstract boolean forEachEntry(TDoubleIntProcedure paramTDoubleIntProcedure);
  
  public abstract void transformValues(TIntFunction paramTIntFunction);
  
  public abstract boolean retainEntries(TDoubleIntProcedure paramTDoubleIntProcedure);
  
  public abstract boolean increment(double paramDouble);
  
  public abstract boolean adjustValue(double paramDouble, int paramInt);
  
  public abstract int adjustOrPutValue(double paramDouble, int paramInt1, int paramInt2);
}
