package net.minecraft.util.io.netty.channel;

import net.minecraft.util.io.netty.util.AttributeMap;
import net.minecraft.util.io.netty.util.concurrent.EventExecutor;

public abstract interface ChannelHandlerContext
  extends AttributeMap, ChannelPropertyAccess, ChannelInboundInvoker, ChannelOutboundInvoker
{
  public abstract Channel channel();
  
  public abstract EventExecutor executor();
  
  public abstract String name();
  
  public abstract ChannelHandler handler();
  
  public abstract boolean isRemoved();
  
  public abstract ChannelHandlerContext fireChannelRegistered();
  
  @Deprecated
  public abstract ChannelHandlerContext fireChannelUnregistered();
  
  public abstract ChannelHandlerContext fireChannelActive();
  
  public abstract ChannelHandlerContext fireChannelInactive();
  
  public abstract ChannelHandlerContext fireExceptionCaught(Throwable paramThrowable);
  
  public abstract ChannelHandlerContext fireUserEventTriggered(Object paramObject);
  
  public abstract ChannelHandlerContext fireChannelRead(Object paramObject);
  
  public abstract ChannelHandlerContext fireChannelReadComplete();
  
  public abstract ChannelHandlerContext fireChannelWritabilityChanged();
  
  public abstract ChannelHandlerContext flush();
}
