package net.minecraft.util.io.netty.channel;

import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import net.minecraft.util.io.netty.util.concurrent.EventExecutorGroup;

public abstract interface ChannelPipeline
  extends ChannelInboundInvoker, ChannelOutboundInvoker, Iterable<Map.Entry<String, ChannelHandler>>
{
  public abstract ChannelPipeline addFirst(String paramString, ChannelHandler paramChannelHandler);
  
  public abstract ChannelPipeline addFirst(EventExecutorGroup paramEventExecutorGroup, String paramString, ChannelHandler paramChannelHandler);
  
  public abstract ChannelPipeline addLast(String paramString, ChannelHandler paramChannelHandler);
  
  public abstract ChannelPipeline addLast(EventExecutorGroup paramEventExecutorGroup, String paramString, ChannelHandler paramChannelHandler);
  
  public abstract ChannelPipeline addBefore(String paramString1, String paramString2, ChannelHandler paramChannelHandler);
  
  public abstract ChannelPipeline addBefore(EventExecutorGroup paramEventExecutorGroup, String paramString1, String paramString2, ChannelHandler paramChannelHandler);
  
  public abstract ChannelPipeline addAfter(String paramString1, String paramString2, ChannelHandler paramChannelHandler);
  
  public abstract ChannelPipeline addAfter(EventExecutorGroup paramEventExecutorGroup, String paramString1, String paramString2, ChannelHandler paramChannelHandler);
  
  public abstract ChannelPipeline addFirst(ChannelHandler... paramVarArgs);
  
  public abstract ChannelPipeline addFirst(EventExecutorGroup paramEventExecutorGroup, ChannelHandler... paramVarArgs);
  
  public abstract ChannelPipeline addLast(ChannelHandler... paramVarArgs);
  
  public abstract ChannelPipeline addLast(EventExecutorGroup paramEventExecutorGroup, ChannelHandler... paramVarArgs);
  
  public abstract ChannelPipeline remove(ChannelHandler paramChannelHandler);
  
  public abstract ChannelHandler remove(String paramString);
  
  public abstract <T extends ChannelHandler> T remove(Class<T> paramClass);
  
  public abstract ChannelHandler removeFirst();
  
  public abstract ChannelHandler removeLast();
  
  public abstract ChannelPipeline replace(ChannelHandler paramChannelHandler1, String paramString, ChannelHandler paramChannelHandler2);
  
  public abstract ChannelHandler replace(String paramString1, String paramString2, ChannelHandler paramChannelHandler);
  
  public abstract <T extends ChannelHandler> T replace(Class<T> paramClass, String paramString, ChannelHandler paramChannelHandler);
  
  public abstract ChannelHandler first();
  
  public abstract ChannelHandlerContext firstContext();
  
  public abstract ChannelHandler last();
  
  public abstract ChannelHandlerContext lastContext();
  
  public abstract ChannelHandler get(String paramString);
  
  public abstract <T extends ChannelHandler> T get(Class<T> paramClass);
  
  public abstract ChannelHandlerContext context(ChannelHandler paramChannelHandler);
  
  public abstract ChannelHandlerContext context(String paramString);
  
  public abstract ChannelHandlerContext context(Class<? extends ChannelHandler> paramClass);
  
  public abstract Channel channel();
  
  public abstract List<String> names();
  
  public abstract Map<String, ChannelHandler> toMap();
  
  public abstract ChannelPipeline fireChannelRegistered();
  
  @Deprecated
  public abstract ChannelPipeline fireChannelUnregistered();
  
  public abstract ChannelPipeline fireChannelActive();
  
  public abstract ChannelPipeline fireChannelInactive();
  
  public abstract ChannelPipeline fireExceptionCaught(Throwable paramThrowable);
  
  public abstract ChannelPipeline fireUserEventTriggered(Object paramObject);
  
  public abstract ChannelPipeline fireChannelRead(Object paramObject);
  
  public abstract ChannelPipeline fireChannelReadComplete();
  
  public abstract ChannelPipeline fireChannelWritabilityChanged();
  
  public abstract ChannelPipeline flush();
  
  public abstract ChannelPipeline read();
}
