package net.minecraft.util.io.netty.handler.codec.http;

import net.minecraft.util.io.netty.buffer.ByteBuf;
import net.minecraft.util.io.netty.buffer.Unpooled;
import net.minecraft.util.io.netty.handler.codec.DecoderResult;





















public abstract interface LastHttpContent
  extends HttpContent
{
  public static final LastHttpContent EMPTY_LAST_CONTENT = new LastHttpContent()
  {
    public ByteBuf content()
    {
      return Unpooled.EMPTY_BUFFER;
    }
    
    public LastHttpContent copy()
    {
      return EMPTY_LAST_CONTENT;
    }
    
    public LastHttpContent duplicate()
    {
      return this;
    }
    
    public HttpHeaders trailingHeaders()
    {
      return HttpHeaders.EMPTY_HEADERS;
    }
    
    public DecoderResult getDecoderResult()
    {
      return DecoderResult.SUCCESS;
    }
    
    public void setDecoderResult(DecoderResult result)
    {
      throw new UnsupportedOperationException("read only");
    }
    
    public int refCnt()
    {
      return 1;
    }
    
    public LastHttpContent retain()
    {
      return this;
    }
    
    public LastHttpContent retain(int increment)
    {
      return this;
    }
    
    public boolean release()
    {
      return false;
    }
    
    public boolean release(int decrement)
    {
      return false;
    }
  };
  
  public abstract HttpHeaders trailingHeaders();
  
  public abstract LastHttpContent copy();
  
  public abstract LastHttpContent retain(int paramInt);
  
  public abstract LastHttpContent retain();
}
