package org.apache.commons.lang.text;

import java.util.Map;











































public abstract class StrLookup
{
  private static final StrLookup NONE_LOOKUP = new MapStrLookup(null);
  static { StrLookup lookup = null;
    try {
      lookup = new MapStrLookup(System.getProperties());
    } catch (SecurityException ex) {
      lookup = NONE_LOOKUP;
    }
    SYSTEM_PROPERTIES_LOOKUP = lookup;
  }
  





  public static StrLookup noneLookup()
  {
    return NONE_LOOKUP;
  }
  










  public static StrLookup systemPropertiesLookup()
  {
    return SYSTEM_PROPERTIES_LOOKUP;
  }
  








  public static StrLookup mapLookup(Map map)
  {
    return new MapStrLookup(map);
  }
  








  private static final StrLookup SYSTEM_PROPERTIES_LOOKUP;
  







  public abstract String lookup(String paramString);
  








  static class MapStrLookup
    extends StrLookup
  {
    private final Map map;
    







    MapStrLookup(Map map)
    {
      this.map = map;
    }
    








    public String lookup(String key)
    {
      if (map == null) {
        return null;
      }
      Object obj = map.get(key);
      if (obj == null) {
        return null;
      }
      return obj.toString();
    }
  }
}
