package org.bukkit.craftbukkit.libs.org.ibex.nestedvm.util;






public class InodeCache
{
  private static final Object PLACEHOLDER = new Object();
  
  private static final short SHORT_PLACEHOLDER = -2;
  private static final short SHORT_NULL = -1;
  private static final int LOAD_FACTOR = 2;
  private final int maxSize;
  private final int totalSlots;
  private final int maxUsedSlots;
  private final Object[] keys;
  private final short[] next;
  private final short[] prev;
  private final short[] inodes;
  private final short[] reverse;
  private int size;
  private int usedSlots;
  private short mru;
  private short lru;
  
  public InodeCache() { this(1024); }
  
  public InodeCache(int paramInt) { maxSize = paramInt;
    totalSlots = (paramInt * 2 * 2 + 3);
    maxUsedSlots = (totalSlots / 2);
    if (totalSlots > 32767) throw new IllegalArgumentException("cache size too large");
    keys = new Object[totalSlots];
    next = new short[totalSlots];
    prev = new short[totalSlots];
    inodes = new short[totalSlots];
    reverse = new short[totalSlots];
    clear();
  }
  
  private static void fill(Object[] paramArrayOfObject, Object paramObject) { for (int i = 0; i < paramArrayOfObject.length; i++) paramArrayOfObject[i] = paramObject; }
  private static void fill(short[] paramArrayOfShort, short paramShort) { for (int i = 0; i < paramArrayOfShort.length; i++) paramArrayOfShort[i] = paramShort; }
  
  public final void clear() { size = (this.usedSlots = 0);
    mru = (this.lru = -1);
    fill(keys, null);
    fill(inodes, (short)-1);
    fill(reverse, (short)-1);
  }
  
  public final short get(Object paramObject) {
    int i = paramObject.hashCode() & 0x7FFFFFFF;
    int j = i % totalSlots;
    int k = j;
    int m = 1;
    int n = 1;
    
    int i1 = -1;
    Object localObject;
    short s; int i3; while ((localObject = keys[j]) != null) {
      if (localObject == PLACEHOLDER) {
        if (i1 == -1) i1 = j;
      } else if (localObject.equals(paramObject)) {
        s = inodes[j];
        if (j == mru) return s;
        if (lru == j) {
          lru = next[lru];
        } else {
          i2 = prev[j];
          i3 = next[j];
          next[i2] = i3;
          prev[i3] = i2;
        }
        prev[j] = mru;
        next[mru] = ((short)j);
        mru = ((short)j);
        return s;
      }
      j = Math.abs((k + (n != 0 ? 1 : -1) * m * m) % totalSlots);
      if (n == 0) m++;
      n = n == 0 ? 1 : 0;
    }
    


    if (i1 == -1)
    {
      s = j;
      if (usedSlots == maxUsedSlots) {
        clear();
        return get(paramObject);
      }
      usedSlots += 1;
    }
    else {
      s = i1;
    }
    
    if (size == maxSize)
    {
      keys[lru] = PLACEHOLDER;
      inodes[lru] = -2;
      lru = next[lru];
    } else {
      if (size == 0) lru = ((short)s);
      size += 1;
    }
    
    label488:
    for (int i2 = i & 0x7FFF;; i2++) {
      j = i2 % totalSlots;
      k = j;
      m = 1;
      n = 1;
      i1 = -1;
      
      while ((i3 = reverse[j]) != -1) {
        int i4 = inodes[i3];
        if (i4 == -2) {
          if (i1 == -1) i1 = j;
        } else if (i4 == i2) {
            break label488;
          }
        j = Math.abs((k + (n != 0 ? 1 : -1) * m * m) % totalSlots);
        if (n == 0) m++;
        n = n == 0 ? 1 : 0;
      }
      
      if (i1 == -1) break; j = i1; break;
    }
    
    keys[s] = paramObject;
    reverse[j] = ((short)s);
    inodes[s] = ((short)i2);
    if (mru != -1) {
      prev[s] = mru;
      next[mru] = ((short)s);
    }
    mru = ((short)s);
    return (short)i2;
  }
  
  public Object reverse(short paramShort) {
    int i = paramShort % totalSlots;
    int j = i;
    int k = 1;
    int m = 1;
    int n;
    while ((n = reverse[i]) != -1) {
      if (inodes[n] == paramShort) return keys[n];
      i = Math.abs((j + (m != 0 ? 1 : -1) * k * k) % totalSlots);
      if (m == 0) k++;
      m = m == 0 ? 1 : 0;
    }
    return null;
  }
}
