package org.json.simple;

import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class ItemList
{
  private String sp = ",";
  List items = new ArrayList();
  
  public ItemList() {}
  
  public ItemList(String paramString)
  {
    split(paramString, sp, items);
  }
  
  public ItemList(String paramString1, String paramString2)
  {
    sp = paramString1;
    split(paramString1, paramString2, items);
  }
  
  public ItemList(String paramString1, String paramString2, boolean paramBoolean)
  {
    split(paramString1, paramString2, items, paramBoolean);
  }
  
  public List getItems()
  {
    return items;
  }
  
  public String[] getArray()
  {
    return (String[])items.toArray();
  }
  
  public void split(String paramString1, String paramString2, List paramList, boolean paramBoolean)
  {
    if ((paramString1 == null) || (paramString2 == null)) {
      return;
    }
    if (paramBoolean)
    {
      StringTokenizer localStringTokenizer = new StringTokenizer(paramString1, paramString2);
      while (localStringTokenizer.hasMoreTokens()) {
        paramList.add(localStringTokenizer.nextToken().trim());
      }
    }
    else
    {
      split(paramString1, paramString2, paramList);
    }
  }
  
  public void split(String paramString1, String paramString2, List paramList)
  {
    if ((paramString1 == null) || (paramString2 == null)) {
      return;
    }
    int i = 0;
    int j = 0;
    do
    {
      j = i;
      i = paramString1.indexOf(paramString2, i);
      if (i == -1) {
        break;
      }
      paramList.add(paramString1.substring(j, i).trim());
      i += paramString2.length();
    } while (i != -1);
    paramList.add(paramString1.substring(j).trim());
  }
  
  public void setSP(String paramString)
  {
    sp = paramString;
  }
  
  public void add(int paramInt, String paramString)
  {
    if (paramString == null) {
      return;
    }
    items.add(paramInt, paramString.trim());
  }
  
  public void add(String paramString)
  {
    if (paramString == null) {
      return;
    }
    items.add(paramString.trim());
  }
  
  public void addAll(ItemList paramItemList)
  {
    items.addAll(items);
  }
  
  public void addAll(String paramString)
  {
    split(paramString, sp, items);
  }
  
  public void addAll(String paramString1, String paramString2)
  {
    split(paramString1, paramString2, items);
  }
  
  public void addAll(String paramString1, String paramString2, boolean paramBoolean)
  {
    split(paramString1, paramString2, items, paramBoolean);
  }
  
  public String get(int paramInt)
  {
    return (String)items.get(paramInt);
  }
  
  public int size()
  {
    return items.size();
  }
  
  public String toString()
  {
    return toString(sp);
  }
  
  public String toString(String paramString)
  {
    StringBuffer localStringBuffer = new StringBuffer();
    for (int i = 0; i < items.size(); i++) {
      if (i == 0)
      {
        localStringBuffer.append(items.get(i));
      }
      else
      {
        localStringBuffer.append(paramString);
        localStringBuffer.append(items.get(i));
      }
    }
    return localStringBuffer.toString();
  }
  
  public void clear()
  {
    items.clear();
  }
  
  public void reset()
  {
    sp = ",";
    items.clear();
  }
}
