package org.json.simple.parser;

public class ParseException
  extends Exception
{
  private static final long serialVersionUID = -7880698968187728548L;
  public static final int ERROR_UNEXPECTED_CHAR = 0;
  public static final int ERROR_UNEXPECTED_TOKEN = 1;
  public static final int ERROR_UNEXPECTED_EXCEPTION = 2;
  private int errorType;
  private Object unexpectedObject;
  private int position;
  
  public ParseException(int paramInt)
  {
    this(-1, paramInt, null);
  }
  
  public ParseException(int paramInt, Object paramObject)
  {
    this(-1, paramInt, paramObject);
  }
  
  public ParseException(int paramInt1, int paramInt2, Object paramObject)
  {
    position = paramInt1;
    errorType = paramInt2;
    unexpectedObject = paramObject;
  }
  
  public int getErrorType()
  {
    return errorType;
  }
  
  public void setErrorType(int paramInt)
  {
    errorType = paramInt;
  }
  
  public int getPosition()
  {
    return position;
  }
  
  public void setPosition(int paramInt)
  {
    position = paramInt;
  }
  
  public Object getUnexpectedObject()
  {
    return unexpectedObject;
  }
  
  public void setUnexpectedObject(Object paramObject)
  {
    unexpectedObject = paramObject;
  }
  
  public String toString()
  {
    StringBuffer localStringBuffer = new StringBuffer();
    switch (errorType)
    {
    case 0: 
      localStringBuffer.append("Unexpected character (").append(unexpectedObject).append(") at position ").append(position).append(".");
      break;
    case 1: 
      localStringBuffer.append("Unexpected token ").append(unexpectedObject).append(" at position ").append(position).append(".");
      break;
    case 2: 
      localStringBuffer.append("Unexpected exception at position ").append(position).append(": ").append(unexpectedObject);
      break;
    default: 
      localStringBuffer.append("Unkown error at position ").append(position).append(".");
    }
    return localStringBuffer.toString();
  }
}
